/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var x=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/nls","vs/nls!vs/server/entry","vs/base/common/network","vs/base/common/types","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/objects","vs/base/common/resources","fs","os","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/product","vs/platform/registry/common/platform","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/configuration/common/configuration","vs/base/common/process","vs/base/common/extpath","@coder/logger","vs/base/parts/ipc/common/ipc","util","vs/base/common/errorMessage","child_process","vs/platform/extensions/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","path","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/base/node/zip","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogService","vs/platform/request/common/request","vs/server/node/logger","vs/server/node/nls","vs/base/parts/ipc/node/ipc.net","vs/base/common/functional","vs/base/common/iterator","vs/base/common/json","vs/base/common/normalization","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/localizations/node/localizations","vs/platform/configuration/common/configurationService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/server/node/util","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminal","vs/workbench/contrib/terminal/node/terminalEnvironment","vs/workbench/services/editor/common/editorService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/environment/node/environmentService","vs/platform/request/node/requestService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/amd","vs/base/common/console","vs/base/common/glob","vs/base/common/marshalling","vs/base/node/languagePacks","vs/base/common/performance","vs/base/node/macAddress","vs/base/node/id","vs/base/node/paths","vs/base/node/extpath","vs/base/node/proxy_agent","vs/base/node/watcher","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/server/node/marketplace","vs/nls!vs/server/node/server","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/terminal/common/terminal","vs/nls!vs/workbench/contrib/terminal/node/terminalProcess","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","crypto","vs/platform/log/common/bufferLog","vs/platform/log/common/fileLogService","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/notification/common/notification","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/browser/errorTelemetry","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/telemetry","vs/platform/workspace/common/workspace","vs/server/common/telemetry","vs/server/node/insights","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalDataBuffering","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminal","vs/workbench/contrib/terminal/node/terminalProcess","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/node/extensionPoints","vs/server/node/channel","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/server/node/marketplace","zlib","vs/code/node/cliProcessMain","vs/server/node/connection","vs/server/node/protocol","vs/server/node/server","string_decoder","proxy-agent","proxy-from-env","https","http","yauzl","yazl","tar-stream","net","graceful-fs","vs/server/entry"],ee=function(H){for(var e=[],h=0,T=H.length;h<T;h++)e[h]=x[H[h]];return e};define(x[90],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(T,b){if(!T)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=h}),define(x[91],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function h(f){return(u,P,g)=>{let p=null,v=null;if(typeof g.value=="function"?(p="value",v=g.value):typeof g.get=="function"&&(p="get",v=g.get),!v)throw new Error("not supported");g[p]=f(v,P)}}e.createDecorator=h;let T=0;function b(){const f=`$memoize${T++}`;let u;const P=function(p,v,c){let E=null,S=null;if(typeof c.value=="function"?(E="value",S=c.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(E="get",S=c.get),!S)throw new Error("not supported");const w=`${f}:${v}`;c[E]=function(...y){return u=this,this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,y)}),this[w]}};return P.clear=()=>{typeof u!="undefined"&&Object.getOwnPropertyNames(u).forEach(g=>{g.indexOf(f)===0&&delete u[g]})},P}e.createMemoizer=b;function _(f,u,P){return b()(f,u,P)}e.memoize=_;function L(f,u,P){return h((g,p)=>{const v=`$debounce$${p}`,c=`$debounce$result$${p}`;return function(...E){this[c]||(this[c]=P?P():void 0),clearTimeout(this[v]),u&&(this[c]=u(this[c],...E),E=[this[c]]),this[v]=setTimeout(()=>{g.apply(this,E),this[c]=P?P():void 0},f)}})}e.debounce=L;function C(f,u,P){return h((g,p)=>{const v=`$throttle$timer$${p}`,c=`$throttle$result$${p}`,E=`$throttle$lastRun$${p}`,S=`$throttle$pending$${p}`;return function(...w){if(this[c]||(this[c]=P?P():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),u&&(this[c]=u(this[c],...w)),!this[S]){const y=this[E]+f;y<=Date.now()?(this[E]=Date.now(),g.apply(this,[this[c]]),this[c]=P?P():void 0):(this[S]=!0,this[v]=setTimeout(()=>{this[S]=!1,this[E]=Date.now(),g.apply(this,[this[c]]),this[c]=P?P():void 0},y-Date.now()))}}})}e.throttle=C}),define(x[14],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class h{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(r=>{r(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=h,e.errorHandler=new h;function T(y){e.errorHandler.setUnexpectedErrorHandler(y)}e.setUnexpectedErrorHandler=T;function b(y){f(y)||e.errorHandler.onUnexpectedError(y)}e.onUnexpectedError=b;function _(y){f(y)||e.errorHandler.onUnexpectedExternalError(y)}e.onUnexpectedExternalError=_;function L(y){if(y instanceof Error){let{name:a,message:r}=y;const s=y.stacktrace||y.stack;return{$isError:!0,name:a,message:r,stack:s}}return y}e.transformErrorForSerialization=L;const C="Canceled";function f(y){return y instanceof Error&&y.name===C&&y.message===C}e.isPromiseCanceledError=f;class u extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=u;function P(){const y=new Error(C);return y.name=y.message,y}e.canceled=P;function g(y){return y?new Error(`Illegal argument: ${y}`):new Error("Illegal argument")}e.illegalArgument=g;function p(y){return y?new Error(`Illegal state: ${y}`):new Error("Illegal state")}e.illegalState=p;function v(y){return y?new Error(`readonly property '${y} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function c(y){const a=new Error(`${y} has been disposed`);return a.name="DISPOSED",a}e.disposed=c;function E(y){return y?y.message?y.message:y.stack?y.stack.split(`
`)[0]:String(y):"Error"}e.getErrorMessage=E;class S extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}e.NotImplementedError=S;class w extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}e.NotSupportedError=w}),define(x[18],ee([0,1,14]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.mergeSort=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(B,k=0){return B[B.length-(1+k)]}e.tail=T;function b(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=b;function _(B,k,O=(F,z)=>F===z){if(B===k)return!0;if(!B||!k||B.length!==k.length)return!1;for(let F=0,z=B.length;F<z;F++)if(!O(B[F],k[F]))return!1;return!0}e.equals=_;function L(B,k,O){let F=0,z=B.length-1;for(;F<=z;){const G=(F+z)/2|0,Y=O(B[G],k);if(Y<0)F=G+1;else if(Y>0)z=G-1;else return G}return-(F+1)}e.binarySearch=L;function C(B,k){let O=0,F=B.length;if(F===0)return 0;for(;O<F;){const z=Math.floor((O+F)/2);k(B[z])?F=z:O=z+1}return O}e.findFirstInSorted=C;function f(B,k,O){if(B=B|0,B>=k.length)throw new TypeError("invalid index");let F=k[Math.floor(k.length*Math.random())],z=[],G=[],Y=[];for(let Q of k){const Z=O(Q,F);Z<0?z.push(Q):Z>0?G.push(Q):Y.push(Q)}return B<z.length?f(B,z,O):B<z.length+Y.length?Y[0]:f(B-(z.length+Y.length),G,O)}e.quickSelect=f;function u(B,k){return g(B,k,0,B.length-1,[]),B}e.mergeSort=u;function P(B,k,O,F,z,G){let Y=O,Q=F+1;for(let Z=O;Z<=z;Z++)G[Z]=B[Z];for(let Z=O;Z<=z;Z++)Y>F?B[Z]=G[Q++]:Q>z?B[Z]=G[Y++]:k(G[Q],G[Y])<0?B[Z]=G[Q++]:B[Z]=G[Y++]}function g(B,k,O,F,z){if(!(F<=O)){const G=O+(F-O)/2|0;g(B,k,O,G,z),g(B,k,G+1,F,z),!(k(B[G],B[G+1])<=0)&&P(B,k,O,G,F,z)}}function p(B,k){const O=[];let F;for(const z of u(B.slice(0),k))!F||k(F[0],z)!==0?(F=[z],O.push(F)):F.push(z);return O}e.groupBy=p;function v(B,k,O){const F=[];function z(Q,Z,se){if(!(Z===0&&se.length===0)){const le=F[F.length-1];le&&le.start+le.deleteCount===Q?(le.deleteCount+=Z,le.toInsert.push(...se)):F.push({start:Q,deleteCount:Z,toInsert:se})}}let G=0,Y=0;for(;;){if(G===B.length){z(G,0,k.slice(Y));break}if(Y===k.length){z(G,B.length-G,[]);break}const Q=B[G],Z=k[Y],se=O(Q,Z);se===0?(G+=1,Y+=1):se<0?(z(G,1,[]),G+=1):se>0&&(z(G,0,[Z]),Y+=1)}return F}e.sortedDiff=v;function c(B,k,O){const F=v(B,k,O),z=[],G=[];for(const Y of F)z.push(...B.slice(Y.start,Y.start+Y.deleteCount)),G.push(...Y.toInsert);return{removed:z,added:G}}e.delta=c;function E(B,k,O){if(O===0)return[];const F=B.slice(0,O).sort(k);return w(B,k,F,O,B.length),F}e.top=E;function S(B,k,O,F,z){return O===0?Promise.resolve([]):new Promise((G,Y)=>{(async()=>{const Q=B.length,Z=B.slice(0,O).sort(k);for(let se=O,le=Math.min(O+F,Q);se<Q;se=le,le=Math.min(le+F,Q)){if(se>O&&await new Promise(fe=>setTimeout(fe)),z&&z.isCancellationRequested)throw h.canceled();w(B,k,Z,se,le)}return Z})().then(G,Y)})}e.topAsync=S;function w(B,k,O,F,z){for(const G=O.length;F<z;F++){const Y=B[F];if(k(Y,O[G-1])<0){O.pop();const Q=C(O,Z=>k(Y,Z)<0);O.splice(Q,0,Y)}}}function y(B){return B.filter(k=>!!k)}e.coalesce=y;function a(B){let k=0;for(let O=0;O<B.length;O++)B[O]&&(B[k]=B[O],k+=1);B.length=k}e.coalesceInPlace=a;function r(B,k,O){B.splice(O,0,B.splice(k,1)[0])}e.move=r;function s(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=s;function t(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=t;function o(B,k){if(!k)return B.filter((F,z)=>B.indexOf(F)===z);const O=Object.create(null);return B.filter(F=>{const z=k(F);return O[z]?!1:(O[z]=!0,!0)})}e.distinct=o;function i(B){const k=new Set;return B.filter(O=>k.has(O)?!1:(k.add(O),!0))}e.distinctES6=i;function l(B){const k=Object.create(null);return O=>{const F=B(O);return k[F]?!1:(k[F]=!0,!0)}}e.uniqueFilter=l;function n(B,k){for(let O=B.length-1;O>=0;O--){const F=B[O];if(k(F))return O}return-1}e.lastIndex=n;function d(B,k){return B.length>0?B[0]:k}e.firstOrDefault=d;function I(B,k,O=(F,z)=>F===z){let F=0;for(let z=0,G=Math.min(B.length,k.length);z<G&&O(B[z],k[z]);z++)F++;return F}e.commonPrefixLength=I;function R(B){return[].concat(...B)}e.flatten=R;function D(B,k){let O=typeof k=="number"?B:0;typeof k=="number"?O=B:(O=0,k=B);const F=[];if(O<=k)for(let z=O;z<k;z++)F.push(z);else for(let z=O;z>k;z--)F.push(z);return F}e.range=D;function m(B,k,O){return B.reduce((F,z)=>(F[k(z)]=O?O(z):z,F),Object.create(null))}e.index=m;function A(B,k){return B.push(k),()=>U(B,k)}e.insert=A;function U(B,k){const O=B.indexOf(k);if(O>-1)return B.splice(O,1),k}e.remove=U;function q(B,k,O){const F=B.slice(0,k),z=B.slice(k);return F.concat(O,z)}e.arrayInsert=q;function M(B,k){let O;if(typeof k=="number"){let F=k;O=()=>{const z=Math.sin(F++)*179426549;return z-Math.floor(z)}}else O=Math.random;for(let F=B.length-1;F>0;F-=1){const z=Math.floor(O()*(F+1)),G=B[F];B[F]=B[z],B[z]=G}}e.shuffle=M;function W(B,k){const O=B.indexOf(k);O>-1&&(B.splice(O,1),B.unshift(k))}e.pushToStart=W;function N(B,k){const O=B.indexOf(k);O>-1&&(B.splice(O,1),B.push(k))}e.pushToEnd=N;function K(B,k){return Array.isArray(B)?B.map(k):k(B)}e.mapArrayOrNot=K;function j(B){return Array.isArray(B)?B:[B]}e.asArray=j;function $(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=$;function J(B,k){for(const O of B){const F=k(O);if(F!==void 0)return F}}e.mapFind=J}),define(x[60],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function h(T){const b=this;let _=!1,L;return function(){return _||(_=!0,L=T.apply(b,arguments)),L}}e.once=h}),define(x[61],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var h;(function(T){function b(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}T.is=b;const _=Object.freeze([]);function L(){return _}T.empty=L;function*C(y){yield y}T.single=C;function f(y){return y||_}T.from=f;function u(y){return!y||y[Symbol.iterator]().next().done===!0}T.isEmpty=u;function P(y){return y[Symbol.iterator]().next().value}T.first=P;function g(y,a){for(const r of y)if(a(r))return!0;return!1}T.some=g;function*p(y,a){for(const r of y)a(r)&&(yield r)}T.filter=p;function*v(y,a){for(const r of y)yield a(r)}T.map=v;function*c(...y){for(const a of y)for(const r of a)yield r}T.concat=c;function*E(y){for(const a of y)for(const r of a)yield r}T.concatNested=E;function*S(y,a,r=y.length){for(a<0&&(a+=y.length),r<0?r+=y.length:r>y.length&&(r=y.length);a<r;a++)yield y[a]}T.slice=S;function w(y,a=Number.POSITIVE_INFINITY){const r=[];if(a===0)return[r,y];const s=y[Symbol.iterator]();for(let t=0;t<a;t++){const o=s.next();if(o.done)return[r,T.empty()];r.push(o.value)}return[r,{[Symbol.iterator](){return s}}]}T.consume=w})(h=e.Iterable||(e.Iterable={}))}),define(x[62],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(t){t.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function L(t,o=!1){let i=0,l=t.length,n="",d=0,I=16,R=0;function D(N){let K=0,j=0;for(;K<N;){const $=t.charCodeAt(i);if($>=48&&$<=57)j=j*16+$-48;else if($>=65&&$<=70)j=j*16+$-65+10;else if($>=97&&$<=102)j=j*16+$-97+10;else break;i++,K++}return K<N&&(j=-1),j}function m(N){i=N,n="",d=0,I=16,R=0}function A(){const N=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&u(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&u(t.charCodeAt(i)))for(i++;i<t.length&&u(t.charCodeAt(i));)i++;else return R=3,t.substring(N,i);let K=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&u(t.charCodeAt(i))){for(i++;i<t.length&&u(t.charCodeAt(i));)i++;K=i}else R=3;return t.substring(N,K)}function U(){let N="",K=i;for(;;){if(i>=l){N+=t.substring(K,i),R=2;break}const j=t.charCodeAt(i);if(j===34){N+=t.substring(K,i),i++;break}if(j===92){if(N+=t.substring(K,i),i++,i>=l){R=2;break}switch(t.charCodeAt(i++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:const J=D(4);J>=0?N+=String.fromCharCode(J):R=4;break;default:R=5}K=i;continue}if(j>=0&&j<=31)if(f(j)){N+=t.substring(K,i),R=2;break}else R=6;i++}return N}function q(){if(n="",R=0,d=i,i>=l)return d=l,I=17;let N=t.charCodeAt(i);if(C(N)){do i++,n+=String.fromCharCode(N),N=t.charCodeAt(i);while(C(N));return I=15}if(f(N))return i++,n+=String.fromCharCode(N),N===13&&t.charCodeAt(i)===10&&(i++,n+=`
`),I=14;switch(N){case 123:return i++,I=1;case 125:return i++,I=2;case 91:return i++,I=3;case 93:return i++,I=4;case 58:return i++,I=6;case 44:return i++,I=5;case 34:return i++,n=U(),I=10;case 47:const K=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<l&&!f(t.charCodeAt(i));)i++;return n=t.substring(K,i),I=12}if(t.charCodeAt(i+1)===42){i+=2;const j=l-1;let $=!1;for(;i<j;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,$=!0;break}i++}return $||(i++,R=1),n=t.substring(K,i),I=13}return n+=String.fromCharCode(N),i++,I=16;case 45:if(n+=String.fromCharCode(N),i++,i===l||!u(t.charCodeAt(i)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=A(),I=11;default:for(;i<l&&M(N);)i++,N=t.charCodeAt(i);if(d!==i){switch(n=t.substring(d,i),n){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return n+=String.fromCharCode(N),i++,I=16}}function M(N){if(C(N)||f(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let N;do N=q();while(N>=12&&N<=15);return N}return{setPosition:m,getPosition:()=>i,scan:o?W:q,getToken:()=>I,getTokenValue:()=>n,getTokenOffset:()=>d,getTokenLength:()=>i-d,getTokenError:()=>R}}e.createScanner=L;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function g(t,o){const i=[],l=new Object;let n;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function R(D,m,A,U){d.value=D,d.offset=m,d.length=A,d.type=U,d.colonOffset=void 0,n=d}try{a(t,{onObjectBegin:(D,m)=>{if(o<=D)throw l;n=void 0,I=o>D,i.push("")},onObjectProperty:(D,m,A)=>{if(o<m||(R(D,m,A,"property"),i[i.length-1]=D,o<=m+A))throw l},onObjectEnd:(D,m)=>{if(o<=D)throw l;n=void 0,i.pop()},onArrayBegin:(D,m)=>{if(o<=D)throw l;n=void 0,i.push(0)},onArrayEnd:(D,m)=>{if(o<=D)throw l;n=void 0,i.pop()},onLiteralValue:(D,m,A)=>{if(o<m||(R(D,m,A,s(D)),o<=m+A))throw l},onSeparator:(D,m,A)=>{if(o<=m)throw l;if(D===":"&&n&&n.type==="property")n.colonOffset=m,I=!1,n=void 0;else if(D===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(I=!0,i[i.length-1]=""),n=void 0}}})}catch(D){if(D!==l)throw D}return{path:i,previousNode:n,isAtPropertyKey:I,matches:D=>{let m=0;for(let A=0;m<D.length&&A<i.length;A++)if(D[m]===i[A]||D[m]==="*")m++;else if(D[m]!=="**")return!1;return m===D.length}}}e.getLocation=g;function p(t,o=[],i=_.DEFAULT){let l=null,n=[];const d=[];function I(D){Array.isArray(n)?n.push(D):l!==null&&(n[l]=D)}return a(t,{onObjectBegin:()=>{const D={};I(D),d.push(n),n=D,l=null},onObjectProperty:D=>{l=D},onObjectEnd:()=>{n=d.pop()},onArrayBegin:()=>{const D=[];I(D),d.push(n),n=D,l=null},onArrayEnd:()=>{n=d.pop()},onLiteralValue:I,onError:(D,m,A)=>{o.push({error:D,offset:m,length:A})}},i),n[0]}e.parse=p;function v(t,o=[],i=_.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(D){l.type==="property"&&(l.length=D-l.offset,l=l.parent)}function d(D){return l.children.push(D),D}a(t,{onObjectBegin:D=>{l=d({type:"object",offset:D,length:-1,parent:l,children:[]})},onObjectProperty:(D,m,A)=>{l=d({type:"property",offset:m,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:D,offset:m,length:A,parent:l})},onObjectEnd:(D,m)=>{l.length=D+m-l.offset,l=l.parent,n(D+m)},onArrayBegin:(D,m)=>{l=d({type:"array",offset:D,length:-1,parent:l,children:[]})},onArrayEnd:(D,m)=>{l.length=D+m-l.offset,l=l.parent,n(D+m)},onLiteralValue:(D,m,A)=>{d({type:s(D),offset:m,length:A,parent:l,value:D}),n(m+A)},onSeparator:(D,m,A)=>{l.type==="property"&&(D===":"?l.colonOffset=m:D===","&&n(m))},onError:(D,m,A)=>{o.push({error:D,offset:m,length:A})}},i);const R=l.children[0];return R&&delete R.parent,R}e.parseTree=v;function c(t,o){if(!!t){let i=t;for(let l of o)if(typeof l=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const d of i.children)if(Array.isArray(d.children)&&d.children[0].value===l){i=d.children[1],n=!0;break}if(!n)return}else{const n=l;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}}e.findNodeAtLocation=c;function E(t){if(!t.parent||!t.parent.children)return[];const o=E(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;o.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&o.push(i)}return o}e.getNodePath=E;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const o=Object.create(null);for(let i of t.children){const l=i.children[1];l&&(o[i.children[0].value]=S(l))}return o;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function w(t,o,i=!1){return o>=t.offset&&o<t.offset+t.length||i&&o===t.offset+t.length}e.contains=w;function y(t,o,i=!1){if(w(t,o,i)){const l=t.children;if(Array.isArray(l))for(let n=0;n<l.length&&l[n].offset<=o;n++){const d=y(l[n],o,i);if(d)return d}return t}}e.findNodeAtOffset=y;function a(t,o,i=_.DEFAULT){const l=L(t,!1);function n(G){return G?()=>G(l.getTokenOffset(),l.getTokenLength()):()=>!0}function d(G){return G?Y=>G(Y,l.getTokenOffset(),l.getTokenLength()):()=>!0}const I=n(o.onObjectBegin),R=d(o.onObjectProperty),D=n(o.onObjectEnd),m=n(o.onArrayBegin),A=n(o.onArrayEnd),U=d(o.onLiteralValue),q=d(o.onSeparator),M=n(o.onComment),W=d(o.onError),N=i&&i.disallowComments,K=i&&i.allowTrailingComma;function j(){for(;;){const G=l.scan();switch(l.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:N||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(G){case 12:case 13:N?$(10):M();break;case 16:$(1);break;case 15:case 14:break;default:return G}}}function $(G,Y=[],Q=[]){if(W(G),Y.length+Q.length>0){let Z=l.getToken();for(;Z!==17;){if(Y.indexOf(Z)!==-1){j();break}else if(Q.indexOf(Z)!==-1)break;Z=j()}}}function J(G){const Y=l.getTokenValue();return G?U(Y):R(Y),j(),!0}function B(){switch(l.getToken()){case 11:let G=0;try{G=JSON.parse(l.getTokenValue()),typeof G!="number"&&($(2),G=0)}catch(Y){$(2)}U(G);break;case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return j(),!0}function k(){return l.getToken()!==10?($(3,[],[2,5]),!1):(J(!1),l.getToken()===6?(q(":"),j(),z()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function O(){I(),j();let G=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(G||$(4,[],[]),q(","),j(),l.getToken()===2&&K)break}else G&&$(6,[],[]);k()||$(4,[],[2,5]),G=!0}return D(),l.getToken()!==2?$(7,[2],[]):j(),!0}function F(){m(),j();let G=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(G||$(4,[],[]),q(","),j(),l.getToken()===4&&K)break}else G&&$(6,[],[]);z()||$(4,[],[4,5]),G=!0}return A(),l.getToken()!==4?$(8,[4],[]):j(),!0}function z(){switch(l.getToken()){case 3:return F();case 1:return O();case 10:return J(!0);default:return B()}}return j(),l.getToken()===17?i.allowEmptyContent?!0:($(4,[],[]),!1):z()?(l.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=a;function r(t,o){let i=L(t),l=[],n,d=0,I;do switch(I=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:d!==I&&l.push(t.substring(d,I)),o!==void 0&&l.push(i.getTokenValue().replace(/[^\r\n]/g,o)),d=i.getPosition();break}while(n!==17);return l.join("")}e.stripComments=r;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(x[2],ee([0,1,60,61]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const b=!1;let _=null;function L(a){_=a}if(e.setDisposableTracker=L,b){const a="__is_disposable_tracked__";_=new class{trackDisposable(r){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[a]||console.log(s)},3e3)}markTracked(r){if(r&&r!==E.None)try{r[a]=!0}catch(s){}}}}function C(a){!_||_.markTracked(a)}function f(a){return _&&_.trackDisposable(a),a}e.trackDisposable=f;class u extends Error{constructor(r){super(`Encounter errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=u;function P(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=P;function g(a){if(T.Iterable.is(a)){let r=[];for(const s of a)if(s){C(s);try{s.dispose()}catch(t){r.push(t)}}if(r.length===1)throw r[0];if(r.length>1)throw new u(r);return Array.isArray(a)?[]:a}else if(a)return C(a),a.dispose(),a}e.dispose=g;function p(...a){return a.forEach(C),v(()=>g(a))}e.combinedDisposable=p;function v(a){const r=f({dispose:()=>{C(r),a()}});return r}e.toDisposable=v;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return C(r),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new c,f(this)}dispose(){C(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,f(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value&&this._value.dispose(),r&&C(r),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value&&this._value.dispose(),this._value=void 0}}e.MutableDisposable=S;class w{constructor(){this.references=new Map}acquire(r,...s){let t=this.references.get(r);t||(t={counter:0,object:this.createReferencedObject(r,...s)},this.references.set(r,t));const{object:o}=t,i=h.once(()=>{--t.counter==0&&(this.destroyReferencedObject(r,t.object),this.references.delete(r))});return t.counter++,{object:o,dispose:i}}}e.ReferenceCollection=w;class y{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=y}),define(x[92],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class h{constructor(_){this.element=_,this.next=h.Undefined,this.prev=h.Undefined}}h.Undefined=new h(void 0);class T{constructor(){this._first=h.Undefined,this._last=h.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===h.Undefined}clear(){this._first=h.Undefined,this._last=h.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,L){const C=new h(_);if(this._first===h.Undefined)this._first=C,this._last=C;else if(L){const u=this._last;this._last=C,C.prev=u,u.next=C}else{const u=this._first;this._first=C,C.next=u,u.prev=C}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(C))}}shift(){if(this._first!==h.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==h.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==h.Undefined&&_.next!==h.Undefined){const L=_.prev;L.next=_.next,_.next.prev=L}else _.prev===h.Undefined&&_.next===h.Undefined?(this._first=h.Undefined,this._last=h.Undefined):_.next===h.Undefined?(this._last=this._last.prev,this._last.next=h.Undefined):_.prev===h.Undefined&&(this._first=this._first.next,this._first.prev=h.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==h.Undefined;)yield _.element,_=_.next}}e.LinkedList=T});"use strict";function $e(H){const e=[];typeof H=="number"&&e.push("code/timeOrigin",H);function h(b){e.push(b,Date.now())}function T(){const b=[];for(let _=0;_<e.length;_+=2)b.push({name:e[_],startTime:e[_+1]});return b}return{mark:h,getMarks:T}}function Ye(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(H){performance.mark(H)},getMarks(){let H=performance.timeOrigin;typeof H!="number"&&(H=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const e=[{name:"code/timeOrigin",startTime:Math.round(H)}];for(const h of performance.getEntriesByType("mark"))e.push({name:h.name,startTime:Math.round(H+h.startTime)});return e}};if(typeof process=="object"){const H=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(H)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function qe(H){return H.MonacoPerformanceMarks||(H.MonacoPerformanceMarks=Ye()),H.MonacoPerformanceMarks}var je;typeof global=="object"?je=global:typeof self=="object"?je=self:je={},typeof define=="function"?define("vs/base/common/performance",[],function(){return qe(je)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=qe(je):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),je.perf=qe(je)),define(x[4],ee([0,1]),function(H,e){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const T="en";let b=!1,_=!1,L=!1,C=!1,f=!1,u=!1,P=!1,g,p=T,v,c;const E=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof process!="undefined"?S=process:typeof E.vscode!="undefined"&&(S=E.vscode.process);const w=typeof((h=S==null?void 0:S.versions)===null||h===void 0?void 0:h.electron)=="string"&&S.type==="renderer";if(e.isElectronSandboxed=w&&(S==null?void 0:S.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const n=S==null?void 0:S.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof n=="string")return n==="none"||n==="code"||n==="bypassHeatCheck"||n==="bypassHeatCheckAndEagerCompile"?n:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!w){c=navigator.userAgent,b=c.indexOf("Windows")>=0,_=c.indexOf("Macintosh")>=0,P=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=c.indexOf("Linux")>=0,u=!0,g=navigator.language,p=g;const n=typeof document!="undefined"&&document.getElementById("vscode-remote-nls-configuration"),d=n&&n.getAttribute("data-settings");if(d)try{const I=JSON.parse(d);g=I.locale,v=I._translationsConfigFile,p=I.availableLanguages["*"]||T}catch(I){}}else if(typeof S=="object"){b=S.platform==="win32",_=S.platform==="darwin",L=S.platform==="linux",C=L&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,g=T,p=T;const n=S.env.VSCODE_NLS_CONFIG;if(n)try{const d=JSON.parse(n),I=d.availableLanguages["*"];g=d.locale,p=I||T,v=d._translationsConfigFile}catch(d){}f=!0}else console.error("Unable to resolve platform.");var y;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function a(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let r=0;_?r=1:b?r=3:L&&(r=2),e.isWindows=b,e.isMacintosh=_,e.isLinux=L,e.isLinuxSnap=C,e.isNative=f,e.isWeb=u,e.isIOS=P,e.platform=r,e.userAgent=c,e.language=p;var s;(function(n){function d(){return e.language}n.value=d;function I(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=I;function R(){return e.language==="en"}n.isDefault=R})(s=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=v,e.globals=E,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let I=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let m=0,A=I.length;m<A;m++){const U=I[m];if(U.id===D.data.vscodeSetImmediateId){I.splice(m,1),U.callback();return}}});let R=0;return D=>{const m=++R;I.push({id:m,callback:D}),e.globals.postMessage({vscodeSetImmediateId:m},"*")}}if(S)return S.nextTick.bind(S);const d=Promise.resolve();return I=>d.then(I)}();var t;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=_||P?2:b?1:3;let o=!0,i=!1;function l(){if(!i){i=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,o=new Uint16Array(n.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=l}),define(x[33],ee([0,1,4]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let T;typeof process!="undefined"?T=process:typeof h.globals.vscode!="undefined"?T={get platform(){return h.globals.vscode.process.platform},get env(){return h.globals.vscode.process.env},nextTick(b){return h.setImmediate(b)},cwd(){return h.globals.vscode.process.env.VSCODE_CWD||h.globals.vscode.process.execPath.substr(0,h.globals.vscode.process.execPath.lastIndexOf(h.globals.vscode.process.platform==="win32"?"\\":"/"))}}:T={get platform(){return h.isWindows?"win32":h.isMacintosh?"darwin":"linux"},nextTick(b){return h.setImmediate(b)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick}),define(x[3],ee([0,1,33]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,b=97,_=90,L=122,C=46,f=47,u=92,P=58,g=63;class p extends Error{constructor(r,s,t){let o;typeof s=="string"&&s.indexOf("not ")===0?(o="must not be",s=s.replace(/^not /,"")):o="must be";const i=r.indexOf(".")!==-1?"property":"argument";let l=`The "${r}" ${i} ${o} of type ${s}`;l+=`. Received type ${typeof t}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function v(a,r){if(typeof a!="string")throw new p(r,"string",a)}function c(a){return a===f||a===u}function E(a){return a===f}function S(a){return a>=T&&a<=_||a>=b&&a<=L}function w(a,r,s,t){let o="",i=0,l=-1,n=0,d=0;for(let I=0;I<=a.length;++I){if(I<a.length)d=a.charCodeAt(I);else{if(t(d))break;d=f}if(t(d)){if(!(l===I-1||n===1))if(n===2){if(o.length<2||i!==2||o.charCodeAt(o.length-1)!==C||o.charCodeAt(o.length-2)!==C){if(o.length>2){const R=o.lastIndexOf(s);R===-1?(o="",i=0):(o=o.slice(0,R),i=o.length-1-o.lastIndexOf(s)),l=I,n=0;continue}else if(o.length!==0){o="",i=0,l=I,n=0;continue}}r&&(o+=o.length>0?`${s}..`:"..",i=2)}else o.length>0?o+=`${s}${a.slice(l+1,I)}`:o=a.slice(l+1,I),i=I-l-1;l=I,n=0}else d===C&&n!==-1?++n:n=-1}return o}function y(a,r){if(r===null||typeof r!="object")throw new p("pathObject","Object",r);const s=r.dir||r.root,t=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${t}`:`${s}${a}${t}`:t}e.win32={resolve(...a){let r="",s="",t=!1;for(let o=a.length-1;o>=-1;o--){let i;if(o>=0){if(i=a[o],v(i,"path"),i.length===0)continue}else r.length===0?i=h.cwd():(i=h.env[`=${r}`]||h.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==r.toLowerCase()&&i.charCodeAt(2)===u)&&(i=`${r}\\`));const l=i.length;let n=0,d="",I=!1;const R=i.charCodeAt(0);if(l===1)c(R)&&(n=1,I=!0);else if(c(R))if(I=!0,c(i.charCodeAt(1))){let D=2,m=D;for(;D<l&&!c(i.charCodeAt(D));)D++;if(D<l&&D!==m){const A=i.slice(m,D);for(m=D;D<l&&c(i.charCodeAt(D));)D++;if(D<l&&D!==m){for(m=D;D<l&&!c(i.charCodeAt(D));)D++;(D===l||D!==m)&&(d=`\\\\${A}\\${i.slice(m,D)}`,n=D)}}}else n=1;else S(R)&&i.charCodeAt(1)===P&&(d=i.slice(0,2),n=2,l>2&&c(i.charCodeAt(2))&&(I=!0,n=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(t){if(r.length>0)break}else if(s=`${i.slice(n)}\\${s}`,t=I,I&&r.length>0)break}return s=w(s,!t,"\\",c),t?`${r}\\${s}`:`${r}${s}`||"."},normalize(a){v(a,"path");const r=a.length;if(r===0)return".";let s=0,t,o=!1;const i=a.charCodeAt(0);if(r===1)return E(i)?"\\":a;if(c(i))if(o=!0,c(a.charCodeAt(1))){let n=2,d=n;for(;n<r&&!c(a.charCodeAt(n));)n++;if(n<r&&n!==d){const I=a.slice(d,n);for(d=n;n<r&&c(a.charCodeAt(n));)n++;if(n<r&&n!==d){for(d=n;n<r&&!c(a.charCodeAt(n));)n++;if(n===r)return`\\\\${I}\\${a.slice(d)}\\`;n!==d&&(t=`\\\\${I}\\${a.slice(d,n)}`,s=n)}}}else s=1;else S(i)&&a.charCodeAt(1)===P&&(t=a.slice(0,2),s=2,r>2&&c(a.charCodeAt(2))&&(o=!0,s=3));let l=s<r?w(a.slice(s),!o,"\\",c):"";return l.length===0&&!o&&(l="."),l.length>0&&c(a.charCodeAt(r-1))&&(l+="\\"),t===void 0?o?`\\${l}`:l:o?`${t}\\${l}`:`${t}${l}`},isAbsolute(a){v(a,"path");const r=a.length;if(r===0)return!1;const s=a.charCodeAt(0);return c(s)||r>2&&S(s)&&a.charCodeAt(1)===P&&c(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let r,s;for(let i=0;i<a.length;++i){const l=a[i];v(l,"path"),l.length>0&&(r===void 0?r=s=l:r+=`\\${l}`)}if(r===void 0)return".";let t=!0,o=0;if(typeof s=="string"&&c(s.charCodeAt(0))){++o;const i=s.length;i>1&&c(s.charCodeAt(1))&&(++o,i>2&&(c(s.charCodeAt(2))?++o:t=!1))}if(t){for(;o<r.length&&c(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.win32.normalize(r)},relative(a,r){if(v(a,"from"),v(r,"to"),a===r)return"";const s=e.win32.resolve(a),t=e.win32.resolve(r);if(s===t||(a=s.toLowerCase(),r=t.toLowerCase(),a===r))return"";let o=0;for(;o<a.length&&a.charCodeAt(o)===u;)o++;let i=a.length;for(;i-1>o&&a.charCodeAt(i-1)===u;)i--;const l=i-o;let n=0;for(;n<r.length&&r.charCodeAt(n)===u;)n++;let d=r.length;for(;d-1>n&&r.charCodeAt(d-1)===u;)d--;const I=d-n,R=l<I?l:I;let D=-1,m=0;for(;m<R;m++){const U=a.charCodeAt(o+m);if(U!==r.charCodeAt(n+m))break;U===u&&(D=m)}if(m!==R){if(D===-1)return t}else{if(I>R){if(r.charCodeAt(n+m)===u)return t.slice(n+m+1);if(m===2)return t.slice(n+m)}l>R&&(a.charCodeAt(o+m)===u?D=m:m===2&&(D=3)),D===-1&&(D=0)}let A="";for(m=o+D+1;m<=i;++m)(m===i||a.charCodeAt(m)===u)&&(A+=A.length===0?"..":"\\..");return n+=D,A.length>0?`${A}${t.slice(n,d)}`:(t.charCodeAt(n)===u&&++n,t.slice(n,d))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const r=e.win32.resolve(a);if(r.length<=2)return a;if(r.charCodeAt(0)===u){if(r.charCodeAt(1)===u){const s=r.charCodeAt(2);if(s!==g&&s!==C)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(S(r.charCodeAt(0))&&r.charCodeAt(1)===P&&r.charCodeAt(2)===u)return`\\\\?\\${r}`;return a},dirname(a){v(a,"path");const r=a.length;if(r===0)return".";let s=-1,t=0;const o=a.charCodeAt(0);if(r===1)return c(o)?a:".";if(c(o)){if(s=t=1,c(a.charCodeAt(1))){let n=2,d=n;for(;n<r&&!c(a.charCodeAt(n));)n++;if(n<r&&n!==d){for(d=n;n<r&&c(a.charCodeAt(n));)n++;if(n<r&&n!==d){for(d=n;n<r&&!c(a.charCodeAt(n));)n++;if(n===r)return a;n!==d&&(s=t=n+1)}}}}else S(o)&&a.charCodeAt(1)===P&&(s=r>2&&c(a.charCodeAt(2))?3:2,t=s);let i=-1,l=!0;for(let n=r-1;n>=t;--n)if(c(a.charCodeAt(n))){if(!l){i=n;break}}else l=!1;if(i===-1){if(s===-1)return".";i=s}return a.slice(0,i)},basename(a,r){r!==void 0&&v(r,"ext"),v(a,"path");let s=0,t=-1,o=!0,i;if(a.length>=2&&S(a.charCodeAt(0))&&a.charCodeAt(1)===P&&(s=2),r!==void 0&&r.length>0&&r.length<=a.length){if(r===a)return"";let l=r.length-1,n=-1;for(i=a.length-1;i>=s;--i){const d=a.charCodeAt(i);if(c(d)){if(!o){s=i+1;break}}else n===-1&&(o=!1,n=i+1),l>=0&&(d===r.charCodeAt(l)?--l==-1&&(t=i):(l=-1,t=n))}return s===t?t=n:t===-1&&(t=a.length),a.slice(s,t)}for(i=a.length-1;i>=s;--i)if(c(a.charCodeAt(i))){if(!o){s=i+1;break}}else t===-1&&(o=!1,t=i+1);return t===-1?"":a.slice(s,t)},extname(a){v(a,"path");let r=0,s=-1,t=0,o=-1,i=!0,l=0;a.length>=2&&a.charCodeAt(1)===P&&S(a.charCodeAt(0))&&(r=t=2);for(let n=a.length-1;n>=r;--n){const d=a.charCodeAt(n);if(c(d)){if(!i){t=n+1;break}continue}o===-1&&(i=!1,o=n+1),d===C?s===-1?s=n:l!==1&&(l=1):s!==-1&&(l=-1)}return s===-1||o===-1||l===0||l===1&&s===o-1&&s===t+1?"":a.slice(s,o)},format:y.bind(null,"\\"),parse(a){v(a,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return r;const s=a.length;let t=0,o=a.charCodeAt(0);if(s===1)return c(o)?(r.root=r.dir=a,r):(r.base=r.name=a,r);if(c(o)){if(t=1,c(a.charCodeAt(1))){let D=2,m=D;for(;D<s&&!c(a.charCodeAt(D));)D++;if(D<s&&D!==m){for(m=D;D<s&&c(a.charCodeAt(D));)D++;if(D<s&&D!==m){for(m=D;D<s&&!c(a.charCodeAt(D));)D++;D===s?t=D:D!==m&&(t=D+1)}}}}else if(S(o)&&a.charCodeAt(1)===P){if(s<=2)return r.root=r.dir=a,r;if(t=2,c(a.charCodeAt(2))){if(s===3)return r.root=r.dir=a,r;t=3}}t>0&&(r.root=a.slice(0,t));let i=-1,l=t,n=-1,d=!0,I=a.length-1,R=0;for(;I>=t;--I){if(o=a.charCodeAt(I),c(o)){if(!d){l=I+1;break}continue}n===-1&&(d=!1,n=I+1),o===C?i===-1?i=I:R!==1&&(R=1):i!==-1&&(R=-1)}return n!==-1&&(i===-1||R===0||R===1&&i===n-1&&i===l+1?r.base=r.name=a.slice(l,n):(r.name=a.slice(l,i),r.base=a.slice(l,n),r.ext=a.slice(i,n))),l>0&&l!==t?r.dir=a.slice(0,l-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let r="",s=!1;for(let t=a.length-1;t>=-1&&!s;t--){const o=t>=0?a[t]:h.cwd();v(o,"path"),o.length!==0&&(r=`${o}/${r}`,s=o.charCodeAt(0)===f)}return r=w(r,!s,"/",E),s?`/${r}`:r.length>0?r:"."},normalize(a){if(v(a,"path"),a.length===0)return".";const r=a.charCodeAt(0)===f,s=a.charCodeAt(a.length-1)===f;return a=w(a,!r,"/",E),a.length===0?r?"/":s?"./":".":(s&&(a+="/"),r?`/${a}`:a)},isAbsolute(a){return v(a,"path"),a.length>0&&a.charCodeAt(0)===f},join(...a){if(a.length===0)return".";let r;for(let s=0;s<a.length;++s){const t=a[s];v(t,"path"),t.length>0&&(r===void 0?r=t:r+=`/${t}`)}return r===void 0?".":e.posix.normalize(r)},relative(a,r){if(v(a,"from"),v(r,"to"),a===r||(a=e.posix.resolve(a),r=e.posix.resolve(r),a===r))return"";const s=1,t=a.length,o=t-s,i=1,l=r.length-i,n=o<l?o:l;let d=-1,I=0;for(;I<n;I++){const D=a.charCodeAt(s+I);if(D!==r.charCodeAt(i+I))break;D===f&&(d=I)}if(I===n)if(l>n){if(r.charCodeAt(i+I)===f)return r.slice(i+I+1);if(I===0)return r.slice(i+I)}else o>n&&(a.charCodeAt(s+I)===f?d=I:I===0&&(d=0));let R="";for(I=s+d+1;I<=t;++I)(I===t||a.charCodeAt(I)===f)&&(R+=R.length===0?"..":"/..");return`${R}${r.slice(i+d)}`},toNamespacedPath(a){return a},dirname(a){if(v(a,"path"),a.length===0)return".";const r=a.charCodeAt(0)===f;let s=-1,t=!0;for(let o=a.length-1;o>=1;--o)if(a.charCodeAt(o)===f){if(!t){s=o;break}}else t=!1;return s===-1?r?"/":".":r&&s===1?"//":a.slice(0,s)},basename(a,r){r!==void 0&&v(r,"ext"),v(a,"path");let s=0,t=-1,o=!0,i;if(r!==void 0&&r.length>0&&r.length<=a.length){if(r===a)return"";let l=r.length-1,n=-1;for(i=a.length-1;i>=0;--i){const d=a.charCodeAt(i);if(d===f){if(!o){s=i+1;break}}else n===-1&&(o=!1,n=i+1),l>=0&&(d===r.charCodeAt(l)?--l==-1&&(t=i):(l=-1,t=n))}return s===t?t=n:t===-1&&(t=a.length),a.slice(s,t)}for(i=a.length-1;i>=0;--i)if(a.charCodeAt(i)===f){if(!o){s=i+1;break}}else t===-1&&(o=!1,t=i+1);return t===-1?"":a.slice(s,t)},extname(a){v(a,"path");let r=-1,s=0,t=-1,o=!0,i=0;for(let l=a.length-1;l>=0;--l){const n=a.charCodeAt(l);if(n===f){if(!o){s=l+1;break}continue}t===-1&&(o=!1,t=l+1),n===C?r===-1?r=l:i!==1&&(i=1):r!==-1&&(i=-1)}return r===-1||t===-1||i===0||i===1&&r===t-1&&r===s+1?"":a.slice(r,t)},format:y.bind(null,"/"),parse(a){v(a,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return r;const s=a.charCodeAt(0)===f;let t;s?(r.root="/",t=1):t=0;let o=-1,i=0,l=-1,n=!0,d=a.length-1,I=0;for(;d>=t;--d){const R=a.charCodeAt(d);if(R===f){if(!n){i=d+1;break}continue}l===-1&&(n=!1,l=d+1),R===C?o===-1?o=d:I!==1&&(I=1):o!==-1&&(I=-1)}if(l!==-1){const R=i===0&&s?1:i;o===-1||I===0||I===1&&o===l-1&&o===i+1?r.base=r.name=a.slice(R,l):(r.name=a.slice(R,o),r.base=a.slice(R,l),r.ext=a.slice(o,l))}return i>0?r.dir=a.slice(0,i-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=h.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h.platform==="win32"?e.win32.join:e.posix.join,e.resolve=h.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=h.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=h.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=h.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=h.platform==="win32"?e.win32.extname:e.posix.extname,e.format=h.platform==="win32"?e.win32.format:e.posix.format,e.parse=h.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=h.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=h.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(x[93],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var h;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(h=e.Source||(e.Source={}));var T;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(T=e.TerminateResponseCode||(e.TerminateResponseCode={}));function b(_,...L){const C=L.reduce((P,g)=>(P[g]=!0,P),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/];Object.keys(_).filter(P=>!C[P]).forEach(P=>{for(let g=0;g<f.length;g++)if(P.search(f[g])!==-1){delete _[P];break}})}e.sanitizeProcessEnvironment=b}),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var h=e();for(var T in h)(typeof exports=="object"?exports:H)[T]=h[T]}}(typeof self!="undefined"?self:this,function(){return function(H){var e={};function h(T){if(e[T])return e[T].exports;var b=e[T]={i:T,l:!1,exports:{}};return H[T].call(b.exports,b,b.exports,h),b.l=!0,b.exports}return h.m=H,h.c=e,h.d=function(T,b,_){h.o(T,b)||Object.defineProperty(T,b,{enumerable:!0,get:_})},h.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},h.t=function(T,b){if(1&b&&(T=h(T)),8&b||4&b&&typeof T=="object"&&T&&T.__esModule)return T;var _=Object.create(null);if(h.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:T}),2&b&&typeof T!="string")for(var L in T)h.d(_,L,function(C){return T[C]}.bind(null,L));return _},h.n=function(T){var b=T&&T.__esModule?function(){return T.default}:function(){return T};return h.d(b,"a",b),b},h.o=function(T,b){return Object.prototype.hasOwnProperty.call(T,b)},h.p="",h(h.s=0)}([function(H,e,h){(function(T){var b;e=H.exports=Q,b=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],f=e.src=[],u=0,P=u++;f[P]="0|[1-9]\\d*";var g=u++;f[g]="[0-9]+";var p=u++;f[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=u++;f[v]="("+f[P]+")\\.("+f[P]+")\\.("+f[P]+")";var c=u++;f[c]="("+f[g]+")\\.("+f[g]+")\\.("+f[g]+")";var E=u++;f[E]="(?:"+f[P]+"|"+f[p]+")";var S=u++;f[S]="(?:"+f[g]+"|"+f[p]+")";var w=u++;f[w]="(?:-("+f[E]+"(?:\\."+f[E]+")*))";var y=u++;f[y]="(?:-?("+f[S]+"(?:\\."+f[S]+")*))";var a=u++;f[a]="[0-9A-Za-z-]+";var r=u++;f[r]="(?:\\+("+f[a]+"(?:\\."+f[a]+")*))";var s=u++,t="v?"+f[v]+f[w]+"?"+f[r]+"?";f[s]="^"+t+"$";var o="[v=\\s]*"+f[c]+f[y]+"?"+f[r]+"?",i=u++;f[i]="^"+o+"$";var l=u++;f[l]="((?:<|>)?=?)";var n=u++;f[n]=f[g]+"|x|X|\\*";var d=u++;f[d]=f[P]+"|x|X|\\*";var I=u++;f[I]="[v=\\s]*("+f[d]+")(?:\\.("+f[d]+")(?:\\.("+f[d]+")(?:"+f[w]+")?"+f[r]+"?)?)?";var R=u++;f[R]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[y]+")?"+f[r]+"?)?)?";var D=u++;f[D]="^"+f[l]+"\\s*"+f[I]+"$";var m=u++;f[m]="^"+f[l]+"\\s*"+f[R]+"$";var A=u++;f[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=u++;f[U]="(?:~>?)";var q=u++;f[q]="(\\s*)"+f[U]+"\\s+",C[q]=new RegExp(f[q],"g");var M=u++;f[M]="^"+f[U]+f[I]+"$";var W=u++;f[W]="^"+f[U]+f[R]+"$";var N=u++;f[N]="(?:\\^)";var K=u++;f[K]="(\\s*)"+f[N]+"\\s+",C[K]=new RegExp(f[K],"g");var j=u++;f[j]="^"+f[N]+f[I]+"$";var $=u++;f[$]="^"+f[N]+f[R]+"$";var J=u++;f[J]="^"+f[l]+"\\s*("+o+")$|^$";var B=u++;f[B]="^"+f[l]+"\\s*("+t+")$|^$";var k=u++;f[k]="(\\s*)"+f[l]+"\\s*("+o+"|"+f[I]+")",C[k]=new RegExp(f[k],"g");var O=u++;f[O]="^\\s*("+f[I]+")\\s+-\\s+("+f[I]+")\\s*$";var F=u++;f[F]="^\\s*("+f[R]+")\\s+-\\s+("+f[R]+")\\s*$";var z=u++;f[z]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)b(G,f[G]),C[G]||(C[G]=new RegExp(f[G]));function Y(X,ne){if(X instanceof Q)return X;if(typeof X!="string"||X.length>_||!(ne?C[i]:C[s]).test(X))return null;try{return new Q(X,ne)}catch(re){return null}}function Q(X,ne){if(X instanceof Q){if(X.loose===ne)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof Q))return new Q(X,ne);b("SemVer",X,ne),this.loose=ne;var re=X.trim().match(ne?C[i]:C[s]);if(!re)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+re[1],this.minor=+re[2],this.patch=+re[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");re[4]?this.prerelease=re[4].split(".").map(function(ve){if(/^[0-9]+$/.test(ve)){var V=+ve;if(V>=0&&V<L)return V}return ve}):this.prerelease=[],this.build=re[5]?re[5].split("."):[],this.format()}e.parse=Y,e.valid=function(X,ne){var re=Y(X,ne);return re?re.version:null},e.clean=function(X,ne){var re=Y(X.trim().replace(/^[=v]+/,""),ne);return re?re.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(X){return b("SemVer.compare",this.version,this.loose,X),X instanceof Q||(X=new Q(X,this.loose)),this.compareMain(X)||this.comparePre(X)},Q.prototype.compareMain=function(X){return X instanceof Q||(X=new Q(X,this.loose)),se(this.major,X.major)||se(this.minor,X.minor)||se(this.patch,X.patch)},Q.prototype.comparePre=function(X){if(X instanceof Q||(X=new Q(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var ne=0;do{var re=this.prerelease[ne],ve=X.prerelease[ne];if(b("prerelease compare",ne,re,ve),re===void 0&&ve===void 0)return 0;if(ve===void 0)return 1;if(re===void 0)return-1;if(re!==ve)return se(re,ve)}while(++ne)},Q.prototype.inc=function(X,ne){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ne);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ne);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ne),this.inc("pre",ne);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ne),this.inc("pre",ne);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var re=this.prerelease.length;--re>=0;)typeof this.prerelease[re]=="number"&&(this.prerelease[re]++,re=-2);re===-1&&this.prerelease.push(0)}ne&&(this.prerelease[0]===ne?isNaN(this.prerelease[1])&&(this.prerelease=[ne,0]):this.prerelease=[ne,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,ne,re,ve){typeof re=="string"&&(ve=re,re=void 0);try{return new Q(X,re).inc(ne,ve).version}catch(V){return null}},e.diff=function(X,ne){if(ae(X,ne))return null;var re=Y(X),ve=Y(ne);if(re.prerelease.length||ve.prerelease.length){for(var V in re)if((V==="major"||V==="minor"||V==="patch")&&re[V]!==ve[V])return"pre"+V;return"prerelease"}for(var V in re)if((V==="major"||V==="minor"||V==="patch")&&re[V]!==ve[V])return V},e.compareIdentifiers=se;var Z=/^[0-9]+$/;function se(X,ne){var re=Z.test(X),ve=Z.test(ne);return re&&ve&&(X=+X,ne=+ne),re&&!ve?-1:ve&&!re?1:X<ne?-1:X>ne?1:0}function le(X,ne,re){return new Q(X,re).compare(new Q(ne,re))}function fe(X,ne,re){return le(X,ne,re)>0}function ie(X,ne,re){return le(X,ne,re)<0}function ae(X,ne,re){return le(X,ne,re)===0}function ue(X,ne,re){return le(X,ne,re)!==0}function ye(X,ne,re){return le(X,ne,re)>=0}function Ce(X,ne,re){return le(X,ne,re)<=0}function Le(X,ne,re,ve){var V;switch(ne){case"===":typeof X=="object"&&(X=X.version),typeof re=="object"&&(re=re.version),V=X===re;break;case"!==":typeof X=="object"&&(X=X.version),typeof re=="object"&&(re=re.version),V=X!==re;break;case"":case"=":case"==":V=ae(X,re,ve);break;case"!=":V=ue(X,re,ve);break;case">":V=fe(X,re,ve);break;case">=":V=ye(X,re,ve);break;case"<":V=ie(X,re,ve);break;case"<=":V=Ce(X,re,ve);break;default:throw new TypeError("Invalid operator: "+ne)}return V}function me(X,ne){if(X instanceof me){if(X.loose===ne)return X;X=X.value}if(!(this instanceof me))return new me(X,ne);b("comparator",X,ne),this.loose=ne,this.parse(X),this.semver===de?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}e.rcompareIdentifiers=function(X,ne){return se(ne,X)},e.major=function(X,ne){return new Q(X,ne).major},e.minor=function(X,ne){return new Q(X,ne).minor},e.patch=function(X,ne){return new Q(X,ne).patch},e.compare=le,e.compareLoose=function(X,ne){return le(X,ne,!0)},e.rcompare=function(X,ne,re){return le(ne,X,re)},e.sort=function(X,ne){return X.sort(function(re,ve){return e.compare(re,ve,ne)})},e.rsort=function(X,ne){return X.sort(function(re,ve){return e.rcompare(re,ve,ne)})},e.gt=fe,e.lt=ie,e.eq=ae,e.neq=ue,e.gte=ye,e.lte=Ce,e.cmp=Le,e.Comparator=me;var de={};function Ee(X,ne){if(X instanceof Ee)return X.loose===ne?X:new Ee(X.raw,ne);if(X instanceof me)return new Ee(X.value,ne);if(!(this instanceof Ee))return new Ee(X,ne);if(this.loose=ne,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(re){return this.parseRange(re.trim())},this).filter(function(re){return re.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function be(X){return!X||X.toLowerCase()==="x"||X==="*"}function Re(X,ne,re,ve,V,te,oe,ce,he,ge,pe,Ie,Te){return((ne=be(re)?"":be(ve)?">="+re+".0.0":be(V)?">="+re+"."+ve+".0":">="+ne)+" "+(ce=be(he)?"":be(ge)?"<"+(+he+1)+".0.0":be(pe)?"<"+he+"."+(+ge+1)+".0":Ie?"<="+he+"."+ge+"."+pe+"-"+Ie:"<="+ce)).trim()}function Me(X,ne){for(var re=0;re<X.length;re++)if(!X[re].test(ne))return!1;if(ne.prerelease.length){for(re=0;re<X.length;re++)if(b(X[re].semver),X[re].semver!==de&&X[re].semver.prerelease.length>0){var ve=X[re].semver;if(ve.major===ne.major&&ve.minor===ne.minor&&ve.patch===ne.patch)return!0}return!1}return!0}function Ue(X,ne,re){try{ne=new Ee(ne,re)}catch(ve){return!1}return ne.test(X)}function Be(X,ne,re,ve){var V,te,oe,ce,he;switch(X=new Q(X,ve),ne=new Ee(ne,ve),re){case">":V=fe,te=Ce,oe=ie,ce=">",he=">=";break;case"<":V=ie,te=ye,oe=fe,ce="<",he="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(X,ne,ve))return!1;for(var ge=0;ge<ne.set.length;++ge){var pe=ne.set[ge],Ie=null,Te=null;if(pe.forEach(function(ke){ke.semver===de&&(ke=new me(">=0.0.0")),Ie=Ie||ke,Te=Te||ke,V(ke.semver,Ie.semver,ve)?Ie=ke:oe(ke.semver,Te.semver,ve)&&(Te=ke)}),Ie.operator===ce||Ie.operator===he||(!Te.operator||Te.operator===ce)&&te(X,Te.semver)||Te.operator===he&&oe(X,Te.semver))return!1}return!0}me.prototype.parse=function(X){var ne=this.loose?C[J]:C[B],re=X.match(ne);if(!re)throw new TypeError("Invalid comparator: "+X);this.operator=re[1],this.operator==="="&&(this.operator=""),re[2]?this.semver=new Q(re[2],this.loose):this.semver=de},me.prototype.toString=function(){return this.value},me.prototype.test=function(X){return b("Comparator.test",X,this.loose),this.semver===de||(typeof X=="string"&&(X=new Q(X,this.loose)),Le(X,this.operator,this.semver,this.loose))},me.prototype.intersects=function(X,ne){if(!(X instanceof me))throw new TypeError("a Comparator is required");var re;if(this.operator==="")return re=new Ee(X.value,ne),Ue(this.value,re,ne);if(X.operator==="")return re=new Ee(this.value,ne),Ue(X.semver,re,ne);var ve=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),V=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),te=this.semver.version===X.semver.version,oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),ce=Le(this.semver,"<",X.semver,ne)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),he=Le(this.semver,">",X.semver,ne)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return ve||V||te&&oe||ce||he},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(X){var ne=this.loose;X=X.trim(),b("range",X,ne);var re=ne?C[F]:C[O];X=X.replace(re,Re),b("hyphen replace",X),X=X.replace(C[k],"$1$2$3"),b("comparator trim",X,C[k]),X=(X=(X=X.replace(C[q],"$1~")).replace(C[K],"$1^")).split(/\s+/).join(" ");var ve=ne?C[J]:C[B],V=X.split(" ").map(function(te){return function(oe,ce){return b("comp",oe),oe=function(he,ge){return he.trim().split(/\s+/).map(function(pe){return function(Ie,Te){b("caret",Ie,Te);var ke=Te?C[$]:C[j];return Ie.replace(ke,function(Fe,_e,Pe,De,Oe){var Ne;return b("caret",Ie,Fe,_e,Pe,De,Oe),be(_e)?Ne="":be(Pe)?Ne=">="+_e+".0.0 <"+(+_e+1)+".0.0":be(De)?Ne=_e==="0"?">="+_e+"."+Pe+".0 <"+_e+"."+(+Pe+1)+".0":">="+_e+"."+Pe+".0 <"+(+_e+1)+".0.0":Oe?(b("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=_e==="0"?Pe==="0"?">="+_e+"."+Pe+"."+De+Oe+" <"+_e+"."+Pe+"."+(+De+1):">="+_e+"."+Pe+"."+De+Oe+" <"+_e+"."+(+Pe+1)+".0":">="+_e+"."+Pe+"."+De+Oe+" <"+(+_e+1)+".0.0"):(b("no pr"),Ne=_e==="0"?Pe==="0"?">="+_e+"."+Pe+"."+De+" <"+_e+"."+Pe+"."+(+De+1):">="+_e+"."+Pe+"."+De+" <"+_e+"."+(+Pe+1)+".0":">="+_e+"."+Pe+"."+De+" <"+(+_e+1)+".0.0"),b("caret return",Ne),Ne})}(pe,ge)}).join(" ")}(oe,ce),b("caret",oe),oe=function(he,ge){return he.trim().split(/\s+/).map(function(pe){return function(Ie,Te){var ke=Te?C[W]:C[M];return Ie.replace(ke,function(Fe,_e,Pe,De,Oe){var Ne;return b("tilde",Ie,Fe,_e,Pe,De,Oe),be(_e)?Ne="":be(Pe)?Ne=">="+_e+".0.0 <"+(+_e+1)+".0.0":be(De)?Ne=">="+_e+"."+Pe+".0 <"+_e+"."+(+Pe+1)+".0":Oe?(b("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=">="+_e+"."+Pe+"."+De+Oe+" <"+_e+"."+(+Pe+1)+".0"):Ne=">="+_e+"."+Pe+"."+De+" <"+_e+"."+(+Pe+1)+".0",b("tilde return",Ne),Ne})}(pe,ge)}).join(" ")}(oe,ce),b("tildes",oe),oe=function(he,ge){return b("replaceXRanges",he,ge),he.split(/\s+/).map(function(pe){return function(Ie,Te){Ie=Ie.trim();var ke=Te?C[m]:C[D];return Ie.replace(ke,function(Fe,_e,Pe,De,Oe,Ne){b("xRange",Ie,Fe,_e,Pe,De,Oe,Ne);var Ke=be(Pe),We=Ke||be(De),ze=We||be(Oe);return _e==="="&&ze&&(_e=""),Ke?Fe=_e===">"||_e==="<"?"<0.0.0":"*":_e&&ze?(We&&(De=0),ze&&(Oe=0),_e===">"?(_e=">=",We?(Pe=+Pe+1,De=0,Oe=0):ze&&(De=+De+1,Oe=0)):_e==="<="&&(_e="<",We?Pe=+Pe+1:De=+De+1),Fe=_e+Pe+"."+De+"."+Oe):We?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":ze&&(Fe=">="+Pe+"."+De+".0 <"+Pe+"."+(+De+1)+".0"),b("xRange return",Fe),Fe})}(pe,ge)}).join(" ")}(oe,ce),b("xrange",oe),oe=function(he,ge){return b("replaceStars",he,ge),he.trim().replace(C[z],"")}(oe,ce),b("stars",oe),oe}(te,ne)}).join(" ").split(/\s+/);return this.loose&&(V=V.filter(function(te){return!!te.match(ve)})),V=V.map(function(te){return new me(te,ne)})},Ee.prototype.intersects=function(X,ne){if(!(X instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(re){return re.every(function(ve){return X.set.some(function(V){return V.every(function(te){return ve.intersects(te,ne)})})})})},e.toComparators=function(X,ne){return new Ee(X,ne).set.map(function(re){return re.map(function(ve){return ve.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new Q(X,this.loose));for(var ne=0;ne<this.set.length;ne++)if(Me(this.set[ne],X))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(X,ne,re){var ve=null,V=null;try{var te=new Ee(ne,re)}catch(oe){return null}return X.forEach(function(oe){te.test(oe)&&(ve&&V.compare(oe)!==-1||(V=new Q(ve=oe,re)))}),ve},e.minSatisfying=function(X,ne,re){var ve=null,V=null;try{var te=new Ee(ne,re)}catch(oe){return null}return X.forEach(function(oe){te.test(oe)&&(ve&&V.compare(oe)!==1||(V=new Q(ve=oe,re)))}),ve},e.validRange=function(X,ne){try{return new Ee(X,ne).range||"*"}catch(re){return null}},e.ltr=function(X,ne,re){return Be(X,ne,"<",re)},e.gtr=function(X,ne,re){return Be(X,ne,">",re)},e.outside=Be,e.prerelease=function(X,ne){var re=Y(X,ne);return re&&re.prerelease.length?re.prerelease:null},e.intersects=function(X,ne,re){return X=new Ee(X,re),ne=new Ee(ne,re),X.intersects(ne)},e.coerce=function(X){if(X instanceof Q)return X;if(typeof X!="string")return null;var ne=X.match(C[A]);return ne==null?null:Y((ne[1]||"0")+"."+(ne[2]||"0")+"."+(ne[3]||"0"))}}).call(this,h(1))},function(H,e){var h,T,b=H.exports={};function _(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function C(S){if(h===setTimeout)return setTimeout(S,0);if((h===_||!h)&&setTimeout)return h=setTimeout,setTimeout(S,0);try{return h(S,0)}catch(w){try{return h.call(null,S,0)}catch(y){return h.call(this,S,0)}}}(function(){try{h=typeof setTimeout=="function"?setTimeout:_}catch(S){h=_}try{T=typeof clearTimeout=="function"?clearTimeout:L}catch(S){T=L}})();var f,u=[],P=!1,g=-1;function p(){P&&f&&(P=!1,f.length?u=f.concat(u):g=-1,u.length&&v())}function v(){if(!P){var S=C(p);P=!0;for(var w=u.length;w;){for(f=u,u=[];++g<w;)f&&f[g].run();g=-1,w=u.length}f=null,P=!1,function(y){if(T===clearTimeout)return clearTimeout(y);if((T===L||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(y);try{T(y)}catch(a){try{return T.call(null,y)}catch(r){return T.call(this,y)}}}(S)}}function c(S,w){this.fun=S,this.array=w}function E(){}b.nextTick=function(S){var w=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)w[y-1]=arguments[y];u.push(new c(S,w)),u.length!==1||P||C(v)},c.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=E,b.addListener=E,b.once=E,b.off=E,b.removeListener=E,b.removeAllListeners=E,b.emit=E,b.prependListener=E,b.prependOnceListener=E,b.listeners=function(S){return[]},b.binding=function(S){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(S){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(x[94],ee([0,1,4]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=h.globals.performance&&typeof h.globals.performance.now=="function";class b{constructor(L){this._highResolution=T&&L,this._startTime=this._now(),this._stopTime=-1}static create(L=!0){return new b(L)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?h.globals.performance.now():Date.now()}}e.StopWatch=b}),define(x[5],ee([0,1,14,60,2,92,94]),function(H,e,h,T,b,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.AsyncEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(y){y.None=()=>b.Disposable.None;function a(N){return(K,j=null,$)=>{let J=!1,B;return B=N(k=>{if(!J)return B?B.dispose():J=!0,K.call(j,k)},null,$),J&&B.dispose(),B}}y.once=a;function r(N,K){return n((j,$=null,J)=>N(B=>j.call($,K(B)),null,J))}y.map=r;function s(N,K){return n((j,$=null,J)=>N(B=>{K(B),j.call($,B)},null,J))}y.forEach=s;function t(N,K){return n((j,$=null,J)=>N(B=>K(B)&&j.call($,B),null,J))}y.filter=t;function o(N){return N}y.signal=o;function i(...N){return(K,j=null,$)=>b.combinedDisposable(...N.map(J=>J(B=>K.call(j,B),null,$)))}y.any=i;function l(N,K,j){let $=j;return r(N,J=>($=K($,J),$))}y.reduce=l;function n(N){let K;const j=new p({onFirstListenerAdd(){K=N(j.fire,j)},onLastListenerRemove(){K.dispose()}});return j.event}y.snapshot=n;function d(N,K,j=100,$=!1,J){let B,k,O,F=0;const z=new p({leakWarningThreshold:J,onFirstListenerAdd(){B=N(G=>{F++,k=K(k,G),$&&!O&&(z.fire(k),k=void 0),clearTimeout(O),O=setTimeout(()=>{const Y=k;k=void 0,O=void 0,(!$||F>1)&&z.fire(Y),F=0},j)})},onLastListenerRemove(){B.dispose()}});return z.event}y.debounce=d;function I(N){const K=new Date().getTime();return r(a(N),j=>new Date().getTime()-K)}y.stopwatch=I;function R(N){let K=!0,j;return t(N,$=>{const J=K||$!==j;return K=!1,j=$,J})}y.latch=R;function D(N,K=!1,j=[]){let $=j.slice(),J=N(O=>{$?$.push(O):k.fire(O)});const B=()=>{$&&$.forEach(O=>k.fire(O)),$=null},k=new p({onFirstListenerAdd(){J||(J=N(O=>k.fire(O)))},onFirstListenerDidAdd(){$&&(K?setTimeout(B):B())},onLastListenerRemove(){J&&J.dispose(),J=null}});return k.event}y.buffer=D;class m{constructor(K){this.event=K}map(K){return new m(r(this.event,K))}forEach(K){return new m(s(this.event,K))}filter(K){return new m(t(this.event,K))}reduce(K,j){return new m(l(this.event,K,j))}latch(){return new m(R(this.event))}debounce(K,j=100,$=!1,J){return new m(d(this.event,K,j,$,J))}on(K,j,$){return this.event(K,j,$)}once(K,j,$){return a(this.event)(K,j,$)}}function A(N){return new m(N)}y.chain=A;function U(N,K,j=$=>$){const $=(...O)=>k.fire(j(...O)),J=()=>N.on(K,$),B=()=>N.removeListener(K,$),k=new p({onFirstListenerAdd:J,onLastListenerRemove:B});return k.event}y.fromNodeEventEmitter=U;function q(N,K,j=$=>$){const $=(...O)=>k.fire(j(...O)),J=()=>N.addEventListener(K,$),B=()=>N.removeEventListener(K,$),k=new p({onFirstListenerAdd:J,onLastListenerRemove:B});return k.event}y.fromDOMEventEmitter=q;function M(N){const K=new p;let j=!1;return N.then(void 0,()=>null).then(()=>{j?K.fire(void 0):setTimeout(()=>K.fire(void 0),0)}),j=!0,K.event}y.fromPromise=M;function W(N){return new Promise(K=>a(N)(K))}y.toPromise=W})(C=e.Event||(e.Event={}));class f{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${f._idPool++}`}start(a){this._stopWatch=new L.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let u=-1;function P(y){const a=u;return u=y,{dispose(){u=a}}}e.setGlobalLeakWarningThreshold=P;class g{constructor(a,r=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let r=u;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),!(r<=0||a<r)){this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(s)||0;if(this._stacks.set(s,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let o,i=0;for(const[l,n]of this._stacks)(!o||i<n)&&(o=l,i=n);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${i}):`),console.warn(o)}return()=>{const o=this._stacks.get(s)||0;this._stacks.set(s,o-1)}}}}class p{constructor(a){var r;this._disposed=!1,this._options=a,this._leakageMon=u>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((r=this._options)===null||r===void 0?void 0:r._profName)?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(a,r,s)=>{var t;this._listeners||(this._listeners=new _.LinkedList);const o=this._listeners.isEmpty();o&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(r?[a,r]:a);o&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,r);const l=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let n;return n={dispose:()=>{l&&l(),n.dispose=p._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},s instanceof b.DisposableStore?s.add(n):Array.isArray(s)&&s.push(n),n}),this._event}fire(a){var r,s;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,a]);for((r=this._perfMon)===null||r===void 0||r.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,o]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,o):t[0].call(t[1],o)}catch(i){h.onUnexpectedError(i)}}(s=this._perfMon)===null||s===void 0||s.stop()}}dispose(){var a,r,s;(a=this._listeners)===null||a===void 0||a.clear(),(r=this._deliveryQueue)===null||r===void 0||r.clear(),(s=this._leakageMon)===null||s===void 0||s.dispose(),this._disposed=!0}}e.Emitter=p,p._noop=function(){};class v extends p{constructor(a){super(a);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=a==null?void 0:a.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=v;class c extends p{async fireAsync(a,r,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const t of this._listeners)this._asyncDeliveryQueue.push([t,a]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[t,o]=this._asyncDeliveryQueue.shift(),i=[],l=Object.assign(Object.assign({},o),{waitUntil:n=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");s&&(n=s(n,typeof t=="function"?t:t[0])),i.push(n)}});try{typeof t=="function"?t.call(void 0,l):t[0].call(t[1],l)}catch(n){h.onUnexpectedError(n);continue}Object.freeze(i),await Promise.all(i).catch(n=>h.onUnexpectedError(n))}}}}e.AsyncEmitter=c;class E{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const r={event:a,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const s=()=>{this.hasListeners&&this.unhook(r);const t=this.events.indexOf(r);this.events.splice(t,1)};return b.toDisposable(T.once(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(r=>this.emitter.fire(r))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=E;class S{constructor(){this.buffers=[]}wrapEvent(a){return(r,s,t)=>a(o=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>r.call(s,o)):r.call(s,o)},void 0,t)}bufferEvents(a){const r=[];this.buffers.push(r);const s=a();return this.buffers.pop(),r.forEach(t=>t()),s}}e.EventBufferer=S;class w{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=b.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(x[25],ee([0,1,5]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(C,f){const u=setTimeout(C.bind(f),0);return{dispose(){clearTimeout(u)}}});var b;(function(C){function f(u){return u===C.None||u===C.Cancelled||u instanceof _?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}C.isCancellationToken=f,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:h.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(b=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new h.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=b.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=b.None}}e.CancellationTokenSource=L}),define(x[15],ee([0,1,25,14,5,2]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function L(W){return W&&typeof W.then=="function"}e.isThenable=L;function C(W){const N=new h.CancellationTokenSource,K=W(N.token),j=new Promise(($,J)=>{N.token.onCancellationRequested(()=>{J(T.canceled())}),Promise.resolve(K).then(B=>{N.dispose(),$(B)},B=>{N.dispose(),J(B)})});return new class{cancel(){N.cancel()}then($,J){return j.then($,J)}catch($){return this.then(void 0,$)}finally($){return j.finally($)}}}e.createCancelablePromise=C;function f(W,N,K){return Promise.race([W,new Promise(j=>N.onCancellationRequested(()=>j(K)))])}e.raceCancellation=f;async function u(W){let N=-1;const K=W.map(($,J)=>$.then(B=>(N=J,B))),j=await Promise.race(K);return W.forEach(($,J)=>{J!==N&&$.cancel()}),j}e.raceCancellablePromises=u;function P(W,N,K){let j;const $=setTimeout(()=>{j==null||j(void 0),K==null||K()},N);return Promise.race([W.finally(()=>clearTimeout($)),new Promise(J=>j=J)])}e.raceTimeout=P;function g(W){return new Promise((N,K)=>{const j=W();L(j)?j.then(N,K):N(j)})}e.asPromise=g;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const K=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(K,K).then(j)})}return new Promise((K,j)=>{this.queuedPromise.then(K,j)})}return this.activePromise=N(),new Promise((K,j)=>{this.activePromise.then($=>{this.activePromise=null,K($)},$=>{this.activePromise=null,j($)})})}}e.Throttler=p;class v{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=v;class c{constructor(){this.promiseMap=new Map}queue(N,K){var j;const J=((j=this.promiseMap.get(N))!==null&&j!==void 0?j:Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.promiseMap.get(N)===J&&this.promiseMap.delete(N)});return this.promiseMap.set(N,J),J}}e.SequencerByKey=c;class E{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,K=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,$)=>{this.doResolve=j,this.doReject=$}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},K),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(T.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=E;class S{constructor(N){this.delayer=new E(N),this.throttler=new p}trigger(N,K){return this.delayer.trigger(()=>this.throttler.queue(N),K)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class w{constructor(){this._isOpen=!1,this._promise=new Promise((N,K)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;function y(W,N){return N?new Promise((K,j)=>{const $=setTimeout(K,W);N.onCancellationRequested(()=>{clearTimeout($),j(T.canceled())})}):C(K=>y(W,K))}e.timeout=y;function a(W,N=0){const K=setTimeout(W,N);return _.toDisposable(()=>clearTimeout(K))}e.disposableTimeout=a;function r(W){return W.then(void 0,N=>{})}e.ignoreErrors=r;function s(W){const N=[];let K=0;const j=W.length;function $(){return K<j?W[K++]():null}function J(B){B!=null&&N.push(B);const k=$();return k?k.then(J):Promise.resolve(N)}return Promise.resolve(null).then(J)}e.sequence=s;function t(W,N=j=>!!j,K=null){let j=0;const $=W.length,J=()=>{if(j>=$)return Promise.resolve(K);const B=W[j++];return Promise.resolve(B()).then(O=>N(O)?Promise.resolve(O):J())};return J()}e.first=t;function o(W,N=j=>!!j,K=null){if(W.length===0)return Promise.resolve(K);let j=W.length;const $=()=>{var J,B;j=-1;for(const k of W)(B=(J=k).cancel)===null||B===void 0||B.call(J)};return new Promise((J,B)=>{for(const k of W)k.then(O=>{--j>=0&&N(O)?($(),J(O)):j===0&&J(K)}).catch(O=>{--j>=0&&($(),B(O))})})}e.firstParallel=o;class i{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new b.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((K,j)=>{this.outstandingPromises.push({factory:N,c:K,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const K=N.factory();K.then(N.c,N.e),K.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class l extends i{constructor(){super(1)}}e.Queue=l;class n{constructor(){this.queues=new Map}queueFor(N){const K=N.toString();if(!this.queues.has(K)){const j=new l;j.onFinished(()=>{j.dispose(),this.queues.delete(K)}),this.queues.set(K,j)}return this.queues.get(K)}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=n;class d{constructor(N,K){this._token=-1,typeof N=="function"&&typeof K=="number"&&this.setIfNotSet(N,K)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,K){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},K)}setIfNotSet(N,K){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},K))}}e.TimeoutTimer=d;class I{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,K){this.cancel(),this._token=setInterval(()=>{N()},K)}}e.IntervalTimer=I;class R{constructor(N,K){this.timeoutToken=-1,this.runner=N,this.timeout=K,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class D extends R{constructor(N,K){super(N,K);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=D,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const K=setTimeout(()=>N(W));let j=!1;return{dispose(){j||(j=!0,clearTimeout(K))}}}}else e.runWhenIdle=(W,N)=>{const K=requestIdleCallback(W,typeof N=="number"?{timeout:N}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(K))}}}}();class m{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(K){this._error=K}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=m;async function A(W,N,K){let j;for(let $=0;$<K;$++)try{return await W()}catch(J){j=J,await y(N)}throw j}e.retry=A;class U{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,K,j){return this._pending={taskId:N,cancel:()=>j==null?void 0:j(),promise:K},K.then(()=>this.donePending(N),()=>this.donePending(N)),K}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let K,j;const $=new Promise((J,B)=>{K=J,j=B});this._next={run:N,promise:$,promiseResolve:K,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=U;class q{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,K)=>{this.completeCallback=N,this.errorCallback=K})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(K=>{this.completeCallback(N),this.resolved=!0,K()})}error(N){return new Promise(K=>{this.errorCallback(N),this.rejected=!0,K()})}cancel(){new Promise(N=>{this.errorCallback(T.canceled()),this.rejected=!0,N()})}}e.DeferredPromise=M}),define(x[42],ee([0,1,14,2]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.observe=e.transform=e.toReadable=e.toStream=e.peekStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function b(S){const w=S;return w&&[w.on,w.pause,w.resume,w.destroy].every(y=>typeof y=="function")}e.isReadableStream=b;function _(S){const w=S;return w&&b(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean"}e.isReadableBufferedStream=_;function L(S,w){return new C(S,w)}e.newWriteableStream=L;class C{constructor(w,y){this.reducer=w,this.options=y,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){var y;if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof((y=this.options)===null||y===void 0?void 0:y.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(w instanceof Error?this.error(w):w&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(y=>y(w))}emitError(w){this.listeners.error.length===0?h.onUnexpectedError(w):this.listeners.error.slice(0).forEach(y=>y(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,y){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(y),this.resume();break;case"end":this.listeners.end.push(y),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(y),this.state.flowing&&this.flowErrors();break}}removeListener(w,y){if(!this.state.destroyed){let a;switch(w){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const r=a.indexOf(y);r>=0&&a.splice(r,1)}}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const y=[...this.pendingWritePromises];this.pendingWritePromises.length=0,y.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(S,w){const y=[];let a;for(;(a=S.read())!==null;)y.push(a);return w(y)}e.consumeReadable=f;function u(S,w,y){const a=[];let r;for(;(r=S.read())!==null&&a.length<y;)a.push(r);return r===null&&a.length>0?w(a):{read:()=>{if(a.length>0)return a.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return S.read()}}}e.peekReadable=u;function P(S,w){return new Promise((y,a)=>{const r=[];S.on("error",s=>a(s)),S.on("end",()=>y(w(r))),S.on("data",s=>r.push(s))})}e.consumeStream=P;function g(S,w){return new Promise((y,a)=>{const r=new T.DisposableStore,s=[],t=l=>{if(s.push(l),s.length>w)return r.dispose(),S.pause(),y({stream:S,buffer:s,ended:!1})};r.add(T.toDisposable(()=>S.removeListener("data",t))),S.on("data",t);const o=l=>a(l);r.add(T.toDisposable(()=>S.removeListener("error",o))),S.on("error",o);const i=()=>y({stream:S,buffer:s,ended:!0});r.add(T.toDisposable(()=>S.removeListener("end",i))),S.on("end",i)})}e.peekStream=g;function p(S,w){const y=L(w);return y.end(S),y}e.toStream=p;function v(S){let w=!1;return{read:()=>w?null:(w=!0,S)}}e.toReadable=v;function c(S,w,y){const a=L(y);return S.on("data",r=>a.write(w.data(r))),S.on("end",()=>a.end()),S.on("error",r=>a.error(w.error?w.error(r):r)),a}e.transform=c;function E(S){const w=Promise.race([new Promise(y=>S.on("end",()=>y())),new Promise(y=>S.on("error",()=>y()))]);return{errorOrEnd(){return S.resume(),w}}}e.observe=E}),define(x[16],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function h(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=h;const T=/{(\d+)}/g;function b(V,...te){return te.length===0?V:V.replace(T,function(oe,ce){const he=parseInt(ce,10);return isNaN(he)||he<0||he>=te.length?oe:te[he]})}e.format=b;function _(V){return V.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=_;function L(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=L;function C(V,te){let oe=0;const ce=te.charCodeAt(0);for(let he=V.length-1;he>=0;he--)V.charCodeAt(he)===ce&&oe++;return oe}e.count=C;function f(V,te,oe="\u2026"){return V.length<=te?V:`${V.substr(0,te)}${oe}`}e.truncate=f;function u(V,te=" "){const oe=P(V,te);return g(oe,te)}e.trim=u;function P(V,te){if(!V||!te)return V;const oe=te.length;if(oe===0||V.length===0)return V;let ce=0;for(;V.indexOf(te,ce)===ce;)ce=ce+oe;return V.substring(ce)}e.ltrim=P;function g(V,te){if(!V||!te)return V;const oe=te.length,ce=V.length;if(oe===0||ce===0)return V;let he=ce,ge=-1;for(;ge=V.lastIndexOf(te,he-1),!(ge===-1||ge+oe!==he);){if(ge===0)return"";he=ge}return V.substring(0,he)}e.rtrim=g;function p(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function v(V){return V.replace(/\*/g,"")}e.stripWildcards=v;function c(V,te,oe={}){if(!V)throw new Error("Cannot create regex from empty string");te||(V=L(V)),oe.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let ce="";return oe.global&&(ce+="g"),oe.matchCase||(ce+="i"),oe.multiline&&(ce+="m"),oe.unicode&&(ce+="u"),new RegExp(V,ce)}e.createRegExp=c;function E(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function S(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function w(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=w;function y(V){return V.split(/\r\n|\r|\n/)}e.splitLines=y;function a(V){for(let te=0,oe=V.length;te<oe;te++){const ce=V.charCodeAt(te);if(ce!==32&&ce!==9)return te}return-1}e.firstNonWhitespaceIndex=a;function r(V,te=0,oe=V.length){for(let ce=te;ce<oe;ce++){const he=V.charCodeAt(ce);if(he!==32&&he!==9)return V.substring(te,ce)}return V.substring(te,oe)}e.getLeadingWhitespace=r;function s(V,te=V.length-1){for(let oe=te;oe>=0;oe--){const ce=V.charCodeAt(oe);if(ce!==32&&ce!==9)return oe}return-1}e.lastNonWhitespaceIndex=s;function t(V,te){return V<te?-1:V>te?1:0}e.compare=t;function o(V,te,oe=0,ce=V.length,he=0,ge=te.length){for(;oe<ce&&he<ge;oe++,he++){let Te=V.charCodeAt(oe),ke=te.charCodeAt(he);if(Te<ke)return-1;if(Te>ke)return 1}const pe=ce-oe,Ie=ge-he;return pe<Ie?-1:pe>Ie?1:0}e.compareSubstring=o;function i(V,te){return l(V,te,0,V.length,0,te.length)}e.compareIgnoreCase=i;function l(V,te,oe=0,ce=V.length,he=0,ge=te.length){for(;oe<ce&&he<ge;oe++,he++){let Te=V.charCodeAt(oe),ke=te.charCodeAt(he);if(Te!==ke){const Fe=Te-ke;if(!(Fe===32&&d(ke))&&!(Fe===-32&&d(Te)))return n(Te)&&n(ke)?Fe:o(V.toLowerCase(),te.toLowerCase(),oe,ce,he,ge)}}const pe=ce-oe,Ie=ge-he;return pe<Ie?-1:pe>Ie?1:0}e.compareSubstringIgnoreCase=l;function n(V){return V>=97&&V<=122}e.isLowerAsciiLetter=n;function d(V){return V>=65&&V<=90}e.isUpperAsciiLetter=d;function I(V){return n(V)||d(V)}function R(V,te){return V.length===te.length&&D(V,te)}e.equalsIgnoreCase=R;function D(V,te,oe=V.length){for(let ce=0;ce<oe;ce++){const he=V.charCodeAt(ce),ge=te.charCodeAt(ce);if(he!==ge){if(I(he)&&I(ge)){const pe=Math.abs(he-ge);if(pe!==0&&pe!==32)return!1}else if(String.fromCharCode(he).toLowerCase()!==String.fromCharCode(ge).toLowerCase())return!1}}return!0}function m(V,te){const oe=te.length;return te.length>V.length?!1:D(V,te,oe)}e.startsWithIgnoreCase=m;function A(V,te){let oe,ce=Math.min(V.length,te.length);for(oe=0;oe<ce;oe++)if(V.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return ce}e.commonPrefixLength=A;function U(V,te){let oe,ce=Math.min(V.length,te.length);const he=V.length-1,ge=te.length-1;for(oe=0;oe<ce;oe++)if(V.charCodeAt(he-oe)!==te.charCodeAt(ge-oe))return oe;return ce}e.commonSuffixLength=U;function q(V){return 55296<=V&&V<=56319}e.isHighSurrogate=q;function M(V){return 56320<=V&&V<=57343}e.isLowSurrogate=M;function W(V,te){return(V-55296<<10)+(te-56320)+65536}e.computeCodePoint=W;function N(V,te,oe){const ce=V.charCodeAt(oe);if(q(ce)&&oe+1<te){const he=V.charCodeAt(oe+1);if(M(he))return W(ce,he)}return ce}e.getNextCodePoint=N;function K(V,te){const oe=V.charCodeAt(te-1);if(M(oe)&&te>1){const ce=V.charCodeAt(te-2);if(q(ce))return W(ce,oe)}return oe}function j(V,te){const oe=re.getInstance(),ce=te,he=V.length,ge=N(V,he,te);te+=ge>=65536?2:1;let pe=oe.getGraphemeBreakType(ge);for(;te<he;){const Ie=N(V,he,te),Te=oe.getGraphemeBreakType(Ie);if(X(pe,Te))break;te+=Ie>=65536?2:1,pe=Te}return te-ce}e.nextCharLength=j;function $(V,te){const oe=re.getInstance(),ce=te,he=K(V,te);te-=he>=65536?2:1;let ge=oe.getGraphemeBreakType(he);for(;te>0;){const pe=K(V,te),Ie=oe.getGraphemeBreakType(pe);if(X(Ie,ge))break;te-=pe>=65536?2:1,ge=Ie}return ce-te}e.prevCharLength=$;function J(V,te){const oe=re.getInstance(),ce=V.length,he=te,ge=N(V,ce,te),pe=oe.getGraphemeBreakType(ge);te+=ge>=65536?2:1;let Ie=pe;for(;te<ce;){const ke=N(V,ce,te),Fe=oe.getGraphemeBreakType(ke);if(X(Ie,Fe))break;te+=ke>=65536?2:1,Ie=Fe}const Te=te;for(te=he,Ie=pe;te>0;){const ke=K(V,te),Fe=oe.getGraphemeBreakType(ke);if(X(Fe,Ie))break;te-=ke>=65536?2:1,Ie=Fe}return[te,Te]}function B(V,te){return te>0&&M(V.charCodeAt(te))?J(V,te-1):J(V,te)}e.getCharContainingOffset=B;function k(V){const te=V.length;let oe=0,ce=0;for(;ce<te;){const pe=N(V,te,ce);ce+=pe>=65536?2:1,pe<128?oe+=1:pe<2048?oe+=2:pe<65536?oe+=3:oe+=4}const he=new Uint8Array(oe);ce=0;let ge=0;for(;ce<te;){const pe=N(V,te,ce);ce+=pe>=65536?2:1,pe<128?he[ge++]=pe:pe<2048?(he[ge++]=192|(pe&1984)>>>6,he[ge++]=128|(pe&63)>>>0):pe<65536?(he[ge++]=224|(pe&61440)>>>12,he[ge++]=128|(pe&4032)>>>6,he[ge++]=128|(pe&63)>>>0):(he[ge++]=240|(pe&1835008)>>>18,he[ge++]=128|(pe&258048)>>>12,he[ge++]=128|(pe&4032)>>>6,he[ge++]=128|(pe&63)>>>0)}return he}e.encodeUTF8=k;function O(V){const te=V.byteLength,oe=[];let ce=0;for(;ce<te;){const he=V[ce];let ge;if(he>=240&&ce+3<te?ge=(V[ce++]&7)<<18>>>0|(V[ce++]&63)<<12>>>0|(V[ce++]&63)<<6>>>0|(V[ce++]&63)<<0>>>0:he>=224&&ce+2<te?ge=(V[ce++]&15)<<12>>>0|(V[ce++]&63)<<6>>>0|(V[ce++]&63)<<0>>>0:he>=192&&ce+1<te?ge=(V[ce++]&31)<<6>>>0|(V[ce++]&63)<<0>>>0:ge=V[ce++],ge>=0&&ge<=55295||ge>=57344&&ge<=65535)oe.push(String.fromCharCode(ge));else if(ge>=65536&&ge<=1114111){const pe=ge-65536,Ie=55296+((pe&1047552)>>>10),Te=56320+((pe&1023)>>>0);oe.push(String.fromCharCode(Ie)),oe.push(String.fromCharCode(Te))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=O;const F=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function z(V){return F.test(V)}e.containsRTL=z;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;function Y(V){return G.test(V)}e.containsEmoji=Y;const Q=/^[\t\n\r\x20-\x7E]*$/;function Z(V){return Q.test(V)}e.isBasicASCII=Z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=se;function le(V){for(let te=0,oe=V.length;te<oe;te++)if(fe(V.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=le;function fe(V){return V=+V,V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=fe;function ie(V){return V>=127462&&V<=127487||V>=9728&&V<=10175||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129003||V>=129280&&V<=129535||V>=129648&&V<=129651||V>=129656&&V<=129666||V>=129680&&V<=129685}e.isEmojiImprecise=ie;function ae(V,te){if(V.length<te)return V;const oe=/\b/g;let ce=0;for(;oe.test(V)&&!(V.length-oe.lastIndex<te);)ce=oe.lastIndex,oe.lastIndex+=1;return V.substring(ce).replace(/^\s/,"")}e.lcut=ae;const ue=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,Ce=/\x1b\[0?m/g;function Le(V){return V&&(V=V.replace(ue,""),V=V.replace(ye,""),V=V.replace(Ce,"")),V}e.removeAnsiEscapeCodes=Le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function me(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=me;function de(V){return me(V)?V.substr(1):V}e.stripUTF8BOM=de;function Ee(V,te){if(!V||!te||V.length<te.length)return!1;const oe=te.length,ce=V.toLowerCase();let he=0,ge=-1;for(;he<oe;){const pe=ce.indexOf(te[he],ge+1);if(pe<0)return!1;ge=pe,he++}return!0}e.fuzzyContains=Ee;function be(V,te=!1){return V?(te&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=be;function Re(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=Re;function Me(V,te=1){if(te===0)return"";let oe=-1;do oe=V.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?V:(V[oe-1]==="\r"&&oe--,V.substr(0,oe))}e.getNLines=Me;function Ue(V){const te=90-65+1;return V=V%(2*te),V<te?String.fromCharCode(97+V):String.fromCharCode(65+V-te)}e.singleLetterHash=Ue;function Be(V){return re.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=Be;function X(V,te){return V===0?te!==5&&te!==7:V===2&&te===3?!1:V===4||V===2||V===3||te===4||te===2||te===3?!0:!(V===8&&(te===8||te===9||te===11||te===12)||(V===11||V===9)&&(te===9||te===10)||(V===12||V===10)&&te===10||te===5||te===13||te===7||V===1||V===13&&te===14||V===6&&te===6)}e.breakBetweenGraphemeBreakType=X;var ne;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(ne=e.GraphemeBreakType||(e.GraphemeBreakType={}));class re{constructor(){this._data=ve()}static getInstance(){return re._INSTANCE||(re._INSTANCE=new re),re._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,ce=oe.length/3;let he=1;for(;he<=ce;)if(te<oe[3*he])he=2*he;else if(te>oe[3*he+1])he=2*he+1;else return oe[3*he+2];return 0}}re._INSTANCE=null;function ve(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(x[17],ee([0,1,16,42]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const b=typeof Buffer!="undefined",_=typeof TextEncoder!="undefined",L=typeof TextDecoder!="undefined";let C,f;class u{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return b?new u(Buffer.allocUnsafe(n)):new u(new Uint8Array(n))}static wrap(n){return b&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new u(n)}static fromString(n,d){return!((d==null?void 0:d.dontUseNodeBuffer)||!1)&&b?new u(Buffer.from(n)):_?(C||(C=new TextEncoder),new u(C.encode(n))):new u(h.encodeUTF8(n))}static concat(n,d){if(typeof d=="undefined"){d=0;for(let D=0,m=n.length;D<m;D++)d+=n[D].byteLength}const I=u.alloc(d);let R=0;for(let D=0,m=n.length;D<m;D++){const A=n[D];I.set(A,R),R+=A.byteLength}return I}toString(){return b?this.buffer.toString():L?(f||(f=new TextDecoder),f.decode(this.buffer)):h.decodeUTF8(this.buffer)}slice(n,d){return new u(this.buffer.subarray(n,d))}set(n,d){n instanceof u?this.buffer.set(n.buffer,d):this.buffer.set(n,d)}readUInt32BE(n){return p(this.buffer,n)}writeUInt32BE(n,d){v(this.buffer,n,d)}readUInt32LE(n){return c(this.buffer,n)}writeUInt32LE(n,d){E(this.buffer,n,d)}readUInt8(n){return S(this.buffer,n)}writeUInt8(n,d){w(this.buffer,n,d)}}e.VSBuffer=u;function P(l,n){return l[n+0]<<0>>>0|l[n+1]<<8>>>0}e.readUInt16LE=P;function g(l,n,d){l[d+0]=n&255,n=n>>>8,l[d+1]=n&255}e.writeUInt16LE=g;function p(l,n){return l[n]*2**24+l[n+1]*2**16+l[n+2]*2**8+l[n+3]}e.readUInt32BE=p;function v(l,n,d){l[d+3]=n,n=n>>>8,l[d+2]=n,n=n>>>8,l[d+1]=n,n=n>>>8,l[d]=n}e.writeUInt32BE=v;function c(l,n){return l[n+0]<<0>>>0|l[n+1]<<8>>>0|l[n+2]<<16>>>0|l[n+3]<<24>>>0}e.readUInt32LE=c;function E(l,n,d){l[d+0]=n&255,n=n>>>8,l[d+1]=n&255,n=n>>>8,l[d+2]=n&255,n=n>>>8,l[d+3]=n&255}e.writeUInt32LE=E;function S(l,n){return l[n]}e.readUInt8=S;function w(l,n,d){l[d]=n}e.writeUInt8=w;function y(l){return T.consumeReadable(l,n=>u.concat(n))}e.readableToBuffer=y;function a(l){return T.toReadable(l)}e.bufferToReadable=a;function r(l){return T.consumeStream(l,n=>u.concat(n))}e.streamToBuffer=r;async function s(l){return l.ended?u.concat(l.buffer):u.concat([...l.buffer,await r(l.stream)])}e.bufferedStreamToBuffer=s;function t(l){return T.toStream(l,n=>u.concat(n))}e.bufferToStream=t;function o(l){return T.transform(l,{data:n=>typeof n=="string"?u.fromString(n):u.wrap(n)},n=>u.concat(n))}e.streamToBufferReadableStream=o;function i(l){return T.newWriteableStream(n=>u.concat(n),l)}e.newWriteableBufferStream=i}),define(x[95],ee([0,1,16]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(T||(T={})),function(b){const _="error",L="warning",C="warn",f="info";function u(P){return P?h.equalsIgnoreCase(_,P)?b.Error:h.equalsIgnoreCase(L,P)||h.equalsIgnoreCase(C,P)?b.Warning:h.equalsIgnoreCase(f,P)?b.Info:b.Ignore:b.Ignore}b.fromValue=u}(T||(T={})),e.default=T}),define(x[11],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function h(n){return Array.isArray(n)}e.isArray=h;function T(n){return typeof n=="string"}e.isString=T;function b(n){return Array.isArray(n)&&n.every(d=>T(d))}e.isStringArray=b;function _(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=_;function L(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=L;function C(n){return n===!0||n===!1}e.isBoolean=C;function f(n){return typeof n=="undefined"}e.isUndefined=f;function u(n){return!P(n)}e.isDefined=u;function P(n){return f(n)||n===null}e.isUndefinedOrNull=P;function g(n,d){if(!n)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}e.assertType=g;function p(n){if(P(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=p;function v(...n){const d=[];for(let I=0;I<n.length;I++){const R=n[I];if(P(R))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);d.push(R)}return d}e.assertAllDefined=v;const c=Object.prototype.hasOwnProperty;function E(n){if(!_(n))return!1;for(let d in n)if(c.call(n,d))return!1;return!0}e.isEmptyObject=E;function S(n){return typeof n=="function"}e.isFunction=S;function w(...n){return n.length>0&&n.every(S)}e.areFunctions=w;function y(n,d){const I=Math.min(n.length,d.length);for(let R=0;R<I;R++)a(n[R],d[R])}e.validateConstraints=y;function a(n,d){if(T(d)){if(typeof n!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(S(d)){try{if(n instanceof d)return}catch(I){}if(!P(n)&&n.constructor===d||d.length===1&&d.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function r(n){let d=[],I=Object.getPrototypeOf(n);for(;Object.prototype!==I;)d=d.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return d}e.getAllPropertyNames=r;function s(n){const d=[];for(const I of r(n))typeof n[I]=="function"&&d.push(I);return d}e.getAllMethodNames=s;function t(n,d){const I=D=>function(){const m=Array.prototype.slice.call(arguments,0);return d(D,m)};let R={};for(const D of n)R[D]=I(D);return R}e.createProxyObject=t;function o(n){return n===null?void 0:n}e.withNullAsUndefined=o;function i(n){return typeof n=="undefined"?null:n}e.withUndefinedAsNull=i;function l(n){return class{constructor(){return new Proxy({},{get(d,I){if(d[I])return d[I];throw new Error(`Not Implemented: ${n}->${String(I)}`)}})}}}e.NotImplementedProxy=l}),define(x[34],ee([0,1,4,16,3,11]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function L(o){return o===47||o===92}e.isPathSeparator=L;function C(o){return o.replace(/[\\/]/g,b.posix.sep)}e.toSlashes=C;function f(o,i=b.posix.sep){if(!o)return"";const l=o.length,n=o.charCodeAt(0);if(L(n)){if(L(o.charCodeAt(1))&&!L(o.charCodeAt(2))){let I=3;const R=I;for(;I<l&&!L(o.charCodeAt(I));I++);if(R!==I&&!L(o.charCodeAt(I+1))){for(I+=1;I<l;I++)if(L(o.charCodeAt(I)))return o.slice(0,I+1).replace(/[\\/]/g,i)}}return i}else if(S(n)&&o.charCodeAt(1)===58)return L(o.charCodeAt(2))?o.slice(0,2)+i:o.slice(0,2);let d=o.indexOf("://");if(d!==-1){for(d+=3;d<l;d++)if(L(o.charCodeAt(d)))return o.slice(0,d+1)}return""}e.getRoot=f;function u(o){if(!h.isWindows||!o||o.length<5)return!1;let i=o.charCodeAt(0);if(i!==92||(i=o.charCodeAt(1),i!==92))return!1;let l=2;const n=l;for(;l<o.length&&(i=o.charCodeAt(l),i!==92);l++);return!(n===l||(i=o.charCodeAt(l+1),isNaN(i)||i===92))}e.isUNC=u;const P=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(o,i=h.isWindows){const l=i?P:g;return!(!o||o.length===0||/^\s+$/.test(o)||(l.lastIndex=0,l.test(o))||i&&p.test(o)||o==="."||o===".."||i&&o[o.length-1]==="."||i&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=v;function c(o,i,l){const n=o===i;return!l||n?n:!o||!i?!1:T.equalsIgnoreCase(o,i)}e.isEqual=c;function E(o,i,l,n=b.sep){if(o===i)return!0;if(!o||!i||i.length>o.length)return!1;if(l){if(!T.startsWithIgnoreCase(o,i))return!1;if(i.length===o.length)return!0;let I=i.length;return i.charAt(i.length-1)===n&&I--,o.charAt(I)===n}return i.charAt(i.length-1)!==n&&(i+=n),o.indexOf(i)===0}e.isEqualOrParent=E;function S(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=S;function w(o,i){return h.isWindows&&o.endsWith(":")&&(o+=b.sep),b.isAbsolute(o)||(o=b.join(i,o)),o=b.normalize(o),h.isWindows?(o=T.rtrim(o,b.sep),o.endsWith(":")&&(o+=b.sep)):(o=T.rtrim(o,b.sep),o||(o=b.sep)),o}e.sanitizeFilePath=w;function y(o){const i=b.normalize(o);return h.isWindows?o.length>3?!1:a(i)&&(o.length===2||i.charCodeAt(2)===92):i===b.posix.sep}e.isRootOrDriveLetter=y;function a(o){return h.isWindows?S(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function r(o){return a(o)?o[0]:void 0}e.getDriveLetter=r;function s(o,i,l){return i.length>o.length?-1:o===i?0:(l&&(o=o.toLowerCase(),i=i.toLowerCase()),o.indexOf(i))}e.indexOfPath=s;function t(o){const i=o.split(":");let l,n,d;if(i.forEach(I=>{const R=Number(I);_.isNumber(R)?n===void 0?n=R:d===void 0&&(d=R):l=l?[l,I].join(":"):I}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:n!==void 0?n:void 0,column:d!==void 0?d:n!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(x[19],ee([0,1,11]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const E=Array.isArray(c)?[]:{};return Object.keys(c).forEach(S=>{c[S]&&typeof c[S]=="object"?E[S]=T(c[S]):E[S]=c[S]}),E}e.deepClone=T;function b(c){if(!c||typeof c!="object")return c;const E=[c];for(;E.length>0;){const S=E.shift();Object.freeze(S);for(const w in S)if(_.call(S,w)){const y=S[w];typeof y=="object"&&!Object.isFrozen(y)&&E.push(y)}}return c}e.deepFreeze=b;const _=Object.prototype.hasOwnProperty;function L(c,E){return C(c,E,new Set)}e.cloneAndChange=L;function C(c,E,S){if(h.isUndefinedOrNull(c))return c;const w=E(c);if(typeof w!="undefined")return w;if(h.isArray(c)){const y=[];for(const a of c)y.push(C(a,E,S));return y}if(h.isObject(c)){if(S.has(c))throw new Error("Cannot clone recursive data-structure");S.add(c);const y={};for(let a in c)_.call(c,a)&&(y[a]=C(c[a],E,S));return S.delete(c),y}return c}function f(c,E,S=!0){return h.isObject(c)?(h.isObject(E)&&Object.keys(E).forEach(w=>{w in c?S&&(h.isObject(c[w])&&h.isObject(E[w])?f(c[w],E[w],S):c[w]=E[w]):c[w]=E[w]}),c):E}e.mixin=f;function u(c,E){if(c===E)return!0;if(c==null||E===null||E===void 0||typeof c!=typeof E||typeof c!="object"||Array.isArray(c)!==Array.isArray(E))return!1;let S,w;if(Array.isArray(c)){if(c.length!==E.length)return!1;for(S=0;S<c.length;S++)if(!u(c[S],E[S]))return!1}else{const y=[];for(w in c)y.push(w);y.sort();const a=[];for(w in E)a.push(w);if(a.sort(),!u(y,a))return!1;for(S=0;S<y.length;S++)if(!u(c[y[S]],E[y[S]]))return!1}return!0}e.equals=u;function P(c){const E=new Set;return JSON.stringify(c,(S,w)=>{if(h.isObject(w)||Array.isArray(w)){if(E.has(w))return"[Circular]";E.add(w)}return w})}e.safeStringify=P;function g(c,E,S){const w=E(c);return typeof w=="undefined"?S:w}e.getOrDefault=g;function p(c,E){const S=Object.create(null);return!c||!E||Object.keys(E).forEach(y=>{const a=c[y],r=E[y];u(a,r)||(S[y]=r)}),S}e.distinct=p;function v(c,E){const S=E.toLowerCase(),w=Object.keys(c).find(y=>y.toLowerCase()===S);return w?c[w]:c[E]}e.getCaseInsensitive=v}),define(x[7],ee([0,1,4,3]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const b=/^\w[\w\d+.-]*$/,_=/^\//,L=/^\/\//;function C(i,l){if(!i.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!b.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!_.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,l){return!i&&!l?"file":i}function u(i,l){switch(i){case"https":case"http":case"file":l?l[0]!==g&&(l=g+l):l=g;break}return l}const P="",g="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(l,n,d,I,R,D=!1){typeof l=="object"?(this.scheme=l.scheme||P,this.authority=l.authority||P,this.path=l.path||P,this.query=l.query||P,this.fragment=l.fragment||P):(this.scheme=f(l,D),this.authority=n||P,this.path=u(this.scheme,d||P),this.query=I||P,this.fragment=R||P,C(this,D))}static isUri(l){return l instanceof v?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}get fsPath(){return a(this,!1)}with(l){if(!l)return this;let{scheme:n,authority:d,path:I,query:R,fragment:D}=l;return n===void 0?n=this.scheme:n===null&&(n=P),d===void 0?d=this.authority:d===null&&(d=P),I===void 0?I=this.path:I===null&&(I=P),R===void 0?R=this.query:R===null&&(R=P),D===void 0?D=this.fragment:D===null&&(D=P),n===this.scheme&&d===this.authority&&I===this.path&&R===this.query&&D===this.fragment?this:new E(n,d,I,R,D)}static parse(l,n=!1){const d=p.exec(l);return d?new E(d[2]||P,o(d[4]||P),o(d[5]||P),o(d[7]||P),o(d[9]||P),n):new E(P,P,P,P,P)}static file(l){let n=P;if(h.isWindows&&(l=l.replace(/\\/g,g)),l[0]===g&&l[1]===g){const d=l.indexOf(g,2);d===-1?(n=l.substring(2),l=g):(n=l.substring(2,d),l=l.substring(d)||g)}return new E("file",n,l,P,P)}static from(l){return new E(l.scheme,l.authority,l.path,l.query,l.fragment)}static joinPath(l,...n){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return h.isWindows&&l.scheme==="file"?d=v.file(T.win32.join(a(l,!0),...n)).path:d=T.posix.join(l.path,...n),l.with({path:d})}toString(l=!1){return r(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof v)return l;{const n=new E(l);return n._formatted=l.external,n._fsPath=l._sep===c?l.fsPath:null,n}}else return l}}e.URI=v;const c=h.isWindows?1:void 0;class E extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(l=!1){return l?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=c),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(i,l){let n,d=-1;for(let I=0;I<i.length;I++){const R=i.charCodeAt(I);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||l&&R===47)d!==-1&&(n+=encodeURIComponent(i.substring(d,I)),d=-1),n!==void 0&&(n+=i.charAt(I));else{n===void 0&&(n=i.substr(0,I));const D=S[R];D!==void 0?(d!==-1&&(n+=encodeURIComponent(i.substring(d,I)),d=-1),n+=D):d===-1&&(d=I)}}return d!==-1&&(n+=encodeURIComponent(i.substring(d))),n!==void 0?n:i}function y(i){let l;for(let n=0;n<i.length;n++){const d=i.charCodeAt(n);d===35||d===63?(l===void 0&&(l=i.substr(0,n)),l+=S[d]):l!==void 0&&(l+=i[n])}return l!==void 0?l:i}function a(i,l){let n;return i.authority&&i.path.length>1&&i.scheme==="file"?n=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?l?n=i.path.substr(1):n=i.path[1].toLowerCase()+i.path.substr(2):n=i.path,h.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=a;function r(i,l){const n=l?y:w;let d="",{scheme:I,authority:R,path:D,query:m,fragment:A}=i;if(I&&(d+=I,d+=":"),(R||I==="file")&&(d+=g,d+=g),R){let U=R.indexOf("@");if(U!==-1){const q=R.substr(0,U);R=R.substr(U+1),U=q.indexOf(":"),U===-1?d+=n(q,!1):(d+=n(q.substr(0,U),!1),d+=":",d+=n(q.substr(U+1),!1)),d+="@"}R=R.toLowerCase(),U=R.indexOf(":"),U===-1?d+=n(R,!1):(d+=n(R.substr(0,U),!1),d+=R.substr(U))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const U=D.charCodeAt(1);U>=65&&U<=90&&(D=`/${String.fromCharCode(U+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const U=D.charCodeAt(0);U>=65&&U<=90&&(D=`${String.fromCharCode(U+32)}:${D.substr(2)}`)}d+=n(D,!0)}return m&&(d+="?",d+=n(m,!1)),A&&(d+="#",d+=l?A:w(A,!1)),d}function s(i){try{return decodeURIComponent(i)}catch(l){return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(i){return i.match(t)?i.replace(t,l=>s(l)):i}}),define(x[96],ee([0,1,18,7]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.getUriFromAmdModule=e.getPathFromAmdModule=void 0;function b(C,f){return _(C,f).fsPath}e.getPathFromAmdModule=b;function _(C,f){return T.URI.parse(C.toUrl(f))}e.getUriFromAmdModule=_;class L{static get(){const f=new Map,u=new Map,P=new Map,g=new Map;function p(w,y){w.has(y.detail)||w.set(y.detail,-y.timestamp)}function v(w,y){let a=w.get(y.detail);!a||a>=0||w.set(y.detail,a+y.timestamp)}const c=h.mergeSort(H.getStats().slice(0),(w,y)=>w.timestamp-y.timestamp);for(const w of c)switch(w.type){case 10:p(f,w);break;case 11:case 12:v(f,w);break;case 21:p(u,w);break;case 22:v(u,w);break;case 33:p(P,w);break;case 34:v(P,w);break;case 31:p(g,w);break;case 32:v(g,w);break}let E=0;P.forEach(w=>E+=w);function S(w){let y=[];return w.forEach((a,r)=>y.push([r,a])),y}return{amdLoad:S(f),amdInvoke:S(u),nodeRequire:S(P),nodeEval:S(g),nodeRequireTotal:E}}static toMarkdownTable(f,u){let P="",g=[];return f.forEach((p,v)=>{g[v]=p.length}),u.forEach(p=>{p.forEach((v,c)=>{typeof v=="undefined"&&(v=p[c]="-");const E=v.toString().length;g[c]=Math.max(E,g[c])})}),f.forEach((p,v)=>{P+=`| ${p+" ".repeat(g[v]-p.toString().length)} `}),P+=`|
`,f.forEach((p,v)=>{P+=`| ${"-".repeat(g[v])} `}),P+=`|
`,u.forEach(p=>{p.forEach((v,c)=>{typeof v!="undefined"&&(P+=`| ${v+" ".repeat(g[c]-v.toString().length)} `)}),P+=`|
`}),P}}e.LoaderStats=L}),define(x[97],ee([0,1,7]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(u){const P=u;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=T;function b(u){const P=[];let g;try{const p=JSON.parse(u.arguments),v=p[p.length-1];v&&v.__$stack&&(p.pop(),g=v.__$stack),P.push(...p)}catch(p){P.push("Unable to log remote console arguments",u.arguments)}return{args:P,stack:g}}e.parse=b;function _(u){if(typeof u!="string")return _(b(u).stack);const P=u;if(P){const g=L(P),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(p&&p.length===4)return{uri:h.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=_;function L(u){if(!u)return u;const P=u.indexOf(`
`);return P===-1?u:u.substring(0,P)}function C(u,P){const{args:g,stack:p}=b(u),v=typeof g[0]=="string"&&g.length===1;let c=L(p);c&&(c=`(${c.trim()})`);let E=[];if(typeof g[0]=="string"?c&&v?E=[`%c[${P}] %c${g[0]} %c${c}`,f("blue"),f(""),f("grey")]:E=[`%c[${P}] %c${g[0]}`,f("blue"),f(""),...g.slice(1)]:E=[`%c[${P}]%`,f("blue"),...g],c&&!v&&E.push(c),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,E)}e.log=C;function f(u){return`color: ${u}`}}),define(x[30],ee([0,1,7,16]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(y,a,r){let s=y.get(a);return s===void 0&&(s=r,y.set(a,s)),s}e.getOrSet=b;function _(y){const a=[];return y.forEach((r,s)=>{a.push(`${s} => ${r}`)}),`Map(${y.size}) {${a.join(", ")}}`}e.mapToString=_;function L(y){const a=[];return y.forEach(r=>{a.push(r)}),`Set(${y.size}) {${a.join(", ")}}`}e.setToString=L;class C{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const r=a.charCodeAt(0),s=this._value.charCodeAt(this._pos);return r-s}value(){return this._value[this._pos]}}e.StringIterator=C;class f{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?T.compareSubstring(a,this._value,0,a.length,this._from,this._to):T.compareSubstringIgnoreCase(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=f;class u{constructor(a=!0,r=!0){this._splitOnBackslash=a,this._caseSensitive=r}reset(a){return this._value=a.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?T.compareSubstring(a,this._value,0,a.length,this._from,this._to):T.compareSubstringIgnoreCase(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=u;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class g{constructor(a){this._ignorePathCasing=a,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new u(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return T.compareIgnoreCase(a,this._value.scheme);if(this._states[this._stateIdx]===2)return T.compareIgnoreCase(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return T.compare(a,this._value.query);if(this._states[this._stateIdx]===5)return T.compare(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class p{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class v{constructor(a){this._iter=a}static forUris(a=()=>!1){return new v(new g(a))}static forPaths(){return new v(new u)}static forStrings(){return new v(new C)}static forConfigKeys(){return new v(new f)}clear(){this._root=void 0}set(a,r){const s=this._iter.reset(a);let t;for(this._root||(this._root=new p,this._root.segment=s.value()),t=this._root;;){const i=s.cmp(t.segment);if(i>0)t.left||(t.left=new p,t.left.segment=s.value()),t=t.left;else if(i<0)t.right||(t.right=new p,t.right.segment=s.value()),t=t.right;else if(s.hasNext())s.next(),t.mid||(t.mid=new p,t.mid.segment=s.value()),t=t.mid;else break}const o=t.value;return t.value=r,t.key=a,o}get(a){var r;return(r=this._getNode(a))===null||r===void 0?void 0:r.value}_getNode(a){const r=this._iter.reset(a);let s=this._root;for(;s;){const t=r.cmp(s.segment);if(t>0)s=s.left;else if(t<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else break}return s}has(a){const r=this._getNode(a);return!((r==null?void 0:r.value)===void 0&&(r==null?void 0:r.mid)===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,r){const s=this._iter.reset(a),t=[];let o=this._root;for(;o;){const i=s.cmp(o.segment);if(i>0)t.push([1,o]),o=o.left;else if(i<0)t.push([-1,o]),o=o.right;else if(s.hasNext())s.next(),t.push([0,o]),o=o.mid;else{for(r?(o.left=void 0,o.mid=void 0,o.right=void 0):o.value=void 0;t.length>0&&o.isEmpty();){let[l,n]=t.pop();switch(l){case 1:n.left=void 0;break;case 0:n.mid=void 0;break;case-1:n.right=void 0;break}o=n}break}}}findSubstr(a){const r=this._iter.reset(a);let s=this._root,t;for(;s;){const o=r.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(r.hasNext())r.next(),t=s.value||t,s=s.mid;else break}return s&&s.value||t}findSuperstr(a){const r=this._iter.reset(a);let s=this._root;for(;s;){const t=r.cmp(s.segment);if(t>0)s=s.left;else if(t<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(a){for(const[r,s]of this)a(s,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(a){a&&(yield*this._entries(a.left),a.value&&(yield[a.key,a.value]),yield*this._entries(a.mid),yield*this._entries(a.right))}}e.TernarySearchTree=v;class c{constructor(a,r){this[Symbol.toStringTag]="ResourceMap",a instanceof c?(this.map=new Map(a.map),this.toKey=r!=null?r:c.defaultToKey):(this.map=new Map,this.toKey=a!=null?a:c.defaultToKey)}set(a,r){return this.map.set(this.toKey(a),r),this}get(a){return this.map.get(this.toKey(a))}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,r){typeof r!="undefined"&&(a=a.bind(r));for(let[s,t]of this.map)a(t,h.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let a of this.map.keys())yield h.URI.parse(a)}*entries(){for(let a of this.map.entries())yield[h.URI.parse(a[0]),a[1]]}*[Symbol.iterator](){for(let a of this.map)yield[h.URI.parse(a[0]),a[1]]}}e.ResourceMap=c,c.defaultToKey=y=>y.toString();var E;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class S{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var a;return(a=this._head)===null||a===void 0?void 0:a.value}get last(){var a;return(a=this._tail)===null||a===void 0?void 0:a.value}has(a){return this._map.has(a)}get(a,r=0){const s=this._map.get(a);if(!!s)return r!==0&&this.touch(s,r),s.value}set(a,r,s=0){let t=this._map.get(a);if(t)t.value=r,s!==0&&this.touch(t,s);else{switch(t={key:a,value:r,next:void 0,previous:void 0},s){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(a,t),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const r=this._map.get(a);if(!!r)return this._map.delete(a),this.removeItem(r),this._size--,r.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}}forEach(a,r){const s=this._state;let t=this._head;for(;t;){if(r?a.bind(r)(t.value,t.key,this):a(t.value,t.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const a=this,r=this._state;let s=this._head;const t={[Symbol.iterator](){return t},next(){if(a._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.key,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return t}values(){const a=this,r=this._state;let s=this._head;const t={[Symbol.iterator](){return t},next(){if(a._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.value,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return t}entries(){const a=this,r=this._state;let s=this._head;const t={[Symbol.iterator](){return t},next(){if(a._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:[s.key,s.value],done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return t}[Symbol.iterator](){return this.entries()}trimOld(a){if(!(a>=this.size)){if(a===0){this.clear();return}let r=this._head,s=this.size;for(;r&&s>a;)this._map.delete(r.key),r=r.next,s--;this._head=r,this._size=s,r&&(r.previous=void 0),this._state++}}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const r=a.next,s=a.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}a.next=void 0,a.previous=void 0,this._state++}touch(a,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(a===this._head)return;const s=a.next,t=a.previous;a===this._tail?(t.next=void 0,this._tail=t):(s.previous=t,t.next=s),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(r===2){if(a===this._tail)return;const s=a.next,t=a.previous;a===this._head?(s.previous=void 0,this._head=s):(s.previous=t,t.next=s),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((r,s)=>{a.push([s,r])}),a}fromJSON(a){this.clear();for(const[r,s]of a)this.set(r,s)}}e.LinkedMap=S;class w extends S{constructor(a,r=1){super();this._limit=a,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,r=2){return super.get(a,r)}peek(a){return super.get(a,0)}set(a,r){return super.set(a,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=w}),define(x[98],ee([0,1,16,34,3,30,15]),function(H,e,h,T,b,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const f="**",u="/",P="[/\\\\]",g="[^/\\\\]",p=/\//g;function v(k){switch(k){case 0:return"";case 1:return`${g}*?`;default:return`(?:${P}|${g}+${P}|${P}${g}+)*?`}}function c(k,O){if(!k)return[];const F=[];let z=!1,G=!1,Y="";for(const Q of k){switch(Q){case O:if(!z&&!G){F.push(Y),Y="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":G=!0;break;case"]":G=!1;break}Y+=Q}return Y&&F.push(Y),F}e.splitGlobAware=c;function E(k){if(!k)return"";let O="";const F=c(k,u);if(F.every(z=>z===f))O=".*";else{let z=!1;F.forEach((G,Y)=>{if(G===f){z||(O+=v(2),z=!0);return}let Q=!1,Z="",se=!1,le="";for(const fe of G){if(fe!=="}"&&Q){Z+=fe;continue}if(se&&(fe!=="]"||!le)){let ie;fe==="-"?ie=fe:(fe==="^"||fe==="!")&&!le?ie="^":fe===u?ie="":ie=h.escapeRegExpCharacters(fe),le+=ie;continue}switch(fe){case"{":Q=!0;continue;case"[":se=!0;continue;case"}":O+=`(?:${c(Z,",").map(ue=>E(ue)).join("|")})`,Q=!1,Z="";break;case"]":O+="["+le+"]",se=!1,le="";break;case"?":O+=g;continue;case"*":O+=v(1);continue;default:O+=h.escapeRegExpCharacters(fe)}}Y<F.length-1&&(F[Y+1]!==f||Y+2<F.length)&&(O+=P),z=!1})}return O}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new _.LRUCache(1e4),o=function(){return!1},i=function(){return null};function l(k,O){if(!k)return i;let F;typeof k!="string"?F=k.pattern:F=k,F=F.trim();const z=`${F}_${!!O.trimForExclusions}`;let G=t.get(z);if(G)return n(G,k);let Y;if(S.test(F)){const Q=F.substr(4);G=function(Z,se){return typeof Z=="string"&&Z.endsWith(Q)?F:null}}else(Y=w.exec(d(F,O)))?G=I(Y[1],F):(O.trimForExclusions?a:y).test(F)?G=R(F,O):(Y=r.exec(d(F,O)))?G=D(Y[1].substr(1),F,!0):(Y=s.exec(d(F,O)))?G=D(Y[1],F,!1):G=m(F);return t.set(z,G),n(G,k)}function n(k,O){return typeof O=="string"?k:function(F,z){return T.isEqualOrParent(F,O.base)?k(b.relative(O.base,F),z):null}}function d(k,O){return O.trimForExclusions&&k.endsWith("/**")?k.substr(0,k.length-2):k}function I(k,O){const F=`/${k}`,z=`\\${k}`,G=function(Q,Z){return typeof Q!="string"?null:Z?Z===k?O:null:Q===k||Q.endsWith(F)||Q.endsWith(z)?O:null},Y=[k];return G.basenames=Y,G.patterns=[O],G.allBasenames=Y,G}function R(k,O){const F=B(k.slice(1,-1).split(",").map(Z=>l(Z,O)).filter(Z=>Z!==i),k),z=F.length;if(!z)return i;if(z===1)return F[0];const G=function(Z,se){for(let le=0,fe=F.length;le<fe;le++)if(F[le](Z,se))return k;return null},Y=F.find(Z=>!!Z.allBasenames);Y&&(G.allBasenames=Y.allBasenames);const Q=F.reduce((Z,se)=>se.allPaths?Z.concat(se.allPaths):Z,[]);return Q.length&&(G.allPaths=Q),G}function D(k,O,F){const z=b.sep===b.posix.sep,G=z?k:k.replace(p,b.sep),Y=b.sep+G,Q=b.posix.sep+k,Z=F?function(se,le){return typeof se=="string"&&(se===G||se.endsWith(Y)||!z&&(se===k||se.endsWith(Q)))?O:null}:function(se,le){return typeof se=="string"&&(se===G||!z&&se===k)?O:null};return Z.allPaths=[(F?"*/":"./")+k],Z}function m(k){try{const O=new RegExp(`^${E(k)}$`);return function(F){return O.lastIndex=0,typeof F=="string"&&O.test(F)?k:null}}catch(O){return i}}function A(k,O,F){return!k||typeof O!="string"?!1:U(k)(O,void 0,F)}e.match=A;function U(k,O={}){if(!k)return o;if(typeof k=="string"||N(k)){const F=l(k,O);if(F===i)return o;const z=function(G,Y){return!!F(G,Y)};return F.allBasenames&&(z.allBasenames=F.allBasenames),F.allPaths&&(z.allPaths=F.allPaths),z}return $(k,O)}e.parse=U;function q(k){if(!!k){let O;return F=>(O||(O=(k()||Promise.resolve([])).then(z=>z?W(z):{})),O.then(z=>!!z[F]))}}e.hasSiblingPromiseFn=q;function M(k){if(!!k){let O;return F=>{if(!O){const z=k();O=z?W(z):{}}return!!O[F]}}}e.hasSiblingFn=M;function W(k){const O={};for(const F of k)O[F]=!0;return O}function N(k){const O=k;return O&&typeof O.base=="string"&&typeof O.pattern=="string"}e.isRelativePattern=N;function K(k){return k.allBasenames||[]}e.getBasenameTerms=K;function j(k){return k.allPaths||[]}e.getPathTerms=j;function $(k,O){const F=B(Object.getOwnPropertyNames(k).map(Z=>J(Z,k[Z],O)).filter(Z=>Z!==i)),z=F.length;if(!z)return i;if(!F.some(Z=>!!Z.requiresSiblings)){if(z===1)return F[0];const Z=function(fe,ie){for(let ae=0,ue=F.length;ae<ue;ae++){const ye=F[ae](fe,ie);if(ye)return ye}return null},se=F.find(fe=>!!fe.allBasenames);se&&(Z.allBasenames=se.allBasenames);const le=F.reduce((fe,ie)=>ie.allPaths?fe.concat(ie.allPaths):fe,[]);return le.length&&(Z.allPaths=le),Z}const G=function(Z,se,le){let fe;for(let ie=0,ae=F.length;ie<ae;ie++){const ue=F[ie];ue.requiresSiblings&&le&&(se||(se=b.basename(Z)),fe||(fe=se.substr(0,se.length-b.extname(Z).length)));const ye=ue(Z,se,fe,le);if(ye)return ye}return null},Y=F.find(Z=>!!Z.allBasenames);Y&&(G.allBasenames=Y.allBasenames);const Q=F.reduce((Z,se)=>se.allPaths?Z.concat(se.allPaths):Z,[]);return Q.length&&(G.allPaths=Q),G}function J(k,O,F){if(O===!1)return i;const z=l(k,F);if(z===i)return i;if(typeof O=="boolean")return z;if(O){const G=O.when;if(typeof G=="string"){const Y=(Q,Z,se,le)=>{if(!le||!z(Q,Z))return null;const fe=G.replace("$(basename)",se),ie=le(fe);return L.isThenable(ie)?ie.then(ae=>ae?k:null):ie?k:null};return Y.requiresSiblings=!0,Y}}return z}function B(k,O){const F=k.filter(Z=>!!Z.basenames);if(F.length<2)return k;const z=F.reduce((Z,se)=>{const le=se.basenames;return le?Z.concat(le):Z},[]);let G;if(O){G=[];for(let Z=0,se=z.length;Z<se;Z++)G.push(O)}else G=F.reduce((Z,se)=>{const le=se.patterns;return le?Z.concat(le):Z},[]);const Y=function(Z,se){if(typeof Z!="string")return null;if(!se){let fe;for(fe=Z.length;fe>0;fe--){const ie=Z.charCodeAt(fe-1);if(ie===47||ie===92)break}se=Z.substr(fe)}const le=z.indexOf(se);return le!==-1?G[le]:null};Y.basenames=z,Y.patterns=G,Y.allBasenames=z;const Q=k.filter(Z=>!Z.basenames);return Q.push(Y),Q}}),define(x[99],ee([0,1,17,16,7]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function _(u){return JSON.stringify(u,C)}e.stringify=_;function L(u){let P=JSON.parse(u);return P=f(P),P}e.parse=L;function C(u,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:T.regExpFlags(P)}:P}function f(u,P=0){if(!u||P>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return b.URI.revive(u);case 2:return new RegExp(u.source,u.flags)}if(u instanceof h.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let g=0;g<u.length;++g)u[g]=f(u[g],P+1);else for(const g in u)Object.hasOwnProperty.call(u,g)&&(u[g]=f(u[g],P+1))}return u}e.revive=f}),define(x[10],ee([0,1,7,4]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var b;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeSettings="vscode-settings",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.vscodeWebviewResource="vscode-webview-resource",C.extension="extension",C.vscodeFileResource="vscode-file"})(b=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,u,P){this._hosts[f]=u,this._ports[f]=P}setConnectionToken(f,u){this._connectionTokens[f]=u}rewrite(f){if(this._delegate)return this._delegate(f);const u=f.authority;let P=this._hosts[u];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const g=this._connectionTokens[u];let p=`path=${encodeURIComponent(f.path)}`;return typeof g=="string"&&(p+=`&tkn=${encodeURIComponent(g)}`),h.URI.from({scheme:T.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:window.location.host,path:`${window.location.pathname.replace(/\/+$/,"")}/vscode-remote-resource`,query:p})}}e.RemoteAuthorities=new _;class L{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(f,u,P){const g=this.toUri(f,u);return g.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(g):T.isNative&&(P||T.isPreferringBrowserCodeLoad)&&g.scheme===b.file?g.with({scheme:b.vscodeFileResource,authority:g.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(f,u){const P=this.toUri(f,u);return P.scheme===b.vscodeFileResource?P.with({scheme:b.file,authority:P.authority!==this.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(f,u){return h.URI.isUri(f)?f:h.URI.parse(u.toUrl(f))}}e.FileAccess=new L}),define(x[63],ee([0,1,30]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const T=new h.LRUCache(1e4);function b(u){return f(u,"NFC",T)}e.normalizeNFC=b;const _=new h.LRUCache(1e4);function L(u){return f(u,"NFD",_)}e.normalizeNFD=L;const C=/[^\u0000-\u0080]/;function f(u,P,g){if(!e.canNormalize||!u)return u;const p=g.get(u);if(p)return p;let v;return C.test(u)?v=u.normalize(P):v=u,g.set(u,v),v}e.removeAccents=function(){if(e.canNormalize){const u=/[\u0300-\u036f]/g;return function(P){return L(P).replace(u,"")}}else return function(u){return u}}()}),define(x[20],ee([0,1,34,3,7,16,10,4]),function(H,e,h,T,b,_,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(v){return b.uriToFsPath(v,!0)}e.originalFSPath=f;class u{constructor(c){this._ignorePathCasing=c}compare(c,E,S=!1){return c===E?0:_.compare(this.getComparisonKey(c,S),this.getComparisonKey(E,S))}isEqual(c,E,S=!1){return c===E?!0:!c||!E?!1:this.getComparisonKey(c,S)===this.getComparisonKey(E,S)}getComparisonKey(c,E=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,E,S=!1){if(c.scheme===E.scheme){if(c.scheme===L.Schemas.file)return h.isEqualOrParent(f(c),f(E),this._ignorePathCasing(c))&&c.query===E.query&&(S||c.fragment===E.fragment);if(e.isEqualAuthority(c.authority,E.authority))return h.isEqualOrParent(c.path,E.path,this._ignorePathCasing(c),"/")&&c.query===E.query&&(S||c.fragment===E.fragment)}return!1}joinPath(c,...E){return b.URI.joinPath(c,...E)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return T.posix.basename(c.path)}extname(c){return T.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let E;return c.scheme===L.Schemas.file?E=b.URI.file(T.dirname(f(c))).path:(E=T.posix.dirname(c.path),c.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),E="/")),c.with({path:E})}normalizePath(c){if(!c.path.length)return c;let E;return c.scheme===L.Schemas.file?E=b.URI.file(T.normalize(f(c))).path:E=T.posix.normalize(c.path),c.with({path:E})}relativePath(c,E){if(!(c.scheme!==E.scheme||!e.isEqualAuthority(c.authority,E.authority))){if(c.scheme===L.Schemas.file){const y=T.relative(f(c),f(E));return C.isWindows?h.toSlashes(y):y}let S=c.path||"/",w=E.path||"/";if(this._ignorePathCasing(c)){let y=0;for(const a=Math.min(S.length,w.length);y<a&&!(S.charCodeAt(y)!==w.charCodeAt(y)&&S.charAt(y).toLowerCase()!==w.charAt(y).toLowerCase());y++);S=w.substr(0,y)+S.substr(y)}return T.posix.relative(S,w)}}resolvePath(c,E){if(c.scheme===L.Schemas.file){const S=b.URI.file(T.resolve(f(c),E));return c.with({authority:S.authority,path:S.path})}return E.indexOf("/")===-1&&(E=h.toSlashes(E),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E)),c.with({path:T.posix.resolve(c.path,E)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,E){return c===E||_.equalsIgnoreCase(c,E)}hasTrailingPathSeparator(c,E=T.sep){if(c.scheme===L.Schemas.file){const S=f(c);return S.length>h.getRoot(S).length&&S[S.length-1]===E}else{const S=c.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,E=T.sep){return e.hasTrailingPathSeparator(c,E)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,E=T.sep){let S=!1;if(c.scheme===L.Schemas.file){const w=f(c);S=w!==void 0&&w.length===h.getRoot(w).length&&w[w.length-1]===E}else{E="/";const w=c.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!e.hasTrailingPathSeparator(c,E)?c.with({path:c.path+"/"}):c}}e.ExtUri=u,e.extUri=new u(()=>!1),e.extUriBiasedIgnorePathCase=new u(v=>v.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new u(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(v,c){const E=[];for(let S=0;S<v.length;S++){const w=c(v[S]);v.some((y,a)=>a===S?!1:e.isEqualOrParent(w,c(y)))||E.push(v[S])}return E}e.distinctParents=P;var g;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function c(E){const S=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(a=>{const[r,s]=a.split(":");r&&s&&S.set(r,s)});const y=E.path.substring(0,E.path.indexOf(";"));return y&&S.set(v.META_DATA_MIME,y),S}v.parseMetaData=c})(g=e.DataUri||(e.DataUri={}));function p(v,c,E){if(c){let S=v.path;return S&&S[0]!==T.posix.sep&&(S=T.posix.sep+S),v.with({scheme:E,authority:c,path:S})}return v.with({scheme:E})}e.toLocalResource=p}),define(x[64],ee([0,1,7,3,16,10,4,20,34]),function(H,e,h,T,b,_,L,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function u(l,n,d){if(typeof l=="string"&&(l=h.URI.file(l)),d){const R=d.getWorkspaceFolder(l);if(R){const D=d.getWorkspace().folders.length>1;let m;if(C.isEqual(R.uri,l)?m="":m=C.relativePath(R.uri,l),D){const A=R.name?R.name:C.basename(R.uri);m=m?A+" \u2022 "+m:A}return m}}if(l.scheme!==_.Schemas.file&&l.scheme!==_.Schemas.untitled)return l.with({query:null,fragment:null}).toString(!0);if(f.hasDriveLetter(l.fsPath))return T.normalize(g(l.fsPath));let I=T.normalize(l.fsPath);return!L.isWindows&&(n==null?void 0:n.userHome)&&(I=v(I,n.userHome.fsPath)),I}e.getPathLabel=u;function P(l){if(!!l){typeof l=="string"&&(l=h.URI.file(l));const n=C.basename(l)||(l.scheme===_.Schemas.file?l.fsPath:l.path);return L.isWindows&&f.isRootOrDriveLetter(n)?g(n):n}}e.getBaseLabel=P;function g(l){return f.hasDriveLetter(l)?l.charAt(0).toUpperCase()+l.slice(1):l}e.normalizeDriveLetter=g;let p=Object.create(null);function v(l,n){if(L.isWindows||!l||!n)return l;let d=p.original===n?p.normalized:void 0;return d||(d=`${b.rtrim(n,T.posix.sep)}${T.posix.sep}`,p={original:n,normalized:d}),(L.isLinux?l.startsWith(d):b.startsWithIgnoreCase(l,d))&&(l=`~/${l.substr(d.length)}`),l}e.tildify=v;function c(l,n){return l.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=c;const E="\u2026",S="\\\\",w="~";function y(l,n=T.sep){const d=new Array(l.length);let I=!1;for(let R=0;R<l.length;R++){let D=l[R];if(D===""){d[R]=`.${n}`;continue}if(!D){d[R]=D;continue}I=!0;let m="";D.indexOf(S)===0?(m=D.substr(0,D.indexOf(S)+S.length),D=D.substr(D.indexOf(S)+S.length)):D.indexOf(n)===0?(m=D.substr(0,D.indexOf(n)+n.length),D=D.substr(D.indexOf(n)+n.length)):D.indexOf(w)===0&&(m=D.substr(0,D.indexOf(w)+w.length),D=D.substr(D.indexOf(w)+w.length));const A=D.split(n);for(let U=1;I&&U<=A.length;U++)for(let q=A.length-U;I&&q>=0;q--){I=!1;let M=A.slice(q,q+U).join(n);for(let W=0;!I&&W<l.length;W++)if(W!==R&&l[W]&&l[W].indexOf(M)>-1){const N=q+U===A.length,K=q>0&&l[W].indexOf(n)>-1?n+M:M,j=l[W].endsWith(K);I=!N||j}if(!I){let W="";(A[0].endsWith(":")||m!=="")&&(q===1&&(q=0,U++,M=A[0]+n+M),q>0&&(W=A[0]+n),W=m+W),q>0&&(W=W+E+n),W=W+M,q+U<A.length&&(W=W+n+E),d[R]=W}}I&&(d[R]=D)}return d}e.shorten=y;var a;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function r(l,n=Object.create(null)){const d=[];let I=!1,R="";for(const D of l)if(D==="$"||I&&D==="{")R&&d.push({value:R,type:a.TEXT}),R="",I=!0;else if(D==="}"&&I){const m=n[R];if(typeof m=="string")m.length&&d.push({value:m,type:a.VARIABLE});else if(m){const A=d[d.length-1];(!A||A.type!==a.SEPARATOR)&&d.push({value:m.label,type:a.SEPARATOR})}R="",I=!1}else R+=D;return R&&!I&&d.push({value:R,type:a.TEXT}),d.filter((D,m)=>{if(D.type===a.SEPARATOR){const A=d[m-1],U=d[m+1];return[A,U].every(q=>q&&(q.type===a.VARIABLE||q.type===a.TEXT)&&q.value.length>0)}return!0}).map(D=>D.value).join("")}e.template=r;function s(l,n){return L.isMacintosh||n?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):l.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function t(l,n){return L.isMacintosh||n?l.replace(/\(&&\w\)|&&/g,""):L.isWindows?l.replace(/&&|&/g,d=>d==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function o(l){return l.replace(/&/g,"&&")}e.unmnemonicLabel=o;function i(l){const n=l.indexOf("/")!==-1?T.posix:T.win32,d=n.basename(l),I=n.dirname(l);return d.length?{name:d,parentPath:I}:{name:I,parentPath:""}}e.splitName=i}),define(x[50],ee([0,1,7,10]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function b(g){return g.toJSON()}class _{constructor(p){this.remoteAuthority=p}transformIncoming(p){return p.scheme===T.Schemas.vscodeRemote?b(h.URI.file(p.path)):p}transformOutgoing(p){return p.scheme===T.Schemas.file?b(h.URI.from({authority:this.remoteAuthority,scheme:T.Schemas.vscodeRemote,path:p.path})):p}transformOutgoingURI(p){return p.scheme===T.Schemas.file?h.URI.from({authority:this.remoteAuthority,scheme:T.Schemas.vscodeRemote,path:p.path}):p}transformOutgoingScheme(p){return p===T.Schemas.file?T.Schemas.vscodeRemote:p}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function L(g,p,v){if(!g||v>200)return null;if(typeof g=="object"){if(g instanceof h.URI)return p.transformOutgoing(g);for(let c in g)if(Object.hasOwnProperty.call(g,c)){const E=L(g[c],p,v+1);E!==null&&(g[c]=E)}}return null}function C(g,p){const v=L(g,p,0);return v===null?g:v}e.transformOutgoingURIs=C;function f(g,p,v,c){if(!g||c>200)return null;if(typeof g=="object"){if(g.$mid===1)return v?h.URI.revive(p.transformIncoming(g)):p.transformIncoming(g);for(let E in g)if(Object.hasOwnProperty.call(g,E)){const S=f(g[E],p,v,c+1);S!==null&&(g[E]=S)}}return null}function u(g,p){const v=f(g,p,!1,0);return v===null?g:v}e.transformIncomingURIs=u;function P(g,p){const v=f(g,p,!0,0);return v===null?g:v}e.transformAndReviveIncomingURIs=P}),define(x[26],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(f){return h.test(f)}e.isUUID=T;const b=new Uint8Array(16),_=[];for(let f=0;f<256;f++)_.push(f.toString(16).padStart(2,"0"));const L=function(f){for(let u=0;u<f.length;u++)f[u]=Math.floor(Math.random()*256);return f};function C(){L(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let f=0,u="";return u+=_[b[f++]],u+=_[b[f++]],u+=_[b[f++]],u+=_[b[f++]],u+="-",u+=_[b[f++]],u+=_[b[f++]],u+="-",u+=_[b[f++]],u+=_[b[f++]],u+="-",u+=_[b[f++]],u+=_[b[f++]],u+="-",u+=_[b[f++]],u+=_[b[f++]],u+=_[b[f++]],u+=_[b[f++]],u+=_[b[f++]],u+=_[b[f++]],u}e.generateUuid=C}),define(x[65],ee([0,1,200]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class T{constructor(_="utf8"){this.stringDecoder=new h.StringDecoder(_),this.remaining=null}write(_){const L=[],C=this.remaining?this.remaining+this.stringDecoder.write(_):this.stringDecoder.write(_);if(C.length<1)return L;let f=0,u,P=f;for(;P<C.length;)if(u=C.charCodeAt(P),u===13||u===10){if(L.push(C.substring(f,P)),P++,P<C.length){const g=u;u=C.charCodeAt(P),(g===13&&u===10||g===10&&u===13)&&P++}f=P}else P++;return this.remaining=f<C.length?C.substr(f):null,L}end(){return this.remaining}}e.LineDecoder=T});"use strict";function Ge(H,e,h,T){function b(w){return new Promise(y=>h.exists(w,y))}function _(w){return new Promise((y,a)=>{const r=new Date;h.utimes(w,r,r,s=>s?a(s):y())})}function L(w){return new Promise((y,a)=>h.lstat(w,(r,s)=>r?a(r):y(s)))}function C(w){return new Promise((y,a)=>h.readdir(w,(r,s)=>r?a(r):y(s)))}function f(w){return new Promise((y,a)=>h.mkdir(w,{recursive:!0},r=>r&&r.code!=="EEXIST"?a(r):y(w)))}function u(w){return new Promise((y,a)=>h.rmdir(w,r=>r?a(r):y(void 0)))}function P(w){return new Promise((y,a)=>h.unlink(w,r=>r?a(r):y(void 0)))}function g(w){return L(w).then(y=>y.isDirectory()&&!y.isSymbolicLink()?C(w).then(a=>Promise.all(a.map(r=>g(e.join(w,r))))).then(()=>u(w)):P(w),y=>{if(y.code!=="ENOENT")throw y})}function p(w){return new Promise(function(y,a){h.readFile(w,"utf8",function(r,s){if(r){a(r);return}y(s)})})}function v(w,y){return new Promise(function(a,r){h.writeFile(w,y,"utf8",function(s){if(s){r(s);return}a()})})}function c(w){const y=e.join(w,"languagepacks.json");try{return JSON.parse(h.readFileSync(y,"utf8"))}catch(a){}}function E(w,y){try{for(;y;){if(w[y])return y;{const a=y.lastIndexOf("-");if(a>0)y=y.substring(0,a);else return}}}catch(a){console.error("Resolving language pack configuration failed.",a)}}function S(w,y,a,r){if(r==="pseudo")return Promise.resolve({locale:r,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:r,availableLanguages:{}});if(r&&(r==="en"||r==="en-us"))return Promise.resolve({locale:r,availableLanguages:{}});const s=r;T.mark("code/willGenerateNls");const t=function(o){return T.mark("code/didGenerateNls"),Promise.resolve({locale:o,availableLanguages:{}})};try{if(!w)return t(s);const o=c(y);if(!o||(r=E(o,r),!r))return t(s);const i=o[r];let l;return!i||typeof i.hash!="string"||!i.translations||typeof(l=i.translations.vscode)!="string"?t(s):b(l).then(n=>{if(!n)return t(s);const d=i.hash+"."+r,I=e.join(y,"clp",d),R=e.join(I,w),D=e.join(I,"tcf.json"),m=e.join(I,"corrupted.info"),A={locale:s,availableLanguages:{"*":r},_languagePackId:d,_translationsConfigFile:D,_cacheRoot:I,_resolvedLanguagePackCoreLocation:R,_corruptedFile:m};return b(m).then(U=>{let q;return U?q=g(I):q=Promise.resolve(void 0),q.then(()=>b(R).then(M=>M?(_(R).catch(()=>{}),T.mark("code/didGenerateNls"),A):f(R).then(()=>Promise.all([p(a),p(l)])).then(W=>{const N=JSON.parse(W[0]),K=JSON.parse(W[1]).contents,j=Object.keys(N.bundles),$=[];for(const J of j){const B=N.bundles[J],k=Object.create(null);for(const O of B){const F=N.keys[O],z=N.messages[O],G=K[O];let Y;if(G){Y=[];for(let Q=0;Q<F.length;Q++){const Z=F[Q],se=typeof Z=="string"?Z:Z.key;let le=G[se];le===void 0&&(le=z[Q]),Y.push(le)}}else Y=z;k[O]=Y}$.push(v(e.join(R,J.replace(/\//g,"!")+".nls.json"),JSON.stringify(k)))}return $.push(v(D,JSON.stringify(i.translations))),Promise.all($)}).then(()=>(T.mark("code/didGenerateNls"),A)).catch(W=>(console.error("Generating translation files failed.",W),t(r)))))})})}catch(o){return console.error("Generating translation files failed.",o),t(r)}}return{getNLSConfiguration:S}}if(typeof define=="function")define(x[100],ee([43,21,101]),function(H,e,h){return Ge(require.__$__nodeRequire,H,e,h)});else if(typeof module=="object"&&typeof module.exports=="object"){const H=require("path"),e=require("fs"),h=require("../common/performance");module.exports=Ge(require,H,e,h)}else throw new Error("Unknown context");define(x[102],ee([0,1,22]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function b(C){const f=C.replace(/\-/g,":").toLowerCase();return!T.has(f)}function _(){return new Promise(async(C,f)=>{const u=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{C(await L())}catch(P){f(P)}finally{clearTimeout(u)}})}e.getMac=_;function L(){return new Promise((C,f)=>{try{const u=h.networkInterfaces();for(const[,P]of Object.entries(u))for(const g of P)if(b(g.mac))return C(g.mac);f("Unable to retrieve mac address (unexpected format)")}catch(u){f(u)}})}}),define(x[103],ee([0,1,14,26,22,30,102]),function(H,e,h,T,b,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=_.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,g=0;const p=b.networkInterfaces();for(let v in p)if(Object.prototype.hasOwnProperty.call(p,v))for(const{mac:c,internal:E}of p[v])E||(g+=1,this._isVirtualMachineMacAdress(c.toUpperCase())&&(P+=1));this._value=g>0?P/g:0}return this._value}};let C;async function f(){return C||(C=(async()=>await u()||T.generateUuid())()),C}e.getMachineId=f;async function u(){try{const P=await new Promise((p,v)=>{H(["crypto"],p,v)}),g=await L.getMac();return P.createHash("sha256").update(g,"utf8").digest("hex")}catch(P){h.onUnexpectedError(P);return}}}),define(x[104],ee([0,1,10]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDefaultUserDataPath=void 0;const T=h.FileAccess.asFileUri("paths",H).fsPath,b=H.__$__nodeRequire(T);e.getDefaultUserDataPath=b.getDefaultUserDataPath}),define(x[12],ee([0,1,21,22,3,15,4,5,37,34,26,63]),function(H,e,h,T,b,_,L,C,f,u,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.copy=e.move=e.whenDeleted=e.fileExists=e.dirExists=e.readDirsInDir=e.writeFileSync=e.writeFile=e.mkdirp=e.readFile=e.truncate=e.symlink=e.unlink=e.readlink=e.renameIgnoreError=e.rename=e.lstat=e.statLink=e.stat=e.chmod=e.exists=e.readdirSync=e.readdirWithFileTypes=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=e.MAX_HEAP_SIZE=e.MAX_FILE_SIZE=void 0;const p=300*1024*1024,v=16*1024*1024*1024,c=700*1024*1024,E=700*2*1024*1024;e.MAX_FILE_SIZE=process.arch==="ia32"?p:v,e.MAX_HEAP_SIZE=process.arch==="ia32"?c:E;var S;(function(ie){ie[ie.UNLINK=0]="UNLINK",ie[ie.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function w(ie,ae=S.UNLINK){if(u.isRootOrDriveLetter(ie))throw new Error("rimraf - will refuse to recursively delete root");return ae===S.UNLINK?y(ie):a(ie)}e.rimraf=w;async function y(ie){try{const ae=await R(ie);if(ae.isDirectory()&&!ae.isSymbolicLink()){const ue=await s(ie);await Promise.all(ue.map(ye=>y(b.join(ie,ye)))),await f.promisify(h.rmdir)(ie)}else{const ue=ae.mode;return ue&h.constants.S_IWUSR||await n(ie,ue|h.constants.S_IWUSR),U(ie)}}catch(ae){if(ae.code!=="ENOENT")throw ae}}async function a(ie){try{const ae=b.join(T.tmpdir(),P.generateUuid());try{await D(ie,ae)}catch(ue){return y(ie)}y(ae)}catch(ae){if(ae.code!=="ENOENT")throw ae}}function r(ie){if(u.isRootOrDriveLetter(ie))throw new Error("rimraf - will refuse to recursively delete root");try{const ae=h.lstatSync(ie);if(ae.isDirectory()&&!ae.isSymbolicLink())o(ie).map(ye=>r(b.join(ie,ye))),h.rmdirSync(ie);else{const ue=ae.mode;return ue&h.constants.S_IWUSR||h.chmodSync(ie,ue|h.constants.S_IWUSR),h.unlinkSync(ie)}}catch(ae){if(ae.code!=="ENOENT")throw ae}}e.rimrafSync=r;async function s(ie){return i(await f.promisify(h.readdir)(ie))}e.readdir=s;async function t(ie){const ae=await f.promisify(h.readdir)(ie,{withFileTypes:!0});if(L.isMacintosh)for(const ue of ae)ue.name=g.normalizeNFC(ue.name);return ae}e.readdirWithFileTypes=t;function o(ie){return i(h.readdirSync(ie))}e.readdirSync=o;function i(ie){return L.isMacintosh?ie.map(ae=>g.normalizeNFC(ae)):ie}function l(ie){return f.promisify(h.exists)(ie)}e.exists=l;function n(ie,ae){return f.promisify(h.chmod)(ie,ae)}e.chmod=n;function d(ie){return f.promisify(h.stat)(ie)}e.stat=d;async function I(ie){let ae;try{if(ae=await R(ie),!ae.isSymbolicLink())return{stat:ae}}catch(ue){}try{return{stat:await d(ie),symbolicLink:(ae==null?void 0:ae.isSymbolicLink())?{dangling:!1}:void 0}}catch(ue){if(ue.code==="ENOENT"&&ae)return{stat:ae,symbolicLink:{dangling:!0}};if(L.isWindows&&ue.code==="EACCES"&&ae)try{return{stat:await d(await A(ie)),symbolicLink:ae.isSymbolicLink()?{dangling:!1}:void 0}}catch(ye){if(ye.code==="ENOENT")return{stat:ae,symbolicLink:{dangling:!0}};throw ye}throw ue}}e.statLink=I;function R(ie){return f.promisify(h.lstat)(ie)}e.lstat=R;function D(ie,ae){return f.promisify(h.rename)(ie,ae)}e.rename=D;function m(ie,ae){return new Promise(ue=>h.rename(ie,ae,()=>ue()))}e.renameIgnoreError=m;function A(ie){return f.promisify(h.readlink)(ie)}e.readlink=A;function U(ie){return f.promisify(h.unlink)(ie)}e.unlink=U;function q(ie,ae,ue){return f.promisify(h.symlink)(ie,ae,ue)}e.symlink=q;function M(ie,ae){return f.promisify(h.truncate)(ie,ae)}e.truncate=M;function W(ie,ae){return f.promisify(h.readFile)(ie,ae)}e.readFile=W;async function N(ie,ae){return f.promisify(h.mkdir)(ie,{mode:ae,recursive:!0})}e.mkdirp=N;const K=new Map;function j(ie,ae,ue){const ye=$(ie);return J(ye).queue(()=>{const Ce=F(ue);return new Promise((Le,me)=>k(ie,ae,Ce,de=>de?me(de):Le()))})}e.writeFile=j;function $(ie){let ae=ie;return(L.isWindows||L.isMacintosh)&&(ae=ae.toLowerCase()),ae}function J(ie){const ae=K.get(ie);if(ae)return ae;const ue=new _.Queue;return K.set(ie,ue),C.Event.once(ue.onFinished)(()=>{K.delete(ie),ue.dispose()}),ue}let B=!0;function k(ie,ae,ue,ye){if(!B)return h.writeFile(ie,ae,{mode:ue.mode,flag:ue.flag},ye);h.open(ie,ue.flag,ue.mode,(Ce,Le)=>{if(Ce)return ye(Ce);h.writeFile(Le,ae,me=>{if(me)return h.close(Le,()=>ye(me));h.fdatasync(Le,de=>(de&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",de),B=!1),h.close(Le,Ee=>ye(Ee))))})})}function O(ie,ae,ue){const ye=F(ue);if(!B)return h.writeFileSync(ie,ae,{mode:ye.mode,flag:ye.flag});const Ce=h.openSync(ie,ye.flag,ye.mode);try{h.writeFileSync(Ce,ae);try{h.fdatasyncSync(Ce)}catch(Le){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Le),B=!1}}finally{h.closeSync(Ce)}}e.writeFileSync=O;function F(ie){return ie?{mode:typeof ie.mode=="number"?ie.mode:438,flag:typeof ie.flag=="string"?ie.flag:"w"}:{mode:438,flag:"w"}}async function z(ie){const ae=await s(ie),ue=[];for(const ye of ae)await G(b.join(ie,ye))&&ue.push(ye);return ue}e.readDirsInDir=z;async function G(ie){try{const{stat:ae,symbolicLink:ue}=await I(ie);return ae.isDirectory()&&(ue==null?void 0:ue.dangling)!==!0}catch(ae){}return!1}e.dirExists=G;async function Y(ie){try{const{stat:ae,symbolicLink:ue}=await I(ie);return ae.isFile()&&(ue==null?void 0:ue.dangling)!==!0}catch(ae){}return!1}e.fileExists=Y;function Q(ie){return new Promise(ae=>{let ue=!1;const ye=setInterval(()=>{ue||(ue=!0,h.exists(ie,Ce=>{ue=!1,Ce||(clearInterval(ye),ae(void 0))}))},1e3)})}e.whenDeleted=Q;async function Z(ie,ae){if(ie!==ae){async function ue(ye){const Ce=await R(ye);if(!(Ce.isDirectory()||Ce.isSymbolicLink())){const Le=await f.promisify(h.open)(ye,"a");try{await f.promisify(h.futimes)(Le,Ce.atime,new Date)}catch(me){}return f.promisify(h.close)(Le)}}try{await D(ie,ae),await ue(ae)}catch(ye){if(ie.toLowerCase()!==ae.toLowerCase()&&ye.code==="EXDEV"||ie.endsWith("."))await le(ie,ae),await w(ie,S.MOVE),await ue(ae);else throw ye}}}e.move=Z;const se=511;async function le(ie,ae,ue){const ye=ue!=null?ue:Object.create(null);if(!ye[ie]){ye[ie]=!0;const{stat:Ce,symbolicLink:Le}=await I(ie);if(!(Le==null?void 0:Le.dangling)){if(!Ce.isDirectory())return fe(ie,ae,Ce.mode&se);await N(ae,Ce.mode&se);const me=await s(ie);for(let de=0;de<me.length;de++){const Ee=me[de];await le(b.join(ie,Ee),b.join(ae,Ee),ye)}}}}e.copy=le;async function fe(ie,ae,ue){return new Promise((ye,Ce)=>{const Le=h.createReadStream(ie),me=h.createWriteStream(ae,{mode:ue});let de=!1;const Ee=be=>{if(!de){if(de=!0,be)return Ce(be);h.chmod(ae,ue,Re=>Re?Ce(Re):ye())}};Le.once("error",be=>Ee(be)),me.once("error",be=>Ee(be)),me.once("close",()=>Ee()),Le.pipe(me)})}}),define(x[105],ee([0,1,21,16,3,12,37]),function(H,e,h,T,b,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function C(g){const p=b.dirname(g);if(g===p)return g;const v=(b.basename(g)||g).toLowerCase();try{const E=_.readdirSync(p).filter(S=>S.toLowerCase()===v);if(E.length===1){const S=C(p);if(S)return b.join(S,E[0])}else if(E.length>1){const S=E.indexOf(v);if(S>=0){const w=C(p);if(w)return b.join(w,E[S])}}}catch(c){}return null}e.realcaseSync=C;async function f(g){try{return await L.promisify(h.realpath)(g)}catch(p){const v=P(g);return await L.promisify(h.access)(v,h.constants.R_OK),v}}e.realpath=f;function u(g){try{return h.realpathSync(g)}catch(p){const v=P(g);return h.accessSync(v,h.constants.R_OK),v}}e.realpathSync=u;function P(g){return T.rtrim(b.normalize(g),b.sep)}});var Ae=this&&this.__await||function(H){return this instanceof Ae?(this.v=H,this):new Ae(H)},He=this&&this.__asyncGenerator||function(H,e,h){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var T=h.apply(H,e||[]),b,_=[];return b={},L("next"),L("throw"),L("return"),b[Symbol.asyncIterator]=function(){return this},b;function L(p){T[p]&&(b[p]=function(v){return new Promise(function(c,E){_.push([p,v,c,E])>1||C(p,v)})})}function C(p,v){try{f(T[p](v))}catch(c){g(_[0][3],c)}}function f(p){p.value instanceof Ae?Promise.resolve(p.value.v).then(u,P):g(_[0][2],p)}function u(p){C("next",p)}function P(p){C("throw",p)}function g(p,v){p(v),_.shift(),_.length&&C(_[0][0],_[0][1])}},Ve=this&&this.__asyncValues||function(H){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=H[Symbol.asyncIterator],h;return e?e.call(H):(H=typeof __values=="function"?__values(H):H[Symbol.iterator](),h={},T("next"),T("throw"),T("return"),h[Symbol.asyncIterator]=function(){return this},h);function T(_){h[_]=H[_]&&function(L){return new Promise(function(C,f){L=H[_](L),b(C,f,L.done,L.value)})}}function b(_,L,C,f){Promise.resolve(f).then(function(u){_({value:u,done:C})},L)}};define(x[66],ee([0,1,12,22,3,33]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L="Windows PowerShell",C="Windows PowerShell (x86)",f=/^\d+$/,u=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/,g=process.arch==="x64",p=g||T.arch()==="x64";class v{constructor(i,l,n){this.exePath=i,this.displayName=l,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await h.fileExists(this.exePath)),this.knownToExist}}function c({useAlternateBitness:o=!1}={}){return o?g?_.env["ProgramFiles(x86)"]||null:p&&_.env.ProgramW6432||null:_.env.ProgramFiles||null}function E({useAlternateBitness:o=!1}={}){const i=_.env.windir;return o?g?b.join(i,"SysWOW64"):p?b.join(i,"Sysnative"):b.join(i,"System32"):b.join(i,"System32")}async function S({useAlternateBitness:o=!1,findPreview:i=!1}={}){const l=c({useAlternateBitness:o});if(!l)return null;const n=b.join(l,"PowerShell");if(!await h.dirExists(n))return null;let d=-1,I=null;for(const m of await h.readdir(n)){let A=-1;if(i){const q=m.indexOf("-");if(q<0)continue;const M=m.substring(0,q);if(!f.test(M)||m.substring(q+1)!=="preview")continue;A=parseInt(M,10)}else{if(!f.test(m))continue;A=parseInt(m,10)}if(!(A<=d)){const U=b.join(n,m,"pwsh.exe");!await h.fileExists(U)||(I=U,d=A)}}if(!I)return null;const R=l.includes("x86")?" (x86)":"",D=i?" Preview":"";return new v(I,`PowerShell${D}${R}`,!0)}async function w({findPreview:o}={}){if(!_.env.LOCALAPPDATA)return null;const i=b.join(_.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await h.dirExists(i))return null;const{pwshMsixDirRegex:l,pwshMsixName:n}=o?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:u,pwshMsixName:"PowerShell (Store)"};for(const d of await h.readdir(i))if(l.test(d)){const I=b.join(i,d,"pwsh.exe");return new v(I,n)}return null}function y(){const o=b.join(T.homedir(),".dotnet","tools","pwsh.exe");return new v(o,".NET Core PowerShell Global Tool")}function a({useAlternateBitness:o=!1}={}){if(!p&&o)return null;const i=E({useAlternateBitness:o}),l=b.join(i,"WindowsPowerShell","v1.0","powershell.exe");let n;return g?n=o?C:L:p?n=o?L:C:n=C,new v(l,n,!0)}function r(){return He(this,arguments,function*(){let i=yield Ae(S());i&&(yield yield Ae(i)),i=yield Ae(S({useAlternateBitness:!0})),i&&(yield yield Ae(i)),i=yield Ae(w()),i&&(yield yield Ae(i)),i=y(),i&&(yield yield Ae(i)),i=yield Ae(S({findPreview:!0})),i&&(yield yield Ae(i)),i=yield Ae(w({findPreview:!0})),i&&(yield yield Ae(i)),i=yield Ae(S({useAlternateBitness:!0,findPreview:!0})),i&&(yield yield Ae(i)),i=a(),i&&(yield yield Ae(i)),i=a({useAlternateBitness:!0}),i&&(yield yield Ae(i))})}function s(){return He(this,arguments,function*(){var i,l;try{for(var n=Ve(r()),d;d=yield Ae(n.next()),!d.done;){const I=d.value;(yield Ae(I.exists()))&&(yield yield Ae(I))}}catch(I){i={error:I}}finally{try{d&&!d.done&&(l=n.return)&&(yield Ae(l.call(n)))}finally{if(i)throw i.error}}})}e.enumeratePowerShellInstallations=s;async function t(){var o,i;try{for(var l=Ve(s()),n;n=await l.next(),!n.done;)return n.value}catch(d){o={error:d}}finally{try{n&&!n.done&&(i=l.return)&&await i.call(l)}finally{if(o)throw o.error}}return null}e.getFirstAvailablePowerShellInstallation=t}),define(x[106],ee([0,1,35,201,202]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.monkeyPatch=void 0;function _(f){if(C()){const u=H("http"),P=H("https"),g=L(f);u.globalAgent=g,P.globalAgent=g}}e.monkeyPatch=_;function L(f){return f?new T:new T.default}function C(){let f=!1;const u=b.getProxyForUrl("http://example.com");u&&(f=!0,h.logger.debug(`using $HTTP_PROXY ${u}`));const P=b.getProxyForUrl("https://example.com");return P&&(f=!0,h.logger.debug(`using $HTTPS_PROXY ${P}`)),f}}),define(x[107],ee([0,1,3,21,4,63,2,12]),function(H,e,h,T,b,_,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function f(g,p,v){return P({path:g,isDirectory:!1},p,v)}e.watchFile=f;function u(g,p,v){return P({path:g,isDirectory:!0},p,v)}e.watchFolder=u,e.CHANGE_BUFFER_DELAY=100;function P(g,p,v){const c=h.basename(g.path),E=new Map;let S=!1,w=[L.toDisposable(()=>{E.forEach(y=>L.dispose(y)),E.clear()})];try{const y=T.watch(g.path);w.push(L.toDisposable(()=>{y.removeAllListeners(),y.close()}));const a=new Set;g.isDirectory&&C.readdir(g.path).then(r=>r.forEach(s=>a.add(s))),y.on("error",(r,s)=>{S||v(`Failed to watch ${g.path} for changes using fs.watch() (${r}, ${s})`)}),y.on("change",(r,s)=>{if(!S){let t="";if(s&&(t=s.toString(),b.isMacintosh&&(t=_.normalizeNFC(t))),!(!t||r!=="change"&&r!=="rename")){const o=g.isDirectory?h.join(g.path,t):g.path;if(g.isDirectory)if(r==="rename"){const i=E.get(o);i&&L.dispose(i);const l=setTimeout(async()=>{E.delete(o);const n=await C.exists(o);if(!S){let d;n?a.has(t)?d="changed":(d="added",a.add(t)):(a.delete(t),d="deleted"),p(d,o)}},e.CHANGE_BUFFER_DELAY);E.set(o,L.toDisposable(()=>clearTimeout(l)))}else{let i;a.has(t)?i="changed":(i="added",a.add(t)),p(i,o)}else if(r==="rename"||t!==c){const i=setTimeout(async()=>{const l=await C.exists(o);S||(l?(p("changed",o),w=[P(g,p,v)]):p("deleted",o))},e.CHANGE_BUFFER_DELAY);L.dispose(w),w=[L.toDisposable(()=>clearTimeout(i))]}else p("changed",o)}}})}catch(y){C.exists(g.path).then(a=>{a&&!S&&v(`Failed to watch ${g.path} for changes using fs.watch() (${y.toString()})`)})}return L.toDisposable(()=>{S=!0,w=L.dispose(w)})}}),define(x[36],ee([0,1,5,2,15,25,14,17,18,11,99,16]),function(H,e,h,T,b,_,L,C,f,u,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.createChannelSender=e.createChannelReceiver=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(k){k[k.Promise=100]="Promise",k[k.PromiseCancel=101]="PromiseCancel",k[k.EventListen=102]="EventListen",k[k.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function v(k){switch(k){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(k){k[k.Initialize=200]="Initialize",k[k.PromiseSuccess=201]="PromiseSuccess",k[k.PromiseError=202]="PromiseError",k[k.PromiseErrorObj=203]="PromiseErrorObj",k[k.EventFire=204]="EventFire"})(c=e.ResponseType||(e.ResponseType={}));function E(k){switch(k){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(k){k[k.Uninitialized=0]="Uninitialized",k[k.Idle=1]="Idle"})(S||(S={}));class w{constructor(O){this.buffer=O,this.pos=0}read(O){const F=this.buffer.slice(this.pos,this.pos+O);return this.pos+=F.byteLength,F}}class y{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var a;(function(k){k[k.Undefined=0]="Undefined",k[k.String=1]="String",k[k.Buffer=2]="Buffer",k[k.VSBuffer=3]="VSBuffer",k[k.Array=4]="Array",k[k.Object=5]="Object"})(a||(a={}));function r(k){const O=C.VSBuffer.alloc(4);return O.writeUInt32BE(k,0),O}function s(k){return k.read(4).readUInt32BE(0)}function t(k){const O=C.VSBuffer.alloc(1);return O.writeUInt8(k,0),O}const o={Undefined:t(a.Undefined),String:t(a.String),Buffer:t(a.Buffer),VSBuffer:t(a.VSBuffer),Array:t(a.Array),Object:t(a.Object)},i=typeof Buffer!="undefined";function l(k,O){if(typeof O=="undefined")k.write(o.Undefined);else if(typeof O=="string"){const F=C.VSBuffer.fromString(O);k.write(o.String),k.write(r(F.byteLength)),k.write(F)}else if(i&&Buffer.isBuffer(O)){const F=C.VSBuffer.wrap(O);k.write(o.Buffer),k.write(r(F.byteLength)),k.write(F)}else if(O instanceof C.VSBuffer)k.write(o.VSBuffer),k.write(r(O.byteLength)),k.write(O);else if(Array.isArray(O)){k.write(o.Array),k.write(r(O.length));for(const F of O)l(k,F)}else{const F=C.VSBuffer.fromString(JSON.stringify(O));k.write(o.Object),k.write(r(F.byteLength)),k.write(F)}}function n(k){switch(k.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return k.read(s(k)).toString();case a.Buffer:return k.read(s(k)).buffer;case a.VSBuffer:return k.read(s(k));case a.Array:{const F=s(k),z=[];for(let G=0;G<F;G++)z.push(n(k));return z}case a.Object:return JSON.parse(k.read(s(k)).toString())}}class d{constructor(O,F,z=null,G=1e3){this.protocol=O,this.ctx=F,this.logger=z,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Y=>this.onRawMessage(Y)),this.sendResponse({type:200})}registerChannel(O,F){this.channels.set(O,F),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const F=this.send([O.type]);this.logger&&this.logger.logOutgoing(F,0,1,E(O.type));return}case 201:case 202:case 204:case 203:{const F=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(F,O.id,1,E(O.type),O.data);return}}}send(O,F=void 0){const z=new y;return l(z,O),l(z,F),this.sendBuffer(z.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(F){return 0}}onRawMessage(O){const F=new w(O),z=n(F),G=n(F),Y=z[0];switch(Y){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${v(Y)}: ${z[2]}.${z[3]}`,G),this.onPromise({type:Y,id:z[1],channelName:z[2],name:z[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${v(Y)}: ${z[2]}.${z[3]}`,G),this.onEventListen({type:Y,id:z[1],channelName:z[2],name:z[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${v(Y)}`),this.disposeActiveRequest({type:Y,id:z[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${v(Y)}`),this.disposeActiveRequest({type:Y,id:z[1]})}}onPromise(O){const F=this.channels.get(O.channelName);if(!F){this.collectPendingRequest(O);return}const z=new _.CancellationTokenSource;let G;try{G=F.call(this.ctx,O.name,O.arg,z.token)}catch(Z){G=Promise.reject(Z)}const Y=O.id;G.then(Z=>{this.sendResponse({id:Y,data:Z,type:201}),this.activeRequests.delete(O.id)},Z=>{Z instanceof Error?this.sendResponse({id:Y,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:Y,data:Z,type:203}),this.activeRequests.delete(O.id)});const Q=T.toDisposable(()=>z.cancel());this.activeRequests.set(O.id,Q)}onEventListen(O){const F=this.channels.get(O.channelName);if(!F){this.collectPendingRequest(O);return}const z=O.id,Y=F.listen(this.ctx,O.name,O.arg)(Q=>this.sendResponse({id:z,data:Q,type:204}));this.activeRequests.set(O.id,Y)}disposeActiveRequest(O){const F=this.activeRequests.get(O.id);F&&(F.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let F=this.pendingRequests.get(O.channelName);F||(F=[],this.pendingRequests.set(O.channelName,F));const z=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:O,timeoutTimer:z})}flushPendingRequests(O){const F=this.pendingRequests.get(O);if(F){for(const z of F)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var I;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(O,F=null){this.protocol=O,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=F}getChannel(O){const F=this;return{call(z,G,Y){return F.isDisposed?Promise.reject(L.canceled()):F.requestPromise(O,z,G,Y)},listen(z,G){return F.isDisposed?Promise.reject(L.canceled()):F.requestEvent(O,z,G)}}}requestPromise(O,F,z,G=_.CancellationToken.None){const Y=this.lastRequestId++,Z={id:Y,type:100,channelName:O,name:F,arg:z};if(G.isCancellationRequested)return Promise.reject(L.canceled());let se;return new Promise((fe,ie)=>{if(G.isCancellationRequested)return ie(L.canceled());const ae=()=>{const Le=me=>{switch(me.type){case 201:this.handlers.delete(Y),fe(me.data);break;case 202:this.handlers.delete(Y);const de=new Error(me.data.message);de.stack=me.data.stack,de.name=me.data.name,ie(de);break;case 203:this.handlers.delete(Y),ie(me.data);break}};this.handlers.set(Y,Le),this.sendRequest(Z)};let ue=null;this.state===S.Idle?ae():(ue=b.createCancelablePromise(Le=>this.whenInitialized()),ue.then(()=>{ue=null,ae()}));const ye=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:Y,type:101}),ie(L.canceled())},Ce=G.onCancellationRequested(ye);se=T.combinedDisposable(T.toDisposable(ye),Ce),this.activeRequests.add(se)}).finally(()=>{this.activeRequests.delete(se)})}requestEvent(O,F,z){const G=this.lastRequestId++,Q={id:G,type:102,channelName:O,name:F,arg:z};let Z=null;const se=new h.Emitter({onFirstListenerAdd:()=>{Z=b.createCancelablePromise(fe=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(se),this.sendRequest(Q)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(se),this.sendRequest({id:G,type:103}))}}),le=fe=>se.fire(fe.data);return this.handlers.set(G,le),se.event}sendRequest(O){switch(O.type){case 100:case 102:{const F=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(F,O.id,0,`${v(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const F=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(F,O.id,0,v(O.type));return}}}send(O,F=void 0){const z=new y;return l(z,O),l(z,F),this.sendBuffer(z.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(F){return 0}}onBuffer(O){const F=new w(O),z=n(F),G=n(F),Y=z[0];switch(Y){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,E(Y)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],0,E(Y),G),this.onResponse({type:z[0],id:z[1],data:G})}}onResponse(O){if(O.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const F=this.handlers.get(O.id);F&&F(O)}whenInitialized(){return this.state===S.Idle?Promise.resolve():h.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelClient=R;class D{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:F,onDidClientDisconnect:z})=>{h.Event.once(F.onMessage)(Y=>{const Q=new w(Y),Z=n(Q),se=new d(F,Z),le=new R(F);this.channels.forEach((ie,ae)=>se.registerChannel(ae,ie));const fe={channelServer:se,channelClient:le,ctx:Z};this._connections.add(fe),this._onDidAddConnection.fire(fe),z(()=>{se.dispose(),le.dispose(),this._connections.delete(fe),this._onDidRemoveConnection.fire(fe)})})})}get connections(){const O=[];return this._connections.forEach(F=>O.push(F)),O}getChannel(O,F){const z=this;return{call(G,Y,Q){let Z;if(u.isFunction(F)){let le=f.getRandomElement(z.connections.filter(F));Z=le?Promise.resolve(le):h.Event.toPromise(h.Event.filter(z.onDidAddConnection,F))}else Z=F.routeCall(z,G,Y);const se=Z.then(le=>le.channelClient.getChannel(O));return A(se).call(G,Y,Q)},listen(G,Y){if(u.isFunction(F))return z.getMulticastEvent(O,F,G,Y);const Q=F.routeEvent(z,G,Y).then(Z=>Z.channelClient.getChannel(O));return A(Q).listen(G,Y)}}}getMulticastEvent(O,F,z,G){const Y=this;let Q=new T.DisposableStore;const Z=new h.Emitter({onFirstListenerAdd:()=>{Q=new T.DisposableStore;const se=new h.EventMultiplexer,le=new Map,fe=ae=>{const ye=ae.channelClient.getChannel(O).listen(z,G),Ce=se.add(ye);le.set(ae,Ce)},ie=ae=>{const ue=le.get(ae);!ue||(ue.dispose(),le.delete(ae))};Y.connections.filter(F).forEach(fe),h.Event.filter(Y.onDidAddConnection,F)(fe,void 0,Q),Y.onDidRemoveConnection(ie,void 0,Q),se.event(Z.fire,Z,Q),Q.add(se)},onLastListenerRemove:()=>{Q.dispose()}});return Z.event}registerChannel(O,F){this.channels.set(O,F),this._connections.forEach(z=>{z.channelServer.registerChannel(O,F)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=D;class m{constructor(O,F,z=null){const G=new y;l(G,F),O.send(G.buffer),this.channelClient=new R(O,z),this.channelServer=new d(O,F,z)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,F){this.channelServer.registerChannel(O,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=m;function A(k){return{call(O,F,z){return k.then(G=>G.call(O,F,z))},listen(O,F){const z=new h.Relay;return k.then(G=>z.input=G.listen(O,F)),z.event}}}e.getDelayedChannel=A;function U(k){let O=!1;return{call(F,z,G){return O?k.call(F,z,G):b.timeout(0).then(()=>O=!0).then(()=>k.call(F,z,G))},listen(F,z){if(O)return k.listen(F,z);const G=new h.Relay;return b.timeout(0).then(()=>O=!0).then(()=>G.input=k.listen(F,z)),G.event}}}e.getNextTickChannel=U;class q{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const F of O.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await h.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=q;function M(k,O){const F=k,z=O&&O.disableMarshalling,G=new Map;for(const Y in F)N(Y)&&G.set(Y,h.Event.buffer(F[Y],!0));return new class{listen(Y,Q){const Z=G.get(Q);if(Z)return Z;throw new Error(`Event not found: ${Q}`)}call(Y,Q,Z){const se=F[Q];if(typeof se=="function"){if(!z&&Array.isArray(Z))for(let le=0;le<Z.length;le++)Z[le]=P.revive(Z[le]);return se.apply(F,Z)}throw new Error(`Method not found: ${Q}`)}}}e.createChannelReceiver=M;function W(k,O){const F=O&&O.disableMarshalling;return new Proxy({},{get(z,G){var Y;if(typeof G=="string")return((Y=O==null?void 0:O.properties)===null||Y===void 0?void 0:Y.has(G))?O.properties.get(G):N(G)?k.listen(G):async function(...Q){let Z;O&&!u.isUndefinedOrNull(O.context)?Z=[O.context,...Q]:Z=Q;const se=await k.call(G,Z);return F?se:P.revive(se)};throw new Error(`Property not found: ${String(G)}`)}})}e.createChannelSender=W;function N(k){return k[0]==="o"&&k[1]==="n"&&g.isUpperAsciiLetter(k.charCodeAt(2))}const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(k){if(Array.isArray(k))return k;if(k&&typeof k=="object"&&typeof k.toString=="function"){let O=k.toString();if(O!=="[object Object]")return O}return k}function $(k){return Array.isArray(k)?k.map(j):j(k)}function J(k,O,F,z,G,Y,Q){Q=$(Q);const Z=K[G],se=Z[z%Z.length];let le=[`%c[${k}]%c[${String(O).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${se}`];/\($/.test(Y)?(le=le.concat(Q),le.push(")")):le.push(Q),console.log.apply(console,le)}e.logWithColors=J;class B{constructor(O,F){this._outgoingPrefix=O,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,F,z,G,Y){this._totalOutgoing+=O,J(this._outgoingPrefix,this._totalOutgoing,O,F,z,G,Y)}logIncoming(O,F,z,G,Y){this._totalIncoming+=O,J(this._incomingPrefix,this._totalIncoming,O,F,z,G,Y)}}e.IPCLogger=B}),define(x[67],ee([0,1,5,36,2,17,4,33]),function(H,e,h,T,b,_,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let f=null;function u(){return f||(f=_.VSBuffer.alloc(0)),f}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,l){if(i===0)return u();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const R=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=i),R}if(this._chunks[0].byteLength>i){const R=this._chunks[0].slice(0,i);return l&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),R}let n=_.VSBuffer.alloc(i),d=0,I=0;for(;i>0;){const R=this._chunks[I];if(R.byteLength>i){const D=R.slice(0,i);n.set(D,d),d+=i,l&&(this._chunks[I]=R.slice(i),this._totalLength-=i),i-=i}else n.set(R,d),d+=R.byteLength,l?(this._chunks.shift(),this._totalLength-=R.byteLength):I++,i-=R.byteLength}return n}}e.ChunkStream=P;var g;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.KeepAlive=4]="KeepAlive",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var p;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",o[o.KeepAliveTime=5e3]="KeepAliveTime",o[o.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(i,l,n,d){this.type=i,this.id=l,this.ack=n,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends b.Disposable{constructor(i){super();this._onMessage=this._register(new h.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const n=this._state.messageType,d=this._state.id,I=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new v(n,d,I,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class E{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(!this._isDisposed){i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=_.VSBuffer.alloc(13);l.writeUInt8(i.type,0),l.writeUInt32BE(i.id,1),l.writeUInt32BE(i.ack,5),l.writeUInt32BE(i.data.byteLength,9),this._writeSoon(l,i.data)}}_bufferAdd(i,l){const n=this._totalLength===0;return this._data.push(i,l),this._totalLength+=i.byteLength+l.byteLength,n}_bufferTake(){const i=_.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,l){this._bufferAdd(i,l)&&L.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends b.Disposable{constructor(i){super();this._onMessage=new h.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new h.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new E(this._socket)),this._socketReader=this._register(new c(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new v(1,0,0,i))}}e.Protocol=S;class w extends T.IPCClient{constructor(i,l,n=null){super(i,l,n);this.protocol=i}static fromSocket(i,l){return new w(new S(i),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=w;class y{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new h.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,C.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=y;class a{constructor(i){this.data=i,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],l=0,n=this._first;for(;n;)i[l++]=n.data,n=n.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const l=new a(i);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class s{constructor(){this.lastRuns=[];const i=Date.now();for(let l=0;l<s._HISTORY_LENGTH;l++)this.lastRuns[l]=i-1e3*l;setInterval(()=>{for(let l=s._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const i=Date.now(),l=(1+s._HISTORY_LENGTH)*1e3;let n=0;for(let d=0;d<s._HISTORY_LENGTH;d++)i-this.lastRuns[d]<=l&&n++;return 1-n/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(i,l=null){this._loadEstimator=s.getInstance(),this._onControlMessage=new y,this.onControlMessage=this._onControlMessage.event,this._onMessage=new y,this.onMessage=this._onMessage.event,this._onDidDispose=new y,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new y,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new y,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=b.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new v(5,0,0,u());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const l=new v(4,0,0,u());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,l){this._isReconnecting=!0,this._socketDisposables=b.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let l=0,n=i.length;l<n;l++)this._socketWriter.write(i[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new v(6,0,0,u())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const l=this._outgoingUnackMsg.toArray();for(let n=0,d=l.length;n<d;n++)this._socketWriter.write(l[n]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new v(1,l,this._incomingAckId,i);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(i){const l=new v(2,0,0,i);this._socketWriter.write(l)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const i=this._outgoingUnackMsg.peek(),l=Date.now()-i.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const i=new v(3,0,this._incomingAckId,u());this._socketWriter.write(i)}}}e.PersistentProtocol=t}),define(x[108],ee([8,9]),function(H,e){return H.create("vs/base/common/actions",e)}),define(x[109],ee([0,1,108,2,5]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.ActionWithMenuAction=e.Separator=e.RadioGroup=e.ActionRunner=e.Action=void 0;class _ extends T.Disposable{constructor(c,E="",S="",w=!0,y){super();this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._checked=!1,this._id=c,this._label=E,this._cssClass=S,this._enabled=w,this._actionCallback=y}get id(){return this._id}get label(){return this._label}set label(c){this._setLabel(c)}_setLabel(c){this._label!==c&&(this._label=c,this._onDidChange.fire({label:c}))}get tooltip(){return this._tooltip||""}set tooltip(c){this._setTooltip(c)}_setTooltip(c){this._tooltip!==c&&(this._tooltip=c,this._onDidChange.fire({tooltip:c}))}get class(){return this._cssClass}set class(c){this._setClass(c)}_setClass(c){this._cssClass!==c&&(this._cssClass=c,this._onDidChange.fire({class:c}))}get enabled(){return this._enabled}set enabled(c){this._setEnabled(c)}_setEnabled(c){this._enabled!==c&&(this._enabled=c,this._onDidChange.fire({enabled:c}))}get checked(){return this._checked}set checked(c){this._setChecked(c)}_setChecked(c){this._checked!==c&&(this._checked=c,this._onDidChange.fire({checked:c}))}run(c,E){return this._actionCallback?this._actionCallback(c):Promise.resolve(!0)}}e.Action=_;class L extends T.Disposable{constructor(){super(...arguments);this._onBeforeRun=this._register(new b.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new b.Emitter),this.onDidRun=this._onDidRun.event}async run(c,E){if(!c.enabled)return Promise.resolve(null);this._onBeforeRun.fire({action:c});try{const S=await this.runAction(c,E);this._onDidRun.fire({action:c,result:S})}catch(S){this._onDidRun.fire({action:c,error:S})}}runAction(c,E){const S=E?c.run(E):c.run();return Promise.resolve(S)}}e.ActionRunner=L;class C extends T.Disposable{constructor(c){super();this.actions=c;for(const E of c)this._register(E.onDidChange(S=>{if(S.checked&&E.checked)for(const w of c)w!==E&&(w.checked=!1)}))}}e.RadioGroup=C;class f extends _{constructor(c){super(f.ID,c,c?"separator text":"separator");this.checked=!1,this.enabled=!1}}e.Separator=f,f.ID="vs.actions.separator";class u extends _{constructor(c,E,S,w,y,a){super(c,S,w,y,a);this._actions=E}get actions(){return this._actions}}e.ActionWithMenuAction=u;class P{constructor(c,E,S,w){this.tooltip="",this.enabled=!0,this.checked=!1,this.id=c,this.label=E,this.class=w,this._actions=S}dispose(){}get actions(){return this._actions}async run(){}}e.SubmenuAction=P;class g extends _{constructor(){super(g.ID,h.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=g,g.ID="vs.actions.empty";function p(v){var c,E;return{id:v.id,label:v.label,class:void 0,enabled:(c=v.enabled)!==null&&c!==void 0?c:!0,checked:(E=v.checked)!==null&&E!==void 0?E:!1,run:async()=>v.run(),tooltip:v.label,dispose:()=>{}}}e.toAction=p}),define(x[110],ee([8,9]),function(H,e){return H.create("vs/base/common/date",e)}),define(x[111],ee([0,1,110]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,b=T*60,_=b*24,L=_*7,C=_*30,f=_*365;function u(g,p){typeof g!="number"&&(g=g.getTime());const v=Math.round((new Date().getTime()-g)/1e3);if(v<-30)return h.localize(0,null,u(new Date().getTime()+v*1e3,!1));if(v<30)return h.localize(1,null);let c;return v<T?(c=v,p?c===1?h.localize(2,null,c):h.localize(3,null,c):c===1?h.localize(4,null,c):h.localize(5,null,c)):v<b?(c=Math.floor(v/T),p?c===1?h.localize(6,null,c):h.localize(7,null,c):c===1?h.localize(8,null,c):h.localize(9,null,c)):v<_?(c=Math.floor(v/b),p?c===1?h.localize(10,null,c):h.localize(11,null,c):c===1?h.localize(12,null,c):h.localize(13,null,c)):v<L?(c=Math.floor(v/_),p?c===1?h.localize(14,null,c):h.localize(15,null,c):c===1?h.localize(16,null,c):h.localize(17,null,c)):v<C?(c=Math.floor(v/L),p?c===1?h.localize(18,null,c):h.localize(19,null,c):c===1?h.localize(20,null,c):h.localize(21,null,c)):v<f?(c=Math.floor(v/C),p?c===1?h.localize(22,null,c):h.localize(23,null,c):c===1?h.localize(24,null,c):h.localize(25,null,c)):(c=Math.floor(v/f),p?c===1?h.localize(26,null,c):h.localize(27,null,c):c===1?h.localize(28,null,c):h.localize(29,null,c))}e.fromNow=u;function P(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(x[112],ee([8,9]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(x[38],ee([0,1,112,11,18]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(u,P){return P&&(u.stack||u.stacktrace)?h.localize(0,null,C(u),L(u.stack)||L(u.stacktrace)):C(u)}function L(u){return Array.isArray(u)?u.join(`
`):u}function C(u){return typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?h.localize(1,null,u.message):u.message||h.localize(2,null)}function f(u=null,P=!1){if(!u)return h.localize(3,null);if(Array.isArray(u)){const g=b.coalesce(u),p=f(g[0],P);return g.length>1?h.localize(4,null,p,g.length):p}if(T.isString(u))return u;if(u.detail){const g=u.detail;if(g.error)return _(g.error,P);if(g.exception)return _(g.exception,P)}return u.stack?_(u,P):u.message?u.message:h.localize(5,null)}e.toErrorMessage=f}),define(x[113],ee([8,9]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(x[114],ee([0,1,113]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function T(b){switch(b){case 1:return h.localize(0,null);case 2:return h.localize(1,null);case 3:return h.localize(2,null);case 4:return h.localize(3,null);case 5:return h.localize(4,null);case 6:return h.localize(5,null);case 7:return h.localize(6,null);case 8:return h.localize(7,null);case 9:return h.localize(8,null);default:return""}}e.getParseErrorMessage=T}),define(x[115],ee([8,9]),function(H,e){return H.create("vs/base/node/processes",e)}),define(x[68],ee([0,1,3,21,37,39,115,11,19,34,4,65,10]),function(H,e,h,T,b,_,L,C,f,u,P,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function v(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(r,s){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};s&&(t.cwd=s);const o=_.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],t);return new Promise(i=>{o.once("error",l=>{i({success:!1,error:l})}),o.once("exit",(l,n)=>{i(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?v(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=p.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",H).fsPath;return new Promise(o=>{_.execFile(t,[r.pid.toString()],{encoding:"utf8",shell:!0},(i,l,n)=>{o(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function E(r=process.env){return r.comspec||"cmd.exe"}e.getWindowsShell=E;class S{constructor(s,t,o,i){if(t!==void 0&&o!==void 0&&i!==void 0)this.cmd=s,this.args=t,this.shell=o,this.options=i;else{const l=s;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(process.env).forEach(n=>{l[n]=process.env[n]}),Object.keys(this.options.env).forEach(n=>{l[n]=this.options.env[n]}),this.options.env=l}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const t=s.lastIndexOf(h.sep);return t!==-1&&(s=s.substring(t+1)),S.WellKnowCommands[s]?s:"other"}start(s){return P.isWindows&&(this.options&&this.options.cwd&&u.isUNC(this.options.cwd)||!this.options&&u.isUNC(process.cwd()))?Promise.reject(new Error(L.localize(0,null))):this.useExec().then(t=>{let o,i;const l=new Promise((n,d)=>{o=n,i=d});if(t){let n=this.cmd;this.args&&(n=n+" "+this.args.join(" ")),this.childProcess=_.exec(n,this.options,(d,I,R)=>{this.childProcess=null;const D=d;D&&D.killed?i({killed:this.terminateRequested,stdout:I.toString(),stderr:R.toString()}):this.handleExec(o,s,d,I,R)})}else{let n=null;const d=I=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(I,o,s,i);const R={terminated:this.terminateRequested};C.isNumber(I)&&(R.cmdCode=I),o(R)};if(this.shell&&P.isWindows){const I=f.deepClone(this.options);I.windowsVerbatimArguments=!0,I.detached=!1;let R=!1,D=!1;const m=[];let A=this.ensureQuotes(this.cmd);m.push(A.value),R=A.quoted,this.args&&this.args.forEach(q=>{A=this.ensureQuotes(q),m.push(A.value),D=D&&A.quoted});const U=["/s","/c"];R?D?U.push('"'+m.join(" ")+'"'):m.length>1?U.push('"'+m[0]+'" '+m.slice(1).join(" ")):U.push('"'+m[0]+'"'):U.push(m.join(" ")),n=_.spawn(E(),U,I)}else this.cmd&&(n=_.spawn(this.cmd,this.args,this.options));n&&(this.childProcess=n,this.childProcessPromise=Promise.resolve(n),this.pidResolve&&(this.pidResolve(C.isNumber(n.pid)?n.pid:-1),this.pidResolve=void 0),n.on("error",I=>{this.childProcess=null,i({terminated:this.terminateRequested,error:I})}),n.pid&&(this.childProcess.on("close",d),this.handleSpawn(n,o,s,i,!0)))}return l})}handleClose(s,t,o,i){}ensureQuotes(s){return S.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,c(s,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!P.isWindows)return s(!1);const t=_.spawn(E(),["/s","/c"]);t.on("error",o=>s(!0)),t.on("exit",o=>s(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class w extends S{constructor(s,t,o,i){super(s,t,o,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,t,o,i,l){[i,l].forEach((n,d)=>{const I=new g.LineDecoder;I.write(n).forEach(m=>{t({line:m,source:d===0?0:1})});const D=I.end();D&&t({line:D,source:d===0?0:1})}),s({terminated:this.terminateRequested,error:o})}handleSpawn(s,t,o,i,l){const n=new g.LineDecoder,d=new g.LineDecoder;s.stdout.on("data",I=>{n.write(I).forEach(D=>o({line:D,source:0}))}),s.stderr.on("data",I=>{d.write(I).forEach(D=>o({line:D,source:1}))}),this.stdoutLineDecoder=n,this.stderrLineDecoder=d}handleClose(s,t,o,i){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&o({line:l,source:0});const n=this.stderrLineDecoder?this.stderrLineDecoder.end():null;n&&o({line:n,source:1})}}e.LineProcess=w;function y(r){let s=[],t=!1;const o=function(i){if(t){s.push(i);return}(!r.send(i,n=>{if(n&&console.error(n),t=!1,s.length>0){const d=s.slice(0);s=[],d.forEach(I=>o(I))}})||P.isWindows)&&(t=!0)};return{send:o}}e.createQueuedSender=y;var a;(function(r){async function s(t,o,i){if(h.isAbsolute(t))return t;if(o===void 0&&(o=process.cwd()),h.dirname(t)!=="."||(i===void 0&&C.isString(process.env.PATH)&&(i=process.env.PATH.split(h.delimiter)),i===void 0||i.length===0))return h.join(o,t);async function n(d){return await b.promisify(T.exists)(d)?!(await b.promisify(T.stat)(d)).isDirectory():!1}for(let d of i){let I;if(h.isAbsolute(d)?I=h.join(d,t):I=h.join(o,d,t),await n(I))return I;let R=I+".com";if(await n(R)||(R=I+".exe",await n(R)))return R}return h.join(o,t)}r.findExecutable=s})(a=e.win32||(e.win32={}))}),define(x[116],ee([0,1,22,4,66,68]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function L(v,c=process.env){return v===3?T.isWindows?g():_.getWindowsShell(c):u(v,c)}e.getSystemShell=L;function C(v,c=process.env){return v===3?T.isWindows?p(c):_.getWindowsShell(c):u(v,c)}e.getSystemShellSync=C;let f=null;function u(v,c){if(T.isLinux&&v===1||T.isMacintosh&&v===2)return"/bin/bash";if(!f){let E;if(T.isWindows)E="/bin/bash";else{if(E=c.SHELL,!E)try{E=h.userInfo().shell}catch(S){}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}f=E}return f}let P=null;async function g(){return P||(P=(await b.getFirstAvailablePowerShellInstallation()).exePath),P}function p(v){if(P)return P;const c=T.isWindows&&parseFloat(h.release())>=10,E=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${v.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?S:_.getWindowsShell(v)}}),define(x[69],ee([0,1,39,2,15,19,5,68,36,97,25,14,17,4]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class c extends f.ChannelServer{constructor(w){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch(a){}},onMessage:L.Event.fromNodeEventEmitter(process,"message",y=>p.VSBuffer.wrap(Buffer.from(y,"base64")))},w);process.once("disconnect",()=>this.dispose())}}e.Server=c;class E{constructor(w,y){this.modulePath=w,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new L.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const a=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new b.Delayer(a),this.child=null,this._client=null}getChannel(w){const y=this;return{call(a,r,s){return y.requestPromise(w,a,r,s)},listen(a,r){return y.requestEvent(w,a,r)}}}requestPromise(w,y,a,r=P.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(g.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(w),t=b.createCancelablePromise(l=>s.call(y,a,l)),o=r.onCancellationRequested(()=>t.cancel()),i=T.toDisposable(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{o.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(w,y,a){if(!this.disposeDelayer)return L.Event.None;this.disposeDelayer.cancel();let r;const s=new L.Emitter({onFirstListenerAdd:()=>{r=this.getCachedChannel(w).listen(y,a)(s.fire,s),this.activeRequests.add(r)},onLastListenerRemove:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env=Object.assign(Object.assign({},_.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(y.env=Object.assign(Object.assign({},y.env),this.options.env)),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.isMacintosh&&y.env&&delete y.env.DYLD_LIBRARY_PATH,this.child=h.fork(this.modulePath,w,y);const a=new L.Emitter;L.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if(u.isRemoteConsoleLog(n)){u.log(n,`IPC Library: ${this.options.serverName}`);return}a.fire(p.VSBuffer.wrap(Buffer.from(n,"base64")))});const s=this.options.useQueue?C.createQueuedSender(this.child):this.child,t=n=>this.child&&this.child.connected&&s.send(n.buffer.toString("base64")),o=a.event,i={send:t,onMessage:o};this._client=new f.ChannelClient(i);const l=()=>this.disposeClient();process.once("exit",l),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,d)=>{process.removeListener("exit",l),this.activeRequests.forEach(I=>T.dispose(I)),this.activeRequests.clear(),n!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+d),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:d})})}return this._client}getCachedChannel(w){let y=this.channels.get(w);return y||(y=this.client.getChannel(w),this.channels.set(w,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(x[117],ee([8,9]),function(H,e){return H.create("vs/base/node/zip",e)}),define(x[118],ee([8,9]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(x[119],ee([8,9]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(x[120],ee([8,9]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(x[121],ee([8,9]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(x[122],ee([8,9]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(x[123],ee([8,9]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(x[124],ee([8,9]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(x[125],ee([8,9]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(x[126],ee([8,9]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(x[127],ee([8,9]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(x[128],ee([8,9]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(x[129],ee([8,9]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(x[130],ee([8,9]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(x[131],ee([8,9]),function(H,e){return H.create("vs/server/node/marketplace",e)}),define(x[132],ee([8,9]),function(H,e){return H.create("vs/server/node/server",e)}),define(x[133],ee([8,9]),function(H,e){return H.create("vs/workbench/common/editor",e)}),define(x[134],ee([8,9]),function(H,e){return H.create("vs/workbench/contrib/terminal/common/terminal",e)}),define(x[135],ee([8,9]),function(H,e){return H.create("vs/workbench/contrib/terminal/node/terminalProcess",e)}),define(x[136],ee([8,9]),function(H,e){return H.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(x[137],ee([8,9]),function(H,e){return H.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(x[138],ee([0,1,5,2]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class b{constructor(){this._onCloseEmitter=new h.Emitter,this._onReloadEmitter=new h.Emitter,this._onTerminateEmitter=new h.Emitter,this._onAttachEmitter=new h.Emitter}call(C,f,u){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(C,f,u){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=b,b.ChannelName="extensionhostdebugservice";class _ extends T.Disposable{constructor(C){super();this.channel=C}reload(C){this.channel.call("reload",[C])}get onReload(){return this.channel.listen("reload")}close(C){this.channel.call("close",[C])}get onClose(){return this.channel.listen("close")}attachSession(C,f,u){this.channel.call("attach",[C,f,u])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(C,f){this.channel.call("terminate",[C,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(C,f,u){return this.channel.call("openExtensionDevelopmentHostWindow",[C,f,u])}}e.ExtensionHostDebugChannelClient=_}),define(x[139],ee([0,1,5,7,50,19,2]),function(H,e,h,T,b,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(c,E){return T.URI.revive(E?E.transformIncoming(c):c)}function f(c,E){return E?E.transformOutgoingURI(c):c}function u(c,E){E=E||b.DefaultURITransformer;const S=c.manifest,w=b.transformAndReviveIncomingURIs(Object.assign(Object.assign({},c),{manifest:void 0}),E);return Object.assign(Object.assign({},w),{manifest:S})}function P(c,E){return E?_.cloneAndChange(c,S=>S instanceof T.URI?E.transformOutgoingURI(S):void 0):c}class g{constructor(E,S){this.service=E,this.getUriTransformer=S,this.onInstallExtension=h.Event.buffer(E.onInstallExtension,!0),this.onDidInstallExtension=h.Event.buffer(E.onDidInstallExtension,!0),this.onUninstallExtension=h.Event.buffer(E.onUninstallExtension,!0),this.onDidUninstallExtension=h.Event.buffer(E.onDidUninstallExtension,!0)}listen(E,S){const w=this.getUriTransformer(E);switch(S){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return h.Event.map(this.onDidInstallExtension,y=>Object.assign(Object.assign({},y),{local:y.local?P(y.local,w):y.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(E,S,w){const y=this.getUriTransformer(E);switch(S){case"zip":return this.service.zip(u(w[0],y)).then(a=>f(a,y));case"unzip":return this.service.unzip(C(w[0],y));case"install":return this.service.install(C(w[0],y));case"getManifest":return this.service.getManifest(C(w[0],y));case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(u(w[0],y),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(u(w[0],y));case"getInstalled":return this.service.getInstalled(w[0]).then(a=>a.map(r=>P(r,y)));case"updateMetadata":return this.service.updateMetadata(u(w[0],y),w[1]).then(a=>P(a,y));case"updateExtensionScope":return this.service.updateExtensionScope(u(w[0],y),w[1]).then(a=>P(a,y));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class p extends L.Disposable{constructor(E){super();this.channel=E,this._onInstallExtension=this._register(new h.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new h.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new h.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new h.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(S=>this._onInstallExtension.fire(S))),this._register(this.channel.listen("onDidInstallExtension")(S=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},S),{local:S.local?u(S.local,null):S.local})))),this._register(this.channel.listen("onUninstallExtension")(S=>this._onUninstallExtension.fire(S))),this._register(this.channel.listen("onDidUninstallExtension")(S=>this._onDidUninstallExtension.fire(S)))}zip(E){return Promise.resolve(this.channel.call("zip",[E]).then(S=>T.URI.revive(S)))}unzip(E){return Promise.resolve(this.channel.call("unzip",[E]))}install(E){return Promise.resolve(this.channel.call("install",[E])).then(S=>u(S,null))}getManifest(E){return Promise.resolve(this.channel.call("getManifest",[E]))}async canInstall(E){return!0}installFromGallery(E,S){return Promise.resolve(this.channel.call("installFromGallery",[E,S])).then(w=>u(w,null))}uninstall(E,S){return Promise.resolve(this.channel.call("uninstall",[E,S]))}reinstallFromGallery(E){return Promise.resolve(this.channel.call("reinstallFromGallery",[E]))}getInstalled(E=null){return Promise.resolve(this.channel.call("getInstalled",[E])).then(S=>S.map(w=>u(w,null)))}updateMetadata(E,S){return Promise.resolve(this.channel.call("updateMetadata",[E,S])).then(w=>u(w,null))}updateExtensionScope(E,S){return Promise.resolve(this.channel.call("updateExtensionScope",[E,S])).then(w=>u(w,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=p;class v{constructor(E){this.service=E}listen(E,S){throw new Error("Invalid listen")}call(E,S,w){switch(S){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=v}),define(x[140],ee([0,1,19]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function b(_,L){const C=f=>{if(typeof f=="string"){const u=T.exec(f);if(!!u)return L[u[1]]||f}};return h.cloneAndChange(_,C)}e.localizeManifest=b}),define(x[51],ee([0,1,124]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function b(g){return g=g.trim(),g==="*"||T.test(g)}e.isValidVersionStr=b;function _(g){if(!b(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=g.match(T);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=_;function L(g){if(!g)return null;let p=g.majorBase,v=g.majorMustEqual,c=g.minorBase,E=g.minorMustEqual,S=g.patchBase,w=g.patchMustEqual;return g.hasCaret&&(p===0||(E=!1),w=!1),{majorBase:p,majorMustEqual:v,minorBase:c,minorMustEqual:E,patchBase:S,patchMustEqual:w,isMinimum:g.hasGreaterEquals}}e.normalizeVersion=L;function C(g,p){let v;typeof g=="string"?v=L(_(g)):v=g;let c;if(typeof p=="string"?c=L(_(p)):c=p,!v||!c)return!1;let E=v.majorBase,S=v.minorBase,w=v.patchBase,y=c.majorBase,a=c.minorBase,r=c.patchBase,s=c.majorMustEqual,t=c.minorMustEqual,o=c.patchMustEqual;return c.isMinimum?E>y?!0:E<y?!1:S>a?!0:S<a?!1:w>=r:(E===1&&y===0&&(!s||!t||!o)&&(y=1,a=0,r=0,s=!0,t=!1,o=!1),E<y?!1:E>y?!s:S<a?!1:S>a?!t:w<r?!1:w>r?!o:!0)}e.isValidVersion=C;function f(g,p,v){return p.isBuiltin||typeof p.main=="undefined"?!0:P(g,p.engines.vscode,v)}e.isValidExtensionVersion=f;function u(g,p){return g==="*"||P(p,g)}e.isEngineValid=u;function P(g,p,v=[]){let c=L(_(p));if(!c)return v.push(h.localize(0,null,p)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return v.push(h.localize(1,null,p)),!1}else if(!c.majorMustEqual)return v.push(h.localize(2,null,p)),!1;return C(g,c)?!0:(v.push(h.localize(3,null,g,p)),!1)}e.isVersionValid=P}),define(x[141],ee([0,1,36,69,2,10]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L extends b.Disposable{constructor(f,u,P,g){super();this.folders=f,this.onDidFilesChange=u,this.onLogMessage=P,this.verboseLogging=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new T.Client(_.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=h.createChannelSender(h.getNextTickChannel(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(u=>!this.isDisposed&&this.onDidFilesChange(u))),this._register(this.service.onDidLogMessage(u=>this.onLogMessage(u))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=L,L.MAX_RESTARTS=5}),define(x[142],ee([0,1,36,69,2,10]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L extends b.Disposable{constructor(f,u,P,g,p={}){super();this.folders=f,this.onDidFilesChange=u,this.onLogMessage=P,this.verboseLogging=g,this.watcherOptions=p,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new T.Client(_.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=h.createChannelSender(h.getNextTickChannel(f.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(u=>!this.isDisposed&&this.onDidFilesChange(u))),this._register(this.service.onDidLogMessage(u=>this.onLogMessage(u))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=L,L.MAX_RESTARTS=5}),define(x[143],ee([0,1,39,65,98,10]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class L{constructor(f,u,P,g,p){this.watchedFolder=f,this.eventCallback=P,this.logCallback=g,this.verboseLogging=p,this.restartCounter=0,Array.isArray(u)?this.ignored=u.map(v=>b.parse(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=h.spawn(_.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",H).fsPath,f);const u=new T.LineDecoder;this.handle.stdout.on("data",P=>{const g=[];u.write(P).forEach(p=>{const v=p.split("|");if(v.length===2){const c=Number(v[0]),E=v[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(S=>S(E))){this.verboseLogging&&this.log(E);return}g.push({type:L.changeTypeMap[c],path:E})}else this.log(v[1])}}),g.length>0&&this.eventCallback(g)}),this.handle.on("error",P=>this.onError(P)),this.handle.stderr.on("data",P=>this.onError(P)),this.handle.on("exit",(P,g)=>this.onExit(P,g))}onError(f){this.error("process error: "+f.toString())}onExit(f,u){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${u})`),this.restartCounter<=L.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=L,L.MAX_RESTARTS=5,L.changeTypeMap=[0,1,2]}),define(x[144],ee([0,1,143,3,16]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class _{constructor(C,f,u,P){this.onDidFilesChange=f,this.onLogMessage=u,this.verboseLogging=P,this.service=void 0,this.folder=C[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=b.rtrim(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new h.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,C=>this.onFileEvents(C),C=>this.onLogMessage(C),this.verboseLogging)}setVerboseLogging(C){this.verboseLogging=C,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(C){this.isDisposed||C.length>0&&this.onDidFilesChange(C)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=_}),define(x[52],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class h{constructor(_,L=[],C=!1){this.ctor=_,this.staticArguments=L,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=h;const T=(b,..._)=>new h(b,_);e.createSyncDescriptor=T}),define(x[145],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=h;class T{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let L of this._nodes.values())L.outgoing.size===0&&_.push(L);return _}insertEdge(_,L){const C=this.lookupOrInsertNode(_),f=this.lookupOrInsertNode(L);C.outgoing.set(this._hashFn(L),f),f.incoming.set(this._hashFn(_),C)}removeNode(_){const L=this._hashFn(_);this._nodes.delete(L);for(let C of this._nodes.values())C.outgoing.delete(L),C.incoming.delete(L)}lookupOrInsertNode(_){const L=this._hashFn(_);let C=this._nodes.get(L);return C||(C=new h(_),this._nodes.set(L,C)),C}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[L,C]of this._nodes)_.push(`${L}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return _.join(`
`)}}e.Graph=T}),define(x[6],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function C(f){return f[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=C})(h=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function T(L,C,f,u){C[h.DI_TARGET]===C?C[h.DI_DEPENDENCIES].push({id:L,index:f,optional:u}):(C[h.DI_DEPENDENCIES]=[{id:L,index:f,optional:u}],C[h.DI_TARGET]=C)}function b(L){if(h.serviceIds.has(L))return h.serviceIds.get(L);const C=function(f,u,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(C,f,P,!1)};return C.toString=()=>L,h.serviceIds.set(L,C),C}e.createDecorator=b;function _(L){return function(C,f,u){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(L,C,u,!0)}}e.optional=_}),define(x[70],ee([0,1,16,6,4]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=b.userAgent||"";const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",b.isMacintosh),L.set("isLinux",b.isLinux),L.set("isWindows",b.isWindows),L.set("isWeb",b.isWeb),L.set("isMacNative",b.isMacintosh&&!b.isWeb),L.set("isEdge",_.indexOf("Edg/")>=0),L.set("isFirefox",_.indexOf("Firefox")>=0),L.set("isChrome",_.indexOf("Chrome")>=0),L.set("isSafari",_.indexOf("Safari")>=0),L.set("isIPad",_.indexOf("iPad")>=0);const C=Object.prototype.hasOwnProperty;var f;(function(D){D[D.False=0]="False",D[D.True=1]="True",D[D.Defined=2]="Defined",D[D.Not=3]="Not",D[D.Equals=4]="Equals",D[D.NotEquals=5]="NotEquals",D[D.And=6]="And",D[D.Regex=7]="Regex",D[D.NotRegex=8]="NotRegex",D[D.Or=9]="Or",D[D.In=10]="In",D[D.NotIn=11]="NotIn",D[D.Greater=12]="Greater",D[D.GreaterEquals=13]="GreaterEquals",D[D.Smaller=14]="Smaller",D[D.SmallerEquals=15]="SmallerEquals"})(f=e.ContextKeyExprType||(e.ContextKeyExprType={}));class u{static false(){return g.INSTANCE}static true(){return p.INSTANCE}static has(m){return v.create(m)}static equals(m,A){return c.create(m,A)}static notEquals(m,A){return w.create(m,A)}static regex(m,A){return o.create(m,A)}static in(m,A){return E.create(m,A)}static not(m){return y.create(m)}static and(...m){return l.create(m)}static or(...m){return n.create(m)}static greater(m,A){return a.create(m,A)}static less(m,A){return s.create(m,A)}static deserialize(m,A=!1){if(!!m)return this._deserializeOrExpression(m,A)}static _deserializeOrExpression(m,A){let U=m.split("||");return n.create(U.map(q=>this._deserializeAndExpression(q,A)))}static _deserializeAndExpression(m,A){let U=m.split("&&");return l.create(U.map(q=>this._deserializeOne(q,A)))}static _deserializeOne(m,A){if(m=m.trim(),m.indexOf("!=")>=0){let U=m.split("!=");return w.create(U[0].trim(),this._deserializeValue(U[1],A))}if(m.indexOf("==")>=0){let U=m.split("==");return c.create(U[0].trim(),this._deserializeValue(U[1],A))}if(m.indexOf("=~")>=0){let U=m.split("=~");return o.create(U[0].trim(),this._deserializeRegexValue(U[1],A))}if(m.indexOf(" in ")>=0){let U=m.split(" in ");return E.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(m)){const U=m.split(">=");return r.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(m)){const U=m.split(">");return a.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(m)){const U=m.split("<=");return t.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(m)){const U=m.split("<");return s.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(m)?y.create(m.substr(1).trim()):v.create(m)}static _deserializeValue(m,A){if(m=m.trim(),m==="true")return!0;if(m==="false")return!1;let U=/^'([^']*)'$/.exec(m);return U?U[1].trim():m}static _deserializeRegexValue(m,A){if(h.isFalsyOrWhitespace(m)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=m.indexOf("/"),q=m.lastIndexOf("/");if(U===q||U<0){if(A)throw new Error(`bad regexp-value '${m}', missing /-enclosure`);return console.warn(`bad regexp-value '${m}', missing /-enclosure`),null}let M=m.slice(U+1,q),W=m[q+1]==="i"?"i":"";try{return new RegExp(M,W)}catch(N){if(A)throw new Error(`bad regexp-value '${m}', parse error: ${N}`);return console.warn(`bad regexp-value '${m}', parse error: ${N}`),null}}}e.ContextKeyExpr=u;function P(D,m){return D.cmp(m)}class g{constructor(){this.type=0}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=g,g.INSTANCE=new g;class p{constructor(){this.type=1}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return g.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class v{constructor(m){this.key=m,this.type=2}static create(m){const A=L.get(m);return typeof A=="boolean"?A?p.INSTANCE:g.INSTANCE:new v(m)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return y.create(this.key)}}e.ContextKeyDefinedExpr=v;class c{constructor(m,A){this.key=m,this.value=A,this.type=4}static create(m,A){if(typeof A=="boolean")return A?v.create(m):y.create(m);const U=L.get(m);return typeof U=="boolean"?A===(U?"true":"false")?p.INSTANCE:g.INSTANCE:new c(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:R(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(m){return m.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class E{constructor(m,A){this.key=m,this.valueKey=A,this.type=10}static create(m,A){return new E(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:R(this.key,this.valueKey,m.key,m.valueKey)}equals(m){return m.type===this.type?this.key===m.key&&this.valueKey===m.valueKey:!1}evaluate(m){const A=m.getValue(this.valueKey),U=m.getValue(this.key);return Array.isArray(A)?A.indexOf(U)>=0:typeof U=="string"&&typeof A=="object"&&A!==null?C.call(A,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(m){return m.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=E;class S{constructor(m){this._actual=m,this.type=11}static create(m){return new S(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new S(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(m,A){this.key=m,this.value=A,this.type=5}static create(m,A){if(typeof A=="boolean")return A?y.create(m):v.create(m);const U=L.get(m);return typeof U=="boolean"?A===(U?"true":"false")?g.INSTANCE:p.INSTANCE:new w(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:R(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(m){return m.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class y{constructor(m){this.key=m,this.type=3}static create(m){const A=L.get(m);return typeof A=="boolean"?A?g.INSTANCE:p.INSTANCE:new y(m)}cmp(m){return m.type!==this.type?this.type-m.type:I(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!m.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(m){return m.mapNot(this.key)}negate(){return v.create(this.key)}}e.ContextKeyNotExpr=y;class a{constructor(m,A){this.key=m,this.value=A,this.type=12}static create(m,A){return new a(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:R(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=a;class r{constructor(m,A){this.key=m,this.value=A,this.type=13}static create(m,A){return new r(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:R(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreaterEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=r;class s{constructor(m,A){this.key=m,this.value=A,this.type=14}static create(m,A){return new s(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:R(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmaller(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeySmallerExpr=s;class t{constructor(m,A){this.key=m,this.value=A,this.type=15}static create(m,A){return new t(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:R(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmallerEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class o{constructor(m,A){this.key=m,this.regexp=A,this.type=7}static create(m,A){return new o(m,A)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.key<m.key)return-1;if(this.key>m.key)return 1;const A=this.regexp?this.regexp.source:"",U=m.regexp?m.regexp.source:"";return A<U?-1:A>U?1:0}equals(m){if(m.type===this.type){const A=this.regexp?this.regexp.source:"",U=m.regexp?m.regexp.source:"";return this.key===m.key&&A===U}return!1}evaluate(m){let A=m.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const m=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${m}`}keys(){return[this.key]}map(m){return m.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=o;class i{constructor(m){this._actual=m,this.type=8}static create(m){return new i(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new i(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class l{constructor(m){this.expr=m,this.type=6}static create(m){return l._normalizeArr(m)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let A=0,U=this.expr.length;A<U;A++){const q=P(this.expr[A],m.expr[A]);if(q!==0)return q}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let A=0,U=this.expr.length;A<U;A++)if(!this.expr[A].equals(m.expr[A]))return!1;return!0}return!1}evaluate(m){for(let A=0,U=this.expr.length;A<U;A++)if(!this.expr[A].evaluate(m))return!1;return!0}static _normalizeArr(m){const A=[];let U=!1;for(const q of m)if(!!q){if(q.type===1){U=!0;continue}if(q.type===0)return g.INSTANCE;if(q.type===6){A.push(...q.expr);continue}A.push(q)}if(A.length===0&&U)return p.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];for(A.sort(P);A.length>1;){const q=A[A.length-1];if(q.type!==9)break;A.pop();const M=A.pop(),W=n.create(q.expr.map(N=>l.create([N,M])));W&&(A.push(W),A.sort(P))}return A.length===1?A[0]:new l(A)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(let A of this.expr)m.push(...A.keys());return m}map(m){return new l(this.expr.map(A=>A.map(m)))}negate(){let m=[];for(let A of this.expr)m.push(A.negate());return n.create(m)}}e.ContextKeyAndExpr=l;class n{constructor(m){this.expr=m,this.type=9}static create(m){const A=n._normalizeArr(m);if(A.length!==0)return A.length===1?A[0]:new n(A)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let A=0,U=this.expr.length;A<U;A++){const q=P(this.expr[A],m.expr[A]);if(q!==0)return q}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let A=0,U=this.expr.length;A<U;A++)if(!this.expr[A].equals(m.expr[A]))return!1;return!0}return!1}evaluate(m){for(let A=0,U=this.expr.length;A<U;A++)if(this.expr[A].evaluate(m))return!0;return!1}static _normalizeArr(m){let A=[],U=!1;if(m){for(let q=0,M=m.length;q<M;q++){const W=m[q];if(!!W){if(W.type===0){U=!0;continue}if(W.type===1)return[p.INSTANCE];if(W.type===9){A=A.concat(W.expr);continue}A.push(W)}}if(A.length===0&&U)return[g.INSTANCE];A.sort(P)}return A}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(let A of this.expr)m.push(...A.keys());return m}map(m){return new n(this.expr.map(A=>A.map(m)))}negate(){let m=[];for(let U of this.expr)m.push(U.negate());const A=U=>U.type===9?U.expr:[U];for(;m.length>1;){const U=m.shift(),q=m.shift(),M=[];for(const W of A(U))for(const N of A(q))M.push(u.and(W,N));m.unshift(u.or(...M))}return m[0]}}e.ContextKeyOrExpr=n;class d extends v{constructor(m,A){super(m);this._defaultValue=A}bindTo(m){return m.createKey(this.key,this._defaultValue)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return u.not(this.key)}isEqualTo(m){return u.equals(this.key,m)}notEqualsTo(m){return u.notEquals(this.key,m)}}e.RawContextKey=d,e.IContextKeyService=T.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function I(D,m){return D<m?-1:D>m?1:0}function R(D,m,A,U){return D<A?-1:D>A?1:m<U?-1:m>U?1:0}}),define(x[146],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=h.createDecorator("downloadService")}),define(x[23],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=h.createDecorator("environmentService"),e.INativeEnvironmentService=h.createDecorator("nativeEnvironmentService")});var Se=this&&this.__decorate||function(H,e,h,T){var b=arguments.length,_=b<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,h):T,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(H,e,h,T);else for(var C=H.length-1;C>=0;C--)(L=H[C])&&(_=(b<3?L(_):b>3?L(e,h,_):L(e,h))||_);return b>3&&_&&Object.defineProperty(e,h,_),_},we=this&&this.__param||function(H,e){return function(h,T){e(h,T,H)}};define(x[147],ee([0,1,23,3,12,14,2]),function(H,e,h,T,b,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends L.Disposable{constructor(u){super();this.environmentService=u,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let u=setTimeout(()=>{u=void 0;const P=T.basename(this.environmentService.logsPath),g=T.dirname(this.environmentService.logsPath);b.readdir(g).then(p=>{const c=p.filter(S=>/^\d{8}T\d{6}$/.test(S)).sort().filter((S,w)=>S!==P),E=c.slice(0,Math.max(0,c.length-9));return Promise.all(E.map(S=>b.rimraf(T.join(g,S))))}).then(null,_.onUnexpectedError)},10*1e3);this._register(L.toDisposable(()=>{u&&(clearTimeout(u),u=void 0)}))}};C=Se([we(0,h.IEnvironmentService)],C),e.LogsDataCleaner=C}),define(x[27],ee([0,1,119,6,10]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function _(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=_;var L;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=5]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(L=e.SortBy||(e.SortBy={}));var C;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var f;(function(g){g.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var u;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=T.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class P extends Error{constructor(p,v){super(p);this.code=v}}e.ExtensionManagementError=P,e.IExtensionManagementService=T.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=T.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=T.createDecorator("IExtensionTipsService"),e.DefaultIconPath=b.FileAccess.asBrowserUri("./media/defaultIcon.png",H).toString(!0),e.ExtensionsLabel=h.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=h.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=T.createDecorator("IExtensionManagementCLIService")}),define(x[40],ee([0,1,16,6]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function b(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=b,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Themes","Testing","Visualization","Other"];var _;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(_=e.ExtensionType||(e.ExtensionType={}));class L{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,g){if(typeof P=="undefined"||P===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof P=="string"||typeof g=="string"){let p=typeof P=="string"?P:P.value,v=typeof g=="string"?g:g.value;return h.equalsIgnoreCase(p,v)}return P._lower===g._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=L;function C(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function f(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=f,e.IBuiltinExtensionsScannerService=T.createDecorator("IBuiltinExtensionsScannerService")}),define(x[31],ee([0,1,16,40]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function b(v,c){return v.uuid&&c.uuid?v.uuid===c.uuid:v.id===c.id?!0:h.compareIgnoreCase(v.id,c.id)===0}e.areSameExtensions=b;class _{constructor(c,E){this.version=E,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof _?b(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=_;function L(v,c){return`${v}.${c}`}e.getExtensionId=L;function C(v){return v.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function f(v,c){return C(L(v,c))}e.getGalleryExtensionId=f;function u(v,c){const E=[],S=w=>{for(const y of E)if(y.some(a=>b(c(a),c(w))))return y;return null};for(const w of v){const y=S(w);y?y.push(w):E.push([w])}return E}e.groupByExtension=u;function P(v){return{id:v.identifier.id,name:v.manifest.name,galleryId:null,publisherId:v.publisherId,publisherName:v.manifest.publisher,publisherDisplayName:v.publisherDisplayName,dependencies:v.manifest.extensionDependencies&&v.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function g(v){return Object.assign({id:v.identifier.id,name:v.name,galleryId:v.identifier.uuid,publisherId:v.publisherId,publisherName:v.publisher,publisherDisplayName:v.publisherDisplayName,dependencies:!!(v.properties.dependencies&&v.properties.dependencies.length>0)},v.telemetryData)}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function p(v){const c=new Set;for(const E of v)E.malicious&&c.add(E.id.id);return c}e.getMaliciousExtensionsSet=p}),define(x[148],ee([0,1,2,3,40,12]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends h.Disposable{constructor(f,u){super();this.environmentService=f,this.extensionsManifestCache=T.join(this.environmentService.userDataPath,b.MANIFEST_CACHE_FOLDER,b.USER_MANIFEST_CACHE_FILE),this._register(u.onDidInstallExtension(P=>this.onDidInstallExtension(P))),this._register(u.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtension(f){f.error||this.invalidate()}onDidUnInstallExtension(f){f.error||this.invalidate()}invalidate(){_.rimraf(this.extensionsManifestCache,_.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(x[24],ee([0,1,126,3,7,6,16,11,30]),function(H,e,h,T,b,_,L,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=_.createDecorator("fileService");var u;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(u=e.FileType||(e.FileType={}));var P;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash"})(P=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=g;function p(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=p;function v(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function c(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=c;var E;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(q,M){super(q);this.code=M}}e.FileSystemProviderError=S;function w(U,q){const M=new S(U.toString(),q);return a(M,q),M}e.createFileSystemProviderError=w;function y(U){return U||w(h.localize(0,null),E.Unknown)}e.ensureFileSystemProviderError=y;function a(U,q){return U.name=q?`${q} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=a;function r(U){if(!U)return E.Unknown;if(U instanceof S)return U.code;const q=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!q)return E.Unknown;switch(q[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=r;function s(U){if(U instanceof d)return U.fileOperationResult;switch(r(U)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var t;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class o{constructor(q,M,W){this.resource=q,this.operation=M,this.target=W}isOperation(q){return this.operation===q}}e.FileOperationEvent=o;var i;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(i=e.FileChangeType||(e.FileChangeType={}));class l{constructor(q,M){this.ignorePathCasing=M,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=q;for(const W of q)switch(W.type){case 1:this.added||(this.added=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(W.resource,W);break;case 0:this.updated||(this.updated=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(W.resource,W);break;case 2:this.deleted||(this.deleted=f.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(W.resource,W);break}}contains(q,...M){return this.doContains(q,{includeChildren:!1},...M)}affects(q,...M){return this.doContains(q,{includeChildren:!0},...M)}doContains(q,M,...W){var N,K,j,$,J,B;if(!q)return!1;const k=W.length>0;return!!((!k||W.includes(1))&&(((N=this.added)===null||N===void 0?void 0:N.get(q))||M.includeChildren&&((K=this.added)===null||K===void 0?void 0:K.findSuperstr(q)))||(!k||W.includes(0))&&(((j=this.updated)===null||j===void 0?void 0:j.get(q))||M.includeChildren&&(($=this.updated)===null||$===void 0?void 0:$.findSuperstr(q)))||(!k||W.includes(2))&&(((J=this.deleted)===null||J===void 0?void 0:J.findSubstr(q))||M.includeChildren&&((B=this.deleted)===null||B===void 0?void 0:B.findSuperstr(q))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(q){const M=[],W=q===1?this.added:q===0?this.updated:this.deleted;if(W)for(const[,N]of W)M.push(N);return M}filter(q){return new l(this.changes.filter(M=>q(M)),this.ignorePathCasing)}}e.FileChangesEvent=l;function n(U,q,M){return!U||!q||U===q||q.length>U.length?!1:(q.charAt(q.length-1)!==T.sep&&(q+=T.sep),M?L.startsWithIgnoreCase(U,q):U.indexOf(q)===0)}e.isParent=n;class d extends Error{constructor(q,M,W){super(q);this.fileOperationResult=M,this.options=W}static isFileOperationError(q){return q instanceof Error&&!C.isUndefinedOrNull(q.fileOperationResult)}}e.FileOperationError=d;var I;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_READ_ONLY=5]="FILE_READ_ONLY",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(I=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=D;async function m(U,q){if(!q.canHandleResource(b.URI.from({scheme:U.scheme})))return new Promise(M=>{const W=q.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===U.scheme&&N.added&&(W.dispose(),M())})})}e.whenProviderRegistered=m,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class A{static formatSize(q){return C.isNumber(q)||(q=0),q<A.KB?h.localize(1,null,q.toFixed(0)):q<A.MB?h.localize(2,null,(q/A.KB).toFixed(2)):q<A.GB?h.localize(3,null,(q/A.MB).toFixed(2)):q<A.TB?h.localize(4,null,(q/A.GB).toFixed(2)):h.localize(5,null,(q/A.TB).toFixed(2))}}e.ByteSize=A,A.KB=1024,A.MB=A.KB*A.KB,A.GB=A.MB*A.KB,A.TB=A.GB*A.KB}),define(x[71],ee([0,1,127,17,24,14]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(P,g,p,v,c,E){let S;try{await C(P,g,p,v,c,E)}catch(w){S=w}finally{S&&c.errorTransformer&&(S=c.errorTransformer(S)),p.end(S)}}e.readFileIntoStream=L;async function C(P,g,p,v,c,E){f(E);const S=await P.open(g,{create:!1});try{f(E);let w=0,y=0,a=c&&typeof c.length=="number"?c.length:void 0,r=T.VSBuffer.alloc(Math.min(c.bufferSize,typeof a=="number"?a:c.bufferSize)),s=c&&typeof c.position=="number"?c.position:0,t=0;do y=await P.read(S,s,r.buffer,t,r.byteLength-t),s+=y,t+=y,w+=y,typeof a=="number"&&(a-=y),t===r.byteLength&&(await p.write(v(r)),r=T.VSBuffer.alloc(Math.min(c.bufferSize,typeof a=="number"?a:c.bufferSize)),t=0);while(y>0&&(typeof a!="number"||a>0)&&f(E)&&u(w,c));if(t>0){let o=t;typeof a=="number"&&(o=Math.min(t,a)),p.write(v(r.slice(0,o)))}}catch(w){throw b.ensureFileSystemProviderError(w)}finally{await P.close(S)}}function f(P){if(P.isCancellationRequested)throw _.canceled();return!0}function u(P,g){if(g==null?void 0:g.limits){if(typeof g.limits.memory=="number"&&P>g.limits.memory)throw b.createFileSystemProviderError(h.localize(0,null),b.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&P>g.limits.size)throw b.createFileSystemProviderError(h.localize(1,null),b.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(x[72],ee([0,1,7,24,4]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function _(f){return f.map(u=>({type:u.type,resource:h.URI.file(u.path)}))}e.toFileChanges=_;function L(f){const u=new C;for(const P of f)u.processEvent(P);return u.normalize()}e.normalizeFileChanges=L;class C{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(u){const P=this.mapPathToChange.get(u.path);if(P){const g=P.type,p=u.type;g===1&&p===2?(this.mapPathToChange.delete(u.path),this.normalized.splice(this.normalized.indexOf(P),1)):g===2&&p===1?P.type=0:g===1&&p===0||(P.type=p)}else this.normalized.push(u),this.mapPathToChange.set(u.path,u)}normalize(){const u=[],P=[];return this.normalized.filter(g=>g.type!==2?(u.push(g),!1):!0).sort((g,p)=>g.path.length-p.path.length).filter(g=>P.some(p=>T.isParent(g.path,p,!b.isLinux))?!1:(P.push(g.path),!0)).concat(u)}}}),define(x[149],ee([0,1,72,2,12,105,107,15,3]),function(H,e,h,T,b,_,L,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class u extends T.Disposable{constructor(g,p,v,c){super();this.path=g,this.onDidFilesChange=p,this.onLogMessage=v,this.verboseLogging=c,this.fileChangesDelayer=this._register(new C.ThrottledDelayer(L.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(g){this.verboseLogging=g}async startWatching(){try{const{stat:g,symbolicLink:p}=await b.statLink(this.path);if(this.isDisposed)return;let v=this.path;if(p)try{v=await _.realpath(v)}catch(c){this.onError(c)}g.isDirectory()?this._register(L.watchFolder(v,(c,E)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:f.join(this.path,f.basename(E))})},c=>this.onError(c))):this._register(L.watchFile(v,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(g){this.onError(g)}}onFileChange(g){this.fileChangesBuffer.push(g),this.verboseLogging&&this.onVerbose(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),this.fileChangesDelayer.trigger(async()=>{const p=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=h.normalizeFileChanges(p);this.verboseLogging&&v.forEach(c=>{this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`)}),v.length>0&&this.onDidFilesChange(v)})}onError(g){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${g}`})}onVerbose(g){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=u}),define(x[53],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...b){this._entries=new Map;for(let[_,L]of b)this.set(_,L)}set(b,_){const L=this._entries.get(b);return this._entries.set(b,_),L}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=h}),define(x[73],ee([0,1,14,145,52,6,53,15]),function(H,e,h,T,b,_,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class u extends Error{constructor(c){super("cyclic dependency between services");this.message=c.toString()}}class P{constructor(c=new L.ServiceCollection,E=!1,S){this._activeInstantiations=new Set,this._services=c,this._strict=E,this._parent=S,this._services.set(_.IInstantiationService,this)}createChild(c){return new P(c,this._strict,this)}invokeFunction(c,...E){let S=p.traceInvocation(c),w=!1;try{return c({get:(a,r)=>{if(w)throw h.illegalState("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(a,S);if(!s&&r!==_.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return s}},...E)}finally{w=!0,S.stop()}}createInstance(c,...E){let S,w;return c instanceof b.SyncDescriptor?(S=p.traceCreation(c.ctor),w=this._createInstance(c.ctor,c.staticArguments.concat(E),S)):(S=p.traceCreation(c),w=this._createInstance(c,E,S)),S.stop(),w}_createInstance(c,E=[],S){let w=_._util.getServiceDependencies(c).sort((r,s)=>r.index-s.index),y=[];for(const r of w){let s=this._getOrCreateServiceInstance(r.id,S);if(!s&&this._strict&&!r.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${r.id}.`);y.push(s)}let a=w.length>0?w[0].index:E.length;if(E.length!==a){console.warn(`[createInstance] First service dependency of ${c.name} at position ${a+1} conflicts with ${E.length} static arguments`);let r=a-E.length;r>0?E=E.concat(new Array(r)):E=E.slice(0,a)}return new c(...[...E,...y])}_setServiceInstance(c,E){if(this._services.get(c)instanceof b.SyncDescriptor)this._services.set(c,E);else if(this._parent)this._parent._setServiceInstance(c,E);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let E=this._services.get(c);return!E&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):E}_getOrCreateServiceInstance(c,E){let S=this._getServiceInstanceOrDescriptor(c);return S instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,S,E.branch(c,!0)):(E.branch(c,!1),S)}_safeCreateAndCacheServiceInstance(c,E,S){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,E,S)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,E,S){const w=new T.Graph(r=>r.id.toString());let y=0;const a=[{id:c,desc:E,_trace:S}];for(;a.length;){const r=a.pop();if(w.lookupOrInsertNode(r),y++>1e3)throw new u(w);for(let s of _._util.getServiceDependencies(r.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${c} depends on ${s.id} which is NOT registered.`),t instanceof b.SyncDescriptor){const o={id:s.id,desc:t,_trace:r._trace.branch(s.id,!0)};w.insertEdge(r,o),a.push(o)}}}for(;;){const r=w.roots();if(r.length===0){if(!w.isEmpty())throw new u(w);break}for(const{data:s}of r){if(this._getServiceInstanceOrDescriptor(s.id)instanceof b.SyncDescriptor){const o=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,o)}w.removeNode(s)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,E,S=[],w,y){if(this._services.get(c)instanceof b.SyncDescriptor)return this._createServiceInstance(E,S,w,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,E,S,w,y);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}_createServiceInstance(c,E=[],S,w){if(S){const y=new C.IdleValue(()=>this._createInstance(c,E,w));return new Proxy(Object.create(null),{get(a,r){if(r in a)return a[r];let s=y.value,t=s[r];return typeof t!="function"||(t=t.bind(s),a[r]=t),t},set(a,r,s){return y.value[r]=s,!0}})}else return this._createInstance(c,E,w)}}e.InstantiationService=P;var g;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(g||(g={}));class p{constructor(c,E){this.type=c,this.name=E,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return f?new p(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(c){return f?new p(0,c.name):p._None}branch(c,E){let S=new p(2,c.toString());return this._dep.push([c,E,S]),S}stop(){let c=Date.now()-this._start;p._totals+=c;let E=!1;function S(y,a){let r=[],s=new Array(y+1).join("	");for(const[t,o,i]of a._dep)if(o&&i){E=!0,r.push(`${s}CREATES -> ${t}`);let l=S(y+1,i);l&&r.push(l)}else r.push(`${s}uses -> ${t}`);return r.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(c>2||E)&&console.log(w.join(`
`))}}p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(x[150],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=h.createDecorator("labelService")}),define(x[44],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=h.createDecorator("localizationsService");function T(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const _ of b.translations)if(typeof _.id!="string"||typeof _.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}e.isValidLocalization=T}),define(x[151],ee([0,1,120,14,7,45,27,31,40,64,25,10,44]),function(H,e,h,T,b,_,L,C,f,u,P,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=e.getIdAndVersion=void 0;const v=a=>h.localize(0,null,a),c=h.localize(1,null,"ms-dotnettools.csharp");function E(a,r){return r?`${a.publisher}.${a.name}@${a.version}`:`${a.publisher}.${a.name}`}const S=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function w(a){const r=S.exec(a);return r&&r[1]?[C.adoptToGalleryExtensionId(r[1]),r[2]]:[C.adoptToGalleryExtensionId(a),void 0]}e.getIdAndVersion=w;let y=class{constructor(r,s,t){this.extensionManagementService=r,this.extensionGalleryService=s,this.localizationsService=t}get location(){}async listExtensions(r,s,t=console){let o=await this.extensionManagementService.getInstalled(1);const i=f.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(s&&s!==""){if(i.indexOf(s.toLowerCase())<0){t.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}o=o.filter(n=>n.manifest.categories?n.manifest.categories.map(I=>I.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){t.log("Possible Categories: "),i.forEach(n=>{t.log(n)});return}this.location&&t.log(h.localize(2,null,this.location)),o=o.sort((n,d)=>n.identifier.id.localeCompare(d.identifier.id));let l;for(let n of o)l!==n.identifier.id&&(l=n.identifier.id,t.log(E(n.manifest,r)))}async installExtensions(r,s,t,o,i=console){const l=[],n=[];r.length&&i.log(this.location?h.localize(3,null,this.location):h.localize(4,null));const d=await this.extensionManagementService.getInstalled(1),I=(m,A)=>{const U=d.find(q=>C.areSameExtensions(q.identifier,{id:m}));if(U){if(!A&&!o)return i.log(h.localize(5,null,m,U.manifest.version,m)),!1;if(A&&U.manifest.version===A)return i.log(h.localize(6,null,`${m}@${A}`)),!1}return!0},R=[],D=[];for(const m of r)if(m instanceof b.URI)R.push(m);else{const[A,U]=w(m);I(A,U)&&D.push({id:A,version:U,installOptions:{isBuiltin:!1,isMachineScoped:t}})}for(const m of s){const[A,U]=w(m);I(A,U)&&D.push({id:A,version:U,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(R.length&&await Promise.all(R.map(async m=>{try{const A=await this.installVSIX(m,o,i);A&&n.push(A)}catch(A){i.error(A.message||A.stack||A),l.push(m.toString())}})),D.length){const m=await this.getGalleryExtensions(D);await Promise.all(D.map(async A=>{const U=m.get(A.id.toLowerCase());if(U)try{const q=await this.installFromGallery(A,U,d,o,i);q&&n.push(q)}catch(q){i.error(q.message||q.stack||q),l.push(A.id)}else i.error(`${v(A.version?`${A.id}@${A.version}`:A.id)}
${c}`),l.push(A.id)}))}if(n.some(m=>f.isLanguagePackExtension(m))&&await this.updateLocalizationsCache(),l.length)throw new Error(h.localize(7,null,l.join(", ")))}async installVSIX(r,s,t){const o=await this.extensionManagementService.getManifest(r);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,s,t))try{return await this.extensionManagementService.install(r),t.log(h.localize(8,null,u.getBaseLabel(r))),o}catch(l){if(T.isPromiseCanceledError(l))return t.log(h.localize(9,null,u.getBaseLabel(r))),null;throw l}return null}async getGalleryExtensions(r){const s=r.filter(({version:i})=>i===void 0).map(({id:i})=>i),t=r.filter(({version:i})=>i!==void 0),o=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(s,P.CancellationToken.None)).forEach(l=>o.set(l.identifier.id.toLowerCase(),l))})(),Promise.all(t.map(async({id:i,version:l})=>{const n=await this.extensionGalleryService.getCompatibleExtension({id:i},l);n&&o.set(n.identifier.id.toLowerCase(),n)}))]),o}async installFromGallery({id:r,version:s,installOptions:t},o,i,l,n){const d=await this.extensionGalleryService.getManifest(o,P.CancellationToken.None);if(d&&!this.validateExtensionKind(d,n))return null;const I=i.find(R=>C.areSameExtensions(R.identifier,o.identifier));if(I){if(o.version===I.manifest.version)return n.log(h.localize(10,null,s?`${r}@${s}`:r)),null;n.log(h.localize(11,null,r,o.version))}try{return t.isBuiltin?n.log(h.localize(12,null,r,o.version)):n.log(h.localize(13,null,r,o.version)),await this.extensionManagementService.installFromGallery(o,t),n.log(h.localize(14,null,r,o.version)),d}catch(R){if(T.isPromiseCanceledError(R))return n.log(h.localize(15,null,r)),null;throw R}}validateExtensionKind(r,s){return!0}async validateVSIX(r,s,t){const o={id:C.getGalleryExtensionId(r.publisher,r.name)},l=(await this.extensionManagementService.getInstalled(1)).find(n=>C.areSameExtensions(o,n.identifier)&&_.gt(n.manifest.version,r.version));return l&&!s?(t.log(h.localize(16,null,l.identifier.id,l.manifest.version,r.version)),!1):this.validateExtensionKind(r,t)}async uninstallExtensions(r,s,t=console){const o=async l=>{if(l instanceof b.URI){const n=await this.extensionManagementService.getManifest(l);return E(n)}return l},i=[];for(const l of r){const n=await o(l),I=(await this.extensionManagementService.getInstalled()).filter(R=>C.areSameExtensions(R.identifier,{id:n}));if(!I.length)throw new Error(`${this.notInstalled(n)}
${c}`);if(I.some(R=>R.type===0)){t.log(h.localize(17,null,n));return}if(!s&&I.some(R=>R.isBuiltin)){t.log(h.localize(18,null,n));return}t.log(h.localize(19,null,n));for(const R of I)await this.extensionManagementService.uninstall(R),i.push(R);this.location?t.log(h.localize(20,null,n,this.location)):t.log(h.localize(21,null,n))}i.some(l=>f.isLanguagePackExtension(l.manifest))&&await this.updateLocalizationsCache()}async locateExtension(r,s=console){const t=await this.extensionManagementService.getInstalled();r.forEach(o=>{t.forEach(i=>{if(i.identifier.id===o&&i.location.scheme===g.Schemas.file){s.log(i.location.fsPath);return}})})}updateLocalizationsCache(){return this.localizationsService.update()}notInstalled(r){return this.location?h.localize(22,null,r,this.location):h.localize(23,null,r)}};y=Se([we(0,L.IExtensionManagementService),we(1,L.IExtensionGalleryService),we(2,p.ILocalizationsService)],y),e.ExtensionManagementCLIService=y}),define(x[13],ee([0,1,6,2,4,5,38]),function(H,e,h,T,b,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.DelegatedLogService=e.MultiplexLogService=e.ConsoleLogInMainService=e.LogServiceAdapter=e.ConsoleLogService=e.ConsoleLogMainService=e.AbstractLogService=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=h.createDecorator("logService"),e.ILoggerService=h.createDecorator("loggerService");function C(){return new Date().toISOString()}var f;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class u extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogService=u;class P extends u{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!b.isWindows}trace(s,...t){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,s,...t):console.log(`[main ${C()}]`,s,...t))}debug(s,...t){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,s,...t):console.log(`[main ${C()}]`,s,...t))}info(s,...t){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,s,...t):console.log(`[main ${C()}]`,s,...t))}warn(s,...t){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,s,...t):console.warn(`[main ${C()}]`,s,...t))}error(s,...t){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,s,...t):console.error(`[main ${C()}]`,s,...t))}critical(s,...t){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,s,...t):console.error(`[main ${C()}]`,s,...t))}dispose(){}flush(){}}e.ConsoleLogMainService=P;class g extends u{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...t){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",s,...t)}debug(s,...t){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...t)}info(s,...t){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",s,...t)}warn(s,...t){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",s,...t)}error(s,...t){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",s,...t)}critical(s,...t){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...t)}dispose(){}flush(){}}e.ConsoleLogService=g;class p extends u{constructor(s,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(t)}trace(s,...t){this.getLevel()<=f.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(s),...t])}debug(s,...t){this.getLevel()<=f.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(s),...t])}info(s,...t){this.getLevel()<=f.Info&&this.adapter.consoleLog("info",[this.extractMessage(s),...t])}warn(s,...t){this.getLevel()<=f.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(s),...t])}error(s,...t){this.getLevel()<=f.Error&&this.adapter.consoleLog("error",[this.extractMessage(s),...t])}critical(s,...t){this.getLevel()<=f.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(s),...t])}extractMessage(s){return typeof s=="string"?s:L.toErrorMessage(s,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.LogServiceAdapter=p;class v extends p{constructor(s,t=e.DEFAULT_LOG_LEVEL){super({consoleLog:(o,i)=>s.consoleLog(o,i)},t)}}e.ConsoleLogInMainService=v;class c extends u{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const t of this.logServices)t.setLevel(s);super.setLevel(s)}trace(s,...t){for(const o of this.logServices)o.trace(s,...t)}debug(s,...t){for(const o of this.logServices)o.debug(s,...t)}info(s,...t){for(const o of this.logServices)o.info(s,...t)}warn(s,...t){for(const o of this.logServices)o.warn(s,...t)}error(s,...t){for(const o of this.logServices)o.error(s,...t)}critical(s,...t){for(const o of this.logServices)o.critical(s,...t)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=c;class E extends T.Disposable{constructor(s){super();this.logService=s,this._register(s)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(s){this.logService.setLevel(s)}getLevel(){return this.logService.getLevel()}trace(s,...t){this.logService.trace(s,...t)}debug(s,...t){this.logService.debug(s,...t)}info(s,...t){this.logService.info(s,...t)}warn(s,...t){this.logService.warn(s,...t)}error(s,...t){this.logService.error(s,...t)}critical(s,...t){this.logService.critical(s,...t)}flush(){this.logService.flush()}}e.DelegatedLogService=E;class S{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(s){}getLevel(){return f.Info}trace(s,...t){}debug(s,...t){}info(s,...t){}warn(s,...t){}error(s,...t){}critical(s,...t){}dispose(){}flush(){}}e.NullLogService=S;function w(r){if(r.verbose)return f.Trace;if(typeof r.logLevel=="string"){const s=y(r.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function y(r){switch(r){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=y;function a(r){switch(r){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=a}),define(x[152],ee([0,1,2,12,24,27,23,7,20,31,13,26,45,4]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const c=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends h.Disposable{constructor(w,y,a,r){super();this.fileService=y,this.extensionGalleryService=a,this.logService=r,this.extensionsDownloadDir=C.URI.file(w.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(w,y){await this.cleanUpPromise;const a=this.getName(w),r=f.joinPath(this.extensionsDownloadDir,a);if(!await this.fileService.exists(r)){const s=f.joinPath(this.extensionsDownloadDir,`.${a}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(w,s,y),await this.rename(s,r,Date.now()+2*60*1e3)}return r}async delete(w){}async rename(w,y,a){try{await T.rename(w.fsPath,y.fsPath)}catch(r){if(v.isWindows&&r&&r.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${w} to ${y} with 'EPERM' error. Trying again...`),this.rename(w,y,a);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const w=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(w.children){const y=[],a=[];for(const t of w.children){const o=this.parse(t.name);o&&a.push([o,t])}const r=u.groupByExtension(a,([t])=>t),s=[];for(const t of r)t.sort((o,i)=>p.rcompare(o[0].version,i[0].version)),y.push(...t.slice(1).map(o=>o[1].resource)),s.push(t[0][1]);s.sort((t,o)=>t.mtime-o.mtime),y.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(t=>t.resource)),await Promise.all(y.map(t=>(this.logService.trace("Deleting vsix from cache",t.path),this.fileService.del(t))))}}catch(w){this.logService.error(w)}}getName(w){return this.cache?new u.ExtensionIdentifierWithVersion(w.identifier,w.version).key().toLowerCase():g.generateUuid()}parse(w){const y=c.exec(w);return y&&y[1]&&y[2]?new u.ExtensionIdentifierWithVersion({id:y[1]},y[2]):null}};E=Se([we(0,L.INativeEnvironmentService),we(1,b.IFileService),we(2,_.IExtensionGalleryService),we(3,P.ILogService)],E),e.ExtensionsDownloader=E}),define(x[153],ee([0,1,2,13,39,38,3,15,5,10,12,23]),function(H,e,h,T,b,_,L,C,f,u,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends h.Disposable{constructor(c,E){super();this.environmentService=c,this.logService=E,this.processesLimiter=new C.Limiter(5)}async postUninstall(c){const E=this.parseScript(c,"uninstall");return E&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(E.script,"uninstall",E.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${S}`)))),P.rimraf(this.getExtensionStoragePath(c)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(c,E){const S=`vscode:${E}`;if(c.location.scheme===u.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[S]=="string"){const w=c.manifest.scripts[S].split(" ");return w.length<2||w[0]!=="node"||!w[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${S} should be a node script`),null):{script:L.join(c.location.fsPath,w[1]),args:w.slice(2)||[]}}return null}runLifecycleHook(c,E,S,w,y){return new Promise((a,r)=>{const s=this.start(c,E,S,y);let t;const o=i=>{t&&(clearTimeout(t),t=null),i?r(i):a(void 0)};s.on("error",i=>{o(_.toErrorMessage(i)||"Unknown")}),s.on("exit",(i,l)=>{o(i?`post-${E} process exited with code ${i}`:void 0)}),w&&(t=setTimeout(()=>{t=null,s.kill(),r("timed out")},5e3))})}start(c,E,S,w){const y={silent:!0,execArgv:void 0},a=b.fork(c,[`--type=extension-post-${E}`,...S],y);a.stdout.setEncoding("utf8"),a.stderr.setEncoding("utf8");const r=f.Event.fromNodeEventEmitter(a.stdout,"data"),s=f.Event.fromNodeEventEmitter(a.stderr,"data");r(i=>this.logService.info(w.identifier.id,w.manifest.version,`post-${E}`,i)),s(i=>this.logService.error(w.identifier.id,w.manifest.version,`post-${E}`,i));const t=f.Event.any(f.Event.map(r,i=>({data:`%c${i}`,format:[""]})),f.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return f.Event.debounce(t,(i,l)=>i?{data:i.data+l.data,format:[...i.format,...l.format]}:{data:l.data,format:l.format},100)(i=>{console.group(w.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),a}getExtensionStoragePath(c){return L.join(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};p=Se([we(0,g.IEnvironmentService),we(1,T.ILogService)],p),e.ExtensionsLifecycle=p}),define(x[74],ee([0,1,125,101,2,24,5,20,30,18,13,17,42,15,25,10,71,61]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c,E,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends b.Disposable{constructor(r){super();this.logService=r,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueues=new Map}registerProvider(r,s){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);T.mark(`code/registerFilesystem/${r}`),this.provider.set(r,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:s});const t=new b.DisposableStore;return t.add(s.onDidChangeFile(o=>this._onDidFilesChange.fire(new _.FileChangesEvent(o,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:r}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(o=>this._onError.fire(new Error(o)))),b.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:s}),this.provider.delete(r),b.dispose(t)})}async activateProvider(r){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(t){t&&s.push(t)}}),!this.provider.has(r)&&await Promise.all(s)}canHandleResource(r){return this.provider.has(r.scheme)}hasCapability(r,s){const t=this.provider.get(r.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return w.Iterable.map(this.provider,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async withProvider(r){if(!C.isAbsolutePath(r))throw new _.FileOperationError(h.localize(0,null,this.resourceForError(r)),8);await this.activateProvider(r.scheme);const s=this.provider.get(r.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=h.localize(1,null,r.toString()),t}return s}async withReadProvider(r){const s=await this.withProvider(r);if(_.hasOpenReadWriteCloseCapability(s)||_.hasReadWriteCapability(s)||_.hasFileReadStreamCapability(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const s=await this.withProvider(r);if(_.hasOpenReadWriteCloseCapability(s)||_.hasReadWriteCapability(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.doResolveFile(r,s)}catch(t){throw _.toFileSystemProviderErrorCode(t)===_.FileSystemProviderErrorCode.FileNotFound?new _.FileOperationError(h.localize(2,null,this.resourceForError(r)),1):_.ensureFileSystemProviderError(t)}}async doResolveFile(r,s){const t=await this.withProvider(r),o=this.isPathCaseSensitive(t),i=s==null?void 0:s.resolveTo,l=s==null?void 0:s.resolveSingleChildDescendants,n=s==null?void 0:s.resolveMetadata,d=await t.stat(r);let I;return this.toFileStat(t,r,d,void 0,!!n,(R,D)=>(I||(I=f.TernarySearchTree.forUris(()=>!o),I.set(r,!0),u.isNonEmptyArray(i)&&i.forEach(m=>I.set(m,!0))),Boolean(I.findSuperstr(R.resource)||I.get(R.resource))?!0:R.isDirectory&&l?D===1:!1))}async toFileStat(r,s,t,o,i,l){const{providerExtUri:n}=this.getExtUri(r),d={resource:s,name:n.basename(s),isFile:(t.type&_.FileType.File)!=0,isDirectory:(t.type&_.FileType.Directory)!=0,isSymbolicLink:(t.type&_.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:_.etag({mtime:t.mtime,size:t.size})};if(d.isDirectory&&l(d,o)){try{const I=await r.readdir(s),R=await Promise.all(I.map(async([D,m])=>{try{const A=n.joinPath(s,D),U=i?await r.stat(A):{type:m};return await this.toFileStat(r,A,U,I.length,i,l)}catch(A){return this.logService.trace(A),null}}));d.children=u.coalesce(R)}catch(I){this.logService.trace(I),d.children=[]}return d}return d}async resolveAll(r){return Promise.all(r.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(r){const s=await this.withProvider(r);try{return!!await s.stat(r)}catch(t){return!1}}async canCreateFile(r,s){try{await this.doValidateCreateFile(r,s)}catch(t){return t}return!0}async doValidateCreateFile(r,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(r))throw new _.FileOperationError(h.localize(3,null,this.resourceForError(r)),3,s)}async createFile(r,s=g.VSBuffer.fromString(""),t){await this.doValidateCreateFile(r,t);const o=await this.writeFile(r,s);return this._onDidRunOperation.fire(new _.FileOperationEvent(r,0,o)),o}async writeFile(r,s,t){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:i}=this.getExtUri(o);try{await this.validateWriteFile(o,r,t)||await this.mkdirp(o,i.dirname(r));let n;if(_.hasReadWriteCapability(o)&&!(s instanceof g.VSBuffer))if(p.isReadableStream(s)){const d=await p.peekStream(s,3);d.ended?n=g.VSBuffer.concat(d.buffer):n=d}else n=p.peekReadable(s,d=>g.VSBuffer.concat(d),3);else n=s;!_.hasOpenReadWriteCloseCapability(o)||_.hasReadWriteCapability(o)&&n instanceof g.VSBuffer?await this.doWriteUnbuffered(o,r,n):await this.doWriteBuffered(o,r,n instanceof g.VSBuffer?g.bufferToReadable(n):n)}catch(l){throw new _.FileOperationError(h.localize(4,null,this.resourceForError(r),_.ensureFileSystemProviderError(l).toString()),_.toFileOperationResult(l),t)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,s,t){let o;try{o=await r.stat(s)}catch(i){return}if((o.type&_.FileType.Directory)!=0)throw new _.FileOperationError(h.localize(5,null,this.resourceForError(s)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==_.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==_.etag({mtime:t.mtime,size:o.size}))throw new _.FileOperationError(h.localize(6,null),3,t);return o}async readFile(r,s){const t=await this.withReadProvider(r),o=await this.doReadAsFileStream(t,r,Object.assign(Object.assign({},s),{preferUnbuffered:!0}));return Object.assign(Object.assign({},o),{value:await g.streamToBuffer(o.value)})}async readFileStream(r,s){const t=await this.withReadProvider(r);return this.doReadAsFileStream(t,r,s)}async doReadAsFileStream(r,s,t){const o=new c.CancellationTokenSource,i=this.validateReadFile(s,t).then(n=>n,n=>{throw o.cancel(),n});let l;try{t&&typeof t.etag=="string"&&t.etag!==_.ETAG_DISABLED&&await i;let n;!(_.hasOpenReadWriteCloseCapability(r)||_.hasFileReadStreamCapability(r))||_.hasReadWriteCapability(r)&&(t==null?void 0:t.preferUnbuffered)?n=this.readFileUnbuffered(r,s,t):_.hasFileReadStreamCapability(r)?n=this.readFileStreamed(r,s,o.token,t):n=this.readFileBuffered(r,s,o.token,t),l=p.observe(n);const d=await i;return Object.assign(Object.assign({},d),{value:n})}catch(n){throw l&&await l.errorOrEnd(),new _.FileOperationError(h.localize(7,null,this.resourceForError(s),_.ensureFileSystemProviderError(n).toString()),_.toFileOperationResult(n),t)}}readFileStreamed(r,s,t,o=Object.create(null)){const i=r.readFileStream(s,o,t);return p.transform(i,{data:l=>l instanceof g.VSBuffer?l:g.VSBuffer.wrap(l),error:l=>new _.FileOperationError(h.localize(8,null,this.resourceForError(s),_.ensureFileSystemProviderError(l).toString()),_.toFileOperationResult(l),o)},l=>g.VSBuffer.concat(l))}readFileBuffered(r,s,t,o=Object.create(null)){const i=g.newWriteableBufferStream();return S.readFileIntoStream(r,s,i,l=>l,Object.assign(Object.assign({},o),{bufferSize:this.BUFFER_SIZE,errorTransformer:l=>new _.FileOperationError(h.localize(9,null,this.resourceForError(s),_.ensureFileSystemProviderError(l).toString()),_.toFileOperationResult(l),o)}),t),i}readFileUnbuffered(r,s,t){const o=p.newWriteableStream(i=>g.VSBuffer.concat(i));return(async()=>{try{let i=await r.readFile(s);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(s,i.byteLength,t),o.end(g.VSBuffer.wrap(i))}catch(i){o.error(i)}})(),o}async validateReadFile(r,s){const t=await this.resolve(r,{resolveMetadata:!0});if(t.isDirectory)throw new _.FileOperationError(h.localize(10,null,this.resourceForError(r)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==_.ETAG_DISABLED&&s.etag===t.etag)throw new _.FileOperationError(h.localize(11,null),2,s);return this.validateReadFileLimits(r,t.size,s),t}validateReadFileLimits(r,s,t){if(t==null?void 0:t.limits){let o;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(o=9),typeof t.limits.size=="number"&&s>t.limits.size&&(o=7),typeof o=="number")throw new _.FileOperationError(h.localize(12,null,this.resourceForError(r)),o)}}async canMove(r,s,t){return this.doCanMoveCopy(r,s,"move",t)}async canCopy(r,s,t){return this.doCanMoveCopy(r,s,"copy",t)}async doCanMoveCopy(r,s,t,o){if(r.toString()!==s.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,r,l,s,t,o)}catch(i){return i}return!0}async move(r,s,t){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),l=await this.doMoveCopy(o,r,i,s,"move",!!t),n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new _.FileOperationEvent(r,l==="move"?2:3,n)),n}async copy(r,s,t){const o=await this.withReadProvider(r),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),l=await this.doMoveCopy(o,r,i,s,"copy",!!t),n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new _.FileOperationEvent(r,l==="copy"?3:2,n)),n}async doMoveCopy(r,s,t,o,i,l){if(s.toString()===o.toString())return i;const{exists:n,isSameResourceWithDifferentPathCase:d}=await this.doValidateMoveCopy(r,s,t,o,i,l);if(n&&!d&&l&&await this.del(o,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(o)),i==="copy"){if(r===t&&_.hasFileFolderCopyCapability(r))await r.copy(s,o,{overwrite:l});else{const I=await this.resolve(s);I.isDirectory?await this.doCopyFolder(r,I,t,o):await this.doCopyFile(r,s,t,o)}return i}else return r===t?(await r.rename(s,o,{overwrite:l}),i):(await this.doMoveCopy(r,s,t,o,"copy",l),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(r,s,t,o){if(_.hasOpenReadWriteCloseCapability(r)&&_.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(r,s,t,o);if(_.hasOpenReadWriteCloseCapability(r)&&_.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(r,s,t,o);if(_.hasReadWriteCapability(r)&&_.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(r,s,t,o);if(_.hasReadWriteCapability(r)&&_.hasReadWriteCapability(t))return this.doPipeUnbuffered(r,s,t,o)}async doCopyFolder(r,s,t,o){await t.mkdir(o),Array.isArray(s.children)&&await Promise.all(s.children.map(async i=>{const l=this.getExtUri(t).providerExtUri.joinPath(o,i.name);return i.isDirectory?this.doCopyFolder(r,await this.resolve(i.resource),t,l):this.doCopyFile(r,i.resource,t,l)}))}async doValidateMoveCopy(r,s,t,o,i,l){let n=!1;if(r===t){const{providerExtUri:I,isPathCaseSensitive:R}=this.getExtUri(r);if(R||(n=I.isEqual(s,o)),n&&i==="copy")throw new Error(h.localize(13,null,this.resourceForError(s),this.resourceForError(o)));if(!n&&I.isEqualOrParent(o,s))throw new Error(h.localize(14,null,this.resourceForError(s),this.resourceForError(o)))}const d=await this.exists(o);if(d&&!n){if(!l)throw new _.FileOperationError(h.localize(15,null,this.resourceForError(s),this.resourceForError(o)),4);if(r===t){const{providerExtUri:I}=this.getExtUri(r);if(I.isEqualOrParent(s,o))throw new Error(h.localize(16,null,this.resourceForError(s),this.resourceForError(o)))}}return{exists:d,isSameResourceWithDifferentPathCase:n}}getExtUri(r){const s=this.isPathCaseSensitive(r);return{providerExtUri:s?C.extUri:C.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(r){return!!(r.capabilities&1024)}async createFolder(r){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(s,r);const t=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new _.FileOperationEvent(r,0,t)),t}async mkdirp(r,s){const t=[],{providerExtUri:o}=this.getExtUri(r);for(;!o.isEqual(s,o.dirname(s));)try{if(((await r.stat(s)).type&_.FileType.Directory)==0)throw new Error(h.localize(17,null,this.resourceForError(s)));break}catch(i){if(_.toFileSystemProviderErrorCode(i)!==_.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(o.basename(s)),s=o.dirname(s)}for(let i=t.length-1;i>=0;i--){s=o.joinPath(s,t[i]);try{await r.mkdir(s)}catch(l){if(_.toFileSystemProviderErrorCode(l)!==_.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,s){try{await this.doValidateDelete(r,s)}catch(t){return t}return!0}async doValidateDelete(r,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error(h.localize(18,null,this.resourceForError(r)));const i=await this.exists(r);if(!i)throw new _.FileOperationError(h.localize(19,null,this.resourceForError(r)),1);if(!!!(s==null?void 0:s.recursive)&&i){const n=await this.resolve(r);if(n.isDirectory&&Array.isArray(n.children)&&n.children.length>0)throw new Error(h.localize(20,null,this.resourceForError(r)))}return t}async del(r,s){const t=await this.doValidateDelete(r,s),o=!!(s==null?void 0:s.useTrash),i=!!(s==null?void 0:s.recursive);await t.delete(r,{recursive:i,useTrash:o}),this._onDidRunOperation.fire(new _.FileOperationEvent(r,1))}watch(r,s={recursive:!1,excludes:[]}){let t=!1,o=()=>{t=!0};return this.doWatch(r,s).then(i=>{t?b.dispose(i):o=()=>b.dispose(i)},i=>this.logService.error(i)),b.toDisposable(()=>o())}async doWatch(r,s){const t=await this.withProvider(r),o=this.toWatchKey(t,r,s),i=this.activeWatchers.get(o)||{count:0,disposable:t.watch(r,s)};return this.activeWatchers.has(o)||this.activeWatchers.set(o,i),i.count+=1,b.toDisposable(()=>{i.count--,i.count===0&&(b.dispose(i.disposable),this.activeWatchers.delete(o))})}toWatchKey(r,s,t){const{providerExtUri:o}=this.getExtUri(r);return[o.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(r=>b.dispose(r.disposable)),this.activeWatchers.clear()}ensureWriteQueue(r,s){const{providerExtUri:t}=this.getExtUri(r),o=t.getComparisonKey(s);let i=this.writeQueues.get(o);return i||(i=new v.Queue,this.writeQueues.set(o,i),L.Event.once(i.onFinished)(()=>{this.writeQueues.delete(o),b.dispose(i)})),i}async doWriteBuffered(r,s,t){return this.ensureWriteQueue(r,s).queue(async()=>{const o=await r.open(s,{create:!0});try{p.isReadableStream(t)||p.isReadableBufferedStream(t)?await this.doWriteStreamBufferedQueued(r,o,t):await this.doWriteReadableBufferedQueued(r,o,t)}catch(i){throw _.ensureFileSystemProviderError(i)}finally{await r.close(o)}})}async doWriteStreamBufferedQueued(r,s,t){let o=0,i;if(p.isReadableBufferedStream(t)){if(t.buffer.length>0){const l=g.VSBuffer.concat(t.buffer);await this.doWriteBuffer(r,s,l,l.byteLength,o,0),o+=l.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(l,n)=>{i.on("data",async d=>{i.pause();try{await this.doWriteBuffer(r,s,d,d.byteLength,o,0)}catch(I){return n(I)}o+=d.byteLength,setTimeout(()=>i.resume())}),i.on("error",d=>n(d)),i.on("end",()=>l())})}async doWriteReadableBufferedQueued(r,s,t){let o=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(r,s,i,i.byteLength,o,0),o+=i.byteLength}async doWriteBuffer(r,s,t,o,i,l){let n=0;for(;n<o;)n+=await r.write(s,i+n,t.buffer,l+n,o-n)}async doWriteUnbuffered(r,s,t){return this.ensureWriteQueue(r,s).queue(()=>this.doWriteUnbufferedQueued(r,s,t))}async doWriteUnbufferedQueued(r,s,t){let o;t instanceof g.VSBuffer?o=t:p.isReadableStream(t)?o=await g.streamToBuffer(t):p.isReadableBufferedStream(t)?o=await g.bufferedStreamToBuffer(t):o=g.readableToBuffer(t),await r.writeFile(s,o.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(r,s,t,o){return this.ensureWriteQueue(t,o).queue(()=>this.doPipeBufferedQueued(r,s,t,o))}async doPipeBufferedQueued(r,s,t,o){let i,l;try{i=await r.open(s,{create:!1}),l=await t.open(o,{create:!0});const n=g.VSBuffer.alloc(this.BUFFER_SIZE);let d=0,I=0,R=0;do R=await r.read(i,d,n.buffer,I,n.byteLength-I),await this.doWriteBuffer(t,l,n,R,d,I),d+=R,I+=R,I===n.byteLength&&(I=0);while(R>0)}catch(n){throw _.ensureFileSystemProviderError(n)}finally{await Promise.all([typeof i=="number"?r.close(i):Promise.resolve(),typeof l=="number"?t.close(l):Promise.resolve()])}}async doPipeUnbuffered(r,s,t,o){return this.ensureWriteQueue(t,o).queue(()=>this.doPipeUnbufferedQueued(r,s,t,o))}async doPipeUnbufferedQueued(r,s,t,o){return t.writeFile(o,await r.readFile(s),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(r,s,t,o){return this.ensureWriteQueue(t,o).queue(()=>this.doPipeUnbufferedToBufferedQueued(r,s,t,o))}async doPipeUnbufferedToBufferedQueued(r,s,t,o){const i=await t.open(o,{create:!0});try{const l=await r.readFile(s);await this.doWriteBuffer(t,i,g.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw _.ensureFileSystemProviderError(l)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(r,s,t,o){const i=await g.streamToBuffer(this.readFileBuffered(r,s,c.CancellationToken.None));await this.doWriteUnbuffered(t,o,i)}throwIfFileSystemIsReadonly(r,s){if(r.capabilities&2048)throw new _.FileOperationError(h.localize(21,null,this.resourceForError(s)),6);return r}resourceForError(r){return r.scheme===E.Schemas.file?r.fsPath:r.toString(!0)}};y=Se([we(0,P.ILogService)],y),e.FileService=y}),define(x[54],ee([0,1,21,37,2,24,5,4,12,3,20,34,15,13,128,72,142,144,141,149,42,71,18,17]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c,E,S,w,y,a,r,s,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class i extends b.Disposable{constructor(n,d){var I;super();this.logService=n,this.options=d,this.BUFFER_SIZE=((I=this.options)===null||I===void 0?void 0:I.bufferSize)||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new p.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:d,symbolicLink:I}=await f.statLink(this.toFilePath(n));return{type:this.toType(d,I),ctime:d.birthtime.getTime(),mtime:d.mtime.getTime(),size:d.size}}catch(d){throw this.toFileSystemProviderError(d)}}async readdir(n){try{const d=await f.readdirWithFileTypes(this.toFilePath(n)),I=[];return await Promise.all(d.map(async R=>{try{let D;R.isSymbolicLink()?D=(await this.stat(P.joinPath(n,R.name))).type:D=this.toType(R),I.push([R.name,D])}catch(D){this.logService.trace(D)}})),I}catch(d){throw this.toFileSystemProviderError(d)}}toType(n,d){let I;return(d==null?void 0:d.dangling)?I=_.FileType.Unknown:n.isFile()?I=_.FileType.File:n.isDirectory()?I=_.FileType.Directory:I=_.FileType.Unknown,d&&(I|=_.FileType.SymbolicLink),I}async readFile(n){try{const d=this.toFilePath(n);return await f.readFile(d)}catch(d){throw this.toFileSystemProviderError(d)}}readFileStream(n,d,I){const R=r.newWriteableStream(D=>o.VSBuffer.concat(D.map(m=>o.VSBuffer.wrap(m))).buffer);return s.readFileIntoStream(this,n,R,D=>D.buffer,Object.assign(Object.assign({},d),{bufferSize:this.BUFFER_SIZE}),I),R}async writeFile(n,d,I){let R;try{const D=this.toFilePath(n);if(!I.create||!I.overwrite){if(await f.exists(D)){if(!I.overwrite)throw _.createFileSystemProviderError(c.localize(0,null),_.FileSystemProviderErrorCode.FileExists)}else if(!I.create)throw _.createFileSystemProviderError(c.localize(1,null),_.FileSystemProviderErrorCode.FileNotFound)}R=await this.open(n,{create:!0}),await this.write(R,0,d,0,d.byteLength)}catch(D){throw this.toFileSystemProviderError(D)}finally{typeof R=="number"&&await this.close(R)}}async open(n,d){try{const I=this.toFilePath(n);let R;if(d.create){if(C.isWindows&&await f.exists(I))try{await f.truncate(I,0),R="r+"}catch(m){this.logService.trace(m)}R||(R="w")}else R="r";const D=await T.promisify(h.open)(I,R);return this.mapHandleToPos.set(D,0),d.create&&this.writeHandles.add(D),D}catch(I){throw this.toFileSystemProviderError(I)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await T.promisify(h.fdatasync)(n)}catch(d){this.canFlush=!1,this.logService.error(d)}return await T.promisify(h.close)(n)}catch(d){throw this.toFileSystemProviderError(d)}}async read(n,d,I,R,D){const m=this.normalizePos(n,d);let A=null;try{const U=await T.promisify(h.read)(n,I,R,D,m);return typeof U=="number"?A=U:A=U.bytesRead,A}catch(U){throw this.toFileSystemProviderError(U)}finally{this.updatePos(n,m,A)}}normalizePos(n,d){return d===this.mapHandleToPos.get(n)?null:d}updatePos(n,d,I){const R=this.mapHandleToPos.get(n);typeof R=="number"&&(typeof d=="number"||(typeof I=="number"?this.mapHandleToPos.set(n,R+I):this.mapHandleToPos.delete(n)))}async write(n,d,I,R,D){return p.retry(()=>this.doWrite(n,d,I,R,D),100,3)}async doWrite(n,d,I,R,D){const m=this.normalizePos(n,d);let A=null;try{const U=await T.promisify(h.write)(n,I,R,D,m);return typeof U=="number"?A=U:A=U.bytesWritten,A}catch(U){throw this.toFileSystemProviderError(U)}finally{this.updatePos(n,m,A)}}async mkdir(n){try{await T.promisify(h.mkdir)(this.toFilePath(n))}catch(d){throw this.toFileSystemProviderError(d)}}async delete(n,d){try{const I=this.toFilePath(n);await this.doDelete(I,d)}catch(I){throw this.toFileSystemProviderError(I)}}async doDelete(n,d){d.recursive?await f.rimraf(n,f.RimRafMode.MOVE):await f.unlink(n)}async rename(n,d,I){const R=this.toFilePath(n),D=this.toFilePath(d);if(R!==D)try{await this.validateTargetDeleted(n,d,"move",I.overwrite),await f.move(R,D)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error(c.localize(2,null,u.basename(R),u.basename(u.dirname(D)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(n,d,I){const R=this.toFilePath(n),D=this.toFilePath(d);if(R!==D)try{await this.validateTargetDeleted(n,d,"copy",I.overwrite),await f.copy(R,D)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error(c.localize(3,null,u.basename(R),u.basename(u.dirname(D)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(n,d,I,R){const D=this.toFilePath(n),m=this.toFilePath(d);let A=!1;if(!!(this.capabilities&1024)||(A=g.isEqual(D,m,!0)),A&&I==="copy")throw _.createFileSystemProviderError(c.localize(4,null),_.FileSystemProviderErrorCode.FileExists);if(!A&&await f.exists(m)){if(!R)throw _.createFileSystemProviderError(c.localize(5,null),_.FileSystemProviderErrorCode.FileExists);await this.delete(d,{recursive:!0,useTrash:!1})}}watch(n,d){return d.recursive?this.watchRecursive(n,d.excludes):this.watchNonRecursive(n)}watchRecursive(n,d){const I={path:this.toFilePath(n),excludes:d},R=t.insert(this.recursiveFoldersToWatch,I);return this.refreshRecursiveWatchers(),b.toDisposable(()=>{R(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var n,d,I;if(this.recursiveWatcher instanceof y.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(b.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let R,D;((d=(n=this.options)===null||n===void 0?void 0:n.watcher)===null||d===void 0?void 0:d.usePolling)?(R=S.FileWatcher,D=(I=this.options)===null||I===void 0?void 0:I.watcher):this.recursiveFoldersToWatch.length===1?C.isWindows?R=w.FileWatcher:R=S.FileWatcher:R=y.FileWatcher,this.recursiveWatcher=new R(this.recursiveFoldersToWatch,m=>this._onDidChangeFile.fire(E.toFileChanges(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===v.LogLevel.Trace,D),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))}}watchNonRecursive(n){const d=new a.FileWatcher(this.toFilePath(n),R=>this._onDidChangeFile.fire(E.toFileChanges(R)),R=>{R.type==="error"&&this._onDidWatchErrorOccur.fire(R.message),this.logService[R.type](R.message)},this.logService.getLevel()===v.LogLevel.Trace),I=this.logService.onDidChangeLogLevel(()=>{d.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)});return b.combinedDisposable(d,I)}toFilePath(n){return u.normalize(n.fsPath)}toFileSystemProviderError(n){if(n instanceof _.FileSystemProviderError)return n;let d;switch(n.code){case"ENOENT":d=_.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":d=_.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":d=_.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":d=_.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":d=_.FileSystemProviderErrorCode.NoPermissions;break;default:d=_.FileSystemProviderErrorCode.Unknown}return _.createFileSystemProviderError(n,d)}dispose(){super.dispose(),b.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,b.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=i}),define(x[75],ee([0,1,12,154,27,2,23,15,31,13,44,18,5,10,3]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let E=class extends _.Disposable{constructor(y,a,r){super();this.extensionManagementService=y,this.logService=r,this._onDidLanguagesChange=this._register(new p.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new S(a,r)),this._register(y.onDidInstallExtension(({local:s})=>this.onDidInstallExtension(s))),this._register(y.onDidUninstallExtension(({identifier:s})=>this.onDidUninstallExtension(s)))}getLanguageIds(){return this.cache.getLanguagePacks().then(y=>{const a=["en",...Object.keys(y)];return g.distinct(a)})}onDidInstallExtension(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",y.identifier.id),this.update().then(a=>{a&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(y){this.cache.getLanguagePacks().then(a=>{Object.keys(a).some(r=>a[r]&&a[r].extensions.some(s=>f.areSameExtensions(s.extensionIdentifier,y)))&&(this.logService.debug("Removing language packs from the extension",y.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}update(){return Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]).then(([y,a])=>this.cache.update(a).then(r=>!g.equals(Object.keys(y),Object.keys(r))))}};E=Se([we(0,b.IExtensionManagementService),we(1,L.INativeEnvironmentService),we(2,u.ILogService)],E),e.LocalizationsService=E;let S=class extends _.Disposable{constructor(y,a){super();this.logService=a,this.languagePacks={},this.languagePacksFilePath=c.join(y.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new C.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(y){return this.withLanguagePacks(a=>{Object.keys(a).forEach(r=>delete a[r]),this.createLanguagePacksFromExtensions(a,...y)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(y,...a){for(const r of a)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(y,r);Object.keys(y).forEach(r=>this.updateHash(y[r]))}createLanguagePacksFromExtension(y,a){const r=a.identifier,s=a.manifest.contributes&&a.manifest.contributes.localizations?a.manifest.contributes.localizations:[];for(const t of s)if(a.location.scheme===v.Schemas.file&&P.isValidLocalization(t)){let o=y[t.languageId];o||(o={hash:"",extensions:[],translations:{}},y[t.languageId]=o);let i=o.extensions.filter(l=>f.areSameExtensions(l.extensionIdentifier,r))[0];i?i.version=a.manifest.version:o.extensions.push({extensionIdentifier:r,version:a.manifest.version});for(const l of t.translations)o.translations[l.id]=c.join(a.location.fsPath,l.path)}}updateHash(y){if(y){const a=T.createHash("md5");for(const r of y.extensions)a.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);y.hash=a.digest("hex")}}withLanguagePacks(y=()=>null){return this.languagePacksFileLimiter.queue(()=>{let a=null;return h.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(s){return{}}}).then(r=>(a=y(r),r)).then(r=>{for(const t of Object.keys(r))r[t]||delete r[t];this.languagePacks=r,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),h.writeFile(this.languagePacksFilePath,s)}).then(()=>a,r=>this.logService.error(r))})}};S=Se([we(0,L.INativeEnvironmentService),we(1,u.ILogService)],S)}),define(x[155],ee([0,1,13]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function T(_,L){switch(L){case h.LogLevel.Trace:return _.trace;case h.LogLevel.Debug:return _.debug;case h.LogLevel.Info:return _.info;case h.LogLevel.Warning:return _.warn;case h.LogLevel.Error:return _.error;case h.LogLevel.Critical:return _.critical;default:throw new Error("Invalid log level")}}class b extends h.AbstractLogService{constructor(L=h.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(L),this._register(this.onDidChangeLogLevel(C=>{this._logger&&this._logger.setLevel(C)}))}set logger(L){this._logger=L;for(const{level:C,args:f}of this.buffer)T(L,C).apply(L,f);this.buffer=[]}_log(L,...C){this._logger?T(this._logger,L).apply(this._logger,C):this.getLevel()<=L&&this.buffer.push({level:L,args:C})}trace(L,...C){this._log(h.LogLevel.Trace,L,...C)}debug(L,...C){this._log(h.LogLevel.Debug,L,...C)}info(L,...C){this._log(h.LogLevel.Info,L,...C)}warn(L,...C){this._log(h.LogLevel.Warning,L,...C)}error(L,...C){this._log(h.LogLevel.Error,L,...C)}critical(L,...C){this._log(h.LogLevel.Critical,L,...C)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=b}),define(x[156],ee([0,1,13,24,15,17,20,2,6,155]),function(H,e,h,T,b,_,L,C,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogService=void 0;const P=5*T.ByteSize.MB;let g=class extends h.AbstractLogService{constructor(c,E,S,w){super();this.name=c,this.resource=E,this.fileService=w,this.backupIndex=1,this.setLevel(S),this.queue=this._register(new b.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const c=arguments[0];if(c instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=c.stack,this._log(h.LogLevel.Error,this.format(E))}else this._log(h.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,this.format(arguments))}flush(){}log(c,E){this._log(c,this.format(E))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(c){if(c.fileOperationResult!==3)throw c}}_log(c,E){this.queue.queue(async()=>{await this.initializePromise;let S=await this.loadContent();S.length>P&&(await this.fileService.writeFile(this.getBackupResource(),_.VSBuffer.fromString(S)),S=""),S+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(c)}] ${E}
`,await this.fileService.writeFile(this.resource,_.VSBuffer.fromString(S))})}getCurrentTimestamp(){const c=w=>w<10?`0${w}`:w,E=w=>w<10?`00${w}`:w<100?`0${w}`:w,S=new Date;return`${S.getFullYear()}-${c(S.getMonth()+1)}-${c(S.getDate())} ${c(S.getHours())}:${c(S.getMinutes())}:${c(S.getSeconds())}.${E(S.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,L.joinPath(L.dirname(this.resource),`${L.basename(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(c){return""}}stringifyLogLevel(c){switch(c){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}format(c){let E="";for(let S=0;S<c.length;S++){let w=c[S];if(typeof w=="object")try{w=JSON.stringify(w)}catch(y){}E+=(S>0?" ":"")+w}return E}};g=Se([we(3,T.IFileService)],g),e.FileLogService=g;let p=class extends C.Disposable{constructor(c,E,S){super();this.logService=c,this.instantiationService=E,this.fileService=S,this.loggers=new Map,this._register(c.onDidChangeLogLevel(w=>this.loggers.forEach(y=>y.setLevel(w))))}getLogger(c){let E=this.loggers.get(c.toString());return E||(E=new u.BufferLogService(this.logService.getLevel()),this.loggers.set(c.toString(),E),T.whenProviderRegistered(c,this.fileService).then(()=>E.logger=this.instantiationService.createInstance(g,L.basename(c),c,this.logService.getLevel()))),E}dispose(){this.loggers.forEach(c=>c.dispose()),this.loggers.clear(),super.dispose()}};p=Se([we(0,h.ILogService),we(1,f.IInstantiationService),we(2,T.IFileService)],p),e.FileLoggerService=p}),define(x[157],ee([0,1,13,5]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=void 0;class b{constructor(f){this.service=f,this.onDidChangeLogLevel=T.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,u){switch(u){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${u}`)}call(f,u,P){switch(u){case"setLevel":return this.service.setLevel(P),Promise.resolve();case"consoleLog":return this.consoleLog(P[0],P[1]),Promise.resolve()}throw new Error(`Call not found: ${u}`)}consoleLog(f,u){let P=console.log;switch(f){case"error":P=console.error;break;case"warn":P=console.warn;break;case"info":P=console.info;break}P.call(console,...u)}}e.LoggerChannel=b;class _{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){_.setLevel(this.channel,f)}static setLevel(f,u){return f.call("setLevel",u)}consoleLog(f,u){this.channel.call("consoleLog",[f,u])}}e.LoggerChannelClient=_;class L extends h.DelegatedLogService{constructor(f,u){super(u);this.parent=f,this._register(f.onDidChangeLogLevel(P=>u.setLevel(P)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=L}),define(x[55],ee([0,1,3,13,24]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogService=e.createRotatingLogger=void 0;async function _(u,P){try{const g=await new Promise((v,c)=>{H(["spdlog"],v,c)});g.setAsyncMode(8192,500);const p=h.join(P,`${u}.log`);return g.createRotatingLoggerAsync(u,p,5*b.ByteSize.MB,6)}catch(g){console.error(g)}return null}function L(u,P,g,p){return H.__$__nodeRequire("spdlog").createRotatingLogger(u,P,g,p)}e.createRotatingLogger=L;function C(u,P,g){switch(P){case T.LogLevel.Trace:u.trace(g);break;case T.LogLevel.Debug:u.debug(g);break;case T.LogLevel.Info:u.info(g);break;case T.LogLevel.Warning:u.warn(g);break;case T.LogLevel.Error:u.error(g);break;case T.LogLevel.Critical:u.critical(g);break;default:throw new Error("Invalid log level")}}class f extends T.AbstractLogService{constructor(P,g,p){super();this.name=P,this.logsFolder=g,this.buffer=[],this._loggerCreationPromise=void 0,this.setLevel(p),this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}_createSpdLogLogger(){return this._loggerCreationPromise||(this._loggerCreationPromise=_(this.name,this.logsFolder).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:g,message:p}of this.buffer)C(this._logger,g,p);this.buffer=[]}})),this._loggerCreationPromise}_log(P,g){this._logger?C(this._logger,P,g):this.getLevel()<=P&&this.buffer.push({level:P,message:g})}trace(P,...g){this.getLevel()<=T.LogLevel.Trace&&this._log(T.LogLevel.Trace,this.format([P,...g]))}debug(P,...g){this.getLevel()<=T.LogLevel.Debug&&this._log(T.LogLevel.Debug,this.format([P,...g]))}info(P,...g){this.getLevel()<=T.LogLevel.Info&&this._log(T.LogLevel.Info,this.format([P,...g]))}warn(P,...g){this.getLevel()<=T.LogLevel.Warning&&this._log(T.LogLevel.Warning,this.format([P,...g]))}error(P,...g){if(this.getLevel()<=T.LogLevel.Error)if(P instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=P.stack,this._log(T.LogLevel.Error,this.format(p))}else this._log(T.LogLevel.Error,this.format([P,...g]))}critical(P,...g){this.getLevel()<=T.LogLevel.Critical&&this._log(T.LogLevel.Critical,this.format([P,...g]))}flush(){this._logger?this._logger.flush():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.disposeLogger()),this._loggerCreationPromise=void 0}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}format(P){let g="";for(let p=0;p<P.length;p++){let v=P[p];if(typeof v=="object")try{v=JSON.stringify(v)}catch(c){}g+=(p>0?" ":"")+v}return g}}e.SpdLogService=f}),define(x[158],ee([0,1,13,2,20,10,156,55,24]),function(H,e,h,T,b,_,L,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let u=class extends T.Disposable{constructor(g,p){super();this.logService=g,this.fileService=p,this.loggers=new Map,this._register(g.onDidChangeLogLevel(v=>this.loggers.forEach(c=>c.setLevel(v))))}getLogger(g){let p=this.loggers.get(g.toString());if(!p){if(g.scheme===_.Schemas.file){const v=b.basename(g),c=b.extname(g);p=new C.SpdLogService(v.substring(0,v.length-c.length),b.dirname(g).fsPath,this.logService.getLevel())}else p=new L.FileLogService(b.basename(g),g,this.logService.getLevel(),this.fileService);this.loggers.set(g.toString(),p)}return p}dispose(){this.loggers.forEach(g=>g.dispose()),this.loggers.clear(),super.dispose()}};u=Se([we(0,h.ILogService),we(1,f.IFileService)],u),e.LoggerService=u}),define(x[159],ee([0,1,95,6,5]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=h.default,e.INotificationService=T.createDecorator("notificationService");var _;(function(u){u[u.WORKSPACE=0]="WORKSPACE",u[u.GLOBAL=1]="GLOBAL"})(_=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var L;(function(u){u[u.OFF=0]="OFF",u[u.SILENT=1]="SILENT",u[u.ERROR=2]="ERROR"})(L=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new f,this.onDidClose=b.Event.None,this.onDidChangeVisibility=b.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.NoOpNotification=C;class f{infinite(){}done(){}total(P){}worked(P){}}e.NoOpProgress=f}),define(x[28],ee([0,1,4,33,10,20]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(h.isWeb||typeof H=="undefined"||typeof H.__$__nodeRequire!="function"){L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.53.0-dev",nameShort:h.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:h.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/master/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});const C=document.getElementById("vscode-remote-product-configuration"),f=C&&C.getAttribute("data-settings");f&&Object.assign(L,JSON.parse(f))}else{const C=_.dirname(b.FileAccess.asFileUri("",H));L=H.__$__nodeRequire(_.joinPath(C,"product.json").fsPath);const f=H.__$__nodeRequire(_.joinPath(C,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`}),Object.assign(L,{version:f.version})}e.default=L}),define(x[46],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=h.createDecorator("productService")}),define(x[29],ee([0,1,11,90]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(L,C){T.ok(h.isString(L)),T.ok(h.isObject(C)),T.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,C)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new b}),define(x[160],ee([0,1,29,5]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class _{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,u){this.schemasById[b(f)]=u,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new _;h.Registry.add(e.Extensions.JSONContribution,L)}),define(x[41],ee([0,1,118,5,29,11,160]),function(H,e,h,T,b,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const f=b.Registry.as(L.Extensions.JSONContribution);class u{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:h.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,y=!0){this.registerConfigurations([w],y)}registerConfigurations(w,y=!0){const a=[];w.forEach(r=>{a.push(...this.validateAndRegisterProperties(r,y)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(w){const y=[],a=r=>{if(r.properties)for(const s in r.properties)y.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s]);r.allOf&&r.allOf.forEach(s=>a(s))};for(const r of w){a(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}f.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}registerDefaultConfigurations(w){const y=[],a=[];for(const r of w)for(const s in r)if(y.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),r[s]);const t={type:"object",default:this.defaultValues[s],description:h.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};a.push(g(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=r[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}deregisterDefaultConfigurations(w){const y=[];for(const a of w)for(const r in a)if(y.push(r),delete this.defaultValues[r],e.OVERRIDE_PROPERTY_PATTERN.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const s=this.configurationProperties[r];s&&(this.updatePropertyDefaultValue(r,s),this.updateSchema(r,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const y of w)this.overrideIdentifiers.add(y);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,y=!0,a=3){a=_.isUndefinedOrNull(w.scope)?a:w.scope;let r=[],s=w.properties;if(s)for(let o in s){if(y&&c(o)){delete s[o];continue}const i=s[o];if(this.updatePropertyDefaultValue(o,i),e.OVERRIDE_PROPERTY_PATTERN.test(o)?i.scope=void 0:i.scope=_.isUndefinedOrNull(i.scope)?a:i.scope,s[o].hasOwnProperty("included")&&!s[o].included){this.excludedConfigurationProperties[o]=s[o],delete s[o];continue}else this.configurationProperties[o]=s[o];!s[o].deprecationMessage&&s[o].markdownDeprecationMessage&&(s[o].deprecationMessage=s[o].markdownDeprecationMessage),r.push(o)}let t=w.allOf;if(t)for(let o of t)r.push(...this.validateAndRegisterProperties(o,y,a));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const y=a=>{let r=a.properties;if(r)for(const t in r)this.updateSchema(t,r[t]);let s=a.allOf;s&&s.forEach(y)};y(w)}updateSchema(w,y){switch(e.allSettings.properties[w]=y,y.scope){case 1:e.applicationSettings.properties[w]=y;break;case 2:e.machineSettings.properties[w]=y;break;case 6:e.machineOverridableSettings.properties[w]=y;break;case 3:e.windowSettings.properties[w]=y;break;case 4:e.resourceSettings.properties[w]=y;break;case 5:e.resourceSettings.properties[w]=y,this.resourceLanguageSettingsSchema.properties[w]=y;break}}removeFromSchema(w,y){switch(delete e.allSettings.properties[w],y.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const y=`[${w}]`,a={type:"object",description:h.localize(2,null),errorMessage:h.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(y,a),e.allSettings.properties[y]=a,e.applicationSettings.properties[y]=a,e.machineSettings.properties[y]=a,e.machineOverridableSettings.properties[y]=a,e.windowSettings.properties[y]=a,e.resourceSettings.properties[y]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,y){let a=this.defaultValues[w];_.isUndefined(a)&&(a=y.default),_.isUndefined(a)&&(a=p(y.type)),y.default=a}}const P="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function g(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=g;function p(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const v=new u;b.Registry.add(e.Extensions.Configuration,v);function c(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?h.localize(5,null,S):v.getConfigurationProperties()[S]!==void 0?h.localize(6,null,S):null:h.localize(4,null)}e.validateProperty=c;function E(){const S=[],w=v.getConfigurationProperties();for(const y of Object.keys(w))S.push([y,w[y].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=E}),define(x[32],ee([0,1,19,11,7,29,6,41]),function(H,e,h,T,b,_,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=L.createDecorator("configurationService");function f(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof b.URI)}e.isConfigurationOverrides=f;var u;(function(o){o[o.USER=1]="USER",o[o.USER_LOCAL=2]="USER_LOCAL",o[o.USER_REMOTE=3]="USER_REMOTE",o[o.WORKSPACE=4]="WORKSPACE",o[o.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",o[o.DEFAULT=6]="DEFAULT",o[o.MEMORY=7]="MEMORY"})(u=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(o){switch(o){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=P;function g(o,i){const l=i?o?i.keys.filter(A=>o.keys.indexOf(A)===-1):[...i.keys]:[],n=o?i?o.keys.filter(A=>i.keys.indexOf(A)===-1):[...o.keys]:[],d=[];if(i&&o){for(const A of o.keys)if(i.keys.indexOf(A)!==-1){const U=w(o.contents,A),q=w(i.contents,A);h.equals(U,q)||d.push(A)}}const I=[],R=A=>{const U={};for(const q of A)for(const M of q.identifiers)U[s(M)]=q;return U},D=i?R(i.overrides):{},m=o?R(o.overrides):{};if(Object.keys(D).length)for(const A of l){const U=D[A];U&&I.push([C.overrideIdentifierFromKey(A),U.keys])}if(Object.keys(m).length)for(const A of n){const U=m[A];U&&I.push([C.overrideIdentifierFromKey(A),U.keys])}if(Object.keys(D).length&&Object.keys(m).length)for(const A of d){const U=m[A],q=D[A];if(U&&q){const M=g({contents:U.contents,keys:U.keys,overrides:[]},{contents:q.contents,keys:q.keys,overrides:[]});I.push([C.overrideIdentifierFromKey(A),[...M.added,...M.removed,...M.updated]])}}return{added:l,removed:n,updated:d,overrides:I}}e.compare=g;function p(o,i){const l=[];for(const n of Object.keys(o))if(C.OVERRIDE_PROPERTY_PATTERN.test(n)){const d={};for(const I in o[n])d[I]=o[n][I];l.push({identifiers:[C.overrideIdentifierFromKey(n).trim()],keys:Object.keys(d),contents:v(d,i)})}return l}e.toOverrides=p;function v(o,i){const l=Object.create(null);for(let n in o)c(l,n,o[n],i);return l}e.toValuesTree=v;function c(o,i,l,n){const d=i.split("."),I=d.pop();let R=o;for(let D=0;D<d.length;D++){let m=d[D],A=R[m];switch(typeof A){case"undefined":A=R[m]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${d.slice(0,D+1).join(".")} is ${JSON.stringify(A)}`);return}R=A}if(typeof R=="object"&&R!==null)try{R[I]=l}catch(D){n(`Ignoring ${i} as ${d.join(".")} is ${JSON.stringify(R)}`)}else n(`Ignoring ${i} as ${d.join(".")} is ${JSON.stringify(R)}`)}e.addToValueTree=c;function E(o,i){const l=i.split(".");S(o,l)}e.removeFromValueTree=E;function S(o,i){const l=i.shift();if(i.length===0){delete o[l];return}if(Object.keys(o).indexOf(l)!==-1){const n=o[l];typeof n=="object"&&!Array.isArray(n)&&(S(n,i),Object.keys(n).length===0&&delete o[l])}}function w(o,i,l){function n(R,D){let m=R;for(const A of D){if(typeof m!="object"||m===null)return;m=m[A]}return m}const d=i.split("."),I=n(o,d);return typeof I=="undefined"?l:I}e.getConfigurationValue=w;function y(o,i,l){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in o?T.isObject(o[n])&&T.isObject(i[n])?y(o[n],i[n],l):l&&(o[n]=i[n]):o[n]=i[n])})}e.merge=y;function a(){const o=_.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(o)}e.getConfigurationKeys=a;function r(){const o=Object.create(null),i=_.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let l in i){let n=i[l].default;c(o,l,n,d=>console.error(`Conflict in default settings: ${d}`))}return o}e.getDefaultValues=r;function s(o){return`[${o}]`}e.keyFromOverrideIdentifier=s;function t(o,i,l){const n=o.inspect(i),d=o.inspect(l);return typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:n.defaultValue}e.getMigratedSettingValue=t}),define(x[161],ee([0,1,62,30,18,11,19,7,41,32,29,2,5]),function(H,e,h,T,b,_,L,C,f,u,P,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(t={},o=[],i=[]){this._contents=t,this._keys=o,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?u.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,o){const i=this.getContentsForOverrideIdentifer(o);return i?t?u.getConfigurationValue(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const o of this.overrides)if(o.identifiers.indexOf(t)!==-1)return o.keys;return[]}override(t){const o=this.getContentsForOverrideIdentifer(t);if(!o||typeof o!="object"||!Object.keys(o).length)return this;let i={};for(const l of b.distinct([...Object.keys(this.contents),...Object.keys(o)])){let n=this.contents[l],d=o[l];d&&(typeof n=="object"&&typeof d=="object"?(n=L.deepClone(n),this.mergeContents(n,d)):n=d),i[l]=n}return new v(i,this.keys,this.overrides)}merge(...t){const o=L.deepClone(this.contents),i=L.deepClone(this.overrides),l=[...this.keys];for(const n of t){this.mergeContents(o,n.contents);for(const d of n.overrides){const[I]=i.filter(R=>b.equals(R.identifiers,d.identifiers));I?this.mergeContents(I.contents,d.contents):i.push(L.deepClone(d))}for(const d of n.keys)l.indexOf(d)===-1&&l.push(d)}return new v(o,l,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,o){for(const i of Object.keys(o)){if(i in t&&_.isObject(t[i])&&_.isObject(o[i])){this.mergeContents(t[i],o[i]);continue}t[i]=L.deepClone(o[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?L.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const o of this.overrides)if(o.identifiers.indexOf(t)!==-1)return o.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,o){this.addKey(t),u.addToValueTree(this.contents,t,o,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&u.removeFromValueTree(this.contents,t)}addKey(t){let o=this.keys.length;for(let i=0;i<o;i++)t.indexOf(this.keys[i])===0&&(o=i);this.keys.splice(o,1,t)}removeKey(t){let o=this.keys.indexOf(t);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=v;class c extends v{constructor(){const t=u.getDefaultValues(),o=u.getConfigurationKeys(),i=[];for(const l of Object.keys(t))f.OVERRIDE_PROPERTY_PATTERN.test(l)&&i.push({identifiers:[f.overrideIdentifierFromKey(l).trim()],keys:Object.keys(t[l]),contents:u.toValuesTree(t[l],n=>console.error(`Conflict in default settings file: ${n}`))});super(t,o,i)}}e.DefaultConfigurationModel=c;class E{constructor(t,o){this._name=t,this._scopes=o,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get errors(){return this._parseErrors}parseContent(t){if(!_.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o)}}parseRaw(t){this._raw=t;const o=this.doParseRaw(t);this._configurationModel=new v(o.contents,o.keys,o.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let o={},i=null,l=[],n=[],d=[];function I(D){Array.isArray(l)?l.push(D):i&&(l[i]=D)}let R={onObjectBegin:()=>{let D={};I(D),n.push(l),l=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{l=n.pop()},onArrayBegin:()=>{let D=[];I(D),n.push(l),l=D,i=null},onArrayEnd:()=>{l=n.pop()},onLiteralValue:I,onError:(D,m,A)=>{d.push({error:D,offset:m,length:A})}};if(t)try{h.visit(t,R),o=l[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return o}doParseRaw(t){if(this._scopes){const n=P.Registry.as(f.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,n,!0,this._scopes)}const o=u.toValuesTree(t,n=>console.error(`Conflict in settings file ${this._name}: ${n}`)),i=Object.keys(t),l=u.toOverrides(t,n=>console.error(`Conflict in settings file ${this._name}: ${n}`));return{contents:o,keys:i,overrides:l}}filterByScope(t,o,i,l){const n={};for(let d in t)if(f.OVERRIDE_PROPERTY_PATTERN.test(d)&&i)n[d]=this.filterByScope(t[d],o,!1,l);else{const I=this.getScope(d,o);(I===void 0||l.indexOf(I)!==-1)&&(n[d]=t[d])}return n}getScope(t,o){const i=o[t];return i?typeof i.scope!="undefined"?i.scope:3:void 0}}e.ConfigurationModelParser=E;class S extends g.Disposable{constructor(t,o,i,l){super();this.userSettingsResource=t,this.scopes=o,this.fileService=l,this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(p.Event.filter(this.fileService.onDidFilesChange,n=>n.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new v}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=S;class w{constructor(t,o,i=new v,l=new v,n=new T.ResourceMap,d=new v,I=new T.ResourceMap,R=!0){this._defaultConfiguration=t,this._localUserConfiguration=o,this._remoteUserConfiguration=i,this._workspaceConfiguration=l,this._folderConfigurations=n,this._memoryConfiguration=d,this._memoryConfigurationByResource=I,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,o,i){return this.getConsolidateConfigurationModel(o,i).getValue(t)}updateValue(t,o,i={}){let l;i.resource?(l=this._memoryConfigurationByResource.get(i.resource),l||(l=new v,this._memoryConfigurationByResource.set(i.resource,l))):l=this._memoryConfiguration,o===void 0?l.removeValue(t):l.setValue(t,o),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,o,i){const l=this.getConsolidateConfigurationModel(o,i),n=this.getFolderConfigurationModelForResource(o.resource,i),d=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,I=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),R=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),D=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),m=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=i?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,U=n?o.overrideIdentifier?n.freeze().override(o.overrideIdentifier).getValue(t):n.freeze().getValue(t):void 0,q=o.overrideIdentifier?d.override(o.overrideIdentifier).getValue(t):d.getValue(t),M=l.getValue(t),W=b.distinct(b.flatten(l.overrides.map(N=>N.identifiers))).filter(N=>l.getOverrideValue(t,N)!==void 0);return{defaultValue:I,userValue:R,userLocalValue:D,userRemoteValue:m,workspaceValue:A,workspaceFolderValue:U,memoryValue:q,value:M,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,userLocal:D!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,userRemote:m!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,workspaceFolder:U!==void 0?{value:n==null?void 0:n.freeze().getValue(t),override:o.overrideIdentifier?n==null?void 0:n.freeze().getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,memory:q!==void 0?{value:d.getValue(t),override:o.overrideIdentifier?d.getOverrideValue(t,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(t){const o=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,o){this._folderConfigurations.set(t,o),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,o){const i=o.filter(l=>f.OVERRIDE_PROPERTY_PATTERN.test(l)).map(l=>{const n=f.overrideIdentifierFromKey(l),d=this._defaultConfiguration.getKeysForOverrideIdentifier(n),I=t.getKeysForOverrideIdentifier(n),R=[...I.filter(D=>d.indexOf(D)===-1),...d.filter(D=>I.indexOf(D)===-1),...d.filter(D=>!L.equals(this._defaultConfiguration.override(n).getValue(D),t.override(n).getValue(D)))];return[n,R]});return this.updateDefaultConfiguration(t),{keys:o,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:o,updated:i,removed:l,overrides:n}=u.compare(this.localUserConfiguration,t),d=[...o,...i,...l];return d.length&&this.updateLocalUserConfiguration(t),{keys:d,overrides:n}}compareAndUpdateRemoteUserConfiguration(t){const{added:o,updated:i,removed:l,overrides:n}=u.compare(this.remoteUserConfiguration,t);let d=[...o,...i,...l];return d.length&&this.updateRemoteUserConfiguration(t),{keys:d,overrides:n}}compareAndUpdateWorkspaceConfiguration(t){const{added:o,updated:i,removed:l,overrides:n}=u.compare(this.workspaceConfiguration,t);let d=[...o,...i,...l];return d.length&&this.updateWorkspaceConfiguration(t),{keys:d,overrides:n}}compareAndUpdateFolderConfiguration(t,o){const i=this.folderConfigurations.get(t),{added:l,updated:n,removed:d,overrides:I}=u.compare(i,o);let R=[...l,...n,...d];return(R.length||!i)&&this.updateFolderConfiguration(t,o),{keys:R,overrides:I}}compareAndDeleteFolderConfiguration(t){const o=this.folderConfigurations.get(t);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:l,removed:n,overrides:d}=u.compare(o,void 0);return{keys:[...i,...l,...n],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,o){let i=this.getConsolidatedConfigurationModelForResource(t,o);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},o){let i=this.getWorkspaceConsolidatedConfiguration();if(o&&t){const l=o.getFolder(t);l&&(i=this.getFolderConsolidatedConfiguration(l.uri)||i);const n=this._memoryConfigurationByResource.get(t);n&&(i=i.merge(n))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let o=this._foldersConsolidatedConfigurations.get(t);if(!o){const i=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(t);l?(o=i.merge(l),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(t,o)):o=i}return o}getFolderConfigurationModelForResource(t,o){if(o&&t){const i=o.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,o)=>{const{contents:i,overrides:l,keys:n}=this._folderConfigurations.get(o);return t.push([o,{contents:i,overrides:l,keys:n}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>t.add(o)),this.userConfiguration.freeze().keys.forEach(o=>t.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>t.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>o.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>o.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(l=>o.add(l))),[...o.values()]}static parse(t){const o=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),l=this.parseConfigurationModel(t.workspace),n=t.folders.reduce((d,I)=>(d.set(C.URI.revive(I[0]),this.parseConfigurationModel(I[1])),d),new T.ResourceMap);return new w(o,i,new v,l,n,new v,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new v(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function y(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,o=new Map;for(const l of s)l.keys.forEach(n=>t.add(n)),l.overrides.forEach(([n,d])=>{const I=T.getOrSet(o,n,new Set);d.forEach(R=>I.add(R))});const i=[];return o.forEach((l,n)=>i.push([n,[...l.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=y;class a{constructor(t,o,i,l){this.change=t,this.previous=o,this.currentConfiguraiton=i,this.currentWorkspace=l,this._previousConfiguration=void 0;const n=new Set;t.keys.forEach(I=>n.add(I)),t.overrides.forEach(([,I])=>I.forEach(R=>n.add(R))),this.affectedKeys=[...n.values()];const d=new v;this.affectedKeys.forEach(I=>d.setValue(I,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,o){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(o){const l=this.previousConfiguration?this.previousConfiguration.getValue(t,o,(i=this.previous)===null||i===void 0?void 0:i.workspace):void 0,n=this.currentConfiguraiton.getValue(t,o,this.currentWorkspace);return!L.equals(l,n)}return!0}return!1}doesAffectedKeysTreeContains(t,o){let i=u.toValuesTree({[o]:!0},()=>{}),l;for(;typeof i=="object"&&(l=Object.keys(i)[0]);){if(t=t[l],!t)return!1;i=i[l]}return!0}}e.ConfigurationChangeEvent=a;class r extends a{constructor(t,o,i,l){super({keys:t.allKeys(),overrides:[]},void 0,t,o);this.source=i,this.sourceConfig=l}}e.AllKeysConfigurationChangeEvent=r}),define(x[76],ee([0,1,29,41,2,32,161,5,15,20]),function(H,e,h,T,b,_,L,C,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends b.Disposable{constructor(p,v){super();this.settingsResource=p,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new L.UserSettings(this.settingsResource,void 0,u.extUriBiasedIgnorePathCase,v)),this.configuration=new L.Configuration(new L.DefaultConfigurationModel,new L.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new f.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(h.Registry.as(T.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const p=await this.userConfiguration.loadConfiguration();this.configuration=new L.Configuration(new L.DefaultConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(p,v){const c=typeof p=="string"?p:void 0,E=_.isConfigurationOverrides(p)?p:_.isConfigurationOverrides(v)?v:{};return this.configuration.getValue(c,E,void 0)}updateValue(p,v,c,E){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const v=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(c,v,1)}onDidDefaultConfigurationChange(p){const v=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new L.DefaultConfigurationModel,p);this.trigger(c,v,6)}trigger(p,v,c){const E=new L.ConfigurationChangeEvent(p,{data:v},this.configuration);E.source=c,E.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(p){switch(p){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(x[162],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=h.createDecorator("remoteAuthorityResolverService");var T;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(L,C=T.Unknown,f){super(L);this._message=L,this._code=C,this._detail=f,this.isHandled=C===T.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(L){return L instanceof b&&L._code===T.TemporarilyNotAvailable}static isNoResolverFound(L){return L instanceof b&&L._code===T.NoResolverFound}static isHandled(L){return L instanceof b&&L.isHandled}}e.RemoteAuthorityResolverError=b}),define(x[56],ee([0,1,129,6,41,29,17]),function(H,e,h,T,b,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=T.createDecorator("requestService");function C(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=C;function f(g){return g.res.statusCode===204}async function u(g){if(!C(g))throw new Error("Server returned "+g.res.statusCode);return f(g)?null:(await L.streamToBuffer(g.stream)).toString()}e.asText=u;async function P(g){if(!C(g))throw new Error("Server returned "+g.res.statusCode);if(f(g))return null;const v=(await L.streamToBuffer(g.stream)).toString();try{return JSON.parse(v)}catch(c){throw c.message+=`:
`+v,c}}e.asJson=P,_.Registry.as(b.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:h.localize(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:h.localize(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:h.localize(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:h.localize(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[h.localize(4,null),h.localize(5,null),h.localize(6,null)],default:"override",description:h.localize(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:h.localize(8,null)}}})}),define(x[163],ee([0,1,25,17]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class b{constructor(C){this.service=C}listen(C,f){throw new Error("Invalid listen")}call(C,f,u){switch(f){case"request":return this.service.request(u[0],h.CancellationToken.None).then(async({res:P,stream:g})=>{const p=await T.streamToBuffer(g);return[{statusCode:P.statusCode,headers:P.headers},p]})}throw new Error("Invalid call")}}e.RequestChannel=b;class _{constructor(C){this.channel=C}async request(C,f){return _.request(this.channel,C,f)}static async request(C,f,u){const[P,g]=await C.call("request",[f]);return{res:P,stream:T.bufferToStream(g)}}}e.RequestChannelClient=_}),define(x[164],ee([0,1,165,11]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function b(L){return L.protocol==="http:"?process.env.HTTP_PROXY||process.env.http_proxy||null:L.protocol==="https:"&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}async function _(L,C={}){const f=h.parse(L),u=C.proxyUrl||b(f);if(!u)return null;const P=h.parse(u);if(!/^https?:$/.test(P.protocol||""))return null;const g={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:T.isBoolean(C.strictSSL)?C.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((p,v)=>{H(["http-proxy-agent"],p,v)}))(g):new(await new Promise((p,v)=>{H(["https-proxy-agent"],p,v)}))(g)}e.getProxyAgent=_}),define(x[166],ee([0,1,26,17]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function b(_,L,C){let f=C&&C.get("storage.serviceMachineId",0)||null;if(f)return f;try{const P=(await L.readFile(_.serviceMachineIdResource)).value.toString();f=h.isUUID(P)?P:null}catch(u){f=null}if(!f){f=h.generateUuid();try{await L.writeFile(_.serviceMachineIdResource,T.VSBuffer.fromString(f))}catch(u){}}return C&&C.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=b}),define(x[167],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=h.createDecorator("stateService")}),define(x[168],ee([0,1,3,21,23,12,11,13]),function(H,e,h,T,b,_,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class f{constructor(g,p){this.dbPath=g,this.onError=p,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const g=await this.loadAsync();this._database||(this._database=g)}}loadSync(){try{return this.lastFlushedSerializedDatabase=T.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await _.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}getItem(g,p){const v=this.database[g];return L.isUndefinedOrNull(v)?p:v}setItem(g,p){if(L.isUndefinedOrNull(p))return this.removeItem(g);(typeof p=="string"||typeof p=="number"||typeof p=="boolean")&&this.database[g]===p||(this.database[g]=p,this.saveSync())}removeItem(g){L.isUndefined(this.database[g])||(this.database[g]=void 0,this.saveSync())}saveSync(){const g=JSON.stringify(this.database,null,4);if(g!==this.lastFlushedSerializedDatabase)try{_.writeFileSync(this.dbPath,g),this.lastFlushedSerializedDatabase=g}catch(p){this.onError(p)}}}e.FileStorage=f;let u=class Xe{constructor(g,p){this.fileStorage=new f(h.join(g.userDataPath,Xe.STATE_FILE),v=>p.error(v))}init(){return this.fileStorage.init()}getItem(g,p){return this.fileStorage.getItem(g,p)}setItem(g,p){this.fileStorage.setItem(g,p)}removeItem(g){this.fileStorage.removeItem(g)}};u.STATE_FILE="storage.json",u=Se([we(0,b.INativeEnvironmentService),we(1,C.ILogService)],u),e.StateService=u}),define(x[169],ee([0,1,6,5,2,11]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const L="__$__targetStorageMarker";e.IStorageService=h.createDecorator("storageService");var C;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var f;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(f=e.StorageScope||(e.StorageScope={}));var u;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(u=e.StorageTarget||(e.StorageTarget={}));class P extends b.Disposable{constructor(){super(...arguments);this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}emitDidChangeValue(c,E){E===L?(c===0?this._globalKeyTargets=void 0:c===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:c})):this._onDidChangeValue.fire({scope:c,key:E,target:this.getKeyTargets(c)[E]})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}store(c,E,S,w){if(_.isUndefinedOrNull(E)){this.remove(c,S);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,S,w),this.doStore(c,E,S)})}remove(c,E){this.withPausedEmitters(()=>{this.updateKeyTarget(c,E,void 0),this.doRemove(c,E)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,E){const S=[],w=this.getKeyTargets(c);for(const y of Object.keys(w))w[y]===E&&S.push(y);return S}updateKeyTarget(c,E,S){const w=this.getKeyTargets(E);typeof S=="number"?w[c]!==S&&(w[c]=S,this.doStore(L,JSON.stringify(w),E)):typeof w[c]=="number"&&(delete w[c],this.doStore(L,JSON.stringify(w),E))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(c){return c===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(c){const E=this.get(L,c);if(E)try{return JSON.parse(E)}catch(S){}return Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}flush(){return this._onWillSaveState.fire({reason:C.NONE}),this.doFlush()}}e.AbstractStorageService=P;class g extends P{constructor(){super(...arguments);this.globalCache=new Map,this.workspaceCache=new Map}getCache(c){return c===0?this.globalCache:this.workspaceCache}get(c,E,S){const w=this.getCache(E).get(c);return _.isUndefinedOrNull(w)?S:w}getBoolean(c,E,S){const w=this.getCache(E).get(c);return _.isUndefinedOrNull(w)?S:w==="true"}getNumber(c,E,S){const w=this.getCache(E).get(c);return _.isUndefinedOrNull(w)?S:parseInt(w,10)}doStore(c,E,S){const w=String(E);this.getCache(S).get(c)!==w&&(this.getCache(S).set(c,w),this.emitDidChangeValue(S,c))}doRemove(c,E){!this.getCache(E).delete(c)||this.emitDidChangeValue(E,c)}logStorage(){p(this.globalCache,this.workspaceCache,"inMemory","inMemory")}async migrate(c){}async doFlush(){}async close(){}}e.InMemoryStorageService=g;async function p(v,c,E,S){const w=i=>{try{return JSON.parse(i)}catch(l){return i}},y=new Map,a=new Map;v.forEach((i,l)=>{y.set(l,i),a.set(l,w(i))});const r=new Map,s=new Map;c.forEach((i,l)=>{r.set(l,i),s.set(l,w(i))}),console.group(`Storage: Global (path: ${E})`);let t=[];y.forEach((i,l)=>{t.push({key:l,value:i})}),console.table(t),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${S})`);let o=[];r.forEach((i,l)=>{o.push({key:l,value:i})}),console.table(o),console.groupEnd(),console.log(s)}e.logStorage=p}),define(x[77],ee([0,1,4,33,26,7]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function L(f,u,P,g,p,v,c,E,S){const w=Object.create(null);w["common.machineId"]=v,w.sessionID=b.generateUuid()+Date.now(),w.commitHash=g,w.version=p,w["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=h.PlatformToString(h.platform),w["common.nodePlatform"]=T.platform,w["common.nodeArch"]=P,w["common.product"]=S||"desktop";const y=C(c||[]);y&&(w["common.msftInternal"]=y);let a=0;const r=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),h.isLinuxSnap&&(w["common.snap"]="true");try{const s=await f.readFile(_.URI.file(E));w["common.source"]=s.value.toString().slice(0,30)}catch(s){}return w}e.resolveCommonProperties=L;function C(f){const u=T.env.USERDNSDOMAIN;if(!u)return!1;const P=u.toLowerCase();return f.some(g=>P===g)}}),define(x[170],ee([0,1,18,14,2,19]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var L;(function(f){function u(P,g){return P.callstack<g.callstack?-1:P.callstack>g.callstack?1:0}f.compare=u})(L=e.ErrorEvent||(e.ErrorEvent={}));class C{constructor(u,P=C.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new b.DisposableStore,this._telemetryService=u,this._flushDelay=P;const g=T.errorHandler.addListener(p=>this._onErrorEvent(p));this._disposables.add(b.toDisposable(g)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(u){if(!!u){u.detail&&u.detail.stack&&(u=u.detail);let P=Array.isArray(u.stack)?u.stack.join(`
`):u.stack,g=u.message?u.message:_.safeStringify(u);!P||this._enqueue({msg:g,callstack:P})}}_enqueue(u){const P=h.binarySearch(this._buffer,u,L.compare);P<0?(u.count=1,this._buffer.splice(~P,0,u)):(this._buffer[P].count||(this._buffer[P].count=0),this._buffer[P].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let u of this._buffer)this._telemetryService.publicLogError2("UnhandledError",u);this._buffer.length=0}}e.default=C,C.ERROR_FLUSH_TIMEOUT=5*1e3}),define(x[171],ee([0,1,2,4,170]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class _ extends b.default{installErrorListeners(){let C,f=this;typeof T.globals.onerror=="function"&&(C=T.globals.onerror),T.globals.onerror=function(u,P,g,p,v){f._onUncaughtError(u,P,g,p,v),C&&C.apply(this,arguments)},this._disposables.add(h.toDisposable(()=>{C&&(T.globals.onerror=C)}))}_onUncaughtError(C,f,u,P,g){let p={callstack:C,msg:C,file:f,line:u,column:P};if(g){let{name:v,message:c,stack:E}=g;p.uncaught_error_name=v,c&&(p.uncaught_error_msg=c),E&&(p.callstack=Array.isArray(g.stack)?g.stack=g.stack.join(`
`):g.stack)}this._enqueue(p)}}e.default=_}),define(x[47],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ITelemetryService=void 0,e.ITelemetryService=h.createDecorator("telemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(x[78],ee([0,1,14,27,31,19,47,56,51,23,25,13,24,7,46,169,166,6,20]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c,E,S,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var a;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished"})(a||(a={}));function r(...B){return String(B.reduce((k,O)=>k|O,0))}var s;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class n{constructor(k=l){this.state=k}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(k,O=this.state.pageSize){return new n(Object.assign(Object.assign({},this.state),{pageNumber:k,pageSize:O}))}withFilter(k,...O){const F=[...this.state.criteria,...O.length?O.map(z=>({filterType:k,value:z})):[{filterType:k}]];return new n(Object.assign(Object.assign({},this.state),{criteria:F}))}withSortBy(k){return new n(Object.assign(Object.assign({},this.state),{sortBy:k}))}withSortOrder(k){return new n(Object.assign(Object.assign({},this.state),{sortOrder:k}))}withFlags(...k){return new n(Object.assign(Object.assign({},this.state),{flags:k.reduce((O,F)=>O|F,0)}))}withAssetTypes(...k){return new n(Object.assign(Object.assign({},this.state),{assetTypes:k}))}get raw(){const{criteria:k,pageNumber:O,pageSize:F,sortBy:z,sortOrder:G,flags:Y,assetTypes:Q}=this.state;return{filters:[{criteria:k,pageNumber:O,pageSize:F,sortBy:z,sortOrder:G}],assetTypes:Q,flags:Y}}get searchText(){const k=this.state.criteria.filter(O=>O.filterType===s.SearchText)[0];return k&&k.value?k.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(k=>String(k.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function d(B,k){const O=(B||[]).filter(F=>F.statisticName===k)[0];return O?O.value:0}function I(B){const k="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(F=>F.assetType.indexOf(k)===0).reduce((F,z)=>{const G=A(B,z.assetType);return G&&F.push([z.assetType.substring(k.length),G]),F},[])}function R(B){if(B.properties){const k=B.properties.filter(z=>z.key===t.Repository),O=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),F=k.filter(z=>O.test(z.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return A(B,t.Repository)}function D(B){return{uri:`${B.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${B.fallbackAssetUri}/${t.VSIX}`}}function m(B){const k=A(B,t.Icon);if(k)return k;const O=T.DefaultIconPath;return{uri:O,fallbackUri:O}}function A(B,k){return B.files.filter(F=>F.assetType===k)[0]?{uri:`${B.assetUri}/${k}`,fallbackUri:`${B.fallbackAssetUri}/${k}`}:null}function U(B,k){const O=B.properties?B.properties.filter(z=>z.key===k):[],F=O.length>0&&O[0].value;return F?F.split(",").map(z=>b.adoptToGalleryExtensionId(z)):[]}function q(B){const k=B.properties?B.properties.filter(O=>O.key===o.Engine):[];return k.length>0&&k[0].value||""}function M(B){const k=B.properties?B.properties.filter(F=>F.key===o.LocalizedLanguages):[],O=k.length>0&&k[0].value||"";return O?O.split(","):[]}function W(B){return B.indexOf("preview")!==-1}function N(B){const k=B.properties?B.properties.find(O=>O.key===o.WebExtension):void 0;return!!k&&k.value==="true"}function K(B){return B.files.some(k=>k.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?y.joinPath(v.URI.parse(B.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function j(B,k,O,F,z){const G={manifest:A(k,t.Manifest),readme:A(k,t.Details),changelog:A(k,t.Changelog),license:A(k,t.License),repository:R(k),download:D(k),icon:m(k),coreTranslations:I(k)};return{identifier:{id:b.getGalleryExtensionId(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:k.version,date:k.lastUpdated,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,description:B.shortDescription||"",installCount:d(B.statistics,"install"),rating:d(B.statistics,"averagerating"),ratingCount:d(B.statistics,"ratingcount"),assetUri:v.URI.parse(k.assetUri),webResource:K(k),assetTypes:k.files.map(({assetType:Y})=>Y),assets:G,properties:{dependencies:U(k,o.Dependency),extensionPack:U(k,o.ExtensionPack),engine:q(k),localizedLanguages:M(k),webExtension:N(k)},telemetryData:{index:(F.pageNumber-1)*F.pageSize+O,searchText:F.searchText,querySource:z},preview:W(B.flags)}}let $=class{constructor(k,O,F,z,G,Y,Q){this.requestService=k,this.logService=O,this.environmentService=F,this.telemetryService=z,this.fileService=G,this.productService=Y;const Z=Y.extensionsGallery;this.extensionsGalleryUrl=Z&&Z.serviceUrl,this.extensionsControlUrl=Z&&Z.controlUrl,this.commonHeadersPromise=J(Y.version,this.environmentService,this.fileService,Q)}api(k=""){return`${this.extensionsGalleryUrl}${k}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(k,O){const F=[];let{total:z,firstPage:G,getPage:Y}=await this.query({names:k,pageSize:k.length},O);F.push(...G);for(let Q=1;F.length<z&&(G=await Y(Q,O),G.length);Q++)F.push(...G);return F}async getCompatibleExtension(k,O){const F=await this.getCompatibleExtensionByEngine(k,O);return(F==null?void 0:F.properties.webExtension)?F.webResource?F:null:F}async getCompatibleExtensionByEngine(k,O){const F=T.isIExtensionIdentifier(k)?null:k;if(F&&F.properties.engine&&f.isEngineValid(F.properties.engine,this.productService.version))return F;const{id:z,uuid:G}=F?F.identifier:k;let Y=new n().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");G?Y=Y.withFilter(s.ExtensionId,G):Y=Y.withFilter(s.ExtensionName,z);const{galleryExtensions:Q}=await this.queryGallery(Y,P.CancellationToken.None),[Z]=Q;if(!Z||!Z.versions.length)return null;if(O){const le=Z.versions.filter(fe=>fe.version===O)[0];if(le){const fe=j(Z,le,0,Y);if(fe.properties.engine&&f.isEngineValid(fe.properties.engine,this.productService.version))return fe}return null}const se=await this.getLastValidExtensionVersion(Z,Z.versions);return se?j(Z,se,0,Y):null}async query(k,O){const F=P.CancellationToken.isCancellationToken(k)?{}:k,z=P.CancellationToken.isCancellationToken(k)?k:O;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let G=F.text||"";const Y=_.getOrDefault(F,ie=>ie.pageSize,50);let Q=new n().withFlags(a.IncludeLatestVersionOnly,a.IncludeAssetUri,a.IncludeStatistics,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,Y).withFilter(s.Target,"Microsoft.VisualStudio.Code");G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,ae,ue)=>(Q=Q.withFilter(s.Category,ue||ae),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,ae,ue)=>(Q=Q.withFilter(s.Tag,ue||ae),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(Q=Q.withFilter(s.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),Q=Q.withFilter(s.SearchText,G)),Q=Q.withSortBy(0)):F.ids?Q=Q.withFilter(s.ExtensionId,...F.ids):F.names?Q=Q.withFilter(s.ExtensionName,...F.names):Q=Q.withSortBy(4),typeof F.sortBy=="number"&&(Q=Q.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(Q=Q.withSortOrder(F.sortOrder));const{galleryExtensions:Z,total:se}=await this.queryGallery(Q,z),le=Z.map((ie,ae)=>j(ie,ie.versions[0],ae,Q,F.source)),fe=async(ie,ae)=>{if(ae.isCancellationRequested)throw h.canceled();const ue=Q.withPage(ie+1),{galleryExtensions:ye}=await this.queryGallery(ue,ae);return ye.map((Ce,Le)=>j(Ce,Ce.versions[0],Le,ue,F.source))};return{firstPage:le,total:se,pageSize:Q.pageSize,getPage:fe}}async queryGallery(k,O){if(!this.isEnabled())throw new Error("No extension gallery service configured.");k=k.withFlags(k.flags,a.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,r(a.Unpublished));const F=await this.commonHeadersPromise,z=JSON.stringify(k.raw),G=Object.assign(Object.assign({},F),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(z.length)}),Y=new Date().getTime();let Q,Z,se=0;try{if(Q=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:z,headers:G},O),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:se};const le=await C.asJson(Q);if(le){const fe=le.results[0],ie=fe.extensions,ae=fe.resultMetadata&&fe.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return se=ae&&ae.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:ie,total:se}}return{galleryExtensions:[],total:se}}catch(le){throw Z=le,le}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},k.telemetryData),{requestBodySize:String(z.length),duration:new Date().getTime()-Y,success:!!Q&&C.isSuccess(Q),responseBodySize:Q==null?void 0:Q.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:Z?h.isPromiseCanceledError(Z)?"canceled":h.getErrorMessage(Z).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(se)}))}}async reportStatistic(k,O,F,z){if(!!this.isEnabled()){const G=await this.commonHeadersPromise,Y=Object.assign(Object.assign({},G),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${k}/extensions/${O}/${F}/stats?statType=${z}`),headers:Y},P.CancellationToken.None)}catch(Q){}}}async download(k,O,F){this.logService.trace("ExtensionGalleryService#download",k.identifier.id);const z=b.getGalleryExtensionTelemetryData(k),G=new Date().getTime(),Y=le=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},z),{duration:le})),Q=F===1?"install":F===2?"update":"",Z=Q?{uri:`${k.assets.download.uri}&${Q}=true`,fallbackUri:`${k.assets.download.fallbackUri}?${Q}=true`}:k.assets.download,se=await this.getAsset(Z);await this.fileService.writeFile(O,se.stream),Y(new Date().getTime()-G)}async getReadme(k,O){if(k.assets.readme){const F=await this.getAsset(k.assets.readme,{},O);return await C.asText(F)||""}return""}async getManifest(k,O){if(k.assets.manifest){const F=await this.getAsset(k.assets.manifest,{},O),z=await C.asText(F);return z?JSON.parse(z):null}return null}async getCoreTranslation(k,O){const F=k.assets.coreTranslations.filter(z=>z[0]===O.toUpperCase())[0];if(F){const z=await this.getAsset(F[1]),G=await C.asText(z);return G?JSON.parse(G):null}return null}async getChangelog(k,O){if(k.assets.changelog){const F=await this.getAsset(k.assets.changelog,{},O);return await C.asText(F)||""}return""}async getAllVersions(k,O){let F=new n().withFlags(a.IncludeVersions,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");k.identifier.uuid?F=F.withFilter(s.ExtensionId,k.identifier.uuid):F=F.withFilter(s.ExtensionName,k.identifier.id);const z=[],{galleryExtensions:G}=await this.queryGallery(F,P.CancellationToken.None);return G.length&&(O?await Promise.all(G[0].versions.map(async Y=>{let Q;try{Q=await this.getEngine(Y)}catch(Z){}Q&&f.isEngineValid(Q,this.productService.version)&&z.push({version:Y.version,date:Y.lastUpdated})})):z.push(...G[0].versions.map(Y=>({version:Y.version,date:Y.lastUpdated})))),z}async getAsset(k,O={},F=P.CancellationToken.None){const z=await this.commonHeadersPromise,G={type:"GET"},Y=Object.assign(Object.assign({},z),O.headers||{});O=Object.assign(Object.assign(Object.assign({},O),G),{headers:Y});const Q=k.uri,Z=k.fallbackUri,se=Object.assign(Object.assign({},O),{url:Q});try{const le=await this.requestService.request(se,F);if(le.res.statusCode===200)return le;const fe=await C.asText(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${fe}`)}catch(le){if(h.isPromiseCanceledError(le))throw le;const fe=h.getErrorMessage(le);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Q,message:fe});const ie=Object.assign(Object.assign({},O),{url:Z});return this.requestService.request(ie,F)}}async getLastValidExtensionVersion(k,O){const F=this.getLastValidExtensionVersionFromProperties(k,O);return F||this.getLastValidExtensionVersionRecursively(k,O)}getLastValidExtensionVersionFromProperties(k,O){for(const F of O){const z=q(F);if(!z)return null;if(f.isEngineValid(z,this.productService.version))return F}return null}async getEngine(k){const O=q(k);if(O)return O;const F=A(k,t.Manifest);if(!F)throw new Error("Manifest was not found");const z={"Accept-Encoding":"gzip"},G=await this.getAsset(F,{headers:z}),Y=await C.asJson(G);if(Y)return Y.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(k,O){if(!O.length)return null;const F=O[0],z=await this.getEngine(F);return f.isEngineValid(z,this.productService.version)?(F.properties=F.properties||[],F.properties.push({key:o.Engine,value:z}),F):this.getLastValidExtensionVersionRecursively(k,O.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const k=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},P.CancellationToken.None);if(k.res.statusCode!==200)throw new Error("Could not get extensions report.");const O=await C.asJson(k),F=new Map;if(O)for(const z of O.malicious){const G=F.get(z)||{id:{id:z},malicious:!0,slow:!1};G.malicious=!0,F.set(z,G)}return[...F.values()]}};$=Se([we(0,C.IRequestService),we(1,g.ILogService),we(2,u.IEnvironmentService),we(3,L.ITelemetryService),we(4,p.IFileService),we(5,c.IProductService),we(6,w.optional(E.IStorageService))],$),e.ExtensionGalleryService=$;async function J(B,k,O,F){const z={"X-Market-Client-Id":`VSCode ${B}`,"User-Agent":`VSCode ${B}`},G=await S.getServiceMachineId(k,O,F);return z["X-Market-User-Id"]=G,z}e.resolveMarketplaceHeaders=J}),define(x[79],ee([0,1,28,130,16,6,32,41,2,19,29]),function(H,e,h,T,b,_,L,C,f,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(c,E){this._configurationService=E,this._experimentProperties={},this._disposables=new f.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp(b.escapeRegExpCharacters(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const w=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!w})}))}setExperimentProperty(c,E){this._experimentProperties[c]=E}setEnabled(c){this._enabled=c}_updateUserOptIn(){var c;const E=(c=this._configurationService)===null||c===void 0?void 0:c.getValue(p);this._userOptIn=E?E.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let E=c.sessionID,S=c["common.instanceId"],w=c["common.machineId"],y=c["common.msftInternal"];return{sessionId:E,instanceId:S,machineId:w,msftInternal:y}}dispose(){this._disposables.dispose()}publicLog(c,E,S){return this.isOptedIn?this._commonProperties.then(w=>{E=u.mixin(E,w),E=u.mixin(E,this._experimentProperties),E=u.cloneAndChange(E,y=>{if(typeof y=="string")return this._cleanupInfo(y,S)}),this._appender.log(c,E)},w=>{console.error(w)}):Promise.resolve(void 0)}publicLog2(c,E,S){return this.publicLog(c,E,S)}publicLogError(c,E){return this.sendErrorTelemetry?this.publicLog(c,E,!0):Promise.resolve(void 0)}publicLogError2(c,E){return this.publicLogError(c,E)}_cleanupInfo(c,E){let S=c;if(E){const w=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(c);if(!t)break;w.push([t.index,s.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(S="";;){const s=a.exec(c);if(!s)break;!y.test(s[0])&&w.every(([t,o])=>s.index<t||s.index>=o)&&(S+=c.substring(r,s.index)+"<REDACTED: user-file-path>",r=a.lastIndex)}r<c.length&&(S+=c.substr(r))}for(let w of this._cleanupPatterns)S=S.replace(w,"");return S}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=Se([we(1,_.optional(L.IConfigurationService))],g),e.TelemetryService=g;const p="telemetry";P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:p,order:110,type:"object",title:T.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:h.default.privacyStatementUrl?T.localize(2,null,h.default.privacyStatementUrl):T.localize(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(x[48],ee([0,1,32,19,11]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(p,v){return Promise.resolve(void 0)}publicLog2(p,v){return this.publicLog(p,v)}publicLogError(p,v){return Promise.resolve(void 0)}publicLogError2(p,v){return this.publicLogError(p,v)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId"})}};function _(...p){return{log:(v,c)=>p.forEach(E=>E.log(v,c)),flush:()=>Promise.all(p.map(v=>v.flush()))}}e.combinedAppender=_,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function L(p,v){return v.onDidChangeConfiguration(c=>{c.source!==6&&p.publicLog2("updateConfiguration",{configurationSource:h.ConfigurationTargetToString(c.source),configurationKeys:P(c.sourceConfig)})})}e.configurationTelemetry=L;function C(p){const v=Object.create(null),c=Object.create(null),E=Object.create(null);u(p,E);for(let S in E){S=S.length>150?S.substr(S.length-149):S;const w=E[S];typeof w=="number"?c[S]=w:typeof w=="boolean"?c[S]=w?1:0:typeof w=="string"?v[S]=w.substring(0,1023):typeof w!="undefined"&&w!==null&&(v[S]=w)}return{properties:v,measurements:c}}e.validateTelemetryData=C;function f(p){if(!p)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{p.indexOf(`${E}+`)===0&&(v=E)}),v}e.cleanRemoteAuthority=f;function u(p,v,c=0,E){if(!!p)for(let S of Object.getOwnPropertyNames(p)){const w=p[S],y=E?E+S:S;Array.isArray(w)?v[y]=T.safeStringify(w):w instanceof Date?v[y]=w.toISOString():b.isObject(w)?c<2?u(w,v,c+1,y+"."):v[y]=T.safeStringify(w):v[y]=w}}function P(p){if(!p)return[];const v=[];return g(v,"",p),v}function g(p,v,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(E=>g(p,v?`${v}.${E}`:E,c[E])):p.push(v)}}),define(x[172],ee([0,1,2,23,13,48]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let L=class extends h.Disposable{constructor(f,u){super();this.logger=this._register(f.getLogger(u.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(f,u){this.logger.trace(`telemetry/${f}`,_.validateTelemetryData(u))}};L=Se([we(0,b.ILoggerService),we(1,T.IEnvironmentService)],L),e.TelemetryLogAppender=L}),define(x[80],ee([0,1,14,19,48]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function _(C){const f=await new Promise((P,g)=>{H(["applicationinsights"],P,g)});let u;return f.defaultClient?(u=new f.TelemetryClient(C),u.channel.setUseDiskRetryCaching(!0)):(f.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),u=f.defaultClient),C.indexOf("AIF-")===0&&(u.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),u}class L{constructor(f,u,P){this._eventPrefix=f,this._defaultData=u,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(f){if(!!this._aiClient){if(typeof this._aiClient!="string"){f(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=_(this._aiClient)),this._asyncAIClient.then(u=>{f(u)},u=>{h.onUnexpectedError(u),console.error(u)})}}log(f,u){!this._aiClient||(u=T.mixin(u,this._defaultData),u=b.validateTelemetryData(u),this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+f,properties:u.properties,measurements:u.measurements})))}flush(){return this._aiClient?new Promise(f=>{this._withAIClient(u=>{u.flush({callback:()=>{this._aiClient=void 0,f(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=L}),define(x[173],ee([0,1,12,21,3]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;function _(L,C){const f=Object.create(null),u=(g,p)=>{const v=JSON.parse(g);f[p]=v};if(C){const g=h.readdirSync(C).filter(v=>{try{return T.statSync(b.join(C,v)).isDirectory()}catch(c){return!1}}),p=[];g.forEach(v=>{h.readdirSync(b.join(C,v)).filter(E=>E==="telemetry.json").length===1&&p.push(v)}),p.forEach(v=>{const c=T.readFileSync(b.join(C,v,"telemetry.json")).toString();u(c,v)})}let P=T.readFileSync(b.join(L,"telemetry-core.json")).toString();return u(P,"vscode-core"),P=T.readFileSync(b.join(L,"telemetry-extensions.json")).toString(),u(P,"vscode-extensions"),JSON.stringify(f,null,4)}e.buildTelemetryMessage=_}),define(x[174],ee([0,1,7,20,6,30]),function(H,e,h,T,b,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=b.createDecorator("contextService");var L;(function(p){p[p.EMPTY=1]="EMPTY",p[p.FOLDER=2]="FOLDER",p[p.WORKSPACE=3]="WORKSPACE"})(L=e.WorkbenchState||(e.WorkbenchState={}));function C(p){const v=p;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=C;function f(p){const v=p;return!!(v&&typeof v=="object"&&h.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=f;class u{constructor(v,c,E,S){this._id=v,this._configuration=E,this._ignorePathCasing=S,this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(v){this._id=v.id,this._configuration=v.configuration,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=_.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=u;class P{constructor(v,c){this.raw=c,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return T.joinPath(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=P;function g(p){return new P({uri:p,index:0,name:T.basenameOrAuthority(p)},{uri:p.toString()})}e.toWorkspaceFolder=g}),define(x[175],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryChannelClient=e.TelemetryChannel=void 0;class h{constructor(_){this.service=_}listen(_,L){throw new Error(`Invalid listen ${L}`)}call(_,L,C){switch(L){case"publicLog":return this.service.publicLog(C[0],C[1],C[2]);case"publicLog2":return this.service.publicLog2(C[0],C[1],C[2]);case"publicLogError":return this.service.publicLogError(C[0],C[1]);case"publicLogError2":return this.service.publicLogError2(C[0],C[1]);case"setEnabled":return Promise.resolve(this.service.setEnabled(C[0]));case"getTelemetryInfo":return this.service.getTelemetryInfo();case"setExperimentProperty":return Promise.resolve(this.service.setExperimentProperty(C[0],C[1]))}throw new Error(`Invalid call ${L}`)}}e.TelemetryChannel=h;class T{constructor(_){this.channel=_,this.isOptedIn=!0,this.sendErrorTelemetry=!0}publicLog(_,L,C){return this.channel.call("publicLog",[_,L,C])}publicLog2(_,L,C){return this.channel.call("publicLog2",[_,L,C])}publicLogError(_,L){return this.channel.call("publicLogError",[_,L])}publicLogError2(_,L){return this.channel.call("publicLogError2",[_,L])}setEnabled(_){this.channel.call("setEnable",[_])}getTelemetryInfo(){return this.channel.call("getTelemetryInfo")}setExperimentProperty(_,L){this.channel.call("setExperimentProperty",[_,L])}}e.TelemetryChannelClient=T}),define(x[176],ee([0,1,203,204,22]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class _{get _sender(){throw new Error("unimplemented")}get _buffer(){throw new Error("unimplemented")}setUseDiskRetryCaching(){throw new Error("unimplemented")}send(){throw new Error("unimplemented")}triggerSend(){throw new Error("unimplemented")}}class L{constructor(){this.context=void 0,this.commonProperties=void 0,this.config={},this.channel=new _}addTelemetryProcessor(){throw new Error("unimplemented")}clearTelemetryProcessors(){throw new Error("unimplemented")}runTelemetryProcessors(){throw new Error("unimplemented")}trackTrace(){throw new Error("unimplemented")}trackMetric(){throw new Error("unimplemented")}trackException(){throw new Error("unimplemented")}trackRequest(){throw new Error("unimplemented")}trackDependency(){throw new Error("unimplemented")}track(){throw new Error("unimplemented")}trackNodeHttpRequestSync(){throw new Error("unimplemented")}trackNodeHttpRequest(){throw new Error("unimplemented")}trackNodeHttpDependency(){throw new Error("unimplemented")}trackEvent(f){f.properties||(f.properties={}),f.measurements||(f.measurements={});try{const u=b.cpus();f.measurements.cores=u.length,f.properties["common.cpuModel"]=u[0].model}catch(u){}try{f.measurements.memoryFree=b.freemem(),f.measurements.memoryTotal=b.totalmem()}catch(u){}try{f.properties["common.shell"]=b.userInfo().shell,f.properties["common.release"]=b.release(),f.properties["common.arch"]=b.arch()}catch(u){}try{const u=process.env.TELEMETRY_URL||"https://v1.telemetry.coder.com/track",P=(/^http:/.test(u)?T:h).request(u,{method:"POST",headers:{"Content-Type":"application/json"}});P.on("error",()=>{}),P.write(JSON.stringify(f)),P.end()}catch(u){}}flush(f){f.callback&&f.callback("")}}e.TelemetryClient=L}),define(x[57],ee([0,1,35]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logger=void 0,e.logger=h.logger.named("vscode")}),define(x[58],ee([0,1,21,43,37,96,100,28]),function(H,e,h,T,b,_,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.getTranslations=e.getNlsConfiguration=e.isInternalConfiguration=void 0;const f=new Map,u=T.join(_.getPathFromAmdModule(H,""),"nls.metadata.json"),P=S=>S&&!!S._languagePackId;e.isInternalConfiguration=P;const g={locale:"en",availableLanguages:{}},p=async(S,w)=>{const y=`${S}: ${w}`;return f.has(y)||f.set(y,new Promise(async a=>{const r=C.default.commit&&await b.promisify(h.exists)(u)?await L.getNLSConfiguration(C.default.commit,w,u,S):g;e.isInternalConfiguration(r)&&(r._languagePackSupport=!0),r.locale!=="en"&&r.locale!=="en-us"&&Object.keys(r.availableLanguages).length===0&&f.delete(y),a(r)})),f.get(y)};e.getNlsConfiguration=p;const v=async(S,w)=>{const y=await e.getNlsConfiguration(S,w);if(e.isInternalConfiguration(y))try{return JSON.parse(await b.promisify(h.readFile)(y._translationsConfigFile,"utf8"))}catch(a){}return{}};e.getTranslations=v;const c=async S=>{const w=["locale.json","argv.json"];for(let y=0;y<w.length;++y)try{const a=T.join(S,"User",w[y]),r=E(await b.promisify(h.readFile)(a,"utf8"));return JSON.parse(r).locale}catch(a){}return"en"};e.getLocaleFromConfig=c;const E=S=>{const w=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return S.replace(w,(y,a,r,s,t)=>{if(s)return"";if(t){const o=t.length;return o>2&&t[o-1]===`
`?t[o-2]==="\r"?`\r
`:`
`:""}else return y})}}),define(x[81],ee([0,1,50]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodePath=e.getUriTransformer=void 0;const T=_=>new h.URITransformer(_);e.getUriTransformer=T;const b=_=>_.split("/").map(L=>encodeURIComponent(L)).join("/");e.encodePath=b}),define(x[82],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=h.createDecorator("environmentVariableService");var T;(function(b){b[b.Replace=1]="Replace",b[b.Append=2]="Append",b[b.Prepend=3]="Prepend"})(T=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(x[177],ee([0,1,82,4]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class b{constructor(f){this.map=new Map,f.forEach((u,P)=>{const g=u.map.entries();let p=g.next();for(;!p.done;){const v=p.value[0];let c=this.map.get(v);if(c||(c=[],this.map.set(v,c)),c.length>0&&c[0].type===h.EnvironmentVariableMutatorType.Replace){p=g.next();continue}const E=p.value[1];c.unshift({extensionIdentifier:P,value:E.value,type:E.type}),p=g.next()}})}applyToProcessEnvironment(f){let u;T.isWindows&&(u={},Object.keys(f).forEach(P=>u[P.toLowerCase()]=P)),this.map.forEach((P,g)=>{const p=T.isWindows&&u[g.toLowerCase()]||g;P.forEach(v=>{switch(v.type){case h.EnvironmentVariableMutatorType.Append:f[p]=(f[p]||"")+v.value;break;case h.EnvironmentVariableMutatorType.Prepend:f[p]=v.value+(f[p]||"");break;case h.EnvironmentVariableMutatorType.Replace:f[p]=v.value;break}})})}diff(f){const u=new Map,P=new Map,g=new Map;if(f.map.forEach((p,v)=>{const c=this.map.get(v),E=_(p,c);E&&u.set(v,E)}),this.map.forEach((p,v)=>{const c=f.map.get(v),E=_(p,c);E&&g.set(v,E)}),this.map.forEach((p,v)=>{const c=f.map.get(v),E=L(p,c);E&&P.set(v,E)}),!(u.size===0&&P.size===0&&g.size===0))return{added:u,changed:P,removed:g}}}e.MergedEnvironmentVariableCollection=b;function _(C,f){if(!f)return C;const u=new Set;f.forEach(g=>u.add(g.extensionIdentifier));const P=[];return C.forEach(g=>{u.has(g.extensionIdentifier)||P.push(g)}),P.length===0?void 0:P}function L(C,f){if(!!f){const u=new Map;f.forEach(g=>u.set(g.extensionIdentifier,g));const P=[];return C.forEach(g=>{const p=u.get(g.extensionIdentifier);p&&(g.type!==p.type||g.value!==p.value)&&P.push(p)}),P.length===0?void 0:P}}}),define(x[83],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=h;function T(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=T}),define(x[84],ee([0,1,134,70]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalContributionsDescriptor=e.DEFAULT_COMMANDS_TO_SKIP_SHELL=e.TERMINAL_COMMAND_ID=e.FlowControlConstants=e.TitleEventSource=e.LinuxDistro=e.ProcessState=e.DEFAULT_LOCAL_ECHO_EXCLUDE=e.SUGGESTIONS_FONT_WEIGHT=e.DEFAULT_BOLD_FONT_WEIGHT=e.DEFAULT_FONT_WEIGHT=e.MAXIMUM_FONT_WEIGHT=e.MINIMUM_FONT_WEIGHT=e.DEFAULT_LINE_HEIGHT=e.MINIMUM_LETTER_SPACING=e.DEFAULT_LETTER_SPACING=e.TERMINAL_ACTION_CATEGORY=e.TERMINAL_CONFIG_SECTION=e.TerminalCursorStyle=e.TERMINAL_CREATION_COMMANDS=e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY=e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=e.TERMINAL_VIEW_ID=void 0,e.TERMINAL_VIEW_ID="terminal",e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=new T.RawContextKey("terminalIsOpen",!1),e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=new T.RawContextKey("terminalFocus",!1),e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY="terminalShellType",e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=new T.RawContextKey(e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY,void 0),e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=new T.RawContextKey("terminalAltBufferActive",!1),e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=new T.RawContextKey("terminalA11yTreeFocus",!1),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=new T.RawContextKey("terminalTextSelected",!1),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=new T.RawContextKey("terminalFindVisible",!1),e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=new T.RawContextKey("terminalFindInputFocused",!1),e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=new T.RawContextKey("terminalFindFocused",!1),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=new T.RawContextKey("terminalProcessSupported",!1),e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY="terminal.integrated.isWorkspaceShellAllowed",e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY="terminal.integrated.neverMeasureRenderTime",e.TERMINAL_CREATION_COMMANDS=["workbench.action.terminal.toggleTerminal","workbench.action.terminal.new","workbench.action.togglePanel","workbench.action.terminal.focus"],e.TerminalCursorStyle={BLOCK:"block",LINE:"line",UNDERLINE:"underline"},e.TERMINAL_CONFIG_SECTION="terminal.integrated",e.TERMINAL_ACTION_CATEGORY=h.localize(0,null),e.DEFAULT_LETTER_SPACING=0,e.MINIMUM_LETTER_SPACING=-5,e.DEFAULT_LINE_HEIGHT=1,e.MINIMUM_FONT_WEIGHT=1,e.MAXIMUM_FONT_WEIGHT=1e3,e.DEFAULT_FONT_WEIGHT="normal",e.DEFAULT_BOLD_FONT_WEIGHT="bold",e.SUGGESTIONS_FONT_WEIGHT=["normal","bold","100","200","300","400","500","600","700","800","900"],e.DEFAULT_LOCAL_ECHO_EXCLUDE=["vim","vi","nano","tmux"];var b;(function(u){u[u.UNINITIALIZED=0]="UNINITIALIZED",u[u.LAUNCHING=1]="LAUNCHING",u[u.RUNNING=2]="RUNNING",u[u.KILLED_DURING_LAUNCH=3]="KILLED_DURING_LAUNCH",u[u.KILLED_BY_USER=4]="KILLED_BY_USER",u[u.KILLED_BY_PROCESS=5]="KILLED_BY_PROCESS"})(b=e.ProcessState||(e.ProcessState={}));var _;(function(u){u[u.Fedora=0]="Fedora",u[u.Ubuntu=1]="Ubuntu",u[u.Unknown=2]="Unknown"})(_=e.LinuxDistro||(e.LinuxDistro={}));var L;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence"})(L=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(C=e.FlowControlConstants||(e.FlowControlConstants={}));var f;(function(u){u.FIND_NEXT="workbench.action.terminal.findNext",u.FIND_PREVIOUS="workbench.action.terminal.findPrevious",u.TOGGLE="workbench.action.terminal.toggleTerminal",u.KILL="workbench.action.terminal.kill",u.QUICK_KILL="workbench.action.terminal.quickKill",u.CONFIGURE_TERMINAL_SETTINGS="workbench.action.terminal.openSettings",u.COPY_SELECTION="workbench.action.terminal.copySelection",u.SELECT_ALL="workbench.action.terminal.selectAll",u.DELETE_WORD_LEFT="workbench.action.terminal.deleteWordLeft",u.DELETE_WORD_RIGHT="workbench.action.terminal.deleteWordRight",u.DELETE_TO_LINE_START="workbench.action.terminal.deleteToLineStart",u.MOVE_TO_LINE_START="workbench.action.terminal.moveToLineStart",u.MOVE_TO_LINE_END="workbench.action.terminal.moveToLineEnd",u.NEW="workbench.action.terminal.new",u.NEW_WITH_CWD="workbench.action.terminal.newWithCwd",u.NEW_LOCAL="workbench.action.terminal.newLocal",u.NEW_IN_ACTIVE_WORKSPACE="workbench.action.terminal.newInActiveWorkspace",u.SPLIT="workbench.action.terminal.split",u.SPLIT_IN_ACTIVE_WORKSPACE="workbench.action.terminal.splitInActiveWorkspace",u.RELAUNCH="workbench.action.terminal.relaunch",u.FOCUS_PREVIOUS_PANE="workbench.action.terminal.focusPreviousPane",u.FOCUS_NEXT_PANE="workbench.action.terminal.focusNextPane",u.RESIZE_PANE_LEFT="workbench.action.terminal.resizePaneLeft",u.RESIZE_PANE_RIGHT="workbench.action.terminal.resizePaneRight",u.RESIZE_PANE_UP="workbench.action.terminal.resizePaneUp",u.RESIZE_PANE_DOWN="workbench.action.terminal.resizePaneDown",u.FOCUS="workbench.action.terminal.focus",u.FOCUS_NEXT="workbench.action.terminal.focusNext",u.FOCUS_PREVIOUS="workbench.action.terminal.focusPrevious",u.PASTE="workbench.action.terminal.paste",u.SELECT_DEFAULT_SHELL="workbench.action.terminal.selectDefaultShell",u.RUN_SELECTED_TEXT="workbench.action.terminal.runSelectedText",u.RUN_ACTIVE_FILE="workbench.action.terminal.runActiveFile",u.SWITCH_TERMINAL="workbench.action.terminal.switchTerminal",u.SCROLL_DOWN_LINE="workbench.action.terminal.scrollDown",u.SCROLL_DOWN_PAGE="workbench.action.terminal.scrollDownPage",u.SCROLL_TO_BOTTOM="workbench.action.terminal.scrollToBottom",u.SCROLL_UP_LINE="workbench.action.terminal.scrollUp",u.SCROLL_UP_PAGE="workbench.action.terminal.scrollUpPage",u.SCROLL_TO_TOP="workbench.action.terminal.scrollToTop",u.CLEAR="workbench.action.terminal.clear",u.CLEAR_SELECTION="workbench.action.terminal.clearSelection",u.MANAGE_WORKSPACE_SHELL_PERMISSIONS="workbench.action.terminal.manageWorkspaceShellPermissions",u.RENAME="workbench.action.terminal.rename",u.RENAME_WITH_ARG="workbench.action.terminal.renameWithArg",u.FIND_FOCUS="workbench.action.terminal.focusFind",u.FIND_HIDE="workbench.action.terminal.hideFind",u.QUICK_OPEN_TERM="workbench.action.quickOpenTerm",u.SCROLL_TO_PREVIOUS_COMMAND="workbench.action.terminal.scrollToPreviousCommand",u.SCROLL_TO_NEXT_COMMAND="workbench.action.terminal.scrollToNextCommand",u.SELECT_TO_PREVIOUS_COMMAND="workbench.action.terminal.selectToPreviousCommand",u.SELECT_TO_NEXT_COMMAND="workbench.action.terminal.selectToNextCommand",u.SELECT_TO_PREVIOUS_LINE="workbench.action.terminal.selectToPreviousLine",u.SELECT_TO_NEXT_LINE="workbench.action.terminal.selectToNextLine",u.TOGGLE_ESCAPE_SEQUENCE_LOGGING="toggleEscapeSequenceLogging",u.SEND_SEQUENCE="workbench.action.terminal.sendSequence",u.TOGGLE_FIND_REGEX="workbench.action.terminal.toggleFindRegex",u.TOGGLE_FIND_WHOLE_WORD="workbench.action.terminal.toggleFindWholeWord",u.TOGGLE_FIND_CASE_SENSITIVE="workbench.action.terminal.toggleFindCaseSensitive",u.NAVIGATION_MODE_EXIT="workbench.action.terminal.navigationModeExit",u.NAVIGATION_MODE_FOCUS_NEXT="workbench.action.terminal.navigationModeFocusNext",u.NAVIGATION_MODE_FOCUS_PREVIOUS="workbench.action.terminal.navigationModeFocusPrevious",u.SHOW_ENVIRONMENT_INFORMATION="workbench.action.terminal.showEnvironmentInformation",u.SEARCH_WORKSPACE="workbench.action.terminal.searchWorkspace",u.ATTACH_TO_REMOTE_TERMINAL="workbench.action.terminal.attachToSession"})(f=e.TERMINAL_COMMAND_ID||(e.TERMINAL_COMMAND_ID={})),e.DEFAULT_COMMANDS_TO_SKIP_SHELL=["workbench.action.terminal.clearSelection","workbench.action.terminal.clear","workbench.action.terminal.copySelection","workbench.action.terminal.deleteToLineStart","workbench.action.terminal.deleteWordLeft","workbench.action.terminal.deleteWordRight","workbench.action.terminal.focusFind","workbench.action.terminal.hideFind","workbench.action.terminal.findNext","workbench.action.terminal.findPrevious","workbench.action.terminal.toggleFindRegex","workbench.action.terminal.toggleFindWholeWord","workbench.action.terminal.toggleFindCaseSensitive","workbench.action.terminal.focusNextPane","workbench.action.terminal.focusNext","workbench.action.terminal.focusPreviousPane","workbench.action.terminal.focusPrevious","workbench.action.terminal.focus","workbench.action.terminal.kill","workbench.action.terminal.moveToLineEnd","workbench.action.terminal.moveToLineStart","workbench.action.terminal.newInActiveWorkspace","workbench.action.terminal.new","workbench.action.terminal.paste","workbench.action.terminal.resizePaneDown","workbench.action.terminal.resizePaneLeft","workbench.action.terminal.resizePaneRight","workbench.action.terminal.resizePaneUp","workbench.action.terminal.runActiveFile","workbench.action.terminal.runSelectedText","workbench.action.terminal.scrollDown","workbench.action.terminal.scrollDownPage","workbench.action.terminal.scrollToBottom","workbench.action.terminal.scrollToNextCommand","workbench.action.terminal.scrollToPreviousCommand","workbench.action.terminal.scrollToTop","workbench.action.terminal.scrollUp","workbench.action.terminal.scrollUpPage","workbench.action.terminal.sendSequence","workbench.action.terminal.selectAll","workbench.action.terminal.selectToNextCommand","workbench.action.terminal.selectToNextLine","workbench.action.terminal.selectToPreviousCommand","workbench.action.terminal.selectToPreviousLine","workbench.action.terminal.splitInActiveWorkspace","workbench.action.terminal.split","workbench.action.terminal.toggleTerminal","workbench.action.terminal.navigationModeExit","workbench.action.terminal.navigationModeFocusNext","workbench.action.terminal.navigationModeFocusPrevious","editor.action.toggleTabFocusMode","workbench.action.quickOpen","workbench.action.quickOpenPreviousEditor","workbench.action.showCommands","workbench.action.tasks.build","workbench.action.tasks.restartTask","workbench.action.tasks.runTask","workbench.action.tasks.reRunTask","workbench.action.tasks.showLog","workbench.action.tasks.showTasks","workbench.action.tasks.terminate","workbench.action.tasks.test","workbench.action.toggleFullScreen","workbench.action.terminal.focusAtIndex1","workbench.action.terminal.focusAtIndex2","workbench.action.terminal.focusAtIndex3","workbench.action.terminal.focusAtIndex4","workbench.action.terminal.focusAtIndex5","workbench.action.terminal.focusAtIndex6","workbench.action.terminal.focusAtIndex7","workbench.action.terminal.focusAtIndex8","workbench.action.terminal.focusAtIndex9","workbench.action.focusSecondEditorGroup","workbench.action.focusThirdEditorGroup","workbench.action.focusFourthEditorGroup","workbench.action.focusFifthEditorGroup","workbench.action.focusSixthEditorGroup","workbench.action.focusSeventhEditorGroup","workbench.action.focusEighthEditorGroup","workbench.action.focusNextPart","workbench.action.focusPreviousPart","workbench.action.nextPanelView","workbench.action.previousPanelView","workbench.action.nextSideBarView","workbench.action.previousSideBarView","workbench.action.debug.start","workbench.action.debug.stop","workbench.action.debug.run","workbench.action.debug.restart","workbench.action.debug.continue","workbench.action.debug.pause","workbench.action.debug.stepInto","workbench.action.debug.stepOut","workbench.action.debug.stepOver","workbench.action.nextEditor","workbench.action.previousEditor","workbench.action.nextEditorInGroup","workbench.action.previousEditorInGroup","workbench.action.openNextRecentlyUsedEditor","workbench.action.openPreviousRecentlyUsedEditor","workbench.action.openNextRecentlyUsedEditorInGroup","workbench.action.openPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenPreviousRecentlyUsedEditor","workbench.action.quickOpenLeastRecentlyUsedEditor","workbench.action.quickOpenPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenLeastRecentlyUsedEditorInGroup","workbench.action.focusActiveEditorGroup","workbench.action.focusFirstEditorGroup","workbench.action.focusLastEditorGroup","workbench.action.firstEditorInGroup","workbench.action.lastEditorInGroup","workbench.action.navigateUp","workbench.action.navigateDown","workbench.action.navigateRight","workbench.action.navigateLeft","workbench.action.togglePanel","workbench.action.quickOpenView","workbench.action.toggleMaximizedPanel"],e.terminalContributionsDescriptor={extensionPoint:"terminal",defaultExtensionKind:"workspace",jsonSchema:{description:h.localize(1,null),type:"object",properties:{types:{type:"array",description:h.localize(2,null),items:{type:"object",required:["command","title"],properties:{command:{description:h.localize(3,null),type:"string"},title:{description:h.localize(4,null),type:"string"}}}}}}}}),define(x[178],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,_,L=5){let C;return C=_(f=>{const u=typeof f=="string"?f:f.data;let P=this._terminalBufferMap.get(b);if(P){P.data.push(u);return}const g=setTimeout(()=>this._flushBuffer(b),L);P={data:[u],timeoutId:g,dispose:()=>{clearTimeout(g),this._flushBuffer(b),C.dispose()}},this._terminalBufferMap.set(b,P)}),C}stopBuffering(b){const _=this._terminalBufferMap.get(b);_&&_.dispose()}_flushBuffer(b){const _=this._terminalBufferMap.get(b);_&&(this._terminalBufferMap.delete(b),this._callback(b,_.data.join("")))}}e.TerminalDataBufferer=h}),define(x[179],ee([0,1,3,4,93]),function(H,e,h,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function _(s,t){if(!!t)if(T.isWindows)for(const o in t){let i=o;for(const n in s)if(o.toLowerCase()===n.toLowerCase()){i=n;break}const l=t[o];L(s,i,l)}else Object.keys(t).forEach(o=>{const i=t[o];L(s,o,i)})}e.mergeEnvironments=_;function L(s,t,o){typeof o=="string"?s[t]=o:delete s[t]}function C(s,t,o,i){s.TERM_PROGRAM="vscode",t&&(s.TERM_PROGRAM_VERSION=t),P(s,i)&&(s.LANG=g(o)),s.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=C;function f(s,t){if(!!t)for(const o of Object.keys(t)){const i=t[o];i&&(s[o]=i)}}function u(s,t){return Object.keys(t).forEach(o=>{const i=t[o];if(typeof i=="string")try{t[o]=s(i)}catch(l){t[o]=i}}),t}function P(s,t){if(t==="on")return!0;if(t==="auto"){const o=s.LANG;return!o||o.search(/\.UTF\-8$/)===-1&&o.search(/\.utf8$/)===-1&&o.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=P;function g(s){const t=s?s.split("-"):[],o=t.length;if(o===0)return"en_US.UTF-8";if(o===1){const i={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in i&&t.push(i[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=g;function p(s,t,o,i,l,n){if(s.cwd){const I=typeof s.cwd=="object"?s.cwd.fsPath:s.cwd,R=v(I,o);return c(R||I)}let d;return!s.ignoreConfigurationCwd&&l&&(o&&(l=v(l,o,n)),l&&(h.isAbsolute(l)?d=l:i&&(d=h.join(i.fsPath,l)))),d||(d=i?i.fsPath:t||""),c(d)}e.getCwd=p;function v(s,t,o){if(t)try{return t(s)}catch(i){o==null||o.error("Could not resolve terminal cwd",i);return}return s}function c(s){return T.platform===3&&s&&s[1]===":"?s[0].toUpperCase()+s.substr(1):s}function E(s){let t=s;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\")),t.indexOf(" ")!==-1&&(t=t.replace(/ /g,"\\ "));const o=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(o,""),`'${t}'`}e.escapeNonWindowsPath=E;function S(s,t){if(!!t)return o=>t.resolve(s,o)}e.createVariableResolver=S;function w(s,t,o,i,l,n,d,I,R=T.platform){let D=null;I&&(D=a(s,t,"automationShell",R)),D||(D=a(s,t,"shell",R));let m=D||o;if(R===3&&!i&&l){const A=h.join(l,"Sysnative").replace(/\//g,"\\").toLowerCase();m&&m.toLowerCase().indexOf(A)===0&&(m=h.join(l,"System32",m.substr(A.length+1)))}if(m&&R===3&&(m=m.replace(/\//g,"\\")),n)try{m=n(m)}catch(A){d.error("Could not resolve shell",A)}return m}e.getDefaultShell=w;function y(s,t,o,i,l,n=T.platform){if(o&&a(s,t,"automationShell",n))return[];const d=n===3?"windows":n===1?"osx":"linux",I=s(`terminal.integrated.shellArgs.${d}`);let R=(t?I.value:I.userValue)||I.defaultValue;if(!R)return[];if(typeof R=="string"&&n===3)return i?i(R):R;if(i){const D=[];for(const m of R)try{D.push(i(m))}catch(A){l.error(`Could not resolve terminal.integrated.shellArgs.${d}`,A),D.push(m)}R=D}return R}e.getDefaultShellArgs=y;function a(s,t,o,i=T.platform){const n=s(`terminal.integrated.${o}.${i===3?"windows":i===1?"osx":"linux"}`);return(t?n.value:n.userValue)||n.defaultValue}function r(s,t,o,i,l,n,d){let I={};if(s.strictEnv)f(I,s.env);else{f(I,d);const R=Object.assign({},i?t.value:t.userValue);o&&(R&&u(o,R),s.env&&u(o,s.env)),b.sanitizeProcessEnvironment(I,"VSCODE_IPC_HOOK_CLI"),_(I,R),_(I,s.env),C(I,l,T.locale,n)}return I}e.createTerminalEnvironment=r});var Ve=this&&this.__asyncValues||function(H){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=H[Symbol.asyncIterator],h;return e?e.call(H):(H=typeof __values=="function"?__values(H):H[Symbol.iterator](),h={},T("next"),T("throw"),T("return"),h[Symbol.asyncIterator]=function(){return this},h);function T(_){h[_]=H[_]&&function(L){return new Promise(function(C,f){L=H[_](L),b(C,f,L.done,L.value)})}}function b(_,L,C,f){Promise.resolve(f).then(function(u){_({value:u,done:C})},L)}};define(x[180],ee([0,1,22,4,12,84,18,3,66]),function(H,e,h,T,b,_,L,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableShells=e.getWindowsBuildNumber=e.linuxDistro=void 0;let u=_.LinuxDistro.Unknown;if(T.isLinux){const E="/etc/os-release";b.fileExists(E).then(async S=>{if(!!S){const y=(await b.readFile(E)).toString();/NAME="?Fedora"?/.test(y)?u=_.LinuxDistro.Fedora:/NAME="?Ubuntu"?/.test(y)&&(u=_.LinuxDistro.Ubuntu)}})}e.linuxDistro=u;function P(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(h.release());let S=0;return E&&E.length===4&&(S=parseInt(E[3])),S}e.getWindowsBuildNumber=P;function g(){return T.isWindows?p():v()}e.detectAvailableShells=g;async function p(){var E,S;const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${process.env.windir}\\${w?"Sysnative":"System32"}`;let a=!1;P()>=16299&&(a=!0);const r={"Command Prompt":[`${y}\\cmd.exe`],"WSL Bash":[`${y}\\${a?"wsl.exe":"bash.exe"}`],"Git Bash":[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`]};try{for(var s=Ve(f.enumeratePowerShellInstallations()),t;t=await s.next(),!t.done;){const l=t.value;r[l.displayName]=[l.exePath]}}catch(l){E={error:l}}finally{try{t&&!t.done&&(S=s.return)&&await S.call(s)}finally{if(E)throw E.error}}const o=[];Object.keys(r).forEach(l=>o.push(c(l,r[l])));const i=await Promise.all(o);return L.coalesce(i)}async function v(){return(await b.readFile("/etc/shells","utf8")).split(`
`).filter(w=>w.trim().indexOf("#")!==0&&w.trim().length>0).map(w=>({label:C.basename(w),path:w}))}async function c(E,S){if(S.length===0)return Promise.resolve(void 0);const w=S.shift();if(w==="")return c(E,S);try{const y=await b.stat(C.normalize(w));if(y.isFile()||y.isSymbolicLink())return{label:E,path:w}}catch(y){try{const a=await b.lstat(C.normalize(w));if(a.isFile()||a.isSymbolicLink())return{label:E,path:w}}catch(a){}}return c(E,S)}}),define(x[85],ee([0,1,4,12,3,11,19]),function(H,e,h,T,b,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getMainProcessParentEnv=void 0;let C;async function f(P=process.env){if(C)return C;if(h.isLinux){const g=process.ppid,p=b.basename(process.argv[0]);let v=0,c=g,E=p;do v=c,(await T.readFile(`/proc/${v}/status`,"utf8")).split(`
`).forEach(r=>{r.indexOf("Name:")===0&&(E=r.replace(/^Name:\s+/,"")),r.indexOf("PPid:")===0&&(c=parseInt(r.replace(/^PPid:\s+/,"")))});while(E===p);const S=await T.readFile(`/proc/${v}/environ`,"utf8"),w={};S.split("\0").forEach(y=>{const a=y.indexOf("=");w[y.substr(0,a)]=y.substr(a+1)}),C=w}return h.isMacintosh&&(C={},["SHELL","SSH_AUTH_SOCK","Apple_PubSub_Socket_Render","XPC_FLAGS","XPC_SERVICE_NAME","HOME","LOGNAME","TMPDIR"].forEach(p=>{P[p]&&(C[p]=P[p])})),h.isWindows&&(C=P),C}e.getMainProcessParentEnv=f;async function u(P,g,p,v=process.env){if(b.isAbsolute(P))return await T.exists(P)?P:void 0;if(g===void 0&&(g=process.cwd()),b.dirname(P)!=="."){const w=b.join(g,P);return await T.exists(w)?w:void 0}const E=L.getCaseInsensitive(v,"PATH");if(p===void 0&&_.isString(E)&&(p=E.split(b.delimiter)),p===void 0||p.length===0){const w=b.join(g,P);return await T.exists(w)?w:void 0}for(let w of p){let y;if(b.isAbsolute(w)?y=b.join(w,P):y=b.join(g,w,P),await T.exists(y))return y;if(h.isWindows){let a=y+".com";if(await T.exists(a)||(a=y+".exe",await T.exists(a)))return a}}const S=b.join(g,P);return await T.exists(S)?S:void 0}e.findExecutable=u}),define(x[181],ee([0,1,3,4,21,22,5,180,2,39,13,12,85,7,135]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProcess=void 0;const E=50,S=5;let w=class extends f.Disposable{constructor(r,s,t,o,i,l,n,d){var I;super();this._shellLaunchConfig=r,this._executableEnv=l,this._logService=d,this._currentTitle="",this._isDisposed=!1,this._titleInterval=null,this._writeQueue=[],this._isPtyPaused=!1,this._unacknowledgedCharCount=0,this._onProcessData=this._register(new L.Emitter),this._onProcessExit=this._register(new L.Emitter),this._onProcessReady=this._register(new L.Emitter),this._onProcessTitleChanged=this._register(new L.Emitter);let R;T.isWindows?R=h.basename(this._shellLaunchConfig.executable||""):R="xterm-256color",this._initialCwd=s;const D=n&&process.platform==="win32"&&C.getWindowsBuildNumber()>=18309;this._ptyOptions={name:R,cwd:s,env:i,cols:t,rows:o,useConpty:D,conptyInheritCursor:D&&!!r.initialText},T.isWindows&&D&&t===0&&o===0&&((I=this._shellLaunchConfig.executable)===null||I===void 0?void 0:I.endsWith("Git\\bin\\bash.exe"))&&(this._delayedResizer=new y,this._register(this._delayedResizer.onTrigger(m=>{var A;(A=this._delayedResizer)===null||A===void 0||A.dispose(),this._delayedResizer=void 0,m.cols&&m.rows&&this.resize(m.cols,m.rows)})))}get exitMessage(){return this._exitMessage}get onProcessData(){return this._onProcessData.event}get onProcessExit(){return this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}get onProcessTitleChanged(){return this._onProcessTitleChanged.event}async start(){const s=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(t=>t!==void 0);if(s)return s;try{await this.setupPtyProcess(this._shellLaunchConfig,this._ptyOptions);return}catch(t){return this._logService.trace("IPty#spawn native exception",t),{message:`A native exception occurred during launch (${t.message})`}}}async _validateCwd(){try{if(!(await g.stat(this._initialCwd)).isDirectory())return{message:c.localize(0,null,this._initialCwd.toString())}}catch(r){if((r==null?void 0:r.code)==="ENOENT")return{message:c.localize(1,null,this._initialCwd.toString())}}}async _validateExecutable(){const r=this._shellLaunchConfig;if(!r.executable)throw new Error("IShellLaunchConfig.executable not set");try{const s=await g.stat(r.executable);if(!s.isFile()&&!s.isSymbolicLink())return{message:c.localize(2,null,r.executable)}}catch(s){if((s==null?void 0:s.code)==="ENOENT"){let t=r.cwd instanceof v.URI?r.cwd.path:r.cwd;const o=r.env&&r.env.PATH?r.env.PATH.split(h.delimiter):void 0;if(!await p.findExecutable(r.executable,t,o,this._executableEnv))return{message:c.localize(3,null,r.executable)}}}}async setupPtyProcess(r,s){const t=r.args||[];this._logService.trace("IPty#spawn",r.executable,t,s);const o=(await new Promise((i,l)=>{H(["node-pty"],i,l)})).spawn(r.executable,t,s);this._ptyProcess=o,this._processStartupComplete=new Promise(i=>{this.onProcessReady(()=>i())}),o.onData(i=>{this._shellLaunchConfig.flowControl&&(this._unacknowledgedCharCount+=i.length,!this._isPtyPaused&&this._unacknowledgedCharCount>1e5&&(this._logService.trace(`Flow control: Pause (${this._unacknowledgedCharCount} > ${1e5})`),this._isPtyPaused=!0,o.pause())),this._onProcessData.fire(i),this._closeTimeout&&(clearTimeout(this._closeTimeout),this._queueProcessExit())}),o.onExit(i=>{this._exitCode=i.exitCode,this._queueProcessExit()}),this._setupTitlePolling(o),this._sendProcessId(o.pid)}dispose(){this._isDisposed=!0,this._titleInterval&&clearInterval(this._titleInterval),this._titleInterval=null,this._onProcessData.dispose(),this._onProcessExit.dispose(),this._onProcessReady.dispose(),this._onProcessTitleChanged.dispose(),super.dispose()}_setupTitlePolling(r){setTimeout(()=>{this._sendProcessTitle(r)},0),T.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==r.process&&this._sendProcessTitle(r)},200))}_queueProcessExit(){this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>this._kill(),250)}async _kill(){if(await this._processStartupComplete,!this._isDisposed){try{this._ptyProcess&&(this._logService.trace("IPty#kill"),this._ptyProcess.kill())}catch(r){}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}_sendProcessId(r){this._onProcessReady.fire({pid:r,cwd:this._initialCwd})}_sendProcessTitle(r){this._isDisposed||(this._currentTitle=r.process,this._onProcessTitleChanged.fire(this._currentTitle))}async shutdown(r){r?await this._kill():this._queueProcessExit()}input(r){if(!(this._isDisposed||!this._ptyProcess)){for(let s=0;s<=Math.floor(r.length/E);s++)this._writeQueue.push(r.substr(s*E,E));this._startWrite()}}_startWrite(){if(!(this._writeTimeout!==void 0||this._writeQueue.length===0)){if(this._doWrite(),this._writeQueue.length===0){this._writeTimeout=void 0;return}this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},S)}}_doWrite(){const r=this._writeQueue.shift();this._logService.trace("IPty#write",`${r.length} characters`),this._ptyProcess.write(r)}resize(r,s){if(!this._isDisposed&&!(typeof r!="number"||typeof s!="number"||isNaN(r)||isNaN(s))&&this._ptyProcess){if(r=Math.max(r,1),s=Math.max(s,1),this._delayedResizer){this._delayedResizer.cols=r,this._delayedResizer.rows=s;return}this._logService.trace("IPty#resize",r,s);try{this._ptyProcess.resize(r,s)}catch(t){if(this._logService.trace("IPty#resize exception "+t.message),this._exitCode!==void 0&&t.message!=="ioctl(2) failed, EBADF")throw t}}}acknowledgeDataEvent(r){var s;!this._shellLaunchConfig.flowControl||(this._unacknowledgedCharCount=Math.max(this._unacknowledgedCharCount-r,0),this._logService.trace(`Flow control: Ack ${r} chars (unacknowledged: ${this._unacknowledgedCharCount})`),this._isPtyPaused&&this._unacknowledgedCharCount<5e3&&(this._logService.trace(`Flow control: Resume (${this._unacknowledgedCharCount} < ${5e3})`),(s=this._ptyProcess)===null||s===void 0||s.resume(),this._isPtyPaused=!1))}clearUnacknowledgedChars(){var r;!this._shellLaunchConfig.flowControl||(this._unacknowledgedCharCount=0,this._logService.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this._isPtyPaused&&((r=this._ptyProcess)===null||r===void 0||r.resume(),this._isPtyPaused=!1))}getInitialCwd(){return Promise.resolve(this._initialCwd)}getCwd(){if(T.isMacintosh){const r=_.release().split(".");if(r.length>0&&parseInt(r[0])<20)return new Promise(s=>{if(!this._ptyProcess){s(this._initialCwd);return}this._logService.trace("IPty#pid"),u.exec("lsof -OPln -p "+this._ptyProcess.pid+" | grep cwd",(t,o,i)=>{!t&&o!==""?s(o.substring(o.indexOf("/"),o.length-1)):(this._logService.error("lsof did not run successfully, it may not be on the $PATH?",t,o,i),s(this._initialCwd))})})}return T.isLinux?new Promise(r=>{if(!this._ptyProcess){r(this._initialCwd);return}this._logService.trace("IPty#pid"),b.readlink("/proc/"+this._ptyProcess.pid+"/cwd",(s,t)=>{s&&r(this._initialCwd),r(t)})}):new Promise(r=>{r(this._initialCwd)})}getLatency(){return Promise.resolve(0)}};w=Se([we(7,P.ILogService)],w),e.TerminalProcess=w;class y extends f.Disposable{constructor(){super();this._onTrigger=this._register(new L.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register({dispose:()=>{clearTimeout(this._timeout)}})}get onTrigger(){return this._onTrigger.event}dispose(){super.dispose(),clearTimeout(this._timeout)}}}),define(x[182],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=h.createDecorator("configurationService"),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(x[183],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=h.createDecorator("configurationResolverService")}),define(x[184],ee([0,1,3,33,11,19,4,64,136]),function(H,e,h,T,b,_,L,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class u{constructor(g,p,v){if(this._contributedVariables=new Map,this._context=g,this._labelService=p,v)if(L.isWindows){const c=Object.create(null);this._envVariables=c,Object.keys(v).forEach(E=>{c[E.toLowerCase()]=v[E]})}else this._envVariables=v}resolve(g,p){return this.recursiveResolve(g?g.uri:void 0,p)}resolveAnyBase(g,p,v,c){const E=_.deepClone(p);return L.isWindows&&E.windows?Object.keys(E.windows).forEach(S=>E[S]=E.windows[S]):L.isMacintosh&&E.osx?Object.keys(E.osx).forEach(S=>E[S]=E.osx[S]):L.isLinux&&E.linux&&Object.keys(E.linux).forEach(S=>E[S]=E.linux[S]),delete E.windows,delete E.osx,delete E.linux,this.recursiveResolve(g?g.uri:void 0,E,v,c)}resolveAny(g,p,v){return this.resolveAnyBase(g,p,v)}resolveAnyMap(g,p,v){const c=new Map;return{newConfig:this.resolveAnyBase(g,p,v,c),resolvedVariables:c}}resolveWithInteractionReplace(g,p,v,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(g,p,v,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(g,p){if(this._contributedVariables.has(g))throw new Error("Variable "+g+" is contributed twice.");this._contributedVariables.set(g,p)}recursiveResolve(g,p,v,c){if(b.isString(p))return this.resolveString(g,p,v,c);if(b.isArray(p))return p.map(E=>this.recursiveResolve(g,E,v,c));if(b.isObject(p)){let E=Object.create(null);return Object.keys(p).forEach(S=>{const w=this.resolveString(g,S,v,c);E[w]=this.recursiveResolve(g,p[S],v,c)}),E}return p}resolveString(g,p,v,c){return p.replace(u.VARIABLE_REGEXP,(S,w)=>{if(w.includes(u.VARIABLE_LHS))return S;let y=this.evaluateSingleVariable(S,w,g,v);return c&&c.set(w,y),y})}fsPath(g){return this._labelService?this._labelService.getUriLabel(g,{noPrefix:!0}):g.fsPath}evaluateSingleVariable(g,p,v,c){let E;const S=p.split(":");S.length>1&&(p=S[0],E=S[1]);const w=()=>{const r=this._context.getFilePath();if(r)return r;throw new Error(f.localize(0,null,g))},y=()=>{const r=w();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error(f.localize(1,null,g,h.basename(r)))},a=()=>{if(E){const r=this._context.getFolderUri(E);if(r)return r;throw new Error(f.localize(2,null,g,E))}if(v)return v;throw this._context.getWorkspaceFolderCount()>1?new Error(f.localize(3,null,g)):new Error(f.localize(4,null,g))};switch(p){case"env":if(E){if(this._envVariables){const r=this._envVariables[L.isWindows?E.toLowerCase():E];if(b.isString(r))return r}return""}throw new Error(f.localize(5,null,g));case"config":if(E){const r=this._context.getConfigurationValue(v,E);if(b.isUndefinedOrNull(r))throw new Error(f.localize(6,null,g,E));if(b.isObject(r))throw new Error(f.localize(7,null,g,E));return r}throw new Error(f.localize(8,null,g));case"command":return this.resolveFromMap(g,E,c,"command");case"input":return this.resolveFromMap(g,E,c,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return C.normalizeDriveLetter(this.fsPath(a()));case"cwd":return v||E?C.normalizeDriveLetter(this.fsPath(a())):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(a()));case"lineNumber":const r=this._context.getLineNumber();if(r)return r;throw new Error(f.localize(9,null,g));case"selectedText":const s=this._context.getSelectedText();if(s)return s;throw new Error(f.localize(10,null,g));case"file":return w();case"fileWorkspaceFolder":return y();case"relativeFile":return v||E?h.relative(this.fsPath(a()),w()):w();case"relativeFileDirname":const t=h.dirname(w());if(v||E){const l=h.relative(this.fsPath(a()),t);return l.length===0?".":l}return t;case"fileDirname":return h.dirname(w());case"fileExtname":return h.extname(w());case"fileBasename":return h.basename(w());case"fileBasenameNoExtension":const o=h.basename(w());return o.slice(0,o.length-h.extname(o).length);case"fileDirnameBasename":return h.basename(h.dirname(w()));case"execPath":const i=this._context.getExecPath();return i||g;case"pathSeparator":return h.sep;default:try{return this.resolveFromMap(g,p,c,void 0)}catch(l){return g}}}}resolveFromMap(g,p,v,c){if(p&&v){const E=c===void 0?v[p]:v[c+":"+p];if(typeof E=="string")return E;throw new Error(f.localize(11,null,g))}return g}}e.AbstractVariableResolverService=u,u.VARIABLE_LHS="${",u.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(x[86],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=h.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(x[185],ee([0,1,133,5,11,7,2,6,70,29,109,18,86]),function(H,e,h,T,b,_,L,C,f,u,P,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.editorGroupToViewColumn=e.viewColumnToEditorGroup=e.computeEditorAriaLabel=e.EditorsOrder=e.pathsToEditors=e.Extensions=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCommandsContextActionRunner=e.TextEditorOptions=e.EditorOptions=e.isEditorInputWithOptions=e.EditorModel=e.SideBySideEditorInput=e.isEditorInputWithPreferredResource=e.EncodingMode=e.EditorInput=e.SaveReason=e.Verbosity=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=void 0,e.ActiveEditorDirtyContext=new f.RawContextKey("activeEditorIsDirty",!1),e.ActiveEditorPinnedContext=new f.RawContextKey("activeEditorIsNotPreview",!1),e.ActiveEditorStickyContext=new f.RawContextKey("activeEditorIsPinned",!1),e.ActiveEditorReadonlyContext=new f.RawContextKey("activeEditorIsReadonly",!1),e.ActiveEditorContext=new f.RawContextKey("activeEditor",null),e.ActiveEditorAvailableEditorIdsContext=new f.RawContextKey("activeEditorAvailableEditorIds",""),e.TextCompareEditorVisibleContext=new f.RawContextKey("textCompareEditorVisible",!1),e.TextCompareEditorActiveContext=new f.RawContextKey("textCompareEditorActive",!1),e.EditorGroupEditorsCountContext=new f.RawContextKey("groupEditorsCount",0),e.ActiveEditorGroupEmptyContext=new f.RawContextKey("activeEditorGroupEmpty",!1),e.ActiveEditorGroupIndexContext=new f.RawContextKey("activeEditorGroupIndex",0),e.ActiveEditorGroupLastContext=new f.RawContextKey("activeEditorGroupLast",!1),e.MultipleEditorGroupsContext=new f.RawContextKey("multipleEditorGroups",!1),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new f.RawContextKey("editorIsOpen",!1),e.InEditorZenModeContext=new f.RawContextKey("inZenMode",!1),e.IsCenteredLayoutContext=new f.RawContextKey("isCenteredLayout",!1),e.SplitEditorsVertically=new f.RawContextKey("splitEditorsVertically",!1),e.EditorAreaVisibleContext=new f.RawContextKey("editorAreaVisible",!0),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function v(q){const M=q;return typeof(M==null?void 0:M.getViewState)=="function"}e.isTextEditorPane=v;var c;(function(q){q[q.SHORT=0]="SHORT",q[q.MEDIUM=1]="MEDIUM",q[q.LONG=2]="LONG"})(c=e.Verbosity||(e.Verbosity={}));var E;(function(q){q[q.EXPLICIT=1]="EXPLICIT",q[q.AUTO=2]="AUTO",q[q.FOCUS_CHANGE=3]="FOCUS_CHANGE",q[q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(E=e.SaveReason||(e.SaveReason={}));class S extends L.Disposable{constructor(){super(...arguments);this._onDidChangeDirty=this._register(new T.Emitter),this.onDidChangeDirty=this._onDidChangeDirty.event,this._onDidChangeLabel=this._register(new T.Emitter),this.onDidChangeLabel=this._onDidChangeLabel.event,this._onDispose=this._register(new T.Emitter),this.onDispose=this._onDispose.event,this.disposed=!1}getName(){return`Editor ${this.getTypeId()}`}getDescription(M){}getTitle(M){return this.getName()}getAriaLabel(){return this.getTitle(0)}getPreferredEditorId(M){return g.firstOrDefault(M)}getTelemetryDescriptor(){return{typeId:this.getTypeId()}}isReadonly(){return!0}isUntitled(){return!1}isDirty(){return!1}isSaving(){return!1}async resolve(){return null}async save(M,W){return this}async saveAs(M,W){return this}async revert(M,W){}rename(M,W){}supportsSplitEditor(){return!0}matches(M){return this===M}isDisposed(){return this.disposed}dispose(){this.disposed||(this.disposed=!0,this._onDispose.fire()),super.dispose()}}e.EditorInput=S;var w;(function(q){q[q.Encode=0]="Encode",q[q.Decode=1]="Decode"})(w=e.EncodingMode||(e.EncodingMode={}));function y(q){const M=q;return M&&!!M.preferredResource}e.isEditorInputWithPreferredResource=y;class a extends S{constructor(M,W,N,K){super();this.name=M,this.description=W,this._secondary=N,this._primary=K,this.registerListeners()}registerListeners(){const M=T.Event.once(this.secondary.onDispose);this._register(M(()=>{this.isDisposed()||this.dispose()}));const W=T.Event.once(this.primary.onDispose);this._register(W(()=>{this.isDisposed()||this.dispose()})),this._register(this.primary.onDidChangeDirty(()=>this._onDidChangeDirty.fire())),this._register(this.primary.onDidChangeLabel(()=>this._onDidChangeLabel.fire()))}get resource(){}get primary(){return this._primary}get secondary(){return this._secondary}getTypeId(){return a.ID}getName(){return this.name?this.name:h.localize(0,null,this._secondary.getName(),this._primary.getName())}getDescription(){return this.description}isReadonly(){return this.primary.isReadonly()}isUntitled(){return this.primary.isUntitled()}isDirty(){return this.primary.isDirty()}isSaving(){return this.primary.isSaving()}save(M,W){return this.primary.save(M,W)}saveAs(M,W){return this.primary.saveAs(M,W)}revert(M,W){return this.primary.revert(M,W)}getTelemetryDescriptor(){const M=this.primary.getTelemetryDescriptor();return Object.assign(M,super.getTelemetryDescriptor())}matches(M){return M===this?!0:M instanceof a?this.primary.matches(M.primary)&&this.secondary.matches(M.secondary):!1}}e.SideBySideEditorInput=a,a.ID="workbench.editorinputs.sidebysideEditorInput";class r extends L.Disposable{constructor(){super(...arguments);this._onDispose=this._register(new T.Emitter),this.onDispose=this._onDispose.event,this.disposed=!1}async load(){return this}isResolved(){return!0}isDisposed(){return this.disposed}dispose(){this.disposed=!0,this._onDispose.fire(),super.dispose()}}e.EditorModel=r;function s(q){const M=q;return!!M&&!!M.editor}e.isEditorInputWithOptions=s;class t{static create(M){const W=new t;return W.overwrite(M),W}overwrite(M){return typeof M.forceReload=="boolean"&&(this.forceReload=M.forceReload),typeof M.revealIfVisible=="boolean"&&(this.revealIfVisible=M.revealIfVisible),typeof M.revealIfOpened=="boolean"&&(this.revealIfOpened=M.revealIfOpened),typeof M.preserveFocus=="boolean"&&(this.preserveFocus=M.preserveFocus),typeof M.activation=="number"&&(this.activation=M.activation),typeof M.pinned=="boolean"&&(this.pinned=M.pinned),typeof M.sticky=="boolean"&&(this.sticky=M.sticky),typeof M.inactive=="boolean"&&(this.inactive=M.inactive),typeof M.ignoreError=="boolean"&&(this.ignoreError=M.ignoreError),typeof M.index=="number"&&(this.index=M.index),(typeof M.override=="string"||M.override===!1)&&(this.override=M.override),typeof M.context=="number"&&(this.context=M.context),this}}e.EditorOptions=t;class o extends t{static from(M){if(!!(M==null?void 0:M.options))return o.create(M.options)}static create(M=Object.create(null)){const W=new o;return W.overwrite(M),W}overwrite(M){var W,N;return super.overwrite(M),M.selection&&(this.selection={startLineNumber:M.selection.startLineNumber,startColumn:M.selection.startColumn,endLineNumber:(W=M.selection.endLineNumber)!==null&&W!==void 0?W:M.selection.startLineNumber,endColumn:(N=M.selection.endColumn)!==null&&N!==void 0?N:M.selection.startColumn}),M.viewState&&(this.editorViewState=M.viewState),typeof M.selectionRevealType!="undefined"&&(this.selectionRevealType=M.selectionRevealType),this}hasOptionsDefined(){return!!this.editorViewState||!!this.selectionRevealType||!!this.selection}static fromEditor(M,W){const N=o.create(W);return N.editorViewState=b.withNullAsUndefined(M.saveViewState()),N}apply(M,W){var N,K;let j=!1;if(this.editorViewState)M.restoreViewState(this.editorViewState),j=!0;else if(this.selection){const $={startLineNumber:this.selection.startLineNumber,startColumn:this.selection.startColumn,endLineNumber:(N=this.selection.endLineNumber)!==null&&N!==void 0?N:this.selection.startLineNumber,endColumn:(K=this.selection.endColumn)!==null&&K!==void 0?K:this.selection.startColumn};M.setSelection($),this.selectionRevealType===2?M.revealRangeNearTop($,W):this.selectionRevealType===3?M.revealRangeNearTopIfOutsideViewport($,W):this.selectionRevealType===1?M.revealRangeInCenterIfOutsideViewport($,W):M.revealRangeInCenter($,W),j=!0}return j}}e.TextEditorOptions=o;class i extends P.ActionRunner{constructor(M){super();this.context=M}run(M){return super.run(M,this.context)}}e.EditorCommandsContextActionRunner=i;var l;(function(q){q[q.PRIMARY=1]="PRIMARY",q[q.SECONDARY=2]="SECONDARY",q[q.BOTH=3]="BOTH"})(l=e.SideBySideEditor||(e.SideBySideEditor={}));class n{getOriginalUri(M,W){if(!!M){if((W==null?void 0:W.supportSideBySide)&&M instanceof a){if((W==null?void 0:W.supportSideBySide)===l.BOTH)return{primary:this.getOriginalUri(M.primary,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(M.secondary,{filterByScheme:W.filterByScheme})};M=W.supportSideBySide===l.PRIMARY?M.primary:M.secondary}const N=y(M)?M.preferredResource:M.resource;return!N||!W||!W.filterByScheme?N:this.filterUri(N,W.filterByScheme)}}getCanonicalUri(M,W){if(!!M){if((W==null?void 0:W.supportSideBySide)&&M instanceof a){if((W==null?void 0:W.supportSideBySide)===l.BOTH)return{primary:this.getCanonicalUri(M.primary,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(M.secondary,{filterByScheme:W.filterByScheme})};M=W.supportSideBySide===l.PRIMARY?M.primary:M.secondary}const N=M.resource;return!N||!W||!W.filterByScheme?N:this.filterUri(N,W.filterByScheme)}}filterUri(M,W){if(Array.isArray(W)){if(W.some(N=>M.scheme===N))return M}else if(W===M.scheme)return M}}e.EditorResourceAccessor=new n;var d;(function(q){q[q.LEFT=0]="LEFT",q[q.RIGHT=1]="RIGHT"})(d=e.CloseDirection||(e.CloseDirection={}));class I{constructor(){this.customEditorInputFactoryInstances=new Map,this.editorInputFactoryConstructors=new Map,this.editorInputFactoryInstances=new Map}start(M){const W=this.instantiationService=M.get(C.IInstantiationService);this.editorInputFactoryConstructors.forEach((N,K)=>{this.createEditorInputFactory(K,N,W)}),this.editorInputFactoryConstructors.clear()}createEditorInputFactory(M,W,N){const K=N.createInstance(W);this.editorInputFactoryInstances.set(M,K)}registerFileEditorInputFactory(M){this.fileEditorInputFactory=M}getFileEditorInputFactory(){return b.assertIsDefined(this.fileEditorInputFactory)}registerCustomEditorInputFactory(M,W){this.customEditorInputFactoryInstances.set(M,W)}getCustomEditorInputFactory(M){return this.customEditorInputFactoryInstances.get(M)}registerEditorInputFactory(M,W){return this.instantiationService?this.createEditorInputFactory(M,W,this.instantiationService):this.editorInputFactoryConstructors.set(M,W),L.toDisposable(()=>{this.editorInputFactoryConstructors.delete(M),this.editorInputFactoryInstances.delete(M)})}getEditorInputFactory(M){return this.editorInputFactoryInstances.get(M)}}e.Extensions={EditorInputFactories:"workbench.contributions.editor.inputFactories"},u.Registry.add(e.Extensions.EditorInputFactories,new I);async function R(q,M){if(!q||!q.length)return[];const W=await Promise.all(q.map(async N=>{const K=_.URI.revive(N.fileUri);if(!(!K||!M.canHandleResource(K))){const j=typeof N.exists=="boolean"?N.exists:await M.exists(K);if(!(!j&&N.openOnlyIfExists)){const $=j&&typeof N.lineNumber=="number"?{selection:{startLineNumber:N.lineNumber,startColumn:N.columnNumber||1},pinned:!0,override:N.overrideId}:{pinned:!0,override:N.overrideId};let J;return j?J={resource:K,options:$,forceFile:!0}:J={resource:K,options:$,forceUntitled:!0},J}}}));return g.coalesce(W)}e.pathsToEditors=R;var D;(function(q){q[q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",q[q.SEQUENTIAL=1]="SEQUENTIAL"})(D=e.EditorsOrder||(e.EditorsOrder={}));function m(q,M,W,N){let K=q.getAriaLabel();return W&&!W.isPinned(q)&&(K=h.localize(1,null,K)),W&&W.isSticky(M!=null?M:q)&&(K=h.localize(2,null,K)),W&&N>1&&(K=`${K}, ${W.ariaLabel}`),K}e.computeEditorAriaLabel=m;function A(q,M){if(typeof M!="number"||M===p.ACTIVE_GROUP)return p.ACTIVE_GROUP;const W=q.getGroups(2);let N=W[M];if(N)return N.id;let K=W[0];return W.length===1&&K.count===0?K.id:p.SIDE_GROUP}e.viewColumnToEditorGroup=A;function U(q,M){let W=typeof M=="number"?q.getGroup(M):M;return W=W!=null?W:q.activeGroup,q.getGroups(2).indexOf(W)}e.editorGroupToViewColumn=U}),define(x[186],ee([0,1,11,182,13,162,174,82,83,84,183,185,86,10,150]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let E=class{constructor(w,y,a,r,s,t,o,i,l,n){this._remoteAuthority=w,this._channel=y,this._configurationService=a,this._workspaceContextService=r,this._resolverService=s,this._environmentVariableService=t,this._remoteAuthorityResolverService=o,this._logService=i,this._editorService=l,this._labelService=n}_readSingleTerminalConfiguration(w){const y=this._configurationService.inspect(w);return{userValue:y.userValue,value:y.value,defaultValue:y.defaultValue}}async createTerminalProcess(w,y,a,r,s,t){await this._configurationService.whenRemoteConfigurationLoaded();const o=this._configurationService.getValue(u.TERMINAL_CONFIG_SECTION),i={"terminal.integrated.automationShell.windows":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.windows"),"terminal.integrated.automationShell.osx":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.osx"),"terminal.integrated.automationShell.linux":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.linux"),"terminal.integrated.shell.windows":this._readSingleTerminalConfiguration("terminal.integrated.shell.windows"),"terminal.integrated.shell.osx":this._readSingleTerminalConfiguration("terminal.integrated.shell.osx"),"terminal.integrated.shell.linux":this._readSingleTerminalConfiguration("terminal.integrated.shell.linux"),"terminal.integrated.shellArgs.windows":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.windows"),"terminal.integrated.shellArgs.osx":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.osx"),"terminal.integrated.shellArgs.linux":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.linux"),"terminal.integrated.env.windows":this._readSingleTerminalConfiguration("terminal.integrated.env.windows"),"terminal.integrated.env.osx":this._readSingleTerminalConfiguration("terminal.integrated.env.osx"),"terminal.integrated.env.linux":this._readSingleTerminalConfiguration("terminal.integrated.env.linux"),"terminal.integrated.inheritEnv":o.inheritEnv,"terminal.integrated.cwd":o.cwd,"terminal.integrated.detectLocale":o.detectLocale,"terminal.flowControl":o.flowControl},l=Object.create(null),n=y?h.withNullAsUndefined(this._workspaceContextService.getWorkspaceFolder(y)):void 0;let d;try{d=await this._resolverService.resolveWithInteraction(n,{shellLaunchConfig:w,configuration:i})}catch(W){this._logService.error(W)}if(d)for(const[W,N]of d.entries())(/^config:/.test(W)||W==="selectedText"||W==="lineNumber")&&(l[W]=N);const I=[];for(const[W,N]of this._environmentVariableService.collections.entries())I.push([W,f.serializeEnvironmentVariableCollection(N.map)]);const R=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),D=R.options&&R.options.extensionHostEnv,m=this._workspaceContextService.getWorkspace(),A=m.folders,U=y?this._workspaceContextService.getWorkspaceFolder(y):null,q=g.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:g.SideBySideEditor.PRIMARY,filterByScheme:[v.Schemas.file,v.Schemas.userData,v.Schemas.vscodeRemote]}),M={configuration:i,resolvedVariables:l,envVariableCollections:I,shellLaunchConfig:w,workspaceId:m.id,workspaceName:this._labelService.getWorkspaceLabel(m),workspaceFolders:A,activeWorkspaceFolder:U,activeFileResource:q,shouldPersistTerminal:a,cols:r,rows:s,isWorkspaceShellAllowed:t,resolverEnv:D};return await this._channel.call("$createTerminalProcess",M)}async startTerminalProcess(w){const y={id:w};return this._channel.call("$startTerminalProcess",y)}onTerminalProcessEvent(w){const y={id:w};return this._channel.listen("$onTerminalProcessEvent",y)}sendInputToTerminalProcess(w,y){const a={id:w,data:y};return this._channel.call("$sendInputToTerminalProcess",a)}sendCharCountToTerminalProcess(w,y){const a={id:w,charCount:y};return this._channel.call("$sendCharCountToTerminalProcess",a)}shutdownTerminalProcess(w,y){const a={id:w,immediate:y};return this._channel.call("$shutdownTerminalProcess",a)}resizeTerminalProcess(w,y,a){const r={id:w,cols:y,rows:a};return this._channel.call("$resizeTerminalProcess",r)}getTerminalInitialCwd(w){const y={id:w};return this._channel.call("$getTerminalInitialCwd",y)}getTerminalCwd(w){const y={id:w};return this._channel.call("$getTerminalCwd",y)}sendCommandResultToTerminalProcess(w,y,a,r){const s={id:w,reqId:y,isError:a,payload:r};return this._channel.call("$sendCommandResultToTerminalProcess",s)}orphanQuestionReply(w){const y={id:w};return this._channel.call("$orphanQuestionReply",y)}listTerminals(w){const y={isInitialization:w};return this._channel.call("$listTerminals",y)}setTerminalLayoutInfo(w){const a={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:w.tabs};return this._channel.call("$setTerminalLayoutInfo",a)}getTerminalLayoutInfo(){const y={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",y)}};E=Se([we(2,T.IWorkbenchConfigurationService),we(3,L.IWorkspaceContextService),we(4,P.IConfigurationResolverService),we(5,C.IEnvironmentVariableService),we(6,_.IRemoteAuthorityResolverService),we(7,b.ILogService),we(8,p.IEditorService),we(9,c.ILabelService)],E),e.RemoteTerminalChannelClient=E}),define(x[187],ee([0,1,159]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var T;(function(_){function L(C,f){if(C===f)return!0;let u=Object.keys(C),P=new Set;for(let g of Object.keys(f))P.add(g);if(u.length!==P.size)return!1;for(let g of u){if(C[g]!==f[g])return!1;P.delete(g)}return P.size===0}_.equals=L})(T=e.Translations||(e.Translations={}));class b{constructor(L){this._messageHandler=L}error(L,C){this._messageHandler(h.Severity.Error,L,C)}warn(L,C){this._messageHandler(h.Severity.Warning,L,C)}info(L,C){this._messageHandler(h.Severity.Info,L,C)}}e.Logger=b}),define(x[188],ee([0,1,137,3,45,62,18,114,11,7,12,31,51,40,187]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const E="package.json";class S{constructor(i,l,n,d,I){this._ourVersion=i,this._log=l,this._absoluteFolderPath=n,this._isBuiltin=d,this._isUnderDevelopment=I,this._absoluteManifestPath=T.join(n,E)}}class w extends S{static _fastParseJSON(i,l){try{return JSON.parse(i)}catch(n){return _.parse(i,l)}}parse(){return P.readFile(this._absoluteManifestPath).then(i=>{var l;const n=[],d=w._fastParseJSON(i.toString(),n);if(_.getNodeType(d)!=="object")this._log.error(this._absoluteFolderPath,h.localize(0,null,this._absoluteManifestPath));else{if(n.length===0)return d.__metadata&&(d.uuid=d.__metadata.id),d.isUserBuiltin=!!((l=d.__metadata)===null||l===void 0?void 0:l.isBuiltin),delete d.__metadata,d;n.forEach(I=>{this._log.error(this._absoluteFolderPath,h.localize(1,null,this._absoluteManifestPath,I.offset,I.length,C.getParseErrorMessage(I.error)))})}return null},i=>(i.code==="ENOENT"||this._log.error(this._absoluteFolderPath,h.localize(2,null,this._absoluteManifestPath,i.message)),null))}}class y extends S{constructor(i,l,n,d,I,R){super(i,l,n,d,I);this._nlsConfig=R}replaceNLS(i){const l=(A,U)=>{U.forEach(q=>{this._log.error(this._absoluteFolderPath,h.localize(3,null,A,C.getParseErrorMessage(q.error)))})},n=A=>{this._log.error(this._absoluteFolderPath,h.localize(4,null,A))};let d=T.extname(this._absoluteManifestPath),I=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-d.length);const R=`${i.publisher}.${i.name}`;let D=this._nlsConfig.translations[R],m;return D?m=P.readFile(D,"utf8").then(A=>{let U=[],q=_.parse(A,U);return U.length>0?(l(D,U),{values:void 0,default:`${I}.nls.json`}):_.getNodeType(q)!=="object"?(n(D),{values:void 0,default:`${I}.nls.json`}):{values:q.contents?q.contents.package:void 0,default:`${I}.nls.json`}},A=>({values:void 0,default:`${I}.nls.json`})):m=P.fileExists(I+".nls"+d).then(A=>{if(!!A)return y.findMessageBundles(this._nlsConfig,I).then(U=>U.localized?P.readFile(U.localized,"utf8").then(q=>{let M=[],W=_.parse(q,M);return M.length>0?(l(U.localized,M),{values:void 0,default:U.original}):_.getNodeType(W)!=="object"?(n(U.localized),{values:void 0,default:U.original}):{values:W,default:U.original}},q=>({values:void 0,default:U.original})):{values:void 0,default:U.original},U=>{})}),m.then(A=>{if(A===void 0)return i;let U=[];return y.resolveOriginalMessageBundle(A.default,U).then(q=>{if(U.length>0)return l(A.default,U),i;if(_.getNodeType(A)!=="object")return n(A.default),i;const M=A.values||Object.create(null);return y._replaceNLStrings(this._nlsConfig,i,M,q,this._log,this._absoluteFolderPath),i})},A=>i)}static resolveOriginalMessageBundle(i,l){return new Promise((n,d)=>{i?P.readFile(i).then(I=>{n(_.parse(I.toString(),l))},I=>{n(null)}):n(null)})}static findMessageBundles(i,l){return new Promise((n,d)=>{function I(R,D){let m=`${R}.nls.${D}.json`;P.fileExists(m).then(A=>{A&&n({localized:m,original:`${R}.nls.json`});let U=D.lastIndexOf("-");U===-1?n({localized:`${R}.nls.json`,original:null}):(D=D.substring(0,U),I(R,D))})}if(i.devMode||i.pseudo||!i.locale)return n({localized:l+".nls.json",original:null});I(l,i.locale)})}static _replaceNLStrings(i,l,n,d,I,R){function D(m,A,U){let q=m[A];if(f.isString(q)){let M=q,W=M.length;if(W>1&&M[0]==="%"&&M[W-1]==="%"){let N=M.substr(1,W-2),K=n[N];K===void 0&&d&&(K=d[N]),K?(i.pseudo&&(K="\uFF3B"+K.replace(/[aouei]/g,"$&$&")+"\uFF3D"),m[A]=U&&(A==="title"||A==="category")&&d?{value:K,original:d[N]}:K):I.warn(R,h.localize(5,null,N))}}else if(f.isObject(q))for(let M in q)q.hasOwnProperty(M)&&(M==="commands"?D(q,M,!0):D(q,M,U));else if(f.isArray(q))for(let M=0;M<q.length;M++)D(q,M,U)}for(let m in l)l.hasOwnProperty(m)&&D(l,m)}}class a extends S{validate(i){let l=i;l.isBuiltin=this._isBuiltin,l.isUserBuiltin=!this._isBuiltin&&!!l.isUserBuiltin,l.isUnderDevelopment=this._isUnderDevelopment;let n=[];return a.isValidExtensionDescription(this._ourVersion,this._absoluteFolderPath,l,n)?(n.forEach(d=>{this._log.warn(this._absoluteFolderPath,d)}),l.publisher||(l.publisher="undefined_publisher"),l.id=g.getExtensionId(l.publisher,l.name),l.identifier=new v.ExtensionIdentifier(l.id),l.extensionLocation=u.URI.file(this._absoluteFolderPath),l):(n.forEach(d=>{this._log.error(this._absoluteFolderPath,d)}),null)}static isValidExtensionDescription(i,l,n,d){return a.baseIsValidExtensionDescription(l,n,d)?b.valid(n.version)?p.isValidExtensionVersion(i,n,d):(d.push(h.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(i,l,n){if(!l)return n.push(h.localize(7,null)),!1;if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return n.push(h.localize(8,null)),!1;if(typeof l.name!="string")return n.push(h.localize(9,null,"name")),!1;if(typeof l.version!="string")return n.push(h.localize(10,null,"version")),!1;if(!l.engines)return n.push(h.localize(11,null,"engines")),!1;if(typeof l.engines.vscode!="string")return n.push(h.localize(12,null,"engines.vscode")),!1;if(typeof l.extensionDependencies!="undefined"&&!a._isStringArray(l.extensionDependencies))return n.push(h.localize(13,null,"extensionDependencies")),!1;if(typeof l.activationEvents!="undefined"){if(!a._isStringArray(l.activationEvents))return n.push(h.localize(14,null,"activationEvents")),!1;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return n.push(h.localize(15,null,"activationEvents","main")),!1}if(typeof l.main!="undefined"){if(typeof l.main!="string")return n.push(h.localize(16,null,"main")),!1;{const d=T.join(i,l.main);d.startsWith(i)||n.push(h.localize(17,null,d,i))}if(typeof l.activationEvents=="undefined")return n.push(h.localize(18,null,"activationEvents","main")),!1}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return n.push(h.localize(19,null,"browser")),!1;{const d=T.join(i,l.browser);d.startsWith(i)||n.push(h.localize(20,null,d,i))}if(typeof l.activationEvents=="undefined")return n.push(h.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(i){if(!Array.isArray(i))return!1;for(let l=0,n=i.length;l<n;l++)if(typeof i[l]!="string")return!1;return!0}}class r{constructor(i,l,n,d,I,R,D,m){this.ourVersion=i,this.commit=l,this.locale=n,this.devMode=d,this.absoluteFolderPath=I,this.isBuiltin=R,this.isUnderDevelopment=D,this.translations=m}static createNLSConfig(i){return{devMode:i.devMode,locale:i.locale,pseudo:i.locale==="pseudo",translations:i.translations}}static equals(i,l){return i.ourVersion===l.ourVersion&&i.commit===l.commit&&i.locale===l.locale&&i.devMode===l.devMode&&i.absoluteFolderPath===l.absoluteFolderPath&&i.isBuiltin===l.isBuiltin&&i.isUnderDevelopment===l.isUnderDevelopment&&i.mtime===l.mtime&&c.Translations.equals(i.translations,l.translations)}}e.ExtensionScannerInput=r;class s{constructor(i){this.root=i}resolveExtensions(){return P.readDirsInDir(this.root).then(i=>i.map(l=>({name:l,path:T.join(this.root,l)})))}}class t{static scanExtension(i,l,n,d,I,R){return n=T.normalize(n),new w(i,l,n,d,I).parse().then(m=>m===null?null:new y(i,l,n,d,I,R).replaceNLS(m)).then(m=>m===null?null:new a(i,l,n,d,I).validate(m))}static async scanExtensions(i,l,n=null){const d=i.absoluteFolderPath,I=i.isBuiltin,R=i.isUnderDevelopment;n||(n=new s(d));try{let D={};if(!I)try{const M=await P.readFile(T.join(d,".obsolete"),"utf8");D=JSON.parse(M)}catch(M){}let m=await n.resolveExtensions();m.sort((M,W)=>M.name<W.name?-1:1),I||(m=m.filter(M=>M.name.indexOf(".")!==0));const A=r.createNLSConfig(i);let U=await Promise.all(m.map(M=>this.scanExtension(i.ourVersion,l,M.path,I,R,A))),q=L.coalesce(U);return q=q.filter(M=>M!==null&&!D[new g.ExtensionIdentifierWithVersion({id:g.getGalleryExtensionId(M.publisher,M.name)},M.version).key()]),I||(q=g.groupByExtension(q,W=>({id:W.identifier.value,uuid:W.uuid})).map(W=>W.sort((N,K)=>b.rcompare(N.version,K.version))[0])),q.sort((M,W)=>M.extensionLocation.fsPath<W.extensionLocation.fsPath?-1:1),q}catch(D){return l.error(d,D),[]}}static scanOneOrMultipleExtensions(i,l){const n=i.absoluteFolderPath,d=i.isBuiltin,I=i.isUnderDevelopment;return P.fileExists(T.join(n,E)).then(R=>{if(R){const D=r.createNLSConfig(i);return this.scanExtension(i.ourVersion,l,n,d,I,D).then(m=>m===null?[]:[m])}return this.scanExtensions(i,l)},R=>(l.error(n,R),[]))}static scanSingleExtension(i,l){const n=i.absoluteFolderPath,d=i.isBuiltin,I=i.isUnderDevelopment,R=r.createNLSConfig(i);return this.scanExtension(i.ourVersion,l,n,d,I,R)}static mergeBuiltinExtensions(i,l){return Promise.all([i,l]).then(([n,d])=>{let I=Object.create(null);for(let D=0,m=n.length;D<m;D++)I[v.ExtensionIdentifier.toKey(n[D].identifier)]=n[D];for(let D=0,m=d.length;D<m;D++)I[v.ExtensionIdentifier.toKey(d[D].identifier)]=d[D];let R=Object.keys(I).map(D=>I[D]);return R.sort((D,m)=>{const A=T.basename(D.extensionLocation.fsPath),U=T.basename(m.extensionLocation.fsPath);return A<U?-1:A>U?1:0}),R})}}e.ExtensionScanner=t}),define(x[189],ee([0,1,35,22,43,17,25,5,4,20,7,50,116,40,54,28,58,81,177,83,178,179,85,181,184,188]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c,E,S,w,y,a,r,s,t,o,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProviderChannel=e.ExtensionEnvironmentChannel=e.FileProviderChannel=void 0;class n extends c.DiskFileSystemProvider{constructor(){super(...arguments);this.watches=new Map}dispose(){this.watches.forEach(M=>M.dispose()),this.watches.clear(),super.dispose()}_watch(M,W,N){this.watches.set(M,this.watch(W,N))}unwatch(M){this.watches.get(M).dispose(),this.watches.delete(M)}}class d{constructor(M,W){this.environmentService=M,this.logService=W,this.watchers=new Map,this.provider=new c.DiskFileSystemProvider(this.logService)}listen(M,W,N){switch(W){case"filechange":return this.filechange(M,N[0]);case"readFileStream":return this.readFileStream(N[0],N[1])}throw new Error(`Invalid listen '${W}'`)}filechange(M,W){const N=new C.Emitter({onFirstListenerAdd:()=>{const K=new n(this.logService);this.watchers.set(W,K);const j=w.getUriTransformer(M.remoteAuthority);K.onDidChangeFile($=>{N.fire($.map(J=>Object.assign(Object.assign({},J),{resource:j.transformOutgoing(J.resource)})))}),K.onDidErrorOccur($=>this.logService.error($))},onLastListenerRemove:()=>{this.watchers.get(W).dispose(),this.watchers.delete(W)}});return N.event}readFileStream(M,W){const N=new L.CancellationTokenSource,K=this.provider.readFileStream(this.transform(M),W,N.token),j=new C.Emitter({onFirstListenerAdd:()=>{K.on("data",$=>j.fire(_.VSBuffer.wrap($))),K.on("error",$=>j.fire($)),K.on("end",()=>j.fire("end"))},onLastListenerRemove:()=>N.cancel()});return j.event}call(M,W,N){switch(W){case"stat":return this.stat(N[0]);case"open":return this.open(N[0],N[1]);case"close":return this.close(N[0]);case"read":return this.read(N[0],N[1],N[2]);case"readFile":return this.readFile(N[0]);case"write":return this.write(N[0],N[1],N[2],N[3],N[4]);case"writeFile":return this.writeFile(N[0],N[1],N[2]);case"delete":return this.delete(N[0],N[1]);case"mkdir":return this.mkdir(N[0]);case"readdir":return this.readdir(N[0]);case"rename":return this.rename(N[0],N[1],N[2]);case"copy":return this.copy(N[0],N[1],N[2]);case"watch":return this.watch(N[0],N[1],N[2],N[3]);case"unwatch":return this.unwatch(N[0],N[1])}throw new Error(`Invalid call '${W}'`)}dispose(){this.watchers.forEach(M=>M.dispose()),this.watchers.clear()}async stat(M){return this.provider.stat(this.transform(M))}async open(M,W){return this.provider.open(this.transform(M),W)}async close(M){return this.provider.close(M)}async read(M,W,N){const K=_.VSBuffer.alloc(N),j=await this.provider.read(M,W,K.buffer,0,N);return[K,j]}async readFile(M){return _.VSBuffer.wrap(await this.provider.readFile(this.transform(M)))}write(M,W,N,K,j){return this.provider.write(M,W,N.buffer,K,j)}writeFile(M,W,N){return this.provider.writeFile(this.transform(M),W.buffer,N)}async delete(M,W){return this.provider.delete(this.transform(M),W)}async mkdir(M){return this.provider.mkdir(this.transform(M))}async readdir(M){return this.provider.readdir(this.transform(M))}async rename(M,W,N){return this.provider.rename(this.transform(M),P.URI.from(W),N)}copy(M,W,N){return this.provider.copy(this.transform(M),P.URI.from(W),N)}async watch(M,W,N,K){this.watchers.get(M)._watch(W,this.transform(N),K)}async unwatch(M,W){this.watchers.get(M).unwatch(W)}transform(M){if(/^\/static[^/]*\//.test(M.path))return P.URI.file(this.environmentService.appRoot+M.path.replace(/^\/static[^/]*\//,"/"));if(M.path==="/vscode-resource"&&M.query)try{const W=JSON.parse(M.query);if(W.requestResourcePath)return P.URI.file(W.requestResourcePath)}catch(W){}return P.URI.from(M)}}e.FileProviderChannel=d;class I{constructor(M,W,N,K){this.environment=M,this.log=W,this.telemetry=N,this.connectionToken=K}listen(M,W){throw new Error(`Invalid listen '${W}'`)}async call(M,W,N){switch(W){case"getEnvironmentData":return g.transformOutgoingURIs(await this.getEnvironmentData(),w.getUriTransformer(M.remoteAuthority));case"scanExtensions":return g.transformOutgoingURIs(await this.scanExtensions(N.language),w.getUriTransformer(M.remoteAuthority));case"getDiagnosticInfo":return this.getDiagnosticInfo();case"disableTelemetry":return this.disableTelemetry();case"logTelemetry":return this.logTelemetry(N[0],N[1]);case"flushTelemetry":return this.flushTelemetry()}throw new Error(`Invalid call '${W}'`)}async getEnvironmentData(){return{pid:process.pid,connectionToken:this.connectionToken,appRoot:P.URI.file(this.environment.appRoot),settingsPath:this.environment.settingsResource,logsPath:P.URI.file(this.environment.logsPath),extensionsPath:P.URI.file(this.environment.extensionsPath),extensionHostLogsPath:P.URI.file(b.join(this.environment.logsPath,"extension-host")),globalStorageHome:this.environment.globalStorageHome,workspaceStorageHome:this.environment.workspaceStorageHome,userHome:this.environment.userHome,os:f.OS,marks:[]}}async scanExtensions(M){const W=await S.getTranslations(M,this.environment.userDataPath),N=($,J,B)=>Promise.all(B.map(k=>l.ExtensionScanner.scanExtensions(new l.ExtensionScannerInput(E.default.version,E.default.commit,M,!!process.env.VSCODE_DEV,k,$,J,W),this.log))),K=async()=>N(!0,!1,[this.environment.builtinExtensionsPath,...this.environment.extraBuiltinExtensionPaths]),j=async()=>N(!1,!0,[this.environment.extensionsPath,...this.environment.extraExtensionPaths]);return Promise.all([K(),j()]).then($=>{const J=new Map;return $.forEach(B=>{B.forEach(k=>{k.forEach(O=>{const F=v.ExtensionIdentifier.toKey(O.identifier);if(J.has(F)){const z=J.get(F).extensionLocation.fsPath,G=O.extensionLocation.fsPath;this.log.warn(`${z} has been overridden ${G}`)}J.set(F,O)})})}),Array.from(J.values())})}getDiagnosticInfo(){throw new Error("not implemented")}async disableTelemetry(){this.telemetry.setEnabled(!1)}async logTelemetry(M,W){this.telemetry.publicLog(M,W)}async flushTelemetry(){}}e.ExtensionEnvironmentChannel=I;class R extends i.AbstractVariableResolverService{constructor(M,W,N){super({getFolderUri:K=>{const j=W.workspaceFolders.find($=>$.name===K);return j&&P.URI.revive(j.uri)},getWorkspaceFolderCount:()=>W.workspaceFolders.length,getConfigurationValue:(K,j)=>W.resolvedVariables[`config:${j}`],getExecPath:()=>W.resolverEnv&&W.resolverEnv.VSCODE_EXEC_PATH||N.VSCODE_EXEC_PATH,getFilePath:()=>{const K=A(M,W.activeFileResource);if(!!K)return K.scheme==="file"?K.fsPath:K.path},getSelectedText:()=>W.resolvedVariables.selectedText,getLineNumber:()=>W.resolvedVariables.selectedText},void 0,N)}}class D{constructor(M,W,N,K,j){this.id=M,this._pid=-1,this._title="",this._onDispose=new C.Emitter,this._isOrphan=!0,this.replayData=[],this.maxReplayData=1e4,this.totalReplayData=0,this.disposeDelay=48*60*60*1e3,this.buffering=!1,this._onEvent=new C.Emitter({onFirstListenerAdd:()=>{h.logger.debug("Terminal bound",h.field("id",this.id)),this._isOrphan=!1,this.buffering||(this.buffering=!0,this.bufferer.startBuffering(this.id,this.process.onProcessData))},onFirstListenerDidAdd:()=>{typeof this.disposeTimeout=="undefined"&&(clearTimeout(this.disposeTimeout),this.disposeTimeout=void 0,h.logger.debug("Terminal replaying",h.field("id",this.id)),this._onEvent.fire({type:"replay",events:[{cols:this.cols,rows:this.rows,data:this.replayData.join("")}]}))},onLastListenerRemove:()=>{h.logger.debug("Terminal unbound",h.field("id",this.id)),this._isOrphan=!0,this.persist?this.disposeTimeout=setTimeout(()=>{this.dispose()},this.disposeDelay):this.dispose()}}),this.bufferer=new r.TerminalDataBufferer(($,J)=>{if(this._onEvent.fire({type:"data",data:J}),!!this.persist){this.replayData.push(J),this.totalReplayData+=J.length;let B=this.totalReplayData-this.maxReplayData;if(!(B<=0)){let k=0;for(;k<this.replayData.length&&this.replayData[k].length<=B;++k)B-=this.replayData[k].length;k>0&&this.replayData.splice(0,k),B>0&&this.replayData.length>0&&(this.replayData[0]=this.replayData[0].substring(B)),this.totalReplayData=this.replayData.reduce((O,F)=>O+F.length,0)}}}),this.workspaceId=N.workspaceId,this.workspaceName=N.workspaceName,this.cols=N.cols,this.rows=N.rows,this.persist=!1,this.process=new o.TerminalProcess(W,W.cwd,this.cols,this.rows,K,process.env,!1,j),this.process.onProcessReady($=>{this._pid=$.pid,this._onEvent.fire({type:"ready",pid:$.pid,cwd:$.cwd})}),this.process.onProcessTitleChanged($=>{this._title=$,this._onEvent.fire({type:"titleChanged",title:$})}),this.process.onProcessExit($=>{h.logger.debug("Terminal exited",h.field("id",this.id),h.field("code",$)),this._onEvent.fire({type:"exit",exitCode:$}),this.dispose()})}get onDispose(){return this._onDispose.event}get isOrphan(){return this._isOrphan}get onEvent(){return this._onEvent.event}get pid(){return this._pid}get title(){return this._title}async dispose(){h.logger.debug("Terminal disposing",h.field("id",this.id)),this._onEvent.dispose(),this.bufferer.dispose(),await this.process.shutdown(!0),this.process.dispose(),this._onDispose.fire(),this._onDispose.dispose()}shutdown(M){return this.process.shutdown(M)}getCwd(){return this.process.getCwd()}getInitialCwd(){return this.process.getInitialCwd()}start(){return this.process.start()}input(M){return this.process.input(M)}resize(M,W){return this.cols=M,this.rows=W,this.process.resize(M,W)}async description(M){const W=await this.getCwd();return{id:M,pid:this.pid,title:this.title,cwd:W,workspaceId:this.workspaceId,workspaceName:this.workspaceName,isOrphan:this.isOrphan}}}class m{constructor(M){this.logService=M,this.terminals=new Map,this.id=0,this.layouts=new Map}listen(M,W,N){switch(W){case"$onTerminalProcessEvent":return this.onTerminalProcessEvent(N)}throw new Error(`Invalid listen '${W}'`)}onTerminalProcessEvent(M){return this.getTerminal(M.id).onEvent}call(M,W,N){switch(W){case"$createTerminalProcess":return this.createTerminalProcess(M.remoteAuthority,N);case"$startTerminalProcess":return this.startTerminalProcess(N);case"$sendInputToTerminalProcess":return this.sendInputToTerminalProcess(N);case"$shutdownTerminalProcess":return this.shutdownTerminalProcess(N);case"$resizeTerminalProcess":return this.resizeTerminalProcess(N);case"$getTerminalInitialCwd":return this.getTerminalInitialCwd(N);case"$getTerminalCwd":return this.getTerminalCwd(N);case"$sendCommandResultToTerminalProcess":return this.sendCommandResultToTerminalProcess(N);case"$orphanQuestionReply":return this.orphanQuestionReply(N[0]);case"$listTerminals":return this.listTerminals(N[0]);case"$setTerminalLayoutInfo":return this.setTerminalLayoutInfo(N);case"$getTerminalLayoutInfo":return this.getTerminalLayoutInfo(N)}throw new Error(`Invalid call '${W}'`)}dispose(){this.terminals.forEach(M=>M.dispose())}async createTerminalProcess(M,W){var N;const K=this.id++;h.logger.debug("Creating terminal",h.field("id",K),h.field("terminals",this.terminals.size));const j={name:W.shellLaunchConfig.name,executable:W.shellLaunchConfig.executable,args:W.shellLaunchConfig.args,cwd:typeof W.shellLaunchConfig.cwd!="string"?A(M,W.shellLaunchConfig.cwd):W.shellLaunchConfig.cwd,env:W.shellLaunchConfig.env},$=A(M,(N=W.activeWorkspaceFolder)===null||N===void 0?void 0:N.uri),J=$&&W.activeWorkspaceFolder?Object.assign(Object.assign({},W.activeWorkspaceFolder),{uri:$,toResource:se=>u.joinPath($,se)}):void 0,B=new R(M,W,process.env),k=s.createVariableResolver(J,B),O=async()=>{if(j.executable){const fe=B.resolve(J,j.executable);let ie=[];if(j.args&&Array.isArray(j.args))for(const ae of j.args)ie.push(B.resolve(J,ae));else j.args&&(ie=B.resolve(J,j.args));return{executable:fe,args:ie}}const se=s.getDefaultShell(fe=>W.configuration[fe],W.isWorkspaceShellAllowed,await p.getSystemShell(f.platform),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,k,this.logService,!1),le=s.getDefaultShellArgs(fe=>W.configuration[fe],W.isWorkspaceShellAllowed,!1,k,this.logService);return{executable:se,args:le}},F=()=>s.getCwd(j,T.homedir(),k,$,W.configuration["terminal.integrated.cwd"],this.logService),z=Object.assign(Object.assign(Object.assign({},j),await O()),{cwd:F()});h.logger.debug("Resolved shell launch configuration",h.field("id",K));const G=()=>f.isWindows?W.configuration["terminal.integrated.env.windows"]:f.isMacintosh?W.configuration["terminal.integrated.env.osx"]:W.configuration["terminal.integrated.env.linux"],Y=async()=>{const se=await t.getMainProcessParentEnv();return se.VSCODE_IPC_HOOK_CLI=process.env.VSCODE_IPC_HOOK_CLI,se},Q=s.createTerminalEnvironment(j,G(),k,W.isWorkspaceShellAllowed,E.default.version,W.configuration["terminal.integrated.detectLocale"],W.configuration["terminal.integrated.inheritEnv"]!==!1?process.env:await Y());if(!j.strictEnv){const se=new Map;for(const[fe,ie]of W.envVariableCollections)se.set(fe,{map:a.deserializeEnvironmentVariableCollection(ie)});new y.MergedEnvironmentVariableCollection(se).applyToProcessEnvironment(Q)}h.logger.debug("Resolved terminal environment",h.field("id",K));const Z=new D(K,z,W,Q,this.logService);return this.terminals.set(K,Z),h.logger.debug("Created terminal",h.field("id",K)),Z.onDispose(()=>this.terminals.delete(K)),{terminalId:K,resolvedShellLaunchConfig:z}}getTerminal(M){const W=this.terminals.get(M);if(!W)throw new Error(`terminal with id ${M} does not exist`);return W}async startTerminalProcess(M){return this.getTerminal(M.id).start()}async sendInputToTerminalProcess(M){return this.getTerminal(M.id).input(M.data)}async shutdownTerminalProcess(M){return this.getTerminal(M.id).shutdown(M.immediate)}async resizeTerminalProcess(M){return this.getTerminal(M.id).resize(M.cols,M.rows)}async getTerminalInitialCwd(M){return this.getTerminal(M.id).getInitialCwd()}async getTerminalCwd(M){return this.getTerminal(M.id).getCwd()}async sendCommandResultToTerminalProcess(M){throw new Error("not implemented")}async orphanQuestionReply(M){throw new Error("not implemented")}async listTerminals(M){return(await Promise.all(Array.from(this.terminals).map(async([N,K])=>K.description(N)))).filter(N=>N.isOrphan)}async setTerminalLayoutInfo(M){this.layouts.set(M.workspaceId,M)}async getTerminalLayoutInfo(M){const W=this.layouts.get(M.workspaceId);if(!!W)return{tabs:await Promise.all(W.tabs.map(async K=>{const j=await Promise.all(K.terminals.map(async $=>{const J=this.terminals.get($.terminal);if(!!J)return Object.assign(Object.assign({},$),{terminal:await J.description($.terminal)})}));return Object.assign(Object.assign({},K),{terminals:j.filter(U)})}))}}}e.TerminalProviderChannel=m;function A(q,M){const W=w.getUriTransformer(q);return M&&P.URI.revive(W.transformIncoming(M))}function U(q){return typeof q!="undefined"}}),define(x[190],ee([0,1,5,2,7,26,17,42,14,38]),function(H,e,h,T,b,_,L,C,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProvider=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class P extends T.Disposable{constructor(p){super();this.session=_.generateUuid(),this._onDidChange=this._register(new h.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new h.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new h.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event;const v=p.getConnection();this.channel=v.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),this.setCaseSensitive(!0),(async()=>{const c=await p.getEnvironment();this.setCaseSensitive((c==null?void 0:c.os)===3)})(),this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(p=>{if(Array.isArray(p)){const v=p;this._onDidChange.fire(v.map(c=>({resource:b.URI.revive(c.resource),type:c.type})))}else{const v=p;this._onDidWatchErrorOccur.fire(v)}}))}setCaseSensitive(p){let v=2|4|16|8;p&&(v|=1024),this._capabilities=v,this._onDidChangeCapabilities.fire(void 0)}stat(p){return this.channel.call("stat",[p])}open(p,v){return this.channel.call("open",[p,v])}close(p){return this.channel.call("close",[p])}async read(p,v,c,E,S){const[w,y]=await this.channel.call("read",[p,v,S]);return c.set(w.buffer.slice(0,y),E),y}async readFile(p){return(await this.channel.call("readFile",[p])).buffer}readFileStream(p,v,c){const E=C.newWriteableStream(w=>L.VSBuffer.concat(w.map(y=>L.VSBuffer.wrap(y))).buffer),S=this.channel.listen("readFileStream",[p,v])(w=>{if(w instanceof L.VSBuffer)E.write(w.buffer);else{if(w==="end")E.end();else{let y=w;y instanceof Error||(y=new Error(u.toErrorMessage(y))),E.end(y)}S.dispose()}});return c.onCancellationRequested(()=>{E.end(f.canceled()),S.dispose()}),E}write(p,v,c,E,S){return this.channel.call("write",[p,v,L.VSBuffer.wrap(c),E,S])}writeFile(p,v,c){return this.channel.call("writeFile",[p,L.VSBuffer.wrap(v),c])}delete(p,v){return this.channel.call("delete",[p,v])}mkdir(p){return this.channel.call("mkdir",[p])}readdir(p){return this.channel.call("readdir",[p])}rename(p,v,c){return this.channel.call("rename",[p,v,c])}copy(p,v,c){return this.channel.call("copy",[p,v,c])}watch(p,v){const c=Math.random();return this.channel.call("watch",[this.session,c,p,v]),T.toDisposable(()=>this.channel.call("unwatch",[this.session,c]))}}e.RemoteFileSystemProvider=P}),define(x[191],ee([0,1,6]),function(H,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=h.createDecorator("remoteAgentService")}),define(x[49],ee([0,1,117,3,21,15,12,205,206,11]),function(H,e,h,T,b,_,L,C,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(t,o){let i=o.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=o}}e.ExtractError=P;function g(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(o=>t&o).reduce((o,i)=>o+i,t&61440)}function p(s){if(s instanceof P)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new P(t,s)}function v(s,t,o,i,l,n){const d=T.dirname(t),I=T.join(i,d);if(!I.startsWith(i))return Promise.reject(new Error(h.localize(0,null,t)));const R=T.join(i,t);let D;return n.onCancellationRequested(()=>{D&&D.destroy()}),Promise.resolve(L.mkdirp(I)).then(()=>new Promise((m,A)=>{if(!n.isCancellationRequested)try{D=b.createWriteStream(R,{mode:o}),D.once("close",()=>m()),D.once("error",A),s.once("error",A),s.pipe(D)}catch(U){A(U)}}))}function c(s,t,o,i){let l=_.createCancelablePromise(()=>Promise.resolve()),n=0;return i.onCancellationRequested(()=>{l.cancel(),s.close()}),new Promise((d,I)=>{const R=new _.Sequencer,D=m=>{m.isCancellationRequested||(n++,s.readEntry())};s.once("error",I),s.once("close",()=>l.then(()=>{i.isCancellationRequested||s.entryCount===n?d():I(new P("Incomplete",new Error(h.localize(1,null,n,s.entryCount))))},I)),s.readEntry(),s.on("entry",m=>{if(!i.isCancellationRequested){if(!o.sourcePathRegex.test(m.fileName)){D(i);return}const A=m.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(A)){const M=T.join(t,A);l=_.createCancelablePromise(W=>L.mkdirp(M).then(()=>D(W)).then(void 0,I));return}const U=S(s,m),q=g(m);l=_.createCancelablePromise(M=>R.queue(()=>U.then(W=>v(W,A,q,t,o,M).then(()=>D(M)))).then(null,I))}})})}function E(s,t=!1){return new Promise((o,i)=>{C.open(s,t?{lazyEntries:!0}:void 0,(l,n)=>{l?i(p(l)):o(u.assertIsDefined(n))})})}function S(s,t){return new Promise((o,i)=>{s.openReadStream(t,(l,n)=>{l?i(p(l)):o(u.assertIsDefined(n))})})}function w(s,t){return new Promise((o,i)=>{const l=new f.ZipFile;t.forEach(d=>{d.contents?l.addBuffer(typeof d.contents=="string"?Buffer.from(d.contents,"utf8"):d.contents,d.path):d.localPath&&l.addFile(d.localPath,d.path)}),l.end();const n=b.createWriteStream(s);l.outputStream.pipe(n),l.outputStream.once("error",i),n.once("error",i),n.once("finish",()=>o(s))})}e.zip=w;function y(s,t,o={},i){const l=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let n=E(s,!0);return o.overwrite&&(n=n.then(d=>L.rimraf(t).then(()=>d))),n.then(d=>c(d,t,{sourcePathRegex:l},i))}e.extract=y;function a(s,t){return E(s).then(o=>new Promise((i,l)=>{o.on("entry",n=>{n.fileName===t&&S(o,n).then(d=>i(d),d=>l(d))}),o.once("close",()=>l(new Error(h.localize(2,null,t))))}))}function r(s,t){return a(s,t).then(o=>new Promise((i,l)=>{const n=[];o.once("error",l),o.on("data",d=>n.push(d)),o.on("end",()=>i(Buffer.concat(n)))}))}e.buffer=r}),define(x[192],ee([0,1,49,122]),function(H,e,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function b(_){return h.buffer(_,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch(C){throw new Error(T.localize(0,null))}})}e.getManifest=b}),define(x[193],ee([0,1,45,2,12,3,13,27,31,15,7,23,140,123,46,49,4,18,10]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c,E,S,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const a="scanningSystem",r="scanningUser",s="extracting",t="deleting",o="renaming";let i=class extends T.Disposable{constructor(n,d,I,R){super();this.beforeRemovingExtension=n,this.logService=d,this.environmentService=I,this.productService=R,this._devSystemExtensionsPath=null,this.systemExtensionsPath=I.builtinExtensionsPath,this.extensionsPath=I.extensionsPath,this.uninstalledPath=_.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new u.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const d=[];(n===null||n===0)&&d.push(this.scanSystemExtensions().then(null,I=>Promise.reject(new C.ExtensionManagementError(this.joinErrors(I).message,a)))),(n===null||n===1)&&d.push(this.scanUserExtensions(!0).then(null,I=>Promise.reject(new C.ExtensionManagementError(this.joinErrors(I).message,r))));try{const I=await Promise.all(d);return w.flatten(I)}catch(I){throw this.joinErrors(I)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[d,I]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return I=I.filter(R=>!d[new f.ExtensionIdentifierWithVersion(R.identifier,R.manifest.version).key()]),n&&(I=f.groupByExtension(I,D=>D.identifier).map(D=>D.sort((m,A)=>h.rcompare(m.manifest.version,A.manifest.version))[0])),this.logService.trace("Scanned user extensions:",I.length),I}async scanAllUserExtensions(){return this.scanExtensionsInDirs(this.extensionsPath,this.environmentService.extraExtensionPaths,1)}async extractUserExtension(n,d,I){const R=n.key(),D=_.join(this.extensionsPath,`.${R}`),m=_.join(this.extensionsPath,R);try{await b.rimraf(m)}catch(U){try{await b.rimraf(m)}catch(q){}throw new C.ExtensionManagementError(v.localize(0,null,m,n.id),t)}await this.extractAtLocation(n,d,D,I);try{await this.rename(n,D,m,Date.now()+2*60*1e3),this.logService.info("Renamed to",m)}catch(U){this.logService.info("Rename failed. Deleting from extracted location",D);try{b.rimraf(D)}catch(q){}throw U}let A=null;try{A=await this.scanExtension(R,this.extensionsPath,1)}catch(U){}if(A)return A;throw new Error(v.localize(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,d){this.setMetadata(n,d),d.isMachineScoped=d.isMachineScoped||void 0,d.isBuiltin=d.isBuiltin||void 0;const I=_.join(n.location.fsPath,"package.json"),R=await b.readFile(I,"utf8"),{manifest:D}=await this.parseManifest(R);return D.__metadata=d,await b.writeFile(I,JSON.stringify(D,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions(n=>n)}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let d;try{d=await b.readFile(this.uninstalledPath,"utf8")}catch(D){if(D.code!=="ENOENT")throw D}let I={};if(d)try{I=JSON.parse(d)}catch(D){}const R=n(I);return Object.keys(I).length?await b.writeFile(this.uninstalledPath,JSON.stringify(I)):await b.rimraf(this.uninstalledPath),R})}async removeExtension(n,d){this.logService.trace(`Deleting ${d} extension from disk`,n.identifier.id,n.location.fsPath),await b.rimraf(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(d=>delete d[new f.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,d,I,R){this.logService.trace(`Started extracting the extension from ${d} to ${I}`);try{await b.rimraf(I)}catch(D){throw new C.ExtensionManagementError(this.joinErrors(D).message,t)}try{await E.extract(d,I,{sourcePath:"extension",overwrite:!0},R),this.logService.info(`Extracted extension to ${I}:`,n.id)}catch(D){try{await b.rimraf(I)}catch(m){}throw new C.ExtensionManagementError(D.message,D instanceof E.ExtractError&&D.type?D.type:s)}}async rename(n,d,I,R){try{await b.rename(d,I)}catch(D){if(S.isWindows&&D&&D.code==="EPERM"&&Date.now()<R)return this.logService.info(`Failed renaming ${d} to ${I} with 'EPERM' error. Trying again...`,n.id),this.rename(n,d,I,R);throw new C.ExtensionManagementError(D.message||v.localize(2,null,d,I),D.code||o)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const d=this.scanDevSystemExtensions(),[I,R]=await Promise.all([n,d]);return[...I,...R]}async scanExtensionsInDir(n,d){const I=new u.Limiter(10),R=await b.readdir(n).catch(m=>{if(m.code!=="ENOENT")throw m;return[]});return(await Promise.all(R.map(m=>I.queue(()=>this.scanExtension(m,n,d))))).filter(m=>m&&m.identifier)}async scanExtension(n,d,I){if(I===1&&n.indexOf(".")===0)return null;const R=_.join(d,n);try{const D=await b.readdir(R),{manifest:m,metadata:A}=await this.readManifest(R),U=D.filter(j=>/^readme(\.txt|\.md|)$/i.test(j))[0],q=U?P.URI.file(_.join(R,U)):void 0,M=D.filter(j=>/^changelog(\.txt|\.md|)$/i.test(j))[0],W=M?P.URI.file(_.join(R,M)):void 0,N={id:f.getGalleryExtensionId(m.publisher,m.name)},K={type:I,identifier:N,manifest:m,location:P.URI.file(R),readmeUrl:q,changelogUrl:W,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:I===0};return A&&this.setMetadata(K,A),K}catch(D){return this.logService.trace(D),null}}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDirs(this.systemExtensionsPath,this.environmentService.extraBuiltinExtensionPaths,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const d=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",d.length),d.filter(I=>n.some(R=>f.areSameExtensions(I.identifier,{id:R})))}else return[]}setMetadata(n,d){n.publisherDisplayName=d.publisherDisplayName||null,n.publisherId=d.publisherId||null,n.identifier.uuid=d.id,n.isMachineScoped=!!d.isMachineScoped,n.isBuiltin=n.type===0||!!d.isBuiltin}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),d=await this.scanAllUserExtensions(),I=new Set;for(const m of d)n[new f.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()]||I.add(m.identifier.id.toLowerCase());const R=f.groupByExtension(d,m=>m.identifier);await Promise.all(R.map(async m=>{const A=m.sort((U,q)=>h.rcompare(U.manifest.version,q.manifest.version))[0];I.has(A.identifier.id.toLowerCase())||await this.beforeRemovingExtension(A)}));const D=d.filter(m=>n[new f.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()]);await Promise.all(D.map(m=>this.removeUninstalledExtension(m)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),d=[],I=f.groupByExtension(n,R=>R.identifier);d.push(...w.flatten(I.map(R=>R.sort((D,m)=>h.rcompare(D.manifest.version,m.manifest.version)).slice(1)))),await Promise.all(d.map(R=>this.removeExtension(R,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const d=Array.isArray(n)?n:[n];return d.length===1?d[0]instanceof Error?d[0]:new Error(d[0]):d.reduce((I,R)=>new Error(`${I.message}${I.message?",":""}${R instanceof Error?R.message:R}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=_.normalize(_.join(y.FileAccess.asFileUri("",H).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const d=[b.readFile(_.join(n,"package.json"),"utf8").then(m=>this.parseManifest(m)),b.readFile(_.join(n,"package.nls.json"),"utf8").then(void 0,m=>m.code!=="ENOENT"?Promise.reject(m):"{}").then(m=>JSON.parse(m))],[{manifest:I,metadata:R},D]=await Promise.all(d);return{manifest:p.localizeManifest(I,D),metadata:R}}parseManifest(n){return new Promise((d,I)=>{try{const R=JSON.parse(n),D=R.__metadata||null;d({manifest:R,metadata:D})}catch(R){I(new Error(v.localize(3,null)))}})}async scanExtensionsInDirs(n,d,I){return(await Promise.all([n,...d].map(D=>this.scanExtensionsInDir(D,I)))).reduce((D,m)=>D.concat(m),[])}};i=Se([we(1,L.ILogService),we(2,g.INativeEnvironmentService),we(3,c.IProductService)],i),e.ExtensionsScanner=i}),define(x[87],ee([0,1,121,3,12,2,18,49,27,31,23,15,5,45,7,28,4,13,148,38,47,51,20,26,146,6,10,25,192,152,193,153]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c,E,S,w,y,a,r,s,t,o,i,l,n,d,I,R,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const A="unsetUninstalled",U="downloading",q="validating",M="local",W="unknown";let N=class extends _.Disposable{constructor(j,$,J,B,k,O){super();this.environmentService=j,this.galleryService=$,this.logService=J,this.downloadService=B,this.telemetryService=k,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new p.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new p.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new p.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new p.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const F=this._register(O.createInstance(m.ExtensionsLifecycle));this.extensionsScanner=this._register(O.createInstance(D.ExtensionsScanner,z=>F.postUninstall(z))),this.manifestCache=this._register(new y.ExtensionsManifestCache(j,this)),this.extensionsDownloader=this._register(O.createInstance(R.ExtensionsDownloader)),this._register(_.toDisposable(()=>{this.installingExtensions.forEach(z=>z.cancel()),this.uninstallingExtensions.forEach(z=>z.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(j){this.logService.trace("ExtensionManagementService#zip",j.identifier.id);const $=await this.collectFiles(j),J=await C.zip(t.joinPath(this.environmentService.tmpDir,o.generateUuid()).fsPath,$);return c.URI.file(J)}async unzip(j){return this.logService.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const $=await this.downloadVsix(j),J=T.resolve($.fsPath);return I.getManifest(J)}async collectFiles(j){const $=async B=>{let k=await b.readdir(B);k=k.map(z=>T.join(B,z));const O=await Promise.all(k.map(z=>b.stat(z)));let F=Promise.resolve([]);return O.forEach((z,G)=>{const Y=k[G];z.isFile()&&(F=F.then(Q=>[...Q,Y])),z.isDirectory()&&(F=F.then(Q=>$(Y).then(Z=>[...Q,...Z])))}),F};return(await $(j.location.fsPath)).map(B=>({path:`extension/${T.relative(j.location.fsPath,B)}`,localPath:B}))}async install(j,$={}){return this.logService.trace("ExtensionManagementService#install",j.toString()),g.createCancelablePromise(async J=>{const B=await this.downloadVsix(j),k=T.resolve(B.fsPath),O=await I.getManifest(k),F={id:u.getGalleryExtensionId(O.publisher,O.name)};let z=1;if(O.engines&&O.engines.vscode&&!s.isEngineValid(O.engines.vscode,E.default.version))throw new Error(h.localize(0,null,F.id,E.default.version));const G=new u.ExtensionIdentifierWithVersion(F,O.version),Q=(await this.getInstalled(1)).find(se=>u.areSameExtensions(F,se.identifier));if(Q)if($.isMachineScoped=$.isMachineScoped||Q.isMachineScoped,$.isBuiltin=$.isBuiltin||Q.isBuiltin,z=2,G.equals(new u.ExtensionIdentifierWithVersion(Q.identifier,Q.manifest.version)))try{await this.extensionsScanner.removeExtension(Q,"existing")}catch(se){throw new Error(h.localize(1,null,O.displayName||O.name))}else v.gt(Q.manifest.version,O.version)&&await this.uninstallExtension(Q);else{const se=await this.unsetUninstalledAndGetLocal(G);if(se)try{await this.extensionsScanner.removeExtension(se,"existing")}catch(le){throw new Error(h.localize(2,null,O.displayName||O.name))}}this.logService.info("Installing the extension:",F.id),this._onInstallExtension.fire({identifier:F,zipPath:k});let Z;try{Z=await this.getGalleryMetadata(u.getGalleryExtensionId(O.publisher,O.name))}catch(se){}try{const se=await this.installFromZipPath(G,k,Object.assign(Object.assign({},Z||{}),$),$,z,J);return this.logService.info("Successfully installed the extension:",F.id),se}catch(se){throw this.logService.error("Failed to install the extension:",F.id,se.message),se}})}async downloadVsix(j){if(j.scheme===n.Schemas.file)return j;if(!this.downloadService)throw new Error("Download service is not available");const $=t.joinPath(this.environmentService.tmpDir,o.generateUuid());return await this.downloadService.download(j,$),$}async installFromZipPath(j,$,J,B,k,O){try{const F=await this.installExtension({zipPath:$,identifierWithVersion:j,metadata:J},O);try{await this.installDependenciesAndPackExtensions(F,void 0,B)}catch(z){L.isNonEmptyArray(F.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",F.identifier.id,z.message),L.isNonEmptyArray(F.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",F.identifier.id,z.message)}return this._onDidInstallExtension.fire({identifier:j,zipPath:$,local:F,operation:k}),F}catch(F){throw this._onDidInstallExtension.fire({identifier:j,zipPath:$,operation:k,error:F}),F}}async canInstall(j){return!0}async installFromGallery(j,$={}){if(!this.galleryService.isEnabled())throw new Error(h.localize(3,null));try{j=await this.checkAndGetCompatibleVersion(j)}catch(k){const O=k&&k.code?k.code:W;throw this.logService.error("Failed to install extension:",j.identifier.id,k?k.message:O),this.reportTelemetry(this.getTelemetryEvent(1),u.getGalleryExtensionTelemetryData(j),void 0,k),k instanceof Error&&(k.name=O),k}const J=new u.ExtensionIdentifierWithVersion(j.identifier,j.version).key();let B=this.installingExtensions.get(J);return B||(B=g.createCancelablePromise(k=>this.doInstallFromGallery(j,$,k)),this.installingExtensions.set(J,B),B.finally(()=>this.installingExtensions.delete(J))),B}async doInstallFromGallery(j,$,J){const B=new Date().getTime();let k=1;this.logService.info("Installing extension:",j.identifier.id),this._onInstallExtension.fire({identifier:j.identifier,gallery:j});try{const F=(await this.getInstalled(1)).find(Y=>u.areSameExtensions(Y.identifier,j.identifier));F&&(k=2);const z=await this.downloadInstallableExtension(j,k);z.metadata.isMachineScoped=$.isMachineScoped||(F==null?void 0:F.isMachineScoped),z.metadata.isBuiltin=$.isBuiltin||(F==null?void 0:F.isBuiltin);const G=await this.installExtension(z,J);try{await this.extensionsDownloader.delete(c.URI.file(z.zipPath))}catch(Y){}if(!$.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(G,F,$)}catch(Y){try{await this.uninstall(G)}catch(Q){}throw Y}return F&&v.neq(F.manifest.version,j.version)&&await this.setUninstalled(F),this.logService.info("Extensions installed successfully:",j.identifier.id),this._onDidInstallExtension.fire({identifier:j.identifier,gallery:j,local:G,operation:k}),this.reportTelemetry(this.getTelemetryEvent(k),u.getGalleryExtensionTelemetryData(j),new Date().getTime()-B,void 0),G}catch(O){const F=O&&O.code?O.code:W;throw this.logService.error("Failed to install extension:",j.identifier.id,O?O.message:F),this._onDidInstallExtension.fire({identifier:j.identifier,gallery:j,operation:k,error:F}),this.reportTelemetry(this.getTelemetryEvent(k),u.getGalleryExtensionTelemetryData(j),new Date().getTime()-B,O),O instanceof Error&&(O.name=F),O}}async checkAndGetCompatibleVersion(j){if(await this.isMalicious(j))throw new f.ExtensionManagementError(h.localize(4,null),f.INSTALL_ERROR_MALICIOUS);const $=await this.galleryService.getCompatibleExtension(j);if(!$)throw new f.ExtensionManagementError(h.localize(5,null,j.identifier.id,E.default.version),f.INSTALL_ERROR_INCOMPATIBLE);return $}async reinstallFromGallery(j){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",j.identifier.id),!this.galleryService.isEnabled())throw new Error(h.localize(6,null));const $=await this.findGalleryExtension(j);if(!$)throw new Error(h.localize(7,null));await this.setUninstalled(j);try{await this.extensionsScanner.removeUninstalledExtension(j)}catch(J){throw new Error(h.localize(8,null,a.toErrorMessage(J)))}await this.installFromGallery($)}getTelemetryEvent(j){return j===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(j){const $=await this.getExtensionsReport();return u.getMaliciousExtensionsSet($).has(j.identifier.id)}async downloadInstallableExtension(j,$){const J={id:j.identifier.uuid,publisherId:j.publisherId,publisherDisplayName:j.publisherDisplayName};let B;try{this.logService.trace("Started downloading extension:",j.identifier.id);const k=await this.extensionsDownloader.downloadExtension(j,$);this.logService.info("Downloaded extension:",j.identifier.id,B),B=k.fsPath}catch(k){throw new f.ExtensionManagementError(this.joinErrors(k).message,U)}try{const k=await I.getManifest(B);return{zipPath:B,identifierWithVersion:new u.ExtensionIdentifierWithVersion(j.identifier,k.version),metadata:J}}catch(k){throw new f.ExtensionManagementError(this.joinErrors(k).message,q)}}async installExtension(j,$){try{const J=await this.unsetUninstalledAndGetLocal(j.identifierWithVersion);if(J)return j.metadata?this.extensionsScanner.saveMetadataForLocalExtension(J,j.metadata):J}catch(J){throw S.isMacintosh?new f.ExtensionManagementError(h.localize(9,null),A):new f.ExtensionManagementError(h.localize(10,null),A)}return this.extractAndInstall(j,$)}async unsetUninstalledAndGetLocal(j){return await this.isUninstalled(j)?(this.logService.trace("Removing the extension from uninstalled list:",j.id),await this.unsetUninstalled(j),this.logService.info("Removed the extension from uninstalled list:",j.id),(await this.getInstalled(1)).find(B=>new u.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version).equals(j))||null):null}async extractAndInstall({zipPath:j,identifierWithVersion:$,metadata:J},B){let k=await this.extensionsScanner.extractUserExtension($,j,B);return this.logService.info("Installation completed.",$.id),J&&(k=await this.extensionsScanner.saveMetadataForLocalExtension(k,J)),k}async installDependenciesAndPackExtensions(j,$,J){if(!!this.galleryService.isEnabled()){const B=j.manifest.extensionDependencies||[];if(j.manifest.extensionPack)for(const k of j.manifest.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(O=>u.areSameExtensions({id:O},{id:k}))||B.every(O=>!u.areSameExtensions({id:O},{id:k}))&&B.push(k);if(B.length){const k=await this.getInstalled(),O=B.filter(F=>k.every(({identifier:z})=>!u.areSameExtensions(z,{id:F})));if(O.length){const z=(await this.galleryService.query({names:O,pageSize:B.length},d.CancellationToken.None)).firstPage;try{await Promise.all(z.map(G=>this.installFromGallery(G,J)))}catch(G){try{await this.rollback(z)}catch(Y){}throw G}}}}}async rollback(j){const J=(await this.getInstalled(1)).filter(B=>j.some(k=>new u.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version).equals(new u.ExtensionIdentifierWithVersion(k.identifier,k.version))));await Promise.all(J.map(B=>this.uninstall(B)))}async uninstall(j,$={}){this.logService.trace("ExtensionManagementService#uninstall",j.identifier.id);const J=await this.getInstalled(1),B=J.find(k=>u.areSameExtensions(k.identifier,j.identifier));if(!B)throw new Error(h.localize(11,null,j.manifest.displayName||j.manifest.name));try{await this.checkForDependenciesAndUninstall(B,J,$)}catch(k){throw this.joinErrors(k)}}async updateMetadata(j,$){return this.logService.trace("ExtensionManagementService#updateMetadata",j.identifier.id),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,Object.assign(Object.assign({},j.manifest.__metadata||{}),$)),this.manifestCache.invalidate(),j}async updateExtensionScope(j,$){return this.logService.trace("ExtensionManagementService#updateExtensionScope",j.identifier.id),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,Object.assign(Object.assign({},j.manifest.__metadata||{}),{isMachineScoped:$})),this.manifestCache.invalidate(),j}async getGalleryMetadata(j){const $=await this.findGalleryExtensionByName(j);return $?{id:$.identifier.uuid,publisherDisplayName:$.publisherDisplayName,publisherId:$.publisherId}:void 0}async findGalleryExtension(j){if(j.identifier.uuid){const $=await this.findGalleryExtensionById(j.identifier.uuid);return $||this.findGalleryExtensionByName(j.identifier.id)}return this.findGalleryExtensionByName(j.identifier.id)}async findGalleryExtensionById(j){return(await this.galleryService.query({ids:[j],pageSize:1},d.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(j){return(await this.galleryService.query({names:[j],pageSize:1},d.CancellationToken.None)).firstPage[0]}joinErrors(j){const $=Array.isArray(j)?j:[j];return $.length===1?$[0]instanceof Error?$[0]:new Error($[0]):$.reduce((J,B)=>new Error(`${J.message}${J.message?",":""}${B instanceof Error?B.message:B}`),new Error(""))}async checkForDependenciesAndUninstall(j,$,J){try{await this.preUninstallExtension(j);const B=J.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(j,$);await this.uninstallExtensions(j,B,$,J)}catch(B){throw await this.postUninstallExtension(j,new f.ExtensionManagementError(B instanceof Error?B.message:B,M)),B}await this.postUninstallExtension(j)}async uninstallExtensions(j,$,J,B){const k=[j,...$];if(!B.donotCheckDependents)for(const O of k)this.checkForDependents(O,k,J,j);await Promise.all([this.uninstallExtension(j),...$.map(O=>this.doUninstall(O))])}checkForDependents(j,$,J,B){const k=this.getDependents(j,J);if(k.length){const O=k.filter(F=>$.indexOf(F)===-1);if(O.length)throw new Error(this.getDependentsErrorMessage(j,O,B))}}getDependentsErrorMessage(j,$,J){return J===j?$.length===1?h.localize(12,null,J.manifest.displayName||J.manifest.name,$[0].manifest.displayName||$[0].manifest.name):$.length===2?h.localize(13,null,J.manifest.displayName||J.manifest.name,$[0].manifest.displayName||$[0].manifest.name,$[1].manifest.displayName||$[1].manifest.name):h.localize(14,null,J.manifest.displayName||J.manifest.name,$[0].manifest.displayName||$[0].manifest.name,$[1].manifest.displayName||$[1].manifest.name):$.length===1?h.localize(15,null,J.manifest.displayName||J.manifest.name,j.manifest.displayName||j.manifest.name,$[0].manifest.displayName||$[0].manifest.name):$.length===2?h.localize(16,null,J.manifest.displayName||J.manifest.name,j.manifest.displayName||j.manifest.name,$[0].manifest.displayName||$[0].manifest.name,$[1].manifest.displayName||$[1].manifest.name):h.localize(17,null,J.manifest.displayName||J.manifest.name,j.manifest.displayName||j.manifest.name,$[0].manifest.displayName||$[0].manifest.name,$[1].manifest.displayName||$[1].manifest.name)}getAllPackExtensionsToUninstall(j,$,J=[]){if(J.indexOf(j)!==-1)return[];J.push(j);const B=j.manifest.extensionPack?j.manifest.extensionPack:[];if(B.length){const k=$.filter(F=>!F.isBuiltin&&B.some(z=>u.areSameExtensions({id:z},F.identifier))),O=[];for(const F of k)O.push(...this.getAllPackExtensionsToUninstall(F,$,J));return[...k,...O]}return[]}getDependents(j,$){return $.filter(J=>J.manifest.extensionDependencies&&J.manifest.extensionDependencies.some(B=>u.areSameExtensions({id:B},j.identifier)))}async doUninstall(j){try{await this.preUninstallExtension(j),await this.uninstallExtension(j)}catch($){throw await this.postUninstallExtension(j,new f.ExtensionManagementError($ instanceof Error?$.message:$,M)),$}await this.postUninstallExtension(j)}async preUninstallExtension(j){if(!await b.exists(j.location.fsPath))throw new Error(h.localize(18,null));this.logService.info("Uninstalling extension:",j.identifier.id),this._onUninstallExtension.fire(j.identifier)}async uninstallExtension(j){let $=this.uninstallingExtensions.get(j.identifier.id);return $||($=g.createCancelablePromise(async()=>{const J=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...J.filter(B=>u.areSameExtensions(B.identifier,j.identifier)))}),this.uninstallingExtensions.set(j.identifier.id,$),$.finally(()=>this.uninstallingExtensions.delete(j.identifier.id))),$}async postUninstallExtension(j,$){if($)this.logService.error("Failed to uninstall extension:",j.identifier.id,$.message);else if(this.logService.info("Successfully uninstalled extension:",j.identifier.id),j.identifier.uuid)try{await this.galleryService.reportStatistic(j.manifest.publisher,j.manifest.name,j.manifest.version,"uninstall")}catch(B){}this.reportTelemetry("extensionGallery:uninstall",u.getLocalExtensionTelemetryData(j),void 0,$);const J=$?$ instanceof f.ExtensionManagementError?$.code:W:void 0;this._onDidUninstallExtension.fire({identifier:j.identifier,error:J})}getInstalled(j=null){return this.extensionsScanner.scanExtensions(j)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(j){return(await this.filterUninstalled(j)).length===1}filterUninstalled(...j){return this.extensionsScanner.withUninstalledExtensions($=>{const J=[];for(const B of j)$[B.key()]&&J.push(B.key());return J})}setUninstalled(...j){const $=j.map(J=>new u.ExtensionIdentifierWithVersion(J.identifier,J.manifest.version));return this.extensionsScanner.withUninstalledExtensions(J=>($.forEach(B=>J[B.key()]=!0),J))}unsetUninstalled(j){return this.extensionsScanner.withUninstalledExtensions($=>delete $[j.key()])}getExtensionsReport(){const j=new Date().getTime();return(!this.reportedExtensions||j-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=j),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const j=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${j.length} reported extensions from service`),j}catch(j){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(j,$,J,B){const k=B?B instanceof f.ExtensionManagementError?B.code:W:void 0;this.telemetryService.publicLogError(j,Object.assign(Object.assign({},$),{success:!B,duration:J,errorcode:k}))}};N=Se([we(0,P.INativeEnvironmentService),we(1,f.IExtensionGalleryService),we(2,w.ILogService),we(3,l.optional(i.IDownloadService)),we(4,r.ITelemetryService),we(5,l.IInstantiationService)],N),e.ExtensionManagementService=N}),define(x[194],ee([0,1,21,43,207,37,12,49,131,28]),function(H,e,h,T,b,_,L,C,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enableCustomMarketplace=e.buffer=e.extract=e.tar=void 0;const P=C.extract,g=C.buffer,p=async(a,r)=>{const s=b.pack(),t=[],o=new Promise(i=>{s.on("end",()=>i(Buffer.concat(t)))});s.on("data",i=>t.push(i));for(let i=0;i<r.length;i++){const l=r[i];s.entry({name:l.path},l.contents)}return s.finalize(),await _.promisify(h.writeFile)(a,await o),a};e.tar=p;const v=async(a,r,s={},t)=>{try{await w(a,r,s,t)}catch(o){o.toString().includes("Invalid tar header")&&await P(a,r,s,t)}};e.extract=v;const c=(a,r)=>new Promise(async(s,t)=>{try{let o=!1;if(await E(a,new RegExp(r),(i,l)=>{T.normalize(i)===T.normalize(r)&&(o=!0,s(l))}),!o)throw new Error("couldn't find asset "+r)}catch(o){o.toString().includes("Invalid tar header")?g(a,r).then(s).catch(t):t(o)}});e.buffer=c;const E=async(a,r,s)=>new Promise((t,o)=>{const i=b.extract(),l=n=>{i.destroy(),o(n)};i.once("error",l),i.on("entry",async(n,d,I)=>{const R=n.name;r.test(R)?S(d).then(D=>{s(R,D),I()}).catch(l):(d.on("end",()=>I()),d.resume())}),i.on("finish",t),h.createReadStream(a).pipe(i)}),S=a=>new Promise((r,s)=>{const t=[];a.on("error",s),a.on("end",()=>r(Buffer.concat(t))),a.on("data",o=>t.push(o))}),w=async(a,r,s={},t)=>new Promise((o,i)=>{const l=new RegExp(s.sourcePath?`^${s.sourcePath}`:""),n=b.extract(),d=I=>{n.destroy(),i(I)};n.once("error",d),n.on("entry",async(I,R,D)=>{const m=()=>{R.on("end",()=>D()),R.resume()},A=T.normalize(I.name);if(t.isCancellationRequested||!l.test(A))return m();const U=A.replace(l,""),q=T.join(r,U);if(/\/$/.test(U))return L.mkdirp(q).then(m);const M=T.dirname(U),W=T.join(r,M);if(W.indexOf(r)!==0)return d(new Error(f.localize(0,null,U)));await L.mkdirp(W,void 0);const N=h.createWriteStream(q,{mode:I.mode});N.once("close",()=>D()),N.once("error",d),R.pipe(N)}),n.once("finish",o),h.createReadStream(a).pipe(n)}),y=()=>{u.default.extensionsGallery=Object.assign({serviceUrl:process.env.SERVICE_URL||"https://extensions.coder.com/api",itemUrl:process.env.ITEM_URL||"",controlUrl:"",recommendationsUrl:""},u.default.extensionsGallery||{});const a=C;a.zip=e.tar,a.extract=e.extract,a.buffer=e.buffer};e.enableCustomMarketplace=y}),define(x[59],ee([0,1,154,208,195,5,36,3,22,26,2,17,67,14,4]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class E{constructor(I){this.socket=I}dispose(){this.socket.destroy()}onData(I){const R=D=>I(g.VSBuffer.wrap(D));return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(I){return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(I){return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(I){if(!this.socket.destroyed)try{this.socket.write(I.buffer)}catch(R){if(R.code==="EPIPE")return;v.onUnexpectedError(R)}}end(){this.socket.end()}drain(){return new Promise((I,R)=>{if(this.socket.bufferSize===0){I();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),I()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=E;var S;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var w;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(w||(w={}));class y extends P.Disposable{constructor(I,R,D,m){super();this._onDidZlibFlush=this._register(new _.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new _.Emitter),this._onClose=this._register(new _.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=I,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=R,this._recordInflateBytes=m,R?(this._zlibInflate=b.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),v.onUnexpectedError(A),this._onClose.fire()}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),D&&(this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=b.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),v.onUnexpectedError(A),this._onClose.fire()}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?g.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):g.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._totalOutgoingDataBytes+=I.byteLength,this._zlibDeflate?(this._zlibDeflate.write(I.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let R=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,R=R.slice(0,R.length-4),this._isEnded||this._write(g.VSBuffer.wrap(R),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(I,!1)}_write(I,R){let D=2;I.byteLength<126?D+=0:I.byteLength<2**16?D+=2:D+=8;const m=g.VSBuffer.alloc(D);if(R?m.writeUInt8(194,0):m.writeUInt8(130,0),I.byteLength<126)m.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){m.writeUInt8(126,1);let A=1;m.writeUInt8(I.byteLength>>>8&255,++A),m.writeUInt8(I.byteLength>>>0&255,++A)}else{m.writeUInt8(127,1);let A=1;m.writeUInt8(0,++A),m.writeUInt8(0,++A),m.writeUInt8(0,++A),m.writeUInt8(0,++A),m.writeUInt8(I.byteLength>>>24&255,++A),m.writeUInt8(I.byteLength>>>16&255,++A),m.writeUInt8(I.byteLength>>>8&255,++A),m.writeUInt8(I.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=m.byteLength+I.byteLength,this.socket.write(g.VSBuffer.concat([m,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._totalIncomingWireBytes+=I.byteLength,this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const R=this._incomingData.peek(this._state.readLen),m=(R.readUInt8(0)&128)>>>7,A=R.readUInt8(1),U=(A&128)>>>7,q=A&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=m,this._state.mask=0}else if(this._state.state===2){const R=this._incomingData.read(this._state.readLen),D=R.readUInt8(1),m=(D&128)>>>7;let A=D&127,U=1;A===126?A=R.readUInt8(++U)*2**8+R.readUInt8(++U):A===127&&(A=R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U));let q=0;m&&(q=R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U)),this._state.state=3,this._state.readLen=A,this._state.mask=q}else if(this._state.state===3){const R=this._incomingData.read(this._state.readLen);a(R,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(R.buffer)),this._zlibInflate.write(R.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const D=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=D.length,this._onData.fire(g.VSBuffer.wrap(D))})):(this._totalIncomingDataBytes+=R.byteLength,this._onData.fire(R))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await _.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=y;function a(d,I){if(I!==0){let R=d.byteLength>>>2;for(let M=0;M<R;M++){const W=d.readUInt32BE(M*4);d.writeUInt32BE(W^I,M*4)}let D=R*4,m=d.byteLength-D;const A=I>>>24&255,U=I>>>16&255,q=I>>>8&255;m>=1&&d.writeUInt8(d.readUInt8(D)^A,D),m>=2&&d.writeUInt8(d.readUInt8(D+1)^U,D+1),m>=3&&d.writeUInt8(d.readUInt8(D+2)^q,D+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function s(){const d=u.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let I;return e.XDG_RUNTIME_DIR?I=C.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):I=C.join(f.tmpdir(),`vscode-ipc-${d}.sock`),o(I),I}e.createRandomIPCHandle=s;function t(d,I,R){const D=h.createHash("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${R}-${I}-sock`;let m;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?m=C.join(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${R}-${I}.sock`):m=C.join(d,`${R}-${I}.sock`),o(m),m}e.createStaticIPCHandle=t;function o(d){const I=r[c.platform];typeof I=="number"&&d.length>=I&&console.warn(`WARNING: IPC handle "${d}" is longer than ${I} chars, try a shorter --user-data-dir`)}class i extends L.IPCServer{constructor(I){super(i.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const R=_.Event.fromNodeEventEmitter(I,"connection");return _.Event.map(R,D=>({protocol:new p.Protocol(new E(D)),onDidClientDisconnect:_.Event.once(_.Event.fromNodeEventEmitter(D,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function l(d){return new Promise((I,R)=>{const D=T.createServer();D.on("error",R),D.listen(d,()=>{D.removeListener("error",R),I(new i(D))})})}e.serve=l;function n(d,I){return new Promise((R,D)=>{const m=T.createConnection(d,()=>{m.removeListener("error",D),R(p.Client.fromSocket(new E(m),I))});m.once("error",D)})}e.connect=n}),define(x[88],ee([0,1,22,104,3,20,91,28,111,10,7,59]),function(H,e,h,T,b,_,L,C,f,u,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataDir=e.parsePathArg=e.parseSearchPort=e.parseExtensionHostPort=e.NativeEnvironmentService=void 0;class p{constructor(a){if(this._args=a,!a.logsPath){const r=f.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");a.logsPath=b.join(this.userDataPath,"logs",r)}this.logsPath=a.logsPath}get args(){return this._args}get appRoot(){return b.dirname(u.FileAccess.asFileUri("",H).fsPath)}get userHome(){return P.URI.file(h.homedir())}get userDataPath(){const a=process.env.VSCODE_PORTABLE;return a?b.join(a,"user-data"):w(this._args,process)}get appSettingsHome(){return P.URI.file(b.join(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(h.tmpdir())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return _.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return _.joinPath(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return P.URI.file(b.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return _.joinPath(P.URI.file(b.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return P.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return P.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return _.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return _.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=process.env.VSCODE_PORTABLE;return a?P.URI.file(b.join(a,"argv.json")):_.joinPath(this.userHome,C.default.dataFolderName,"argv.json")}get snippetsHome(){return _.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file(b.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return b.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const a=S(this._args["builtin-extensions-dir"],process);return a||b.normalize(b.join(u.FileAccess.asFileUri("",H).fsPath,"..","extensions"))}get extensionsDownloadPath(){const a=S(this._args["extensions-download-dir"],process);return a||b.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const a=S(this._args["extensions-dir"],process);if(a)return a;const r=process.env.VSCODE_EXTENSIONS;if(r)return r;const s=process.env.VSCODE_PORTABLE;return s?b.join(s,"extensions"):_.joinPath(this.userHome,C.default.dataFolderName,"extensions").fsPath}get extraExtensionPaths(){return(this._args["extra-extensions-dir"]||[]).map(a=>S(a,process))}get extraBuiltinExtensionPaths(){return(this._args["extra-builtin-extensions-dir"]||[]).map(a=>S(a,process))}get extensionDevelopmentLocationURI(){const a=this._args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(r=>/^[^:/?#]+?:\/\//.test(r)?P.URI.parse(r):P.URI.file(b.normalize(r)))}get extensionTestsLocationURI(){const a=this._args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?P.URI.parse(a):P.URI.file(b.normalize(a))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const a=this._args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return v(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get sharedIPCHandle(){return g.createStaticIPCHandle(this.userDataPath,"shared",C.default.version)}get serviceMachineIdResource(){return _.joinPath(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return P.URI.file(b.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}Se([L.memoize],p.prototype,"appRoot",null),Se([L.memoize],p.prototype,"userHome",null),Se([L.memoize],p.prototype,"userDataPath",null),Se([L.memoize],p.prototype,"appSettingsHome",null),Se([L.memoize],p.prototype,"tmpDir",null),Se([L.memoize],p.prototype,"userRoamingDataHome",null),Se([L.memoize],p.prototype,"settingsResource",null),Se([L.memoize],p.prototype,"userDataSyncHome",null),Se([L.memoize],p.prototype,"userDataSyncLogResource",null),Se([L.memoize],p.prototype,"sync",null),Se([L.memoize],p.prototype,"machineSettingsResource",null),Se([L.memoize],p.prototype,"globalStorageHome",null),Se([L.memoize],p.prototype,"workspaceStorageHome",null),Se([L.memoize],p.prototype,"keybindingsResource",null),Se([L.memoize],p.prototype,"keyboardLayoutResource",null),Se([L.memoize],p.prototype,"argvResource",null),Se([L.memoize],p.prototype,"snippetsHome",null),Se([L.memoize],p.prototype,"isExtensionDevelopment",null),Se([L.memoize],p.prototype,"untitledWorkspacesHome",null),Se([L.memoize],p.prototype,"installSourcePath",null),Se([L.memoize],p.prototype,"builtinExtensionsPath",null),Se([L.memoize],p.prototype,"extensionsPath",null),Se([L.memoize],p.prototype,"extraExtensionPaths",null),Se([L.memoize],p.prototype,"extraBuiltinExtensionPaths",null),Se([L.memoize],p.prototype,"extensionDevelopmentLocationURI",null),Se([L.memoize],p.prototype,"extensionTestsLocationURI",null),Se([L.memoize],p.prototype,"debugExtensionHost",null),Se([L.memoize],p.prototype,"sharedIPCHandle",null),Se([L.memoize],p.prototype,"serviceMachineIdResource",null),Se([L.memoize],p.prototype,"telemetryLogResource",null),e.NativeEnvironmentService=p;function v(y,a){return E(y["inspect-extensions"],y["inspect-brk-extensions"],5870,a,y.debugId)}e.parseExtensionHostPort=v;function c(y,a){return E(y["inspect-search"],y["inspect-brk-search"],5876,a)}e.parseSearchPort=c;function E(y,a,r,s,t){const i=Number(a||y)||(s?null:r),l=i?Boolean(!!a):!1;return{port:i,break:l,debugId:t}}function S(y,a){if(!!y){const r=b.resolve(y);return b.normalize(y)===r?r:b.resolve(a.env.VSCODE_CWD||a.cwd(),y)}}e.parsePathArg=S;function w(y,a){return S(y["user-data-dir"],a)||b.resolve(T.getDefaultUserDataPath())}e.parseUserDataDir=w}),define(x[89],ee([0,1,195,165,2,11,14,164,32,13,17]),function(H,e,h,T,b,_,L,C,f,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let g=class extends b.Disposable{constructor(v,c){super();this.logService=c,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,c){this.logService.trace("RequestService#request",v.url);const{proxyUrl:E,strictSSL:S}=this,w=v.agent?v.agent:await C.getProxyAgent(v.url||"",{proxyUrl:E,strictSSL:S});return v.agent=w,v.strictSSL=S,this.authorization&&(v.headers=Object.assign(Object.assign({},v.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(v,c)}async getNodeRequest(v){return(T.parse(v.url).protocol==="https:"?await new Promise((S,w)=>{H(["https"],S,w)}):await new Promise((S,w)=>{H(["http"],S,w)})).request}_request(v,c){return new Promise(async(E,S)=>{let w;const y=T.parse(v.url),a=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),r={hostname:y.hostname,port:y.port?parseInt(y.port):y.protocol==="https:"?443:80,protocol:y.protocol,path:y.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:_.isBoolean(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(r.auth=v.user+":"+v.password),w=a(r,s=>{const t=_.isNumber(v.followRedirects)?v.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&t>0&&s.headers.location)this._request(Object.assign(Object.assign({},v),{url:s.headers.location,followRedirects:t-1}),c).then(E,S);else{let o=s;s.headers["content-encoding"]==="gzip"&&(o=s.pipe(h.createGunzip())),E({res:s,stream:P.streamToBufferReadableStream(o)})}}),w.on("error",S),v.timeout&&w.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&w.write(v.data),w.end(),c.onCancellationRequested(()=>{w.abort(),S(L.canceled())})})}async resolveProxy(v){}};g=Se([we(0,f.IConfigurationService),we(1,u.ILogService)],g),e.RequestService=g}),define(x[196],ee([0,1,22,21,209,3,15,28,53,52,73,23,88,27,87,78,47,48,79,77,56,89,32,76,80,12,167,168,13,10,55,173,74,24,54,2,46,151,7,75,44,14,38]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c,E,S,w,y,a,r,s,t,o,i,l,n,d,I,R,D,m,A,U,q,M,W,N,K,j,$,J,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class k extends M.Disposable{constructor(z){super();this.argv=z,b.gracefulify(T),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[z,G]=await this.initServices();return z.invokeFunction(async Y=>{const Q=Y.get(I.ILogService),Z=Y.get(g.INativeEnvironmentService),se=Y.get(v.IExtensionManagementCLIService);return Q.info("CLI main",this.argv),this.registerErrorHandler(Q),await this.doRun(Z,se),L.raceTimeout(w.combinedAppender(...G).flush(),1e3)})}async initServices(){const z=new f.ServiceCollection,G=new p.NativeEnvironmentService(this.argv);z.set(g.IEnvironmentService,G),z.set(g.INativeEnvironmentService,G),await Promise.all([G.appSettingsHome.fsPath,G.extensionsPath].map(de=>de?l.mkdirp(de):void 0));const Y=I.getLogLevel(G),Q=[];Q.push(new D.SpdLogService("cli",G.logsPath,Y)),Y===I.LogLevel.Trace&&Q.push(new I.ConsoleLogService(Y));const Z=this._register(new I.MultiplexLogService(Q));z.set(I.ILogService,Z);const se=this._register(new A.FileService(Z));z.set(U.IFileService,se);const le=this._register(new q.DiskFileSystemProvider(Z));se.registerProvider(R.Schemas.file,le);const fe=this._register(new o.ConfigurationService(G.settingsResource,se));z.set(t.IConfigurationService,fe),await fe.initialize();const ie=new d.StateService(G,Z);z.set(n.IStateService,ie),z.set(W.IProductService,Object.assign({_serviceBrand:void 0},C.default));const{appRoot:ae,extensionsPath:ue,extensionDevelopmentLocationURI:ye,isBuilt:Ce,installSourcePath:Le}=G;z.set(r.IRequestService,new u.SyncDescriptor(s.RequestService)),z.set(v.IExtensionManagementService,new u.SyncDescriptor(c.ExtensionManagementService)),z.set(v.IExtensionGalleryService,new u.SyncDescriptor(E.ExtensionGalleryService)),z.set(v.IExtensionManagementCLIService,new u.SyncDescriptor(N.ExtensionManagementCLIService)),z.set($.ILocalizationsService,new u.SyncDescriptor(j.LocalizationsService));const me=[];if(Ce&&!ye&&!G.disableTelemetry&&C.default.enableTelemetry){C.default.aiConfig&&C.default.aiConfig.asimovKey&&me.push(new i.AppInsightsAppender("monacoworkbench",null,C.default.aiConfig.asimovKey));const de={appender:w.combinedAppender(...me),sendErrorTelemetry:!1,commonProperties:a.resolveCommonProperties(se,h.release(),process.arch,C.default.commit,C.default.version,ie.getItem("telemetry.machineId"),C.default.msftInternalDomains,Le),piiPaths:[ae,ue]};z.set(S.ITelemetryService,new u.SyncDescriptor(y.TelemetryService,[de]))}else z.set(S.ITelemetryService,w.NullTelemetryService);return[new P.InstantiationService(z),me]}registerErrorHandler(z){J.setUnexpectedErrorHandler(G=>{const Y=B.toErrorMessage(G,!0);!Y||z.error(`[uncaught exception in CLI]: ${Y}`)})}async doRun(z,G){if(this.argv["install-source"])return this.setInstallSource(z,this.argv["install-source"]);if(this.argv["list-extensions"])return G.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return G.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return G.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return G.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(m.buildTelemetryMessage(z.appRoot,z.extensionsPath))}asExtensionIdOrVSIX(z){return z.map(G=>/\.vsix$/i.test(G)?K.URI.file(_.isAbsolute(G)?G:_.join(process.cwd(),G)):G)}setInstallSource(z,G){return l.writeFile(z.installSourcePath,G.slice(0,30))}}async function O(F){const z=new k(F);try{await z.run()}finally{z.dispose()}}e.main=O}),define(x[197],ee([0,1,35,39,5,10,59,58]),function(H,e,h,T,b,_,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.ManagementConnection=e.Connection=void 0;class f{constructor(p,v){this.protocol=p,this.token=v,this._onClose=new b.Emitter,this.onClose=this._onClose.event,this.disposed=!1}get offline(){return this._offline}reconnect(p,v){this._offline=void 0,this.doReconnect(p,v)}dispose(){this.disposed||(this.disposed=!0,this.doDispose(),this._onClose.fire())}setOffline(){this._offline||(this._offline=Date.now())}}e.Connection=f;class u extends f{constructor(p,v){super(p,v);this.protocol=p,p.onDidDispose(()=>this.dispose()),p.onSocketClose(()=>this.setOffline())}doDispose(){this.protocol.sendDisconnect(),this.protocol.dispose(),this.protocol.getUnderlyingSocket().destroy()}doReconnect(p,v){this.protocol.beginAcceptReconnection(p,v),this.protocol.endAcceptReconnection()}}e.ManagementConnection=u;class P extends f{constructor(p,v,c,E,S){super(v,E);this.environment=S,this.logger=h.logger.named("exthost",h.field("token",E)),this.protocol.dispose(),this.spawn(p,c).then(w=>this.process=w),this.protocol.getUnderlyingSocket().pause()}doDispose(){this.process&&this.process.kill(),this.protocol.getUnderlyingSocket().destroy()}doReconnect(p,v){this.protocol.beginAcceptReconnection(p,null),this.protocol.dispose(),this.sendInitMessage(v)}sendInitMessage(p){const v=this.protocol.getUnderlyingSocket();v.pause();const c=this.protocol.getSocket();this.logger.trace("Sending socket"),this.process.send({type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:Buffer.from(p.buffer).toString("base64"),skipWebSocketFrames:!(c instanceof L.WebSocketNodeSocket),permessageDeflate:this.protocol.options.permessageDeflate,inflateBytes:c instanceof L.WebSocketNodeSocket?Buffer.from(c.recordedInflateBytes.buffer).toString("base64"):void 0},v)}async spawn(p,v){this.logger.trace("Getting NLS configuration...");const c=await C.getNlsConfiguration(p,this.environment.userDataPath);this.logger.trace("Spawning extension host...");const E=T.fork(_.FileAccess.asFileUri("bootstrap-fork",H).fsPath,["--type=extensionHost"],{env:Object.assign(Object.assign({},process.env),{VSCODE_AMD_ENTRYPOINT:"vs/workbench/services/extensions/node/extensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_LOG_LEVEL:process.env.LOG_LEVEL,VSCODE_NLS_CONFIG:JSON.stringify(c),VSCODE_PARENT_PID:String(process.pid)}),silent:!0});return E.on("error",S=>{this.logger.error("Exited unexpectedly",h.field("error",S)),this.dispose()}),E.on("exit",S=>{this.logger.trace("Exited",h.field("code",S)),this.dispose()}),E.stdout&&E.stderr&&(E.stdout.setEncoding("utf8").on("data",S=>this.logger.info(S)),E.stderr.setEncoding("utf8").on("data",S=>this.logger.error(S))),E.on("message",S=>{switch(S.type){case"__$console":const w=this.logger[S.severity==="log"?"info":S.severity];w?w.bind(this.logger)("console",h.field("arguments",S.arguments)):this.logger.error("Unexpected severity",h.field("event",S));break;case"VSCODE_EXTHOST_DISCONNECTED":this.logger.trace("Going offline"),this.setOffline();break;case"VSCODE_EXTHOST_IPC_READY":this.logger.trace("Got ready message"),this.sendInitMessage(v);break;default:this.logger.error("Unexpected message",h.field("event",S));break}}),this.logger.trace("Waiting for handshake..."),E}}e.ExtensionHostConnection=P}),define(x[198],ee([0,1,35,17,67,59,57]),function(H,e,h,T,b,_,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class C extends b.PersistentProtocol{constructor(u,P){super(P.skipWebSocketFrames?new _.NodeSocket(u):new _.WebSocketNodeSocket(new _.NodeSocket(u),P.permessageDeflate||!1,P.inflateBytes||null,P.recordInflateBytes||!1));this.options=P}getUnderlyingSocket(){const u=this.getSocket();return u instanceof _.NodeSocket?u.socket:u.socket.socket}handshake(){return L.logger.trace("Protocol handshake",h.field("token",this.options.reconnectionToken)),new Promise((u,P)=>{const g=setTimeout(()=>{L.logger.error("Handshake timed out",h.field("token",this.options.reconnectionToken)),P(new Error("timed out"))},1e4),p=this.onControlMessage(v=>{try{const c=v.toString();L.logger.trace("Protocol message",h.field("token",this.options.reconnectionToken),h.field("message",c));const E=JSON.parse(c);switch(E.type){case"auth":return this.authenticate(E);case"connectionType":return p.dispose(),clearTimeout(g),u(E);default:throw new Error("Unrecognized message type")}}catch(c){p.dispose(),clearTimeout(g),P(c)}});this.authenticate()})}authenticate(u){this.sendMessage({type:"sign",data:""})}tunnel(){throw new Error("Tunnel is not implemented yet")}sendMessage(u){this.sendControl(T.VSBuffer.fromString(JSON.stringify(u)))}}e.Protocol=C}),define(x[199],ee([0,1,35,22,21,43,5,10,7,103,36,147,196,32,76,138,23,88,78,27,139,87,24,74,54,52,73,53,44,75,13,157,158,55,28,46,56,163,89,171,47,172,79,48,80,77,175,189,197,176,57,58,198,81,186,190,191,132]),function(H,e,h,T,b,_,L,C,f,u,P,g,p,v,c,E,S,w,y,a,r,s,t,o,i,l,n,d,I,R,D,m,A,U,q,M,W,N,K,j,$,J,B,k,O,F,z,G,Y,Q,Z,se,le,fe,ie,ae,ue,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Vscode=void 0;class Ce{constructor(){this._onDidClientConnect=new L.Emitter,this.onDidClientConnect=this._onDidClientConnect.event,this.ipc=new P.IPCServer(this.onDidClientConnect),this.maxExtraOfflineConnections=0,this.connections=new Map,this.services=new d.ServiceCollection}async cli(me){return p.main(me)}async initialize(me){const de=fe.getUriTransformer(me.remoteAuthority);this.servicesPromise||(this.servicesPromise=this.initializeServices(me.args)),await this.servicesPromise;const Ee=this.services.get(S.IEnvironmentService),be=me.startPath,Re=Me=>{try{return f.URI.parse(Me,!0)}catch(Ue){return f.URI.from({scheme:C.Schemas.vscodeRemote,authority:me.remoteAuthority,path:Me})}};return{workbenchWebConfiguration:{workspaceUri:be&&be.workspace?Re(be.url):void 0,folderUri:be&&!be.workspace?Re(be.url):void 0,remoteAuthority:me.remoteAuthority,logLevel:D.getLogLevel(Ee),workspaceProvider:{payload:[["userDataPath",Ee.userDataPath],["enableProposedApi",JSON.stringify(me.args["enable-proposed-api"]||[])]]},homeIndicator:me.args.home?{href:me.args.home,icon:"code",title:ye.localize(0,null)}:void 0},remoteUserDataUri:de.transformOutgoing(f.URI.file(Ee.userDataPath)),productConfiguration:q.default,nlsConfiguration:await se.getNlsConfiguration(Ee.args.locale||await se.getLocaleFromConfig(Ee.userDataPath),Ee.userDataPath),commit:q.default.commit||"development"}}async handleWebSocket(me,de,Ee){if(!de.reconnectionToken)throw new Error("Reconnection token is missing from query parameters");const be=new le.Protocol(me,{reconnectionToken:de.reconnectionToken,reconnection:de.reconnection==="true",skipWebSocketFrames:de.skipWebSocketFrames==="true"});try{await this.connect(await be.handshake(),be)}catch(Re){be.sendMessage({type:"error",reason:Re.message}),be.dispose(),be.getSocket().dispose()}return!0}async connect(me,de){switch(q.default.commit&&me.commit!==q.default.commit&&Z.logger.warn(`Version mismatch (${me.commit} instead of ${q.default.commit})`),me.desiredConnectionType){case 2:case 1:this.connections.has(me.desiredConnectionType)||this.connections.set(me.desiredConnectionType,new Map);const Ee=this.connections.get(me.desiredConnectionType),be=async()=>me.desiredConnectionType===2?{debugPort:await this.getDebugPort()}:{type:"ok"},Re=de.options.reconnectionToken;if(de.options.reconnection&&Ee.has(Re)){de.sendMessage(await be());const Ue=de.readEntireBuffer();return de.dispose(),Ee.get(Re).reconnect(de.getSocket(),Ue)}else if(de.options.reconnection||Ee.has(Re))throw new Error(de.options.reconnection?"Unrecognized reconnection token":"Duplicate reconnection token");Z.logger.debug("New connection",h.field("token",Re)),de.sendMessage(await be());let Me;if(me.desiredConnectionType===1)Me=new Y.ManagementConnection(de,Re),this._onDidClientConnect.fire({protocol:de,onDidClientDisconnect:Me.onClose});else{const Ue=de.readEntireBuffer();Me=new Y.ExtensionHostConnection(me.args?me.args.language:"en",de,Ue,Re,this.services.get(S.IEnvironmentService))}Ee.set(Re,Me),Me.onClose(()=>{Z.logger.debug("Connection closed",h.field("token",Re)),Ee.delete(Re)}),this.disposeOldOfflineConnections(Ee);break;case 3:return de.tunnel();default:throw new Error("Unrecognized connection type")}}disposeOldOfflineConnections(me){const de=Array.from(me.values()).filter(Ee=>typeof Ee.offline!="undefined");for(let Ee=0,be=de.length-this.maxExtraOfflineConnections;Ee<be;++Ee)Z.logger.debug("Disposing offline connection",h.field("token",de[Ee].token)),de[Ee].dispose()}async initializeServices(me){const de=new w.NativeEnvironmentService(me);b.mkdirSync(de.globalStorageHome.fsPath,{recursive:!0});const Ee=new U.SpdLogService(ue.RemoteExtensionLogFileName,de.logsPath,D.getLogLevel(de)),be=new o.FileService(Ee);be.registerProvider(C.Schemas.file,new i.DiskFileSystemProvider(Ee));const Re=[_.join(de.userDataPath,"clp"),de.appRoot,de.extensionsPath,de.builtinExtensionsPath,...de.extraExtensionPaths,...de.extraBuiltinExtensionPaths];this.ipc.registerChannel("logger",new m.LoggerChannel(Ee)),this.ipc.registerChannel(E.ExtensionHostDebugBroadcastChannel.ChannelName,new E.ExtensionHostDebugBroadcastChannel),this.services.set(D.ILogService,Ee),this.services.set(S.IEnvironmentService,de),this.services.set(S.INativeEnvironmentService,de),this.services.set(D.ILoggerService,new l.SyncDescriptor(A.LoggerService));const Me=new c.ConfigurationService(de.settingsResource,be);await Me.initialize(),this.services.set(v.IConfigurationService,Me),this.services.set(W.IRequestService,new l.SyncDescriptor(K.RequestService)),this.services.set(t.IFileService,be),this.services.set(M.IProductService,Object.assign({_serviceBrand:void 0},q.default));const Ue=await u.getMachineId();await new Promise(Be=>{const X=new n.InstantiationService(this.services);X.invokeFunction(ne=>{X.createInstance(g.LogsDataCleaner);let re;de.disableTelemetry?re=k.NullTelemetryService:re=new B.TelemetryService({appender:k.combinedAppender(new O.AppInsightsAppender("code-server",null,()=>new Q.TelemetryClient),new J.TelemetryLogAppender(ne.get(D.ILoggerService),de)),sendErrorTelemetry:!0,commonProperties:F.resolveCommonProperties(be,T.release(),process.arch,q.default.commit,q.default.version,Ue,[],de.installSourcePath,"code-server"),piiPaths:Re},Me),this.services.set($.ITelemetryService,re),this.services.set(a.IExtensionManagementService,new l.SyncDescriptor(s.ExtensionManagementService)),this.services.set(a.IExtensionGalleryService,new l.SyncDescriptor(y.ExtensionGalleryService)),this.services.set(I.ILocalizationsService,new l.SyncDescriptor(R.LocalizationsService)),this.ipc.registerChannel("extensions",new r.ExtensionManagementChannel(ne.get(a.IExtensionManagementService),ve=>fe.getUriTransformer(ve.remoteAuthority))),this.ipc.registerChannel("remoteextensionsenvironment",new G.ExtensionEnvironmentChannel(de,Ee,re,"")),this.ipc.registerChannel("request",new N.RequestChannel(ne.get(W.IRequestService))),this.ipc.registerChannel("telemetry",new z.TelemetryChannel(re)),this.ipc.registerChannel("localizations",P.createChannelReceiver(ne.get(I.ILocalizationsService))),this.ipc.registerChannel(ae.REMOTE_FILE_SYSTEM_CHANNEL_NAME,new G.FileProviderChannel(de,Ee)),this.ipc.registerChannel(ie.REMOTE_TERMINAL_CHANNEL_NAME,new G.TerminalProviderChannel(Ee)),Be(new j.default(re))})})}async getDebugPort(){}}e.Vscode=Ce}),define(x[210],ee([0,1,35,14,57,194,199,106]),function(H,e,h,T,b,_,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),T.setUnexpectedErrorHandler(g=>b.logger.warn(g instanceof Error?g.message:g)),_.enableCustomMarketplace(),C.monkeyPatch(!0);const f=process.exit;if(process.exit=function(g){b.logger.warn(`process.exit() was prevented: ${g||"unknown code"}.`)},typeof process.env.CODE_SERVER_PARENT_PID!="undefined"){const g=parseInt(process.env.CODE_SERVER_PARENT_PID,10);setInterval(()=>{try{process.kill(g,0)}catch(p){f()}},5e3)}else b.logger.error("no parent process"),f(1);const u=new L.Vscode,P=g=>{if(!process.send)throw new Error("not spawned with IPC");process.send(g)};process.on("message",async(g,p)=>{switch(b.logger.debug("got message from code-server",h.field("type",g.type)),b.logger.trace("code-server message content",h.field("message",g)),g.type){case"init":try{const v=await u.initialize(g.options);P({type:"options",id:g.id,options:v})}catch(v){b.logger.error(v.message),b.logger.error(v.stack),f(1)}break;case"cli":try{await u.cli(g.args),f(0)}catch(v){b.logger.error(v.message),b.logger.error(v.stack),f(1)}break;case"socket":u.handleWebSocket(p,g.query,g.permessageDeflate);break}}),process.send?P({type:"ready"}):(b.logger.error("not spawned with IPC"),f(1))})}).call(this);

//# sourceMappingURL=entry.js.map
