/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/path","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","os","child_process","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/codicons","vs/base/common/marshalling","util","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/hash","vs/base/common/severity","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/comparers","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/uriIpc","string_decoder","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogService","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/terminal/node/terminal","vs/workbench/contrib/terminal/node/terminalEnvironment","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/proxy_agent","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/terminal/common/terminal","vs/nls!vs/workbench/contrib/terminal/node/terminalProcess","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminal","vs/workbench/contrib/terminal/common/terminalDataBuffering","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProcess","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/node/outputAppender","vs/workbench/api/node/extHostOutputService","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","@coder/logger","proxy-agent","proxy-from-env","vs/base/common/marked/marked","https","tls","url","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(Z){for(var e=[],_=0,k=Z.length;_<k;_++)e[_]=ge[Z[_]];return e};define(ge[53],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(k,R){if(!k)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=_}),define(ge[54],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function k(C){const S=[];for(let v in C)_.call(C,v)&&S.push(C[v]);return S}e.values=k;function R(C,S){for(let v in C)if(_.call(C,v)&&S({key:v,value:C[v]},function(){delete C[v]})===!1)return}e.forEach=R;function T(C,S){const v=Object.create(null);for(const f of C){const u=S(f);let m=v[u];m||(m=v[u]=[]),m.push(f)}return v}e.groupBy=T;function P(C){const S=Object.create(null);return C&&C.forEach((v,f)=>{S[f]=v}),S}e.fromMap=P;function D(C,S){const v=[],f=[];for(let u of C)S.has(u)||v.push(u);for(let u of S)C.has(u)||f.push(u);return{removed:v,added:f}}e.diffSets=D;function I(C,S){const v=[],f=[];for(let[u,m]of C)S.has(u)||v.push(m);for(let[u,m]of S)C.has(u)||f.push(m);return{removed:v,added:f}}e.diffMaps=I;class n{constructor(){this.map=new Map}add(S,v){let f=this.map.get(S);f||(f=new Set,this.map.set(S,f)),f.add(v)}delete(S,v){const f=this.map.get(S);!f||(f.delete(v),f.size===0&&this.map.delete(S))}forEach(S,v){const f=this.map.get(S);!f||f.forEach(v)}}e.SetMap=n}),define(ge[55],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(I){return(n,C,S)=>{let v=null,f=null;if(typeof S.value=="function"?(v="value",f=S.value):typeof S.get=="function"&&(v="get",f=S.get),!f)throw new Error("not supported");S[v]=I(f,C)}}e.createDecorator=_;let k=0;function R(){const I=`$memoize${k++}`;let n;const C=function(v,f,u){let m=null,w=null;if(typeof u.value=="function"?(m="value",w=u.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(m="get",w=u.get),!w)throw new Error("not supported");const p=`${I}:${f}`;u[m]=function(...d){return n=this,this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!0,enumerable:!1,writable:!0,value:w.apply(this,d)}),this[p]}};return C.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(S=>{S.indexOf(I)===0&&delete n[S]})},C}e.createMemoizer=R;function T(I,n,C){return R()(I,n,C)}e.memoize=T;function P(I,n,C){return _((S,v)=>{const f=`$debounce$${v}`,u=`$debounce$result$${v}`;return function(...m){this[u]||(this[u]=C?C():void 0),clearTimeout(this[f]),n&&(this[u]=n(this[u],...m),m=[this[u]]),this[f]=setTimeout(()=>{S.apply(this,m),this[u]=C?C():void 0},I)}})}e.debounce=P;function D(I,n,C){return _((S,v)=>{const f=`$throttle$timer$${v}`,u=`$throttle$result$${v}`,m=`$throttle$lastRun$${v}`,w=`$throttle$pending$${v}`;return function(...p){if(this[u]||(this[u]=C?C():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),n&&(this[u]=n(this[u],...p)),!this[w]){const d=this[m]+I;d<=Date.now()?(this[m]=Date.now(),S.apply(this,[this[u]]),this[u]=C?C():void 0):(this[w]=!0,this[f]=setTimeout(()=>{this[w]=!1,this[m]=Date.now(),S.apply(this,[this[u]]),this[u]=C?C():void 0},d-Date.now()))}}})}e.throttle=D}),define(ge[15],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(a=>{a(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=_,e.errorHandler=new _;function k(d){e.errorHandler.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=k;function R(d){I(d)||e.errorHandler.onUnexpectedError(d)}e.onUnexpectedError=R;function T(d){I(d)||e.errorHandler.onUnexpectedExternalError(d)}e.onUnexpectedExternalError=T;function P(d){if(d instanceof Error){let{name:s,message:a}=d;const c=d.stacktrace||d.stack;return{$isError:!0,name:s,message:a,stack:c}}return d}e.transformErrorForSerialization=P;const D="Canceled";function I(d){return d instanceof Error&&d.name===D&&d.message===D}e.isPromiseCanceledError=I;class n extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=n;function C(){const d=new Error(D);return d.name=d.message,d}e.canceled=C;function S(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.illegalArgument=S;function v(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.illegalState=v;function f(d){return d?new Error(`readonly property '${d} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function u(d){const s=new Error(`${d} has been disposed`);return s.name="DISPOSED",s}e.disposed=u;function m(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.getErrorMessage=m;class w extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=w;class p extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=p}),define(ge[13],pe([0,1,15]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.mergeSort=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(U,V=0){return U[U.length-(1+V)]}e.tail=k;function R(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=R;function T(U,V,z=(Q,ae)=>Q===ae){if(U===V)return!0;if(!U||!V||U.length!==V.length)return!1;for(let Q=0,ae=U.length;Q<ae;Q++)if(!z(U[Q],V[Q]))return!1;return!0}e.equals=T;function P(U,V,z){let Q=0,ae=U.length-1;for(;Q<=ae;){const ce=(Q+ae)/2|0,fe=z(U[ce],V);if(fe<0)Q=ce+1;else if(fe>0)ae=ce-1;else return ce}return-(Q+1)}e.binarySearch=P;function D(U,V){let z=0,Q=U.length;if(Q===0)return 0;for(;z<Q;){const ae=Math.floor((z+Q)/2);V(U[ae])?Q=ae:z=ae+1}return z}e.findFirstInSorted=D;function I(U,V,z){if(U=U|0,U>=V.length)throw new TypeError("invalid index");let Q=V[Math.floor(V.length*Math.random())],ae=[],ce=[],fe=[];for(let we of V){const be=z(we,Q);be<0?ae.push(we):be>0?ce.push(we):fe.push(we)}return U<ae.length?I(U,ae,z):U<ae.length+fe.length?fe[0]:I(U-(ae.length+fe.length),ce,z)}e.quickSelect=I;function n(U,V){return S(U,V,0,U.length-1,[]),U}e.mergeSort=n;function C(U,V,z,Q,ae,ce){let fe=z,we=Q+1;for(let be=z;be<=ae;be++)ce[be]=U[be];for(let be=z;be<=ae;be++)fe>Q?U[be]=ce[we++]:we>ae?U[be]=ce[fe++]:V(ce[we],ce[fe])<0?U[be]=ce[we++]:U[be]=ce[fe++]}function S(U,V,z,Q,ae){if(!(Q<=z)){const ce=z+(Q-z)/2|0;S(U,V,z,ce,ae),S(U,V,ce+1,Q,ae),!(V(U[ce],U[ce+1])<=0)&&C(U,V,z,ce,Q,ae)}}function v(U,V){const z=[];let Q;for(const ae of n(U.slice(0),V))!Q||V(Q[0],ae)!==0?(Q=[ae],z.push(Q)):Q.push(ae);return z}e.groupBy=v;function f(U,V,z){const Q=[];function ae(we,be,H){if(!(be===0&&H.length===0)){const X=Q[Q.length-1];X&&X.start+X.deleteCount===we?(X.deleteCount+=be,X.toInsert.push(...H)):Q.push({start:we,deleteCount:be,toInsert:H})}}let ce=0,fe=0;for(;;){if(ce===U.length){ae(ce,0,V.slice(fe));break}if(fe===V.length){ae(ce,U.length-ce,[]);break}const we=U[ce],be=V[fe],H=z(we,be);H===0?(ce+=1,fe+=1):H<0?(ae(ce,1,[]),ce+=1):H>0&&(ae(ce,0,[be]),fe+=1)}return Q}e.sortedDiff=f;function u(U,V,z){const Q=f(U,V,z),ae=[],ce=[];for(const fe of Q)ae.push(...U.slice(fe.start,fe.start+fe.deleteCount)),ce.push(...fe.toInsert);return{removed:ae,added:ce}}e.delta=u;function m(U,V,z){if(z===0)return[];const Q=U.slice(0,z).sort(V);return p(U,V,Q,z,U.length),Q}e.top=m;function w(U,V,z,Q,ae){return z===0?Promise.resolve([]):new Promise((ce,fe)=>{(async()=>{const we=U.length,be=U.slice(0,z).sort(V);for(let H=z,X=Math.min(z+Q,we);H<we;H=X,X=Math.min(X+Q,we)){if(H>z&&await new Promise(re=>setTimeout(re)),ae&&ae.isCancellationRequested)throw _.canceled();p(U,V,be,H,X)}return be})().then(ce,fe)})}e.topAsync=w;function p(U,V,z,Q,ae){for(const ce=z.length;Q<ae;Q++){const fe=U[Q];if(V(fe,z[ce-1])<0){z.pop();const we=D(z,be=>V(fe,be)<0);z.splice(we,0,fe)}}}function d(U){return U.filter(V=>!!V)}e.coalesce=d;function s(U){let V=0;for(let z=0;z<U.length;z++)U[z]&&(U[V]=U[z],V+=1);U.length=V}e.coalesceInPlace=s;function a(U,V,z){U.splice(z,0,U.splice(V,1)[0])}e.move=a;function c(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=c;function t(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=t;function r(U,V){if(!V)return U.filter((Q,ae)=>U.indexOf(Q)===ae);const z=Object.create(null);return U.filter(Q=>{const ae=V(Q);return z[ae]?!1:(z[ae]=!0,!0)})}e.distinct=r;function o(U){const V=new Set;return U.filter(z=>V.has(z)?!1:(V.add(z),!0))}e.distinctES6=o;function l(U){const V=Object.create(null);return z=>{const Q=U(z);return V[Q]?!1:(V[Q]=!0,!0)}}e.uniqueFilter=l;function i(U,V){for(let z=U.length-1;z>=0;z--){const Q=U[z];if(V(Q))return z}return-1}e.lastIndex=i;function h(U,V){return U.length>0?U[0]:V}e.firstOrDefault=h;function y(U,V,z=(Q,ae)=>Q===ae){let Q=0;for(let ae=0,ce=Math.min(U.length,V.length);ae<ce&&z(U[ae],V[ae]);ae++)Q++;return Q}e.commonPrefixLength=y;function g(U){return[].concat(...U)}e.flatten=g;function E(U,V){let z=typeof V=="number"?U:0;typeof V=="number"?z=U:(z=0,V=U);const Q=[];if(z<=V)for(let ae=z;ae<V;ae++)Q.push(ae);else for(let ae=z;ae>V;ae--)Q.push(ae);return Q}e.range=E;function b(U,V,z){return U.reduce((Q,ae)=>(Q[V(ae)]=z?z(ae):ae,Q),Object.create(null))}e.index=b;function L(U,V){return U.push(V),()=>A(U,V)}e.insert=L;function A(U,V){const z=U.indexOf(V);if(z>-1)return U.splice(z,1),V}e.remove=A;function N(U,V,z){const Q=U.slice(0,V),ae=U.slice(V);return Q.concat(z,ae)}e.arrayInsert=N;function W(U,V){let z;if(typeof V=="number"){let Q=V;z=()=>{const ae=Math.sin(Q++)*179426549;return ae-Math.floor(ae)}}else z=Math.random;for(let Q=U.length-1;Q>0;Q-=1){const ae=Math.floor(z()*(Q+1)),ce=U[Q];U[Q]=U[ae],U[ae]=ce}}e.shuffle=W;function x(U,V){const z=U.indexOf(V);z>-1&&(U.splice(z,1),U.unshift(V))}e.pushToStart=x;function M(U,V){const z=U.indexOf(V);z>-1&&(U.splice(z,1),U.push(V))}e.pushToEnd=M;function $(U,V){return Array.isArray(U)?U.map(V):V(U)}e.mapArrayOrNot=$;function O(U){return Array.isArray(U)?U:[U]}e.asArray=O;function B(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=B;function J(U,V){for(const z of U){const Q=V(z);if(Q!==void 0)return Q}}e.mapFind=J}),define(ge[70],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(k){const R=this;let T=!1,P;return function(){return T||(T=!0,P=k.apply(R,arguments)),P}}e.once=_}),define(ge[71],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(R){this._prefix=R,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(ge[72],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(k){function R(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}k.is=R;const T=Object.freeze([]);function P(){return T}k.empty=P;function*D(d){yield d}k.single=D;function I(d){return d||T}k.from=I;function n(d){return!d||d[Symbol.iterator]().next().done===!0}k.isEmpty=n;function C(d){return d[Symbol.iterator]().next().value}k.first=C;function S(d,s){for(const a of d)if(s(a))return!0;return!1}k.some=S;function*v(d,s){for(const a of d)s(a)&&(yield a)}k.filter=v;function*f(d,s){for(const a of d)yield s(a)}k.map=f;function*u(...d){for(const s of d)for(const a of s)yield a}k.concat=u;function*m(d){for(const s of d)for(const a of s)yield a}k.concatNested=m;function*w(d,s,a=d.length){for(s<0&&(s+=d.length),a<0?a+=d.length:a>d.length&&(a=d.length);s<a;s++)yield d[s]}k.slice=w;function p(d,s=Number.POSITIVE_INFINITY){const a=[];if(s===0)return[a,d];const c=d[Symbol.iterator]();for(let t=0;t<s;t++){const r=c.next();if(r.done)return[a,k.empty()];a.push(r.value)}return[a,{[Symbol.iterator](){return c}}]}k.consume=p})(_=e.Iterable||(e.Iterable={}))}),define(ge[56],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function P(t,r=!1){let o=0,l=t.length,i="",h=0,y=16,g=0;function E(M){let $=0,O=0;for(;$<M;){const B=t.charCodeAt(o);if(B>=48&&B<=57)O=O*16+B-48;else if(B>=65&&B<=70)O=O*16+B-65+10;else if(B>=97&&B<=102)O=O*16+B-97+10;else break;o++,$++}return $<M&&(O=-1),O}function b(M){o=M,i="",h=0,y=16,g=0}function L(){const M=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&n(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&n(t.charCodeAt(o)))for(o++;o<t.length&&n(t.charCodeAt(o));)o++;else return g=3,t.substring(M,o);let $=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&n(t.charCodeAt(o))){for(o++;o<t.length&&n(t.charCodeAt(o));)o++;$=o}else g=3;return t.substring(M,$)}function A(){let M="",$=o;for(;;){if(o>=l){M+=t.substring($,o),g=2;break}const O=t.charCodeAt(o);if(O===34){M+=t.substring($,o),o++;break}if(O===92){if(M+=t.substring($,o),o++,o>=l){g=2;break}switch(t.charCodeAt(o++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:const J=E(4);J>=0?M+=String.fromCharCode(J):g=4;break;default:g=5}$=o;continue}if(O>=0&&O<=31)if(I(O)){M+=t.substring($,o),g=2;break}else g=6;o++}return M}function N(){if(i="",g=0,h=o,o>=l)return h=l,y=17;let M=t.charCodeAt(o);if(D(M)){do o++,i+=String.fromCharCode(M),M=t.charCodeAt(o);while(D(M));return y=15}if(I(M))return o++,i+=String.fromCharCode(M),M===13&&t.charCodeAt(o)===10&&(o++,i+=`
`),y=14;switch(M){case 123:return o++,y=1;case 125:return o++,y=2;case 91:return o++,y=3;case 93:return o++,y=4;case 58:return o++,y=6;case 44:return o++,y=5;case 34:return o++,i=A(),y=10;case 47:const $=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<l&&!I(t.charCodeAt(o));)o++;return i=t.substring($,o),y=12}if(t.charCodeAt(o+1)===42){o+=2;const O=l-1;let B=!1;for(;o<O;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,B=!0;break}o++}return B||(o++,g=1),i=t.substring($,o),y=13}return i+=String.fromCharCode(M),o++,y=16;case 45:if(i+=String.fromCharCode(M),o++,o===l||!n(t.charCodeAt(o)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=L(),y=11;default:for(;o<l&&W(M);)o++,M=t.charCodeAt(o);if(h!==o){switch(i=t.substring(h,o),i){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return i+=String.fromCharCode(M),o++,y=16}}function W(M){if(D(M)||I(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let M;do M=N();while(M>=12&&M<=15);return M}return{setPosition:b,getPosition:()=>o,scan:r?x:N,getToken:()=>y,getTokenValue:()=>i,getTokenOffset:()=>h,getTokenLength:()=>o-h,getTokenError:()=>g}}e.createScanner=P;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function I(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function S(t,r){const o=[],l=new Object;let i;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function g(E,b,L,A){h.value=E,h.offset=b,h.length=L,h.type=A,h.colonOffset=void 0,i=h}try{s(t,{onObjectBegin:(E,b)=>{if(r<=E)throw l;i=void 0,y=r>E,o.push("")},onObjectProperty:(E,b,L)=>{if(r<b||(g(E,b,L,"property"),o[o.length-1]=E,r<=b+L))throw l},onObjectEnd:(E,b)=>{if(r<=E)throw l;i=void 0,o.pop()},onArrayBegin:(E,b)=>{if(r<=E)throw l;i=void 0,o.push(0)},onArrayEnd:(E,b)=>{if(r<=E)throw l;i=void 0,o.pop()},onLiteralValue:(E,b,L)=>{if(r<b||(g(E,b,L,c(E)),r<=b+L))throw l},onSeparator:(E,b,L)=>{if(r<=b)throw l;if(E===":"&&i&&i.type==="property")i.colonOffset=b,y=!1,i=void 0;else if(E===","){const A=o[o.length-1];typeof A=="number"?o[o.length-1]=A+1:(y=!0,o[o.length-1]=""),i=void 0}}})}catch(E){if(E!==l)throw E}return{path:o,previousNode:i,isAtPropertyKey:y,matches:E=>{let b=0;for(let L=0;b<E.length&&L<o.length;L++)if(E[b]===o[L]||E[b]==="*")b++;else if(E[b]!=="**")return!1;return b===E.length}}}e.getLocation=S;function v(t,r=[],o=T.DEFAULT){let l=null,i=[];const h=[];function y(E){Array.isArray(i)?i.push(E):l!==null&&(i[l]=E)}return s(t,{onObjectBegin:()=>{const E={};y(E),h.push(i),i=E,l=null},onObjectProperty:E=>{l=E},onObjectEnd:()=>{i=h.pop()},onArrayBegin:()=>{const E=[];y(E),h.push(i),i=E,l=null},onArrayEnd:()=>{i=h.pop()},onLiteralValue:y,onError:(E,b,L)=>{r.push({error:E,offset:b,length:L})}},o),i[0]}e.parse=v;function f(t,r=[],o=T.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(E){l.type==="property"&&(l.length=E-l.offset,l=l.parent)}function h(E){return l.children.push(E),E}s(t,{onObjectBegin:E=>{l=h({type:"object",offset:E,length:-1,parent:l,children:[]})},onObjectProperty:(E,b,L)=>{l=h({type:"property",offset:b,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:E,offset:b,length:L,parent:l})},onObjectEnd:(E,b)=>{l.length=E+b-l.offset,l=l.parent,i(E+b)},onArrayBegin:(E,b)=>{l=h({type:"array",offset:E,length:-1,parent:l,children:[]})},onArrayEnd:(E,b)=>{l.length=E+b-l.offset,l=l.parent,i(E+b)},onLiteralValue:(E,b,L)=>{h({type:c(E),offset:b,length:L,parent:l,value:E}),i(b+L)},onSeparator:(E,b,L)=>{l.type==="property"&&(E===":"?l.colonOffset=b:E===","&&i(b))},onError:(E,b,L)=>{r.push({error:E,offset:b,length:L})}},o);const g=l.children[0];return g&&delete g.parent,g}e.parseTree=f;function u(t,r){if(!!t){let o=t;for(let l of r)if(typeof l=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let i=!1;for(const h of o.children)if(Array.isArray(h.children)&&h.children[0].value===l){o=h.children[1],i=!0;break}if(!i)return}else{const i=l;if(o.type!=="array"||i<0||!Array.isArray(o.children)||i>=o.children.length)return;o=o.children[i]}return o}}e.findNodeAtLocation=u;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;r.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&r.push(o)}return r}e.getNodePath=m;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":const r=Object.create(null);for(let o of t.children){const l=o.children[1];l&&(r[o.children[0].value]=w(l))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function p(t,r,o=!1){return r>=t.offset&&r<t.offset+t.length||o&&r===t.offset+t.length}e.contains=p;function d(t,r,o=!1){if(p(t,r,o)){const l=t.children;if(Array.isArray(l))for(let i=0;i<l.length&&l[i].offset<=r;i++){const h=d(l[i],r,o);if(h)return h}return t}}e.findNodeAtOffset=d;function s(t,r,o=T.DEFAULT){const l=P(t,!1);function i(ce){return ce?()=>ce(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(ce){return ce?fe=>ce(fe,l.getTokenOffset(),l.getTokenLength()):()=>!0}const y=i(r.onObjectBegin),g=h(r.onObjectProperty),E=i(r.onObjectEnd),b=i(r.onArrayBegin),L=i(r.onArrayEnd),A=h(r.onLiteralValue),N=h(r.onSeparator),W=i(r.onComment),x=h(r.onError),M=o&&o.disallowComments,$=o&&o.allowTrailingComma;function O(){for(;;){const ce=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:M||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ce){case 12:case 13:M?B(10):W();break;case 16:B(1);break;case 15:case 14:break;default:return ce}}}function B(ce,fe=[],we=[]){if(x(ce),fe.length+we.length>0){let be=l.getToken();for(;be!==17;){if(fe.indexOf(be)!==-1){O();break}else if(we.indexOf(be)!==-1)break;be=O()}}}function J(ce){const fe=l.getTokenValue();return ce?A(fe):g(fe),O(),!0}function U(){switch(l.getToken()){case 11:let ce=0;try{ce=JSON.parse(l.getTokenValue()),typeof ce!="number"&&(B(2),ce=0)}catch(fe){B(2)}A(ce);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return O(),!0}function V(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(J(!1),l.getToken()===6?(N(":"),O(),ae()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function z(){y(),O();let ce=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ce||B(4,[],[]),N(","),O(),l.getToken()===2&&$)break}else ce&&B(6,[],[]);V()||B(4,[],[2,5]),ce=!0}return E(),l.getToken()!==2?B(7,[2],[]):O(),!0}function Q(){b(),O();let ce=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ce||B(4,[],[]),N(","),O(),l.getToken()===4&&$)break}else ce&&B(6,[],[]);ae()||B(4,[],[4,5]),ce=!0}return L(),l.getToken()!==4?B(8,[4],[]):O(),!0}function ae(){switch(l.getToken()){case 3:return Q();case 1:return z();case 10:return J(!0);default:return U()}}return O(),l.getToken()===17?o.allowEmptyContent?!0:(B(4,[],[]),!1):ae()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=s;function a(t,r){let o=P(t),l=[],i,h=0,y;do switch(y=o.getPosition(),i=o.scan(),i){case 12:case 13:case 17:h!==y&&l.push(t.substring(h,y)),r!==void 0&&l.push(o.getTokenValue().replace(/[^\r\n]/g,r)),h=o.getPosition();break}while(i!==17);return l.join("")}e.stripComments=a;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ge[130],pe([0,1,56]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(I,n,C){let S,v,f,u,m;if(n){for(u=n.offset,m=u+n.length,f=u;f>0&&!D(I,f-1);)f--;let h=m;for(;h<I.length&&!D(I,h);)h++;v=I.substring(f,h),S=T(v,C)}else v=I,S=0,f=0,u=0,m=I.length;const w=P(C,I);let p=!1,d=0,s;C.insertSpaces?s=R(" ",C.tabSize||4):s="	";const a=_.createScanner(v,!1);let c=!1;function t(){return w+R(s,S+d)}function r(){let h=a.scan();for(p=!1;h===15||h===14;)p=p||h===14,h=a.scan();return c=h===16||a.getTokenError()!==0,h}const o=[];function l(h,y,g){!c&&y<m&&g>u&&I.substring(y,g)!==h&&o.push({offset:y,length:g-y,content:h})}let i=r();if(i!==17){const h=a.getTokenOffset()+f,y=R(s,S);l(y,f,h)}for(;i!==17;){let h=a.getTokenOffset()+a.getTokenLength()+f,y=r(),g="";for(;!p&&(y===12||y===13);){const b=a.getTokenOffset()+f;l(" ",h,b),h=a.getTokenOffset()+a.getTokenLength()+f,g=y===12?t():"",y=r()}if(y===2)i!==1&&(d--,g=t());else if(y===4)i!==3&&(d--,g=t());else{switch(i){case 3:case 1:d++,g=t();break;case 5:case 12:g=t();break;case 13:p?g=t():g=" ";break;case 6:g=" ";break;case 10:if(y===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?g=" ":y!==5&&y!==17&&(c=!0);break;case 16:c=!0;break}p&&(y===12||y===13)&&(g=t())}const E=a.getTokenOffset()+f;l(g,h,E),i=y}return o}e.format=k;function R(I,n){let C="";for(let S=0;S<n;S++)C+=I;return C}function T(I,n){let C=0,S=0;const v=n.tabSize||4;for(;C<I.length;){const f=I.charAt(C);if(f===" ")S++;else if(f==="	")S+=v;else break;C++}return Math.floor(S/v)}function P(I,n){for(let C=0;C<n.length;C++){const S=n.charAt(C);if(S==="\r")return C+1<n.length&&n.charAt(C+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return I&&I.eol||`
`}e.getEOL=P;function D(I,n){return`\r
`.indexOf(I.charAt(n))!==-1}e.isEOL=D}),define(ge[131],pe([0,1,56,130,13]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(C,S,v){return P(C,S,void 0,v)}e.removeProperty=T;function P(C,S,v,f,u){const m=S.slice(),w=[],p=_.parseTree(C,w);let d,s;for(;m.length>0&&(s=m.pop(),d=_.findNodeAtLocation(p,m),d===void 0&&v!==void 0);)typeof s=="string"?v={[s]:v}:v=[v];if(d)if(d.type==="object"&&typeof s=="string"&&Array.isArray(d.children)){const a=_.findNodeAtLocation(d,[s]);if(a!==void 0)if(v===void 0){if(!a.parent)throw new Error("Malformed AST");const c=d.children.indexOf(a.parent);let t,r=a.parent.offset+a.parent.length;if(c>0){const o=d.children[c-1];t=o.offset+o.length}else t=d.offset+1,d.children.length>1&&(r=d.children[1].offset);return D(C,{offset:t,length:r-t,content:""},f)}else return D(C,{offset:a.offset,length:a.length,content:JSON.stringify(v)},f);else{if(v===void 0)return[];const c=`${JSON.stringify(s)}: ${JSON.stringify(v)}`,t=u?u(d.children.map(o=>o.children[0].value)):d.children.length;let r;if(t>0){const o=d.children[t-1];r={offset:o.offset+o.length,length:0,content:","+c}}else d.children.length===0?r={offset:d.offset+1,length:0,content:c}:r={offset:d.offset+1,length:0,content:c+","};return D(C,r,f)}}else if(d.type==="array"&&typeof s=="number"&&Array.isArray(d.children))if(v!==void 0){const a=`${JSON.stringify(v)}`;let c;if(d.children.length===0||s===0)c={offset:d.offset+1,length:0,content:d.children.length===0?a:a+","};else{const t=s===-1||s>d.children.length?d.children.length:s,r=d.children[t-1];c={offset:r.offset+r.length,length:0,content:","+a}}return D(C,c,f)}else{const a=s,c=d.children[a];let t;if(d.children.length===1)t={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===a){const r=d.children[a-1],o=r.offset+r.length,l=d.offset+d.length;t={offset:o,length:l-2-o,content:""}}else t={offset:c.offset,length:d.children[a+1].offset-c.offset,content:""};return D(C,t,f)}else throw new Error(`Can not add ${typeof s!="number"?"index":"property"} to parent of type ${d.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(C,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(v)},f)}}e.setProperty=P;function D(C,S,v){let f=I(C,S),u=S.offset,m=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;u>0&&!k.isEOL(f,u-1);)u--;for(;m<f.length&&!k.isEOL(f,m);)m++}const w=k.format(f,{offset:u,length:m-u},v);for(let d=w.length-1;d>=0;d--){const s=w[d];f=I(f,s),u=Math.min(u,s.offset),m=Math.max(m,s.offset+s.length),m+=s.content.length-s.length}const p=C.length-(f.length-m)-u;return[{offset:u,length:p,content:f.substring(u,m)}]}e.withFormatting=D;function I(C,S){return C.substring(0,S.offset)+S.content+C.substring(S.offset+S.length)}e.applyEdit=I;function n(C,S){let v=R.mergeSort(S,(u,m)=>{const w=u.offset-m.offset;return w===0?u.length-m.length:w}),f=C.length;for(let u=v.length-1;u>=0;u--){let m=v[u];if(m.offset+m.length<=f)C=I(C,m);else throw new Error("Overlapping edit");f=m.offset}return C}e.applyEdits=n}),define(ge[5],pe([0,1,70,72]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const R=!1;let T=null;function P(s){T=s}if(e.setDisposableTracker=P,R){const s="__is_disposable_tracked__";T=new class{trackDisposable(a){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(c)},3e3)}markTracked(a){if(a&&a!==m.None)try{a[s]=!0}catch(c){}}}}function D(s){!T||T.markTracked(s)}function I(s){return T&&T.trackDisposable(s),s}e.trackDisposable=I;class n extends Error{constructor(a){super(`Encounter errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=n;function C(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=C;function S(s){if(k.Iterable.is(s)){let a=[];for(const c of s)if(c){D(c);try{c.dispose()}catch(t){a.push(t)}}if(a.length===1)throw a[0];if(a.length>1)throw new n(a);return Array.isArray(s)?[]:s}else if(s)return D(s),s.dispose(),s}e.dispose=S;function v(...s){return s.forEach(D),f(()=>S(s))}e.combinedDisposable=v;function f(s){const a=I({dispose:()=>{D(a),s()}});return a}e.toDisposable=f;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{S(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return D(a),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new u,I(this)}dispose(){D(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value&&this._value.dispose(),a&&D(a),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,D(this),this._value&&this._value.dispose(),this._value=void 0}}e.MutableDisposable=w;class p{constructor(){this.references=new Map}acquire(a,...c){let t=this.references.get(a);t||(t={counter:0,object:this.createReferencedObject(a,...c)},this.references.set(a,t));const{object:r}=t,o=_.once(()=>{--t.counter==0&&(this.destroyReferencedObject(a,t.object),this.references.delete(a))});return t.counter++,{object:r,dispose:o}}}e.ReferenceCollection=p;class d{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=d}),define(ge[73],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(T){this.element=T,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class k{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,P){const D=new _(T);if(this._first===_.Undefined)this._first=D,this._last=D;else if(P){const n=this._last;this._last=D,D.prev=n,n.next=D}else{const n=this._first;this._first=D,D.next=n,n.prev=D}this._size+=1;let I=!1;return()=>{I||(I=!0,this._remove(D))}}shift(){if(this._first!==_.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==_.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==_.Undefined&&T.next!==_.Undefined){const P=T.prev;P.next=T.next,T.next.prev=P}else T.prev===_.Undefined&&T.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):T.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):T.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==_.Undefined;)yield T.element,T=T.next}}e.LinkedList=k}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(ee,te){for(var G=0;G<te.length;G++){var F=te[G];F.enumerable=F.enumerable||!1,F.configurable=!0,"value"in F&&(F.writable=!0),Object.defineProperty(ee,F.key,F)}}function e(ee,te,G){return te&&Z(ee.prototype,te),G&&Z(ee,G),ee}function _(ee,te){if(!!ee){if(typeof ee=="string")return k(ee,te);var G=Object.prototype.toString.call(ee).slice(8,-1);if(G==="Object"&&ee.constructor&&(G=ee.constructor.name),G==="Map"||G==="Set")return Array.from(ee);if(G==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(G))return k(ee,te)}}function k(ee,te){(te==null||te>ee.length)&&(te=ee.length);for(var G=0,F=new Array(te);G<te;G++)F[G]=ee[G];return F}function R(ee,te){var G;if(typeof Symbol=="undefined"||ee[Symbol.iterator]==null){if(Array.isArray(ee)||(G=_(ee))||te&&ee&&typeof ee.length=="number"){G&&(ee=G);var F=0;return function(){return F>=ee.length?{done:!0}:{done:!1,value:ee[F++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return G=ee[Symbol.iterator](),G.next.bind(G)}function T(ee,te){return te={exports:{}},ee(te,te.exports),te.exports}var P=T(function(ee){function te(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function G(F){ee.exports.defaults=F}ee.exports={defaults:te(),getDefaults:te,changeDefaults:G}}),D=P.defaults,I=P.getDefaults,n=P.changeDefaults,C=/[&<>"']/,S=/[&<>"']/g,v=/[<>"']|&(?!#?\w+;)/,f=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(te){return u[te]};function w(ee,te){if(te){if(C.test(ee))return ee.replace(S,m)}else if(v.test(ee))return ee.replace(f,m);return ee}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(ee){return ee.replace(p,function(te,G){return G=G.toLowerCase(),G==="colon"?":":G.charAt(0)==="#"?G.charAt(1)==="x"?String.fromCharCode(parseInt(G.substring(2),16)):String.fromCharCode(+G.substring(1)):""})}var s=/(^|[^\[])\^/g;function a(ee,te){ee=ee.source||ee,te=te||"";var G={replace:function(ie,oe){return oe=oe.source||oe,oe=oe.replace(s,"$1"),ee=ee.replace(ie,oe),G},getRegex:function(){return new RegExp(ee,te)}};return G}var c=/[^\w:]/g,t=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function r(ee,te,G){if(ee){var F;try{F=decodeURIComponent(d(G)).replace(c,"").toLowerCase()}catch(ie){return null}if(F.indexOf("javascript:")===0||F.indexOf("vbscript:")===0||F.indexOf("data:")===0)return null}te&&!t.test(G)&&(G=y(te,G));try{G=encodeURI(G).replace(/%25/g,"%")}catch(ie){return null}return G}var o={},l=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(ee,te){o[" "+ee]||(l.test(ee)?o[" "+ee]=ee+"/":o[" "+ee]=L(ee,"/",!0)),ee=o[" "+ee];var G=ee.indexOf(":")===-1;return te.substring(0,2)==="//"?G?te:ee.replace(i,"$1")+te:te.charAt(0)==="/"?G?te:ee.replace(h,"$1")+te:ee+te}var g={exec:function(){}};function E(ee){for(var te=1,G,F;te<arguments.length;te++){G=arguments[te];for(F in G)Object.prototype.hasOwnProperty.call(G,F)&&(ee[F]=G[F])}return ee}function b(ee,te){var G=ee.replace(/\|/g,function(oe,me,ke){for(var Re=!1,xe=me;--xe>=0&&ke[xe]==="\\";)Re=!Re;return Re?"|":" |"}),F=G.split(/ \|/),ie=0;if(F.length>te)F.splice(te);else for(;F.length<te;)F.push("");for(;ie<F.length;ie++)F[ie]=F[ie].trim().replace(/\\\|/g,"|");return F}function L(ee,te,G){var F=ee.length;if(F===0)return"";for(var ie=0;ie<F;){var oe=ee.charAt(F-ie-1);if(oe===te&&!G)ie++;else if(oe!==te&&G)ie++;else break}return ee.substr(0,F-ie)}function A(ee,te){if(ee.indexOf(te[1])===-1)return-1;for(var G=ee.length,F=0,ie=0;ie<G;ie++)if(ee[ie]==="\\")ie++;else if(ee[ie]===te[0])F++;else if(ee[ie]===te[1]&&(F--,F<0))return ie;return-1}function N(ee){ee&&ee.sanitize&&!ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W(ee,te){if(te<1)return"";for(var G="";te>1;)te&1&&(G+=ee),te>>=1,ee+=ee;return G+ee}var x={escape:w,unescape:d,edit:a,cleanUrl:r,resolveUrl:y,noopTest:g,merge:E,splitCells:b,rtrim:L,findClosingBracket:A,checkSanitizeDeprecation:N,repeatString:W},M=P.defaults,$=x.rtrim,O=x.splitCells,B=x.escape,J=x.findClosingBracket;function U(ee,te,G){var F=te.href,ie=te.title?B(te.title):null,oe=ee[1].replace(/\\([\[\]])/g,"$1");return ee[0].charAt(0)!=="!"?{type:"link",raw:G,href:F,title:ie,text:oe}:{type:"image",raw:G,href:F,title:ie,text:B(oe)}}function V(ee,te){var G=ee.match(/^(\s+)(?:```)/);if(G===null)return te;var F=G[1];return te.split(`
`).map(function(ie){var oe=ie.match(/^\s+/);if(oe===null)return ie;var me=oe[0];return me.length>=F.length?ie.slice(F.length):ie}).join(`
`)}var z=function(){function ee(G){this.options=G||M}var te=ee.prototype;return te.space=function(F){var ie=this.rules.block.newline.exec(F);if(ie)return ie[0].length>1?{type:"space",raw:ie[0]}:{raw:`
`}},te.code=function(F,ie){var oe=this.rules.block.code.exec(F);if(oe){var me=ie[ie.length-1];if(me&&me.type==="paragraph")return{raw:oe[0],text:oe[0].trimRight()};var ke=oe[0].replace(/^ {4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?ke:$(ke,`
`)}}},te.fences=function(F){var ie=this.rules.block.fences.exec(F);if(ie){var oe=ie[0],me=V(oe,ie[3]||"");return{type:"code",raw:oe,lang:ie[2]?ie[2].trim():ie[2],text:me}}},te.heading=function(F){var ie=this.rules.block.heading.exec(F);if(ie)return{type:"heading",raw:ie[0],depth:ie[1].length,text:ie[2]}},te.nptable=function(F){var ie=this.rules.block.nptable.exec(F);if(ie){var oe={type:"table",header:O(ie[1].replace(/^ *| *\| *$/g,"")),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ie[3]?ie[3].replace(/\n$/,"").split(`
`):[],raw:ie[0]};if(oe.header.length===oe.align.length){var me=oe.align.length,ke;for(ke=0;ke<me;ke++)/^ *-+: *$/.test(oe.align[ke])?oe.align[ke]="right":/^ *:-+: *$/.test(oe.align[ke])?oe.align[ke]="center":/^ *:-+ *$/.test(oe.align[ke])?oe.align[ke]="left":oe.align[ke]=null;for(me=oe.cells.length,ke=0;ke<me;ke++)oe.cells[ke]=O(oe.cells[ke],oe.header.length);return oe}}},te.hr=function(F){var ie=this.rules.block.hr.exec(F);if(ie)return{type:"hr",raw:ie[0]}},te.blockquote=function(F){var ie=this.rules.block.blockquote.exec(F);if(ie){var oe=ie[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ie[0],text:oe}}},te.list=function(F){var ie=this.rules.block.list.exec(F);if(ie){for(var oe=ie[0],me=ie[2],ke=me.length>1,Re=me[me.length-1]===")",xe={type:"list",raw:oe,ordered:ke,start:ke?+me.slice(0,-1):"",loose:!1,items:[]},qe=ie[0].match(this.rules.block.item),Ge=!1,Ke,st,$e,Xe,ft,et,mt,ot=qe.length,Ze=0;Ze<ot;Ze++)Ke=qe[Ze],oe=Ke,st=Ke.length,Ke=Ke.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ke.indexOf(`
 `)&&(st-=Ke.length,Ke=this.options.pedantic?Ke.replace(/^ {1,4}/gm,""):Ke.replace(new RegExp("^ {1,"+st+"}","gm"),"")),Ze!==ot-1&&($e=this.rules.block.bullet.exec(qe[Ze+1])[0],(ke?$e.length===1||!Re&&$e[$e.length-1]===")":$e.length>1||this.options.smartLists&&$e!==me)&&(Xe=qe.slice(Ze+1).join(`
`),xe.raw=xe.raw.substring(0,xe.raw.length-Xe.length),Ze=ot-1)),ft=Ge||/\n\n(?!\s*$)/.test(Ke),Ze!==ot-1&&(Ge=Ke.charAt(Ke.length-1)===`
`,ft||(ft=Ge)),ft&&(xe.loose=!0),et=/^\[[ xX]\] /.test(Ke),mt=void 0,et&&(mt=Ke[1]!==" ",Ke=Ke.replace(/^\[[ xX]\] +/,"")),xe.items.push({type:"list_item",raw:oe,task:et,checked:mt,loose:ft,text:Ke});return xe}},te.html=function(F){var ie=this.rules.block.html.exec(F);if(ie)return{type:this.options.sanitize?"paragraph":"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):B(ie[0]):ie[0]}},te.def=function(F){var ie=this.rules.block.def.exec(F);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var oe=ie[1].toLowerCase().replace(/\s+/g," ");return{tag:oe,raw:ie[0],href:ie[2],title:ie[3]}}},te.table=function(F){var ie=this.rules.block.table.exec(F);if(ie){var oe={type:"table",header:O(ie[1].replace(/^ *| *\| *$/g,"")),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ie[3]?ie[3].replace(/\n$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=ie[0];var me=oe.align.length,ke;for(ke=0;ke<me;ke++)/^ *-+: *$/.test(oe.align[ke])?oe.align[ke]="right":/^ *:-+: *$/.test(oe.align[ke])?oe.align[ke]="center":/^ *:-+ *$/.test(oe.align[ke])?oe.align[ke]="left":oe.align[ke]=null;for(me=oe.cells.length,ke=0;ke<me;ke++)oe.cells[ke]=O(oe.cells[ke].replace(/^ *\| *| *\| *$/g,""),oe.header.length);return oe}}},te.lheading=function(F){var ie=this.rules.block.lheading.exec(F);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1]}},te.paragraph=function(F){var ie=this.rules.block.paragraph.exec(F);if(ie)return{type:"paragraph",raw:ie[0],text:ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1]}},te.text=function(F,ie){var oe=this.rules.block.text.exec(F);if(oe){var me=ie[ie.length-1];return me&&me.type==="text"?{raw:oe[0],text:oe[0]}:{type:"text",raw:oe[0],text:oe[0]}}},te.escape=function(F){var ie=this.rules.inline.escape.exec(F);if(ie)return{type:"escape",raw:ie[0],text:B(ie[1])}},te.tag=function(F,ie,oe){var me=this.rules.inline.tag.exec(F);if(me)return!ie&&/^<a /i.test(me[0])?ie=!0:ie&&/^<\/a>/i.test(me[0])&&(ie=!1),!oe&&/^<(pre|code|kbd|script)(\s|>)/i.test(me[0])?oe=!0:oe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(me[0])&&(oe=!1),{type:this.options.sanitize?"text":"html",raw:me[0],inLink:ie,inRawBlock:oe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):B(me[0]):me[0]}},te.link=function(F){var ie=this.rules.inline.link.exec(F);if(ie){var oe=J(ie[2],"()");if(oe>-1){var me=ie[0].indexOf("!")===0?5:4,ke=me+ie[1].length+oe;ie[2]=ie[2].substring(0,oe),ie[0]=ie[0].substring(0,ke).trim(),ie[3]=""}var Re=ie[2],xe="";if(this.options.pedantic){var qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);qe?(Re=qe[1],xe=qe[3]):xe=""}else xe=ie[3]?ie[3].slice(1,-1):"";Re=Re.trim().replace(/^<([\s\S]*)>$/,"$1");var Ge=U(ie,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:xe&&xe.replace(this.rules.inline._escapes,"$1")},ie[0]);return Ge}},te.reflink=function(F,ie){var oe;if((oe=this.rules.inline.reflink.exec(F))||(oe=this.rules.inline.nolink.exec(F))){var me=(oe[2]||oe[1]).replace(/\s+/g," ");if(me=ie[me.toLowerCase()],!me||!me.href){var ke=oe[0].charAt(0);return{type:"text",raw:ke,text:ke}}var Re=U(oe,me,oe[0]);return Re}},te.strong=function(F,ie,oe){oe===void 0&&(oe="");var me=this.rules.inline.strong.start.exec(F);if(me&&(!me[1]||me[1]&&(oe===""||this.rules.inline.punctuation.exec(oe)))){ie=ie.slice(-1*F.length);var ke=me[0]==="**"?this.rules.inline.strong.endAst:this.rules.inline.strong.endUnd;ke.lastIndex=0;for(var Re;(me=ke.exec(ie))!=null;)if(Re=this.rules.inline.strong.middle.exec(ie.slice(0,me.index+3)),Re)return{type:"strong",raw:F.slice(0,Re[0].length),text:F.slice(2,Re[0].length-2)}}},te.em=function(F,ie,oe){oe===void 0&&(oe="");var me=this.rules.inline.em.start.exec(F);if(me&&(!me[1]||me[1]&&(oe===""||this.rules.inline.punctuation.exec(oe)))){ie=ie.slice(-1*F.length);var ke=me[0]==="*"?this.rules.inline.em.endAst:this.rules.inline.em.endUnd;ke.lastIndex=0;for(var Re;(me=ke.exec(ie))!=null;)if(Re=this.rules.inline.em.middle.exec(ie.slice(0,me.index+2)),Re)return{type:"em",raw:F.slice(0,Re[0].length),text:F.slice(1,Re[0].length-1)}}},te.codespan=function(F){var ie=this.rules.inline.code.exec(F);if(ie){var oe=ie[2].replace(/\n/g," "),me=/[^ ]/.test(oe),ke=oe.startsWith(" ")&&oe.endsWith(" ");return me&&ke&&(oe=oe.substring(1,oe.length-1)),oe=B(oe,!0),{type:"codespan",raw:ie[0],text:oe}}},te.br=function(F){var ie=this.rules.inline.br.exec(F);if(ie)return{type:"br",raw:ie[0]}},te.del=function(F){var ie=this.rules.inline.del.exec(F);if(ie)return{type:"del",raw:ie[0],text:ie[1]}},te.autolink=function(F,ie){var oe=this.rules.inline.autolink.exec(F);if(oe){var me,ke;return oe[2]==="@"?(me=B(this.options.mangle?ie(oe[1]):oe[1]),ke="mailto:"+me):(me=B(oe[1]),ke=me),{type:"link",raw:oe[0],text:me,href:ke,tokens:[{type:"text",raw:me,text:me}]}}},te.url=function(F,ie){var oe;if(oe=this.rules.inline.url.exec(F)){var me,ke;if(oe[2]==="@")me=B(this.options.mangle?ie(oe[0]):oe[0]),ke="mailto:"+me;else{var Re;do Re=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(Re!==oe[0]);me=B(oe[0]),oe[1]==="www."?ke="http://"+me:ke=me}return{type:"link",raw:oe[0],text:me,href:ke,tokens:[{type:"text",raw:me,text:me}]}}},te.inlineText=function(F,ie,oe){var me=this.rules.inline.text.exec(F);if(me){var ke;return ie?ke=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):B(me[0]):me[0]:ke=B(this.options.smartypants?oe(me[0]):me[0]),{type:"text",raw:me[0],text:ke}}},ee}(),Q=x.noopTest,ae=x.edit,ce=x.merge,fe={newline:/^\n+/,code:/^( {4}[^\n]+\n*)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6}) +([^\n]*?)(?: +#+)? *(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:Q,table:Q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html)[^\n]+)*)/,text:/^[^\n]+/};fe._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,fe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,fe.def=ae(fe.def).replace("label",fe._label).replace("title",fe._title).getRegex(),fe.bullet=/(?:[*+-]|\d{1,9}[.)])/,fe.item=/^( *)(bull) ?[^\n]*(?:\n(?!\1bull ?)[^\n]*)*/,fe.item=ae(fe.item,"gm").replace(/bull/g,fe.bullet).getRegex(),fe.list=ae(fe.list).replace(/bull/g,fe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+fe.def.source+")").getRegex(),fe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",fe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,fe.html=ae(fe.html,"i").replace("comment",fe._comment).replace("tag",fe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),fe.paragraph=ae(fe._paragraph).replace("hr",fe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",fe._tag).getRegex(),fe.blockquote=ae(fe.blockquote).replace("paragraph",fe.paragraph).getRegex(),fe.normal=ce({},fe),fe.gfm=ce({},fe.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),fe.gfm.nptable=ae(fe.gfm.nptable).replace("hr",fe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",fe._tag).getRegex(),fe.gfm.table=ae(fe.gfm.table).replace("hr",fe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",fe._tag).getRegex(),fe.pedantic=ce({},fe.normal,{html:ae(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",fe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^ *(#{1,6}) *([^\n]+?) *(?:#+ *)?(?:\n+|$)/,fences:Q,paragraph:ae(fe.normal._paragraph).replace("hr",fe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",fe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var we={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",strong:{start:/^(?:(\*\*(?=[*punctuation]))|\*\*)(?![\s])|__/,middle:/^\*\*(?:(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)|\*(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)*?\*)+?\*\*$|^__(?![\s])((?:(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)|_(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)*?_)+?)__$/,endAst:/[^punctuation\s]\*\*(?!\*)|[punctuation]\*\*(?!\*)(?:(?=[punctuation_\s]|$))/,endUnd:/[^\s]__(?!_)(?:(?=[punctuation*\s])|$)/},em:{start:/^(?:(\*(?=[punctuation]))|\*)(?![*\s])|_/,middle:/^\*(?:(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)|\*(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)*?\*)+?\*$|^_(?![_\s])(?:(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)|_(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)*?_)+?_$/,endAst:/[^punctuation\s]\*(?!\*)|[punctuation]\*(?!\*)(?:(?=[punctuation_\s]|$))/,endUnd:/[^\s]_(?!_)(?:(?=[punctuation*\s])|$)/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\s*punctuation])/};we._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",we.punctuation=ae(we.punctuation).replace(/punctuation/g,we._punctuation).getRegex(),we._blockSkip="\\[[^\\]]*?\\]\\([^\\)]*?\\)|`[^`]*?`|<[^>]*?>",we._overlapSkip="__[^_]*?__|\\*\\*\\[^\\*\\]*?\\*\\*",we._comment=ae(fe._comment).replace("(?:-->|$)","-->").getRegex(),we.em.start=ae(we.em.start).replace(/punctuation/g,we._punctuation).getRegex(),we.em.middle=ae(we.em.middle).replace(/punctuation/g,we._punctuation).replace(/overlapSkip/g,we._overlapSkip).getRegex(),we.em.endAst=ae(we.em.endAst,"g").replace(/punctuation/g,we._punctuation).getRegex(),we.em.endUnd=ae(we.em.endUnd,"g").replace(/punctuation/g,we._punctuation).getRegex(),we.strong.start=ae(we.strong.start).replace(/punctuation/g,we._punctuation).getRegex(),we.strong.middle=ae(we.strong.middle).replace(/punctuation/g,we._punctuation).replace(/overlapSkip/g,we._overlapSkip).getRegex(),we.strong.endAst=ae(we.strong.endAst,"g").replace(/punctuation/g,we._punctuation).getRegex(),we.strong.endUnd=ae(we.strong.endUnd,"g").replace(/punctuation/g,we._punctuation).getRegex(),we.blockSkip=ae(we._blockSkip,"g").getRegex(),we.overlapSkip=ae(we._overlapSkip,"g").getRegex(),we._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,we._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,we._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,we.autolink=ae(we.autolink).replace("scheme",we._scheme).replace("email",we._email).getRegex(),we._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,we.tag=ae(we.tag).replace("comment",we._comment).replace("attribute",we._attribute).getRegex(),we._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,we._href=/<(?:\\[<>]?|[^\s<>\\])*>|[^\s\x00-\x1f]*/,we._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,we.link=ae(we.link).replace("label",we._label).replace("href",we._href).replace("title",we._title).getRegex(),we.reflink=ae(we.reflink).replace("label",we._label).getRegex(),we.reflinkSearch=ae(we.reflinkSearch,"g").replace("reflink",we.reflink).replace("nolink",we.nolink).getRegex(),we.normal=ce({},we),we.pedantic=ce({},we.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ae(/^!?\[(label)\]\((.*?)\)/).replace("label",we._label).getRegex(),reflink:ae(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",we._label).getRegex()}),we.gfm=ce({},we.normal,{escape:ae(we.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^~+(?=\S)([\s\S]*?\S)~+/,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),we.gfm.url=ae(we.gfm.url,"i").replace("email",we.gfm._extended_email).getRegex(),we.breaks=ce({},we.gfm,{br:ae(we.br).replace("{2,}","*").getRegex(),text:ae(we.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var be={block:fe,inline:we},H=P.defaults,X=be.block,re=be.inline,Y=x.repeatString;function le(ee){return ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ve(ee){var te="",G,F,ie=ee.length;for(G=0;G<ie;G++)F=ee.charCodeAt(G),Math.random()>.5&&(F="x"+F.toString(16)),te+="&#"+F+";";return te}var De=function(){function ee(G){this.tokens=[],this.tokens.links=Object.create(null),this.options=G||H,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var F={block:X.normal,inline:re.normal};this.options.pedantic?(F.block=X.pedantic,F.inline=re.pedantic):this.options.gfm&&(F.block=X.gfm,this.options.breaks?F.inline=re.breaks:F.inline=re.gfm),this.tokenizer.rules=F}ee.lex=function(F,ie){var oe=new ee(ie);return oe.lex(F)},ee.lexInline=function(F,ie){var oe=new ee(ie);return oe.inlineTokens(F)};var te=ee.prototype;return te.lex=function(F){return F=F.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(F,this.tokens,!0),this.inline(this.tokens),this.tokens},te.blockTokens=function(F,ie,oe){ie===void 0&&(ie=[]),oe===void 0&&(oe=!0),F=F.replace(/^ +$/gm,"");for(var me,ke,Re,xe;F;){if(me=this.tokenizer.space(F)){F=F.substring(me.raw.length),me.type&&ie.push(me);continue}if(me=this.tokenizer.code(F,ie)){F=F.substring(me.raw.length),me.type?ie.push(me):(xe=ie[ie.length-1],xe.raw+=`
`+me.raw,xe.text+=`
`+me.text);continue}if(me=this.tokenizer.fences(F)){F=F.substring(me.raw.length),ie.push(me);continue}if(me=this.tokenizer.heading(F)){F=F.substring(me.raw.length),ie.push(me);continue}if(me=this.tokenizer.nptable(F)){F=F.substring(me.raw.length),ie.push(me);continue}if(me=this.tokenizer.hr(F)){F=F.substring(me.raw.length),ie.push(me);continue}if(me=this.tokenizer.blockquote(F)){F=F.substring(me.raw.length),me.tokens=this.blockTokens(me.text,[],oe),ie.push(me);continue}if(me=this.tokenizer.list(F)){for(F=F.substring(me.raw.length),Re=me.items.length,ke=0;ke<Re;ke++)me.items[ke].tokens=this.blockTokens(me.items[ke].text,[],!1);ie.push(me);continue}if(me=this.tokenizer.html(F)){F=F.substring(me.raw.length),ie.push(me);continue}if(oe&&(me=this.tokenizer.def(F))){F=F.substring(me.raw.length),this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(F)){F=F.substring(me.raw.length),ie.push(me);continue}if(me=this.tokenizer.lheading(F)){F=F.substring(me.raw.length),ie.push(me);continue}if(oe&&(me=this.tokenizer.paragraph(F))){F=F.substring(me.raw.length),ie.push(me);continue}if(me=this.tokenizer.text(F,ie)){F=F.substring(me.raw.length),me.type?ie.push(me):(xe=ie[ie.length-1],xe.raw+=`
`+me.raw,xe.text+=`
`+me.text);continue}if(F){var qe="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return ie},te.inline=function(F){var ie,oe,me,ke,Re,xe,qe=F.length;for(ie=0;ie<qe;ie++)switch(xe=F[ie],xe.type){case"paragraph":case"text":case"heading":{xe.tokens=[],this.inlineTokens(xe.text,xe.tokens);break}case"table":{for(xe.tokens={header:[],cells:[]},ke=xe.header.length,oe=0;oe<ke;oe++)xe.tokens.header[oe]=[],this.inlineTokens(xe.header[oe],xe.tokens.header[oe]);for(ke=xe.cells.length,oe=0;oe<ke;oe++)for(Re=xe.cells[oe],xe.tokens.cells[oe]=[],me=0;me<Re.length;me++)xe.tokens.cells[oe][me]=[],this.inlineTokens(Re[me],xe.tokens.cells[oe][me]);break}case"blockquote":{this.inline(xe.tokens);break}case"list":{for(ke=xe.items.length,oe=0;oe<ke;oe++)this.inline(xe.items[oe].tokens);break}}return F},te.inlineTokens=function(F,ie,oe,me,ke){ie===void 0&&(ie=[]),oe===void 0&&(oe=!1),me===void 0&&(me=!1),ke===void 0&&(ke="");var Re,xe=F,qe;if(this.tokens.links){var Ge=Object.keys(this.tokens.links);if(Ge.length>0)for(;(qe=this.tokenizer.rules.inline.reflinkSearch.exec(xe))!=null;)Ge.includes(qe[0].slice(qe[0].lastIndexOf("[")+1,-1))&&(xe=xe.slice(0,qe.index)+"["+Y("a",qe[0].length-2)+"]"+xe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(qe=this.tokenizer.rules.inline.blockSkip.exec(xe))!=null;)xe=xe.slice(0,qe.index)+"["+Y("a",qe[0].length-2)+"]"+xe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;F;){if(Re=this.tokenizer.escape(F)){F=F.substring(Re.raw.length),ie.push(Re);continue}if(Re=this.tokenizer.tag(F,oe,me)){F=F.substring(Re.raw.length),oe=Re.inLink,me=Re.inRawBlock,ie.push(Re);continue}if(Re=this.tokenizer.link(F)){F=F.substring(Re.raw.length),Re.type==="link"&&(Re.tokens=this.inlineTokens(Re.text,[],!0,me)),ie.push(Re);continue}if(Re=this.tokenizer.reflink(F,this.tokens.links)){F=F.substring(Re.raw.length),Re.type==="link"&&(Re.tokens=this.inlineTokens(Re.text,[],!0,me)),ie.push(Re);continue}if(Re=this.tokenizer.strong(F,xe,ke)){F=F.substring(Re.raw.length),Re.tokens=this.inlineTokens(Re.text,[],oe,me),ie.push(Re);continue}if(Re=this.tokenizer.em(F,xe,ke)){F=F.substring(Re.raw.length),Re.tokens=this.inlineTokens(Re.text,[],oe,me),ie.push(Re);continue}if(Re=this.tokenizer.codespan(F)){F=F.substring(Re.raw.length),ie.push(Re);continue}if(Re=this.tokenizer.br(F)){F=F.substring(Re.raw.length),ie.push(Re);continue}if(Re=this.tokenizer.del(F)){F=F.substring(Re.raw.length),Re.tokens=this.inlineTokens(Re.text,[],oe,me),ie.push(Re);continue}if(Re=this.tokenizer.autolink(F,ve)){F=F.substring(Re.raw.length),ie.push(Re);continue}if(!oe&&(Re=this.tokenizer.url(F,ve))){F=F.substring(Re.raw.length),ie.push(Re);continue}if(Re=this.tokenizer.inlineText(F,me,le)){F=F.substring(Re.raw.length),ke=Re.raw.slice(-1),ie.push(Re);continue}if(F){var Ke="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(Ke);break}else throw new Error(Ke)}}return ie},e(ee,null,[{key:"rules",get:function(){return{block:X,inline:re}}}]),ee}(),Me=P.defaults,Ee=x.cleanUrl,Pe=x.escape,Ce=function(){function ee(G){this.options=G||Me}var te=ee.prototype;return te.code=function(F,ie,oe){var me=(ie||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(F,me);ke!=null&&ke!==F&&(oe=!0,F=ke)}return me?'<pre><code class="'+this.options.langPrefix+Pe(me,!0)+'">'+(oe?F:Pe(F,!0))+`</code></pre>
`:"<pre><code>"+(oe?F:Pe(F,!0))+`</code></pre>
`},te.blockquote=function(F){return`<blockquote>
`+F+`</blockquote>
`},te.html=function(F){return F},te.heading=function(F,ie,oe,me){return this.options.headerIds?"<h"+ie+' id="'+this.options.headerPrefix+me.slug(oe)+'">'+F+"</h"+ie+`>
`:"<h"+ie+">"+F+"</h"+ie+`>
`},te.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},te.list=function(F,ie,oe){var me=ie?"ol":"ul",ke=ie&&oe!==1?' start="'+oe+'"':"";return"<"+me+ke+`>
`+F+"</"+me+`>
`},te.listitem=function(F){return"<li>"+F+`</li>
`},te.checkbox=function(F){return"<input "+(F?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},te.paragraph=function(F){return"<p>"+F+`</p>
`},te.table=function(F,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+F+`</thead>
`+ie+`</table>
`},te.tablerow=function(F){return`<tr>
`+F+`</tr>
`},te.tablecell=function(F,ie){var oe=ie.header?"th":"td",me=ie.align?"<"+oe+' align="'+ie.align+'">':"<"+oe+">";return me+F+"</"+oe+`>
`},te.strong=function(F){return"<strong>"+F+"</strong>"},te.em=function(F){return"<em>"+F+"</em>"},te.codespan=function(F){return"<code>"+F+"</code>"},te.br=function(){return this.options.xhtml?"<br/>":"<br>"},te.del=function(F){return"<del>"+F+"</del>"},te.link=function(F,ie,oe){if(F=Ee(this.options.sanitize,this.options.baseUrl,F),F===null)return oe;var me='<a href="'+Pe(F)+'"';return ie&&(me+=' title="'+ie+'"'),me+=">"+oe+"</a>",me},te.image=function(F,ie,oe){if(F=Ee(this.options.sanitize,this.options.baseUrl,F),F===null)return oe;var me='<img src="'+F+'" alt="'+oe+'"';return ie&&(me+=' title="'+ie+'"'),me+=this.options.xhtml?"/>":">",me},te.text=function(F){return F},ee}(),Oe=function(){function ee(){}var te=ee.prototype;return te.strong=function(F){return F},te.em=function(F){return F},te.codespan=function(F){return F},te.del=function(F){return F},te.html=function(F){return F},te.text=function(F){return F},te.link=function(F,ie,oe){return""+oe},te.image=function(F,ie,oe){return""+oe},te.br=function(){return""},ee}(),Se=function(){function ee(){this.seen={}}var te=ee.prototype;return te.serialize=function(F){return F.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},te.getNextSafeSlug=function(F,ie){var oe=F,me=0;if(this.seen.hasOwnProperty(oe)){me=this.seen[F];do me++,oe=F+"-"+me;while(this.seen.hasOwnProperty(oe))}return ie||(this.seen[F]=me,this.seen[oe]=0),oe},te.slug=function(F,ie){ie===void 0&&(ie={});var oe=this.serialize(F);return this.getNextSafeSlug(oe,ie.dryrun)},ee}(),Be=P.defaults,K=x.unescape,se=function(){function ee(G){this.options=G||Be,this.options.renderer=this.options.renderer||new Ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Oe,this.slugger=new Se}ee.parse=function(F,ie){var oe=new ee(ie);return oe.parse(F)},ee.parseInline=function(F,ie){var oe=new ee(ie);return oe.parseInline(F)};var te=ee.prototype;return te.parse=function(F,ie){ie===void 0&&(ie=!0);var oe="",me,ke,Re,xe,qe,Ge,Ke,st,$e,Xe,ft,et,mt,ot,Ze,St,_t,gt,at=F.length;for(me=0;me<at;me++)switch(Xe=F[me],Xe.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(Xe.tokens),Xe.depth,K(this.parseInline(Xe.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(Xe.text,Xe.lang,Xe.escaped);continue}case"table":{for(st="",Ke="",xe=Xe.header.length,ke=0;ke<xe;ke++)Ke+=this.renderer.tablecell(this.parseInline(Xe.tokens.header[ke]),{header:!0,align:Xe.align[ke]});for(st+=this.renderer.tablerow(Ke),$e="",xe=Xe.cells.length,ke=0;ke<xe;ke++){for(Ge=Xe.tokens.cells[ke],Ke="",qe=Ge.length,Re=0;Re<qe;Re++)Ke+=this.renderer.tablecell(this.parseInline(Ge[Re]),{header:!1,align:Xe.align[Re]});$e+=this.renderer.tablerow(Ke)}oe+=this.renderer.table(st,$e);continue}case"blockquote":{$e=this.parse(Xe.tokens),oe+=this.renderer.blockquote($e);continue}case"list":{for(ft=Xe.ordered,et=Xe.start,mt=Xe.loose,xe=Xe.items.length,$e="",ke=0;ke<xe;ke++)Ze=Xe.items[ke],St=Ze.checked,_t=Ze.task,ot="",Ze.task&&(gt=this.renderer.checkbox(St),mt?Ze.tokens.length>0&&Ze.tokens[0].type==="text"?(Ze.tokens[0].text=gt+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=gt+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:gt}):ot+=gt),ot+=this.parse(Ze.tokens,mt),$e+=this.renderer.listitem(ot,_t,St);oe+=this.renderer.list($e,ft,et);continue}case"html":{oe+=this.renderer.html(Xe.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(Xe.tokens));continue}case"text":{for($e=Xe.tokens?this.parseInline(Xe.tokens):Xe.text;me+1<at&&F[me+1].type==="text";)Xe=F[++me],$e+=`
`+(Xe.tokens?this.parseInline(Xe.tokens):Xe.text);oe+=ie?this.renderer.paragraph($e):$e;continue}default:{var ut='Token with "'+Xe.type+'" type was not found.';if(this.options.silent){console.error(ut);return}else throw new Error(ut)}}return oe},te.parseInline=function(F,ie){ie=ie||this.renderer;var oe="",me,ke,Re=F.length;for(me=0;me<Re;me++)switch(ke=F[me],ke.type){case"escape":{oe+=ie.text(ke.text);break}case"html":{oe+=ie.html(ke.text);break}case"link":{oe+=ie.link(ke.href,ke.title,this.parseInline(ke.tokens,ie));break}case"image":{oe+=ie.image(ke.href,ke.title,ke.text);break}case"strong":{oe+=ie.strong(this.parseInline(ke.tokens,ie));break}case"em":{oe+=ie.em(this.parseInline(ke.tokens,ie));break}case"codespan":{oe+=ie.codespan(ke.text);break}case"br":{oe+=ie.br();break}case"del":{oe+=ie.del(this.parseInline(ke.tokens,ie));break}case"text":{oe+=ie.text(ke.text);break}default:{var xe='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(xe);return}else throw new Error(xe)}}return oe},ee}(),_e=x.merge,Ae=x.checkSanitizeDeprecation,Ue=x.escape,ze=P.getDefaults,je=P.changeDefaults,ue=P.defaults;function ye(ee,te,G){if(typeof ee=="undefined"||ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ee)+", string expected");if(typeof te=="function"&&(G=te,te=null),te=_e({},ye.defaults,te||{}),Ae(te),G){var F=te.highlight,ie;try{ie=De.lex(ee,te)}catch(Re){return G(Re)}var oe=function(xe){var qe;if(!xe)try{qe=se.parse(ie,te)}catch(Ge){xe=Ge}return te.highlight=F,xe?G(xe):G(null,qe)};if(!F||F.length<3||(delete te.highlight,!ie.length))return oe();var me=0;ye.walkTokens(ie,function(Re){Re.type==="code"&&(me++,setTimeout(function(){F(Re.text,Re.lang,function(xe,qe){if(xe)return oe(xe);qe!=null&&qe!==Re.text&&(Re.text=qe,Re.escaped=!0),me--,me===0&&oe()})},0))}),me===0&&oe();return}try{var ke=De.lex(ee,te);return te.walkTokens&&ye.walkTokens(ke,te.walkTokens),se.parse(ke,te)}catch(Re){if(Re.message+=`
Please report this to https://github.com/markedjs/marked.`,te.silent)return"<p>An error occurred:</p><pre>"+Ue(Re.message+"",!0)+"</pre>";throw Re}}ye.options=ye.setOptions=function(ee){return _e(ye.defaults,ee),je(ye.defaults),ye},ye.getDefaults=ze,ye.defaults=ue,ye.use=function(ee){var te=_e({},ee);if(ee.renderer&&function(){var F=ye.defaults.renderer||new Ce,ie=function(ke){var Re=F[ke];F[ke]=function(){for(var xe=arguments.length,qe=new Array(xe),Ge=0;Ge<xe;Ge++)qe[Ge]=arguments[Ge];var Ke=ee.renderer[ke].apply(F,qe);return Ke===!1&&(Ke=Re.apply(F,qe)),Ke}};for(var oe in ee.renderer)ie(oe);te.renderer=F}(),ee.tokenizer&&function(){var F=ye.defaults.tokenizer||new z,ie=function(ke){var Re=F[ke];F[ke]=function(){for(var xe=arguments.length,qe=new Array(xe),Ge=0;Ge<xe;Ge++)qe[Ge]=arguments[Ge];var Ke=ee.tokenizer[ke].apply(F,qe);return Ke===!1&&(Ke=Re.apply(F,qe)),Ke}};for(var oe in ee.tokenizer)ie(oe);te.tokenizer=F}(),ee.walkTokens){var G=ye.defaults.walkTokens;te.walkTokens=function(F){ee.walkTokens(F),G&&G(F)}}ye.setOptions(te)},ye.walkTokens=function(ee,te){for(var G=R(ee),F;!(F=G()).done;){var ie=F.value;switch(te(ie),ie.type){case"table":{for(var oe=R(ie.tokens.header),me;!(me=oe()).done;){var ke=me.value;ye.walkTokens(ke,te)}for(var Re=R(ie.tokens.cells),xe;!(xe=Re()).done;)for(var qe=xe.value,Ge=R(qe),Ke;!(Ke=Ge()).done;){var st=Ke.value;ye.walkTokens(st,te)}break}case"list":{ye.walkTokens(ie.items,te);break}default:ie.tokens&&ye.walkTokens(ie.tokens,te)}}},ye.parseInline=function(ee,te){if(typeof ee=="undefined"||ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ee)+", string expected");te=_e({},ye.defaults,te||{}),Ae(te);try{var G=De.lexInline(ee,te);return te.walkTokens&&ye.walkTokens(G,te.walkTokens),se.parseInline(G,te)}catch(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,te.silent)return"<p>An error occurred:</p><pre>"+Ue(F.message+"",!0)+"</pre>";throw F}},ye.Parser=se,ye.parser=se.parse,ye.Renderer=Ce,ye.TextRenderer=Oe,ye.Lexer=De,ye.lexer=De.lex,ye.Tokenizer=z,ye.Slugger=Se,ye.parse=ye;var Ne=ye;return Ne}),define(ge[74],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(P,D,I){return Math.min(Math.max(P,D),I)}e.clamp=_;function k(P,D){return(D+P%D)%D}e.rot=k;class R{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=R;class T{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";function ci(Z){const e=[];typeof Z=="number"&&e.push("code/timeOrigin",Z);function _(R){e.push(R,Date.now())}function k(){const R=[];for(let T=0;T<e.length;T+=2)R.push({name:e[T],startTime:e[T+1]});return R}return{mark:_,getMarks:k}}function Ii(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ci():{mark(Z){performance.mark(Z)},getMarks(){let Z=performance.timeOrigin;typeof Z!="number"&&(Z=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const e=[{name:"code/timeOrigin",startTime:Math.round(Z)}];for(const _ of performance.getEntriesByType("mark"))e.push({name:_.name,startTime:Math.round(Z+_.startTime)});return e}};if(typeof process=="object"){const Z=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ci(Z)}else return console.trace("perf-util loaded in UNKNOWN environment"),ci()}function ui(Z){return Z.MonacoPerformanceMarks||(Z.MonacoPerformanceMarks=Ii()),Z.MonacoPerformanceMarks}var At;typeof global=="object"?At=global:typeof self=="object"?At=self:At={},typeof define=="function"?define("vs/base/common/performance",[],function(){return ui(At)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=ui(At):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),At.perf=ui(At)),define(ge[9],pe([0,1]),function(Z,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const k="en";let R=!1,T=!1,P=!1,D=!1,I=!1,n=!1,C=!1,S,v=k,f,u;const m=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof process!="undefined"?w=process:typeof m.vscode!="undefined"&&(w=m.vscode.process);const p=typeof((_=w==null?void 0:w.versions)===null||_===void 0?void 0:_.electron)=="string"&&w.type==="renderer";if(e.isElectronSandboxed=p&&(w==null?void 0:w.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=w==null?void 0:w.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p){u=navigator.userAgent,R=u.indexOf("Windows")>=0,T=u.indexOf("Macintosh")>=0,C=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=u.indexOf("Linux")>=0,n=!0,S=navigator.language,v=S;const i=typeof document!="undefined"&&document.getElementById("vscode-remote-nls-configuration"),h=i&&i.getAttribute("data-settings");if(h)try{const y=JSON.parse(h);S=y.locale,f=y._translationsConfigFile,v=y.availableLanguages["*"]||k}catch(y){}}else if(typeof w=="object"){R=w.platform==="win32",T=w.platform==="darwin",P=w.platform==="linux",D=P&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,S=k,v=k;const i=w.env.VSCODE_NLS_CONFIG;if(i)try{const h=JSON.parse(i),y=h.availableLanguages["*"];S=h.locale,v=y||k,f=h._translationsConfigFile}catch(h){}I=!0}else console.error("Unable to resolve platform.");var d;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function s(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=s;let a=0;T?a=1:R?a=3:P&&(a=2),e.isWindows=R,e.isMacintosh=T,e.isLinux=P,e.isLinuxSnap=D,e.isNative=I,e.isWeb=n,e.isIOS=C,e.platform=a,e.userAgent=u,e.language=v;var c;(function(i){function h(){return e.language}i.value=h;function y(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=y;function g(){return e.language==="en"}i.isDefault=g})(c=e.Language||(e.Language={})),e.locale=S,e.translationsConfigFile=f,e.globals=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let y=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeSetImmediateId)for(let b=0,L=y.length;b<L;b++){const A=y[b];if(A.id===E.data.vscodeSetImmediateId){y.splice(b,1),A.callback();return}}});let g=0;return E=>{const b=++g;y.push({id:b,callback:E}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(w)return w.nextTick.bind(w);const h=Promise.resolve();return y=>h.then(y)}();var t;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||C?2:R?1:3;let r=!0,o=!1;function l(){if(!o){o=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,r=new Uint16Array(i.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=l}),define(ge[38],pe([0,1,9]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;typeof process!="undefined"?k=process:typeof _.globals.vscode!="undefined"?k={get platform(){return _.globals.vscode.process.platform},get env(){return _.globals.vscode.process.env},nextTick(R){return _.setImmediate(R)},cwd(){return _.globals.vscode.process.env.VSCODE_CWD||_.globals.vscode.process.execPath.substr(0,_.globals.vscode.process.execPath.lastIndexOf(_.globals.vscode.process.platform==="win32"?"\\":"/"))}}:k={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(R){return _.setImmediate(R)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(ge[7],pe([0,1,38]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,R=97,T=90,P=122,D=46,I=47,n=92,C=58,S=63;class v extends Error{constructor(a,c,t){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const o=a.indexOf(".")!==-1?"property":"argument";let l=`The "${a}" ${o} ${r} of type ${c}`;l+=`. Received type ${typeof t}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function f(s,a){if(typeof s!="string")throw new v(a,"string",s)}function u(s){return s===I||s===n}function m(s){return s===I}function w(s){return s>=k&&s<=T||s>=R&&s<=P}function p(s,a,c,t){let r="",o=0,l=-1,i=0,h=0;for(let y=0;y<=s.length;++y){if(y<s.length)h=s.charCodeAt(y);else{if(t(h))break;h=I}if(t(h)){if(!(l===y-1||i===1))if(i===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==D||r.charCodeAt(r.length-2)!==D){if(r.length>2){const g=r.lastIndexOf(c);g===-1?(r="",o=0):(r=r.slice(0,g),o=r.length-1-r.lastIndexOf(c)),l=y,i=0;continue}else if(r.length!==0){r="",o=0,l=y,i=0;continue}}a&&(r+=r.length>0?`${c}..`:"..",o=2)}else r.length>0?r+=`${c}${s.slice(l+1,y)}`:r=s.slice(l+1,y),o=y-l-1;l=y,i=0}else h===D&&i!==-1?++i:i=-1}return r}function d(s,a){if(a===null||typeof a!="object")throw new v("pathObject","Object",a);const c=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return c?c===a.root?`${c}${t}`:`${c}${s}${t}`:t}e.win32={resolve(...s){let a="",c="",t=!1;for(let r=s.length-1;r>=-1;r--){let o;if(r>=0){if(o=s[r],f(o,"path"),o.length===0)continue}else a.length===0?o=_.cwd():(o=_.env[`=${a}`]||_.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==a.toLowerCase()&&o.charCodeAt(2)===n)&&(o=`${a}\\`));const l=o.length;let i=0,h="",y=!1;const g=o.charCodeAt(0);if(l===1)u(g)&&(i=1,y=!0);else if(u(g))if(y=!0,u(o.charCodeAt(1))){let E=2,b=E;for(;E<l&&!u(o.charCodeAt(E));)E++;if(E<l&&E!==b){const L=o.slice(b,E);for(b=E;E<l&&u(o.charCodeAt(E));)E++;if(E<l&&E!==b){for(b=E;E<l&&!u(o.charCodeAt(E));)E++;(E===l||E!==b)&&(h=`\\\\${L}\\${o.slice(b,E)}`,i=E)}}}else i=1;else w(g)&&o.charCodeAt(1)===C&&(h=o.slice(0,2),i=2,l>2&&u(o.charCodeAt(2))&&(y=!0,i=3));if(h.length>0)if(a.length>0){if(h.toLowerCase()!==a.toLowerCase())continue}else a=h;if(t){if(a.length>0)break}else if(c=`${o.slice(i)}\\${c}`,t=y,y&&a.length>0)break}return c=p(c,!t,"\\",u),t?`${a}\\${c}`:`${a}${c}`||"."},normalize(s){f(s,"path");const a=s.length;if(a===0)return".";let c=0,t,r=!1;const o=s.charCodeAt(0);if(a===1)return m(o)?"\\":s;if(u(o))if(r=!0,u(s.charCodeAt(1))){let i=2,h=i;for(;i<a&&!u(s.charCodeAt(i));)i++;if(i<a&&i!==h){const y=s.slice(h,i);for(h=i;i<a&&u(s.charCodeAt(i));)i++;if(i<a&&i!==h){for(h=i;i<a&&!u(s.charCodeAt(i));)i++;if(i===a)return`\\\\${y}\\${s.slice(h)}\\`;i!==h&&(t=`\\\\${y}\\${s.slice(h,i)}`,c=i)}}}else c=1;else w(o)&&s.charCodeAt(1)===C&&(t=s.slice(0,2),c=2,a>2&&u(s.charCodeAt(2))&&(r=!0,c=3));let l=c<a?p(s.slice(c),!r,"\\",u):"";return l.length===0&&!r&&(l="."),l.length>0&&u(s.charCodeAt(a-1))&&(l+="\\"),t===void 0?r?`\\${l}`:l:r?`${t}\\${l}`:`${t}${l}`},isAbsolute(s){f(s,"path");const a=s.length;if(a===0)return!1;const c=s.charCodeAt(0);return u(c)||a>2&&w(c)&&s.charCodeAt(1)===C&&u(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,c;for(let o=0;o<s.length;++o){const l=s[o];f(l,"path"),l.length>0&&(a===void 0?a=c=l:a+=`\\${l}`)}if(a===void 0)return".";let t=!0,r=0;if(typeof c=="string"&&u(c.charCodeAt(0))){++r;const o=c.length;o>1&&u(c.charCodeAt(1))&&(++r,o>2&&(u(c.charCodeAt(2))?++r:t=!1))}if(t){for(;r<a.length&&u(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(s,a){if(f(s,"from"),f(a,"to"),s===a)return"";const c=e.win32.resolve(s),t=e.win32.resolve(a);if(c===t||(s=c.toLowerCase(),a=t.toLowerCase(),s===a))return"";let r=0;for(;r<s.length&&s.charCodeAt(r)===n;)r++;let o=s.length;for(;o-1>r&&s.charCodeAt(o-1)===n;)o--;const l=o-r;let i=0;for(;i<a.length&&a.charCodeAt(i)===n;)i++;let h=a.length;for(;h-1>i&&a.charCodeAt(h-1)===n;)h--;const y=h-i,g=l<y?l:y;let E=-1,b=0;for(;b<g;b++){const A=s.charCodeAt(r+b);if(A!==a.charCodeAt(i+b))break;A===n&&(E=b)}if(b!==g){if(E===-1)return t}else{if(y>g){if(a.charCodeAt(i+b)===n)return t.slice(i+b+1);if(b===2)return t.slice(i+b)}l>g&&(s.charCodeAt(r+b)===n?E=b:b===2&&(E=3)),E===-1&&(E=0)}let L="";for(b=r+E+1;b<=o;++b)(b===o||s.charCodeAt(b)===n)&&(L+=L.length===0?"..":"\\..");return i+=E,L.length>0?`${L}${t.slice(i,h)}`:(t.charCodeAt(i)===n&&++i,t.slice(i,h))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const a=e.win32.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===n){if(a.charCodeAt(1)===n){const c=a.charCodeAt(2);if(c!==S&&c!==D)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(w(a.charCodeAt(0))&&a.charCodeAt(1)===C&&a.charCodeAt(2)===n)return`\\\\?\\${a}`;return s},dirname(s){f(s,"path");const a=s.length;if(a===0)return".";let c=-1,t=0;const r=s.charCodeAt(0);if(a===1)return u(r)?s:".";if(u(r)){if(c=t=1,u(s.charCodeAt(1))){let i=2,h=i;for(;i<a&&!u(s.charCodeAt(i));)i++;if(i<a&&i!==h){for(h=i;i<a&&u(s.charCodeAt(i));)i++;if(i<a&&i!==h){for(h=i;i<a&&!u(s.charCodeAt(i));)i++;if(i===a)return s;i!==h&&(c=t=i+1)}}}}else w(r)&&s.charCodeAt(1)===C&&(c=a>2&&u(s.charCodeAt(2))?3:2,t=c);let o=-1,l=!0;for(let i=a-1;i>=t;--i)if(u(s.charCodeAt(i))){if(!l){o=i;break}}else l=!1;if(o===-1){if(c===-1)return".";o=c}return s.slice(0,o)},basename(s,a){a!==void 0&&f(a,"ext"),f(s,"path");let c=0,t=-1,r=!0,o;if(s.length>=2&&w(s.charCodeAt(0))&&s.charCodeAt(1)===C&&(c=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let l=a.length-1,i=-1;for(o=s.length-1;o>=c;--o){const h=s.charCodeAt(o);if(u(h)){if(!r){c=o+1;break}}else i===-1&&(r=!1,i=o+1),l>=0&&(h===a.charCodeAt(l)?--l==-1&&(t=o):(l=-1,t=i))}return c===t?t=i:t===-1&&(t=s.length),s.slice(c,t)}for(o=s.length-1;o>=c;--o)if(u(s.charCodeAt(o))){if(!r){c=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":s.slice(c,t)},extname(s){f(s,"path");let a=0,c=-1,t=0,r=-1,o=!0,l=0;s.length>=2&&s.charCodeAt(1)===C&&w(s.charCodeAt(0))&&(a=t=2);for(let i=s.length-1;i>=a;--i){const h=s.charCodeAt(i);if(u(h)){if(!o){t=i+1;break}continue}r===-1&&(o=!1,r=i+1),h===D?c===-1?c=i:l!==1&&(l=1):c!==-1&&(l=-1)}return c===-1||r===-1||l===0||l===1&&c===r-1&&c===t+1?"":s.slice(c,r)},format:d.bind(null,"\\"),parse(s){f(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const c=s.length;let t=0,r=s.charCodeAt(0);if(c===1)return u(r)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(u(r)){if(t=1,u(s.charCodeAt(1))){let E=2,b=E;for(;E<c&&!u(s.charCodeAt(E));)E++;if(E<c&&E!==b){for(b=E;E<c&&u(s.charCodeAt(E));)E++;if(E<c&&E!==b){for(b=E;E<c&&!u(s.charCodeAt(E));)E++;E===c?t=E:E!==b&&(t=E+1)}}}}else if(w(r)&&s.charCodeAt(1)===C){if(c<=2)return a.root=a.dir=s,a;if(t=2,u(s.charCodeAt(2))){if(c===3)return a.root=a.dir=s,a;t=3}}t>0&&(a.root=s.slice(0,t));let o=-1,l=t,i=-1,h=!0,y=s.length-1,g=0;for(;y>=t;--y){if(r=s.charCodeAt(y),u(r)){if(!h){l=y+1;break}continue}i===-1&&(h=!1,i=y+1),r===D?o===-1?o=y:g!==1&&(g=1):o!==-1&&(g=-1)}return i!==-1&&(o===-1||g===0||g===1&&o===i-1&&o===l+1?a.base=a.name=s.slice(l,i):(a.name=s.slice(l,o),a.base=s.slice(l,i),a.ext=s.slice(o,i))),l>0&&l!==t?a.dir=s.slice(0,l-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...s){let a="",c=!1;for(let t=s.length-1;t>=-1&&!c;t--){const r=t>=0?s[t]:_.cwd();f(r,"path"),r.length!==0&&(a=`${r}/${a}`,c=r.charCodeAt(0)===I)}return a=p(a,!c,"/",m),c?`/${a}`:a.length>0?a:"."},normalize(s){if(f(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===I,c=s.charCodeAt(s.length-1)===I;return s=p(s,!a,"/",m),s.length===0?a?"/":c?"./":".":(c&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return f(s,"path"),s.length>0&&s.charCodeAt(0)===I},join(...s){if(s.length===0)return".";let a;for(let c=0;c<s.length;++c){const t=s[c];f(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(s,a){if(f(s,"from"),f(a,"to"),s===a||(s=e.posix.resolve(s),a=e.posix.resolve(a),s===a))return"";const c=1,t=s.length,r=t-c,o=1,l=a.length-o,i=r<l?r:l;let h=-1,y=0;for(;y<i;y++){const E=s.charCodeAt(c+y);if(E!==a.charCodeAt(o+y))break;E===I&&(h=y)}if(y===i)if(l>i){if(a.charCodeAt(o+y)===I)return a.slice(o+y+1);if(y===0)return a.slice(o+y)}else r>i&&(s.charCodeAt(c+y)===I?h=y:y===0&&(h=0));let g="";for(y=c+h+1;y<=t;++y)(y===t||s.charCodeAt(y)===I)&&(g+=g.length===0?"..":"/..");return`${g}${a.slice(o+h)}`},toNamespacedPath(s){return s},dirname(s){if(f(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===I;let c=-1,t=!0;for(let r=s.length-1;r>=1;--r)if(s.charCodeAt(r)===I){if(!t){c=r;break}}else t=!1;return c===-1?a?"/":".":a&&c===1?"//":s.slice(0,c)},basename(s,a){a!==void 0&&f(a,"ext"),f(s,"path");let c=0,t=-1,r=!0,o;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let l=a.length-1,i=-1;for(o=s.length-1;o>=0;--o){const h=s.charCodeAt(o);if(h===I){if(!r){c=o+1;break}}else i===-1&&(r=!1,i=o+1),l>=0&&(h===a.charCodeAt(l)?--l==-1&&(t=o):(l=-1,t=i))}return c===t?t=i:t===-1&&(t=s.length),s.slice(c,t)}for(o=s.length-1;o>=0;--o)if(s.charCodeAt(o)===I){if(!r){c=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":s.slice(c,t)},extname(s){f(s,"path");let a=-1,c=0,t=-1,r=!0,o=0;for(let l=s.length-1;l>=0;--l){const i=s.charCodeAt(l);if(i===I){if(!r){c=l+1;break}continue}t===-1&&(r=!1,t=l+1),i===D?a===-1?a=l:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||t===-1||o===0||o===1&&a===t-1&&a===c+1?"":s.slice(a,t)},format:d.bind(null,"/"),parse(s){f(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const c=s.charCodeAt(0)===I;let t;c?(a.root="/",t=1):t=0;let r=-1,o=0,l=-1,i=!0,h=s.length-1,y=0;for(;h>=t;--h){const g=s.charCodeAt(h);if(g===I){if(!i){o=h+1;break}continue}l===-1&&(i=!1,l=h+1),g===D?r===-1?r=h:y!==1&&(y=1):r!==-1&&(y=-1)}if(l!==-1){const g=o===0&&c?1:o;r===-1||y===0||y===1&&r===l-1&&r===o+1?a.base=a.name=s.slice(g,l):(a.name=s.slice(g,r),a.base=s.slice(g,l),a.ext=s.slice(r,l))}return o>0?a.dir=s.slice(0,o-1):c&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[132],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var k;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(T,...P){const D=P.reduce((C,S)=>(C[S]=!0,C),{}),I=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/];Object.keys(T).filter(C=>!D[C]).forEach(C=>{for(let S=0;S<I.length;S++)if(C.search(I[S])!==-1){delete T[C];break}})}e.sanitizeProcessEnvironment=R}),define(ge[47],pe([0,1,9]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=_.globals.performance&&typeof _.globals.performance.now=="function";class R{constructor(P){this._highResolution=k&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new R(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=R}),define(ge[3],pe([0,1,15,70,5,73,47]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.AsyncEmitter=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(d){d.None=()=>R.Disposable.None;function s(M){return($,O=null,B)=>{let J=!1,U;return U=M(V=>{if(!J)return U?U.dispose():J=!0,$.call(O,V)},null,B),J&&U.dispose(),U}}d.once=s;function a(M,$){return i((O,B=null,J)=>M(U=>O.call(B,$(U)),null,J))}d.map=a;function c(M,$){return i((O,B=null,J)=>M(U=>{$(U),O.call(B,U)},null,J))}d.forEach=c;function t(M,$){return i((O,B=null,J)=>M(U=>$(U)&&O.call(B,U),null,J))}d.filter=t;function r(M){return M}d.signal=r;function o(...M){return($,O=null,B)=>R.combinedDisposable(...M.map(J=>J(U=>$.call(O,U),null,B)))}d.any=o;function l(M,$,O){let B=O;return a(M,J=>(B=$(B,J),B))}d.reduce=l;function i(M){let $;const O=new v({onFirstListenerAdd(){$=M(O.fire,O)},onLastListenerRemove(){$.dispose()}});return O.event}d.snapshot=i;function h(M,$,O=100,B=!1,J){let U,V,z,Q=0;const ae=new v({leakWarningThreshold:J,onFirstListenerAdd(){U=M(ce=>{Q++,V=$(V,ce),B&&!z&&(ae.fire(V),V=void 0),clearTimeout(z),z=setTimeout(()=>{const fe=V;V=void 0,z=void 0,(!B||Q>1)&&ae.fire(fe),Q=0},O)})},onLastListenerRemove(){U.dispose()}});return ae.event}d.debounce=h;function y(M){const $=new Date().getTime();return a(s(M),O=>new Date().getTime()-$)}d.stopwatch=y;function g(M){let $=!0,O;return t(M,B=>{const J=$||B!==O;return $=!1,O=B,J})}d.latch=g;function E(M,$=!1,O=[]){let B=O.slice(),J=M(z=>{B?B.push(z):V.fire(z)});const U=()=>{B&&B.forEach(z=>V.fire(z)),B=null},V=new v({onFirstListenerAdd(){J||(J=M(z=>V.fire(z)))},onFirstListenerDidAdd(){B&&($?setTimeout(U):U())},onLastListenerRemove(){J&&J.dispose(),J=null}});return V.event}d.buffer=E;class b{constructor($){this.event=$}map($){return new b(a(this.event,$))}forEach($){return new b(c(this.event,$))}filter($){return new b(t(this.event,$))}reduce($,O){return new b(l(this.event,$,O))}latch(){return new b(g(this.event))}debounce($,O=100,B=!1,J){return new b(h(this.event,$,O,B,J))}on($,O,B){return this.event($,O,B)}once($,O,B){return s(this.event)($,O,B)}}function L(M){return new b(M)}d.chain=L;function A(M,$,O=B=>B){const B=(...z)=>V.fire(O(...z)),J=()=>M.on($,B),U=()=>M.removeListener($,B),V=new v({onFirstListenerAdd:J,onLastListenerRemove:U});return V.event}d.fromNodeEventEmitter=A;function N(M,$,O=B=>B){const B=(...z)=>V.fire(O(...z)),J=()=>M.addEventListener($,B),U=()=>M.removeEventListener($,B),V=new v({onFirstListenerAdd:J,onLastListenerRemove:U});return V.event}d.fromDOMEventEmitter=N;function W(M){const $=new v;let O=!1;return M.then(void 0,()=>null).then(()=>{O?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),O=!0,$.event}d.fromPromise=W;function x(M){return new Promise($=>s(M)($))}d.toPromise=x})(D=e.Event||(e.Event={}));class I{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${I._idPool++}`}start(s){this._stopWatch=new P.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}I._idPool=0;let n=-1;function C(d){const s=n;return n=d,{dispose(){n=s}}}e.setGlobalLeakWarningThreshold=C;class S{constructor(s,a=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let a=n;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),!(a<=0||s<a)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),t=this._stacks.get(c)||0;if(this._stacks.set(c,t+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let r,o=0;for(const[l,i]of this._stacks)(!r||o<i)&&(r=l,o=i);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${o}):`),console.warn(r)}return()=>{const r=this._stacks.get(c)||0;this._stacks.set(c,r-1)}}}}class v{constructor(s){var a;this._disposed=!1,this._options=s,this._leakageMon=n>0?new S(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((a=this._options)===null||a===void 0?void 0:a._profName)?new I(this._options._profName):void 0}get event(){return this._event||(this._event=(s,a,c)=>{var t;this._listeners||(this._listeners=new T.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(a?[s,a]:s);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,a);const l=(t=this._leakageMon)===null||t===void 0?void 0:t.check(this._listeners.size);let i;return i={dispose:()=>{l&&l(),i.dispose=v._noop,this._disposed||(o(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof R.DisposableStore?c.add(i):Array.isArray(c)&&c.push(i),i}),this._event}fire(s){var a,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,s]);for((a=this._perfMon)===null||a===void 0||a.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,r]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,r):t[0].call(t[1],r)}catch(o){_.onUnexpectedError(o)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var s,a,c;(s=this._listeners)===null||s===void 0||s.clear(),(a=this._deliveryQueue)===null||a===void 0||a.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=v,v._noop=function(){};class f extends v{constructor(s){super(s);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=s==null?void 0:s.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=f;class u extends v{async fireAsync(s,a,c){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const t of this._listeners)this._asyncDeliveryQueue.push([t,s]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[t,r]=this._asyncDeliveryQueue.shift(),o=[],l=Object.assign(Object.assign({},r),{waitUntil:i=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");c&&(i=c(i,typeof t=="function"?t:t[0])),o.push(i)}});try{typeof t=="function"?t.call(void 0,l):t[0].call(t[1],l)}catch(i){_.onUnexpectedError(i);continue}Object.freeze(o),await Promise.all(o).catch(i=>_.onUnexpectedError(i))}}}}e.AsyncEmitter=u;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const a={event:s,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const c=()=>{this.hasListeners&&this.unhook(a);const t=this.events.indexOf(a);this.events.splice(t,1)};return R.toDisposable(k.once(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(a=>this.emitter.fire(a))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class w{constructor(){this.buffers=[]}wrapEvent(s){return(a,c,t)=>s(r=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>a.call(c,r)):a.call(c,r)},void 0,t)}bufferEvents(s){const a=[];this.buffers.push(a);const c=s();return this.buffers.pop(),a.forEach(t=>t()),c}}e.EventBufferer=w;class p{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=R.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(ge[21],pe([0,1,3]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(D,I){const n=setTimeout(D.bind(I),0);return{dispose(){clearTimeout(n)}}});var R;(function(D){function I(n){return n===D.None||n===D.Cancelled||n instanceof T?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}D.isCancellationToken=I,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(R=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=R.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=P}),define(ge[19],pe([0,1,21,15,3,5]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(x){return x&&typeof x.then=="function"}e.isThenable=P;function D(x){const M=new _.CancellationTokenSource,$=x(M.token),O=new Promise((B,J)=>{M.token.onCancellationRequested(()=>{J(k.canceled())}),Promise.resolve($).then(U=>{M.dispose(),B(U)},U=>{M.dispose(),J(U)})});return new class{cancel(){M.cancel()}then(B,J){return O.then(B,J)}catch(B){return this.then(void 0,B)}finally(B){return O.finally(B)}}}e.createCancelablePromise=D;function I(x,M,$){return Promise.race([x,new Promise(O=>M.onCancellationRequested(()=>O($)))])}e.raceCancellation=I;async function n(x){let M=-1;const $=x.map((B,J)=>B.then(U=>(M=J,U))),O=await Promise.race($);return x.forEach((B,J)=>{J!==M&&B.cancel()}),O}e.raceCancellablePromises=n;function C(x,M,$){let O;const B=setTimeout(()=>{O==null||O(void 0),$==null||$()},M);return Promise.race([x.finally(()=>clearTimeout(B)),new Promise(J=>O=J)])}e.raceTimeout=C;function S(x){return new Promise((M,$)=>{const O=x();P(O)?O.then(M,$):M(O)})}e.asPromise=S;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then($,$).then(O)})}return new Promise(($,O)=>{this.queuedPromise.then($,O)})}return this.activePromise=M(),new Promise(($,O)=>{this.activePromise.then(B=>{this.activePromise=null,$(B)},B=>{this.activePromise=null,O(B)})})}}e.Throttler=v;class f{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=f;class u{constructor(){this.promiseMap=new Map}queue(M,$){var O;const J=((O=this.promiseMap.get(M))!==null&&O!==void 0?O:Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(M)===J&&this.promiseMap.delete(M)});return this.promiseMap.set(M,J),J}}e.SequencerByKey=u;class m{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,$=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,B)=>{this.doResolve=O,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(k.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class w{constructor(M){this.delayer=new m(M),this.throttler=new v}trigger(M,$){return this.delayer.trigger(()=>this.throttler.queue(M),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class p{constructor(){this._isOpen=!1,this._promise=new Promise((M,$)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=p;function d(x,M){return M?new Promise(($,O)=>{const B=setTimeout($,x);M.onCancellationRequested(()=>{clearTimeout(B),O(k.canceled())})}):D($=>d(x,$))}e.timeout=d;function s(x,M=0){const $=setTimeout(x,M);return T.toDisposable(()=>clearTimeout($))}e.disposableTimeout=s;function a(x){return x.then(void 0,M=>{})}e.ignoreErrors=a;function c(x){const M=[];let $=0;const O=x.length;function B(){return $<O?x[$++]():null}function J(U){U!=null&&M.push(U);const V=B();return V?V.then(J):Promise.resolve(M)}return Promise.resolve(null).then(J)}e.sequence=c;function t(x,M=O=>!!O,$=null){let O=0;const B=x.length,J=()=>{if(O>=B)return Promise.resolve($);const U=x[O++];return Promise.resolve(U()).then(z=>M(z)?Promise.resolve(z):J())};return J()}e.first=t;function r(x,M=O=>!!O,$=null){if(x.length===0)return Promise.resolve($);let O=x.length;const B=()=>{var J,U;O=-1;for(const V of x)(U=(J=V).cancel)===null||U===void 0||U.call(J)};return new Promise((J,U)=>{for(const V of x)V.then(z=>{--O>=0&&M(z)?(B(),J(z)):O===0&&J($)}).catch(z=>{--O>=0&&(B(),U(z))})})}e.firstParallel=r;class o{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise(($,O)=>{this.outstandingPromises.push({factory:M,c:$,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const $=M.factory();$.then(M.c,M.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class l extends o{constructor(){super(1)}}e.Queue=l;class i{constructor(){this.queues=new Map}queueFor(M){const $=M.toString();if(!this.queues.has($)){const O=new l;O.onFinished(()=>{O.dispose(),this.queues.delete($)}),this.queues.set($,O)}return this.queues.get($)}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=i;class h{constructor(M,$){this._token=-1,typeof M=="function"&&typeof $=="number"&&this.setIfNotSet(M,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},$)}setIfNotSet(M,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},$))}}e.TimeoutTimer=h;class y{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,$){this.cancel(),this._token=setInterval(()=>{M()},$)}}e.IntervalTimer=y;class g{constructor(M,$){this.timeoutToken=-1,this.runner=M,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=g;class E extends g{constructor(M,$){super(M,$);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=E,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const $=setTimeout(()=>M(x));let O=!1;return{dispose(){O||(O=!0,clearTimeout($))}}}}else e.runWhenIdle=(x,M)=>{const $=requestIdleCallback(x,typeof M=="number"?{timeout:M}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback($))}}}}();class b{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=b;async function L(x,M,$){let O;for(let B=0;B<$;B++)try{return await x()}catch(J){O=J,await d(M)}throw O}e.retry=L;class A{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,$,O){return this._pending={taskId:M,cancel:()=>O==null?void 0:O(),promise:$},$.then(()=>this.donePending(M),()=>this.donePending(M)),$}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let $,O;const B=new Promise((J,U)=>{$=J,O=U});this._next={run:M,promise:B,promiseResolve:$,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=A;class N{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,$)=>{this.completeCallback=M,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise($=>{this.completeCallback(M),this.resolved=!0,$()})}error(M){return new Promise($=>{this.errorCallback(M),this.rejected=!0,$()})}cancel(){new Promise(M=>{this.errorCallback(k.canceled()),this.rejected=!0,M()})}}e.DeferredPromise=W}),define(ge[57],pe([0,1,3]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(C){const S=this._icons.get(C.id);S?C.description?S.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new k;e.iconRegistry=R;function T(n,C){return new P(n,C)}e.registerCodicon=T;class P{constructor(C,S,v){this.id=C,this.definition=S,this.description=v,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function D(n,C){const S=["codicon","codicon-"+n];return C&&S.push("codicon-modifier-"+C),S}e.getClassNamesArray=D;var I;(function(n){n.iconIdRegex=/^(codicon\/)?([a-z\-]+)(?:~([a-z\-]+))?$/i;function C(f){if(f instanceof P)return["codicon","codicon-"+f.id];const u=n.iconIdRegex.exec(f.id);if(!u)return C(P.error);let[,,m,w]=u;const p=["codicon","codicon-"+m];return w&&p.push("codicon-modifier-"+w),p}n.asClassNameArray=C;function S(f){return C(f).join(" ")}n.asClassName=S;function v(f){return"."+C(f).join(".")}n.asCSSSelector=v})(I=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{character:"\\ea60"}),n.plus=new n("plus",{character:"\\ea60"}),n.gistNew=new n("gist-new",{character:"\\ea60"}),n.repoCreate=new n("repo-create",{character:"\\ea60"}),n.lightbulb=new n("lightbulb",{character:"\\ea61"}),n.lightBulb=new n("light-bulb",{character:"\\ea61"}),n.repo=new n("repo",{character:"\\ea62"}),n.repoDelete=new n("repo-delete",{character:"\\ea62"}),n.gistFork=new n("gist-fork",{character:"\\ea63"}),n.repoForked=new n("repo-forked",{character:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{character:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{character:"\\ea64"}),n.recordKeys=new n("record-keys",{character:"\\ea65"}),n.keyboard=new n("keyboard",{character:"\\ea65"}),n.tag=new n("tag",{character:"\\ea66"}),n.tagAdd=new n("tag-add",{character:"\\ea66"}),n.tagRemove=new n("tag-remove",{character:"\\ea66"}),n.person=new n("person",{character:"\\ea67"}),n.personAdd=new n("person-add",{character:"\\ea67"}),n.personFollow=new n("person-follow",{character:"\\ea67"}),n.personOutline=new n("person-outline",{character:"\\ea67"}),n.personFilled=new n("person-filled",{character:"\\ea67"}),n.gitBranch=new n("git-branch",{character:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{character:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{character:"\\ea68"}),n.sourceControl=new n("source-control",{character:"\\ea68"}),n.mirror=new n("mirror",{character:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{character:"\\ea69"}),n.star=new n("star",{character:"\\ea6a"}),n.starAdd=new n("star-add",{character:"\\ea6a"}),n.starDelete=new n("star-delete",{character:"\\ea6a"}),n.starEmpty=new n("star-empty",{character:"\\ea6a"}),n.comment=new n("comment",{character:"\\ea6b"}),n.commentAdd=new n("comment-add",{character:"\\ea6b"}),n.alert=new n("alert",{character:"\\ea6c"}),n.warning=new n("warning",{character:"\\ea6c"}),n.search=new n("search",{character:"\\ea6d"}),n.searchSave=new n("search-save",{character:"\\ea6d"}),n.logOut=new n("log-out",{character:"\\ea6e"}),n.signOut=new n("sign-out",{character:"\\ea6e"}),n.logIn=new n("log-in",{character:"\\ea6f"}),n.signIn=new n("sign-in",{character:"\\ea6f"}),n.eye=new n("eye",{character:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{character:"\\ea70"}),n.eyeWatch=new n("eye-watch",{character:"\\ea70"}),n.circleFilled=new n("circle-filled",{character:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{character:"\\ea71"}),n.closeDirty=new n("close-dirty",{character:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{character:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{character:"\\ea71"}),n.debugHint=new n("debug-hint",{character:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{character:"\\ea72"}),n.edit=new n("edit",{character:"\\ea73"}),n.pencil=new n("pencil",{character:"\\ea73"}),n.info=new n("info",{character:"\\ea74"}),n.issueOpened=new n("issue-opened",{character:"\\ea74"}),n.gistPrivate=new n("gist-private",{character:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{character:"\\ea75"}),n.lock=new n("lock",{character:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{character:"\\ea75"}),n.close=new n("close",{character:"\\ea76"}),n.removeClose=new n("remove-close",{character:"\\ea76"}),n.x=new n("x",{character:"\\ea76"}),n.repoSync=new n("repo-sync",{character:"\\ea77"}),n.sync=new n("sync",{character:"\\ea77"}),n.clone=new n("clone",{character:"\\ea78"}),n.desktopDownload=new n("desktop-download",{character:"\\ea78"}),n.beaker=new n("beaker",{character:"\\ea79"}),n.microscope=new n("microscope",{character:"\\ea79"}),n.vm=new n("vm",{character:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{character:"\\ea7a"}),n.file=new n("file",{character:"\\ea7b"}),n.fileText=new n("file-text",{character:"\\ea7b"}),n.more=new n("more",{character:"\\ea7c"}),n.ellipsis=new n("ellipsis",{character:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{character:"\\ea7c"}),n.mailReply=new n("mail-reply",{character:"\\ea7d"}),n.reply=new n("reply",{character:"\\ea7d"}),n.organization=new n("organization",{character:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{character:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{character:"\\ea7e"}),n.newFile=new n("new-file",{character:"\\ea7f"}),n.fileAdd=new n("file-add",{character:"\\ea7f"}),n.newFolder=new n("new-folder",{character:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{character:"\\ea80"}),n.trash=new n("trash",{character:"\\ea81"}),n.trashcan=new n("trashcan",{character:"\\ea81"}),n.history=new n("history",{character:"\\ea82"}),n.clock=new n("clock",{character:"\\ea82"}),n.folder=new n("folder",{character:"\\ea83"}),n.fileDirectory=new n("file-directory",{character:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{character:"\\ea83"}),n.logoGithub=new n("logo-github",{character:"\\ea84"}),n.markGithub=new n("mark-github",{character:"\\ea84"}),n.github=new n("github",{character:"\\ea84"}),n.terminal=new n("terminal",{character:"\\ea85"}),n.console=new n("console",{character:"\\ea85"}),n.repl=new n("repl",{character:"\\ea85"}),n.zap=new n("zap",{character:"\\ea86"}),n.symbolEvent=new n("symbol-event",{character:"\\ea86"}),n.error=new n("error",{character:"\\ea87"}),n.stop=new n("stop",{character:"\\ea87"}),n.variable=new n("variable",{character:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{character:"\\ea88"}),n.array=new n("array",{character:"\\ea8a"}),n.symbolArray=new n("symbol-array",{character:"\\ea8a"}),n.symbolModule=new n("symbol-module",{character:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{character:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{character:"\\ea8b"}),n.symbolObject=new n("symbol-object",{character:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{character:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{character:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{character:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{character:"\\ea8f"}),n.symbolNull=new n("symbol-null",{character:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{character:"\\ea90"}),n.symbolNumber=new n("symbol-number",{character:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{character:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{character:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{character:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{character:"\\ea92"}),n.symbolKey=new n("symbol-key",{character:"\\ea93"}),n.symbolText=new n("symbol-text",{character:"\\ea93"}),n.symbolReference=new n("symbol-reference",{character:"\\ea94"}),n.goToFile=new n("go-to-file",{character:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{character:"\\ea95"}),n.symbolValue=new n("symbol-value",{character:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{character:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{character:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{character:"\\ea97"}),n.archive=new n("archive",{character:"\\ea98"}),n.arrowBoth=new n("arrow-both",{character:"\\ea99"}),n.arrowDown=new n("arrow-down",{character:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{character:"\\ea9b"}),n.arrowRight=new n("arrow-right",{character:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{character:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{character:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{character:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{character:"\\eaa0"}),n.arrowUp=new n("arrow-up",{character:"\\eaa1"}),n.bell=new n("bell",{character:"\\eaa2"}),n.bold=new n("bold",{character:"\\eaa3"}),n.book=new n("book",{character:"\\eaa4"}),n.bookmark=new n("bookmark",{character:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{character:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{character:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{character:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{character:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{character:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{character:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{character:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{character:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{character:"\\eaab"}),n.briefcase=new n("briefcase",{character:"\\eaac"}),n.broadcast=new n("broadcast",{character:"\\eaad"}),n.browser=new n("browser",{character:"\\eaae"}),n.bug=new n("bug",{character:"\\eaaf"}),n.calendar=new n("calendar",{character:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{character:"\\eab1"}),n.check=new n("check",{character:"\\eab2"}),n.checklist=new n("checklist",{character:"\\eab3"}),n.chevronDown=new n("chevron-down",{character:"\\eab4"}),n.chevronLeft=new n("chevron-left",{character:"\\eab5"}),n.chevronRight=new n("chevron-right",{character:"\\eab6"}),n.chevronUp=new n("chevron-up",{character:"\\eab7"}),n.chromeClose=new n("chrome-close",{character:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{character:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{character:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{character:"\\eabb"}),n.circleOutline=new n("circle-outline",{character:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{character:"\\eabc"}),n.circleSlash=new n("circle-slash",{character:"\\eabd"}),n.circuitBoard=new n("circuit-board",{character:"\\eabe"}),n.clearAll=new n("clear-all",{character:"\\eabf"}),n.clippy=new n("clippy",{character:"\\eac0"}),n.closeAll=new n("close-all",{character:"\\eac1"}),n.cloudDownload=new n("cloud-download",{character:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{character:"\\eac3"}),n.code=new n("code",{character:"\\eac4"}),n.collapseAll=new n("collapse-all",{character:"\\eac5"}),n.colorMode=new n("color-mode",{character:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{character:"\\eac7"}),n.compareChanges=new n("compare-changes",{character:"\\eafd"}),n.creditCard=new n("credit-card",{character:"\\eac9"}),n.dash=new n("dash",{character:"\\eacc"}),n.dashboard=new n("dashboard",{character:"\\eacd"}),n.database=new n("database",{character:"\\eace"}),n.debugContinue=new n("debug-continue",{character:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{character:"\\ead0"}),n.debugPause=new n("debug-pause",{character:"\\ead1"}),n.debugRestart=new n("debug-restart",{character:"\\ead2"}),n.debugStart=new n("debug-start",{character:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{character:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{character:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{character:"\\ead6"}),n.debugStop=new n("debug-stop",{character:"\\ead7"}),n.debug=new n("debug",{character:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{character:"\\ead9"}),n.deviceCamera=new n("device-camera",{character:"\\eada"}),n.deviceMobile=new n("device-mobile",{character:"\\eadb"}),n.diffAdded=new n("diff-added",{character:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{character:"\\eadd"}),n.diffModified=new n("diff-modified",{character:"\\eade"}),n.diffRemoved=new n("diff-removed",{character:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{character:"\\eae0"}),n.diff=new n("diff",{character:"\\eae1"}),n.discard=new n("discard",{character:"\\eae2"}),n.editorLayout=new n("editor-layout",{character:"\\eae3"}),n.emptyWindow=new n("empty-window",{character:"\\eae4"}),n.exclude=new n("exclude",{character:"\\eae5"}),n.extensions=new n("extensions",{character:"\\eae6"}),n.eyeClosed=new n("eye-closed",{character:"\\eae7"}),n.fileBinary=new n("file-binary",{character:"\\eae8"}),n.fileCode=new n("file-code",{character:"\\eae9"}),n.fileMedia=new n("file-media",{character:"\\eaea"}),n.filePdf=new n("file-pdf",{character:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{character:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{character:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{character:"\\eaee"}),n.fileZip=new n("file-zip",{character:"\\eaef"}),n.files=new n("files",{character:"\\eaf0"}),n.filter=new n("filter",{character:"\\eaf1"}),n.flame=new n("flame",{character:"\\eaf2"}),n.foldDown=new n("fold-down",{character:"\\eaf3"}),n.foldUp=new n("fold-up",{character:"\\eaf4"}),n.fold=new n("fold",{character:"\\eaf5"}),n.folderActive=new n("folder-active",{character:"\\eaf6"}),n.folderOpened=new n("folder-opened",{character:"\\eaf7"}),n.gear=new n("gear",{character:"\\eaf8"}),n.gift=new n("gift",{character:"\\eaf9"}),n.gistSecret=new n("gist-secret",{character:"\\eafa"}),n.gist=new n("gist",{character:"\\eafb"}),n.gitCommit=new n("git-commit",{character:"\\eafc"}),n.gitCompare=new n("git-compare",{character:"\\eafd"}),n.gitMerge=new n("git-merge",{character:"\\eafe"}),n.githubAction=new n("github-action",{character:"\\eaff"}),n.githubAlt=new n("github-alt",{character:"\\eb00"}),n.globe=new n("globe",{character:"\\eb01"}),n.grabber=new n("grabber",{character:"\\eb02"}),n.graph=new n("graph",{character:"\\eb03"}),n.gripper=new n("gripper",{character:"\\eb04"}),n.heart=new n("heart",{character:"\\eb05"}),n.home=new n("home",{character:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{character:"\\eb07"}),n.hubot=new n("hubot",{character:"\\eb08"}),n.inbox=new n("inbox",{character:"\\eb09"}),n.issueClosed=new n("issue-closed",{character:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{character:"\\eb0b"}),n.issues=new n("issues",{character:"\\eb0c"}),n.italic=new n("italic",{character:"\\eb0d"}),n.jersey=new n("jersey",{character:"\\eb0e"}),n.json=new n("json",{character:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{character:"\\eb10"}),n.key=new n("key",{character:"\\eb11"}),n.law=new n("law",{character:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{character:"\\eb13"}),n.linkExternal=new n("link-external",{character:"\\eb14"}),n.link=new n("link",{character:"\\eb15"}),n.listOrdered=new n("list-ordered",{character:"\\eb16"}),n.listUnordered=new n("list-unordered",{character:"\\eb17"}),n.liveShare=new n("live-share",{character:"\\eb18"}),n.loading=new n("loading",{character:"\\eb19"}),n.location=new n("location",{character:"\\eb1a"}),n.mailRead=new n("mail-read",{character:"\\eb1b"}),n.mail=new n("mail",{character:"\\eb1c"}),n.markdown=new n("markdown",{character:"\\eb1d"}),n.megaphone=new n("megaphone",{character:"\\eb1e"}),n.mention=new n("mention",{character:"\\eb1f"}),n.milestone=new n("milestone",{character:"\\eb20"}),n.mortarBoard=new n("mortar-board",{character:"\\eb21"}),n.move=new n("move",{character:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{character:"\\eb23"}),n.mute=new n("mute",{character:"\\eb24"}),n.noNewline=new n("no-newline",{character:"\\eb25"}),n.note=new n("note",{character:"\\eb26"}),n.octoface=new n("octoface",{character:"\\eb27"}),n.openPreview=new n("open-preview",{character:"\\eb28"}),n.package_=new n("package",{character:"\\eb29"}),n.paintcan=new n("paintcan",{character:"\\eb2a"}),n.pin=new n("pin",{character:"\\eb2b"}),n.play=new n("play",{character:"\\eb2c"}),n.run=new n("run",{character:"\\eb2c"}),n.plug=new n("plug",{character:"\\eb2d"}),n.preserveCase=new n("preserve-case",{character:"\\eb2e"}),n.preview=new n("preview",{character:"\\eb2f"}),n.project=new n("project",{character:"\\eb30"}),n.pulse=new n("pulse",{character:"\\eb31"}),n.question=new n("question",{character:"\\eb32"}),n.quote=new n("quote",{character:"\\eb33"}),n.radioTower=new n("radio-tower",{character:"\\eb34"}),n.reactions=new n("reactions",{character:"\\eb35"}),n.references=new n("references",{character:"\\eb36"}),n.refresh=new n("refresh",{character:"\\eb37"}),n.regex=new n("regex",{character:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{character:"\\eb39"}),n.remote=new n("remote",{character:"\\eb3a"}),n.remove=new n("remove",{character:"\\eb3b"}),n.replaceAll=new n("replace-all",{character:"\\eb3c"}),n.replace=new n("replace",{character:"\\eb3d"}),n.repoClone=new n("repo-clone",{character:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{character:"\\eb3f"}),n.repoPull=new n("repo-pull",{character:"\\eb40"}),n.repoPush=new n("repo-push",{character:"\\eb41"}),n.report=new n("report",{character:"\\eb42"}),n.requestChanges=new n("request-changes",{character:"\\eb43"}),n.rocket=new n("rocket",{character:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{character:"\\eb45"}),n.rootFolder=new n("root-folder",{character:"\\eb46"}),n.rss=new n("rss",{character:"\\eb47"}),n.ruby=new n("ruby",{character:"\\eb48"}),n.saveAll=new n("save-all",{character:"\\eb49"}),n.saveAs=new n("save-as",{character:"\\eb4a"}),n.save=new n("save",{character:"\\eb4b"}),n.screenFull=new n("screen-full",{character:"\\eb4c"}),n.screenNormal=new n("screen-normal",{character:"\\eb4d"}),n.searchStop=new n("search-stop",{character:"\\eb4e"}),n.server=new n("server",{character:"\\eb50"}),n.settingsGear=new n("settings-gear",{character:"\\eb51"}),n.settings=new n("settings",{character:"\\eb52"}),n.shield=new n("shield",{character:"\\eb53"}),n.smiley=new n("smiley",{character:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{character:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{character:"\\eb56"}),n.splitVertical=new n("split-vertical",{character:"\\eb57"}),n.squirrel=new n("squirrel",{character:"\\eb58"}),n.starFull=new n("star-full",{character:"\\eb59"}),n.starHalf=new n("star-half",{character:"\\eb5a"}),n.symbolClass=new n("symbol-class",{character:"\\eb5b"}),n.symbolColor=new n("symbol-color",{character:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{character:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{character:"\\eb5e"}),n.symbolField=new n("symbol-field",{character:"\\eb5f"}),n.symbolFile=new n("symbol-file",{character:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{character:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{character:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{character:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{character:"\\eb64"}),n.symbolProperty=new n("symbol-property",{character:"\\eb65"}),n.wrench=new n("wrench",{character:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{character:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{character:"\\eb66"}),n.tasklist=new n("tasklist",{character:"\\eb67"}),n.telescope=new n("telescope",{character:"\\eb68"}),n.textSize=new n("text-size",{character:"\\eb69"}),n.threeBars=new n("three-bars",{character:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{character:"\\eb6b"}),n.thumbsup=new n("thumbsup",{character:"\\eb6c"}),n.tools=new n("tools",{character:"\\eb6d"}),n.triangleDown=new n("triangle-down",{character:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{character:"\\eb6f"}),n.triangleRight=new n("triangle-right",{character:"\\eb70"}),n.triangleUp=new n("triangle-up",{character:"\\eb71"}),n.twitter=new n("twitter",{character:"\\eb72"}),n.unfold=new n("unfold",{character:"\\eb73"}),n.unlock=new n("unlock",{character:"\\eb74"}),n.unmute=new n("unmute",{character:"\\eb75"}),n.unverified=new n("unverified",{character:"\\eb76"}),n.verified=new n("verified",{character:"\\eb77"}),n.versions=new n("versions",{character:"\\eb78"}),n.vmActive=new n("vm-active",{character:"\\eb79"}),n.vmOutline=new n("vm-outline",{character:"\\eb7a"}),n.vmRunning=new n("vm-running",{character:"\\eb7b"}),n.watch=new n("watch",{character:"\\eb7c"}),n.whitespace=new n("whitespace",{character:"\\eb7d"}),n.wholeWord=new n("whole-word",{character:"\\eb7e"}),n.window=new n("window",{character:"\\eb7f"}),n.wordWrap=new n("word-wrap",{character:"\\eb80"}),n.zoomIn=new n("zoom-in",{character:"\\eb81"}),n.zoomOut=new n("zoom-out",{character:"\\eb82"}),n.listFilter=new n("list-filter",{character:"\\eb83"}),n.listFlat=new n("list-flat",{character:"\\eb84"}),n.listSelection=new n("list-selection",{character:"\\eb85"}),n.selection=new n("selection",{character:"\\eb85"}),n.listTree=new n("list-tree",{character:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{character:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{character:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{character:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{character:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{character:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{character:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{character:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{character:"\\eb8c"}),n.symbolString=new n("symbol-string",{character:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{character:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{character:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{character:"\\eb90"}),n.callIncoming=new n("call-incoming",{character:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{character:"\\eb93"}),n.menu=new n("menu",{character:"\\eb94"}),n.expandAll=new n("expand-all",{character:"\\eb95"}),n.feedback=new n("feedback",{character:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{character:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{character:"\\eb98"}),n.account=new n("account",{character:"\\eb99"}),n.bellDot=new n("bell-dot",{character:"\\eb9a"}),n.debugConsole=new n("debug-console",{character:"\\eb9b"}),n.library=new n("library",{character:"\\eb9c"}),n.output=new n("output",{character:"\\eb9d"}),n.runAll=new n("run-all",{character:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{character:"\\eb9f"}),n.pinned=new n("pinned",{character:"\\eba0"}),n.githubInverted=new n("github-inverted",{character:"\\eba1"}),n.debugAlt=new n("debug-alt",{character:"\\eb91"}),n.serverProcess=new n("server-process",{character:"\\eba2"}),n.serverEnvironment=new n("server-environment",{character:"\\eba3"}),n.pass=new n("pass",{character:"\\eba4"}),n.stopCircle=new n("stop-circle",{character:"\\eba5"}),n.playCircle=new n("play-circle",{character:"\\eba6"}),n.record=new n("record",{character:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{character:"\\eba8"}),n.vmConnect=new n("vm-connect",{character:"\\eba9"}),n.cloud=new n("cloud",{character:"\\ebaa"}),n.merge=new n("merge",{character:"\\ebab"}),n.exportIcon=new n("export",{character:"\\ebac"}),n.graphLeft=new n("graph-left",{character:"\\ebad"}),n.magnet=new n("magnet",{character:"\\ebae"}),n.notebook=new n("notebook",{character:"\\ebaf"}),n.redo=new n("redo",{character:"\\ebb0"}),n.checkAll=new n("check-all",{character:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{character:"\\ebb2"}),n.passFilled=new n("pass-filled",{character:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{character:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{character:"\\ebb5"}),n.combine=new n("combine",{character:"\\ebb6"}),n.gather=new n("gather",{character:"\\ebb6"}),n.table=new n("table",{character:"\\ebb7"}),n.variableGroup=new n("variable-group",{character:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{character:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{character:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{character:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{character:"\\ebbc"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(ge[93],pe([0,1,7,19]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const R=new k.IdleValue(()=>{const a=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:a,collatorIsNumeric:a.resolvedOptions().numeric}}),T=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(a,c,t=!1){const r=a||"",o=c||"",l=R.value.collator.compare(r,o);return R.value.collatorIsNumeric&&l===0&&r!==o?r<o?-1:1:l}e.compareFileNames=D;function I(a,c){const t=T.value.collator;return a=a||"",c=c||"",m(t,a,c)}e.compareFileNamesDefault=I;function n(a,c,t=!1){t||(a=a&&a.toLowerCase(),c=c&&c.toLowerCase());const[r,o]=f(a),[l,i]=f(c);return r!==l?r<l?-1:1:o===i?0:o<i?-1:1}e.noIntlCompareFileNames=n;function C(a,c){const[t,r]=f(a),[o,l]=f(c);let i=R.value.collator.compare(r,l);if(i===0){if(R.value.collatorIsNumeric&&r!==l)return r<l?-1:1;if(i=R.value.collator.compare(t,o),R.value.collatorIsNumeric&&i===0&&t!==o)return t<o?-1:1}return i}e.compareFileExtensions=C;function S(a,c){a=a||"",c=c||"";const t=u(a),r=u(c),o=T.value.collator,l=P.value.collator;let i;return i=m(l,t,r),i!==0?i:m(o,a,c)}e.compareFileExtensionsDefault=S;const v=/^(.*?)(\.([^.]*))?$/;function f(a,c=!1){const t=a?v.exec(a):[];let r=[t&&t[1]||"",t&&t[3]||""];return c&&(!r[0]&&r[1]||r[0]&&r[0].charAt(0)===".")&&(r=[r[0]+"."+r[1],""]),r}function u(a){const c=a?v.exec(a):[];return c&&c[1]&&c[1].charAt(0)!=="."&&c[3]||""}function m(a,c,t){let r=a.compare(c,t);return r!==0?r:c.length!==t.length?c.length<t.length?-1:1:0}function w(a,c,t=!1){return t||(a=a&&a.toLowerCase(),c=c&&c.toLowerCase()),a===c?0:a<c?-1:1}function p(a,c,t=!1){const r=a.split(_.sep),o=c.split(_.sep),l=r.length-1,i=o.length-1;let h,y;for(let g=0;;g++){if(h=l===g,y=i===g,h&&y)return D(r[g],o[g],t);if(h)return-1;if(y)return 1;const E=w(r[g],o[g],t);if(E!==0)return E}}e.comparePaths=p;function d(a,c,t){const r=a.toLowerCase(),o=c.toLowerCase(),l=s(a,c,t);if(l)return l;const i=r.endsWith(t),h=o.endsWith(t);if(i!==h)return i?-1:1;const y=D(r,o);return y!==0?y:r.localeCompare(o)}e.compareAnything=d;function s(a,c,t){const r=a.toLowerCase(),o=c.toLowerCase(),l=r.startsWith(t),i=o.startsWith(t);if(l!==i)return l?-1:1;if(l&&i){if(r.length<o.length)return-1;if(r.length>o.length)return 1}return 0}e.compareByPrefix=s}),define(ge[94],pe([0,1,15,5]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.observe=e.transform=e.toReadable=e.toStream=e.peekStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(w){const p=w;return p&&[p.on,p.pause,p.resume,p.destroy].every(d=>typeof d=="function")}e.isReadableStream=R;function T(w){const p=w;return p&&R(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean"}e.isReadableBufferedStream=T;function P(w,p){return new D(w,p)}e.newWriteableStream=P;class D{constructor(p,d){this.reducer=p,this.options=d,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){var d;if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof((d=this.options)===null||d===void 0?void 0:d.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(p instanceof Error?this.error(p):p&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(d=>d(p))}emitError(p){this.listeners.error.length===0?_.onUnexpectedError(p):this.listeners.error.slice(0).forEach(d=>d(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,d){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(d),this.resume();break;case"end":this.listeners.end.push(d),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(d),this.state.flowing&&this.flowErrors();break}}removeListener(p,d){if(!this.state.destroyed){let s;switch(p){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const a=s.indexOf(d);a>=0&&s.splice(a,1)}}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const d=[...this.pendingWritePromises];this.pendingWritePromises.length=0,d.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(w,p){const d=[];let s;for(;(s=w.read())!==null;)d.push(s);return p(d)}e.consumeReadable=I;function n(w,p,d){const s=[];let a;for(;(a=w.read())!==null&&s.length<d;)s.push(a);return a===null&&s.length>0?p(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a!="undefined"){const c=a;return a=void 0,c}return w.read()}}}e.peekReadable=n;function C(w,p){return new Promise((d,s)=>{const a=[];w.on("error",c=>s(c)),w.on("end",()=>d(p(a))),w.on("data",c=>a.push(c))})}e.consumeStream=C;function S(w,p){return new Promise((d,s)=>{const a=new k.DisposableStore,c=[],t=l=>{if(c.push(l),c.length>p)return a.dispose(),w.pause(),d({stream:w,buffer:c,ended:!1})};a.add(k.toDisposable(()=>w.removeListener("data",t))),w.on("data",t);const r=l=>s(l);a.add(k.toDisposable(()=>w.removeListener("error",r))),w.on("error",r);const o=()=>d({stream:w,buffer:c,ended:!0});a.add(k.toDisposable(()=>w.removeListener("end",o))),w.on("end",o)})}e.peekStream=S;function v(w,p){const d=P(p);return d.end(w),d}e.toStream=v;function f(w){let p=!1;return{read:()=>p?null:(p=!0,w)}}e.toReadable=f;function u(w,p,d){const s=P(d);return w.on("data",a=>s.write(p.data(a))),w.on("end",()=>s.end()),w.on("error",a=>s.error(p.error?p.error(a):a)),s}e.transform=u;function m(w){const p=Promise.race([new Promise(d=>w.on("end",()=>d())),new Promise(d=>w.on("error",()=>d()))]);return{errorOrEnd(){return w.resume(),p}}}e.observe=m}),define(ge[10],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=_;const k=/{(\d+)}/g;function R(ue,...ye){return ye.length===0?ue:ue.replace(k,function(Ne,ee){const te=parseInt(ee,10);return isNaN(te)||te<0||te>=ye.length?Ne:ye[te]})}e.format=R;function T(ue){return ue.replace(/[<>&]/g,function(ye){switch(ye){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ye}})}e.escape=T;function P(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function D(ue,ye){let Ne=0;const ee=ye.charCodeAt(0);for(let te=ue.length-1;te>=0;te--)ue.charCodeAt(te)===ee&&Ne++;return Ne}e.count=D;function I(ue,ye,Ne="\u2026"){return ue.length<=ye?ue:`${ue.substr(0,ye)}${Ne}`}e.truncate=I;function n(ue,ye=" "){const Ne=C(ue,ye);return S(Ne,ye)}e.trim=n;function C(ue,ye){if(!ue||!ye)return ue;const Ne=ye.length;if(Ne===0||ue.length===0)return ue;let ee=0;for(;ue.indexOf(ye,ee)===ee;)ee=ee+Ne;return ue.substring(ee)}e.ltrim=C;function S(ue,ye){if(!ue||!ye)return ue;const Ne=ye.length,ee=ue.length;if(Ne===0||ee===0)return ue;let te=ee,G=-1;for(;G=ue.lastIndexOf(ye,te-1),!(G===-1||G+Ne!==te);){if(G===0)return"";te=G}return ue.substring(0,te)}e.rtrim=S;function v(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function f(ue){return ue.replace(/\*/g,"")}e.stripWildcards=f;function u(ue,ye,Ne={}){if(!ue)throw new Error("Cannot create regex from empty string");ye||(ue=P(ue)),Ne.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let ee="";return Ne.global&&(ee+="g"),Ne.matchCase||(ee+="i"),Ne.multiline&&(ee+="m"),Ne.unicode&&(ee+="u"),new RegExp(ue,ee)}e.createRegExp=u;function m(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function w(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function p(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=p;function d(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=d;function s(ue){for(let ye=0,Ne=ue.length;ye<Ne;ye++){const ee=ue.charCodeAt(ye);if(ee!==32&&ee!==9)return ye}return-1}e.firstNonWhitespaceIndex=s;function a(ue,ye=0,Ne=ue.length){for(let ee=ye;ee<Ne;ee++){const te=ue.charCodeAt(ee);if(te!==32&&te!==9)return ue.substring(ye,ee)}return ue.substring(ye,Ne)}e.getLeadingWhitespace=a;function c(ue,ye=ue.length-1){for(let Ne=ye;Ne>=0;Ne--){const ee=ue.charCodeAt(Ne);if(ee!==32&&ee!==9)return Ne}return-1}e.lastNonWhitespaceIndex=c;function t(ue,ye){return ue<ye?-1:ue>ye?1:0}e.compare=t;function r(ue,ye,Ne=0,ee=ue.length,te=0,G=ye.length){for(;Ne<ee&&te<G;Ne++,te++){let oe=ue.charCodeAt(Ne),me=ye.charCodeAt(te);if(oe<me)return-1;if(oe>me)return 1}const F=ee-Ne,ie=G-te;return F<ie?-1:F>ie?1:0}e.compareSubstring=r;function o(ue,ye){return l(ue,ye,0,ue.length,0,ye.length)}e.compareIgnoreCase=o;function l(ue,ye,Ne=0,ee=ue.length,te=0,G=ye.length){for(;Ne<ee&&te<G;Ne++,te++){let oe=ue.charCodeAt(Ne),me=ye.charCodeAt(te);if(oe!==me){const ke=oe-me;if(!(ke===32&&h(me))&&!(ke===-32&&h(oe)))return i(oe)&&i(me)?ke:r(ue.toLowerCase(),ye.toLowerCase(),Ne,ee,te,G)}}const F=ee-Ne,ie=G-te;return F<ie?-1:F>ie?1:0}e.compareSubstringIgnoreCase=l;function i(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=i;function h(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=h;function y(ue){return i(ue)||h(ue)}function g(ue,ye){return ue.length===ye.length&&E(ue,ye)}e.equalsIgnoreCase=g;function E(ue,ye,Ne=ue.length){for(let ee=0;ee<Ne;ee++){const te=ue.charCodeAt(ee),G=ye.charCodeAt(ee);if(te!==G){if(y(te)&&y(G)){const F=Math.abs(te-G);if(F!==0&&F!==32)return!1}else if(String.fromCharCode(te).toLowerCase()!==String.fromCharCode(G).toLowerCase())return!1}}return!0}function b(ue,ye){const Ne=ye.length;return ye.length>ue.length?!1:E(ue,ye,Ne)}e.startsWithIgnoreCase=b;function L(ue,ye){let Ne,ee=Math.min(ue.length,ye.length);for(Ne=0;Ne<ee;Ne++)if(ue.charCodeAt(Ne)!==ye.charCodeAt(Ne))return Ne;return ee}e.commonPrefixLength=L;function A(ue,ye){let Ne,ee=Math.min(ue.length,ye.length);const te=ue.length-1,G=ye.length-1;for(Ne=0;Ne<ee;Ne++)if(ue.charCodeAt(te-Ne)!==ye.charCodeAt(G-Ne))return Ne;return ee}e.commonSuffixLength=A;function N(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=N;function W(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=W;function x(ue,ye){return(ue-55296<<10)+(ye-56320)+65536}e.computeCodePoint=x;function M(ue,ye,Ne){const ee=ue.charCodeAt(Ne);if(N(ee)&&Ne+1<ye){const te=ue.charCodeAt(Ne+1);if(W(te))return x(ee,te)}return ee}e.getNextCodePoint=M;function $(ue,ye){const Ne=ue.charCodeAt(ye-1);if(W(Ne)&&ye>1){const ee=ue.charCodeAt(ye-2);if(N(ee))return x(ee,Ne)}return Ne}function O(ue,ye){const Ne=ze.getInstance(),ee=ye,te=ue.length,G=M(ue,te,ye);ye+=G>=65536?2:1;let F=Ne.getGraphemeBreakType(G);for(;ye<te;){const ie=M(ue,te,ye),oe=Ne.getGraphemeBreakType(ie);if(Ae(F,oe))break;ye+=ie>=65536?2:1,F=oe}return ye-ee}e.nextCharLength=O;function B(ue,ye){const Ne=ze.getInstance(),ee=ye,te=$(ue,ye);ye-=te>=65536?2:1;let G=Ne.getGraphemeBreakType(te);for(;ye>0;){const F=$(ue,ye),ie=Ne.getGraphemeBreakType(F);if(Ae(ie,G))break;ye-=F>=65536?2:1,G=ie}return ee-ye}e.prevCharLength=B;function J(ue,ye){const Ne=ze.getInstance(),ee=ue.length,te=ye,G=M(ue,ee,ye),F=Ne.getGraphemeBreakType(G);ye+=G>=65536?2:1;let ie=F;for(;ye<ee;){const me=M(ue,ee,ye),ke=Ne.getGraphemeBreakType(me);if(Ae(ie,ke))break;ye+=me>=65536?2:1,ie=ke}const oe=ye;for(ye=te,ie=F;ye>0;){const me=$(ue,ye),ke=Ne.getGraphemeBreakType(me);if(Ae(ke,ie))break;ye-=me>=65536?2:1,ie=ke}return[ye,oe]}function U(ue,ye){return ye>0&&W(ue.charCodeAt(ye))?J(ue,ye-1):J(ue,ye)}e.getCharContainingOffset=U;function V(ue){const ye=ue.length;let Ne=0,ee=0;for(;ee<ye;){const F=M(ue,ye,ee);ee+=F>=65536?2:1,F<128?Ne+=1:F<2048?Ne+=2:F<65536?Ne+=3:Ne+=4}const te=new Uint8Array(Ne);ee=0;let G=0;for(;ee<ye;){const F=M(ue,ye,ee);ee+=F>=65536?2:1,F<128?te[G++]=F:F<2048?(te[G++]=192|(F&1984)>>>6,te[G++]=128|(F&63)>>>0):F<65536?(te[G++]=224|(F&61440)>>>12,te[G++]=128|(F&4032)>>>6,te[G++]=128|(F&63)>>>0):(te[G++]=240|(F&1835008)>>>18,te[G++]=128|(F&258048)>>>12,te[G++]=128|(F&4032)>>>6,te[G++]=128|(F&63)>>>0)}return te}e.encodeUTF8=V;function z(ue){const ye=ue.byteLength,Ne=[];let ee=0;for(;ee<ye;){const te=ue[ee];let G;if(te>=240&&ee+3<ye?G=(ue[ee++]&7)<<18>>>0|(ue[ee++]&63)<<12>>>0|(ue[ee++]&63)<<6>>>0|(ue[ee++]&63)<<0>>>0:te>=224&&ee+2<ye?G=(ue[ee++]&15)<<12>>>0|(ue[ee++]&63)<<6>>>0|(ue[ee++]&63)<<0>>>0:te>=192&&ee+1<ye?G=(ue[ee++]&31)<<6>>>0|(ue[ee++]&63)<<0>>>0:G=ue[ee++],G>=0&&G<=55295||G>=57344&&G<=65535)Ne.push(String.fromCharCode(G));else if(G>=65536&&G<=1114111){const F=G-65536,ie=55296+((F&1047552)>>>10),oe=56320+((F&1023)>>>0);Ne.push(String.fromCharCode(ie)),Ne.push(String.fromCharCode(oe))}else Ne.push(String.fromCharCode(65533))}return Ne.join("")}e.decodeUTF8=z;const Q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ae(ue){return Q.test(ue)}e.containsRTL=ae;const ce=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;function fe(ue){return ce.test(ue)}e.containsEmoji=fe;const we=/^[\t\n\r\x20-\x7E]*$/;function be(ue){return we.test(ue)}e.isBasicASCII=be,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=H;function X(ue){for(let ye=0,Ne=ue.length;ye<Ne;ye++)if(re(ue.charCodeAt(ye)))return!0;return!1}e.containsFullWidthCharacter=X;function re(ue){return ue=+ue,ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=re;function Y(ue){return ue>=127462&&ue<=127487||ue>=9728&&ue<=10175||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129003||ue>=129280&&ue<=129535||ue>=129648&&ue<=129651||ue>=129656&&ue<=129666||ue>=129680&&ue<=129685}e.isEmojiImprecise=Y;function le(ue,ye){if(ue.length<ye)return ue;const Ne=/\b/g;let ee=0;for(;Ne.test(ue)&&!(ue.length-Ne.lastIndex<ye);)ee=Ne.lastIndex,Ne.lastIndex+=1;return ue.substring(ee).replace(/^\s/,"")}e.lcut=le;const ve=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Me=/\x1b\[0?m/g;function Ee(ue){return ue&&(ue=ue.replace(ve,""),ue=ue.replace(De,""),ue=ue.replace(Me,"")),ue}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Pe(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Pe;function Ce(ue){return Pe(ue)?ue.substr(1):ue}e.stripUTF8BOM=Ce;function Oe(ue,ye){if(!ue||!ye||ue.length<ye.length)return!1;const Ne=ye.length,ee=ue.toLowerCase();let te=0,G=-1;for(;te<Ne;){const F=ee.indexOf(ye[te],G+1);if(F<0)return!1;G=F,te++}return!0}e.fuzzyContains=Oe;function Se(ue,ye=!1){return ue?(ye&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=Se;function Be(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=Be;function K(ue,ye=1){if(ye===0)return"";let Ne=-1;do Ne=ue.indexOf(`
`,Ne+1),ye--;while(ye>0&&Ne>=0);return Ne===-1?ue:(ue[Ne-1]==="\r"&&Ne--,ue.substr(0,Ne))}e.getNLines=K;function se(ue){const ye=90-65+1;return ue=ue%(2*ye),ue<ye?String.fromCharCode(97+ue):String.fromCharCode(65+ue-ye)}e.singleLetterHash=se;function _e(ue){return ze.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=_e;function Ae(ue,ye){return ue===0?ye!==5&&ye!==7:ue===2&&ye===3?!1:ue===4||ue===2||ue===3||ye===4||ye===2||ye===3?!0:!(ue===8&&(ye===8||ye===9||ye===11||ye===12)||(ue===11||ue===9)&&(ye===9||ye===10)||(ue===12||ue===10)&&ye===10||ye===5||ye===13||ye===7||ue===1||ue===13&&ye===14||ue===6&&ye===6)}e.breakBetweenGraphemeBreakType=Ae;var Ue;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(Ue=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=je()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(ye){if(ye<32)return ye===10?3:ye===13?2:4;if(ye<127)return 0;const Ne=this._data,ee=Ne.length/3;let te=1;for(;te<=ee;)if(ye<Ne[3*te])te=2*te;else if(ye>Ne[3*te+1])te=2*te+1;else return Ne[3*te+2];return 0}}ze._INSTANCE=null;function je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ge[27],pe([0,1,10,94]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",P=typeof TextDecoder!="undefined";let D,I;class n{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return R?new n(Buffer.allocUnsafe(i)):new n(new Uint8Array(i))}static wrap(i){return R&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new n(i)}static fromString(i,h){return!((h==null?void 0:h.dontUseNodeBuffer)||!1)&&R?new n(Buffer.from(i)):T?(D||(D=new TextEncoder),new n(D.encode(i))):new n(_.encodeUTF8(i))}static concat(i,h){if(typeof h=="undefined"){h=0;for(let E=0,b=i.length;E<b;E++)h+=i[E].byteLength}const y=n.alloc(h);let g=0;for(let E=0,b=i.length;E<b;E++){const L=i[E];y.set(L,g),g+=L.byteLength}return y}toString(){return R?this.buffer.toString():P?(I||(I=new TextDecoder),I.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(i,h){return new n(this.buffer.subarray(i,h))}set(i,h){i instanceof n?this.buffer.set(i.buffer,h):this.buffer.set(i,h)}readUInt32BE(i){return v(this.buffer,i)}writeUInt32BE(i,h){f(this.buffer,i,h)}readUInt32LE(i){return u(this.buffer,i)}writeUInt32LE(i,h){m(this.buffer,i,h)}readUInt8(i){return w(this.buffer,i)}writeUInt8(i,h){p(this.buffer,i,h)}}e.VSBuffer=n;function C(l,i){return l[i+0]<<0>>>0|l[i+1]<<8>>>0}e.readUInt16LE=C;function S(l,i,h){l[h+0]=i&255,i=i>>>8,l[h+1]=i&255}e.writeUInt16LE=S;function v(l,i){return l[i]*2**24+l[i+1]*2**16+l[i+2]*2**8+l[i+3]}e.readUInt32BE=v;function f(l,i,h){l[h+3]=i,i=i>>>8,l[h+2]=i,i=i>>>8,l[h+1]=i,i=i>>>8,l[h]=i}e.writeUInt32BE=f;function u(l,i){return l[i+0]<<0>>>0|l[i+1]<<8>>>0|l[i+2]<<16>>>0|l[i+3]<<24>>>0}e.readUInt32LE=u;function m(l,i,h){l[h+0]=i&255,i=i>>>8,l[h+1]=i&255,i=i>>>8,l[h+2]=i&255,i=i>>>8,l[h+3]=i&255}e.writeUInt32LE=m;function w(l,i){return l[i]}e.readUInt8=w;function p(l,i,h){l[h]=i}e.writeUInt8=p;function d(l){return k.consumeReadable(l,i=>n.concat(i))}e.readableToBuffer=d;function s(l){return k.toReadable(l)}e.bufferToReadable=s;function a(l){return k.consumeStream(l,i=>n.concat(i))}e.streamToBuffer=a;async function c(l){return l.ended?n.concat(l.buffer):n.concat([...l.buffer,await a(l.stream)])}e.bufferedStreamToBuffer=c;function t(l){return k.toStream(l,i=>n.concat(i))}e.bufferToStream=t;function r(l){return k.transform(l,{data:i=>typeof i=="string"?n.fromString(i):n.wrap(i)},i=>n.concat(i))}e.streamToBufferReadableStream=r;function o(l){return k.newWriteableStream(i=>n.concat(i),l)}e.newWriteableBufferStream=o}),define(ge[75],pe([0,1,10]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function k(p){return R(p,0)}e.hash=k;function R(p,d){switch(typeof p){case"object":return p===null?T(349,d):Array.isArray(p)?I(p,d):n(p,d);case"string":return D(p,d);case"boolean":return P(p,d);case"number":return T(p,d);case"undefined":return T(937,d);default:return T(617,d)}}e.doHash=R;function T(p,d){return(d<<5)-d+p|0}function P(p,d){return T(p?433:863,d)}function D(p,d){d=T(149417,d);for(let s=0,a=p.length;s<a;s++)d=T(p.charCodeAt(s),d);return d}e.stringHash=D;function I(p,d){return d=T(104579,d),p.reduce((s,a)=>R(a,s),d)}function n(p,d){return d=T(181387,d),Object.keys(p).sort().reduce((s,a)=>(s=D(a,s),R(p[a],s)),d)}class C{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=R(d,this._value),this._value}}e.Hasher=C;var S;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function v(p,d,s=32){const a=s-d,c=~((1<<a)-1);return(p<<d|(c&p)>>>a)>>>0}function f(p,d=0,s=p.byteLength,a=0){for(let c=0;c<s;c++)p[d+c]=a}function u(p,d,s="0"){for(;p.length<d;)p=s+p;return p}function m(p,d=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(s=>s.toString(16).padStart(2,"0")).join(""):u((p>>>0).toString(16),d/4)}e.toHexString=m;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const s=d.length;if(s!==0){const a=this._buff;let c=this._buffLen,t=this._leftoverHighSurrogate,r,o;for(t!==0?(r=t,o=-1,t=0):(r=d.charCodeAt(0),o=0);;){let l=r;if(_.isHighSurrogate(r))if(o+1<s){const i=d.charCodeAt(o+1);_.isLowSurrogate(i)?(o++,l=_.computeCodePoint(r,i)):l=65533}else{t=r;break}else _.isLowSurrogate(r)&&(l=65533);if(c=this._push(a,c,l),o++,o<s)r=d.charCodeAt(o);else break}this._buffLen=c,this._leftoverHighSurrogate=t}}_push(d,s,a){return a<128?d[s++]=a:a<2048?(d[s++]=192|(a&1984)>>>6,d[s++]=128|(a&63)>>>0):a<65536?(d[s++]=224|(a&61440)>>>12,d[s++]=128|(a&4032)>>>6,d[s++]=128|(a&63)>>>0):(d[s++]=240|(a&1835008)>>>18,d[s++]=128|(a&258048)>>>12,d[s++]=128|(a&4032)>>>6,d[s++]=128|(a&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=w._bigBlock32,s=this._buffDV;for(let y=0;y<64;y+=4)d.setUint32(y,s.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)d.setUint32(y,v(d.getUint32(y-12,!1)^d.getUint32(y-32,!1)^d.getUint32(y-56,!1)^d.getUint32(y-64,!1),1),!1);let a=this._h0,c=this._h1,t=this._h2,r=this._h3,o=this._h4,l,i,h;for(let y=0;y<80;y++)y<20?(l=c&t|~c&r,i=1518500249):y<40?(l=c^t^r,i=1859775393):y<60?(l=c&t|c&r|t&r,i=2400959708):(l=c^t^r,i=3395469782),h=v(a,5)+l+o+i+d.getUint32(y*4,!1)&4294967295,o=r,r=t,t=v(c,30),c=a,a=h;this._h0=this._h0+a&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[76],pe([0,1,10]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(k||(k={})),function(R){const T="error",P="warning",D="warn",I="info";function n(C){return C?_.equalsIgnoreCase(T,C)?R.Error:_.equalsIgnoreCase(P,C)||_.equalsIgnoreCase(D,C)?R.Warning:_.equalsIgnoreCase(I,C)?R.Info:R.Ignore:R.Ignore}R.fromValue=n}(k||(k={})),e.default=k}),define(ge[16],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(i){return Array.isArray(i)}e.isArray=_;function k(i){return typeof i=="string"}e.isString=k;function R(i){return Array.isArray(i)&&i.every(h=>k(h))}e.isStringArray=R;function T(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}e.isObject=T;function P(i){return typeof i=="number"&&!isNaN(i)}e.isNumber=P;function D(i){return i===!0||i===!1}e.isBoolean=D;function I(i){return typeof i=="undefined"}e.isUndefined=I;function n(i){return!C(i)}e.isDefined=n;function C(i){return I(i)||i===null}e.isUndefinedOrNull=C;function S(i,h){if(!i)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=S;function v(i){if(C(i))throw new Error("Assertion Failed: argument is undefined or null");return i}e.assertIsDefined=v;function f(...i){const h=[];for(let y=0;y<i.length;y++){const g=i[y];if(C(g))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);h.push(g)}return h}e.assertAllDefined=f;const u=Object.prototype.hasOwnProperty;function m(i){if(!T(i))return!1;for(let h in i)if(u.call(i,h))return!1;return!0}e.isEmptyObject=m;function w(i){return typeof i=="function"}e.isFunction=w;function p(...i){return i.length>0&&i.every(w)}e.areFunctions=p;function d(i,h){const y=Math.min(i.length,h.length);for(let g=0;g<y;g++)s(i[g],h[g])}e.validateConstraints=d;function s(i,h){if(k(h)){if(typeof i!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(w(h)){try{if(i instanceof h)return}catch(y){}if(!C(i)&&i.constructor===h||h.length===1&&h.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function a(i){let h=[],y=Object.getPrototypeOf(i);for(;Object.prototype!==y;)h=h.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return h}e.getAllPropertyNames=a;function c(i){const h=[];for(const y of a(i))typeof i[y]=="function"&&h.push(y);return h}e.getAllMethodNames=c;function t(i,h){const y=E=>function(){const b=Array.prototype.slice.call(arguments,0);return h(E,b)};let g={};for(const E of i)g[E]=y(E);return g}e.createProxyObject=t;function r(i){return i===null?void 0:i}e.withNullAsUndefined=r;function o(i){return typeof i=="undefined"?null:i}e.withUndefinedAsNull=o;function l(i){return class{constructor(){return new Proxy({},{get(h,y){if(h[y])return h[y];throw new Error(`Not Implemented: ${i}->${String(y)}`)}})}}}e.NotImplementedProxy=l}),define(ge[30],pe([0,1,9,10,7,16]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function P(r){return r===47||r===92}e.isPathSeparator=P;function D(r){return r.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=D;function I(r,o=R.posix.sep){if(!r)return"";const l=r.length,i=r.charCodeAt(0);if(P(i)){if(P(r.charCodeAt(1))&&!P(r.charCodeAt(2))){let y=3;const g=y;for(;y<l&&!P(r.charCodeAt(y));y++);if(g!==y&&!P(r.charCodeAt(y+1))){for(y+=1;y<l;y++)if(P(r.charCodeAt(y)))return r.slice(0,y+1).replace(/[\\/]/g,o)}}return o}else if(w(i)&&r.charCodeAt(1)===58)return P(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<l;h++)if(P(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.getRoot=I;function n(r){if(!_.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let l=2;const i=l;for(;l<r.length&&(o=r.charCodeAt(l),o!==92);l++);return!(i===l||(o=r.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=n;const C=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,o=_.isWindows){const l=o?C:S;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||o&&v.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function u(r,o,l){const i=r===o;return!l||i?i:!r||!o?!1:k.equalsIgnoreCase(r,o)}e.isEqual=u;function m(r,o,l,i=R.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(l){if(!k.startsWithIgnoreCase(r,o))return!1;if(o.length===r.length)return!0;let y=o.length;return o.charAt(o.length-1)===i&&y--,r.charAt(y)===i}return o.charAt(o.length-1)!==i&&(o+=i),r.indexOf(o)===0}e.isEqualOrParent=m;function w(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=w;function p(r,o){return _.isWindows&&r.endsWith(":")&&(r+=R.sep),R.isAbsolute(r)||(r=R.join(o,r)),r=R.normalize(r),_.isWindows?(r=k.rtrim(r,R.sep),r.endsWith(":")&&(r+=R.sep)):(r=k.rtrim(r,R.sep),r||(r=R.sep)),r}e.sanitizeFilePath=p;function d(r){const o=R.normalize(r);return _.isWindows?r.length>3?!1:s(o)&&(r.length===2||o.charCodeAt(2)===92):o===R.posix.sep}e.isRootOrDriveLetter=d;function s(r){return _.isWindows?w(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function a(r){return s(r)?r[0]:void 0}e.getDriveLetter=a;function c(r,o,l){return o.length>r.length?-1:r===o?0:(l&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=c;function t(r){const o=r.split(":");let l,i,h;if(o.forEach(y=>{const g=Number(y);T.isNumber(g)?i===void 0?i=g:h===void 0&&(h=g):l=l?[l,y].join(":"):y}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:i!==void 0?i:void 0,column:h!==void 0?h:i!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ge[25],pe([0,1,16]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.keys(u).forEach(w=>{u[w]&&typeof u[w]=="object"?m[w]=k(u[w]):m[w]=u[w]}),m}e.deepClone=k;function R(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const w=m.shift();Object.freeze(w);for(const p in w)if(T.call(w,p)){const d=w[p];typeof d=="object"&&!Object.isFrozen(d)&&m.push(d)}}return u}e.deepFreeze=R;const T=Object.prototype.hasOwnProperty;function P(u,m){return D(u,m,new Set)}e.cloneAndChange=P;function D(u,m,w){if(_.isUndefinedOrNull(u))return u;const p=m(u);if(typeof p!="undefined")return p;if(_.isArray(u)){const d=[];for(const s of u)d.push(D(s,m,w));return d}if(_.isObject(u)){if(w.has(u))throw new Error("Cannot clone recursive data-structure");w.add(u);const d={};for(let s in u)T.call(u,s)&&(d[s]=D(u[s],m,w));return w.delete(u),d}return u}function I(u,m,w=!0){return _.isObject(u)?(_.isObject(m)&&Object.keys(m).forEach(p=>{p in u?w&&(_.isObject(u[p])&&_.isObject(m[p])?I(u[p],m[p],w):u[p]=m[p]):u[p]=m[p]}),u):m}e.mixin=I;function n(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let w,p;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(w=0;w<u.length;w++)if(!n(u[w],m[w]))return!1}else{const d=[];for(p in u)d.push(p);d.sort();const s=[];for(p in m)s.push(p);if(s.sort(),!n(d,s))return!1;for(w=0;w<d.length;w++)if(!n(u[d[w]],m[d[w]]))return!1}return!0}e.equals=n;function C(u){const m=new Set;return JSON.stringify(u,(w,p)=>{if(_.isObject(p)||Array.isArray(p)){if(m.has(p))return"[Circular]";m.add(p)}return p})}e.safeStringify=C;function S(u,m,w){const p=m(u);return typeof p=="undefined"?w:p}e.getOrDefault=S;function v(u,m){const w=Object.create(null);return!u||!m||Object.keys(m).forEach(d=>{const s=u[d],a=m[d];n(s,a)||(w[d]=a)}),w}e.distinct=v;function f(u,m){const w=m.toLowerCase(),p=Object.keys(u).find(d=>d.toLowerCase()===w);return p?u[p]:u[m]}e.getCaseInsensitive=f}),define(ge[95],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function k(T){return T<0?0:T>255?255:T|0}e.toUint8=k;function R(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=R}),define(ge[2],pe([0,1,9,7]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,T=/^\//,P=/^\/\//;function D(o,l){if(!o.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!R.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!T.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(o,l){return!o&&!l?"file":o}function n(o,l){switch(o){case"https":case"http":case"file":l?l[0]!==S&&(l=S+l):l=S;break}return l}const C="",S="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(l,i,h,y,g,E=!1){typeof l=="object"?(this.scheme=l.scheme||C,this.authority=l.authority||C,this.path=l.path||C,this.query=l.query||C,this.fragment=l.fragment||C):(this.scheme=I(l,E),this.authority=i||C,this.path=n(this.scheme,h||C),this.query=y||C,this.fragment=g||C,D(this,E))}static isUri(l){return l instanceof f?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}get fsPath(){return s(this,!1)}with(l){if(!l)return this;let{scheme:i,authority:h,path:y,query:g,fragment:E}=l;return i===void 0?i=this.scheme:i===null&&(i=C),h===void 0?h=this.authority:h===null&&(h=C),y===void 0?y=this.path:y===null&&(y=C),g===void 0?g=this.query:g===null&&(g=C),E===void 0?E=this.fragment:E===null&&(E=C),i===this.scheme&&h===this.authority&&y===this.path&&g===this.query&&E===this.fragment?this:new m(i,h,y,g,E)}static parse(l,i=!1){const h=v.exec(l);return h?new m(h[2]||C,r(h[4]||C),r(h[5]||C),r(h[7]||C),r(h[9]||C),i):new m(C,C,C,C,C)}static file(l){let i=C;if(_.isWindows&&(l=l.replace(/\\/g,S)),l[0]===S&&l[1]===S){const h=l.indexOf(S,2);h===-1?(i=l.substring(2),l=S):(i=l.substring(2,h),l=l.substring(h)||S)}return new m("file",i,l,C,C)}static from(l){return new m(l.scheme,l.authority,l.path,l.query,l.fragment)}static joinPath(l,...i){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return _.isWindows&&l.scheme==="file"?h=f.file(k.win32.join(s(l,!0),...i)).path:h=k.posix.join(l.path,...i),l.with({path:h})}toString(l=!1){return a(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof f)return l;{const i=new m(l);return i._formatted=l.external,i._fsPath=l._sep===u?l.fsPath:null,i}}else return l}}e.URI=f;const u=_.isWindows?1:void 0;class m extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(l=!1){return l?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=u),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(o,l){let i,h=-1;for(let y=0;y<o.length;y++){const g=o.charCodeAt(y);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||l&&g===47)h!==-1&&(i+=encodeURIComponent(o.substring(h,y)),h=-1),i!==void 0&&(i+=o.charAt(y));else{i===void 0&&(i=o.substr(0,y));const E=w[g];E!==void 0?(h!==-1&&(i+=encodeURIComponent(o.substring(h,y)),h=-1),i+=E):h===-1&&(h=y)}}return h!==-1&&(i+=encodeURIComponent(o.substring(h))),i!==void 0?i:o}function d(o){let l;for(let i=0;i<o.length;i++){const h=o.charCodeAt(i);h===35||h===63?(l===void 0&&(l=o.substr(0,i)),l+=w[h]):l!==void 0&&(l+=o[i])}return l!==void 0?l:o}function s(o,l){let i;return o.authority&&o.path.length>1&&o.scheme==="file"?i=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?l?i=o.path.substr(1):i=o.path[1].toLowerCase()+o.path.substr(2):i=o.path,_.isWindows&&(i=i.replace(/\//g,"\\")),i}e.uriToFsPath=s;function a(o,l){const i=l?d:p;let h="",{scheme:y,authority:g,path:E,query:b,fragment:L}=o;if(y&&(h+=y,h+=":"),(g||y==="file")&&(h+=S,h+=S),g){let A=g.indexOf("@");if(A!==-1){const N=g.substr(0,A);g=g.substr(A+1),A=N.indexOf(":"),A===-1?h+=i(N,!1):(h+=i(N.substr(0,A),!1),h+=":",h+=i(N.substr(A+1),!1)),h+="@"}g=g.toLowerCase(),A=g.indexOf(":"),A===-1?h+=i(g,!1):(h+=i(g.substr(0,A),!1),h+=g.substr(A))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const A=E.charCodeAt(1);A>=65&&A<=90&&(E=`/${String.fromCharCode(A+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const A=E.charCodeAt(0);A>=65&&A<=90&&(E=`${String.fromCharCode(A+32)}:${E.substr(2)}`)}h+=i(E,!0)}return b&&(h+="?",h+=i(b,!1)),L&&(h+="#",h+=l?L:p(L,!1)),h}function c(o){try{return decodeURIComponent(o)}catch(l){return o.length>3?o.substr(0,3)+c(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(o){return o.match(t)?o.replace(t,l=>c(l)):o}}),define(ge[22],pe([0,1,2,10]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(d,s,a){let c=d.get(s);return c===void 0&&(c=a,d.set(s,c)),c}e.getOrSet=R;function T(d){const s=[];return d.forEach((a,c)=>{s.push(`${c} => ${a}`)}),`Map(${d.size}) {${s.join(", ")}}`}e.mapToString=T;function P(d){const s=[];return d.forEach(a=>{s.push(a)}),`Set(${d.size}) {${s.join(", ")}}`}e.setToString=P;class D{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const a=s.charCodeAt(0),c=this._value.charCodeAt(this._pos);return a-c}value(){return this._value[this._pos]}}e.StringIterator=D;class I{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?k.compareSubstring(s,this._value,0,s.length,this._from,this._to):k.compareSubstringIgnoreCase(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class n{constructor(s=!0,a=!0){this._splitOnBackslash=s,this._caseSensitive=a}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?k.compareSubstring(s,this._value,0,s.length,this._from,this._to):k.compareSubstringIgnoreCase(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var C;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(C||(C={}));class S{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return k.compareIgnoreCase(s,this._value.scheme);if(this._states[this._stateIdx]===2)return k.compareIgnoreCase(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return k.compare(s,this._value.query);if(this._states[this._stateIdx]===5)return k.compare(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class f{constructor(s){this._iter=s}static forUris(s=()=>!1){return new f(new S(s))}static forPaths(){return new f(new n)}static forStrings(){return new f(new D)}static forConfigKeys(){return new f(new I)}clear(){this._root=void 0}set(s,a){const c=this._iter.reset(s);let t;for(this._root||(this._root=new v,this._root.segment=c.value()),t=this._root;;){const o=c.cmp(t.segment);if(o>0)t.left||(t.left=new v,t.left.segment=c.value()),t=t.left;else if(o<0)t.right||(t.right=new v,t.right.segment=c.value()),t=t.right;else if(c.hasNext())c.next(),t.mid||(t.mid=new v,t.mid.segment=c.value()),t=t.mid;else break}const r=t.value;return t.value=a,t.key=s,r}get(s){var a;return(a=this._getNode(s))===null||a===void 0?void 0:a.value}_getNode(s){const a=this._iter.reset(s);let c=this._root;for(;c;){const t=a.cmp(c.segment);if(t>0)c=c.left;else if(t<0)c=c.right;else if(a.hasNext())a.next(),c=c.mid;else break}return c}has(s){const a=this._getNode(s);return!((a==null?void 0:a.value)===void 0&&(a==null?void 0:a.mid)===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,a){const c=this._iter.reset(s),t=[];let r=this._root;for(;r;){const o=c.cmp(r.segment);if(o>0)t.push([1,r]),r=r.left;else if(o<0)t.push([-1,r]),r=r.right;else if(c.hasNext())c.next(),t.push([0,r]),r=r.mid;else{for(a?(r.left=void 0,r.mid=void 0,r.right=void 0):r.value=void 0;t.length>0&&r.isEmpty();){let[l,i]=t.pop();switch(l){case 1:i.left=void 0;break;case 0:i.mid=void 0;break;case-1:i.right=void 0;break}r=i}break}}}findSubstr(s){const a=this._iter.reset(s);let c=this._root,t;for(;c;){const r=a.cmp(c.segment);if(r>0)c=c.left;else if(r<0)c=c.right;else if(a.hasNext())a.next(),t=c.value||t,c=c.mid;else break}return c&&c.value||t}findSuperstr(s){const a=this._iter.reset(s);let c=this._root;for(;c;){const t=a.cmp(c.segment);if(t>0)c=c.left;else if(t<0)c=c.right;else if(a.hasNext())a.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(s){for(const[a,c]of this)s(c,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){s&&(yield*this._entries(s.left),s.value&&(yield[s.key,s.value]),yield*this._entries(s.mid),yield*this._entries(s.right))}}e.TernarySearchTree=f;class u{constructor(s,a){this[Symbol.toStringTag]="ResourceMap",s instanceof u?(this.map=new Map(s.map),this.toKey=a!=null?a:u.defaultToKey):(this.map=new Map,this.toKey=s!=null?s:u.defaultToKey)}set(s,a){return this.map.set(this.toKey(s),a),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,a){typeof a!="undefined"&&(s=s.bind(a));for(let[c,t]of this.map)s(t,_.URI.parse(c),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield _.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[_.URI.parse(s[0]),s[1]]}*[Symbol.iterator](){for(let s of this.map)yield[_.URI.parse(s[0]),s[1]]}}e.ResourceMap=u,u.defaultToKey=d=>d.toString();var m;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(m=e.Touch||(e.Touch={}));class w{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,a=0){const c=this._map.get(s);if(!!c)return a!==0&&this.touch(c,a),c.value}set(s,a,c=0){let t=this._map.get(s);if(t)t.value=a,c!==0&&this.touch(t,c);else{switch(t={key:s,value:a,next:void 0,previous:void 0},c){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(s,t),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const a=this._map.get(s);if(!!a)return this._map.delete(s),this.removeItem(a),this._size--,a.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}}forEach(s,a){const c=this._state;let t=this._head;for(;t;){if(a?s.bind(a)(t.value,t.key,this):s(t.value,t.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const s=this,a=this._state;let c=this._head;const t={[Symbol.iterator](){return t},next(){if(s._state!==a)throw new Error("LinkedMap got modified during iteration.");if(c){const r={value:c.key,done:!1};return c=c.next,r}else return{value:void 0,done:!0}}};return t}values(){const s=this,a=this._state;let c=this._head;const t={[Symbol.iterator](){return t},next(){if(s._state!==a)throw new Error("LinkedMap got modified during iteration.");if(c){const r={value:c.value,done:!1};return c=c.next,r}else return{value:void 0,done:!0}}};return t}entries(){const s=this,a=this._state;let c=this._head;const t={[Symbol.iterator](){return t},next(){if(s._state!==a)throw new Error("LinkedMap got modified during iteration.");if(c){const r={value:[c.key,c.value],done:!1};return c=c.next,r}else return{value:void 0,done:!0}}};return t}[Symbol.iterator](){return this.entries()}trimOld(s){if(!(s>=this.size)){if(s===0){this.clear();return}let a=this._head,c=this.size;for(;a&&c>s;)this._map.delete(a.key),a=a.next,c--;this._head=a,this._size=c,a&&(a.previous=void 0),this._state++}}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const a=s.next,c=s.previous;if(!a||!c)throw new Error("Invalid list");a.previous=c,c.next=a}s.next=void 0,s.previous=void 0,this._state++}touch(s,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(s===this._head)return;const c=s.next,t=s.previous;s===this._tail?(t.next=void 0,this._tail=t):(c.previous=t,t.next=c),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(a===2){if(s===this._tail)return;const c=s.next,t=s.previous;s===this._head?(c.previous=void 0,this._head=c):(c.previous=t,t.next=c),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((a,c)=>{s.push([c,a])}),s}fromJSON(s){this.clear();for(const[a,c]of s)this.set(a,c)}}e.LinkedMap=w;class p extends w{constructor(s,a=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,a=2){return super.get(s,a)}peek(s){return super.get(s,0)}set(s,a){return super.set(s,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p}),define(ge[96],pe([0,1,22,10]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function R(...Ee){return function(Pe,Ce){for(let Oe=0,Se=Ee.length;Oe<Se;Oe++){const Be=Ee[Oe](Pe,Ce);if(Be)return Be}return null}}e.or=R,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(Ee,Pe,Ce){if(!Ce||Ce.length<Pe.length)return null;let Oe;return Ee?Oe=k.startsWithIgnoreCase(Ce,Pe):Oe=Ce.indexOf(Pe)===0,Oe?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function P(Ee,Pe){const Ce=Pe.toLowerCase().indexOf(Ee.toLowerCase());return Ce===-1?null:[{start:Ce,end:Ce+Ee.length}]}e.matchesContiguousSubString=P;function D(Ee,Pe){return I(Ee.toLowerCase(),Pe.toLowerCase(),0,0)}e.matchesSubString=D;function I(Ee,Pe,Ce,Oe){if(Ce===Ee.length)return[];if(Oe===Pe.length)return null;if(Ee[Ce]===Pe[Oe]){let Se=null;return(Se=I(Ee,Pe,Ce+1,Oe+1))?p({start:Oe,end:Oe+1},Se):null}return I(Ee,Pe,Ce,Oe+1)}function n(Ee){return 97<=Ee&&Ee<=122}function C(Ee){return 65<=Ee&&Ee<=90}e.isUpper=C;function S(Ee){return 48<=Ee&&Ee<=57}function v(Ee){return Ee===32||Ee===9||Ee===10||Ee===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Ee=>f.add(Ee.charCodeAt(0)));function u(Ee){return v(Ee)||f.has(Ee)}function m(Ee,Pe){return Ee===Pe||u(Ee)&&u(Pe)}function w(Ee){return n(Ee)||C(Ee)||S(Ee)}function p(Ee,Pe){return Pe.length===0?Pe=[Ee]:Ee.end===Pe[0].start?Pe[0].start=Ee.start:Pe.unshift(Ee),Pe}function d(Ee,Pe){for(let Ce=Pe;Ce<Ee.length;Ce++){const Oe=Ee.charCodeAt(Ce);if(C(Oe)||S(Oe)||Ce>0&&!w(Ee.charCodeAt(Ce-1)))return Ce}return Ee.length}function s(Ee,Pe,Ce,Oe){if(Ce===Ee.length)return[];if(Oe===Pe.length)return null;if(Ee[Ce]!==Pe[Oe].toLowerCase())return null;{let Se=null,Be=Oe+1;for(Se=s(Ee,Pe,Ce+1,Oe+1);!Se&&(Be=d(Pe,Be))<Pe.length;)Se=s(Ee,Pe,Ce+1,Be),Be++;return Se===null?null:p({start:Oe,end:Oe+1},Se)}}function a(Ee){let Pe=0,Ce=0,Oe=0,Se=0,Be=0;for(let Ue=0;Ue<Ee.length;Ue++)Be=Ee.charCodeAt(Ue),C(Be)&&Pe++,n(Be)&&Ce++,w(Be)&&Oe++,S(Be)&&Se++;const K=Pe/Ee.length,se=Ce/Ee.length,_e=Oe/Ee.length,Ae=Se/Ee.length;return{upperPercent:K,lowerPercent:se,alphaPercent:_e,numericPercent:Ae}}function c(Ee){const{upperPercent:Pe,lowerPercent:Ce}=Ee;return Ce===0&&Pe>.6}function t(Ee){const{upperPercent:Pe,lowerPercent:Ce,alphaPercent:Oe,numericPercent:Se}=Ee;return Ce>.2&&Pe<.8&&Oe>.6&&Se<.2}function r(Ee){let Pe=0,Ce=0,Oe=0,Se=0;for(let Be=0;Be<Ee.length;Be++)Oe=Ee.charCodeAt(Be),C(Oe)&&Pe++,n(Oe)&&Ce++,v(Oe)&&Se++;return(Pe===0||Ce===0)&&Se===0?Ee.length<=30:Pe<=5}function o(Ee,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!r(Ee)||Pe.length>60)return null;const Ce=a(Pe);if(!t(Ce)){if(!c(Ce))return null;Pe=Pe.toLowerCase()}let Oe=null,Se=0;for(Ee=Ee.toLowerCase();Se<Pe.length&&(Oe=s(Ee,Pe,0,Se))===null;)Se=d(Pe,Se+1);return Oe}e.matchesCamelCase=o;function l(Ee,Pe,Ce=!1){if(!Pe||Pe.length===0)return null;let Oe=null,Se=0;for(Ee=Ee.toLowerCase(),Pe=Pe.toLowerCase();Se<Pe.length&&(Oe=i(Ee,Pe,0,Se,Ce))===null;)Se=h(Pe,Se+1);return Oe}e.matchesWords=l;function i(Ee,Pe,Ce,Oe,Se){if(Ce===Ee.length)return[];if(Oe===Pe.length)return null;if(m(Ee.charCodeAt(Ce),Pe.charCodeAt(Oe))){let Be=null,K=Oe+1;if(Be=i(Ee,Pe,Ce+1,Oe+1,Se),!Se)for(;!Be&&(K=h(Pe,K))<Pe.length;)Be=i(Ee,Pe,Ce+1,K,Se),K++;return Be===null?null:p({start:Oe,end:Oe+1},Be)}else return null}function h(Ee,Pe){for(let Ce=Pe;Ce<Ee.length;Ce++)if(u(Ee.charCodeAt(Ce))||Ce>0&&u(Ee.charCodeAt(Ce-1)))return Ce;return Ee.length}const y=R(e.matchesPrefix,o,P),g=R(e.matchesPrefix,o,D),E=new _.LRUCache(1e4);function b(Ee,Pe,Ce=!1){if(typeof Ee!="string"||typeof Pe!="string")return null;let Oe=E.get(Ee);Oe||(Oe=new RegExp(k.convertSimple2RegExpPattern(Ee),"i"),E.set(Ee,Oe));const Se=Oe.exec(Pe);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Ce?g(Ee,Pe):y(Ee,Pe)}e.matchesFuzzy=b;function L(Ee,Pe){const Ce=X(Ee,Ee.toLowerCase(),0,Pe,Pe.toLowerCase(),0,!0);return Ce?N(Ce):null}e.matchesFuzzy2=L;function A(Ee,Pe,Ce,Oe,Se,Be){const K=X(Ee,Pe,0,Oe,Se,0,!0);if(K)return K;let se=[],_e=0,Ae=Be;for(let Ue=0;Ue<Pe.length&&Ue<W;++Ue){const ze=Se.indexOf(Pe.charAt(Ue),Ae);if(ze>=0)_e+=1,se.unshift(ze),Ae=ze+1;else if(se.length>0)break}return[_e,Be,...se]}e.anyScore=A;function N(Ee){if(typeof Ee=="undefined")return[];const Pe=[],Ce=Ee[1];for(let Oe=Ee.length-1;Oe>1;Oe--){const Se=Ee[Oe]+Ce,Be=Pe[Pe.length-1];Be&&Be.end===Se?Be.end=Se+1:Pe.push({start:Se,end:Se+1})}return Pe}e.createMatches=N;const W=128;function x(){const Ee=[],Pe=[];for(let Ce=0;Ce<=W;Ce++)Pe[Ce]=0;for(let Ce=0;Ce<=W;Ce++)Ee.push(Pe.slice(0));return Ee}function M(Ee){const Pe=[];for(let Ce=0;Ce<=Ee;Ce++)Pe[Ce]=0;return Pe}const $=M(2*W),O=M(2*W),B=x(),J=x(),U=x(),V=!1;function z(Ee,Pe,Ce,Oe,Se){function Be(se,_e,Ae=" "){for(;se.length<_e;)se=Ae+se;return se}let K=` |   |${Oe.split("").map(se=>Be(se,3)).join("|")}
`;for(let se=0;se<=Ce;se++)se===0?K+=" |":K+=`${Pe[se-1]}|`,K+=Ee[se].slice(0,Se+1).map(_e=>Be(_e.toString(),3)).join("|")+`
`;return K}function Q(Ee,Pe,Ce,Oe){Ee=Ee.substr(Pe),Ce=Ce.substr(Oe),console.log(z(J,Ee,Ee.length,Ce,Ce.length)),console.log(z(U,Ee,Ee.length,Ce,Ce.length)),console.log(z(B,Ee,Ee.length,Ce,Ce.length))}function ae(Ee,Pe){if(Pe<0||Pe>=Ee.length)return!1;const Ce=Ee.codePointAt(Pe);switch(Ce){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(Ce)}}function ce(Ee,Pe){if(Pe<0||Pe>=Ee.length)return!1;switch(Ee.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function fe(Ee,Pe,Ce){return Pe[Ee]!==Ce[Ee]}function we(Ee,Pe,Ce,Oe,Se,Be,K=!1){for(;Pe<Ce&&Se<Be;)Ee[Pe]===Oe[Se]&&(K&&($[Pe]=Se),Pe+=1),Se+=1;return Pe===Ce}e.isPatternInWord=we;var be;(function(Ee){Ee[Ee.Diag=1]="Diag",Ee[Ee.Left=2]="Left",Ee[Ee.LeftLeft=3]="LeftLeft"})(be||(be={}));var H;(function(Ee){Ee.Default=[-100,0];function Pe(Ce){return!Ce||Ce[0]===-100&&Ce[1]===0&&Ce[2]===0}Ee.isDefault=Pe})(H=e.FuzzyScore||(e.FuzzyScore={}));function X(Ee,Pe,Ce,Oe,Se,Be,K){const se=Ee.length>W?W:Ee.length,_e=Oe.length>W?W:Oe.length;if(!(Ce>=se||Be>=_e||se-Ce>_e-Be)&&!!we(Pe,Ce,se,Se,Be,_e,!0)){re(se,_e,Ce,Be,Pe,Se);let Ae=1,Ue=1,ze=Ce,je=Be;const ue=[!1];for(Ae=1,ze=Ce;ze<se;Ae++,ze++){const G=$[ze],F=O[ze],ie=ze+1<se?O[ze+1]:_e;for(Ue=G-Be+1,je=G;je<ie;Ue++,je++){let oe=Number.MIN_SAFE_INTEGER,me=!1;je<=F&&(oe=Y(Ee,Pe,ze,Ce,Oe,Se,je,_e,Be,B[Ae-1][Ue-1]===0,ue));let ke=0;oe!==Number.MAX_SAFE_INTEGER&&(me=!0,ke=oe+J[Ae-1][Ue-1]);const Re=je>G,xe=Re?J[Ae][Ue-1]+(B[Ae][Ue-1]>0?-5:0):0,qe=je>G+1&&B[Ae][Ue-1]>0,Ge=qe?J[Ae][Ue-2]+(B[Ae][Ue-2]>0?-5:0):0;if(qe&&(!Re||Ge>=xe)&&(!me||Ge>=ke))J[Ae][Ue]=Ge,U[Ae][Ue]=3,B[Ae][Ue]=0;else if(Re&&(!me||xe>=ke))J[Ae][Ue]=xe,U[Ae][Ue]=2,B[Ae][Ue]=0;else if(me)J[Ae][Ue]=ke,U[Ae][Ue]=1,B[Ae][Ue]=B[Ae-1][Ue-1]+1;else throw new Error("not possible")}}if(V&&Q(Ee,Ce,Oe,Be),!(!ue[0]&&!K)){Ae--,Ue--;const ye=[J[Ae][Ue],Be];let Ne=0,ee=0;for(;Ae>=1;){let G=Ue;do{const F=U[Ae][G];if(F===3)G=G-2;else if(F===2)G=G-1;else break}while(G>=1);Ne>1&&Pe[Ce+Ae-1]===Se[Be+Ue-1]&&!fe(G+Be-1,Oe,Se)&&Ne+1>B[Ae][G]&&(G=Ue),G===Ue?Ne++:Ne=1,ee||(ee=G),Ae--,Ue=G-1,ye.push(Ue)}_e===se&&(ye[0]+=2);const te=ee-se;return ye[0]-=te,ye}}}e.fuzzyScore=X;function re(Ee,Pe,Ce,Oe,Se,Be){let K=Ee-1,se=Pe-1;for(;K>=Ce&&se>=Oe;)Se[K]===Be[se]&&(O[K]=se,K--),se--}function Y(Ee,Pe,Ce,Oe,Se,Be,K,se,_e,Ae,Ue){if(Pe[Ce]!==Be[K])return Number.MIN_SAFE_INTEGER;let ze=1,je=!1;return K===Ce-Oe?ze=Ee[Ce]===Se[K]?7:5:fe(K,Se,Be)&&(K===0||!fe(K-1,Se,Be))?(ze=Ee[Ce]===Se[K]?7:5,je=!0):ae(Be,K)&&(K===0||!ae(Be,K-1))?ze=5:(ae(Be,K-1)||ce(Be,K-1))&&(ze=5,je=!0),ze>1&&Ce===Oe&&(Ue[0]=!0),je||(je=fe(K,Se,Be)||ae(Be,K-1)||ce(Be,K-1)),Ce===Oe?K>_e&&(ze-=je?3:5):Ae?ze+=je?2:0:ze+=je?0:1,K+1===se&&(ze-=je?3:5),ze}function le(Ee,Pe,Ce,Oe,Se,Be,K){return De(Ee,Pe,Ce,Oe,Se,Be,!0,K)}e.fuzzyScoreGracefulAggressive=le;function ve(Ee,Pe,Ce,Oe,Se,Be,K){return De(Ee,Pe,Ce,Oe,Se,Be,!1,K)}e.fuzzyScoreGraceful=ve;function De(Ee,Pe,Ce,Oe,Se,Be,K,se){let _e=X(Ee,Pe,Ce,Oe,Se,Be,se);if(_e&&!K)return _e;if(Ee.length>=3){const Ae=Math.min(7,Ee.length-1);for(let Ue=Ce+1;Ue<Ae;Ue++){const ze=Me(Ee,Ue);if(ze){const je=X(ze,ze.toLowerCase(),Ce,Oe,Se,Be,se);je&&(je[0]-=3,(!_e||je[0]>_e[0])&&(_e=je))}}}return _e}function Me(Ee,Pe){if(!(Pe+1>=Ee.length)){const Ce=Ee[Pe],Oe=Ee[Pe+1];if(Ce!==Oe)return Ee.slice(0,Pe)+Oe+Ce+Ee.slice(Pe+2)}}}),define(ge[97],pe([0,1,93,96,7,9,10]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const D=0,I=[D,[]];function n(M,$,O,B){if(!M||!$)return I;const J=M.length,U=$.length;if(J<U)return I;const V=M.toLowerCase();return!B&&!V.includes(O)?I:C($,O,U,M,V,J)}e.scoreFuzzy=n;function C(M,$,O,B,J,U){const V=[],z=[];for(let fe=0;fe<O;fe++){const we=fe*U,be=we-U,H=fe>0,X=M[fe],re=$[fe];for(let Y=0;Y<U;Y++){const le=Y>0,ve=we+Y,De=ve-1,Me=be+Y-1,Ee=le?V[De]:0,Pe=H&&le?V[Me]:0,Ce=H&&le?z[Me]:0;let Oe;!Pe&&H?Oe=0:Oe=S(X,re,B,J,Y,Ce),Oe&&Pe+Oe>=Ee?(z[ve]=Ce+1,V[ve]=Pe+Oe):(z[ve]=D,V[ve]=Ee)}}const Q=[];let ae=O-1,ce=U-1;for(;ae>=0&&ce>=0;){const fe=ae*U+ce;z[fe]===D||(Q.push(ce),ae--),ce--}return[V[O*U-1],Q.reverse()]}function S(M,$,O,B,J,U){let V=0;if(!v($,B[J]))return V;if(V+=1,U>0&&(V+=U*5),M===O[J]&&(V+=1),J===0)V+=8;else{const z=f(O.charCodeAt(J-1));z?V+=z:k.isUpper(O.charCodeAt(J))&&(V+=2)}return V}function v(M,$){return M===$?!0:M==="/"||M==="\\"?$==="/"||$==="\\":!1}function f(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function m(M,$,O=0,B=0){const J=$;return J.values&&J.values.length>1?w(M,J.values,O,B):p(M,$,O,B)}e.scoreFuzzy2=m;function w(M,$,O,B){let J=0;const U=[];for(const V of $){const[z,Q]=p(M,V,O,B);if(typeof z!="number")return u;J+=z,U.push(...Q)}return[J,h(U)]}function p(M,$,O,B){const J=k.fuzzyScore($.original,$.originalLowercase,O,M,M.toLowerCase(),B,!0);return J?[J[0],k.createMatches(J)]:u}const d=Object.freeze({score:0}),s=1<<18,a=1<<17,c=1<<16;function t(M,$,O,B,J){if(!M||!$.normalized)return d;const U=B.getItemLabel(M);if(!U)return d;const V=B.getItemDescription(M);let z;V?z=`${U}${V}${$.normalized}${Array.isArray($.values)?$.values.length:""}${O}`:z=`${U}${$.normalized}${Array.isArray($.values)?$.values.length:""}${O}`;const Q=J[z];if(Q)return Q;const ae=r(U,V,B.getItemPath(M),$,O);return J[z]=ae,ae}e.scoreItemFuzzy=t;function r(M,$,O,B,J){const U=!O||!B.containsPathSeparator;return O&&(T.isLinux?B.pathNormalized===O:P.equalsIgnoreCase(B.pathNormalized,O))?{score:s,labelMatch:[{start:0,end:M.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:B.values&&B.values.length>1?o(M,$,O,B.values,U,J):l(M,$,O,B,U,J)}function o(M,$,O,B,J,U){let V=0;const z=[],Q=[];for(const ae of B){const{score:ce,labelMatch:fe,descriptionMatch:we}=l(M,$,O,ae,J,U);if(ce===D)return d;V+=ce,fe&&z.push(...fe),we&&Q.push(...we)}return{score:V,labelMatch:h(z),descriptionMatch:h(Q)}}function l(M,$,O,B,J,U){if(J||!$){const[V,z]=n(M,B.normalized,B.normalizedLowercase,U);if(V){const Q=k.matchesPrefix(B.normalized,M);let ae;return Q?(ae=a,ae+=Math.round(B.normalized.length/M.length*100)):ae=c,{score:ae+V,labelMatch:Q||i(z)}}}if($){let V=$;O&&(V=`${$}${R.sep}`);const z=V.length,Q=`${V}${M}`,[ae,ce]=n(Q,B.normalized,B.normalizedLowercase,U);if(ae){const fe=i(ce),we=[],be=[];return fe.forEach(H=>{H.start<z&&H.end>z?(we.push({start:0,end:H.end-z}),be.push({start:H.start,end:z})):H.start>=z?we.push({start:H.start-z,end:H.end-z}):be.push(H)}),{score:ae,labelMatch:we,descriptionMatch:be}}}return d}function i(M){const $=[];if(!M)return $;let O;for(const B of M)O&&O.end===B?O.end+=1:(O={start:B,end:B+1},$.push(O));return $}function h(M){const $=M.sort((J,U)=>J.start-U.start),O=[];let B;for(const J of $)!B||!y(B,J)?(B=J,O.push(J)):(B.start=Math.min(B.start,J.start),B.end=Math.max(B.end,J.end));return O}function y(M,$){return!(M.end<$.start||$.end<M.start)}function g(M,$,O,B,J,U){const V=t(M,O,B,J,U),z=t($,O,B,J,U),Q=V.score,ae=z.score;if((Q===s||ae===s)&&Q!==ae)return Q===s?-1:1;if(Q>c||ae>c){if(Q!==ae)return Q>ae?-1:1;if(Q<a&&ae<a){const re=b(V.labelMatch,z.labelMatch);if(re!==0)return re}const H=J.getItemLabel(M)||"",X=J.getItemLabel($)||"";if(H.length!==X.length)return H.length-X.length}if(Q!==ae)return Q>ae?-1:1;const ce=Array.isArray(V.labelMatch)&&V.labelMatch.length>0,fe=Array.isArray(z.labelMatch)&&z.labelMatch.length>0;if(ce&&!fe)return-1;if(fe&&!ce)return 1;const we=E(M,V,J),be=E($,z,J);return we&&be&&we!==be?be>we?-1:1:L(M,$,O,J)}e.compareItemsByFuzzyScore=g;function E(M,$,O){let B=-1,J=-1;if($.descriptionMatch&&$.descriptionMatch.length?B=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(B=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(J=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const U=O.getItemDescription(M);U&&(J+=U.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(J=$.descriptionMatch[$.descriptionMatch.length-1].end);return J-B}function b(M,$){if(!M&&!$||(!M||!M.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!M||!M.length)return 1;const O=M[0].start,J=M[M.length-1].end-O,U=$[0].start,z=$[$.length-1].end-U;return J===z?0:z<J?1:-1}function L(M,$,O,B){const J=B.getItemLabel(M)||"",U=B.getItemLabel($)||"",V=B.getItemDescription(M),z=B.getItemDescription($),Q=J.length+(V?V.length:0),ae=U.length+(z?z.length:0);if(Q!==ae)return Q-ae;const ce=B.getItemPath(M),fe=B.getItemPath($);return ce&&fe&&ce.length!==fe.length?ce.length-fe.length:J!==U?_.compareAnything(J,U,O.normalized):V&&z&&V!==z?_.compareAnything(V,z,O.normalized):ce&&fe&&ce!==fe?_.compareAnything(ce,fe,O.normalized):0}const A=" ";function N(M){typeof M!="string"&&(M="");const $=M.toLowerCase(),{pathNormalized:O,normalized:B,normalizedLowercase:J}=W(M),U=O.indexOf(R.sep)>=0;let V;const z=M.split(A);if(z.length>1)for(const Q of z){const{pathNormalized:ae,normalized:ce,normalizedLowercase:fe}=W(Q);ce&&(V||(V=[]),V.push({original:Q,originalLowercase:Q.toLowerCase(),pathNormalized:ae,normalized:ce,normalizedLowercase:fe}))}return{original:M,originalLowercase:$,pathNormalized:O,normalized:B,normalizedLowercase:J,values:V,containsPathSeparator:U}}e.prepareQuery=N;function W(M){let $;T.isWindows?$=M.replace(/\//g,R.sep):$=M.replace(/\\/g,R.sep);const O=P.stripWildcards($).replace(/\s/g,"");return{pathNormalized:$,normalized:O,normalizedLowercase:O.toLowerCase()}}function x(M){return Array.isArray(M)?N(M.map($=>$.original).join(A)):N(M.original)}e.pieceToQuery=x}),define(ge[33],pe([0,1,10,30,7,22,19]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const I="**",n="/",C="[/\\\\]",S="[^/\\\\]",v=/\//g;function f(V){switch(V){case 0:return"";case 1:return`${S}*?`;default:return`(?:${C}|${S}+${C}|${C}${S}+)*?`}}function u(V,z){if(!V)return[];const Q=[];let ae=!1,ce=!1,fe="";for(const we of V){switch(we){case z:if(!ae&&!ce){Q.push(fe),fe="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}fe+=we}return fe&&Q.push(fe),Q}e.splitGlobAware=u;function m(V){if(!V)return"";let z="";const Q=u(V,n);if(Q.every(ae=>ae===I))z=".*";else{let ae=!1;Q.forEach((ce,fe)=>{if(ce===I){ae||(z+=f(2),ae=!0);return}let we=!1,be="",H=!1,X="";for(const re of ce){if(re!=="}"&&we){be+=re;continue}if(H&&(re!=="]"||!X)){let Y;re==="-"?Y=re:(re==="^"||re==="!")&&!X?Y="^":re===n?Y="":Y=_.escapeRegExpCharacters(re),X+=Y;continue}switch(re){case"{":we=!0;continue;case"[":H=!0;continue;case"}":z+=`(?:${u(be,",").map(ve=>m(ve)).join("|")})`,we=!1,be="";break;case"]":z+="["+X+"]",H=!1,X="";break;case"?":z+=S;continue;case"*":z+=f(1);continue;default:z+=_.escapeRegExpCharacters(re)}}fe<Q.length-1&&(Q[fe+1]!==I||fe+2<Q.length)&&(z+=C),ae=!1})}return z}const w=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),r=function(){return!1},o=function(){return null};function l(V,z){if(!V)return o;let Q;typeof V!="string"?Q=V.pattern:Q=V,Q=Q.trim();const ae=`${Q}_${!!z.trimForExclusions}`;let ce=t.get(ae);if(ce)return i(ce,V);let fe;if(w.test(Q)){const we=Q.substr(4);ce=function(be,H){return typeof be=="string"&&be.endsWith(we)?Q:null}}else(fe=p.exec(h(Q,z)))?ce=y(fe[1],Q):(z.trimForExclusions?s:d).test(Q)?ce=g(Q,z):(fe=a.exec(h(Q,z)))?ce=E(fe[1].substr(1),Q,!0):(fe=c.exec(h(Q,z)))?ce=E(fe[1],Q,!1):ce=b(Q);return t.set(ae,ce),i(ce,V)}function i(V,z){return typeof z=="string"?V:function(Q,ae){return k.isEqualOrParent(Q,z.base)?V(R.relative(z.base,Q),ae):null}}function h(V,z){return z.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function y(V,z){const Q=`/${V}`,ae=`\\${V}`,ce=function(we,be){return typeof we!="string"?null:be?be===V?z:null:we===V||we.endsWith(Q)||we.endsWith(ae)?z:null},fe=[V];return ce.basenames=fe,ce.patterns=[z],ce.allBasenames=fe,ce}function g(V,z){const Q=U(V.slice(1,-1).split(",").map(be=>l(be,z)).filter(be=>be!==o),V),ae=Q.length;if(!ae)return o;if(ae===1)return Q[0];const ce=function(be,H){for(let X=0,re=Q.length;X<re;X++)if(Q[X](be,H))return V;return null},fe=Q.find(be=>!!be.allBasenames);fe&&(ce.allBasenames=fe.allBasenames);const we=Q.reduce((be,H)=>H.allPaths?be.concat(H.allPaths):be,[]);return we.length&&(ce.allPaths=we),ce}function E(V,z,Q){const ae=R.sep===R.posix.sep,ce=ae?V:V.replace(v,R.sep),fe=R.sep+ce,we=R.posix.sep+V,be=Q?function(H,X){return typeof H=="string"&&(H===ce||H.endsWith(fe)||!ae&&(H===V||H.endsWith(we)))?z:null}:function(H,X){return typeof H=="string"&&(H===ce||!ae&&H===V)?z:null};return be.allPaths=[(Q?"*/":"./")+V],be}function b(V){try{const z=new RegExp(`^${m(V)}$`);return function(Q){return z.lastIndex=0,typeof Q=="string"&&z.test(Q)?V:null}}catch(z){return o}}function L(V,z,Q){return!V||typeof z!="string"?!1:A(V)(z,void 0,Q)}e.match=L;function A(V,z={}){if(!V)return r;if(typeof V=="string"||M(V)){const Q=l(V,z);if(Q===o)return r;const ae=function(ce,fe){return!!Q(ce,fe)};return Q.allBasenames&&(ae.allBasenames=Q.allBasenames),Q.allPaths&&(ae.allPaths=Q.allPaths),ae}return B(V,z)}e.parse=A;function N(V){if(!!V){let z;return Q=>(z||(z=(V()||Promise.resolve([])).then(ae=>ae?x(ae):{})),z.then(ae=>!!ae[Q]))}}e.hasSiblingPromiseFn=N;function W(V){if(!!V){let z;return Q=>{if(!z){const ae=V();z=ae?x(ae):{}}return!!z[Q]}}}e.hasSiblingFn=W;function x(V){const z={};for(const Q of V)z[Q]=!0;return z}function M(V){const z=V;return z&&typeof z.base=="string"&&typeof z.pattern=="string"}e.isRelativePattern=M;function $(V){return V.allBasenames||[]}e.getBasenameTerms=$;function O(V){return V.allPaths||[]}e.getPathTerms=O;function B(V,z){const Q=U(Object.getOwnPropertyNames(V).map(be=>J(be,V[be],z)).filter(be=>be!==o)),ae=Q.length;if(!ae)return o;if(!Q.some(be=>!!be.requiresSiblings)){if(ae===1)return Q[0];const be=function(re,Y){for(let le=0,ve=Q.length;le<ve;le++){const De=Q[le](re,Y);if(De)return De}return null},H=Q.find(re=>!!re.allBasenames);H&&(be.allBasenames=H.allBasenames);const X=Q.reduce((re,Y)=>Y.allPaths?re.concat(Y.allPaths):re,[]);return X.length&&(be.allPaths=X),be}const ce=function(be,H,X){let re;for(let Y=0,le=Q.length;Y<le;Y++){const ve=Q[Y];ve.requiresSiblings&&X&&(H||(H=R.basename(be)),re||(re=H.substr(0,H.length-R.extname(be).length)));const De=ve(be,H,re,X);if(De)return De}return null},fe=Q.find(be=>!!be.allBasenames);fe&&(ce.allBasenames=fe.allBasenames);const we=Q.reduce((be,H)=>H.allPaths?be.concat(H.allPaths):be,[]);return we.length&&(ce.allPaths=we),ce}function J(V,z,Q){if(z===!1)return o;const ae=l(V,Q);if(ae===o)return o;if(typeof z=="boolean")return ae;if(z){const ce=z.when;if(typeof ce=="string"){const fe=(we,be,H,X)=>{if(!X||!ae(we,be))return null;const re=ce.replace("$(basename)",H),Y=X(re);return P.isThenable(Y)?Y.then(le=>le?V:null):Y?V:null};return fe.requiresSiblings=!0,fe}}return ae}function U(V,z){const Q=V.filter(be=>!!be.basenames);if(Q.length<2)return V;const ae=Q.reduce((be,H)=>{const X=H.basenames;return X?be.concat(X):be},[]);let ce;if(z){ce=[];for(let be=0,H=ae.length;be<H;be++)ce.push(z)}else ce=Q.reduce((be,H)=>{const X=H.patterns;return X?be.concat(X):be},[]);const fe=function(be,H){if(typeof be!="string")return null;if(!H){let re;for(re=be.length;re>0;re--){const Y=be.charCodeAt(re-1);if(Y===47||Y===92)break}H=be.substr(re)}const X=ae.indexOf(H);return X!==-1?ce[X]:null};fe.basenames=ae,fe.patterns=ce,fe.allBasenames=ae;const we=V.filter(be=>!be.basenames);return we.push(fe),we}}),define(ge[133],pe([0,1,96,10]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownUnescapeIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const R=/(\\)?\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)/gi;function T(m){return m.replace(R,(w,p)=>p?w:`\\${w}`)}e.escapeIcons=T;const P=/\\\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)/gi;function D(m){return m.replace(P,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=D;const I=/(\\)?\$\\\(([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?)\\\)/gi;function n(m){return m.replace(I,(w,p,d)=>p?w:`$(${d})`)}e.markdownUnescapeIcons=n;const C=/(\s)?(\\)?\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)(\s)?/gi;function S(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(C,(w,p,d,s)=>d?w:p||s||"")}e.stripIcons=S;function v(m){const w=m.indexOf(e.iconStartMarker);return w===-1?{text:m}:f(m,w)}e.parseLabelWithIcons=v;function f(m,w){const p=[];let d="";function s(h){if(h){d+=h;for(const y of h)p.push(t)}}let a=-1,c="",t=0,r,o,l=w;const i=m.length;for(s(m.substr(0,w));l<i;)r=m[l],o=m[l+1],r===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(a=l,s(c),c=e.iconStartMarker,l++):r===")"&&a!==-1?(t+=l-a+1,a=-1,c=""):a!==-1?/^[a-z0-9\-]$/i.test(r)?c+=r:(s(c),a=-1,c=""):s(r),l++;return s(c),{text:d,iconOffsets:p}}function u(m,w,p=!1){const{text:d,iconOffsets:s}=w;if(!s||s.length===0)return _.matchesFuzzy(m,d,p);const a=k.ltrim(d," "),c=d.length-a.length,t=_.matchesFuzzy(m,a,p);if(t)for(const r of t){const o=s[r.start+c]+c;r.start+=o,r.end+=o}return t}e.matchesFuzzyIconAware=u}),define(ge[98],pe([0,1,13,133,15]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class P{constructor(m="",w=!1){var p,d;if(this.value=m,typeof this.value!="string")throw R.illegalArgument("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1):(this.isTrusted=(p=w.isTrusted)!==null&&p!==void 0?p:void 0,this.supportThemeIcons=(d=w.supportThemeIcons)!==null&&d!==void 0?d:!1)}appendText(m,w=0){return this.value+=S(this.supportThemeIcons?k.escapeIcons(m):m).replace(/([ \t]+)/g,(p,d)=>"&nbsp;".repeat(d.length)).replace(/^>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,w){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=w,this.value+="\n```\n",this}}e.MarkdownString=P;function D(u){return I(u)?!u.value:Array.isArray(u)?u.every(D):!0}e.isEmptyMarkdownString=D;function I(u){return u instanceof P?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function n(u,m){return!u&&!m?!0:!u||!m?!1:Array.isArray(u)&&Array.isArray(m)?_.equals(u,m,C):I(u)&&I(m)?C(u,m):!1}e.markedStringsEquals=n;function C(u,m){return u===m?!0:!u||!m?!1:u.value===m.value&&u.isTrusted===m.isTrusted&&u.supportThemeIcons===m.supportThemeIcons}function S(u){return u.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function v(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=v;function f(u){const m=[],w=u.split("|").map(d=>d.trim());u=w[0];const p=w[1];if(p){const d=/height=(\d+)/.exec(p),s=/width=(\d+)/.exec(p),a=d?d[1]:"",c=s?s[1]:"",t=isFinite(parseInt(c)),r=isFinite(parseInt(a));t&&m.push(`width="${c}"`),r&&m.push(`height="${a}"`)}return{href:u,dimensions:m}}e.parseHrefAndDimensions=f}),define(ge[58],pe([0,1,27,10,2]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(n){return JSON.stringify(n,D)}e.stringify=T;function P(n){let C=JSON.parse(n);return C=I(C),C}e.parse=P;function D(n,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:k.regExpFlags(C)}:C}function I(n,C=0){if(!n||C>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return R.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof _.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let S=0;S<n.length;++S)n[S]=I(n[S],C+1);else for(const S in n)Object.hasOwnProperty.call(n,S)&&(n[S]=I(n[S],C+1))}return n}e.revive=I}),define(ge[11],pe([0,1,2,9]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeSettings="vscode-settings",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.vscodeWebviewResource="vscode-webview-resource",D.extension="extension",D.vscodeFileResource="vscode-file"})(R=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(I){this._preferredWebSchema=I}setDelegate(I){this._delegate=I}set(I,n,C){this._hosts[I]=n,this._ports[I]=C}setConnectionToken(I,n){this._connectionTokens[I]=n}rewrite(I){if(this._delegate)return this._delegate(I);const n=I.authority;let C=this._hosts[n];C&&C.indexOf(":")!==-1&&(C=`[${C}]`);const S=this._connectionTokens[n];let v=`path=${encodeURIComponent(I.path)}`;return typeof S=="string"&&(v+=`&tkn=${encodeURIComponent(S)}`),_.URI.from({scheme:k.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:window.location.host,path:`${window.location.pathname.replace(/\/+$/,"")}/vscode-remote-resource`,query:v})}}e.RemoteAuthorities=new T;class P{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(I,n,C){const S=this.toUri(I,n);return S.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(S):k.isNative&&(C||k.isPreferringBrowserCodeLoad)&&S.scheme===R.file?S.with({scheme:R.vscodeFileResource,authority:S.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):S}asFileUri(I,n){const C=this.toUri(I,n);return C.scheme===R.vscodeFileResource?C.with({scheme:R.file,authority:C.authority!==this.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(I,n){return _.URI.isUri(I)?I:_.URI.parse(n.toUrl(I))}}e.FileAccess=new P}),define(ge[77],pe([0,1,22]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const k=new _.LRUCache(1e4);function R(n){return I(n,"NFC",k)}e.normalizeNFC=R;const T=new _.LRUCache(1e4);function P(n){return I(n,"NFD",T)}e.normalizeNFD=P;const D=/[^\u0000-\u0080]/;function I(n,C,S){if(!e.canNormalize||!n)return n;const v=S.get(n);if(v)return v;let f;return D.test(n)?f=n.normalize(C):f=n,S.set(n,f),f}e.removeAccents=function(){if(e.canNormalize){const n=/[\u0300-\u036f]/g;return function(C){return P(C).replace(n,"")}}else return function(n){return n}}()}),define(ge[23],pe([0,1,30,7,2,10,11,9]),function(Z,e,_,k,R,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(f){return R.uriToFsPath(f,!0)}e.originalFSPath=I;class n{constructor(u){this._ignorePathCasing=u}compare(u,m,w=!1){return u===m?0:T.compare(this.getComparisonKey(u,w),this.getComparisonKey(m,w))}isEqual(u,m,w=!1){return u===m?!0:!u||!m?!1:this.getComparisonKey(u,w)===this.getComparisonKey(m,w)}getComparisonKey(u,m=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,m,w=!1){if(u.scheme===m.scheme){if(u.scheme===P.Schemas.file)return _.isEqualOrParent(I(u),I(m),this._ignorePathCasing(u))&&u.query===m.query&&(w||u.fragment===m.fragment);if(e.isEqualAuthority(u.authority,m.authority))return _.isEqualOrParent(u.path,m.path,this._ignorePathCasing(u),"/")&&u.query===m.query&&(w||u.fragment===m.fragment)}return!1}joinPath(u,...m){return R.URI.joinPath(u,...m)}basenameOrAuthority(u){return e.basename(u)||u.authority}basename(u){return k.posix.basename(u.path)}extname(u){return k.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let m;return u.scheme===P.Schemas.file?m=R.URI.file(k.dirname(I(u))).path:(m=k.posix.dirname(u.path),u.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),m="/")),u.with({path:m})}normalizePath(u){if(!u.path.length)return u;let m;return u.scheme===P.Schemas.file?m=R.URI.file(k.normalize(I(u))).path:m=k.posix.normalize(u.path),u.with({path:m})}relativePath(u,m){if(!(u.scheme!==m.scheme||!e.isEqualAuthority(u.authority,m.authority))){if(u.scheme===P.Schemas.file){const d=k.relative(I(u),I(m));return D.isWindows?_.toSlashes(d):d}let w=u.path||"/",p=m.path||"/";if(this._ignorePathCasing(u)){let d=0;for(const s=Math.min(w.length,p.length);d<s&&!(w.charCodeAt(d)!==p.charCodeAt(d)&&w.charAt(d).toLowerCase()!==p.charAt(d).toLowerCase());d++);w=p.substr(0,d)+w.substr(d)}return k.posix.relative(w,p)}}resolvePath(u,m){if(u.scheme===P.Schemas.file){const w=R.URI.file(k.resolve(I(u),m));return u.with({authority:w.authority,path:w.path})}return m.indexOf("/")===-1&&(m=_.toSlashes(m),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m)),u.with({path:k.posix.resolve(u.path,m)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,m){return u===m||T.equalsIgnoreCase(u,m)}hasTrailingPathSeparator(u,m=k.sep){if(u.scheme===P.Schemas.file){const w=I(u);return w.length>_.getRoot(w).length&&w[w.length-1]===m}else{const w=u.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,m=k.sep){return e.hasTrailingPathSeparator(u,m)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,m=k.sep){let w=!1;if(u.scheme===P.Schemas.file){const p=I(u);w=p!==void 0&&p.length===_.getRoot(p).length&&p[p.length-1]===m}else{m="/";const p=u.path;w=p.length===1&&p.charCodeAt(p.length-1)===47}return!w&&!e.hasTrailingPathSeparator(u,m)?u.with({path:u.path+"/"}):u}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(f=>f.scheme===P.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new n(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(f,u){const m=[];for(let w=0;w<f.length;w++){const p=u(f[w]);f.some((d,s)=>s===w?!1:e.isEqualOrParent(p,u(d)))||m.push(f[w])}return m}e.distinctParents=C;var S;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function u(m){const w=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(s=>{const[a,c]=s.split(":");a&&c&&w.set(a,c)});const d=m.path.substring(0,m.path.indexOf(";"));return d&&w.set(f.META_DATA_MIME,d),w}f.parseMetaData=u})(S=e.DataUri||(e.DataUri={}));function v(f,u,m){if(u){let w=f.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),f.with({scheme:m,authority:u,path:w})}return f.with({scheme:m})}e.toLocalResource=v}),define(ge[78],pe([0,1,2,7,10,11,9,23,30]),function(Z,e,_,k,R,T,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(l,i,h){if(typeof l=="string"&&(l=_.URI.file(l)),h){const g=h.getWorkspaceFolder(l);if(g){const E=h.getWorkspace().folders.length>1;let b;if(D.isEqual(g.uri,l)?b="":b=D.relativePath(g.uri,l),E){const L=g.name?g.name:D.basename(g.uri);b=b?L+" \u2022 "+b:L}return b}}if(l.scheme!==T.Schemas.file&&l.scheme!==T.Schemas.untitled)return l.with({query:null,fragment:null}).toString(!0);if(I.hasDriveLetter(l.fsPath))return k.normalize(S(l.fsPath));let y=k.normalize(l.fsPath);return!P.isWindows&&(i==null?void 0:i.userHome)&&(y=f(y,i.userHome.fsPath)),y}e.getPathLabel=n;function C(l){if(!!l){typeof l=="string"&&(l=_.URI.file(l));const i=D.basename(l)||(l.scheme===T.Schemas.file?l.fsPath:l.path);return P.isWindows&&I.isRootOrDriveLetter(i)?S(i):i}}e.getBaseLabel=C;function S(l){return I.hasDriveLetter(l)?l.charAt(0).toUpperCase()+l.slice(1):l}e.normalizeDriveLetter=S;let v=Object.create(null);function f(l,i){if(P.isWindows||!l||!i)return l;let h=v.original===i?v.normalized:void 0;return h||(h=`${R.rtrim(i,k.posix.sep)}${k.posix.sep}`,v={original:i,normalized:h}),(P.isLinux?l.startsWith(h):R.startsWithIgnoreCase(l,h))&&(l=`~/${l.substr(h.length)}`),l}e.tildify=f;function u(l,i){return l.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=u;const m="\u2026",w="\\\\",p="~";function d(l,i=k.sep){const h=new Array(l.length);let y=!1;for(let g=0;g<l.length;g++){let E=l[g];if(E===""){h[g]=`.${i}`;continue}if(!E){h[g]=E;continue}y=!0;let b="";E.indexOf(w)===0?(b=E.substr(0,E.indexOf(w)+w.length),E=E.substr(E.indexOf(w)+w.length)):E.indexOf(i)===0?(b=E.substr(0,E.indexOf(i)+i.length),E=E.substr(E.indexOf(i)+i.length)):E.indexOf(p)===0&&(b=E.substr(0,E.indexOf(p)+p.length),E=E.substr(E.indexOf(p)+p.length));const L=E.split(i);for(let A=1;y&&A<=L.length;A++)for(let N=L.length-A;y&&N>=0;N--){y=!1;let W=L.slice(N,N+A).join(i);for(let x=0;!y&&x<l.length;x++)if(x!==g&&l[x]&&l[x].indexOf(W)>-1){const M=N+A===L.length,$=N>0&&l[x].indexOf(i)>-1?i+W:W,O=l[x].endsWith($);y=!M||O}if(!y){let x="";(L[0].endsWith(":")||b!=="")&&(N===1&&(N=0,A++,W=L[0]+i+W),N>0&&(x=L[0]+i),x=b+x),N>0&&(x=x+m+i),x=x+W,N+A<L.length&&(x=x+i+m),h[g]=x}}y&&(h[g]=E)}return h}e.shorten=d;var s;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function a(l,i=Object.create(null)){const h=[];let y=!1,g="";for(const E of l)if(E==="$"||y&&E==="{")g&&h.push({value:g,type:s.TEXT}),g="",y=!0;else if(E==="}"&&y){const b=i[g];if(typeof b=="string")b.length&&h.push({value:b,type:s.VARIABLE});else if(b){const L=h[h.length-1];(!L||L.type!==s.SEPARATOR)&&h.push({value:b.label,type:s.SEPARATOR})}g="",y=!1}else g+=E;return g&&!y&&h.push({value:g,type:s.TEXT}),h.filter((E,b)=>{if(E.type===s.SEPARATOR){const L=h[b-1],A=h[b+1];return[L,A].every(N=>N&&(N.type===s.VARIABLE||N.type===s.TEXT)&&N.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=a;function c(l,i){return P.isMacintosh||i?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):l.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function t(l,i){return P.isMacintosh||i?l.replace(/\(&&\w\)|&&/g,""):P.isWindows?l.replace(/&&|&/g,h=>h==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(l){return l.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(l){const i=l.indexOf("/")!==-1?k.posix:k.win32,h=i.basename(l),y=i.dirname(l);return h.length?{name:h,parentPath:y}:{name:y,parentPath:""}}e.splitName=o}),define(ge[99],pe([0,1,2,11]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(S){return S.toJSON()}class T{constructor(v){this.remoteAuthority=v}transformIncoming(v){return v.scheme===k.Schemas.vscodeRemote?R(_.URI.file(v.path)):v}transformOutgoing(v){return v.scheme===k.Schemas.file?R(_.URI.from({authority:this.remoteAuthority,scheme:k.Schemas.vscodeRemote,path:v.path})):v}transformOutgoingURI(v){return v.scheme===k.Schemas.file?_.URI.from({authority:this.remoteAuthority,scheme:k.Schemas.vscodeRemote,path:v.path}):v}transformOutgoingScheme(v){return v===k.Schemas.file?k.Schemas.vscodeRemote:v}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function P(S,v,f){if(!S||f>200)return null;if(typeof S=="object"){if(S instanceof _.URI)return v.transformOutgoing(S);for(let u in S)if(Object.hasOwnProperty.call(S,u)){const m=P(S[u],v,f+1);m!==null&&(S[u]=m)}}return null}function D(S,v){const f=P(S,v,0);return f===null?S:f}e.transformOutgoingURIs=D;function I(S,v,f,u){if(!S||u>200)return null;if(typeof S=="object"){if(S.$mid===1)return f?_.URI.revive(v.transformIncoming(S)):v.transformIncoming(S);for(let m in S)if(Object.hasOwnProperty.call(S,m)){const w=I(S[m],v,f,u+1);w!==null&&(S[m]=w)}}return null}function n(S,v){const f=I(S,v,!1,0);return f===null?S:f}e.transformIncomingURIs=n;function C(S,v){const f=I(S,v,!0,0);return f===null?S:f}e.transformAndReviveIncomingURIs=C}),define(ge[26],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(I){return _.test(I)}e.isUUID=k;const R=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));const P=function(I){for(let n=0;n<I.length;n++)I[n]=Math.floor(Math.random()*256);return I};function D(){P(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let I=0,n="";return n+=T[R[I++]],n+=T[R[I++]],n+=T[R[I++]],n+=T[R[I++]],n+="-",n+=T[R[I++]],n+=T[R[I++]],n+="-",n+=T[R[I++]],n+=T[R[I++]],n+="-",n+=T[R[I++]],n+=T[R[I++]],n+="-",n+=T[R[I++]],n+=T[R[I++]],n+=T[R[I++]],n+=T[R[I++]],n+=T[R[I++]],n+=T[R[I++]],n}e.generateUuid=D}),define(ge[134],pe([0,1,100]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(T="utf8"){this.stringDecoder=new _.StringDecoder(T),this.remaining=null}write(T){const P=[],D=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(D.length<1)return P;let I=0,n,C=I;for(;C<D.length;)if(n=D.charCodeAt(C),n===13||n===10){if(P.push(D.substring(I,C)),C++,C<D.length){const S=n;n=D.charCodeAt(C),(S===13&&n===10||S===10&&n===13)&&C++}I=C}else C++;return this.remaining=I<D.length?D.substr(I):null,P}end(){return this.remaining}}e.LineDecoder=k}),define(ge[24],pe([0,1,39,34,7,19,9,3,59,30,26,77]),function(Z,e,_,k,R,T,P,D,I,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.copy=e.move=e.whenDeleted=e.fileExists=e.dirExists=e.readDirsInDir=e.writeFileSync=e.writeFile=e.mkdirp=e.readFile=e.truncate=e.symlink=e.unlink=e.readlink=e.renameIgnoreError=e.rename=e.lstat=e.statLink=e.stat=e.chmod=e.exists=e.readdirSync=e.readdirWithFileTypes=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=e.MAX_HEAP_SIZE=e.MAX_FILE_SIZE=void 0;const v=300*1024*1024,f=16*1024*1024*1024,u=700*1024*1024,m=700*2*1024*1024;e.MAX_FILE_SIZE=process.arch==="ia32"?v:f,e.MAX_HEAP_SIZE=process.arch==="ia32"?u:m;var w;(function(Y){Y[Y.UNLINK=0]="UNLINK",Y[Y.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function p(Y,le=w.UNLINK){if(n.isRootOrDriveLetter(Y))throw new Error("rimraf - will refuse to recursively delete root");return le===w.UNLINK?d(Y):s(Y)}e.rimraf=p;async function d(Y){try{const le=await g(Y);if(le.isDirectory()&&!le.isSymbolicLink()){const ve=await c(Y);await Promise.all(ve.map(De=>d(R.join(Y,De)))),await I.promisify(_.rmdir)(Y)}else{const ve=le.mode;return ve&_.constants.S_IWUSR||await i(Y,ve|_.constants.S_IWUSR),A(Y)}}catch(le){if(le.code!=="ENOENT")throw le}}async function s(Y){try{const le=R.join(k.tmpdir(),C.generateUuid());try{await E(Y,le)}catch(ve){return d(Y)}d(le)}catch(le){if(le.code!=="ENOENT")throw le}}function a(Y){if(n.isRootOrDriveLetter(Y))throw new Error("rimraf - will refuse to recursively delete root");try{const le=_.lstatSync(Y);if(le.isDirectory()&&!le.isSymbolicLink())r(Y).map(De=>a(R.join(Y,De))),_.rmdirSync(Y);else{const ve=le.mode;return ve&_.constants.S_IWUSR||_.chmodSync(Y,ve|_.constants.S_IWUSR),_.unlinkSync(Y)}}catch(le){if(le.code!=="ENOENT")throw le}}e.rimrafSync=a;async function c(Y){return o(await I.promisify(_.readdir)(Y))}e.readdir=c;async function t(Y){const le=await I.promisify(_.readdir)(Y,{withFileTypes:!0});if(P.isMacintosh)for(const ve of le)ve.name=S.normalizeNFC(ve.name);return le}e.readdirWithFileTypes=t;function r(Y){return o(_.readdirSync(Y))}e.readdirSync=r;function o(Y){return P.isMacintosh?Y.map(le=>S.normalizeNFC(le)):Y}function l(Y){return I.promisify(_.exists)(Y)}e.exists=l;function i(Y,le){return I.promisify(_.chmod)(Y,le)}e.chmod=i;function h(Y){return I.promisify(_.stat)(Y)}e.stat=h;async function y(Y){let le;try{if(le=await g(Y),!le.isSymbolicLink())return{stat:le}}catch(ve){}try{return{stat:await h(Y),symbolicLink:(le==null?void 0:le.isSymbolicLink())?{dangling:!1}:void 0}}catch(ve){if(ve.code==="ENOENT"&&le)return{stat:le,symbolicLink:{dangling:!0}};if(P.isWindows&&ve.code==="EACCES"&&le)try{return{stat:await h(await L(Y)),symbolicLink:le.isSymbolicLink()?{dangling:!1}:void 0}}catch(De){if(De.code==="ENOENT")return{stat:le,symbolicLink:{dangling:!0}};throw De}throw ve}}e.statLink=y;function g(Y){return I.promisify(_.lstat)(Y)}e.lstat=g;function E(Y,le){return I.promisify(_.rename)(Y,le)}e.rename=E;function b(Y,le){return new Promise(ve=>_.rename(Y,le,()=>ve()))}e.renameIgnoreError=b;function L(Y){return I.promisify(_.readlink)(Y)}e.readlink=L;function A(Y){return I.promisify(_.unlink)(Y)}e.unlink=A;function N(Y,le,ve){return I.promisify(_.symlink)(Y,le,ve)}e.symlink=N;function W(Y,le){return I.promisify(_.truncate)(Y,le)}e.truncate=W;function x(Y,le){return I.promisify(_.readFile)(Y,le)}e.readFile=x;async function M(Y,le){return I.promisify(_.mkdir)(Y,{mode:le,recursive:!0})}e.mkdirp=M;const $=new Map;function O(Y,le,ve){const De=B(Y);return J(De).queue(()=>{const Me=Q(ve);return new Promise((Ee,Pe)=>V(Y,le,Me,Ce=>Ce?Pe(Ce):Ee()))})}e.writeFile=O;function B(Y){let le=Y;return(P.isWindows||P.isMacintosh)&&(le=le.toLowerCase()),le}function J(Y){const le=$.get(Y);if(le)return le;const ve=new T.Queue;return $.set(Y,ve),D.Event.once(ve.onFinished)(()=>{$.delete(Y),ve.dispose()}),ve}let U=!0;function V(Y,le,ve,De){if(!U)return _.writeFile(Y,le,{mode:ve.mode,flag:ve.flag},De);_.open(Y,ve.flag,ve.mode,(Me,Ee)=>{if(Me)return De(Me);_.writeFile(Ee,le,Pe=>{if(Pe)return _.close(Ee,()=>De(Pe));_.fdatasync(Ee,Ce=>(Ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Ce),U=!1),_.close(Ee,Oe=>De(Oe))))})})}function z(Y,le,ve){const De=Q(ve);if(!U)return _.writeFileSync(Y,le,{mode:De.mode,flag:De.flag});const Me=_.openSync(Y,De.flag,De.mode);try{_.writeFileSync(Me,le);try{_.fdatasyncSync(Me)}catch(Ee){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Ee),U=!1}}finally{_.closeSync(Me)}}e.writeFileSync=z;function Q(Y){return Y?{mode:typeof Y.mode=="number"?Y.mode:438,flag:typeof Y.flag=="string"?Y.flag:"w"}:{mode:438,flag:"w"}}async function ae(Y){const le=await c(Y),ve=[];for(const De of le)await ce(R.join(Y,De))&&ve.push(De);return ve}e.readDirsInDir=ae;async function ce(Y){try{const{stat:le,symbolicLink:ve}=await y(Y);return le.isDirectory()&&(ve==null?void 0:ve.dangling)!==!0}catch(le){}return!1}e.dirExists=ce;async function fe(Y){try{const{stat:le,symbolicLink:ve}=await y(Y);return le.isFile()&&(ve==null?void 0:ve.dangling)!==!0}catch(le){}return!1}e.fileExists=fe;function we(Y){return new Promise(le=>{let ve=!1;const De=setInterval(()=>{ve||(ve=!0,_.exists(Y,Me=>{ve=!1,Me||(clearInterval(De),le(void 0))}))},1e3)})}e.whenDeleted=we;async function be(Y,le){if(Y!==le){async function ve(De){const Me=await g(De);if(!(Me.isDirectory()||Me.isSymbolicLink())){const Ee=await I.promisify(_.open)(De,"a");try{await I.promisify(_.futimes)(Ee,Me.atime,new Date)}catch(Pe){}return I.promisify(_.close)(Ee)}}try{await E(Y,le),await ve(le)}catch(De){if(Y.toLowerCase()!==le.toLowerCase()&&De.code==="EXDEV"||Y.endsWith("."))await X(Y,le),await p(Y,w.MOVE),await ve(le);else throw De}}}e.move=be;const H=511;async function X(Y,le,ve){const De=ve!=null?ve:Object.create(null);if(!De[Y]){De[Y]=!0;const{stat:Me,symbolicLink:Ee}=await y(Y);if(!(Ee==null?void 0:Ee.dangling)){if(!Me.isDirectory())return re(Y,le,Me.mode&H);await M(le,Me.mode&H);const Pe=await c(Y);for(let Ce=0;Ce<Pe.length;Ce++){const Oe=Pe[Ce];await X(R.join(Y,Oe),R.join(le,Oe),De)}}}}e.copy=X;async function re(Y,le,ve){return new Promise((De,Me)=>{const Ee=_.createReadStream(Y),Pe=_.createWriteStream(le,{mode:ve});let Ce=!1;const Oe=Se=>{if(!Ce){if(Ce=!0,Se)return Me(Se);_.chmod(le,ve,Be=>Be?Me(Be):De())}};Ee.once("error",Se=>Oe(Se)),Pe.once("error",Se=>Oe(Se)),Pe.once("close",()=>Oe()),Ee.pipe(Pe)})}}),define(ge[135],pe([0,1,39,10,7,24,59]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function D(S){const v=R.dirname(S);if(S===v)return S;const f=(R.basename(S)||S).toLowerCase();try{const m=T.readdirSync(v).filter(w=>w.toLowerCase()===f);if(m.length===1){const w=D(v);if(w)return R.join(w,m[0])}else if(m.length>1){const w=m.indexOf(f);if(w>=0){const p=D(v);if(p)return R.join(p,m[w])}}}catch(u){}return null}e.realcaseSync=D;async function I(S){try{return await P.promisify(_.realpath)(S)}catch(v){const f=C(S);return await P.promisify(_.access)(f,_.constants.R_OK),f}}e.realpath=I;function n(S){try{return _.realpathSync(S)}catch(v){const f=C(S);return _.accessSync(f,_.constants.R_OK),f}}e.realpathSync=n;function C(S){return k.rtrim(R.normalize(S),R.sep)}});var ht=this&&this.__await||function(Z){return this instanceof ht?(this.v=Z,this):new ht(Z)},bi=this&&this.__asyncGenerator||function(Z,e,_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var k=_.apply(Z,e||[]),R,T=[];return R={},P("next"),P("throw"),P("return"),R[Symbol.asyncIterator]=function(){return this},R;function P(v){k[v]&&(R[v]=function(f){return new Promise(function(u,m){T.push([v,f,u,m])>1||D(v,f)})})}function D(v,f){try{I(k[v](f))}catch(u){S(T[0][3],u)}}function I(v){v.value instanceof ht?Promise.resolve(v.value.v).then(n,C):S(T[0][2],v)}function n(v){D("next",v)}function C(v){D("throw",v)}function S(v,f){v(f),T.shift(),T.length&&D(T[0][0],T[0][1])}},ii=this&&this.__asyncValues||function(Z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Z[Symbol.asyncIterator],_;return e?e.call(Z):(Z=typeof __values=="function"?__values(Z):Z[Symbol.iterator](),_={},k("next"),k("throw"),k("return"),_[Symbol.asyncIterator]=function(){return this},_);function k(T){_[T]=Z[T]&&function(P){return new Promise(function(D,I){P=Z[T](P),R(D,I,P.done,P.value)})}}function R(T,P,D,I){Promise.resolve(I).then(function(n){T({value:n,done:D})},P)}};define(ge[101],pe([0,1,24,34,7,38]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const P="Windows PowerShell",D="Windows PowerShell (x86)",I=/^\d+$/,n=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/,S=process.arch==="x64",v=S||k.arch()==="x64";class f{constructor(o,l,i){this.exePath=o,this.displayName=l,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await _.fileExists(this.exePath)),this.knownToExist}}function u({useAlternateBitness:r=!1}={}){return r?S?T.env["ProgramFiles(x86)"]||null:v&&T.env.ProgramW6432||null:T.env.ProgramFiles||null}function m({useAlternateBitness:r=!1}={}){const o=T.env.windir;return r?S?R.join(o,"SysWOW64"):v?R.join(o,"Sysnative"):R.join(o,"System32"):R.join(o,"System32")}async function w({useAlternateBitness:r=!1,findPreview:o=!1}={}){const l=u({useAlternateBitness:r});if(!l)return null;const i=R.join(l,"PowerShell");if(!await _.dirExists(i))return null;let h=-1,y=null;for(const b of await _.readdir(i)){let L=-1;if(o){const N=b.indexOf("-");if(N<0)continue;const W=b.substring(0,N);if(!I.test(W)||b.substring(N+1)!=="preview")continue;L=parseInt(W,10)}else{if(!I.test(b))continue;L=parseInt(b,10)}if(!(L<=h)){const A=R.join(i,b,"pwsh.exe");!await _.fileExists(A)||(y=A,h=L)}}if(!y)return null;const g=l.includes("x86")?" (x86)":"",E=o?" Preview":"";return new f(y,`PowerShell${E}${g}`,!0)}async function p({findPreview:r}={}){if(!T.env.LOCALAPPDATA)return null;const o=R.join(T.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await _.dirExists(o))return null;const{pwshMsixDirRegex:l,pwshMsixName:i}=r?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:n,pwshMsixName:"PowerShell (Store)"};for(const h of await _.readdir(o))if(l.test(h)){const y=R.join(o,h,"pwsh.exe");return new f(y,i)}return null}function d(){const r=R.join(k.homedir(),".dotnet","tools","pwsh.exe");return new f(r,".NET Core PowerShell Global Tool")}function s({useAlternateBitness:r=!1}={}){if(!v&&r)return null;const o=m({useAlternateBitness:r}),l=R.join(o,"WindowsPowerShell","v1.0","powershell.exe");let i;return S?i=r?D:P:v?i=r?P:D:i=D,new f(l,i,!0)}function a(){return bi(this,arguments,function*(){let o=yield ht(w());o&&(yield yield ht(o)),o=yield ht(w({useAlternateBitness:!0})),o&&(yield yield ht(o)),o=yield ht(p()),o&&(yield yield ht(o)),o=d(),o&&(yield yield ht(o)),o=yield ht(w({findPreview:!0})),o&&(yield yield ht(o)),o=yield ht(p({findPreview:!0})),o&&(yield yield ht(o)),o=yield ht(w({useAlternateBitness:!0,findPreview:!0})),o&&(yield yield ht(o)),o=s(),o&&(yield yield ht(o)),o=s({useAlternateBitness:!0}),o&&(yield yield ht(o))})}function c(){return bi(this,arguments,function*(){var o,l;try{for(var i=ii(a()),h;h=yield ht(i.next()),!h.done;){const y=h.value;(yield ht(y.exists()))&&(yield yield ht(y))}}catch(y){o={error:y}}finally{try{h&&!h.done&&(l=i.return)&&(yield ht(l.call(i)))}finally{if(o)throw o.error}}})}e.enumeratePowerShellInstallations=c;async function t(){var r,o;try{for(var l=ii(c()),i;i=await l.next(),!i.done;)return i.value}catch(h){r={error:h}}finally{try{i&&!i.done&&(o=l.return)&&await o.call(l)}finally{if(r)throw r.error}}return null}e.getFirstAvailablePowerShellInstallation=t}),define(ge[136],pe([0,1,285,286,287]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.monkeyPatch=void 0;function T(I){if(D()){const n=Z("http"),C=Z("https"),S=P(I);n.globalAgent=S,C.globalAgent=S}}e.monkeyPatch=T;function P(I){return I?new k:new k.default}function D(){let I=!1;const n=R.getProxyForUrl("http://example.com");n&&(I=!0,_.logger.debug(`using $HTTP_PROXY ${n}`));const C=R.getProxyForUrl("https://example.com");return C&&(I=!0,_.logger.debug(`using $HTTPS_PROXY ${C}`)),I}}),define(ge[102],pe([0,1,3,5,19,21,15,27,13,16,58,10]),function(Z,e,_,k,R,T,P,D,I,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.createChannelSender=e.createChannelReceiver=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function f(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(u=e.ResponseType||(e.ResponseType={}));function m(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(w||(w={}));class p{constructor(z){this.buffer=z,this.pos=0}read(z){const Q=this.buffer.slice(this.pos,this.pos+z);return this.pos+=Q.byteLength,Q}}class d{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var s;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(s||(s={}));function a(V){const z=D.VSBuffer.alloc(4);return z.writeUInt32BE(V,0),z}function c(V){return V.read(4).readUInt32BE(0)}function t(V){const z=D.VSBuffer.alloc(1);return z.writeUInt8(V,0),z}const r={Undefined:t(s.Undefined),String:t(s.String),Buffer:t(s.Buffer),VSBuffer:t(s.VSBuffer),Array:t(s.Array),Object:t(s.Object)},o=typeof Buffer!="undefined";function l(V,z){if(typeof z=="undefined")V.write(r.Undefined);else if(typeof z=="string"){const Q=D.VSBuffer.fromString(z);V.write(r.String),V.write(a(Q.byteLength)),V.write(Q)}else if(o&&Buffer.isBuffer(z)){const Q=D.VSBuffer.wrap(z);V.write(r.Buffer),V.write(a(Q.byteLength)),V.write(Q)}else if(z instanceof D.VSBuffer)V.write(r.VSBuffer),V.write(a(z.byteLength)),V.write(z);else if(Array.isArray(z)){V.write(r.Array),V.write(a(z.length));for(const Q of z)l(V,Q)}else{const Q=D.VSBuffer.fromString(JSON.stringify(z));V.write(r.Object),V.write(a(Q.byteLength)),V.write(Q)}}function i(V){switch(V.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return V.read(c(V)).toString();case s.Buffer:return V.read(c(V)).buffer;case s.VSBuffer:return V.read(c(V));case s.Array:{const Q=c(V),ae=[];for(let ce=0;ce<Q;ce++)ae.push(i(V));return ae}case s.Object:return JSON.parse(V.read(c(V)).toString())}}class h{constructor(z,Q,ae=null,ce=1e3){this.protocol=z,this.ctx=Q,this.logger=ae,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(fe=>this.onRawMessage(fe)),this.sendResponse({type:200})}registerChannel(z,Q){this.channels.set(z,Q),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const Q=this.send([z.type]);this.logger&&this.logger.logOutgoing(Q,0,1,m(z.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([z.type,z.id],z.data);this.logger&&this.logger.logOutgoing(Q,z.id,1,m(z.type),z.data);return}}}send(z,Q=void 0){const ae=new d;return l(ae,z),l(ae,Q),this.sendBuffer(ae.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(Q){return 0}}onRawMessage(z){const Q=new p(z),ae=i(Q),ce=i(Q),fe=ae[0];switch(fe){case 100:return this.logger&&this.logger.logIncoming(z.byteLength,ae[1],1,`${f(fe)}: ${ae[2]}.${ae[3]}`,ce),this.onPromise({type:fe,id:ae[1],channelName:ae[2],name:ae[3],arg:ce});case 102:return this.logger&&this.logger.logIncoming(z.byteLength,ae[1],1,`${f(fe)}: ${ae[2]}.${ae[3]}`,ce),this.onEventListen({type:fe,id:ae[1],channelName:ae[2],name:ae[3],arg:ce});case 101:return this.logger&&this.logger.logIncoming(z.byteLength,ae[1],1,`${f(fe)}`),this.disposeActiveRequest({type:fe,id:ae[1]});case 103:return this.logger&&this.logger.logIncoming(z.byteLength,ae[1],1,`${f(fe)}`),this.disposeActiveRequest({type:fe,id:ae[1]})}}onPromise(z){const Q=this.channels.get(z.channelName);if(!Q){this.collectPendingRequest(z);return}const ae=new T.CancellationTokenSource;let ce;try{ce=Q.call(this.ctx,z.name,z.arg,ae.token)}catch(be){ce=Promise.reject(be)}const fe=z.id;ce.then(be=>{this.sendResponse({id:fe,data:be,type:201}),this.activeRequests.delete(z.id)},be=>{be instanceof Error?this.sendResponse({id:fe,data:{message:be.message,name:be.name,stack:be.stack?be.stack.split?be.stack.split(`
`):be.stack:void 0},type:202}):this.sendResponse({id:fe,data:be,type:203}),this.activeRequests.delete(z.id)});const we=k.toDisposable(()=>ae.cancel());this.activeRequests.set(z.id,we)}onEventListen(z){const Q=this.channels.get(z.channelName);if(!Q){this.collectPendingRequest(z);return}const ae=z.id,fe=Q.listen(this.ctx,z.name,z.arg)(we=>this.sendResponse({id:ae,data:we,type:204}));this.activeRequests.set(z.id,fe)}disposeActiveRequest(z){const Q=this.activeRequests.get(z.id);Q&&(Q.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let Q=this.pendingRequests.get(z.channelName);Q||(Q=[],this.pendingRequests.set(z.channelName,Q));const ae=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:z,timeoutTimer:ae})}flushPendingRequests(z){const Q=this.pendingRequests.get(z);if(Q){for(const ae of Q)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.onPromise(ae.request);break;case 102:this.onEventListen(ae.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var y;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class g{constructor(z,Q=null){this.protocol=z,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ae=>this.onBuffer(ae)),this.logger=Q}getChannel(z){const Q=this;return{call(ae,ce,fe){return Q.isDisposed?Promise.reject(P.canceled()):Q.requestPromise(z,ae,ce,fe)},listen(ae,ce){return Q.isDisposed?Promise.reject(P.canceled()):Q.requestEvent(z,ae,ce)}}}requestPromise(z,Q,ae,ce=T.CancellationToken.None){const fe=this.lastRequestId++,be={id:fe,type:100,channelName:z,name:Q,arg:ae};if(ce.isCancellationRequested)return Promise.reject(P.canceled());let H;return new Promise((re,Y)=>{if(ce.isCancellationRequested)return Y(P.canceled());const le=()=>{const Ee=Pe=>{switch(Pe.type){case 201:this.handlers.delete(fe),re(Pe.data);break;case 202:this.handlers.delete(fe);const Ce=new Error(Pe.data.message);Ce.stack=Pe.data.stack,Ce.name=Pe.data.name,Y(Ce);break;case 203:this.handlers.delete(fe),Y(Pe.data);break}};this.handlers.set(fe,Ee),this.sendRequest(be)};let ve=null;this.state===w.Idle?le():(ve=R.createCancelablePromise(Ee=>this.whenInitialized()),ve.then(()=>{ve=null,le()}));const De=()=>{ve?(ve.cancel(),ve=null):this.sendRequest({id:fe,type:101}),Y(P.canceled())},Me=ce.onCancellationRequested(De);H=k.combinedDisposable(k.toDisposable(De),Me),this.activeRequests.add(H)}).finally(()=>{this.activeRequests.delete(H)})}requestEvent(z,Q,ae){const ce=this.lastRequestId++,we={id:ce,type:102,channelName:z,name:Q,arg:ae};let be=null;const H=new _.Emitter({onFirstListenerAdd:()=>{be=R.createCancelablePromise(re=>this.whenInitialized()),be.then(()=>{be=null,this.activeRequests.add(H),this.sendRequest(we)})},onLastListenerRemove:()=>{be?(be.cancel(),be=null):(this.activeRequests.delete(H),this.sendRequest({id:ce,type:103}))}}),X=re=>H.fire(re.data);return this.handlers.set(ce,X),H.event}sendRequest(z){switch(z.type){case 100:case 102:{const Q=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(Q,z.id,0,`${f(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const Q=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(Q,z.id,0,f(z.type));return}}}send(z,Q=void 0){const ae=new d;return l(ae,z),l(ae,Q),this.sendBuffer(ae.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(Q){return 0}}onBuffer(z){const Q=new p(z),ae=i(Q),ce=i(Q),fe=ae[0];switch(fe){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,m(fe)),this.onResponse({type:ae[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,ae[1],0,m(fe),ce),this.onResponse({type:ae[0],id:ae[1],data:ce})}}onResponse(z){if(z.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const Q=this.handlers.get(z.id);Q&&Q(z)}whenInitialized(){return this.state===w.Idle?Promise.resolve():_.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelClient=g;class E{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:Q,onDidClientDisconnect:ae})=>{_.Event.once(Q.onMessage)(fe=>{const we=new p(fe),be=i(we),H=new h(Q,be),X=new g(Q);this.channels.forEach((Y,le)=>H.registerChannel(le,Y));const re={channelServer:H,channelClient:X,ctx:be};this._connections.add(re),this._onDidAddConnection.fire(re),ae(()=>{H.dispose(),X.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const z=[];return this._connections.forEach(Q=>z.push(Q)),z}getChannel(z,Q){const ae=this;return{call(ce,fe,we){let be;if(n.isFunction(Q)){let X=I.getRandomElement(ae.connections.filter(Q));be=X?Promise.resolve(X):_.Event.toPromise(_.Event.filter(ae.onDidAddConnection,Q))}else be=Q.routeCall(ae,ce,fe);const H=be.then(X=>X.channelClient.getChannel(z));return L(H).call(ce,fe,we)},listen(ce,fe){if(n.isFunction(Q))return ae.getMulticastEvent(z,Q,ce,fe);const we=Q.routeEvent(ae,ce,fe).then(be=>be.channelClient.getChannel(z));return L(we).listen(ce,fe)}}}getMulticastEvent(z,Q,ae,ce){const fe=this;let we=new k.DisposableStore;const be=new _.Emitter({onFirstListenerAdd:()=>{we=new k.DisposableStore;const H=new _.EventMultiplexer,X=new Map,re=le=>{const De=le.channelClient.getChannel(z).listen(ae,ce),Me=H.add(De);X.set(le,Me)},Y=le=>{const ve=X.get(le);!ve||(ve.dispose(),X.delete(le))};fe.connections.filter(Q).forEach(re),_.Event.filter(fe.onDidAddConnection,Q)(re,void 0,we),fe.onDidRemoveConnection(Y,void 0,we),H.event(be.fire,be,we),we.add(H)},onLastListenerRemove:()=>{we.dispose()}});return be.event}registerChannel(z,Q){this.channels.set(z,Q),this._connections.forEach(ae=>{ae.channelServer.registerChannel(z,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class b{constructor(z,Q,ae=null){const ce=new d;l(ce,Q),z.send(ce.buffer),this.channelClient=new g(z,ae),this.channelServer=new h(z,Q,ae)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,Q){this.channelServer.registerChannel(z,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=b;function L(V){return{call(z,Q,ae){return V.then(ce=>ce.call(z,Q,ae))},listen(z,Q){const ae=new _.Relay;return V.then(ce=>ae.input=ce.listen(z,Q)),ae.event}}}e.getDelayedChannel=L;function A(V){let z=!1;return{call(Q,ae,ce){return z?V.call(Q,ae,ce):R.timeout(0).then(()=>z=!0).then(()=>V.call(Q,ae,ce))},listen(Q,ae){if(z)return V.listen(Q,ae);const ce=new _.Relay;return R.timeout(0).then(()=>z=!0).then(()=>ce.input=V.listen(Q,ae)),ce.event}}}e.getNextTickChannel=A;class N{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const Q of z.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await _.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=N;function W(V,z){const Q=V,ae=z&&z.disableMarshalling,ce=new Map;for(const fe in Q)M(fe)&&ce.set(fe,_.Event.buffer(Q[fe],!0));return new class{listen(fe,we){const be=ce.get(we);if(be)return be;throw new Error(`Event not found: ${we}`)}call(fe,we,be){const H=Q[we];if(typeof H=="function"){if(!ae&&Array.isArray(be))for(let X=0;X<be.length;X++)be[X]=C.revive(be[X]);return H.apply(Q,be)}throw new Error(`Method not found: ${we}`)}}}e.createChannelReceiver=W;function x(V,z){const Q=z&&z.disableMarshalling;return new Proxy({},{get(ae,ce){var fe;if(typeof ce=="string")return((fe=z==null?void 0:z.properties)===null||fe===void 0?void 0:fe.has(ce))?z.properties.get(ce):M(ce)?V.listen(ce):async function(...we){let be;z&&!n.isUndefinedOrNull(z.context)?be=[z.context,...we]:be=we;const H=await V.call(ce,be);return Q?H:C.revive(H)};throw new Error(`Property not found: ${String(ce)}`)}})}e.createChannelSender=x;function M(V){return V[0]==="o"&&V[1]==="n"&&S.isUpperAsciiLetter(V.charCodeAt(2))}const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let z=V.toString();if(z!=="[object Object]")return z}return V}function B(V){return Array.isArray(V)?V.map(O):O(V)}function J(V,z,Q,ae,ce,fe,we){we=B(we);const be=$[ce],H=be[ae%be.length];let X=[`%c[${V}]%c[${String(z).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${fe}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(fe)?(X=X.concat(we),X.push(")")):X.push(we),console.log.apply(console,X)}e.logWithColors=J;class U{constructor(z,Q){this._outgoingPrefix=z,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,Q,ae,ce,fe){this._totalOutgoing+=z,J(this._outgoingPrefix,this._totalOutgoing,z,Q,ae,ce,fe)}logIncoming(z,Q,ae,ce,fe){this._totalIncoming+=z,J(this._incomingPrefix,this._totalIncoming,z,Q,ae,ce,fe)}}e.IPCLogger=U}),define(ge[103],pe([0,1,3,102,5,27,9,38]),function(Z,e,_,k,R,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let I=null;function n(){return I||(I=T.VSBuffer.alloc(0)),I}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,l){if(o===0)return n();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const g=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=o),g}if(this._chunks[0].byteLength>o){const g=this._chunks[0].slice(0,o);return l&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),g}let i=T.VSBuffer.alloc(o),h=0,y=0;for(;o>0;){const g=this._chunks[y];if(g.byteLength>o){const E=g.slice(0,o);i.set(E,h),h+=o,l&&(this._chunks[y]=g.slice(o),this._totalLength-=o),o-=o}else i.set(g,h),h+=g.byteLength,l?(this._chunks.shift(),this._totalLength-=g.byteLength):y++,o-=g.byteLength}return i}}e.ChunkStream=C;var S;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(S||(S={}));var v;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(o,l,i,h){this.type=o,this.id=l,this.ack=i,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends R.Disposable{constructor(o){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const i=this._state.messageType,h=this._state.id,y=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new f(i,h,y,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=T.VSBuffer.alloc(13);l.writeUInt8(o.type,0),l.writeUInt32BE(o.id,1),l.writeUInt32BE(o.ack,5),l.writeUInt32BE(o.data.byteLength,9),this._writeSoon(l,o.data)}}_bufferAdd(o,l){const i=this._totalLength===0;return this._data.push(o,l),this._totalLength+=o.byteLength+l.byteLength,i}_bufferTake(){const o=T.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,l){this._bufferAdd(o,l)&&P.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class w extends R.Disposable{constructor(o){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new u(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new f(1,0,0,o))}}e.Protocol=w;class p extends k.IPCClient{constructor(o,l,i=null){super(o,l,i);this.protocol=o}static fromSocket(o,l){return new p(new w(o),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=p;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,D.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class s{constructor(o){this.data=o,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],l=0,i=this._first;for(;i;)o[l++]=i.data,i=i.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const l=new s(o);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class c{constructor(){this.lastRuns=[];const o=Date.now();for(let l=0;l<c._HISTORY_LENGTH;l++)this.lastRuns[l]=o-1e3*l;setInterval(()=>{for(let l=c._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const o=Date.now(),l=(1+c._HISTORY_LENGTH)*1e3;let i=0;for(let h=0;h<c._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=l&&i++;return 1-i/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class t{constructor(o,l=null){this._loadEstimator=c.getInstance(),this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new u(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(i=>this._receiveMessage(i))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=R.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new f(5,0,0,n());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const l=new f(4,0,0,n());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,l){this._isReconnecting=!0,this._socketDisposables=R.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new u(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(i=>this._receiveMessage(i))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let l=0,i=o.length;l<i;l++)this._socketWriter.write(o[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new f(6,0,0,n())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const l=this._outgoingUnackMsg.toArray();for(let i=0,h=l.length;i<h;i++)this._socketWriter.write(l[i]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const i=new f(1,l,this._incomingAckId,o);this._outgoingUnackMsg.push(i),this._isReconnecting||(this._socketWriter.write(i),this._recvAckCheck())}sendControl(o){const l=new f(2,0,0,o);this._socketWriter.write(l)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),l=Date.now()-o.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new f(3,0,this._incomingAckId,n());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(ge[104],pe([0,1,95]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class k{constructor(D){let I=_.toUint8(D);this._defaultValue=I,this._asciiMap=k._createAsciiMap(I),this._map=new Map}static _createAsciiMap(D){let I=new Uint8Array(256);for(let n=0;n<256;n++)I[n]=D;return I}set(D,I){let n=_.toUint8(I);D>=0&&D<256?this._asciiMap[D]=n:this._map.set(D,n)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=k;var R;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(R||(R={}));class T{constructor(){this._actual=new k(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=T}),define(ge[137],pe([0,1,104]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var k;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(k=e.WordCharacterClass||(e.WordCharacterClass={}));class R extends _.CharacterClassifier{constructor(D){super(0);for(let I=0,n=D.length;I<n;I++)this.set(D.charCodeAt(I),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=R;function T(P){let D={};return I=>(D.hasOwnProperty(I)||(D[I]=P(I)),D[I])}e.getMapForWordSeparators=T(P=>new R(P))}),define(ge[48],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(R,T){this.lineNumber=R,this.column=T}with(R=this.lineNumber,T=this.column){return R===this.lineNumber&&T===this.column?this:new _(R,T)}delta(R=0,T=0){return this.with(this.lineNumber+R,this.column+T)}equals(R){return _.equals(this,R)}static equals(R,T){return!R&&!T?!0:!!R&&!!T&&R.lineNumber===T.lineNumber&&R.column===T.column}isBefore(R){return _.isBefore(this,R)}static isBefore(R,T){return R.lineNumber<T.lineNumber?!0:T.lineNumber<R.lineNumber?!1:R.column<T.column}isBeforeOrEqual(R){return _.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,T){return R.lineNumber<T.lineNumber?!0:T.lineNumber<R.lineNumber?!1:R.column<=T.column}static compare(R,T){let P=R.lineNumber|0,D=T.lineNumber|0;if(P===D){let I=R.column|0,n=T.column|0;return I-n}return P-D}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new _(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}}e.Position=_}),define(ge[44],pe([0,1,48]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class k{constructor(T,P,D,I){T>D||T===D&&P>I?(this.startLineNumber=D,this.startColumn=I,this.endLineNumber=T,this.endColumn=P):(this.startLineNumber=T,this.startColumn=P,this.endLineNumber=D,this.endColumn=I)}isEmpty(){return k.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return k.containsPosition(this,T)}static containsPosition(T,P){return!(P.lineNumber<T.startLineNumber||P.lineNumber>T.endLineNumber||P.lineNumber===T.startLineNumber&&P.column<T.startColumn||P.lineNumber===T.endLineNumber&&P.column>T.endColumn)}containsRange(T){return k.containsRange(this,T)}static containsRange(T,P){return!(P.startLineNumber<T.startLineNumber||P.endLineNumber<T.startLineNumber||P.startLineNumber>T.endLineNumber||P.endLineNumber>T.endLineNumber||P.startLineNumber===T.startLineNumber&&P.startColumn<T.startColumn||P.endLineNumber===T.endLineNumber&&P.endColumn>T.endColumn)}strictContainsRange(T){return k.strictContainsRange(this,T)}static strictContainsRange(T,P){return!(P.startLineNumber<T.startLineNumber||P.endLineNumber<T.startLineNumber||P.startLineNumber>T.endLineNumber||P.endLineNumber>T.endLineNumber||P.startLineNumber===T.startLineNumber&&P.startColumn<=T.startColumn||P.endLineNumber===T.endLineNumber&&P.endColumn>=T.endColumn)}plusRange(T){return k.plusRange(this,T)}static plusRange(T,P){let D,I,n,C;return P.startLineNumber<T.startLineNumber?(D=P.startLineNumber,I=P.startColumn):P.startLineNumber===T.startLineNumber?(D=P.startLineNumber,I=Math.min(P.startColumn,T.startColumn)):(D=T.startLineNumber,I=T.startColumn),P.endLineNumber>T.endLineNumber?(n=P.endLineNumber,C=P.endColumn):P.endLineNumber===T.endLineNumber?(n=P.endLineNumber,C=Math.max(P.endColumn,T.endColumn)):(n=T.endLineNumber,C=T.endColumn),new k(D,I,n,C)}intersectRanges(T){return k.intersectRanges(this,T)}static intersectRanges(T,P){let D=T.startLineNumber,I=T.startColumn,n=T.endLineNumber,C=T.endColumn,S=P.startLineNumber,v=P.startColumn,f=P.endLineNumber,u=P.endColumn;return D<S?(D=S,I=v):D===S&&(I=Math.max(I,v)),n>f?(n=f,C=u):n===f&&(C=Math.min(C,u)),D>n||D===n&&I>C?null:new k(D,I,n,C)}equalsRange(T){return k.equalsRange(this,T)}static equalsRange(T,P){return!!T&&!!P&&T.startLineNumber===P.startLineNumber&&T.startColumn===P.startColumn&&T.endLineNumber===P.endLineNumber&&T.endColumn===P.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(T){return new _.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(T){return new _.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,P){return new k(this.startLineNumber,this.startColumn,T,P)}setStartPosition(T,P){return new k(T,P,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(T){return new k(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,P=T){return new k(T.lineNumber,T.column,P.lineNumber,P.column)}static lift(T){return T?new k(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,P){return!(T.endLineNumber<P.startLineNumber||T.endLineNumber===P.startLineNumber&&T.endColumn<P.startColumn||P.endLineNumber<T.startLineNumber||P.endLineNumber===T.startLineNumber&&P.endColumn<T.startColumn)}static areIntersecting(T,P){return!(T.endLineNumber<P.startLineNumber||T.endLineNumber===P.startLineNumber&&T.endColumn<=P.startColumn||P.endLineNumber<T.startLineNumber||P.endLineNumber===T.startLineNumber&&P.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,P){if(T&&P){const n=T.startLineNumber|0,C=P.startLineNumber|0;if(n===C){const S=T.startColumn|0,v=P.startColumn|0;if(S===v){const f=T.endLineNumber|0,u=P.endLineNumber|0;if(f===u){const m=T.endColumn|0,w=P.endColumn|0;return m-w}return f-u}return S-v}return n-C}return(T?1:0)-(P?1:0)}static compareRangesUsingEnds(T,P){return T.endLineNumber===P.endLineNumber?T.endColumn===P.endColumn?T.startLineNumber===P.startLineNumber?T.startColumn-P.startColumn:T.startLineNumber-P.startLineNumber:T.endColumn-P.endColumn:T.endLineNumber-P.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=k}),define(ge[138],pe([0,1,48,44]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var R;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(R=e.SelectionDirection||(e.SelectionDirection={}));class T extends k.Range{constructor(D,I,n,C){super(D,I,n,C);this.selectionStartLineNumber=D,this.selectionStartColumn=I,this.positionLineNumber=n,this.positionColumn=C}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return T.selectionsEqual(this,D)}static selectionsEqual(D,I){return D.selectionStartLineNumber===I.selectionStartLineNumber&&D.selectionStartColumn===I.selectionStartColumn&&D.positionLineNumber===I.positionLineNumber&&D.positionColumn===I.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,I){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,D,I):new T(D,I,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,I){return this.getDirection()===0?new T(D,I,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,D,I)}static fromPositions(D,I=D){return new T(D.lineNumber,D.column,I.lineNumber,I.column)}static liftSelection(D){return new T(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,I){if(D&&!I||!D&&I)return!1;if(!D&&!I)return!0;if(D.length!==I.length)return!1;for(let n=0,C=D.length;n<C;n++)if(!this.selectionsEqual(D[n],I[n]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,I,n,C,S){return S===0?new T(D,I,n,C):new T(n,C,D,I)}}e.Selection=T}),define(ge[105],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(R=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var P;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(P=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(u){this.tabSize=Math.max(1,u.tabSize|0),this.indentSize=u.tabSize|0,this.insertSpaces=Boolean(u.insertSpaces),this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=Boolean(u.trimAutoWhitespace)}equals(u){return this.tabSize===u.tabSize&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class I{constructor(u,m){this.range=u,this.matches=m}}e.FindMatch=I;var n;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var C;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(C=e.ModelConstants||(e.ModelConstants={}));class S{constructor(u,m,w,p,d,s){this.identifier=u,this.range=m,this.text=w,this.forceMoveMarkers=p,this.isAutoWhitespaceEdit=d,this._isTracked=s}}e.ValidAnnotatedEditOperation=S;class v{constructor(u,m,w){this.reverseEdits=u,this.changes=m,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=v}),define(ge[139],pe([0,1,10,137,48,44,105]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class I{constructor(s,a,c,t){this.searchString=s,this.isRegex=a,this.matchCase=c,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=n(this.searchString):s=this.searchString.indexOf(`
`)>=0;let a=null;try{a=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch(t){return null}if(!a)return null;let c=!this.isRegex&&!s;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new C(a,this.wordSeparators?k.getMapForWordSeparators(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=I;function n(d){if(!d||d.length===0)return!1;for(let s=0,a=d.length;s<a;s++)if(d.charCodeAt(s)===92){if(s++,s>=a)break;const t=d.charCodeAt(s);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class C{constructor(s,a,c){this.regex=s,this.wordSeparators=a,this.simpleSearch=c}}e.SearchData=C;function S(d,s,a){if(!a)return new P.FindMatch(d,null);let c=[];for(let t=0,r=s.length;t<r;t++)c[t]=s[t];return new P.FindMatch(d,c)}e.createFindMatch=S;class v{constructor(s){let a=[],c=0;for(let t=0,r=s.length;t<r;t++)s.charCodeAt(t)===10&&(a[c++]=t);this._lineFeedsOffsets=a}findLineFeedCountBeforeOffset(s){const a=this._lineFeedsOffsets;let c=0,t=a.length-1;if(t===-1||s<=a[0])return 0;for(;c<t;){const r=c+((t-c)/2>>0);a[r]>=s?t=r-1:a[r+1]>=s?(c=r,t=r):c=r+1}return c+1}}class f{static findMatches(s,a,c,t,r){const o=a.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(s,c,new p(o.wordSeparators,o.regex),t,r):this._doFindMatchesLineByLine(s,c,o,t,r):[]}static _getMultilineMatchRange(s,a,c,t,r,o){let l,i=0;t?(i=t.findLineFeedCountBeforeOffset(r),l=a+r+i):l=a+r;let h;if(t){let b=t.findLineFeedCountBeforeOffset(r+o.length)-i;h=l+o.length+b}else h=l+o.length;const y=s.getPositionAt(l),g=s.getPositionAt(h);return new T.Range(y.lineNumber,y.column,g.lineNumber,g.column)}static _doFindMatchesMultiline(s,a,c,t,r){const o=s.getOffsetAt(a.getStartPosition()),l=s.getValueInRange(a,1),i=s.getEOL()===`\r
`?new v(l):null,h=[];let y=0,g;for(c.reset(0);g=c.next(l);)if(h[y++]=S(this._getMultilineMatchRange(s,o,l,i,g.index,g[0]),g,t),y>=r)return h;return h}static _doFindMatchesLineByLine(s,a,c,t,r){const o=[];let l=0;if(a.startLineNumber===a.endLineNumber){const h=s.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return l=this._findMatchesInLine(c,h,a.startLineNumber,a.startColumn-1,l,o,t,r),o}const i=s.getLineContent(a.startLineNumber).substring(a.startColumn-1);l=this._findMatchesInLine(c,i,a.startLineNumber,a.startColumn-1,l,o,t,r);for(let h=a.startLineNumber+1;h<a.endLineNumber&&l<r;h++)l=this._findMatchesInLine(c,s.getLineContent(h),h,0,l,o,t,r);if(l<r){const h=s.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);l=this._findMatchesInLine(c,h,a.endLineNumber,0,l,o,t,r)}return o}static _findMatchesInLine(s,a,c,t,r,o,l,i){const h=s.wordSeparators;if(!l&&s.simpleSearch){const E=s.simpleSearch,b=E.length,L=a.length;let A=-b;for(;(A=a.indexOf(E,A+b))!==-1;)if((!h||w(h,a,L,A,b))&&(o[r++]=new P.FindMatch(new T.Range(c,A+1+t,c,A+1+b+t),null),r>=i))return r;return r}const y=new p(s.wordSeparators,s.regex);let g;y.reset(0);do if(g=y.next(a),g&&(o[r++]=S(new T.Range(c,g.index+1+t,c,g.index+1+g[0].length+t),g,l),r>=i))return r;while(g);return r}static findNextMatch(s,a,c,t){const r=a.parseSearchRequest();if(!r)return null;const o=new p(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(s,c,o,t):this._doFindNextMatchLineByLine(s,c,o,t)}static _doFindNextMatchMultiline(s,a,c,t){const r=new R.Position(a.lineNumber,1),o=s.getOffsetAt(r),l=s.getLineCount(),i=s.getValueInRange(new T.Range(r.lineNumber,r.column,l,s.getLineMaxColumn(l)),1),h=s.getEOL()===`\r
`?new v(i):null;c.reset(a.column-1);let y=c.next(i);return y?S(this._getMultilineMatchRange(s,o,i,h,y.index,y[0]),y,t):a.lineNumber!==1||a.column!==1?this._doFindNextMatchMultiline(s,new R.Position(1,1),c,t):null}static _doFindNextMatchLineByLine(s,a,c,t){const r=s.getLineCount(),o=a.lineNumber,l=s.getLineContent(o),i=this._findFirstMatchInLine(c,l,o,a.column,t);if(i)return i;for(let h=1;h<=r;h++){const y=(o+h-1)%r,g=s.getLineContent(y+1),E=this._findFirstMatchInLine(c,g,y+1,1,t);if(E)return E}return null}static _findFirstMatchInLine(s,a,c,t,r){s.reset(t-1);const o=s.next(a);return o?S(new T.Range(c,o.index+1,c,o.index+1+o[0].length),o,r):null}static findPreviousMatch(s,a,c,t){const r=a.parseSearchRequest();if(!r)return null;const o=new p(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(s,c,o,t):this._doFindPreviousMatchLineByLine(s,c,o,t)}static _doFindPreviousMatchMultiline(s,a,c,t){const r=this._doFindMatchesMultiline(s,new T.Range(1,1,a.lineNumber,a.column),c,t,10*D);if(r.length>0)return r[r.length-1];const o=s.getLineCount();return a.lineNumber!==o||a.column!==s.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(s,new R.Position(o,s.getLineMaxColumn(o)),c,t):null}static _doFindPreviousMatchLineByLine(s,a,c,t){const r=s.getLineCount(),o=a.lineNumber,l=s.getLineContent(o).substring(0,a.column-1),i=this._findLastMatchInLine(c,l,o,t);if(i)return i;for(let h=1;h<=r;h++){const y=(r+o-h-1)%r,g=s.getLineContent(y+1),E=this._findLastMatchInLine(c,g,y+1,t);if(E)return E}return null}static _findLastMatchInLine(s,a,c,t){let r=null,o;for(s.reset(0);o=s.next(a);)r=S(new T.Range(c,o.index+1,c,o.index+1+o[0].length),o,t);return r}}e.TextModelSearch=f;function u(d,s,a,c,t){if(c===0)return!0;const r=s.charCodeAt(c-1);if(d.get(r)!==0||r===13||r===10)return!0;if(t>0){const o=s.charCodeAt(c);if(d.get(o)!==0)return!0}return!1}function m(d,s,a,c,t){if(c+t===a)return!0;const r=s.charCodeAt(c+t);if(d.get(r)!==0||r===13||r===10)return!0;if(t>0){const o=s.charCodeAt(c+t-1);if(d.get(o)!==0)return!0}return!1}function w(d,s,a,c,t){return u(d,s,a,c,t)&&m(d,s,a,c,t)}e.isValidMatch=w;class p{constructor(s,a){this._wordSeparators=s,this._searchRegex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const a=s.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===a||(c=this._searchRegex.exec(s),!c))return null;const t=c.index,r=c[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){_.getNextCodePoint(s,a,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||w(this._wordSeparators,s,a,t,r))return c}while(c);return null}}e.Searcher=p}),define(ge[106],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(D=""){let I="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)D.indexOf(n)>=0||(I+="\\"+n);return I+="\\s]+)",new RegExp(I,"g")}e.DEFAULT_WORD_REGEXP=_();function k(D){let I=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)I=D;else{let n="g";D.ignoreCase&&(n+="i"),D.multiline&&(n+="m"),D.unicode&&(n+="u"),I=new RegExp(D.source,n)}return I.lastIndex=0,I}e.ensureValidWordDefinition=k;const R={maxLen:1e3,windowSize:15,timeBudget:150};function T(D,I,n,C,S=R){if(n.length>S.maxLen){let w=D-S.maxLen/2;return w<0?w=0:C+=w,n=n.substring(w,D+S.maxLen/2),T(D,I,n,C,S)}const v=Date.now(),f=D-1-C;let u=-1,m=null;for(let w=1;!(Date.now()-v>=S.timeBudget);w++){const p=f-S.windowSize*w;I.lastIndex=Math.max(0,p);const d=P(I,n,f,u);if(!d&&m||(m=d,p<=0))break;u=p}if(m){let w={word:m[0],startColumn:C+1+m.index,endColumn:C+1+m.index+m[0].length};return I.lastIndex=0,w}return null}e.getWordAtText=T;function P(D,I,n,C){let S;for(;S=D.exec(I);){const v=S.index||0;if(v<=n&&D.lastIndex>=n)return S;if(C>0&&v>C)return null}return null}}),define(ge[140],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class k{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let I=0,n=D.notIn.length;I<n;I++)switch(D.notIn[I]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=k;class R{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of D)T(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),T(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),T(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),T(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&T(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.AutoClosingPairs=R;function T(P,D,I){P.has(D)?P.get(D).push(I):P.set(D,[I])}}),define(ge[79],pe([0,1,33,7]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function R(T,P,D,I){if(Array.isArray(T)){let n=0;for(const C of T){const S=R(C,P,D,I);if(S===10)return S;S>n&&(n=S)}return n}else{if(typeof T=="string")return I?T==="*"?5:T===D?10:0:0;if(T){const{language:n,pattern:C,scheme:S,hasAccessToAllModels:v}=T;if(!I&&!v)return 0;let f=0;if(S)if(S===P.scheme)f=10;else if(S==="*")f=5;else return 0;if(n)if(n===D)f=10;else if(n==="*")f=Math.max(f,5);else return 0;if(C){let u;if(typeof C=="string"?u=C:u=Object.assign(Object.assign({},C),{base:k.normalize(C.base)}),u===P.fsPath||_.match(u,P.fsPath))f=10;else return 0}return f}else return 0}}e.score=R}),define(ge[141],pe([0,1,104]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var k;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(k=e.State||(e.State={}));class R{constructor(u,m,w){const p=new Uint8Array(u*m);for(let d=0,s=u*m;d<s;d++)p[d]=w;this._data=p,this.rows=u,this.cols=m}get(u,m){return this._data[u*this.cols+m]}set(u,m,w){this._data[u*this.cols+m]=w}}e.Uint8Matrix=R;class T{constructor(u){let m=0,w=0;for(let d=0,s=u.length;d<s;d++){let[a,c,t]=u[d];c>m&&(m=c),a>w&&(w=a),t>w&&(w=t)}m++,w++;let p=new R(w,m,0);for(let d=0,s=u.length;d<s;d++){let[a,c,t]=u[d];p.set(a,c,t)}this._states=p,this._maxCharCode=m}nextState(u,m){return m<0||m>=this._maxCharCode?0:this._states.get(u,m)}}e.StateMachine=T;let P=null;function D(){return P===null&&(P=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var I;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(I||(I={}));let n=null;function C(){if(n===null){n=new _.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<f.length;m++)n.set(f.charCodeAt(m),1);const u=".,;";for(let m=0;m<u.length;m++)n.set(u.charCodeAt(m),2)}return n}class S{static _createLink(u,m,w,p,d){let s=d-1;do{const a=m.charCodeAt(s);if(u.get(a)!==2)break;s--}while(s>p);if(p>0){const a=m.charCodeAt(p-1),c=m.charCodeAt(s);(a===40&&c===41||a===91&&c===93||a===123&&c===125)&&s--}return{range:{startLineNumber:w,startColumn:p+1,endLineNumber:w,endColumn:s+2},url:m.substring(p,s+1)}}static computeLinks(u,m=D()){const w=C();let p=[];for(let d=1,s=u.getLineCount();d<=s;d++){const a=u.getLineContent(d),c=a.length;let t=0,r=0,o=0,l=1,i=!1,h=!1,y=!1,g=!1;for(;t<c;){let E=!1;const b=a.charCodeAt(t);if(l===13){let L;switch(b){case 40:i=!0,L=0;break;case 41:L=i?0:1;break;case 91:y=!0,h=!0,L=0;break;case 93:y=!1,L=h?0:1;break;case 123:g=!0,L=0;break;case 125:L=g?0:1;break;case 39:L=o===34||o===96?0:1;break;case 34:L=o===39||o===96?0:1;break;case 96:L=o===39||o===34?0:1;break;case 42:L=o===42?1:0;break;case 124:L=o===124?1:0;break;case 32:L=y?0:1;break;default:L=w.get(b)}L===1&&(p.push(S._createLink(w,a,d,r,t)),E=!0)}else if(l===12){let L;b===91?(h=!0,L=0):L=w.get(b),L===1?E=!0:l=13}else l=m.nextState(l,b),l===0&&(E=!0);E&&(l=1,i=!1,h=!1,g=!1,r=t+1,o=b),t++}l===13&&p.push(S._createLink(w,a,d,r,c))}return p}}e.LinkComputer=S;function v(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:S.computeLinks(f)}e.computeLinks=v}),define(ge[142],pe([0,1,3,5]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class R{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,D){return this._map.set(P,D),this.fire([P]),k.toDisposable(()=>{this._map.get(P)===D&&(this._map.delete(P),this.fire([P]))})}registerPromise(P,D){let I=null,n=!1;return this._promises.set(P,D.then(C=>{this._promises.delete(P),!(n||!C)&&(I=this.register(P,C))})),k.toDisposable(()=>{n=!0,I&&I.dispose()})}getPromise(P){const D=this.get(P);if(D)return Promise.resolve(D);const I=this._promises.get(P);return I?I.then(n=>this.get(P)):null}get(P){return this._map.get(P)||null}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=R}),define(ge[107],pe([0,1,27,9]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var R;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(R||(R={}));function T(S){for(let v=0,f=S.length;v<f;v+=4){const u=S[v+0],m=S[v+1],w=S[v+2],p=S[v+3];S[v+0]=p,S[v+1]=w,S[v+2]=m,S[v+3]=u}}function P(S){const v=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return k.isLittleEndian()||T(v),_.VSBuffer.wrap(v)}function D(S){const v=S.buffer;if(k.isLittleEndian()||T(v),v.byteOffset%4==0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const f=new Uint8Array(v.byteLength);return f.set(v),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function I(S){const v=new Uint32Array(n(S));let f=0;if(v[f++]=S.id,S.type==="full")v[f++]=1,v[f++]=S.data.length,v.set(S.data,f),f+=S.data.length;else{v[f++]=2,v[f++]=S.deltas.length;for(const u of S.deltas)v[f++]=u.start,v[f++]=u.deleteCount,u.data?(v[f++]=u.data.length,v.set(u.data,f),f+=u.data.length):v[f++]=0}return P(v)}e.encodeSemanticTokensDto=I;function n(S){let v=0;if(v+=1+1,S.type==="full")v+=1+S.data.length;else{v+=1,v+=(1+1+1)*S.deltas.length;for(const f of S.deltas)f.data&&(v+=f.data.length)}return v}function C(S){const v=D(S);let f=0;const u=v[f++];if(v[f++]===1){const d=v[f++],s=v.subarray(f,f+d);return f+=d,{id:u,type:"full",data:s}}const w=v[f++];let p=[];for(let d=0;d<w;d++){const s=v[f++],a=v[f++],c=v[f++];let t;c>0&&(t=v.subarray(f,f+c),f+=c),p[d]={start:s,deleteCount:a,data:t}}return{id:u,type:"delta",deltas:p}}e.decodeSemanticTokensDto=C}),define(ge[108],pe([0,1,95]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class k{constructor(P,D){this.index=P,this.remainder=D}}e.PrefixSumIndexOfResult=k;class R{constructor(P){this.values=P,this.prefixSum=new Uint32Array(P.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(P,D){P=_.toUint32(P);const I=this.values,n=this.prefixSum,C=D.length;return C===0?!1:(this.values=new Uint32Array(I.length+C),this.values.set(I.subarray(0,P),0),this.values.set(I.subarray(P),P+C),this.values.set(D,P),P-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=P-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(P,D){return P=_.toUint32(P),D=_.toUint32(D),this.values[P]===D?!1:(this.values[P]=D,P-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=P-1),!0)}removeValues(P,D){P=_.toUint32(P),D=_.toUint32(D);const I=this.values,n=this.prefixSum;if(P>=I.length)return!1;let C=I.length-P;return D>=C&&(D=C),D===0?!1:(this.values=new Uint32Array(I.length-D),this.values.set(I.subarray(0,P),0),this.values.set(I.subarray(P+D),P),this.prefixSum=new Uint32Array(this.values.length),P-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=P-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(P){return P<0?0:(P=_.toUint32(P),this._getAccumulatedValue(P))}_getAccumulatedValue(P){if(P<=this.prefixSumValidIndex[0])return this.prefixSum[P];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),P>=this.values.length&&(P=this.values.length-1);for(let I=D;I<=P;I++)this.prefixSum[I]=this.prefixSum[I-1]+this.values[I];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],P),this.prefixSum[P]}getIndexOf(P){P=Math.floor(P),this.getTotalValue();let D=0,I=this.values.length-1,n=0,C=0,S=0;for(;D<=I;)if(n=D+(I-D)/2|0,C=this.prefixSum[n],S=C-this.values[n],P<S)I=n-1;else if(P>=C)D=n+1;else break;return new k(n,P-S)}}e.PrefixSumComputer=R}),define(ge[143],pe([0,1,10,48,108]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(D,I,n,C){this._uri=D,this._lines=I,this._eol=n,this._versionId=C,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const I=D.changes;for(const n of I)this._acceptDeleteRange(n.range),this._acceptInsertText(new k.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,I=this._lines.length,n=new Uint32Array(I);for(let C=0;C<I;C++)n[C]=this._lines[C].length+D;this._lineStarts=new R.PrefixSumComputer(n)}}_setLineText(D,I){this._lines[D]=I,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,I){if(I.length!==0){let n=_.splitLines(I);if(n.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+n[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}n[n.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+n[0]);let C=new Uint32Array(n.length-1);for(let S=1;S<n.length;S++)this._lines.splice(D.lineNumber+S-1,0,n[S]),C[S-1]=n[S].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,C)}}}e.MirrorTextModel=T}),define(ge[144],pe([17,18]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(ge[145],pe([0,1,144]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,R=k*60,T=R*24,P=T*7,D=T*30,I=T*365;function n(S,v){typeof S!="number"&&(S=S.getTime());const f=Math.round((new Date().getTime()-S)/1e3);if(f<-30)return _.localize(0,null,n(new Date().getTime()+f*1e3,!1));if(f<30)return _.localize(1,null);let u;return f<k?(u=f,v?u===1?_.localize(2,null,u):_.localize(3,null,u):u===1?_.localize(4,null,u):_.localize(5,null,u)):f<R?(u=Math.floor(f/k),v?u===1?_.localize(6,null,u):_.localize(7,null,u):u===1?_.localize(8,null,u):_.localize(9,null,u)):f<T?(u=Math.floor(f/R),v?u===1?_.localize(10,null,u):_.localize(11,null,u):u===1?_.localize(12,null,u):_.localize(13,null,u)):f<P?(u=Math.floor(f/T),v?u===1?_.localize(14,null,u):_.localize(15,null,u):u===1?_.localize(16,null,u):_.localize(17,null,u)):f<D?(u=Math.floor(f/P),v?u===1?_.localize(18,null,u):_.localize(19,null,u):u===1?_.localize(20,null,u):_.localize(21,null,u)):f<I?(u=Math.floor(f/D),v?u===1?_.localize(22,null,u):_.localize(23,null,u):u===1?_.localize(24,null,u):_.localize(25,null,u)):(u=Math.floor(f/I),v?u===1?_.localize(26,null,u):_.localize(27,null,u):u===1?_.localize(28,null,u):_.localize(29,null,u))}e.fromNow=n;function C(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(ge[146],pe([17,18]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(ge[49],pe([0,1,146,16,13]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(n,C){return C&&(n.stack||n.stacktrace)?_.localize(0,null,D(n),P(n.stack)||P(n.stacktrace)):D(n)}function P(n){return Array.isArray(n)?n.join(`
`):n}function D(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?_.localize(1,null,n.message):n.message||_.localize(2,null)}function I(n=null,C=!1){if(!n)return _.localize(3,null);if(Array.isArray(n)){const S=R.coalesce(n),v=I(S[0],C);return S.length>1?_.localize(4,null,v,S.length):v}if(k.isString(n))return n;if(n.detail){const S=n.detail;if(S.error)return T(S.error,C);if(S.exception)return T(S.exception,C)}return n.stack?T(n,C):n.message?n.message:_.localize(5,null)}e.toErrorMessage=I}),define(ge[147],pe([17,18]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(ge[80],pe([0,1,7,39,59,35,147,16,25,30,9,134,11]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(a,c){if(C.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};c&&(t.cwd=c);const r=T.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],t);return new Promise(o=>{r.once("error",l=>{o({success:!1,error:l})}),r.once("exit",(l,i)=>{o(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?f(t.status):1})}else if(C.isLinux||C.isMacintosh)try{const t=v.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(r=>{T.execFile(t,[a.pid.toString()],{encoding:"utf8",shell:!0},(o,l,i)=>{r(o?{success:!1,error:o}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function m(a=process.env){return a.comspec||"cmd.exe"}e.getWindowsShell=m;class w{constructor(c,t,r,o){if(t!==void 0&&r!==void 0&&o!==void 0)this.cmd=c,this.args=t,this.shell=r,this.options=o;else{const l=c;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(process.env).forEach(i=>{l[i]=process.env[i]}),Object.keys(this.options.env).forEach(i=>{l[i]=this.options.env[i]}),this.options.env=l}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const t=c.lastIndexOf(_.sep);return t!==-1&&(c=c.substring(t+1)),w.WellKnowCommands[c]?c:"other"}start(c){return C.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(process.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(t=>{let r,o;const l=new Promise((i,h)=>{r=i,o=h});if(t){let i=this.cmd;this.args&&(i=i+" "+this.args.join(" ")),this.childProcess=T.exec(i,this.options,(h,y,g)=>{this.childProcess=null;const E=h;E&&E.killed?o({killed:this.terminateRequested,stdout:y.toString(),stderr:g.toString()}):this.handleExec(r,c,h,y,g)})}else{let i=null;const h=y=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(y,r,c,o);const g={terminated:this.terminateRequested};D.isNumber(y)&&(g.cmdCode=y),r(g)};if(this.shell&&C.isWindows){const y=I.deepClone(this.options);y.windowsVerbatimArguments=!0,y.detached=!1;let g=!1,E=!1;const b=[];let L=this.ensureQuotes(this.cmd);b.push(L.value),g=L.quoted,this.args&&this.args.forEach(N=>{L=this.ensureQuotes(N),b.push(L.value),E=E&&L.quoted});const A=["/s","/c"];g?E?A.push('"'+b.join(" ")+'"'):b.length>1?A.push('"'+b[0]+'" '+b.slice(1).join(" ")):A.push('"'+b[0]+'"'):A.push(b.join(" ")),i=T.spawn(m(),A,y)}else this.cmd&&(i=T.spawn(this.cmd,this.args,this.options));i&&(this.childProcess=i,this.childProcessPromise=Promise.resolve(i),this.pidResolve&&(this.pidResolve(D.isNumber(i.pid)?i.pid:-1),this.pidResolve=void 0),i.on("error",y=>{this.childProcess=null,o({terminated:this.terminateRequested,error:y})}),i.pid&&(this.childProcess.on("close",h),this.handleSpawn(i,r,c,o,!0)))}return l})}handleClose(c,t,r,o){}ensureQuotes(c){return w.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,u(c,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!C.isWindows)return c(!1);const t=T.spawn(m(),["/s","/c"]);t.on("error",r=>c(!0)),t.on("exit",r=>c(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class p extends w{constructor(c,t,r,o){super(c,t,r,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,t,r,o,l){[o,l].forEach((i,h)=>{const y=new S.LineDecoder;y.write(i).forEach(b=>{t({line:b,source:h===0?0:1})});const E=y.end();E&&t({line:E,source:h===0?0:1})}),c({terminated:this.terminateRequested,error:r})}handleSpawn(c,t,r,o,l){const i=new S.LineDecoder,h=new S.LineDecoder;c.stdout.on("data",y=>{i.write(y).forEach(E=>r({line:E,source:0}))}),c.stderr.on("data",y=>{h.write(y).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=i,this.stderrLineDecoder=h}handleClose(c,t,r,o){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&r({line:l,source:0});const i=this.stderrLineDecoder?this.stderrLineDecoder.end():null;i&&r({line:i,source:1})}}e.LineProcess=p;function d(a){let c=[],t=!1;const r=function(o){if(t){c.push(o);return}(!a.send(o,i=>{if(i&&console.error(i),t=!1,c.length>0){const h=c.slice(0);c=[],h.forEach(y=>r(y))}})||C.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=d;var s;(function(a){async function c(t,r,o){if(_.isAbsolute(t))return t;if(r===void 0&&(r=process.cwd()),_.dirname(t)!=="."||(o===void 0&&D.isString(process.env.PATH)&&(o=process.env.PATH.split(_.delimiter)),o===void 0||o.length===0))return _.join(r,t);async function i(h){return await R.promisify(k.exists)(h)?!(await R.promisify(k.stat)(h)).isDirectory():!1}for(let h of o){let y;if(_.isAbsolute(h)?y=_.join(h,t):y=_.join(r,h,t),await i(y))return y;let g=y+".com";if(await i(g)||(g=y+".exe",await i(g)))return g}return _.join(r,t)}a.findExecutable=c})(s=e.win32||(e.win32={}))}),define(ge[148],pe([0,1,34,9,101,80]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(f,u=process.env){return f===3?k.isWindows?S():T.getWindowsShell(u):n(f,u)}e.getSystemShell=P;function D(f,u=process.env){return f===3?k.isWindows?v(u):T.getWindowsShell(u):n(f,u)}e.getSystemShellSync=D;let I=null;function n(f,u){if(k.isLinux&&f===1||k.isMacintosh&&f===2)return"/bin/bash";if(!I){let m;if(k.isWindows)m="/bin/bash";else{if(m=u.SHELL,!m)try{m=_.userInfo().shell}catch(w){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}I=m}return I}let C=null;async function S(){return C||(C=(await R.getFirstAvailablePowerShellInstallation()).exePath),C}function v(f){if(C)return C;const u=k.isWindows&&parseFloat(_.release())>=10,m=f.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${f.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?w:T.getWindowsShell(f)}}),define(ge[149],pe([17,18]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(ge[150],pe([0,1,149,9,106]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=P;class D{constructor(){this._values=[]}_read(se){return this._values[se]}get(se){return this._values[se]}_write(se,_e){this._values[se]=_e}}e.ValidatedEditorOptions=D;class I{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=I;class n{constructor(se,_e,Ae,Ue){this.id=se,this.name=_e,this.defaultValue=Ae,this.schema=Ue}compute(se,_e,Ae){return Ae}}class C{constructor(se,_e=null){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(se){return this.defaultValue}}class S{constructor(se,_e,Ae,Ue){this.id=se,this.name=_e,this.defaultValue=Ae,this.schema=Ue}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,_e,Ae){return Ae}}function v(K,se){return typeof K=="undefined"?se:K==="false"?!1:Boolean(K)}e.boolean=v;class f extends S{constructor(se,_e,Ae,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="boolean",Ue.default=Ae),super(se,_e,Ae,Ue)}validate(se){return v(se,this.defaultValue)}}class u extends S{constructor(se,_e,Ae,Ue,ze,je=void 0){typeof je!="undefined"&&(je.type="integer",je.default=Ae,je.minimum=Ue,je.maximum=ze),super(se,_e,Ae,je),this.minimum=Ue,this.maximum=ze}static clampedInt(se,_e,Ae,Ue){if(typeof se=="undefined")return _e;let ze=parseInt(se,10);return isNaN(ze)?_e:(ze=Math.max(Ae,ze),ze=Math.min(Ue,ze),ze|0)}validate(se){return u.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class m extends S{constructor(se,_e,Ae,Ue,ze){typeof ze!="undefined"&&(ze.type="number",ze.default=Ae),super(se,_e,Ae,ze),this.validationFn=Ue}static clamp(se,_e,Ae){return se<_e?_e:se>Ae?Ae:se}static float(se,_e){if(typeof se=="number")return se;if(typeof se=="undefined")return _e;const Ae=parseFloat(se);return isNaN(Ae)?_e:Ae}validate(se){return this.validationFn(m.float(se,this.defaultValue))}}class w extends S{static string(se,_e){return typeof se!="string"?_e:se}constructor(se,_e,Ae,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.default=Ae),super(se,_e,Ae,Ue)}validate(se){return w.string(se,this.defaultValue)}}function p(K,se,_e){return typeof K!="string"||_e.indexOf(K)===-1?se:K}e.stringSet=p;class d extends S{constructor(se,_e,Ae,Ue,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.enum=Ue,ze.default=Ae),super(se,_e,Ae,ze),this._allowedValues=Ue}validate(se){return p(se,this.defaultValue,this._allowedValues)}}class s extends n{constructor(se,_e,Ae,Ue,ze,je,ue=void 0){typeof ue!="undefined"&&(ue.type="string",ue.enum=ze,ue.default=Ue),super(se,_e,Ae,ue),this._allowedValues=ze,this._convert=je}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function a(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,_e,Ae){return Ae===0?se.accessibilitySupport:Ae}}class t extends n{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(16,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:_.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{insertSpace:v(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function i(K){switch(K){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=i;function h(K){switch(K){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class y extends C{constructor(){super(121,[60,29])}compute(se,_e,Ae){const Ue=["monaco-editor"];return _e.get(29)&&Ue.push(_e.get(29)),se.extraEditorClassName&&Ue.push(se.extraEditorClassName),_e.get(60)==="default"?Ue.push("mouse-default"):_e.get(60)==="copy"&&Ue.push("mouse-copy"),_e.get(95)&&Ue.push("showUnused"),_e.get(119)&&Ue.push("showDeprecated"),Ue.join(" ")}}class g extends f{constructor(){super(28,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(se,_e,Ae){return Ae&&se.emptySelectionClipboard}}class E extends n{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(31,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:se.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:_.localize(13,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:_.localize(15,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{cursorMoveOnType:v(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:v(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":p(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(_e.loop,this.defaultValue.loop)}}}class b extends n{constructor(){super(39,"fontLigatures",b.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?b.OFF:se==="true"?b.ON:se:Boolean(se)?b.ON:b.OFF}}e.EditorFontLigatures=b,b.OFF='"liga" off, "calt" off',b.ON='"liga" on, "calt" on';class L extends C{constructor(){super(38)}compute(se,_e,Ae){return se.fontInfo}}class A extends S{constructor(){super(40,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(se){let _e=m.float(se,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(_e,6,100)}compute(se,_e,Ae){return se.fontInfo.fontSize}}class N extends n{constructor(){super(41,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:N.MINIMUM_VALUE,maximum:N.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:N.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(se){return se==="normal"||se==="bold"?se:String(u.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,N.MINIMUM_VALUE,N.MAXIMUM_VALUE))}}N.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],N.MINIMUM_VALUE=1,N.MAXIMUM_VALUE=1e3;class W extends n{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]};super(45,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,description:_.localize(35,null)}})}validate(se){var _e,Ae,Ue,ze,je;if(!se||typeof se!="object")return this.defaultValue;const ue=se;return{multiple:p(ue.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=ue.multipleDefinitions)!==null&&_e!==void 0?_e:p(ue.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ae=ue.multipleTypeDefinitions)!==null&&Ae!==void 0?Ae:p(ue.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ue=ue.multipleDeclarations)!==null&&Ue!==void 0?Ue:p(ue.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(ze=ue.multipleImplementations)!==null&&ze!==void 0?ze:p(ue.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(je=ue.multipleReferences)!==null&&je!==void 0?je:p(ue.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(ue.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(ue.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(ue.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(ue.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(ue.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends n{constructor(){const se={enabled:!0,delay:300,sticky:!0};super(48,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:se.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:_.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:v(_e.enabled,this.defaultValue.enabled),delay:u.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:v(_e.sticky,this.defaultValue.sticky)}}}var M;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(M=e.RenderMinimap||(e.RenderMinimap={}));class $ extends C{constructor(){super(124,[44,52,33,59,87,54,55,89,111,114,115,116,2])}compute(se,_e,Ae){return $.computeLayout(_e,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const _e=se.height/se.lineHeight,Ae=se.scrollBeyondLastLine?_e-1:0,Ue=(se.viewLineCount+Ae)/(se.pixelRatio*se.height),ze=Math.floor(se.viewLineCount/Ue);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Ae,desiredRatio:Ue,minimapLineCount:ze}}static _computeMinimapLayout(se,_e){const Ae=se.outerWidth,Ue=se.outerHeight,ze=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ze*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const je=_e.stableMinimapLayoutInput,ue=je&&se.outerHeight===je.outerHeight&&se.lineHeight===je.lineHeight&&se.typicalHalfwidthCharacterWidth===je.typicalHalfwidthCharacterWidth&&se.pixelRatio===je.pixelRatio&&se.scrollBeyondLastLine===je.scrollBeyondLastLine&&se.minimap.enabled===je.minimap.enabled&&se.minimap.side===je.minimap.side&&se.minimap.size===je.minimap.size&&se.minimap.showSlider===je.minimap.showSlider&&se.minimap.renderCharacters===je.minimap.renderCharacters&&se.minimap.maxColumn===je.minimap.maxColumn&&se.minimap.scale===je.minimap.scale&&se.verticalScrollbarWidth===je.verticalScrollbarWidth&&se.isViewportWrapping===je.isViewportWrapping,ye=se.lineHeight,Ne=se.typicalHalfwidthCharacterWidth,ee=se.scrollBeyondLastLine,te=se.minimap.renderCharacters;let G=ze>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const F=se.minimap.maxColumn,ie=se.minimap.size,oe=se.minimap.side,me=se.verticalScrollbarWidth,ke=se.viewLineCount,Re=se.remainingWidth,xe=se.isViewportWrapping,qe=te?2:3;let Ge=Math.floor(ze*Ue);const Ke=Ge/ze;let st=!1,$e=!1,Xe=qe*G,ft=G/ze,et=1;if(ie==="fill"||ie==="fit"){const{typicalViewportLineCount:at,extraLinesBeyondLastLine:ut,desiredRatio:rt,minimapLineCount:kt}=$.computeContainedMinimapLineCount({viewLineCount:ke,scrollBeyondLastLine:ee,height:Ue,lineHeight:ye,pixelRatio:ze});if(ke/kt>1)st=!0,$e=!0,G=1,Xe=1,ft=G/ze;else{let Et=!1,pt=G+1;if(ie==="fit"){const yt=Math.ceil((ke+ut)*Xe);xe&&ue&&Re<=_e.stableFitRemainingWidth?(Et=!0,pt=_e.stableFitMaxMinimapScale):(Et=yt>Ge,xe&&Et?(_e.stableMinimapLayoutInput=se,_e.stableFitRemainingWidth=Re):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(ie==="fill"||Et){st=!0;const yt=G;Xe=Math.min(ye*ze,Math.max(1,Math.floor(1/rt))),G=Math.min(pt,Math.max(1,Math.floor(Xe/qe))),G>yt&&(et=Math.min(2,G/yt)),ft=G/ze/et,Ge=Math.ceil(Math.max(at,ke+ut)*Xe),xe&&Et&&(_e.stableFitMaxMinimapScale=G)}}}const mt=Math.floor(F*ft),ot=Math.min(mt,Math.max(0,Math.floor((Re-me-2)*ft/(Ne+ft)))+e.MINIMAP_GUTTER_WIDTH);let Ze=Math.floor(ze*ot);const St=Ze/ze;Ze=Math.floor(Ze*et);const _t=te?1:2,gt=oe==="left"?0:Ae-ot-me;return{renderMinimap:_t,minimapLeft:gt,minimapWidth:ot,minimapHeightIsEditorHeight:st,minimapIsSampling:$e,minimapScale:G,minimapLineHeight:Xe,minimapCanvasInnerWidth:Ze,minimapCanvasInnerHeight:Ge,minimapCanvasOuterWidth:St,minimapCanvasOuterHeight:Ke}}static computeLayout(se,_e){const Ae=_e.outerWidth|0,Ue=_e.outerHeight|0,ze=_e.lineHeight|0,je=_e.lineNumbersDigitCount|0,ue=_e.typicalHalfwidthCharacterWidth,ye=_e.maxDigitWidth,Ne=_e.pixelRatio,ee=_e.viewLineCount,te=se.get(116),G=te==="inherit"?se.get(115):te,F=G==="inherit"?se.get(111):G,ie=se.get(114),oe=se.get(2),me=_e.isDominatedByLongLines,ke=se.get(44),Re=se.get(54).renderType!==0,xe=se.get(55),qe=se.get(89),Ge=se.get(59),Ke=se.get(87),st=Ke.verticalScrollbarSize,$e=Ke.verticalHasArrows,Xe=Ke.arrowSize,ft=Ke.horizontalScrollbarSize,et=se.get(52),mt=se.get(33);let ot;if(typeof et=="string"&&/^\d+(\.\d+)?ch$/.test(et)){const Pt=parseFloat(et.substr(0,et.length-2));ot=u.clampedInt(Pt*ue,0,0,1e3)}else ot=u.clampedInt(et,0,0,1e3);mt&&(ot+=16);let Ze=0;if(Re){const Pt=Math.max(je,xe);Ze=Math.round(Pt*ye)}let St=0;ke&&(St=ze);let _t=0,gt=_t+St,at=gt+Ze,ut=at+ot;const rt=Ae-St-Ze-ot;let kt=!1,wt=!1,Et=-1;oe!==2&&(G==="inherit"&&me?(kt=!0,wt=!0):F==="on"||F==="bounded"?wt=!0:F==="wordWrapColumn"&&(Et=ie));const pt=$._computeMinimapLayout({outerWidth:Ae,outerHeight:Ue,lineHeight:ze,typicalHalfwidthCharacterWidth:ue,pixelRatio:Ne,scrollBeyondLastLine:qe,minimap:Ge,verticalScrollbarWidth:st,viewLineCount:ee,remainingWidth:rt,isViewportWrapping:wt},_e.memory||new I);pt.renderMinimap!==0&&pt.minimapLeft===0&&(_t+=pt.minimapWidth,gt+=pt.minimapWidth,at+=pt.minimapWidth,ut+=pt.minimapWidth);const yt=rt-pt.minimapWidth,vt=Math.max(1,Math.floor((yt-st-2)/ue)),Ct=$e?Xe:0;return wt&&(Et=Math.max(1,vt),F==="bounded"&&(Et=Math.min(Et,ie))),{width:Ae,height:Ue,glyphMarginLeft:_t,glyphMarginWidth:St,lineNumbersLeft:gt,lineNumbersWidth:Ze,decorationsLeft:at,decorationsWidth:ot,contentLeft:ut,contentWidth:yt,minimap:pt,viewportColumn:vt,isWordWrapMinified:kt,isViewportWrapping:wt,wrappingColumn:Et,verticalScrollbarWidth:st,horizontalScrollbarHeight:ft,overviewRuler:{top:Ct,width:st,height:Ue-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=$;class O extends n{constructor(){const se={enabled:!0};super(51,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:_.localize(39,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:v(se.enabled,this.defaultValue.enabled)}}}class B extends n{constructor(){const se={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(120,"inlineHints",se,{"editor.inlineHints.enabled":{type:"boolean",default:se.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:se.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:se.fontFamily,description:_.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:v(_e.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class J extends u{constructor(){super(53,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(se,_e,Ae){return se.fontInfo.lineHeight}}class U extends n{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(59,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:se.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:_.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:v(_e.enabled,this.defaultValue.enabled),size:p(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(_e.side,this.defaultValue.side,["right","left"]),showSlider:p(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(_e.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(_e.scale,1,1,3),maxColumn:u.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function V(K){return K==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class z extends n{constructor(){super(69,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{top:u.clampedInt(_e.top,0,0,1e3),bottom:u.clampedInt(_e.bottom,0,0,1e3)}}}class Q extends n{constructor(){const se={enabled:!0,cycle:!1};super(70,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:_.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{enabled:v(_e.enabled,this.defaultValue.enabled),cycle:v(_e.cycle,this.defaultValue.cycle)}}}class ae extends C{constructor(){super(122)}compute(se,_e,Ae){return se.pixelRatio}}class ce extends n{constructor(){const se={other:!0,comments:!1,strings:!1};super(73,"quickSuggestions",se,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:se.strings,description:_.localize(58,null)},comments:{type:"boolean",default:se.comments,description:_.localize(59,null)},other:{type:"boolean",default:se.other,description:_.localize(60,null)}}}],default:se,description:_.localize(61,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean")return se;if(se&&typeof se=="object"){const _e=se,Ae={other:v(_e.other,this.defaultValue.other),comments:v(_e.comments,this.defaultValue.comments),strings:v(_e.strings,this.defaultValue.strings)};return Ae.other&&Ae.comments&&Ae.strings?!0:!Ae.other&&!Ae.comments&&!Ae.strings?!1:Ae}return this.defaultValue}}var fe;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class we extends n{constructor(){super(54,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(se){let _e=this.defaultValue.renderType,Ae=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(_e=4,Ae=se):se==="interval"?_e=3:se==="relative"?_e=2:se==="on"?_e=1:_e=0),{renderType:_e,renderFn:Ae}}}function be(K){const se=K.get(82);return se==="editable"?K.get(75):se!=="on"}e.filterValidationDecorations=be;class H extends n{constructor(){const se=[],_e={type:"number",description:_.localize(67,null)};super(86,"rulers",se,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:se,description:_.localize(69,null)})}validate(se){if(Array.isArray(se)){let _e=[];for(let Ae of se)if(typeof Ae=="number")_e.push({column:u.clampedInt(Ae,0,0,1e4),color:null});else if(Ae&&typeof Ae=="object"){const Ue=Ae;_e.push({column:u.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return _e.sort((Ae,Ue)=>Ae.column-Ue.column),_e}return this.defaultValue}}function X(K,se){if(typeof K!="string")return se;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class re extends n{constructor(){super(87,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se,Ae=u.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=u.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:X(_e.vertical,this.defaultValue.vertical),horizontal:X(_e.horizontal,this.defaultValue.horizontal),useShadows:v(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ae,horizontalSliderSize:u.clampedInt(_e.horizontalSliderSize,Ae,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:u.clampedInt(_e.verticalSliderSize,Ue,0,1e3),scrollByPage:v(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class Y extends n{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(101,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:se.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{insertMode:p(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(_e.showIcons,this.defaultValue.showIcons),showStatusBar:v(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:v(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(_e.showMethods,this.defaultValue.showMethods),showFunctions:v(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:v(_e.showConstructors,this.defaultValue.showConstructors),showFields:v(_e.showFields,this.defaultValue.showFields),showVariables:v(_e.showVariables,this.defaultValue.showVariables),showClasses:v(_e.showClasses,this.defaultValue.showClasses),showStructs:v(_e.showStructs,this.defaultValue.showStructs),showInterfaces:v(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:v(_e.showModules,this.defaultValue.showModules),showProperties:v(_e.showProperties,this.defaultValue.showProperties),showEvents:v(_e.showEvents,this.defaultValue.showEvents),showOperators:v(_e.showOperators,this.defaultValue.showOperators),showUnits:v(_e.showUnits,this.defaultValue.showUnits),showValues:v(_e.showValues,this.defaultValue.showValues),showConstants:v(_e.showConstants,this.defaultValue.showConstants),showEnums:v(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:v(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(_e.showKeywords,this.defaultValue.showKeywords),showWords:v(_e.showWords,this.defaultValue.showWords),showColors:v(_e.showColors,this.defaultValue.showColors),showFiles:v(_e.showFiles,this.defaultValue.showFiles),showReferences:v(_e.showReferences,this.defaultValue.showReferences),showFolders:v(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:v(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(_e.showSnippets,this.defaultValue.showSnippets),showUsers:v(_e.showUsers,this.defaultValue.showUsers),showIssues:v(_e.showIssues,this.defaultValue.showIssues)}}}class le extends n{constructor(){super(97,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ve extends C{constructor(){super(123,[75])}compute(se,_e,Ae){return _e.get(75)?!0:se.tabFocusMode}}var De;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Me(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Ee extends C{constructor(){super(125,[124])}compute(se,_e,Ae){const Ue=_e.get(124);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}const Pe="Consolas, 'Courier New', monospace",Ce="Menlo, Monaco, 'Courier New', monospace",Oe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?Ce:k.isLinux?Oe:Pe,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Se(K){return e.editorOptionsRegistry[K.id]=K,K}var Be;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingOvertype=6]="autoClosingOvertype",K[K.autoClosingQuotes=7]="autoClosingQuotes",K[K.autoIndent=8]="autoIndent",K[K.automaticLayout=9]="automaticLayout",K[K.autoSurround=10]="autoSurround",K[K.codeLens=11]="codeLens",K[K.codeLensFontFamily=12]="codeLensFontFamily",K[K.codeLensFontSize=13]="codeLensFontSize",K[K.colorDecorators=14]="colorDecorators",K[K.columnSelection=15]="columnSelection",K[K.comments=16]="comments",K[K.contextmenu=17]="contextmenu",K[K.copyWithSyntaxHighlighting=18]="copyWithSyntaxHighlighting",K[K.cursorBlinking=19]="cursorBlinking",K[K.cursorSmoothCaretAnimation=20]="cursorSmoothCaretAnimation",K[K.cursorStyle=21]="cursorStyle",K[K.cursorSurroundingLines=22]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=23]="cursorSurroundingLinesStyle",K[K.cursorWidth=24]="cursorWidth",K[K.disableLayerHinting=25]="disableLayerHinting",K[K.disableMonospaceOptimizations=26]="disableMonospaceOptimizations",K[K.dragAndDrop=27]="dragAndDrop",K[K.emptySelectionClipboard=28]="emptySelectionClipboard",K[K.extraEditorClassName=29]="extraEditorClassName",K[K.fastScrollSensitivity=30]="fastScrollSensitivity",K[K.find=31]="find",K[K.fixedOverflowWidgets=32]="fixedOverflowWidgets",K[K.folding=33]="folding",K[K.foldingStrategy=34]="foldingStrategy",K[K.foldingHighlight=35]="foldingHighlight",K[K.unfoldOnClickAfterEndOfLine=36]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=37]="fontFamily",K[K.fontInfo=38]="fontInfo",K[K.fontLigatures=39]="fontLigatures",K[K.fontSize=40]="fontSize",K[K.fontWeight=41]="fontWeight",K[K.formatOnPaste=42]="formatOnPaste",K[K.formatOnType=43]="formatOnType",K[K.glyphMargin=44]="glyphMargin",K[K.gotoLocation=45]="gotoLocation",K[K.hideCursorInOverviewRuler=46]="hideCursorInOverviewRuler",K[K.highlightActiveIndentGuide=47]="highlightActiveIndentGuide",K[K.hover=48]="hover",K[K.inDiffEditor=49]="inDiffEditor",K[K.letterSpacing=50]="letterSpacing",K[K.lightbulb=51]="lightbulb",K[K.lineDecorationsWidth=52]="lineDecorationsWidth",K[K.lineHeight=53]="lineHeight",K[K.lineNumbers=54]="lineNumbers",K[K.lineNumbersMinChars=55]="lineNumbersMinChars",K[K.linkedEditing=56]="linkedEditing",K[K.links=57]="links",K[K.matchBrackets=58]="matchBrackets",K[K.minimap=59]="minimap",K[K.mouseStyle=60]="mouseStyle",K[K.mouseWheelScrollSensitivity=61]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=62]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=63]="multiCursorMergeOverlapping",K[K.multiCursorModifier=64]="multiCursorModifier",K[K.multiCursorPaste=65]="multiCursorPaste",K[K.occurrencesHighlight=66]="occurrencesHighlight",K[K.overviewRulerBorder=67]="overviewRulerBorder",K[K.overviewRulerLanes=68]="overviewRulerLanes",K[K.padding=69]="padding",K[K.parameterHints=70]="parameterHints",K[K.peekWidgetDefaultFocus=71]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=72]="definitionLinkOpensInPeek",K[K.quickSuggestions=73]="quickSuggestions",K[K.quickSuggestionsDelay=74]="quickSuggestionsDelay",K[K.readOnly=75]="readOnly",K[K.renameOnType=76]="renameOnType",K[K.renderControlCharacters=77]="renderControlCharacters",K[K.renderIndentGuides=78]="renderIndentGuides",K[K.renderFinalNewline=79]="renderFinalNewline",K[K.renderLineHighlight=80]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=81]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=82]="renderValidationDecorations",K[K.renderWhitespace=83]="renderWhitespace",K[K.revealHorizontalRightPadding=84]="revealHorizontalRightPadding",K[K.roundedSelection=85]="roundedSelection",K[K.rulers=86]="rulers",K[K.scrollbar=87]="scrollbar",K[K.scrollBeyondLastColumn=88]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=89]="scrollBeyondLastLine",K[K.scrollPredominantAxis=90]="scrollPredominantAxis",K[K.selectionClipboard=91]="selectionClipboard",K[K.selectionHighlight=92]="selectionHighlight",K[K.selectOnLineNumbers=93]="selectOnLineNumbers",K[K.showFoldingControls=94]="showFoldingControls",K[K.showUnused=95]="showUnused",K[K.snippetSuggestions=96]="snippetSuggestions",K[K.smartSelect=97]="smartSelect",K[K.smoothScrolling=98]="smoothScrolling",K[K.stickyTabStops=99]="stickyTabStops",K[K.stopRenderingLineAfter=100]="stopRenderingLineAfter",K[K.suggest=101]="suggest",K[K.suggestFontSize=102]="suggestFontSize",K[K.suggestLineHeight=103]="suggestLineHeight",K[K.suggestOnTriggerCharacters=104]="suggestOnTriggerCharacters",K[K.suggestSelection=105]="suggestSelection",K[K.tabCompletion=106]="tabCompletion",K[K.tabIndex=107]="tabIndex",K[K.unusualLineTerminators=108]="unusualLineTerminators",K[K.useTabStops=109]="useTabStops",K[K.wordSeparators=110]="wordSeparators",K[K.wordWrap=111]="wordWrap",K[K.wordWrapBreakAfterCharacters=112]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=113]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=114]="wordWrapColumn",K[K.wordWrapOverride1=115]="wordWrapOverride1",K[K.wordWrapOverride2=116]="wordWrapOverride2",K[K.wrappingIndent=117]="wrappingIndent",K[K.wrappingStrategy=118]="wrappingStrategy",K[K.showDeprecated=119]="showDeprecated",K[K.inlineHints=120]="inlineHints",K[K.editorClassName=121]="editorClassName",K[K.pixelRatio=122]="pixelRatio",K[K.tabFocusMode=123]="tabFocusMode",K[K.layoutInfo=124]="layoutInfo",K[K.wrappingInfo=125]="wrappingInfo"})(Be=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:Se(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:Se(new c),accessibilityPageSize:Se(new u(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null)})),ariaLabel:Se(new w(4,"ariaLabel",_.localize(115,null))),autoClosingBrackets:Se(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(116,null),_.localize(117,null),""],description:_.localize(118,null)})),autoClosingOvertype:Se(new d(6,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(119,null),""],description:_.localize(120,null)})),autoClosingQuotes:Se(new d(7,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(121,null),_.localize(122,null),""],description:_.localize(123,null)})),autoIndent:Se(new s(8,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[_.localize(124,null),_.localize(125,null),_.localize(126,null),_.localize(127,null),_.localize(128,null)],description:_.localize(129,null)})),automaticLayout:Se(new f(9,"automaticLayout",!1)),autoSurround:Se(new d(10,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(130,null),_.localize(131,null),_.localize(132,null),""],description:_.localize(133,null)})),stickyTabStops:Se(new f(99,"stickyTabStops",!1,{description:_.localize(134,null)})),codeLens:Se(new f(11,"codeLens",!0,{description:_.localize(135,null)})),codeLensFontFamily:Se(new w(12,"codeLensFontFamily","",{description:_.localize(136,null)})),codeLensFontSize:Se(new u(13,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(137,null)})),colorDecorators:Se(new f(14,"colorDecorators",!0,{description:_.localize(138,null)})),columnSelection:Se(new f(15,"columnSelection",!1,{description:_.localize(139,null)})),comments:Se(new t),contextmenu:Se(new f(17,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new f(18,"copyWithSyntaxHighlighting",!0,{description:_.localize(140,null)})),cursorBlinking:Se(new s(19,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:_.localize(141,null)})),cursorSmoothCaretAnimation:Se(new f(20,"cursorSmoothCaretAnimation",!1,{description:_.localize(142,null)})),cursorStyle:Se(new s(21,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:_.localize(143,null)})),cursorSurroundingLines:Se(new u(22,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(144,null)})),cursorSurroundingLinesStyle:Se(new d(23,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(145,null),_.localize(146,null)],description:_.localize(147,null)})),cursorWidth:Se(new u(24,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(148,null)})),disableLayerHinting:Se(new f(25,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new f(26,"disableMonospaceOptimizations",!1)),dragAndDrop:Se(new f(27,"dragAndDrop",!0,{description:_.localize(149,null)})),emptySelectionClipboard:Se(new g),extraEditorClassName:Se(new w(29,"extraEditorClassName","")),fastScrollSensitivity:Se(new m(30,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:_.localize(150,null)})),find:Se(new E),fixedOverflowWidgets:Se(new f(32,"fixedOverflowWidgets",!1)),folding:Se(new f(33,"folding",!0,{description:_.localize(151,null)})),foldingStrategy:Se(new d(34,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(152,null),_.localize(153,null)],description:_.localize(154,null)})),foldingHighlight:Se(new f(35,"foldingHighlight",!0,{description:_.localize(155,null)})),unfoldOnClickAfterEndOfLine:Se(new f(36,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(156,null)})),fontFamily:Se(new w(37,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(157,null)})),fontInfo:Se(new L),fontLigatures2:Se(new b),fontSize:Se(new A),fontWeight:Se(new N),formatOnPaste:Se(new f(42,"formatOnPaste",!1,{description:_.localize(158,null)})),formatOnType:Se(new f(43,"formatOnType",!1,{description:_.localize(159,null)})),glyphMargin:Se(new f(44,"glyphMargin",!0,{description:_.localize(160,null)})),gotoLocation:Se(new W),hideCursorInOverviewRuler:Se(new f(46,"hideCursorInOverviewRuler",!1,{description:_.localize(161,null)})),highlightActiveIndentGuide:Se(new f(47,"highlightActiveIndentGuide",!0,{description:_.localize(162,null)})),hover:Se(new x),inDiffEditor:Se(new f(49,"inDiffEditor",!1)),letterSpacing:Se(new m(50,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>m.clamp(K,-5,20),{description:_.localize(163,null)})),lightbulb:Se(new O),lineDecorationsWidth:Se(new S(52,"lineDecorationsWidth",10)),lineHeight:Se(new J),lineNumbers:Se(new we),lineNumbersMinChars:Se(new u(55,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new f(56,"linkedEditing",!1,{description:_.localize(164,null)})),links:Se(new f(57,"links",!0,{description:_.localize(165,null)})),matchBrackets:Se(new d(58,"matchBrackets","always",["always","near","never"],{description:_.localize(166,null)})),minimap:Se(new U),mouseStyle:Se(new d(60,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new m(61,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:_.localize(167,null)})),mouseWheelZoom:Se(new f(62,"mouseWheelZoom",!1,{markdownDescription:_.localize(168,null)})),multiCursorMergeOverlapping:Se(new f(63,"multiCursorMergeOverlapping",!0,{description:_.localize(169,null)})),multiCursorModifier:Se(new s(64,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],V,{markdownEnumDescriptions:[_.localize(170,null),_.localize(171,null)],markdownDescription:_.localize(172,null)})),multiCursorPaste:Se(new d(65,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(173,null),_.localize(174,null)],markdownDescription:_.localize(175,null)})),occurrencesHighlight:Se(new f(66,"occurrencesHighlight",!0,{description:_.localize(176,null)})),overviewRulerBorder:Se(new f(67,"overviewRulerBorder",!0,{description:_.localize(177,null)})),overviewRulerLanes:Se(new u(68,"overviewRulerLanes",3,0,3)),padding:Se(new z),parameterHints:Se(new Q),peekWidgetDefaultFocus:Se(new d(71,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(178,null),_.localize(179,null)],description:_.localize(180,null)})),definitionLinkOpensInPeek:Se(new f(72,"definitionLinkOpensInPeek",!1,{description:_.localize(181,null)})),quickSuggestions:Se(new ce),quickSuggestionsDelay:Se(new u(74,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(182,null)})),readOnly:Se(new f(75,"readOnly",!1)),renameOnType:Se(new f(76,"renameOnType",!1,{description:_.localize(183,null),markdownDeprecationMessage:_.localize(184,null)})),renderControlCharacters:Se(new f(77,"renderControlCharacters",!1,{description:_.localize(185,null)})),renderIndentGuides:Se(new f(78,"renderIndentGuides",!0,{description:_.localize(186,null)})),renderFinalNewline:Se(new f(79,"renderFinalNewline",!0,{description:_.localize(187,null)})),renderLineHighlight:Se(new d(80,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(188,null)],description:_.localize(189,null)})),renderLineHighlightOnlyWhenFocus:Se(new f(81,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(190,null)})),renderValidationDecorations:Se(new d(82,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new d(83,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(191,null),_.localize(192,null),_.localize(193,null),""],description:_.localize(194,null)})),revealHorizontalRightPadding:Se(new u(84,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new f(85,"roundedSelection",!0,{description:_.localize(195,null)})),rulers:Se(new H),scrollbar:Se(new re),scrollBeyondLastColumn:Se(new u(88,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(196,null)})),scrollBeyondLastLine:Se(new f(89,"scrollBeyondLastLine",!0,{description:_.localize(197,null)})),scrollPredominantAxis:Se(new f(90,"scrollPredominantAxis",!0,{description:_.localize(198,null)})),selectionClipboard:Se(new f(91,"selectionClipboard",!0,{description:_.localize(199,null),included:k.isLinux})),selectionHighlight:Se(new f(92,"selectionHighlight",!0,{description:_.localize(200,null)})),selectOnLineNumbers:Se(new f(93,"selectOnLineNumbers",!0)),showFoldingControls:Se(new d(94,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(201,null),_.localize(202,null)],description:_.localize(203,null)})),showUnused:Se(new f(95,"showUnused",!0,{description:_.localize(204,null)})),showDeprecated:Se(new f(119,"showDeprecated",!0,{description:_.localize(205,null)})),inlineHints:Se(new B),snippetSuggestions:Se(new d(96,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(206,null),_.localize(207,null),_.localize(208,null),_.localize(209,null)],description:_.localize(210,null)})),smartSelect:Se(new le),smoothScrolling:Se(new f(98,"smoothScrolling",!1,{description:_.localize(211,null)})),stopRenderingLineAfter:Se(new u(100,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new Y),suggestFontSize:Se(new u(102,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(212,null)})),suggestLineHeight:Se(new u(103,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(213,null)})),suggestOnTriggerCharacters:Se(new f(104,"suggestOnTriggerCharacters",!0,{description:_.localize(214,null)})),suggestSelection:Se(new d(105,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(215,null),_.localize(216,null),_.localize(217,null)],description:_.localize(218,null)})),tabCompletion:Se(new d(106,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(219,null),_.localize(220,null),_.localize(221,null)],description:_.localize(222,null)})),tabIndex:Se(new u(107,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new d(108,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(223,null),_.localize(224,null),_.localize(225,null)],description:_.localize(226,null)})),useTabStops:Se(new f(109,"useTabStops",!0,{description:_.localize(227,null)})),wordSeparators:Se(new w(110,"wordSeparators",R.USUAL_WORD_SEPARATORS,{description:_.localize(228,null)})),wordWrap:Se(new d(111,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(229,null),_.localize(230,null),_.localize(231,null),_.localize(232,null)],description:_.localize(233,null)})),wordWrapBreakAfterCharacters:Se(new w(112,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new w(113,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new u(114,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(234,null)})),wordWrapOverride1:Se(new d(115,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new d(116,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new s(117,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Me,{enumDescriptions:[_.localize(235,null),_.localize(236,null),_.localize(237,null),_.localize(238,null)],description:_.localize(239,null)})),wrappingStrategy:Se(new d(118,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(240,null),_.localize(241,null)],description:_.localize(242,null)})),editorClassName:Se(new y),pixelRatio:Se(new ae),tabFocusMode:Se(new ve),layoutInfo:Se(new $),wrappingInfo:Se(new Ee)}}),define(ge[151],pe([17,18]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[152],pe([17,18]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[153],pe([17,18]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(ge[154],pe([17,18]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(ge[155],pe([17,18]),function(Z,e){return Z.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[156],pe([17,18]),function(Z,e){return Z.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[157],pe([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ge[158],pe([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[159],pe([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ge[160],pe([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[161],pe([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[162],pe([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[163],pe([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[164],pe([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[165],pe([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[166],pe([17,18]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[167],pe([17,18]),function(Z,e){return Z.create("vs/workbench/common/views",e)}),define(ge[168],pe([17,18]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[169],pe([17,18]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[170],pe([17,18]),function(Z,e){return Z.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(ge[171],pe([17,18]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[172],pe([17,18]),function(Z,e){return Z.create("vs/workbench/contrib/terminal/common/terminal",e)}),define(ge[173],pe([17,18]),function(Z,e){return Z.create("vs/workbench/contrib/terminal/node/terminalProcess",e)}),define(ge[174],pe([17,18]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[109],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(T,P=[],D=!1){this.ctor=T,this.staticArguments=P,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=_;const k=(R,...T)=>new _(R,T);e.createSyncDescriptor=k}),define(ge[81],pe([0,1,109]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function R(P,D,I){k.push([P,new _.SyncDescriptor(D,[],I)])}e.registerSingleton=R;function T(){return k}e.getSingletonServiceDescriptors=T}),define(ge[175],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=_;class k{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let P of this._nodes.values())P.outgoing.size===0&&T.push(P);return T}insertEdge(T,P){const D=this.lookupOrInsertNode(T),I=this.lookupOrInsertNode(P);D.outgoing.set(this._hashFn(P),I),I.incoming.set(this._hashFn(T),D)}removeNode(T){const P=this._hashFn(T);this._nodes.delete(P);for(let D of this._nodes.values())D.outgoing.delete(P),D.incoming.delete(P)}lookupOrInsertNode(T){const P=this._hashFn(T);let D=this._nodes.get(P);return D||(D=new _(T),this._nodes.set(P,D)),D}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[P,D]of this._nodes)T.push(`${P}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return T.join(`
`)}}e.Graph=k}),define(ge[4],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function D(I){return I[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=D})(_=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function k(P,D,I,n){D[_.DI_TARGET]===D?D[_.DI_DEPENDENCIES].push({id:P,index:I,optional:n}):(D[_.DI_DEPENDENCIES]=[{id:P,index:I,optional:n}],D[_.DI_TARGET]=D)}function R(P){if(_.serviceIds.has(P))return _.serviceIds.get(P);const D=function(I,n,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(D,I,C,!1)};return D.toString=()=>P,_.serviceIds.set(P,D),D}e.createDecorator=R;function T(P){return function(D,I,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(P,D,n,!0)}}e.optional=T}),define(ge[176],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=_.createDecorator("modelService");function k(R){return!R.isTooLargeForSyncing()&&!R.isForSimpleWidget}e.shouldSynchronizeModel=k}),define(ge[177],pe([0,1,3,75,5,22,74,79,176]),function(Z,e,_,k,R,T,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(n):!!v.exclusive}class C{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(f,u){let m={selector:f,provider:u,_score:-1,_time:this._clock++};return this._entries.push(m),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),R.toDisposable(()=>{if(m){let w=this._entries.indexOf(m);w>=0&&(this._entries.splice(w,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),m=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const u=[];for(let m of this._entries)m._score>0&&u.push(m.provider);return u}ordered(f){const u=[];return this._orderedForEach(f,m=>u.push(m.provider)),u}orderedGroups(f){const u=[];let m,w;return this._orderedForEach(f,p=>{m&&w===p._score?m.push(p.provider):(w=p._score,m=[p.provider],u.push(m))}),u}_orderedForEach(f,u){if(!!f){this._updateScores(f);for(const m of this._entries)m._score>0&&u(m)}}_updateScores(f){let u={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===u.language&&this._lastCandidate.uri===u.uri)){this._lastCandidate=u;for(let m of this._entries)if(m._score=D.score(m.selector,f.uri,f.getLanguageIdentifier().language,I.shouldSynchronizeModel(f)),n(m.selector)&&m._score>0){for(let w of this._entries)w._score=0;m._score=1e3;break}this._entries.sort(C._compareByScoreAndTime)}}static _compareByScoreAndTime(f,u){return f._score<u._score?1:f._score>u._score?-1:f._time<u._time?1:f._time>u._time?-1:0}}e.LanguageFeatureRegistry=C;class S{constructor(f,u,m=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=u,this.max=m,this._cache=new T.LRUCache(50,.7)}_key(f){return f.id+k.hash(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const u=this._key(f),m=this._cache.get(u);return this._clamp(m==null?void 0:m.value)}update(f,u){const m=this._key(f);let w=this._cache.get(m);return w||(w=new P.MovingAverage,this._cache.set(m,w)),w.update(u),this.get(f)}}e.LanguageFeatureRequestDelays=S}),define(ge[82],pe([0,1,2,44,177,142,57]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class I{constructor(E,b){this.language=E,this.id=b}}e.LanguageIdentifier=I;var n;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var C;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(C=e.ColorId||(e.ColorId={}));var S;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(S=e.StandardTokenType||(e.StandardTokenType={}));var v;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(v=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let b=this.getForeground(E),L="mtk"+b,A=this.getFontStyle(E);return A&1&&(L+=" mtki"),A&2&&(L+=" mtkb"),A&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(E,b){const L=this.getForeground(E),A=this.getFontStyle(E);let N=`color: ${b[L]};`;return A&1&&(N+="font-style: italic;"),A&2&&(N+="font-weight: bold;"),A&4&&(N+="text-decoration: underline;"),N}}e.TokenMetadata=f;var u;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(E){const b=g[E];let L=b&&P.iconRegistry.get(b);return L||(console.info("No codicon found for CompletionItemKind "+E),L=P.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(E,b){let L=g[E];return typeof L=="undefined"&&!b&&(L=9),L}}();var m;(function(g){g[g.Deprecated=1]="Deprecated"})(m=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var d;(function(g){g[g.Auto=1]="Auto",g[g.Manual=2]="Manual"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var a;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(a=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function c(g){return g&&_.URI.isUri(g.uri)&&k.Range.isIRange(g.range)&&(k.Range.isIRange(g.originSelectionRange)||k.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=c;var t;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(g){g[g.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var o;(function(g){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const b=new Map;b.set(0,"file"),b.set(1,"module"),b.set(2,"namespace"),b.set(3,"package"),b.set(4,"class"),b.set(5,"method"),b.set(6,"property"),b.set(7,"field"),b.set(8,"constructor"),b.set(9,"enum"),b.set(10,"interface"),b.set(11,"function"),b.set(12,"variable"),b.set(13,"constant"),b.set(14,"string"),b.set(15,"number"),b.set(16,"boolean"),b.set(17,"array"),b.set(18,"object"),b.set(19,"key"),b.set(20,"null"),b.set(21,"enum-member"),b.set(22,"struct"),b.set(23,"event"),b.set(24,"operator"),b.set(25,"type-parameter");function L(W){return E.get(W)}g.fromString=L;function A(W){return b.get(W)}g.toString=A;function N(W,x){const M=b.get(W);let $=M&&P.iconRegistry.get("symbol-"+M);return $||(console.info("No codicon found for SymbolKind "+W),$=P.Codicon.symbolProperty),`${x?"inline":"block"} ${$.classNames}`}g.toCssClassName=N})(o=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(E){this.value=E}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var i;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(i=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={})),e.ReferenceProviderRegistry=new R.LanguageFeatureRegistry,e.RenameProviderRegistry=new R.LanguageFeatureRegistry,e.CompletionProviderRegistry=new R.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new R.LanguageFeatureRegistry,e.HoverProviderRegistry=new R.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new R.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new R.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new R.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new R.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new R.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.LinkProviderRegistry=new R.LanguageFeatureRegistry,e.ColorProviderRegistry=new R.LanguageFeatureRegistry,e.SelectionRangeRegistry=new R.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var y;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[178],pe([0,1,5,16,4,3,73,72]),function(Z,e,_,k,R,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=R.createDecorator("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(I,n){if(!I)throw new Error("invalid command");if(typeof I=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:I,handler:n})}if(I.description){const u=[];for(let w of I.description.args)u.push(w.constraint);const m=I.handler;I.handler=function(w,...p){return k.validateConstraints(p,u),m(w,...p)}}const{id:C}=I;let S=this._commands.get(C);S||(S=new P.LinkedList,this._commands.set(C,S));let v=S.unshift(I),f=_.toDisposable(()=>{v();const u=this._commands.get(C);(u==null?void 0:u.isEmpty())&&this._commands.delete(C)});return this._onDidRegisterCommand.fire(C),f}registerCommandAlias(I,n){return e.CommandsRegistry.registerCommand(I,(C,...S)=>C.get(e.ICommandService).executeCommand(n,...S))}getCommand(I){const n=this._commands.get(I);if(!(!n||n.isEmpty()))return D.Iterable.first(n)}getCommands(){const I=new Map;for(const n of this._commands.keys()){const C=this.getCommand(n);C&&I.set(n,C)}return I}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ge[60],pe([0,1,10,4,9]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=R.userAgent||"";const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",R.isMacintosh),P.set("isLinux",R.isLinux),P.set("isWindows",R.isWindows),P.set("isWeb",R.isWeb),P.set("isMacNative",R.isMacintosh&&!R.isWeb),P.set("isEdge",T.indexOf("Edg/")>=0),P.set("isFirefox",T.indexOf("Firefox")>=0),P.set("isChrome",T.indexOf("Chrome")>=0),P.set("isSafari",T.indexOf("Safari")>=0),P.set("isIPad",T.indexOf("iPad")>=0);const D=Object.prototype.hasOwnProperty;var I;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return S.INSTANCE}static true(){return v.INSTANCE}static has(b){return f.create(b)}static equals(b,L){return u.create(b,L)}static notEquals(b,L){return p.create(b,L)}static regex(b,L){return r.create(b,L)}static in(b,L){return m.create(b,L)}static not(b){return d.create(b)}static and(...b){return l.create(b)}static or(...b){return i.create(b)}static greater(b,L){return s.create(b,L)}static less(b,L){return c.create(b,L)}static deserialize(b,L=!1){if(!!b)return this._deserializeOrExpression(b,L)}static _deserializeOrExpression(b,L){let A=b.split("||");return i.create(A.map(N=>this._deserializeAndExpression(N,L)))}static _deserializeAndExpression(b,L){let A=b.split("&&");return l.create(A.map(N=>this._deserializeOne(N,L)))}static _deserializeOne(b,L){if(b=b.trim(),b.indexOf("!=")>=0){let A=b.split("!=");return p.create(A[0].trim(),this._deserializeValue(A[1],L))}if(b.indexOf("==")>=0){let A=b.split("==");return u.create(A[0].trim(),this._deserializeValue(A[1],L))}if(b.indexOf("=~")>=0){let A=b.split("=~");return r.create(A[0].trim(),this._deserializeRegexValue(A[1],L))}if(b.indexOf(" in ")>=0){let A=b.split(" in ");return m.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(b)){const A=b.split(">=");return a.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(b)){const A=b.split(">");return s.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(b)){const A=b.split("<=");return t.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(b)){const A=b.split("<");return c.create(A[0].trim(),A[1].trim())}return/^\!\s*/.test(b)?d.create(b.substr(1).trim()):f.create(b)}static _deserializeValue(b,L){if(b=b.trim(),b==="true")return!0;if(b==="false")return!1;let A=/^'([^']*)'$/.exec(b);return A?A[1].trim():b}static _deserializeRegexValue(b,L){if(_.isFalsyOrWhitespace(b)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let A=b.indexOf("/"),N=b.lastIndexOf("/");if(A===N||A<0){if(L)throw new Error(`bad regexp-value '${b}', missing /-enclosure`);return console.warn(`bad regexp-value '${b}', missing /-enclosure`),null}let W=b.slice(A+1,N),x=b[N+1]==="i"?"i":"";try{return new RegExp(W,x)}catch(M){if(L)throw new Error(`bad regexp-value '${b}', parse error: ${M}`);return console.warn(`bad regexp-value '${b}', parse error: ${M}`),null}}}e.ContextKeyExpr=n;function C(E,b){return E.cmp(b)}class S{constructor(){this.type=0}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=S,S.INSTANCE=new S;class v{constructor(){this.type=1}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class f{constructor(b){this.key=b,this.type=2}static create(b){const L=P.get(b);return typeof L=="boolean"?L?v.INSTANCE:S.INSTANCE:new f(b)}cmp(b){return b.type!==this.type?this.type-b.type:y(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return d.create(this.key)}}e.ContextKeyDefinedExpr=f;class u{constructor(b,L){this.key=b,this.value=L,this.type=4}static create(b,L){if(typeof L=="boolean")return L?f.create(b):d.create(b);const A=P.get(b);return typeof A=="boolean"?L===(A?"true":"false")?v.INSTANCE:S.INSTANCE:new u(b,L)}cmp(b){return b.type!==this.type?this.type-b.type:g(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(b){return b.mapEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class m{constructor(b,L){this.key=b,this.valueKey=L,this.type=10}static create(b,L){return new m(b,L)}cmp(b){return b.type!==this.type?this.type-b.type:g(this.key,this.valueKey,b.key,b.valueKey)}equals(b){return b.type===this.type?this.key===b.key&&this.valueKey===b.valueKey:!1}evaluate(b){const L=b.getValue(this.valueKey),A=b.getValue(this.key);return Array.isArray(L)?L.indexOf(A)>=0:typeof A=="string"&&typeof L=="object"&&L!==null?D.call(L,A):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(b){return b.mapIn(this.key,this.valueKey)}negate(){return w.create(this)}}e.ContextKeyInExpr=m;class w{constructor(b){this._actual=b,this.type=11}static create(b){return new w(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new w(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class p{constructor(b,L){this.key=b,this.value=L,this.type=5}static create(b,L){if(typeof L=="boolean")return L?d.create(b):f.create(b);const A=P.get(b);return typeof A=="boolean"?L===(A?"true":"false")?S.INSTANCE:v.INSTANCE:new p(b,L)}cmp(b){return b.type!==this.type?this.type-b.type:g(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(b){return b.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=p;class d{constructor(b){this.key=b,this.type=3}static create(b){const L=P.get(b);return typeof L=="boolean"?L?S.INSTANCE:v.INSTANCE:new d(b)}cmp(b){return b.type!==this.type?this.type-b.type:y(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!b.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(b){return b.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=d;class s{constructor(b,L){this.key=b,this.value=L,this.type=12}static create(b,L){return new s(b,L)}cmp(b){return b.type!==this.type?this.type-b.type:g(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=s;class a{constructor(b,L){this.key=b,this.value=L,this.type=13}static create(b,L){return new a(b,L)}cmp(b){return b.type!==this.type?this.type-b.type:g(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreaterEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=a;class c{constructor(b,L){this.key=b,this.value=L,this.type=14}static create(b,L){return new c(b,L)}cmp(b){return b.type!==this.type?this.type-b.type:g(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmaller(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerExpr=c;class t{constructor(b,L){this.key=b,this.value=L,this.type=15}static create(b,L){return new t(b,L)}cmp(b){return b.type!==this.type?this.type-b.type:g(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmallerEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(b,L){this.key=b,this.regexp=L,this.type=7}static create(b,L){return new r(b,L)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.key<b.key)return-1;if(this.key>b.key)return 1;const L=this.regexp?this.regexp.source:"",A=b.regexp?b.regexp.source:"";return L<A?-1:L>A?1:0}equals(b){if(b.type===this.type){const L=this.regexp?this.regexp.source:"",A=b.regexp?b.regexp.source:"";return this.key===b.key&&L===A}return!1}evaluate(b){let L=b.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const b=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${b}`}keys(){return[this.key]}map(b){return b.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=r;class o{constructor(b){this._actual=b,this.type=8}static create(b){return new o(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new o(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class l{constructor(b){this.expr=b,this.type=6}static create(b){return l._normalizeArr(b)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let L=0,A=this.expr.length;L<A;L++){const N=C(this.expr[L],b.expr[L]);if(N!==0)return N}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let L=0,A=this.expr.length;L<A;L++)if(!this.expr[L].equals(b.expr[L]))return!1;return!0}return!1}evaluate(b){for(let L=0,A=this.expr.length;L<A;L++)if(!this.expr[L].evaluate(b))return!1;return!0}static _normalizeArr(b){const L=[];let A=!1;for(const N of b)if(!!N){if(N.type===1){A=!0;continue}if(N.type===0)return S.INSTANCE;if(N.type===6){L.push(...N.expr);continue}L.push(N)}if(L.length===0&&A)return v.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];for(L.sort(C);L.length>1;){const N=L[L.length-1];if(N.type!==9)break;L.pop();const W=L.pop(),x=i.create(N.expr.map(M=>l.create([M,W])));x&&(L.push(x),L.sort(C))}return L.length===1?L[0]:new l(L)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(let L of this.expr)b.push(...L.keys());return b}map(b){return new l(this.expr.map(L=>L.map(b)))}negate(){let b=[];for(let L of this.expr)b.push(L.negate());return i.create(b)}}e.ContextKeyAndExpr=l;class i{constructor(b){this.expr=b,this.type=9}static create(b){const L=i._normalizeArr(b);if(L.length!==0)return L.length===1?L[0]:new i(L)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let L=0,A=this.expr.length;L<A;L++){const N=C(this.expr[L],b.expr[L]);if(N!==0)return N}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let L=0,A=this.expr.length;L<A;L++)if(!this.expr[L].equals(b.expr[L]))return!1;return!0}return!1}evaluate(b){for(let L=0,A=this.expr.length;L<A;L++)if(this.expr[L].evaluate(b))return!0;return!1}static _normalizeArr(b){let L=[],A=!1;if(b){for(let N=0,W=b.length;N<W;N++){const x=b[N];if(!!x){if(x.type===0){A=!0;continue}if(x.type===1)return[v.INSTANCE];if(x.type===9){L=L.concat(x.expr);continue}L.push(x)}}if(L.length===0&&A)return[S.INSTANCE];L.sort(C)}return L}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(let L of this.expr)b.push(...L.keys());return b}map(b){return new i(this.expr.map(L=>L.map(b)))}negate(){let b=[];for(let A of this.expr)b.push(A.negate());const L=A=>A.type===9?A.expr:[A];for(;b.length>1;){const A=b.shift(),N=b.shift(),W=[];for(const x of L(A))for(const M of L(N))W.push(n.and(x,M));b.unshift(n.or(...W))}return b[0]}}e.ContextKeyOrExpr=i;class h extends f{constructor(b,L){super(b);this._defaultValue=L}bindTo(b){return b.createKey(this.key,this._defaultValue)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(b){return n.equals(this.key,b)}notEqualsTo(b){return n.notEquals(this.key,b)}}e.RawContextKey=h,e.IContextKeyService=k.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(E,b){return E<b?-1:E>b?1:0}function g(E,b,L,A){return E<L?-1:E>L?1:b<A?-1:b>A?1:0}}),define(ge[179],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=_.createDecorator("environmentService"),e.INativeEnvironmentService=_.createDecorator("nativeEnvironmentService")}),define(ge[180],pe([0,1,152,4,11]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function T(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}e.isIExtensionIdentifier=T;var P;(function(S){S[S.NoneOrRelevance=0]="NoneOrRelevance",S[S.LastUpdatedDate=1]="LastUpdatedDate",S[S.Title=2]="Title",S[S.PublisherName=3]="PublisherName",S[S.InstallCount=4]="InstallCount",S[S.PublishedDate=5]="PublishedDate",S[S.AverageRating=6]="AverageRating",S[S.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var D;(function(S){S[S.Default=0]="Default",S[S.Ascending=1]="Ascending",S[S.Descending=2]="Descending"})(D=e.SortOrder||(e.SortOrder={}));var I;(function(S){S.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var n;(function(S){S[S.None=0]="None",S[S.Install=1]="Install",S[S.Update=2]="Update"})(n=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=k.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class C extends Error{constructor(v,f){super(v);this.code=f}}e.ExtensionManagementError=C,e.IExtensionManagementService=k.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=k.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=k.createDecorator("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",Z).toString(!0),e.ExtensionsLabel=_.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=_.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=k.createDecorator("IExtensionManagementCLIService")}),define(ge[29],pe([0,1,10,4]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function R(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Themes","Testing","Visualization","Other"];var T;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class P{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,S){if(typeof C=="undefined"||C===null)return typeof S=="undefined"||S===null;if(typeof S=="undefined"||S===null)return!1;if(typeof C=="string"||typeof S=="string"){let v=typeof C=="string"?C:C.value,f=typeof S=="string"?S:S.value;return _.equalsIgnoreCase(v,f)}return C._lower===S._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=P;function D(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function I(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=k.createDecorator("IBuiltinExtensionsScannerService")}),define(ge[181],pe([0,1,10,29]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(f,u){return f.uuid&&u.uuid?f.uuid===u.uuid:f.id===u.id?!0:_.compareIgnoreCase(f.id,u.id)===0}e.areSameExtensions=R;class T{constructor(u,m){this.version=m,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof T?R(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=T;function P(f,u){return`${f}.${u}`}e.getExtensionId=P;function D(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function I(f,u){return D(P(f,u))}e.getGalleryExtensionId=I;function n(f,u){const m=[],w=p=>{for(const d of m)if(d.some(s=>R(u(s),u(p))))return d;return null};for(const p of f){const d=w(p);d?d.push(p):m.push([p])}return m}e.groupByExtension=n;function C(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=C;function S(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function v(f){const u=new Set;for(const m of f)m.malicious&&u.add(m.id.id);return u}e.getMaliciousExtensionsSet=v}),define(ge[50],pe([0,1,153,7,2,4,10,16,22]),function(Z,e,_,k,R,T,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=T.createDecorator("fileService");var n;(function(A){A[A.Unknown=0]="Unknown",A[A.File=1]="File",A[A.Directory=2]="Directory",A[A.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var C;(function(A){A[A.FileReadWrite=2]="FileReadWrite",A[A.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",A[A.FileReadStream=16]="FileReadStream",A[A.FileFolderCopy=8]="FileFolderCopy",A[A.PathCaseSensitive=1024]="PathCaseSensitive",A[A.Readonly=2048]="Readonly",A[A.Trash=4096]="Trash"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(A){return!!(A.capabilities&2)}e.hasReadWriteCapability=S;function v(A){return!!(A.capabilities&8)}e.hasFileFolderCopyCapability=v;function f(A){return!!(A.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function u(A){return!!(A.capabilities&16)}e.hasFileReadStreamCapability=u;var m;(function(A){A.FileExists="EntryExists",A.FileNotFound="EntryNotFound",A.FileNotADirectory="EntryNotADirectory",A.FileIsADirectory="EntryIsADirectory",A.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",A.FileTooLarge="EntryTooLarge",A.NoPermissions="NoPermissions",A.Unavailable="Unavailable",A.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(N,W){super(N);this.code=W}}e.FileSystemProviderError=w;function p(A,N){const W=new w(A.toString(),N);return s(W,N),W}e.createFileSystemProviderError=p;function d(A){return A||p(_.localize(0,null),m.Unknown)}e.ensureFileSystemProviderError=d;function s(A,N){return A.name=N?`${N} (FileSystemError)`:"FileSystemError",A}e.markAsFileSystemProviderError=s;function a(A){if(!A)return m.Unknown;if(A instanceof w)return A.code;const N=/^(.+) \(FileSystemError\)$/.exec(A.name);if(!N)return m.Unknown;switch(N[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=a;function c(A){if(A instanceof h)return A.fileOperationResult;switch(a(A)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var t;(function(A){A[A.CREATE=0]="CREATE",A[A.DELETE=1]="DELETE",A[A.MOVE=2]="MOVE",A[A.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class r{constructor(N,W,x){this.resource=N,this.operation=W,this.target=x}isOperation(N){return this.operation===N}}e.FileOperationEvent=r;var o;(function(A){A[A.UPDATED=0]="UPDATED",A[A.ADDED=1]="ADDED",A[A.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(N,W){this.ignorePathCasing=W,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=N;for(const x of N)switch(x.type){case 1:this.added||(this.added=I.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(x.resource,x);break;case 0:this.updated||(this.updated=I.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(x.resource,x);break;case 2:this.deleted||(this.deleted=I.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(x.resource,x);break}}contains(N,...W){return this.doContains(N,{includeChildren:!1},...W)}affects(N,...W){return this.doContains(N,{includeChildren:!0},...W)}doContains(N,W,...x){var M,$,O,B,J,U;if(!N)return!1;const V=x.length>0;return!!((!V||x.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get(N))||W.includeChildren&&(($=this.added)===null||$===void 0?void 0:$.findSuperstr(N)))||(!V||x.includes(0))&&(((O=this.updated)===null||O===void 0?void 0:O.get(N))||W.includeChildren&&((B=this.updated)===null||B===void 0?void 0:B.findSuperstr(N)))||(!V||x.includes(2))&&(((J=this.deleted)===null||J===void 0?void 0:J.findSubstr(N))||W.includeChildren&&((U=this.deleted)===null||U===void 0?void 0:U.findSuperstr(N))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(N){const W=[],x=N===1?this.added:N===0?this.updated:this.deleted;if(x)for(const[,M]of x)W.push(M);return W}filter(N){return new l(this.changes.filter(W=>N(W)),this.ignorePathCasing)}}e.FileChangesEvent=l;function i(A,N,W){return!A||!N||A===N||N.length>A.length?!1:(N.charAt(N.length-1)!==k.sep&&(N+=k.sep),W?P.startsWithIgnoreCase(A,N):A.indexOf(N)===0)}e.isParent=i;class h extends Error{constructor(N,W,x){super(N);this.fileOperationResult=W,this.options=x}static isFileOperationError(N){return N instanceof Error&&!D.isUndefinedOrNull(N.fileOperationResult)}}e.FileOperationError=h;var y;(function(A){A[A.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",A[A.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",A[A.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",A[A.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",A[A.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",A[A.FILE_READ_ONLY=5]="FILE_READ_ONLY",A[A.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",A[A.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",A[A.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",A[A.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",A[A.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",A[A.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var g;(function(A){A[A.FILE=0]="FILE",A[A.FOLDER=1]="FOLDER",A[A.ROOT_FOLDER=2]="ROOT_FOLDER"})(g=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function E(A){if(!(typeof A.size!="number"||typeof A.mtime!="number"))return A.mtime.toString(29)+A.size.toString(31)}e.etag=E;async function b(A,N){if(!N.canHandleResource(R.URI.from({scheme:A.scheme})))return new Promise(W=>{const x=N.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===A.scheme&&M.added&&(x.dispose(),W())})})}e.whenProviderRegistered=b,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(N){return D.isNumber(N)||(N=0),N<L.KB?_.localize(1,null,N.toFixed(0)):N<L.MB?_.localize(2,null,(N/L.KB).toFixed(2)):N<L.GB?_.localize(3,null,(N/L.MB).toFixed(2)):N<L.TB?_.localize(4,null,(N/L.GB).toFixed(2)):_.localize(5,null,(N/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB}),define(ge[83],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...R){this._entries=new Map;for(let[T,P]of R)this.set(T,P)}set(R,T){const P=this._entries.get(R);return this._entries.set(R,T),P}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=_}),define(ge[182],pe([0,1,15,175,109,4,83,19]),function(Z,e,_,k,R,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const I=!1;class n extends Error{constructor(u){super("cyclic dependency between services");this.message=u.toString()}}class C{constructor(u=new P.ServiceCollection,m=!1,w){this._activeInstantiations=new Set,this._services=u,this._strict=m,this._parent=w,this._services.set(T.IInstantiationService,this)}createChild(u){return new C(u,this._strict,this)}invokeFunction(u,...m){let w=v.traceInvocation(u),p=!1;try{return u({get:(s,a)=>{if(p)throw _.illegalState("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(s,w);if(!c&&a!==T.optional)throw new Error(`[invokeFunction] unknown service '${s}'`);return c}},...m)}finally{p=!0,w.stop()}}createInstance(u,...m){let w,p;return u instanceof R.SyncDescriptor?(w=v.traceCreation(u.ctor),p=this._createInstance(u.ctor,u.staticArguments.concat(m),w)):(w=v.traceCreation(u),p=this._createInstance(u,m,w)),w.stop(),p}_createInstance(u,m=[],w){let p=T._util.getServiceDependencies(u).sort((a,c)=>a.index-c.index),d=[];for(const a of p){let c=this._getOrCreateServiceInstance(a.id,w);if(!c&&this._strict&&!a.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${a.id}.`);d.push(c)}let s=p.length>0?p[0].index:m.length;if(m.length!==s){console.warn(`[createInstance] First service dependency of ${u.name} at position ${s+1} conflicts with ${m.length} static arguments`);let a=s-m.length;a>0?m=m.concat(new Array(a)):m=m.slice(0,s)}return new u(...[...m,...d])}_setServiceInstance(u,m){if(this._services.get(u)instanceof R.SyncDescriptor)this._services.set(u,m);else if(this._parent)this._parent._setServiceInstance(u,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let m=this._services.get(u);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):m}_getOrCreateServiceInstance(u,m){let w=this._getServiceInstanceOrDescriptor(u);return w instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,w,m.branch(u,!0)):(m.branch(u,!1),w)}_safeCreateAndCacheServiceInstance(u,m,w){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,m,w)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,m,w){const p=new k.Graph(a=>a.id.toString());let d=0;const s=[{id:u,desc:m,_trace:w}];for(;s.length;){const a=s.pop();if(p.lookupOrInsertNode(a),d++>1e3)throw new n(p);for(let c of T._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${u} depends on ${c.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:c.id,desc:t,_trace:a._trace.branch(c.id,!0)};p.insertEdge(a,r),s.push(r)}}}for(;;){const a=p.roots();if(a.length===0){if(!p.isEmpty())throw new n(p);break}for(const{data:c}of a){if(this._getServiceInstanceOrDescriptor(c.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,r)}p.removeNode(c)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,m,w=[],p,d){if(this._services.get(u)instanceof R.SyncDescriptor)return this._createServiceInstance(m,w,p,d);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,m,w,p,d);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(u,m=[],w,p){if(w){const d=new D.IdleValue(()=>this._createInstance(u,m,p));return new Proxy(Object.create(null),{get(s,a){if(a in s)return s[a];let c=d.value,t=c[a];return typeof t!="function"||(t=t.bind(c),s[a]=t),t},set(s,a,c){return d.value[a]=c,!0}})}else return this._createInstance(u,m,p)}}e.InstantiationService=C;var S;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(S||(S={}));class v{constructor(u,m){this.type=u,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return I?new v(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(u){return I?new v(0,u.name):v._None}branch(u,m){let w=new v(2,u.toString());return this._dep.push([u,m,w]),w}stop(){let u=Date.now()-this._start;v._totals+=u;let m=!1;function w(d,s){let a=[],c=new Array(d+1).join("	");for(const[t,r,o]of s._dep)if(r&&o){m=!0,a.push(`${c}CREATES -> ${t}`);let l=w(d+1,o);l&&a.push(l)}else a.push(`${c}uses -> ${t}`);return a.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(u>2||m)&&console.log(p.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(ge[12],pe([0,1,4,5,9,3,49]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.DelegatedLogService=e.MultiplexLogService=e.ConsoleLogInMainService=e.LogServiceAdapter=e.ConsoleLogService=e.ConsoleLogMainService=e.AbstractLogService=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=_.createDecorator("logService"),e.ILoggerService=_.createDecorator("loggerService");function D(){return new Date().toISOString()}var I;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(I=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=I.Info;class n extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(c){this.level!==c&&(this.level=c,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogService=n;class C extends n{constructor(c=e.DEFAULT_LOG_LEVEL){super();this.setLevel(c),this.useColors=!R.isWindows}trace(c,...t){this.getLevel()<=I.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,c,...t):console.log(`[main ${D()}]`,c,...t))}debug(c,...t){this.getLevel()<=I.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,c,...t):console.log(`[main ${D()}]`,c,...t))}info(c,...t){this.getLevel()<=I.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,c,...t):console.log(`[main ${D()}]`,c,...t))}warn(c,...t){this.getLevel()<=I.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,c,...t):console.warn(`[main ${D()}]`,c,...t))}error(c,...t){this.getLevel()<=I.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,c,...t):console.error(`[main ${D()}]`,c,...t))}critical(c,...t){this.getLevel()<=I.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,c,...t):console.error(`[main ${D()}]`,c,...t))}dispose(){}flush(){}}e.ConsoleLogMainService=C;class S extends n{constructor(c=e.DEFAULT_LOG_LEVEL){super();this.setLevel(c)}trace(c,...t){this.getLevel()<=I.Trace&&console.log("%cTRACE","color: #888",c,...t)}debug(c,...t){this.getLevel()<=I.Debug&&console.log("%cDEBUG","background: #eee; color: #888",c,...t)}info(c,...t){this.getLevel()<=I.Info&&console.log("%c INFO","color: #33f",c,...t)}warn(c,...t){this.getLevel()<=I.Warning&&console.log("%c WARN","color: #993",c,...t)}error(c,...t){this.getLevel()<=I.Error&&console.log("%c  ERR","color: #f33",c,...t)}critical(c,...t){this.getLevel()<=I.Critical&&console.log("%cCRITI","background: #f33; color: white",c,...t)}dispose(){}flush(){}}e.ConsoleLogService=S;class v extends n{constructor(c,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=c,this.setLevel(t)}trace(c,...t){this.getLevel()<=I.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(c),...t])}debug(c,...t){this.getLevel()<=I.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(c),...t])}info(c,...t){this.getLevel()<=I.Info&&this.adapter.consoleLog("info",[this.extractMessage(c),...t])}warn(c,...t){this.getLevel()<=I.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(c),...t])}error(c,...t){this.getLevel()<=I.Error&&this.adapter.consoleLog("error",[this.extractMessage(c),...t])}critical(c,...t){this.getLevel()<=I.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(c),...t])}extractMessage(c){return typeof c=="string"?c:P.toErrorMessage(c,this.getLevel()<=I.Trace)}dispose(){}flush(){}}e.LogServiceAdapter=v;class f extends v{constructor(c,t=e.DEFAULT_LOG_LEVEL){super({consoleLog:(r,o)=>c.consoleLog(r,o)},t)}}e.ConsoleLogInMainService=f;class u extends n{constructor(c){super();this.logServices=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const t of this.logServices)t.setLevel(c);super.setLevel(c)}trace(c,...t){for(const r of this.logServices)r.trace(c,...t)}debug(c,...t){for(const r of this.logServices)r.debug(c,...t)}info(c,...t){for(const r of this.logServices)r.info(c,...t)}warn(c,...t){for(const r of this.logServices)r.warn(c,...t)}error(c,...t){for(const r of this.logServices)r.error(c,...t)}critical(c,...t){for(const r of this.logServices)r.critical(c,...t)}flush(){for(const c of this.logServices)c.flush()}dispose(){for(const c of this.logServices)c.dispose()}}e.MultiplexLogService=u;class m extends k.Disposable{constructor(c){super();this.logService=c,this._register(c)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(c){this.logService.setLevel(c)}getLevel(){return this.logService.getLevel()}trace(c,...t){this.logService.trace(c,...t)}debug(c,...t){this.logService.debug(c,...t)}info(c,...t){this.logService.info(c,...t)}warn(c,...t){this.logService.warn(c,...t)}error(c,...t){this.logService.error(c,...t)}critical(c,...t){this.logService.critical(c,...t)}flush(){this.logService.flush()}}e.DelegatedLogService=m;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(c){}getLevel(){return I.Info}trace(c,...t){}debug(c,...t){}info(c,...t){}warn(c,...t){}error(c,...t){}critical(c,...t){}dispose(){}flush(){}}e.NullLogService=w;function p(a){if(a.verbose)return I.Trace;if(typeof a.logLevel=="string"){const c=d(a.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function d(a){switch(a){case"trace":return I.Trace;case"debug":return I.Debug;case"info":return I.Info;case"warn":return I.Warning;case"error":return I.Error;case"critical":return I.Critical;case"off":return I.Off}}e.parseLogLevel=d;function s(a){switch(a){case I.Trace:return"trace";case I.Debug:return"debug";case I.Info:return"info";case I.Warning:return"warn";case I.Error:return"error";case I.Critical:return"critical";case I.Off:return"off"}}e.LogLevelToString=s}),define(ge[110],pe([0,1,7,12,50]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogService=e.createRotatingLogger=void 0;async function T(n,C){try{const S=await new Promise((f,u)=>{Z(["spdlog"],f,u)});S.setAsyncMode(8192,500);const v=_.join(C,`${n}.log`);return S.createRotatingLoggerAsync(n,v,5*R.ByteSize.MB,6)}catch(S){console.error(S)}return null}function P(n,C,S,v){return Z.__$__nodeRequire("spdlog").createRotatingLogger(n,C,S,v)}e.createRotatingLogger=P;function D(n,C,S){switch(C){case k.LogLevel.Trace:n.trace(S);break;case k.LogLevel.Debug:n.debug(S);break;case k.LogLevel.Info:n.info(S);break;case k.LogLevel.Warning:n.warn(S);break;case k.LogLevel.Error:n.error(S);break;case k.LogLevel.Critical:n.critical(S);break;default:throw new Error("Invalid log level")}}class I extends k.AbstractLogService{constructor(C,S,v){super();this.name=C,this.logsFolder=S,this.buffer=[],this._loggerCreationPromise=void 0,this.setLevel(v),this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){return this._loggerCreationPromise||(this._loggerCreationPromise=T(this.name,this.logsFolder).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:S,message:v}of this.buffer)D(this._logger,S,v);this.buffer=[]}})),this._loggerCreationPromise}_log(C,S){this._logger?D(this._logger,C,S):this.getLevel()<=C&&this.buffer.push({level:C,message:S})}trace(C,...S){this.getLevel()<=k.LogLevel.Trace&&this._log(k.LogLevel.Trace,this.format([C,...S]))}debug(C,...S){this.getLevel()<=k.LogLevel.Debug&&this._log(k.LogLevel.Debug,this.format([C,...S]))}info(C,...S){this.getLevel()<=k.LogLevel.Info&&this._log(k.LogLevel.Info,this.format([C,...S]))}warn(C,...S){this.getLevel()<=k.LogLevel.Warning&&this._log(k.LogLevel.Warning,this.format([C,...S]))}error(C,...S){if(this.getLevel()<=k.LogLevel.Error)if(C instanceof Error){const v=Array.prototype.slice.call(arguments);v[0]=C.stack,this._log(k.LogLevel.Error,this.format(v))}else this._log(k.LogLevel.Error,this.format([C,...S]))}critical(C,...S){this.getLevel()<=k.LogLevel.Critical&&this._log(k.LogLevel.Critical,this.format([C,...S]))}flush(){this._logger?this._logger.flush():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.disposeLogger()),this._loggerCreationPromise=void 0}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}format(C){let S="";for(let v=0;v<C.length;v++){let f=C[v];if(typeof f=="object")try{f=JSON.stringify(f)}catch(u){}S+=(v>0?" ":"")+f}return S}}e.SpdLogService=I}),define(ge[111],pe([0,1,4,154,76]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(I){I[I.Unnecessary=1]="Unnecessary",I[I.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var P;(function(I){I[I.Hint=1]="Hint",I[I.Info=2]="Info",I[I.Warning=4]="Warning",I[I.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(I){function n(u,m){return m-u}I.compare=n;const C=Object.create(null);C[I.Error]=k.localize(0,null),C[I.Warning]=k.localize(1,null),C[I.Info]=k.localize(2,null);function S(u){return C[u]||""}I.toString=S;function v(u){switch(u){case R.default.Error:return I.Error;case R.default.Warning:return I.Warning;case R.default.Info:return I.Info;case R.default.Ignore:return I.Hint}}I.fromSeverity=v;function f(u){switch(u){case I.Error:return R.default.Error;case I.Warning:return R.default.Warning;case I.Info:return R.default.Info;case I.Hint:return R.default.Ignore}}I.toSeverity=f}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(I){const n="";function C(v){return S(v,!0)}I.makeKey=C;function S(v,f){let u=[n];return v.source?u.push(v.source.replace("\xA6","\\\xA6")):u.push(n),v.code?typeof v.code=="string"?u.push(v.code.replace("\xA6","\\\xA6")):u.push(v.code.value.replace("\xA6","\\\xA6")):u.push(n),v.severity!==void 0&&v.severity!==null?u.push(P.toString(v.severity)):u.push(n),v.message&&f?u.push(v.message.replace("\xA6","\\\xA6")):u.push(n),v.startLineNumber!==void 0&&v.startLineNumber!==null?u.push(v.startLineNumber.toString()):u.push(n),v.startColumn!==void 0&&v.startColumn!==null?u.push(v.startColumn.toString()):u.push(n),v.endLineNumber!==void 0&&v.endLineNumber!==null?u.push(v.endLineNumber.toString()):u.push(n),v.endColumn!==void 0&&v.endColumn!==null?u.push(v.endColumn.toString()):u.push(n),u.push(n),u.join("\xA6")}I.makeKeyOptionalMessage=S})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=_.createDecorator("markerService")}),define(ge[183],pe([0,1,76,4,3]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=k.createDecorator("notificationService");var T;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new I,this.onDidClose=R.Event.None,this.onDidChangeVisibility=R.Event.None}updateSeverity(C){}updateMessage(C){}updateActions(C){}close(){}}e.NoOpNotification=D;class I{infinite(){}done(){}total(C){}worked(C){}}e.NoOpProgress=I}),define(ge[184],pe([0,1,9,38,11,23]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(_.isWeb||typeof Z=="undefined"||typeof Z.__$__nodeRequire!="function"){P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.53.0-dev",nameShort:_.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:_.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/master/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});const D=document.getElementById("vscode-remote-product-configuration"),I=D&&D.getAttribute("data-settings");I&&Object.assign(P,JSON.parse(I))}else{const D=T.dirname(R.FileAccess.asFileUri("",Z));P=Z.__$__nodeRequire(T.joinPath(D,"product.json").fsPath);const I=Z.__$__nodeRequire(T.joinPath(D,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:I.version})}e.default=P}),define(ge[185],pe([0,1,4,21,5]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=_.createDecorator("progressService");var T;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(n){this.callback=n}get value(){return this._value}report(n){this._value=n,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});class D extends R.Disposable{constructor(n){super();this.progressIndicator=n,this.currentOperationId=0,this.currentOperationDisposables=this._register(new R.DisposableStore)}start(n){this.stop();const C=++this.currentOperationId,S=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{C===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},n),this.currentOperationDisposables.add(R.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(R.toDisposable(()=>S.cancel())),this.currentOperationDisposables.add(R.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:C,token:S.token,stop:()=>this.doStop(C),isCurrent:()=>this.currentOperationId===C}}stop(){this.doStop(this.currentOperationId)}doStop(n){this.currentOperationId===n&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=_.createDecorator("editorProgressService")}),define(ge[41],pe([0,1,16,53]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(P,D){k.ok(_.isString(P)),k.ok(_.isObject(D)),k.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,D)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new R}),define(ge[112],pe([0,1,41,3]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class T{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,n){this.schemasById[R(I)]=n,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new T;_.Registry.add(e.Extensions.JSONContribution,P)}),define(ge[84],pe([0,1,151,3,41,16,112]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const I=R.Registry.as(P.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,d=!0){this.registerConfigurations([p],d)}registerConfigurations(p,d=!0){const s=[];p.forEach(a=>{s.push(...this.validateAndRegisterProperties(a,d)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(p){const d=[],s=a=>{if(a.properties)for(const c in a.properties)d.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,a.properties[c]);a.allOf&&a.allOf.forEach(c=>s(c))};for(const a of p){s(a);const c=this.configurationContributors.indexOf(a);c!==-1&&this.configurationContributors.splice(c,1)}I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}registerDefaultConfigurations(p){const d=[],s=[];for(const a of p)for(const c in a)if(d.push(c),e.OVERRIDE_PROPERTY_PATTERN.test(c)){this.defaultValues[c]=Object.assign(Object.assign({},this.defaultValues[c]||{}),a[c]);const t={type:"object",default:this.defaultValues[c],description:_.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId};s.push(S(c)),this.configurationProperties[c]=t,this.defaultLanguageConfigurationOverridesNode.properties[c]=t}else{this.defaultValues[c]=a[c];const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(p){const d=[];for(const s of p)for(const a in s)if(d.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const c=this.configurationProperties[a];c&&(this.updatePropertyDefaultValue(a,c),this.updateSchema(a,c))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const d of p)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,d=!0,s=3){s=T.isUndefinedOrNull(p.scope)?s:p.scope;let a=[],c=p.properties;if(c)for(let r in c){if(d&&u(r)){delete c[r];continue}const o=c[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:o.scope=T.isUndefinedOrNull(o.scope)?s:o.scope,c[r].hasOwnProperty("included")&&!c[r].included){this.excludedConfigurationProperties[r]=c[r],delete c[r];continue}else this.configurationProperties[r]=c[r];!c[r].deprecationMessage&&c[r].markdownDeprecationMessage&&(c[r].deprecationMessage=c[r].markdownDeprecationMessage),a.push(r)}let t=p.allOf;if(t)for(let r of t)a.push(...this.validateAndRegisterProperties(r,d,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const d=s=>{let a=s.properties;if(a)for(const t in a)this.updateSchema(t,a[t]);let c=s.allOf;c&&c.forEach(d)};d(p)}updateSchema(p,d){switch(e.allSettings.properties[p]=d,d.scope){case 1:e.applicationSettings.properties[p]=d;break;case 2:e.machineSettings.properties[p]=d;break;case 6:e.machineOverridableSettings.properties[p]=d;break;case 3:e.windowSettings.properties[p]=d;break;case 4:e.resourceSettings.properties[p]=d;break;case 5:e.resourceSettings.properties[p]=d,this.resourceLanguageSettingsSchema.properties[p]=d;break}}removeFromSchema(p,d){switch(delete e.allSettings.properties[p],d.scope){case 1:delete e.applicationSettings.properties[p];break;case 2:delete e.machineSettings.properties[p];break;case 6:delete e.machineOverridableSettings.properties[p];break;case 3:delete e.windowSettings.properties[p];break;case 4:case 5:delete e.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const d=`[${p}]`,s={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,s),e.allSettings.properties[d]=s,e.applicationSettings.properties[d]=s,e.machineSettings.properties[d]=s,e.machineOverridableSettings.properties[d]=s,e.windowSettings.properties[d]=s,e.resourceSettings.properties[d]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,d){let s=this.defaultValues[p];T.isUndefined(s)&&(s=d.default),T.isUndefined(s)&&(s=v(d.type)),d.default=s}}const C="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(C);function S(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=S;function v(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const f=new n;R.Registry.add(e.Extensions.Configuration,f);function u(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?_.localize(5,null,w):f.getConfigurationProperties()[w]!==void 0?_.localize(6,null,w):null:_.localize(4,null)}e.validateProperty=u;function m(){const w=[],p=f.getConfigurationProperties();for(const d of Object.keys(p))w.push([d,p[d].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=m}),define(ge[85],pe([0,1,25,16,2,41,4,84]),function(Z,e,_,k,R,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=P.createDecorator("configurationService");function I(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=I;var n;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function S(r,o){const l=o?r?o.keys.filter(L=>r.keys.indexOf(L)===-1):[...o.keys]:[],i=r?o?r.keys.filter(L=>o.keys.indexOf(L)===-1):[...r.keys]:[],h=[];if(o&&r){for(const L of r.keys)if(o.keys.indexOf(L)!==-1){const A=p(r.contents,L),N=p(o.contents,L);_.equals(A,N)||h.push(L)}}const y=[],g=L=>{const A={};for(const N of L)for(const W of N.identifiers)A[c(W)]=N;return A},E=o?g(o.overrides):{},b=r?g(r.overrides):{};if(Object.keys(E).length)for(const L of l){const A=E[L];A&&y.push([D.overrideIdentifierFromKey(L),A.keys])}if(Object.keys(b).length)for(const L of i){const A=b[L];A&&y.push([D.overrideIdentifierFromKey(L),A.keys])}if(Object.keys(E).length&&Object.keys(b).length)for(const L of h){const A=b[L],N=E[L];if(A&&N){const W=S({contents:A.contents,keys:A.keys,overrides:[]},{contents:N.contents,keys:N.keys,overrides:[]});y.push([D.overrideIdentifierFromKey(L),[...W.added,...W.removed,...W.updated]])}}return{added:l,removed:i,updated:h,overrides:y}}e.compare=S;function v(r,o){const l=[];for(const i of Object.keys(r))if(D.OVERRIDE_PROPERTY_PATTERN.test(i)){const h={};for(const y in r[i])h[y]=r[i][y];l.push({identifiers:[D.overrideIdentifierFromKey(i).trim()],keys:Object.keys(h),contents:f(h,o)})}return l}e.toOverrides=v;function f(r,o){const l=Object.create(null);for(let i in r)u(l,i,r[i],o);return l}e.toValuesTree=f;function u(r,o,l,i){const h=o.split("."),y=h.pop();let g=r;for(let E=0;E<h.length;E++){let b=h[E],L=g[b];switch(typeof L){case"undefined":L=g[b]=Object.create(null);break;case"object":break;default:i(`Ignoring ${o} as ${h.slice(0,E+1).join(".")} is ${JSON.stringify(L)}`);return}g=L}if(typeof g=="object"&&g!==null)try{g[y]=l}catch(E){i(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(g)}`)}else i(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(g)}`)}e.addToValueTree=u;function m(r,o){const l=o.split(".");w(r,l)}e.removeFromValueTree=m;function w(r,o){const l=o.shift();if(o.length===0){delete r[l];return}if(Object.keys(r).indexOf(l)!==-1){const i=r[l];typeof i=="object"&&!Array.isArray(i)&&(w(i,o),Object.keys(i).length===0&&delete r[l])}}function p(r,o,l){function i(g,E){let b=g;for(const L of E){if(typeof b!="object"||b===null)return;b=b[L]}return b}const h=o.split("."),y=i(r,h);return typeof y=="undefined"?l:y}e.getConfigurationValue=p;function d(r,o,l){Object.keys(o).forEach(i=>{i!=="__proto__"&&(i in r?k.isObject(r[i])&&k.isObject(o[i])?d(r[i],o[i],l):l&&(r[i]=o[i]):r[i]=o[i])})}e.merge=d;function s(){const r=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=s;function a(){const r=Object.create(null),o=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let l in o){let i=o[l].default;u(r,l,i,h=>console.error(`Conflict in default settings: ${h}`))}return r}e.getDefaultValues=a;function c(r){return`[${r}]`}e.keyFromOverrideIdentifier=c;function t(r,o,l){const i=r.inspect(o),h=r.inspect(l);return typeof i.userValue!="undefined"||typeof i.workspaceValue!="undefined"||typeof i.workspaceFolderValue!="undefined"?i.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:i.defaultValue}e.getMigratedSettingValue=t}),define(ge[186],pe([0,1,56,22,13,16,25,2,84,85,41,5,3]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},r=[],o=[]){this._contents=t,this._keys=r,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?n.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const o=this.getContentsForOverrideIdentifer(r);return o?t?n.getConfigurationValue(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let o={};for(const l of R.distinct([...Object.keys(this.contents),...Object.keys(r)])){let i=this.contents[l],h=r[l];h&&(typeof i=="object"&&typeof h=="object"?(i=P.deepClone(i),this.mergeContents(i,h)):i=h),o[l]=i}return new f(o,this.keys,this.overrides)}merge(...t){const r=P.deepClone(this.contents),o=P.deepClone(this.overrides),l=[...this.keys];for(const i of t){this.mergeContents(r,i.contents);for(const h of i.overrides){const[y]=o.filter(g=>R.equals(g.identifiers,h.identifiers));y?this.mergeContents(y.contents,h.contents):o.push(P.deepClone(h))}for(const h of i.keys)l.indexOf(h)===-1&&l.push(h)}return new f(r,l,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const o of Object.keys(r)){if(o in t&&T.isObject(t[o])&&T.isObject(r[o])){this.mergeContents(t[o],r[o]);continue}t[o]=P.deepClone(r[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),n.addToValueTree(this.contents,t,r,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&n.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let o=0;o<r;o++)t.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=f;class u extends f{constructor(){const t=n.getDefaultValues(),r=n.getConfigurationKeys(),o=[];for(const l of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(l)&&o.push({identifiers:[I.overrideIdentifierFromKey(l).trim()],keys:Object.keys(t[l]),contents:n.toValuesTree(t[l],i=>console.error(`Conflict in default settings file: ${i}`))});super(t,r,o)}}e.DefaultConfigurationModel=u;class m{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get errors(){return this._parseErrors}parseContent(t){if(!T.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new f(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},o=null,l=[],i=[],h=[];function y(E){Array.isArray(l)?l.push(E):o&&(l[o]=E)}let g={onObjectBegin:()=>{let E={};y(E),i.push(l),l=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{l=i.pop()},onArrayBegin:()=>{let E=[];y(E),i.push(l),l=E,o=null},onArrayEnd:()=>{l=i.pop()},onLiteralValue:y,onError:(E,b,L)=>{h.push({error:E,offset:b,length:L})}};if(t)try{_.visit(t,g),r=l[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(t){if(this._scopes){const i=C.Registry.as(I.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,i,!0,this._scopes)}const r=n.toValuesTree(t,i=>console.error(`Conflict in settings file ${this._name}: ${i}`)),o=Object.keys(t),l=n.toOverrides(t,i=>console.error(`Conflict in settings file ${this._name}: ${i}`));return{contents:r,keys:o,overrides:l}}filterByScope(t,r,o,l){const i={};for(let h in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(h)&&o)i[h]=this.filterByScope(t[h],r,!1,l);else{const y=this.getScope(h,r);(y===void 0||l.indexOf(y)!==-1)&&(i[h]=t[h])}return i}getScope(t,r){const o=r[t];return o?typeof o.scope!="undefined"?o.scope:3:void 0}}e.ConfigurationModelParser=m;class w extends S.Disposable{constructor(t,r,o,l){super();this.userSettingsResource=t,this.scopes=r,this.fileService=l,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(v.Event.filter(this.fileService.onDidFilesChange,i=>i.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new f}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=w;class p{constructor(t,r,o=new f,l=new f,i=new k.ResourceMap,h=new f,y=new k.ResourceMap,g=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=l,this._folderConfigurations=i,this._memoryConfiguration=h,this._memoryConfigurationByResource=y,this._freeze=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,r,o){return this.getConsolidateConfigurationModel(r,o).getValue(t)}updateValue(t,r,o={}){let l;o.resource?(l=this._memoryConfigurationByResource.get(o.resource),l||(l=new f,this._memoryConfigurationByResource.set(o.resource,l))):l=this._memoryConfiguration,r===void 0?l.removeValue(t):l.setValue(t,r),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,o){const l=this.getConsolidateConfigurationModel(r,o),i=this.getFolderConfigurationModelForResource(r.resource,o),h=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,y=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),b=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),L=o?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,A=i?r.overrideIdentifier?i.freeze().override(r.overrideIdentifier).getValue(t):i.freeze().getValue(t):void 0,N=r.overrideIdentifier?h.override(r.overrideIdentifier).getValue(t):h.getValue(t),W=l.getValue(t),x=R.distinct(R.flatten(l.overrides.map(M=>M.identifiers))).filter(M=>l.getOverrideValue(t,M)!==void 0);return{defaultValue:y,userValue:g,userLocalValue:E,userRemoteValue:b,workspaceValue:L,workspaceFolderValue:A,memoryValue:N,value:W,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:g!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:b!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:A!==void 0?{value:i==null?void 0:i.freeze().getValue(t),override:r.overrideIdentifier?i==null?void 0:i.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:N!==void 0?{value:h.getValue(t),override:r.overrideIdentifier?h.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const o=r.filter(l=>I.OVERRIDE_PROPERTY_PATTERN.test(l)).map(l=>{const i=I.overrideIdentifierFromKey(l),h=this._defaultConfiguration.getKeysForOverrideIdentifier(i),y=t.getKeysForOverrideIdentifier(i),g=[...y.filter(E=>h.indexOf(E)===-1),...h.filter(E=>y.indexOf(E)===-1),...h.filter(E=>!P.equals(this._defaultConfiguration.override(i).getValue(E),t.override(i).getValue(E)))];return[i,g]});return this.updateDefaultConfiguration(t),{keys:r,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:o,removed:l,overrides:i}=n.compare(this.localUserConfiguration,t),h=[...r,...o,...l];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:i}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:o,removed:l,overrides:i}=n.compare(this.remoteUserConfiguration,t);let h=[...r,...o,...l];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:i}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:o,removed:l,overrides:i}=n.compare(this.workspaceConfiguration,t);let h=[...r,...o,...l];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:i}}compareAndUpdateFolderConfiguration(t,r){const o=this.folderConfigurations.get(t),{added:l,updated:i,removed:h,overrides:y}=n.compare(o,r);let g=[...l,...i,...h];return(g.length||!o)&&this.updateFolderConfiguration(t,r),{keys:g,overrides:y}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:l,removed:i,overrides:h}=n.compare(r,void 0);return{keys:[...o,...l,...i],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},r){let o=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const l=r.getFolder(t);l&&(o=this.getFolderConsolidatedConfiguration(l.uri)||o);const i=this._memoryConfigurationByResource.get(t);i&&(o=o.merge(i))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const o=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(t);l?(r=o.merge(l),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=o}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const o=r.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:o,overrides:l,keys:i}=this._folderConfigurations.get(r);return t.push([r,{contents:o,overrides:l,keys:i}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(l=>r.add(l))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),l=this.parseConfigurationModel(t.workspace),i=t.folders.reduce((h,y)=>(h.set(D.URI.revive(y[0]),this.parseConfigurationModel(y[1])),h),new k.ResourceMap);return new p(r,o,new f,l,i,new f,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function d(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,r=new Map;for(const l of c)l.keys.forEach(i=>t.add(i)),l.overrides.forEach(([i,h])=>{const y=k.getOrSet(r,i,new Set);h.forEach(g=>y.add(g))});const o=[];return r.forEach((l,i)=>o.push([i,[...l.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=d;class s{constructor(t,r,o,l){this.change=t,this.previous=r,this.currentConfiguraiton=o,this.currentWorkspace=l,this._previousConfiguration=void 0;const i=new Set;t.keys.forEach(y=>i.add(y)),t.overrides.forEach(([,y])=>y.forEach(g=>i.add(g))),this.affectedKeys=[...i.values()];const h=new f;this.affectedKeys.forEach(y=>h.setValue(y,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const l=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!P.equals(l,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let o=n.toValuesTree({[r]:!0},()=>{}),l;for(;typeof o=="object"&&(l=Object.keys(o)[0]);){if(t=t[l],!t)return!1;o=o[l]}return!0}}e.ConfigurationChangeEvent=s;class a extends s{constructor(t,r,o,l){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=o,this.sourceConfig=l}}e.AllKeysConfigurationChangeEvent=a}),define(ge[113],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=_.createDecorator("remoteAuthorityResolverService");var k;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(P,D=k.Unknown,I){super(P);this._message=P,this._code=D,this._detail=I,this.isHandled=D===k.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(P){return P instanceof R&&P._code===k.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof R&&P._code===k.NoResolverFound}static isHandled(P){return P instanceof R&&P.isHandled}}e.RemoteAuthorityResolverError=R}),define(ge[114],pe([0,1,11]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function k(T){return T.scheme===_.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=k;function R(T){if(!!T){const P=T.indexOf("+");return P<0?T:T.substr(0,P)}}e.getRemoteName=R}),define(ge[187],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class _{vsda(){return new Promise((R,T)=>Z(["vsda"],R,T))}async sign(R){try{const T=await this.vsda(),P=new T.signer;if(P)return P.sign(R)}catch(T){}return R}}e.SignService=_}),define(ge[188],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(ge[189],pe([0,1,4,5,41,3,188,57]),function(Z,e,_,k,R,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=_.createDecorator("themeService");var I;(function(w){function p(d){return d&&typeof d=="object"&&typeof d.id=="string"}w.isThemeColor=p})(I=e.ThemeColor||(e.ThemeColor={}));function n(w){return{id:w}}e.themeColorFromId=n;var C;(function(w){function p(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||I.isThemeColor(t.color))}w.isThemeIcon=p;const d=/^\$\(([a-z.]+\/)?([a-z-~]+)\)$/i;function s(t){const r=d.exec(t);if(!!r){let[,o,l]=r;return!o||o==="codicon/"?{id:l}:{id:o+l}}}w.fromString=s;function a(t,r){let o=t.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),r&&(o=`${o}~${r}`),{id:o}}w.modify=a;function c(t,r){var o,l;return t.id===r.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((l=r.color)===null||l===void 0?void 0:l.id)}w.isEqual=c,w.asClassNameArray=D.CSSIcon.asClassNameArray,w.asClassName=D.CSSIcon.asClassName,w.asCSSSelector=D.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function S(w){switch(w){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),k.toDisposable(()=>{const d=this.themingParticipants.indexOf(p);this.themingParticipants.splice(d,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new v;R.Registry.add(e.Extensions.ThemingContribution,f);function u(w){return f.onColorThemeChange(w)}e.registerThemingParticipant=u;class m extends k.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(d=>this.onThemeChange(d)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,d){let s=this.theme.getColor(p);return s&&d&&(s=d(s,this.theme)),s?s.toString():null}}e.Themable=m}),define(ge[190],pe([0,1,41,189,3,155,112,19,57]),function(Z,e,_,k,R,T,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:T.localize(0,null)},fontCharacter:{type:"string",description:T.localize(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",enum:[],enumDescriptions:[]},this.iconsById={}}registerIcon(p,d,s,a){const c=this.iconsById[p];if(c){if(s&&!c.description){c.description=s,this.iconSchema.properties[p].markdownDescription=`${s} $(${p})`;const o=this.iconReferenceSchema.enum.indexOf(p);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=s),this._onDidChange.fire()}return c}let t={id:p,description:s,defaults:d,deprecationMessage:a};this.iconsById[p]=t;let r={$ref:"#/definitions/icons"};return a&&(r.deprecationMessage=a),s&&(r.markdownDescription=`${s}: $(${p})`),this.iconSchema.properties[p]=r,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const d=this.iconReferenceSchema.enum.indexOf(p);d!==-1&&(this.iconReferenceSchema.enum.splice(d,1),this.iconReferenceSchema.enumDescriptions.splice(d,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}getCSS(){const p=[];for(let d in this.iconsById){const s=this.formatRule(d);s&&p.push(s)}return p.join(`
`)}formatRule(p){let d=this.iconsById[p].defaults;for(;k.ThemeIcon.isThemeIcon(d);){const s=this.iconsById[d.id];if(!s)return;d=s.defaults}return`.codicon-${p}:before { content: '${d.character}'; }`}toString(){const p=(c,t)=>c.id.localeCompare(t.id),d=c=>{for(;k.ThemeIcon.isThemeIcon(c.defaults);)c=this.iconsById[c.defaults.id];return`codicon codicon-${c?c.id:""}`};let s=[];s.push("| preview     | identifier                        | default codicon id                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.iconsById).map(c=>this.iconsById[c]);for(const c of a.filter(t=>!!t.description).sort(p))s.push(`|<i class="${d(c)}"></i>|${c.id}|${k.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const c of a.filter(t=>!k.ThemeIcon.isThemeIcon(t.defaults)).sort(p))s.push(`|<i class="${d(c)}"></i>|${c.id}|`);return s.join(`
`)}}const C=new n;_.Registry.add(e.Extensions.IconContribution,C);function S(w,p,d,s){return C.registerIcon(w,p,d,s)}e.registerIcon=S;function v(){return C}e.getIconRegistry=v;function f(){for(const w of I.iconRegistry.all)C.registerIcon(w.id,w.definition,w.description);I.iconRegistry.onDidRegister(w=>C.registerIcon(w.id,w.definition,w.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let u=_.Registry.as(P.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,C.getIconSchema());const m=new D.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);C.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.widgetClose=S("widget-close",I.Codicon.close,T.localize(2,null)),e.gotoPreviousLocation=S("goto-previous-location",I.Codicon.arrowUp,T.localize(3,null)),e.gotoNextLocation=S("goto-next-location",I.Codicon.arrowDown,T.localize(4,null)),e.syncing=k.ThemeIcon.modify(I.Codicon.sync,"spin")}),define(ge[61],pe([0,1,2,23,4,22]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=R.createDecorator("contextService");var P;(function(v){v[v.EMPTY=1]="EMPTY",v[v.FOLDER=2]="FOLDER",v[v.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function D(v){const f=v;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=D;function I(v){const f=v;return!!(f&&typeof f=="object"&&_.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=I;class n{constructor(f,u,m,w){this._id=f,this._configuration=m,this._ignorePathCasing=w,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class C{constructor(f,u){this.raw=u,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return k.joinPath(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=C;function S(v){return new C({uri:v,index:0,name:k.basenameOrAuthority(v)},{uri:v.toString()})}e.toWorkspaceFolder=S}),define(ge[115],pe([0,1,4,156,61,2,9,7,23,131,56,11,78,30,114]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:k.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(W){return(typeof W=="string"?D.extname(W):I.extname(W))===m}e.hasWorkspaceFileExtension=w,e.IWorkspacesService=_.createDecorator("workspacesService");function p(W){return W.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function d(W){return W.hasOwnProperty("folderUri")}e.isRecentFolder=d;function s(W){return W.hasOwnProperty("fileUri")}e.isRecentFile=s;function a(W){const x=W;return typeof(x==null?void 0:x.id)=="string"&&T.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=a;function c(W){if(W.configuration)return{id:W.id,configPath:W.configuration};if(W.folders.length===1)return{id:W.id,uri:W.folders[0].uri}}e.toWorkspaceIdentifier=c;function t(W){const x=W;return typeof(x==null?void 0:x.id)=="string"&&T.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function r(W){if(W==null?void 0:W.uri)return{id:W.id,uri:T.URI.revive(W.uri)};if(W==null?void 0:W.configPath)return{id:W.id,configPath:T.URI.revive(W.configPath)}}e.reviveIdentifier=r;function o(W,x){return I.extUriBiasedIgnorePathCase.isEqualOrParent(W,x.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function l(W){return i(W)||h(W)}e.isStoredWorkspaceFolder=l;function i(W){const x=W;return typeof(x==null?void 0:x.path)=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=i;function h(W){const x=W;return typeof(x==null?void 0:x.uri)=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=h;function y(W,x,M,$,O=!P.isWindows,B){if(W.scheme!==$.scheme)return{name:M,uri:W.toString(!0)};let J=x?void 0:B.relativePath($,W);if(J!==void 0)J.length===0?J=".":P.isWindows&&W.scheme===S.Schemas.file&&!O&&(J=J.replace(/\//g,"\\"));else if(W.scheme===S.Schemas.file)J=W.fsPath,P.isWindows&&(J=v.normalizeDriveLetter(J),O&&(J=f.toSlashes(J)));else{if(!B.isEqualAuthority(W.authority,$.authority))return{name:M,uri:W.toString(!0)};J=W.path}return{name:M,path:J}}e.getStoredWorkspaceFolder=y;function g(W,x,M){let $=[],O=new Set;const B=M.dirname(x);for(let J of W){let U=null;if(i(J))J.path&&(U=M.resolvePath(B,J.path));else if(h(J))try{U=T.URI.parse(J.uri),U.path[0]!=="/"&&(U=U.with({path:"/"+U.path}))}catch(V){console.warn(V)}if(U){let V=M.getComparisonKey(U);if(!O.has(V)){O.add(V);const z=J.name||M.basenameOrAuthority(U);$.push(new R.WorkspaceFolder({uri:U,name:z,index:$.length},J))}}}return $}e.toWorkspaceFolders=g;function E(W,x,M,$,O){let B=b(x,W);const J=O.dirname(x),U=O.dirname($),V=[],z=L(B.folders);for(const fe of B.folders){const we=i(fe)?O.resolvePath(J,fe.path):T.URI.parse(fe.uri);let be;M?be=!1:be=!i(fe)||D.isAbsolute(fe.path),V.push(y(we,be,fe.name,U,z,O))}const Q={insertSpaces:!1,tabSize:4,eol:P.isLinux||P.isMacintosh?`
`:`\r
`},ae=n.setProperty(W,["folders"],V,Q);let ce=n.applyEdits(W,ae);return B.remoteAuthority===u.getRemoteAuthority($)&&(ce=n.applyEdits(ce,n.removeProperty(ce,["remoteAuthority"],Q))),ce}e.rewriteWorkspaceFileForNewLocation=E;function b(W,x){let M=C.parse(x);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter($=>l($));else throw new Error(`${W} looks like an invalid workspace file.`);return M}function L(W){return P.isWindows?W.some(x=>i(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=L;function A(W,x){const M={workspaces:[],files:[]};if(W){const $=function(B,J){for(let U=0;U<B.length;U++)try{J(B[U],U)}catch(V){x.warn(`Error restoring recent entry ${JSON.stringify(B[U])}: ${V.toString()}. Skip entry.`)}},O=W;Array.isArray(O.workspaces3)&&$(O.workspaces3,(B,J)=>{const U=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[J]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?M.workspaces.push({label:U,workspace:{id:B.id,configPath:T.URI.parse(B.configURIPath)}}):typeof B=="string"&&M.workspaces.push({label:U,folderUri:T.URI.parse(B)})}),Array.isArray(O.files2)&&$(O.files2,(B,J)=>{const U=Array.isArray(O.fileLabels)&&O.fileLabels[J]||void 0;typeof B=="string"&&M.files.push({label:U,fileUri:T.URI.parse(B)})})}return M}e.restoreRecentlyOpened=A;function N(W){const x={workspaces3:[],files2:[]};let M=!1;const $=[];for(const B of W.workspaces)d(B)?x.workspaces3.push(B.folderUri.toString()):x.workspaces3.push({id:B.workspace.id,configURIPath:B.workspace.configPath.toString()}),$.push(B.label||null),M=M||!!B.label;M&&(x.workspaceLabels=$),M=!1;const O=[];for(const B of W.files)x.files2.push(B.fileUri.toString()),O.push(B.label||null),M=M||!!B.label;return M&&(x.fileLabels=O),x}e.toStoreData=N}),define(ge[86],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(R){this.id=R,this._data=new Map,this._idPool=1}add(R){const T=this._idPool++;return this._data.set(T,R),this.logDebugInfo(),T}get(R,T){return this._data.has(R)?this._data.get(R)[T]:void 0}delete(R){this._data.delete(R),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(ge[191],pe([0,1,2,3]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class R{constructor(){this._onDidChangeTabs=new k.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(P){this._tabs=P.map(D=>({name:D.name,group:D.group,resource:_.URI.revive(D.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=R}),define(ge[62],pe([0,1,11,4]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(P,D){D===null?this._providerInfo.delete(P):this._providerInfo.set(P,D)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=k.createDecorator("IExtHostFileSystemInfo")}),define(ge[28],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=_.createDecorator("IExtHostInitDataService")}),define(ge[192],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class _{constructor(T,P,D){this._id=T,this._shared=P,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)})}get whenReady(){return this._init}get(T,P){let D=this._value[T];return typeof D=="undefined"&&(D=P),D}update(T,P){return this._value[T]=P,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=_;class k extends _{constructor(T,P){super(T.identifier.value,!0,P);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=k}),define(ge[14],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=_.createDecorator("IExtHostRpcService");class k{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=k});var Je=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},We=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[193],pe([0,1,29,3]),function(Z,e,_,k){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(D,I){R.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(D.identifier),Je(this,R,I),We(this,R).onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(D){return We(this,R).get(this._id,D)}store(D,I){return We(this,R).store(this._id,D,I)}delete(D){return We(this,R).delete(this._id,D)}}e.ExtensionSecrets=T,R=new WeakMap});var He=this&&this.__decorate||function(Z,e,_,k){var R=arguments.length,T=R<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,_):k,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Z,e,_,k);else for(var D=Z.length-1;D>=0;D--)(P=Z[D])&&(T=(R<3?P(T):R>3?P(e,_,T):P(e,_))||T);return R>3&&T&&Object.defineProperty(e,_,T),T},Fe=this&&this.__param||function(Z,e){return function(_,k){e(_,k,Z)}};define(ge[51],pe([0,1,4,3,14]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(D){function I(C){return{remoteAddress:C.remoteAddress,localAddress:C.localAddress,public:!!C.public}}D.fromApiTunnel=I;function n(C){return{remoteAddress:{host:C.tunnelRemoteHost,port:C.tunnelRemotePort},localAddress:C.localAddress,public:C.public}}D.fromServiceTunnel=n})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=_.createDecorator("IExtHostTunnelService");let P=class{constructor(I){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(I){return{dispose:()=>{}}}async $forwardPort(I,n){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=He([Fe(0,R.IExtHostRpcService)],P),e.ExtHostTunnelService=P}),define(ge[63],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=_.createDecorator("IURITransformerService");class k{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=k}),define(ge[87],pe([0,1,2]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function k(T,P,D){const I=T.webviewResourceRoot.replace("{{resource}}",D.scheme+R(D)).replace("{{uuid}}",P);return _.URI.parse(I)}e.asWebviewUri=k;function R(T){return T.toString().replace(/^\S+?:/,"")}}),define(ge[194],pe([0,1,3,5,87,26]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(I,n,C){this._proxy=I,this._editors=n,this._initData=C,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const S=n.getVisibleTextEditors();for(const v of this._insets.values())S.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,n,C,S,v){let f;for(const a of this._editors.getVisibleTextEditors())if(a===I){f=a;break}if(!f)throw new Error("not a visible editor");const u=this,m=this._handlePool++,w=new _.Emitter,p=new _.Emitter,d=new class{constructor(){this._uuid=T.generateUuid(),this._html="",this._options=Object.create(null)}asWebviewUri(a){return R.asWebviewUri(u._initData,this._uuid,a)}get cspSource(){return u._initData.webviewCspSource}set options(a){this._options=a,u._proxy.$setOptions(m,a)}get options(){return this._options}set html(a){this._html=a,u._proxy.$setHtml(m,a)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(a){return u._proxy.$postMessage(m,a)}},s=new class{constructor(){this.editor=I,this.line=n,this.height=C,this.webview=d,this.onDidDispose=p.event}dispose(){u._insets.has(m)&&(u._insets.delete(m),u._proxy.$disposeEditorInset(m),p.fire(),p.dispose(),w.dispose())}};return this._proxy.$createEditorInset(m,f.id,f.document.uri,n+1,C,S||{},v.identifier,v.extensionLocation),this._insets.set(m,{editor:I,inset:s,onDidReceiveMessage:w}),s}$onDidDispose(I){const n=this._insets.get(I);n&&n.inset.dispose()}$onDidReceiveMessage(I,n){const C=this._insets.get(I);C&&C.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=P}),define(ge[195],pe([0,1,3,60,167,4,5,22,41,13,54,25,57,190]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=f.registerIcon("default-view-icon",v.Codicon.window,R.localize(0,null));var u;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(u=e.Extensions||(e.Extensions={}));var m;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={}));function w(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=w;class p extends P.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return n.flatten([...this.viewContainers.values()])}registerViewContainer(i,h,y){const g=this.get(i.id);if(g)return g;const E=i;return D.getOrSet(this.viewContainers,h,[]).push(E),y&&this.defaultViewContainers.push(E),this._onDidRegister.fire({viewContainer:E,viewContainerLocation:h}),E}deregisterViewContainer(i){for(const h of this.viewContainers.keys()){const y=this.viewContainers.get(h),g=y==null?void 0:y.indexOf(i);if(g!==-1){y==null||y.splice(g,1),y.length===0&&this.viewContainers.delete(h),this._onDidDeregister.fire({viewContainer:i,viewContainerLocation:h});return}}}get(i){return this.all.filter(h=>h.id===i)[0]}getViewContainers(i){return[...this.viewContainers.get(i)||[]]}getViewContainerLocation(i){return[...this.viewContainers.keys()].filter(h=>this.getViewContainers(h).filter(y=>(y==null?void 0:y.id)===i.id).length>0)[0]}getDefaultViewContainer(i){return this.defaultViewContainers.find(h=>this.getViewContainerLocation(h)===i)}}I.Registry.add(u.ViewContainersRegistry,new p);var d;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function s(l,i){var h,y,g,E;const b=(h=l.group)!==null&&h!==void 0?h:d.More,L=(y=i.group)!==null&&y!==void 0?y:d.More;return b!==L?b.localeCompare(L):((g=l.order)!==null&&g!==void 0?g:5)-((E=i.order)!==null&&E!==void 0?E:5)}class a extends P.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new C.SetMap}registerViews(i,h){this.registerViews2([{views:i,viewContainer:h}])}registerViews2(i){i.forEach(({views:h,viewContainer:y})=>this.addViews(h,y)),this._onViewsRegistered.fire(i)}deregisterViews(i,h){const y=this.removeViews(i,h);y.length&&this._onViewsDeregistered.fire({views:y,viewContainer:h})}moveViews(i,h){for(const y of this._views.keys())if(y!==h){const g=this.removeViews(i,y);g.length&&(this.addViews(g,h),this._onDidChangeContainer.fire({views:g,from:y,to:h}))}}getViews(i){return this._views.get(i)||[]}getView(i){for(const h of this._viewContainers){const y=(this._views.get(h)||[]).filter(g=>g.id===i)[0];if(y)return y}return null}getViewContainer(i){for(const h of this._viewContainers)if((this._views.get(h)||[]).filter(g=>g.id===i)[0])return h;return null}registerViewWelcomeContent(i,h){return this._viewWelcomeContents.add(i,h),this._onDidChangeViewWelcomeContent.fire(i),P.toDisposable(()=>{this._viewWelcomeContents.delete(i,h),this._onDidChangeViewWelcomeContent.fire(i)})}getViewWelcomeContent(i){const h=[];return this._viewWelcomeContents.forEach(i,y=>h.push(y)),n.mergeSort(h,s),h}addViews(i,h){let y=this._views.get(h);y||(y=[],this._views.set(h,y),this._viewContainers.push(h));for(const g of i){if(this.getView(g.id)!==null)throw new Error(R.localize(1,null,g.id));y.push(g)}}removeViews(i,h){const y=this._views.get(h);if(!y)return[];const g=[],E=[];for(const b of y)i.includes(b)?g.push(b):E.push(b);return g.length&&(E.length?this._views.set(h,E):(this._views.delete(h),this._viewContainers.splice(this._viewContainers.indexOf(h),1))),g}}I.Registry.add(u.ViewsRegistry,new a),e.IViewsService=T.createDecorator("viewsService"),e.FocusedViewContext=new k.RawContextKey("focusedView","");function c(l){return`view.${l}.visible`}e.getVisbileViewContextKey=c,e.IViewDescriptorService=T.createDecorator("viewDescriptorService");var t;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(t=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(i,h){this.resolved=!1,this._hasResolve=!1,S.mixin(this,i),this._hasResolve=!!h,this.resolve=async y=>{var g,E;if(h&&!this.resolved){const b=await h(y);b&&(this.tooltip=(g=this.tooltip)!==null&&g!==void 0?g:b.tooltip,this.command=(E=this.command)!==null&&E!==void 0?E:b.command)}y.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o}),define(ge[196],pe([0,1,2,178,115,12,179,195]),function(Z,e,_,k,R,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function I(m){return(w,...p)=>m(w.get(k.ICommandService),...p)}class n{static execute(w,p){const d={forceReuseWindow:p&&p.reuseWindow,remoteAuthority:p&&p.remoteAuthority};return w.executeCommand("_files.newWindow",d)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",k.CommandsRegistry.registerCommand({id:n.ID,handler:I(n.execute),description:{description:"Opens an new window",args:[]}}),k.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(m,w){return m.get(R.IWorkspacesService).removeRecentlyOpened([w])});class C{static execute(w,p){return typeof p=="string"?p=p.match(/^[^:/?#]+:\/\//)?_.URI.parse(p):_.URI.file(p):p=_.URI.revive(p),w.executeCommand("_workbench.removeFromRecentlyOpened",p)}}e.RemoveFromRecentlyOpenedAPICommand=C,C.ID="vscode.removeFromRecentlyOpened",k.CommandsRegistry.registerCommand(C.ID,I(C.execute));class S{static execute(w,p){const d=typeof p=="string"?{extensionId:p}:p;return w.executeCommand("workbench.action.openIssueReporter",d)}}e.OpenIssueReporter=S,S.ID="vscode.openIssueReporter",k.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(m,w){const p=m.get(R.IWorkspacesService);let d;const s=w.uri,a=w.label;return w.type==="workspace"?d={workspace:await p.getWorkspaceIdentifier(s),label:a}:w.type==="folder"?d={folderUri:s,label:a}:d={fileUri:s,label:a},p.addRecentlyOpened([d])}),k.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(m){return m.get(R.IWorkspacesService).getRecentlyOpened()}),k.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(m,w){const p=m.get(T.ILogService),d=m.get(P.IEnvironmentService);d.isExtensionDevelopment&&!!d.extensionTestsLocationURI&&p.setLevel(w)}),k.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(m){return m.get(T.ILogService).getLevel()}),k.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(m,w){const p=m.get(D.IViewDescriptorService),d=p.getViewContainerById(w.destinationId);if(!!d){for(const s of w.viewIds){const a=p.getViewDescriptorById(s);(a==null?void 0:a.canMoveView)&&p.moveViewsToContainer([a],d,D.ViewVisibilityState.Default)}await m.get(D.IViewsService).openViewContainer(d.id,!0)}});class v{static execute(w,p){return!Array.isArray(p==null?void 0:p.viewIds)||typeof(p==null?void 0:p.destinationId)!="string"?Promise.reject("Invalid arguments"):w.executeCommand("_workbench.action.moveViews",p)}}e.MoveViewsAPICommand=v,v.ID="vscode.moveViews",k.CommandsRegistry.registerCommand({id:v.ID,handler:I(v.execute),description:{description:"Move Views",args:[]}});class f{static execute(w,p){return w.executeCommand("_workbench.open",p)}}f.ID="vscode.open",k.CommandsRegistry.registerCommand(f.ID,I(f.execute));class u{static execute(w,p,d,s,a){return w.executeCommand("_workbench.diff",[p,d,s])}}u.ID="vscode.diff",k.CommandsRegistry.registerCommand(u.ID,I(u.execute))}),define(ge[116],pe([0,1,3,19,168]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,I,n,C){const S={command:D};if(I&&Object.keys(I).length>0&&(S.arguments=I),this.internalSend("request",S),typeof C=="number"){const v=setTimeout(()=>{clearTimeout(v);const f=this.pendingRequests.get(S.seq);if(f){this.pendingRequests.delete(S.seq);const u={type:"response",seq:0,request_seq:S.seq,success:!1,command:D,message:R.localize(0,null,C,D)};f(u)}},C)}return n&&this.pendingRequests.set(S.seq,n),S.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,I){return D.type!=="event"||I.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await k.timeout(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const I=D,n=this.pendingRequests.get(I.request_seq);n&&(this.pendingRequests.delete(I.request_seq),n(I));break}}}internalSend(D,I){I.type=D,I.seq=this.sequence++,this.sendMessage(I)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((I,n)=>D.set(n,I)),await k.timeout(500),D.forEach((I,n)=>{I({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(ge[197],pe([0,1,10,2,7,25,11]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function I(r,o,l){return r.replace(D,function(i,h){return o&&h.length>0&&h[0]!=="_"?i:l&&l.hasOwnProperty(h)?l[h]:i})}e.formatPII=I;function n(r){const o={};for(const l of Object.keys(r))l.startsWith("!")||(o[l]=r[l]);return o}e.filterExceptionsFromTelemetry=n;function C(r){return r.configuration.request==="attach"&&!S(r)}e.isSessionAttach=C;function S(r){let o=r.configuration.type;if(!!o)return o==="vslsShare"&&(o=r.configuration.adapterProxy.configuration.type),_.equalsIgnoreCase(o,"extensionhost")||_.equalsIgnoreCase(o,"pwa-extensionhost")?r:r.parentSession?S(r.parentSession):void 0}e.getExtensionHostDebugSession=S;function v(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=v;function f(r,o,l){let i,h=0,y=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,g=null;for(;g=y.exec(r);){let E=g.index+1,b=E+g[0].length;if(E<=o&&b>=l){i=g[0],h=E;break}}if(i){let E=/\w+/g,b=null;for(;(b=E.exec(i))&&!(b.index+1+h+b[0].length>=l););b&&(i=i.substring(0,E.lastIndex))}return i?{start:h,end:h+i.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(r){return!!(r&&r.match(u))}e.isUri=m;function w(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(m(r.path))return k.URI.parse(r.path);if(R.isAbsolute(r.path))return k.URI.file(r.path)}return r.path}function p(r){if(typeof r.path=="object"){const o=k.URI.revive(r.path);if(o)return o.scheme===P.Schemas.file?o.fsPath:o.toString()}return r.path}function d(r,o){const l=o?w:p,i=T.deepClone(r);return a(i,(h,y)=>{h&&y&&(y.path=l(y))}),i}e.convertToDAPaths=d;function s(r,o){const l=o?w:p,i=T.deepClone(r);return a(i,(h,y)=>{!h&&y&&(y.path=l(y))}),i}e.convertToVSCPaths=s;function a(r,o){switch(r.type){case"event":const l=r;switch(l.event){case"output":o(!1,l.body.source);break;case"loadedSource":o(!1,l.body.source);break;case"breakpoint":o(!1,l.body.breakpoint.source);break;default:break}break;case"request":const i=r;switch(i.command){case"setBreakpoints":o(!0,i.arguments.source);break;case"breakpointLocations":o(!0,i.arguments.source);break;case"source":o(!0,i.arguments.source);break;case"gotoTargets":o(!0,i.arguments.source);break;case"launchVSCode":i.arguments.args.forEach(y=>o(!1,y));break;default:break}break;case"response":const h=r;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(y=>o(!1,y.source));break;case"loadedSources":h.body.sources.forEach(y=>o(!1,y));break;case"scopes":h.body.scopes.forEach(y=>o(!1,y.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(y=>o(!1,y.source));break;case"setBreakpoints":h.body.breakpoints.forEach(y=>o(!1,y.source));break;default:break}break}}function c(r){return r.filter(o=>{var l;return!((l=o.presentation)===null||l===void 0?void 0:l.hidden)}).sort((o,l)=>o.presentation?l.presentation?o.presentation.group?l.presentation.group?o.presentation.group!==l.presentation.group?o.presentation.group.localeCompare(l.presentation.group):t(o.presentation.order,l.presentation.order):-1:l.presentation.group?1:t(o.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=c;function t(r,o){return typeof r!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:r-o}}),define(ge[198],pe([0,1,24,35,169,117,7,10,25,9,180,116]),function(Z,e,_,k,R,T,P,D,I,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class v extends S.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(d,s){this.outputStream=s,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,d.on("data",a=>this.handleData(a))}sendMessage(d){if(this.outputStream){const s=JSON.stringify(d);this.outputStream.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${v.TWO_CRLF}${s}`,"utf8")}}handleData(d){for(this.rawData=Buffer.concat([this.rawData,d]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const s=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+s))}continue}}else{const s=this.rawData.indexOf(v.TWO_CRLF);if(s!==-1){const c=this.rawData.toString("utf8",0,s).split(v.HEADER_LINESEPARATOR);for(const t of c){const r=t.split(v.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(s+v.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=v,v.TWO_CRLF=`\r
\r
`,v.HEADER_LINESEPARATOR=/\r?\n/,v.HEADER_FIELDSEPARATOR=/: */;class f extends v{startSession(){return new Promise((d,s)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),d(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.socket.on("error",c=>{a?this._onError.fire(c):s(c)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class u extends f{constructor(d){super();this.adapterServer=d}createConnection(d){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",d)}}e.SocketDebugAdapter=u;class m extends f{constructor(d){super();this.adapterServer=d}createConnection(d){return T.createConnection(this.adapterServer.path,d)}}e.NamedPipeDebugAdapter=m;class w extends v{constructor(d,s,a){super();this.adapterExecutable=d,this.debugType=s,this.outputService=a}async startSession(){const d=this.adapterExecutable.command,s=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(d)if(P.isAbsolute(d)){if(!await _.exists(d))throw new Error(R.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(R.localize(1,null,this.debugType));let c=process.env;if(a.env&&Object.keys(a.env).length>0&&(c=I.mixin(I.deepClone(process.env),a.env)),d==="node")if(Array.isArray(s)&&s.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:c,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(o.cwd=a.cwd);const l=k.fork(s[0],s.slice(1),o);if(!l.pid)throw new Error(R.localize(2,null,s[0]));this.serverProcess=l}else throw new Error(R.localize(3,null));else{const r={env:c};a.cwd&&(r.cwd=a.cwd),this.serverProcess=k.spawn(d,s,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,o)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const l=t.getChannel(C.ExtensionsChannelId);l&&l.append(r(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(c){this._onError.fire(c)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),n.isWindows?new Promise((d,s)=>{const a=k.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(c,t,r){if(c)return s(c)});a.on("exit",d),a.on("error",s)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(d,s){if(!!d){const a=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?a.runtime=P.join(s,d.runtime):a.runtime=d.runtime),d.runtimeArgs&&(a.runtimeArgs=d.runtimeArgs),d.program&&(P.isAbsolute(d.program)?a.program=d.program:a.program=P.join(s,d.program)),d.args&&(a.args=d.args);const c=d;return c.win&&(a.win=w.extract(c.win,s)),c.winx86&&(a.winx86=w.extract(c.winx86,s)),c.windows&&(a.windows=w.extract(c.windows,s)),c.osx&&(a.osx=w.extract(c.osx,s)),c.linux&&(a.linux=w.extract(c.linux,s)),a}}static platformAdapterExecutable(d,s){let a=Object.create(null);s=s.toLowerCase();for(const i of d)if(i.contributes){const h=i.contributes.debuggers;h&&h.length>0&&h.filter(y=>typeof y.type=="string"&&D.equalsIgnoreCase(y.type,s)).forEach(y=>{const g=w.extract(y,i.extensionLocation.fsPath);a=I.mixin(a,g,i.isBuiltin)})}let c;n.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?c=a.winx86||a.win||a.windows:n.isWindows?c=a.win||a.windows:n.isMacintosh?c=a.osx:n.isLinux&&(c=a.linux),c=c||a;let t=c.program||a.program;const r=c.args||a.args;let o=c.runtime||a.runtime;const l=c.runtimeArgs||a.runtimeArgs;if(o)return{type:"executable",command:o,args:(l||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=w}),define(ge[199],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ge[200],pe([0,1,35,7,80,170,24,9,85,4,199,11]),function(Z,e,_,k,R,T,P,D,I,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=T.localize(0,null);let f=class Mt{constructor(s){this._configurationService=s}openTerminal(s){if(this._configurationService){const a=this._configurationService.getValue();this.spawnTerminal(_,a,R.getWindowsShell(),s)}}runInTerminal(s,a,c,t,r){const o=r.windowsExec||Mt.getDefaultTerminalWindows();return new Promise((l,i)=>{const h=`"${a} - ${v}"`,y=`""${c.join('" "')}" & pause"`,g=["/c","start",h,"/wait",o,"/c",y],E=Object.assign({},process.env,t);Object.keys(E).filter(A=>E[A]===null).forEach(A=>delete E[A]);const b={cwd:a,env:E,windowsVerbatimArguments:!0};_.spawn(Mt.CMD,g,b).on("error",A=>{i(w(A))}),l(void 0)})}spawnTerminal(s,a,c,t){const o=a.terminal.external.windowsExec||Mt.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const l=k.basename(o).toLowerCase();if(l==="cmder"||l==="cmder.exe")return s.spawn(o,t?[t]:void 0),Promise.resolve(void 0);const i=["/c","start","/wait"];return o.indexOf(" ")>=0&&i.push('""'),i.push(o),(l==="wt"||l==="wt.exe")&&i.push("-d ."),new Promise((h,y)=>{const g=t?{cwd:t}:void 0,E=s.spawn(c,i,g);E.on("error",y),E.on("exit",()=>h())})}static getDefaultTerminalWindows(){if(!Mt._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Mt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return Mt._DEFAULT_TERMINAL_WINDOWS}};f.CMD="cmd.exe",f=He([Fe(0,n.optional(I.IConfigurationService))],f),e.WindowsExternalTerminalService=f;let u=class Si{constructor(s){this._configurationService=s}openTerminal(s){if(this._configurationService){const a=this._configurationService.getValue();this.spawnTerminal(_,a,s)}}runInTerminal(s,a,c,t,r){const o=r.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((l,i)=>{if(o===C.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const h=o===C.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",g=[S.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,Z).fsPath,"-t",s||v,"-w",a];for(let L of c)g.push("-a"),g.push(L);if(t)for(let L in t){const A=t[L];A===null?(g.push("-u"),g.push(L)):(g.push("-e"),g.push(`${L}=${A}`))}let E="";const b=_.spawn(Si.OSASCRIPT,g);b.on("error",L=>{i(w(L))}),b.stderr.on("data",L=>{E+=L.toString()}),b.on("exit",L=>{if(L===0)l(void 0);else if(E){const A=E.split(`
`,1);i(new Error(A[0]))}else i(new Error(T.localize(1,null,h,L)))})}else i(new Error(T.localize(2,null,o)))})}spawnTerminal(s,a,c){const r=a.terminal.external.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((o,l)=>{const i=["-a",r];c&&i.push(c);const h=s.spawn("/usr/bin/open",i);h.on("error",l),h.on("exit",()=>o())})}};u.OSASCRIPT="/usr/bin/osascript",u=He([Fe(0,n.optional(I.IConfigurationService))],u),e.MacExternalTerminalService=u;let m=class Nt{constructor(s){this._configurationService=s}openTerminal(s){if(this._configurationService){const a=this._configurationService.getValue();this.spawnTerminal(_,a,s)}}runInTerminal(s,a,c,t,r){const o=r.linuxExec?Promise.resolve(r.linuxExec):Nt.getDefaultTerminalLinuxReady();return new Promise((l,i)=>{let h=[];o.then(y=>{y.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const g=`${p(c)}; echo; read -p "${Nt.WAIT_MESSAGE}" -n1;`;h.push(`''${g}''`);const E=Object.assign({},process.env,t);Object.keys(E).filter(N=>E[N]===null).forEach(N=>delete E[N]);const b={cwd:a,env:E};let L="";const A=_.spawn(y,h,b);A.on("error",N=>{i(w(N))}),A.stderr.on("data",N=>{L+=N.toString()}),A.on("exit",N=>{if(N===0)l(void 0);else if(L){const W=L.split(`
`,1);i(new Error(W[0]))}else i(new Error(T.localize(4,null,y,N)))})})})}spawnTerminal(s,a,c){const t=a.terminal.external,r=t.linuxExec?Promise.resolve(t.linuxExec):Nt.getDefaultTerminalLinuxReady();return new Promise((o,l)=>{r.then(i=>{const h=c?{cwd:c}:void 0,y=s.spawn(i,[],h);y.on("error",l),y.on("exit",()=>o())})})}static async getDefaultTerminalLinuxReady(){return Nt._DEFAULT_TERMINAL_LINUX_READY||(Nt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async s=>{D.isLinux?await P.exists("/etc/debian_version")?s("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?s("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?s("konsole"):process.env.COLORTERM?s(process.env.COLORTERM):process.env.TERM?s(process.env.TERM):s("xterm"):s("xterm")})),Nt._DEFAULT_TERMINAL_LINUX_READY}};m.WAIT_MESSAGE=T.localize(3,null),m=He([Fe(0,n.optional(I.IConfigurationService))],m),e.LinuxExternalTerminalService=m;function w(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(T.localize(5,null,d.path)):d}function p(d){let s="";for(let a of d)a.indexOf(" ")>=0?s+='"'+a+'"':s+=a,s+=" ";return s}}),define(ge[201],pe([0,1,35,9,200,30]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let P;function D(v,f){if(!P)if(k.isWindows)P=new R.WindowsExternalTerminalService(void 0);else if(k.isMacintosh)P=new R.MacExternalTerminalService(void 0);else if(k.isLinux)P=new R.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const u=f.getConfiguration("terminal");return P.runInTerminal(v.title,v.cwd,v.args,v.env||{},u.external||{})}e.runInExternalTerminal=D;function I(v,f){return new Promise((u,m)=>{let w="";const p=_.spawn(v,f);p.pid&&p.stdout.on("data",d=>{w+=d.toString()}),p.on("error",d=>{m(d)}),p.on("close",d=>{u(w)})})}function n(v){return v?k.isWindows?I("wmic",["process","get","ParentProcessId"]).then(f=>f.split(`\r
`).some(m=>parseInt(m)===v),f=>!0):I("/usr/bin/pgrep",["-lP",String(v)]).then(f=>{const u=f.trim();return!(u.length===0||u.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=n;var C;(function(v){v[v.cmd=0]="cmd",v[v.powershell=1]="powershell",v[v.bash=2]="bash"})(C||(C={}));function S(v,f,u,m){v=v.trim().toLowerCase();let w;v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0?w=1:v.indexOf("cmd.exe")>=0?w=0:v.indexOf("bash")>=0?w=2:k.isWindows?w=0:w=2;let p,d=" ";switch(w){case 1:if(p=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),u){const a=T.getDriveLetter(u);a&&(d+=`${a}:; `),d+=`cd ${p(u)}; `}if(m)for(let a in m){const c=m[a];c===null?d+=`Remove-Item env:${a}; `:d+=`\${env:${a}}='${c}'; `}if(f.length>0){const a=p(f.shift());d+=a[0]==="'"?`& ${a} `:`${a} `;for(let c of f)d+=`${p(c)} `}break;case 0:if(p=a=>(a=a.replace(/\"/g,'""'),a.indexOf(" ")>=0||a.indexOf('"')>=0||a.length===0?`"${a}"`:a),u){const a=T.getDriveLetter(u);a&&(d+=`${a}: && `),d+=`cd ${p(u)} && `}if(m){d+='cmd /C "';for(let a in m){let c=m[a];c===null?d+=`set "${a}=" && `:(c=c.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),d+=`set "${a}=${c}" && `)}}for(let a of f)d+=`${p(a)} `;m&&(d+='"');break;case 2:p=a=>(a=a.replace(/(["'\\\$])/g,"\\$1"),a.indexOf(" ")>=0||a.indexOf(";")>=0||a.length===0?`"${a}"`:a);const s=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(u&&(d+=`cd ${p(u)} ; `),m){d+="/usr/bin/env";for(let a in m){const c=m[a];c===null?d+=` -u ${s(a)}`:d+=` ${s(`${a}=${c}`)}`}d+=" "}for(let a of f)d+=`${p(a)} `;break}return d}e.prepareCommand=S}),define(ge[45],pe([0,1,33,26,11,7,9,60]),function(Z,e,_,k,R,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.NotebookCellsChangeType=e.addIdToOutput=e.isTransformedDisplayOutput=e.MimeTypeRendererResolver=e.NotebookCellRunState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellOutputKind=e.CellKind=void 0;var I;(function(E){E[E.Markdown=1]="Markdown",E[E.Code=2]="Code"})(I=e.CellKind||(e.CellKind={}));var n;(function(E){E[E.Text=1]="Text",E[E.Error=2]="Error",E[E.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,runnable:!0,cellEditable:!0,cellRunnable:!0,cellHasExecutionOrder:!0,displayOrder:e.NOTEBOOK_DISPLAY_ORDER,custom:{},runState:C.Idle,languages:[],trusted:!0};var S;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle",E[E.Success=3]="Success",E[E.Error=4]="Error"})(S=e.NotebookCellRunState||(e.NotebookCellRunState={}));var v;(function(E){E[E.Core=0]="Core",E[E.Active=1]="Active",E[E.Lazy=2]="Lazy"})(v=e.MimeTypeRendererResolver||(e.MimeTypeRendererResolver={}));function f(E){return E.outputKind===n.Rich&&!!E.outputId}e.isTransformedDisplayOutput=f;const u=(E,b=k.generateUuid())=>E.outputKind===n.Rich?Object.assign(Object.assign({},E),{outputId:b}):E;e.addIdToOutput=u;var m;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.CellClearOutput=3]="CellClearOutput",E[E.CellsClearOutput=4]="CellsClearOutput",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.ChangeCellContent=9]="ChangeCellContent",E[E.ChangeDocumentMetadata=10]="ChangeDocumentMetadata",E[E.Unknown=11]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.OutputsSplice=6]="OutputsSplice",E[E.Move=7]="Move",E[E.Unknown=8]="Unknown",E[E.CellContent=9]="CellContent"})(w=e.CellEditType||(e.CellEditType={}));function p(E){const b=d.parse(E);return b?b.notebook.toString():E.toString()}e.getCellUndoRedoComparisonKey=p;var d;(function(E){E.scheme=R.Schemas.vscodeNotebookCell;const b=/^ch(\d{7,})/;function L(x,M){return x.with({scheme:E.scheme,fragment:`ch${M.toString().padStart(7,"0")}${x.scheme!==R.Schemas.file?x.scheme:""}`})}E.generate=L;function A(x){if(x.scheme===E.scheme){const M=b.exec(x.fragment);if(!!M)return{handle:Number(M[1]),notebook:x.with({scheme:x.fragment.substr(M[0].length)||R.Schemas.file,fragment:null})}}}E.parse=A;function N(x,M){return x.with({scheme:R.Schemas.vscodeNotebookCellMetadata,fragment:`ch${M.toString().padStart(7,"0")}${x.scheme!==R.Schemas.file?x.scheme:""}`})}E.generateCellMetadataUri=N;function W(x){if(x.scheme===R.Schemas.vscodeNotebookCellMetadata){const M=b.exec(x.fragment);if(!!M)return{handle:Number(M[1]),notebook:x.with({scheme:x.fragment.substr(M[0].length)||R.Schemas.file,fragment:null})}}}E.parseCellMetadataUri=W})(d=e.CellUri||(e.CellUri={}));function s(E){return["application/json","text/markdown","image/png","text/plain"].indexOf(E)>-1}e.mimeTypeIsAlwaysSecure=s;function a(E){return["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain","text/x-javascript"].indexOf(E)>-1}e.mimeTypeSupportedByCore=a;function c(E,b){return P.isWindows&&(E=E.replace(/\//g,"\\"),b=b.replace(/\//g,"\\")),_.match(E,b)}function t(E,b,L,A){let N=0;for(let W=0;W<b.length;W++){if(c(b[W],E))return N;N++}for(let W=0;W<L.length;W++){if(c(L[W],E))return N;N++}for(let W=0;W<A.length;W++){if(c(A[W],E))return N;N++}return N}function r(E,b,L,A){return E.sort((W,x)=>t(W,b,L,A)-t(x,b,L,A))}e.sortMimeTypes=r;function o(E,b,L,A=(N,W)=>N===W){const N=[];function W($,O,B){if(!(O===0&&B.length===0)){const J=N[N.length-1];J&&J.start+J.deleteCount===$?(J.deleteCount+=O,J.toInsert.push(...B)):N.push({start:$,deleteCount:O,toInsert:B})}}let x=0,M=0;for(;;){if(x===E.length){W(x,0,b.slice(M));break}if(M===b.length){W(x,E.length-x,[]);break}const $=E[x],O=b[M];if(A($,O)){x+=1,M+=1;continue}L(O)?(W(x,1,[]),x+=1):(W(x,0,[O]),M+=1)}return N}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new D.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var l;(function(E){E.default="default",E.option="option"})(l=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(E){const b=E;return!!((typeof b.include=="string"||_.isRelativePattern(b.include))&&(typeof b.exclude=="string"||_.isRelativePattern(b.exclude)))}e.isDocumentExcludePattern=i;function h(E,b,L){if(Array.isArray(E.viewType)&&E.viewType.indexOf(b)>=0||E.viewType===b)return!0;if(E.filenamePattern){let A=i(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,N=i(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(_.match(A,T.basename(L.fsPath).toLowerCase()))return!(N&&_.match(N,T.basename(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class y{constructor(b){this.textModel=b}getElements(){const b=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)b[L]=this.textModel.cells[L].getHashValue();return b}}e.CellSequence=y,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var g;(function(E){E[E.LEFT=0]="LEFT",E[E.RIGHT=1]="RIGHT"})(g=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}))}),define(ge[202],pe([0,1,3,75,5,11,23,2,26,45,86]),function(Z,e,_,k,R,T,P,D,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;function S(w){const p=new _.Emitter;return{proxy:new Proxy(w,{set(s,a,c,t){return s[a]=c,p.fire(),!0}}),onDidChange:p.event}}class v{constructor(p,d,s,a){this.start=p,this.deletedCount=d,this.deletedItems=s,this.items=a}static asApiEvent(p){return Object.freeze({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems.map(d=>d.cell),items:p.items.map(d=>d.cell)})}}class f extends R.Disposable{constructor(p,d,s,a){var c;super();this._mainThreadBulkEdits=p,this._notebook=d,this._extHostDocument=s,this._cellData=a,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._onDidChangeOutputs=new _.Emitter,this.onDidChangeOutputs=this._onDidChangeOutputs.event,this._outputMapping=new WeakMap,this.handle=a.handle,this.uri=D.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs;for(const r of this._outputs)this._outputMapping.set(r,r.outputId),delete r.outputId;const t=S((c=a.metadata)!==null&&c!==void 0?c:{});this._metadata=t.proxy,this._metadataChangeListener=this._register(t.onDidChange(()=>{this._updateMetadata()}))}static asModelAddData(p,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:p}}get cell(){if(!this._cell){const p=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return p._notebook.getCellIndex(p)},notebook:p._notebook.notebookDocument,uri:p.uri,cellKind:this._cellData.cellKind,document:d.document,get language(){return d.document.languageId},get outputs(){return p._outputs},set outputs(s){p._updateOutputs(s)},get metadata(){return p._metadata},set metadata(s){p.setMetadata(s),p._updateMetadata()}})}return this._cell}dispose(){super.dispose(),this._onDidDispose.fire()}setOutputs(p){this._outputs=p}_updateOutputs(p){const s=n.diff(this._outputs||[],p||[],a=>this._outputMapping.has(a)).map(a=>{for(let c=a.start;c<a.start+a.deleteCount;c++)this._outputMapping.delete(this._outputs[c]);return{deleteCount:a.deleteCount,start:a.start,toInsert:a.toInsert.map(c=>{if(c.outputKind===n.CellOutputKind.Rich){const t=I.generateUuid();return this._outputMapping.set(c,t),Object.assign(Object.assign({},c),{outputId:t})}return this._outputMapping.set(c,void 0),c})}});this._outputs=p,this._onDidChangeOutputs.fire(s)}setMetadata(p){this._metadataChangeListener.dispose();const d=S(p);this._metadata=d.proxy,this._metadataChangeListener=this._register(d.onDidChange(()=>{this._updateMetadata()}))}_updateMetadata(){const p=this._notebook.notebookDocument.cells.indexOf(this.cell),d={_type:3,metadata:void 0,resource:this._notebook.uri,notebookVersionId:this._notebook.notebookDocument.version,edit:{editType:3,index:p,metadata:this._metadata}};return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit({edits:[d]})}}e.ExtHostCell=f;function u(w){const p=w.scheme===T.Schemas.file||w.scheme===T.Schemas.untitled?w.fsPath:w.toString();return k.hash(p)+""}class m extends R.Disposable{constructor(p,d,s,a,c,t,r,o,l){super();this._proxy=p,this._documentsAndEditors=d,this._mainThreadBulkEdits=s,this._emitter=a,this._viewType=c,this._contentOptions=t,this.uri=o,this._storagePath=l,this.handle=m._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._backupCounter=1,this._disposed=!1,this._languages=[],this._edits=new C.Cache("notebook documents");const i=S(r);this._metadata=i.proxy,this._metadataChangeListener=this._register(i.onDidChange(()=>{this._tryUpdateMetadata()}))}dispose(){this._disposed=!0,super.dispose(),R.dispose(this._cellDisposableMapping.values())}_updateMetadata(p){this._metadataChangeListener.dispose(),p=Object.assign(Object.assign({},n.notebookDocumentMetadataDefaults),p),this._metadataChangeListener&&this._metadataChangeListener.dispose();const d=S(p);this._metadata=d.proxy,this._metadataChangeListener=this._register(d.onDidChange(()=>{this._tryUpdateMetadata()})),this._tryUpdateMetadata()}_tryUpdateMetadata(){const p={_type:3,metadata:void 0,edit:{editType:5,metadata:this._metadata},resource:this.uri,notebookVersionId:this.notebookDocument.version};return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit({edits:[p]})}get notebookDocument(){if(!this._notebook){const p=this;this._notebook=Object.freeze({get uri(){return p.uri},get version(){return p._versionId},get fileName(){return p.uri.fsPath},get viewType(){return p._viewType},get isDirty(){return p._isDirty},get isUntitled(){return p.uri.scheme===T.Schemas.untitled},get cells(){return p._cells.map(d=>d.cell)},get languages(){return p._languages},set languages(d){p._trySetLanguages(d)},get metadata(){return p._metadata},set metadata(d){p._updateMetadata(d)},get contentOptions(){return p._contentOptions}})}return this._notebook}_trySetLanguages(p){this._languages=p,this._proxy.$updateNotebookLanguages(this._viewType,this.uri,this._languages)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const p=u(this.uri)+this._backupCounter++;return P.joinPath(this._storagePath,p)}updateBackup(p){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=p}disposeBackup(){var p;(p=this._backup)===null||p===void 0||p.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(p){const d=Object.assign(Object.assign({},n.notebookDocumentMetadataDefaults),p.metadata);this._metadataChangeListener&&this._metadataChangeListener.dispose();const s=S(d);this._metadata=s.proxy,this._metadataChangeListener=this._register(s.onDidChange(()=>{this._tryUpdateMetadata()})),this._emitter.emitDocumentMetadataChange({document:this.notebookDocument})}acceptModelChanged(p,d){this._versionId=p.versionId,this._isDirty=d,p.rawEvents.forEach(s=>{s.kind===n.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(s.changes,!0),s.kind===n.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===n.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===n.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===n.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===n.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(s.index,s.metadata)})}_spliceNotebookCells(p,d){if(!this._disposed){const s=[],a=[],c=[];p.reverse().forEach(t=>{var r;const l=t[2].map(h=>{const y=new f(this._mainThreadBulkEdits,this,this._documentsAndEditors,h);if(d||a.push(f.asModelAddData(this.notebookDocument,h)),!this._cellDisposableMapping.has(y.handle)){const E=new R.DisposableStore;E.add(y),this._cellDisposableMapping.set(y.handle,E)}return this._cellDisposableMapping.get(y.handle).add(y.onDidChangeOutputs(E=>{this.eventuallyUpdateCellOutputs(y,E)})),y});for(let h=t[0];h<t[0]+t[1];h++)(r=this._cellDisposableMapping.get(this._cells[h].handle))===null||r===void 0||r.dispose(),this._cellDisposableMapping.delete(this._cells[h].handle);const i=this._cells.splice(t[0],t[1],...l);for(let h of i)c.push(h.uri);s.push(new v(t[0],t[1],i,l))}),this._documentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:c}),d||this._emitter.emitModelChange({document:this.notebookDocument,changes:s.map(v.asApiEvent)})}}_moveCell(p,d){const s=this._cells.splice(p,1);this._cells.splice(d,0,...s);const a=[{start:p,deletedCount:1,deletedItems:s.map(c=>c.cell),items:[]},{start:d,deletedCount:0,deletedItems:[],items:s.map(c=>c.cell)}];this._emitter.emitModelChange({document:this.notebookDocument,changes:a})}_setCellOutputs(p,d){const s=this._cells[p];s.setOutputs(d),this._emitter.emitCellOutputsChange({document:this.notebookDocument,cells:[s.cell]})}_changeCellLanguage(p,d){const s=this._cells[p],a={document:this.notebookDocument,cell:s.cell,language:d};this._emitter.emitCellLanguageChange(a)}_changeCellMetadata(p,d){const s=this._cells[p];s.setMetadata(d||{});const a={document:this.notebookDocument,cell:s.cell};this._emitter.emitCellMetadataChange(a)}async eventuallyUpdateCellOutputs(p,d){const s=d.map(a=>{const c=a.toInsert;return[a.start,a.deleteCount,c]});!s.length||(await this._proxy.$spliceNotebookCellOutputs(this._viewType,this.uri,p.handle,s),this._emitter.emitCellOutputsChange({document:this.notebookDocument,cells:[p.cell]}))}getCell(p){return this._cells.find(d=>d.handle===p)}getCellIndex(p){return this._cells.indexOf(p)}addEdit(p){return this._edits.add([p])}async undo(p,d){await this.getEdit(p).undo()}async redo(p,d){await this.getEdit(p).redo()}getEdit(p){const d=this._edits.get(p,0);if(!d)throw new Error("No edit found");return d}disposeEdits(p){for(const d of p)this._edits.delete(d)}}e.ExtHostNotebookDocument=m,m._handlePool=0});var Je=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},We=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[8],pe([0,1,13,15,98,22,16,2,26,50,113,45]),function(Z,e,_,k,R,T,P,D,I,n,C,S){"use strict";var v,f,u,m,w,p,d,s,a,c,t,r,o,l,i,h,y,g,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TestState=e.TestMessageSeverity=e.TestRunState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookRunState=e.NotebookCellRunState=e.CellOutputKind=e.CellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTrigger=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function b(q){function j(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(j,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(j,q),Object.setPrototypeOf(j.prototype,q.prototype),j}let L=p=class{constructor(j){v.set(this,void 0),Je(this,v,j)}static from(...j){let de=j;return new p(function(){if(de){for(const Te of de)Te&&typeof Te.dispose=="function"&&Te.dispose();de=void 0}})}dispose(){typeof We(this,v)=="function"&&(We(this,v).call(this),Je(this,v,void 0))}};v=new WeakMap,L=p=He([b],L),e.Disposable=L;let A=d=class{constructor(j,de){if(j<0)throw k.illegalArgument("line must be non-negative");if(de<0)throw k.illegalArgument("character must be non-negative");this._line=j,this._character=de}static Min(...j){if(j.length===0)throw new TypeError;let de=j[0];for(let Te=1;Te<j.length;Te++){const Ve=j[Te];Ve.isBefore(de)&&(de=Ve)}return de}static Max(...j){if(j.length===0)throw new TypeError;let de=j[0];for(let Te=1;Te<j.length;Te++){const Ve=j[Te];Ve.isAfter(de)&&(de=Ve)}return de}static isPosition(j){if(!j)return!1;if(j instanceof d)return!0;let{line:de,character:Te}=j;return typeof de=="number"&&typeof Te=="number"}get line(){return this._line}get character(){return this._character}isBefore(j){return this._line<j._line?!0:j._line<this._line?!1:this._character<j._character}isBeforeOrEqual(j){return this._line<j._line?!0:j._line<this._line?!1:this._character<=j._character}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this._line===j._line&&this._character===j._character}compareTo(j){return this._line<j._line?-1:this._line>j.line?1:this._character<j._character?-1:this._character>j._character?1:0}translate(j,de=0){if(j===null||de===null)throw k.illegalArgument();let Te;return typeof j=="undefined"?Te=0:typeof j=="number"?Te=j:(Te=typeof j.lineDelta=="number"?j.lineDelta:0,de=typeof j.characterDelta=="number"?j.characterDelta:0),Te===0&&de===0?this:new d(this.line+Te,this.character+de)}with(j,de=this.character){if(j===null||de===null)throw k.illegalArgument();let Te;return typeof j=="undefined"?Te=this.line:typeof j=="number"?Te=j:(Te=typeof j.line=="number"?j.line:this.line,de=typeof j.character=="number"?j.character:this.character),Te===this.line&&de===this.character?this:new d(Te,de)}toJSON(){return{line:this.line,character:this.character}}};A=d=He([b],A),e.Position=A;let N=s=class{constructor(j,de,Te,Ve){let Ye,nt;if(typeof j=="number"&&typeof de=="number"&&typeof Te=="number"&&typeof Ve=="number"?(Ye=new A(j,de),nt=new A(Te,Ve)):j instanceof A&&de instanceof A&&(Ye=j,nt=de),!Ye||!nt)throw new Error("Invalid arguments");Ye.isBefore(nt)?(this._start=Ye,this._end=nt):(this._start=nt,this._end=Ye)}static isRange(j){return j instanceof s?!0:j?A.isPosition(j.start)&&A.isPosition(j.end):!1}get start(){return this._start}get end(){return this._end}contains(j){return j instanceof s?this.contains(j._start)&&this.contains(j._end):j instanceof A?!(j.isBefore(this._start)||this._end.isBefore(j)):!1}isEqual(j){return this._start.isEqual(j._start)&&this._end.isEqual(j._end)}intersection(j){const de=A.Max(j.start,this._start),Te=A.Min(j.end,this._end);if(!de.isAfter(Te))return new s(de,Te)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const de=A.Min(j.start,this._start),Te=A.Max(j.end,this.end);return new s(de,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(j,de=this.end){if(j===null||de===null)throw k.illegalArgument();let Te;return j?A.isPosition(j)?Te=j:(Te=j.start||this.start,de=j.end||this.end):Te=this.start,Te.isEqual(this._start)&&de.isEqual(this.end)?this:new s(Te,de)}toJSON(){return[this.start,this.end]}};N=s=He([b],N),e.Range=N;let W=a=class extends N{constructor(j,de,Te,Ve){let Ye,nt;if(typeof j=="number"&&typeof de=="number"&&typeof Te=="number"&&typeof Ve=="number"?(Ye=new A(j,de),nt=new A(Te,Ve)):j instanceof A&&de instanceof A&&(Ye=j,nt=de),!Ye||!nt)throw new Error("Invalid arguments");super(Ye,nt);this._anchor=Ye,this._active=nt}static isSelection(j){return j instanceof a?!0:j?N.isRange(j)&&A.isPosition(j.anchor)&&A.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};W=a=He([b],W),e.Selection=W;class x{constructor(j,de,Te){if(typeof j!="string"||j.length===0)throw k.illegalArgument("host");if(typeof de!="number"||de===0||Math.round(de)!==de)throw k.illegalArgument("port");if(typeof Te!="undefined"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw k.illegalArgument("connectionToken");this.host=j,this.port=Math.round(de),this.connectionToken=Te}}e.ResolvedAuthority=x;class M extends Error{constructor(j,de=C.RemoteAuthorityResolverErrorCode.Unknown,Te){super(j);this._message=j,this._code=de,this._detail=Te,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static NotAvailable(j,de){return new M(j,C.RemoteAuthorityResolverErrorCode.NotAvailable,de)}static TemporarilyNotAvailable(j){return new M(j,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=M;var $;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var O;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(O=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=c=class{constructor(j,de){this._range=j,this._newText=de}static isTextEdit(j){return j instanceof c?!0:j?N.isRange(j)&&typeof j.newText=="string":!1}static replace(j,de){return new c(j,de)}static insert(j,de){return c.replace(new N(j,j),de)}static delete(j){return c.replace(j,"")}static setEndOfLine(j){const de=new c(new N(new A(0,0),new A(0,0)),"");return de.newEol=j,de}get range(){return this._range}set range(j){if(j&&!N.isRange(j))throw k.illegalArgument("range");this._range=j}get newText(){return this._newText||""}set newText(j){if(j&&typeof j!="string")throw k.illegalArgument("newText");this._newText=j}get newEol(){return this._newEol}set newEol(j){if(j&&typeof j!="number")throw k.illegalArgument("newEol");this._newEol=j}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=c=He([b],B),e.TextEdit=B;var J;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell"})(J=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=new Array}_allEntries(){return this._edits}renameFile(j,de,Te,Ve){this._edits.push({_type:1,from:j,to:de,options:Te,metadata:Ve})}createFile(j,de,Te){this._edits.push({_type:1,from:void 0,to:j,options:de,metadata:Te})}deleteFile(j,de,Te){this._edits.push({_type:1,from:j,to:void 0,options:de,metadata:Te})}replaceNotebookMetadata(j,de,Te){this._edits.push({_type:3,metadata:Te,uri:j,edit:{editType:5,metadata:Object.assign(Object.assign({},S.notebookDocumentMetadataDefaults),de)},notebookMetadata:de})}replaceNotebookCells(j,de,Te,Ve,Ye){(de!==Te||Ve.length>0)&&this._edits.push({_type:3,metadata:Ye,uri:j,edit:{editType:1,index:de,count:Te-de,cells:Ve.map(nt=>Object.assign(Object.assign({},nt),{outputs:nt.outputs.map(ne=>S.addIdToOutput(ne))}))}})}replaceNotebookCellOutput(j,de,Te,Ve){this._edits.push({_type:3,metadata:Ve,uri:j,edit:{editType:2,index:de,outputs:Te.map(Ye=>Ht.isNotebookCellOutput(Ye)?S.addIdToOutput(Ye.toJSON()):S.addIdToOutput(Ye))}})}replaceNotebookCellMetadata(j,de,Te,Ve){this._edits.push({_type:3,metadata:Ve,uri:j,edit:{editType:3,index:de,metadata:Te}})}replace(j,de,Te,Ve){this._edits.push({_type:2,uri:j,edit:new B(de,Te),metadata:Ve})}insert(j,de,Te,Ve){this.replace(j,new N(de,de),Te,Ve)}delete(j,de,Te){this.replace(j,de,"",Te)}has(j){return this._edits.some(de=>de._type===2&&de.uri.toString()===j.toString())}set(j,de){if(de)for(const Te of de)Te&&this._edits.push({_type:2,uri:j,edit:Te});else{for(let Te=0;Te<this._edits.length;Te++){const Ve=this._edits[Te];Ve._type===2&&Ve.uri.toString()===j.toString()&&(this._edits[Te]=void 0)}_.coalesceInPlace(this._edits)}}get(j){const de=[];for(let Te of this._edits)Te._type===2&&Te.uri.toString()===j.toString()&&de.push(Te.edit);return de}entries(){const j=new T.ResourceMap;for(let de of this._edits)if(de._type===2){let Te=j.get(de.uri);Te||(Te=[de.uri,[]],j.set(de.uri,Te)),Te[1].push(de.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=He([b],U),e.WorkspaceEdit=U;let V=t=class{constructor(j){this._tabstop=1,this.value=j||""}static isSnippetString(j){return j instanceof t?!0:j?typeof j.value=="string":!1}static _escape(j){return j.replace(/\$|}|\\/g,"\\$&")}appendText(j){return this.value+=t._escape(j),this}appendTabstop(j=this._tabstop++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,de=this._tabstop++){if(typeof j=="function"){const Te=new t;Te._tabstop=this._tabstop,j(Te),this._tabstop=Te._tabstop,j=Te.value}else j=t._escape(j);return this.value+="${",this.value+=de,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,de=this._tabstop++){const Te=j.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=de,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(j,de){if(typeof de=="function"){const Te=new t;Te._tabstop=this._tabstop,de(Te),this._tabstop=Te._tabstop,de=Te.value}else typeof de=="string"&&(de=de.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,de&&(this.value+=":",this.value+=de),this.value+="}",this}};V=t=He([b],V),e.SnippetString=V;var z;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(z=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ae=r=class{constructor(j,de){if(this.uri=j,de)if(de instanceof N)this.range=de;else if(de instanceof A)this.range=new N(de,de);else throw new Error("Illegal argument")}static isLocation(j){return j instanceof r?!0:j?N.isRange(j.range)&&D.URI.isUri(j.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ae=r=He([b],ae),e.Location=ae;let ce=class{constructor(j,de){this.location=j,this.message=de}static is(j){return j?typeof j.message=="string"&&j.location&&N.isRange(j.location.range)&&D.URI.isUri(j.location.uri):!1}static isEqual(j,de){return j===de?!0:!j||!de?!1:j.message===de.message&&j.location.range.isEqual(de.location.range)&&j.location.uri.toString()===de.location.uri.toString()}};ce=He([b],ce),e.DiagnosticRelatedInformation=ce;let fe=class{constructor(j,de,Te=Q.Error){if(!N.isRange(j))throw new TypeError("range must be set");if(!de)throw new TypeError("message must be set");this.range=j,this.message=de,this.severity=Te}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,de){return j===de?!0:!j||!de?!1:j.message===de.message&&j.severity===de.severity&&j.code===de.code&&j.severity===de.severity&&j.source===de.source&&j.range.isEqual(de.range)&&_.equals(j.tags,de.tags)&&_.equals(j.relatedInformation,de.relatedInformation,ce.isEqual)}};fe=He([b],fe),e.Diagnostic=fe;let we=class{constructor(j,de){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:R.isMarkdownString(j)?this.contents=[j]:this.contents=[j],this.range=de}};we=He([b],we),e.Hover=we;var be;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let H=class{constructor(j,de=be.Text){this.range=j,this.kind=de}toJSON(){return{range:this.range,kind:be[this.kind]}}};H=He([b],H),e.DocumentHighlight=H;var X;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(X=e.SymbolKind||(e.SymbolKind={}));var re;(function(q){q[q.Deprecated=1]="Deprecated"})(re=e.SymbolTag||(e.SymbolTag={}));let Y=o=class{constructor(j,de,Te,Ve,Ye){this.name=j,this.kind=de,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ve instanceof ae?this.location=Ve:Te instanceof N&&(this.location=new ae(Ve,Te)),o.validate(this)}static validate(j){if(!j.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:X[this.kind],location:this.location,containerName:this.containerName}}};Y=o=He([b],Y),e.SymbolInformation=Y;let le=l=class{constructor(j,de,Te,Ve,Ye){this.name=j,this.detail=de,this.kind=Te,this.range=Ve,this.selectionRange=Ye,this.children=[],l.validate(this)}static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children&&j.children.forEach(l.validate)}};le=l=He([b],le),e.DocumentSymbol=le;var ve;(function(q){q[q.Automatic=1]="Automatic",q[q.Manual=2]="Manual"})(ve=e.CodeActionTrigger||(e.CodeActionTrigger={}));let De=class{constructor(j,de){this.title=j,this.kind=de}};De=He([b],De),e.CodeAction=De;let Me=i=class{constructor(j){this.value=j}append(j){return new i(this.value?this.value+i.sep+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+i.sep)}};Me.sep=".",Me=i=He([b],Me),e.CodeActionKind=Me,Me.Empty=new Me(""),Me.QuickFix=Me.Empty.append("quickfix"),Me.Refactor=Me.Empty.append("refactor"),Me.RefactorExtract=Me.Refactor.append("extract"),Me.RefactorInline=Me.Refactor.append("inline"),Me.RefactorRewrite=Me.Refactor.append("rewrite"),Me.Source=Me.Empty.append("source"),Me.SourceOrganizeImports=Me.Source.append("organizeImports"),Me.SourceFixAll=Me.Source.append("fixAll");let Ee=class{constructor(j,de){if(this.range=j,this.parent=de,de&&!de.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=He([b],Ee),e.SelectionRange=Ee;class Pe{constructor(j,de,Te,Ve,Ye,nt){this.kind=j,this.name=de,this.detail=Te,this.uri=Ve,this.range=Ye,this.selectionRange=nt}}e.CallHierarchyItem=Pe;class Ce{constructor(j,de){this.fromRanges=de,this.from=j}}e.CallHierarchyIncomingCall=Ce;class Oe{constructor(j,de){this.fromRanges=de,this.to=j}}e.CallHierarchyOutgoingCall=Oe;let Se=class{constructor(j,de){this.range=j,this.command=de}get isResolved(){return!!this.command}};Se=He([b],Se),e.CodeLens=Se;let Be=h=class{constructor(j,de=!1){f.set(this,void 0),Je(this,f,new R.MarkdownString(j,{supportThemeIcons:de}))}static isMarkdownString(j){return j instanceof h?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}get value(){return We(this,f).value}set value(j){We(this,f).value=j}get isTrusted(){return We(this,f).isTrusted}set isTrusted(j){We(this,f).isTrusted=j}get supportThemeIcons(){return We(this,f).supportThemeIcons}appendText(j){return We(this,f).appendText(j),this}appendMarkdown(j){return We(this,f).appendMarkdown(j),this}appendCodeblock(j,de){return We(this,f).appendCodeblock(de!=null?de:"",j),this}};f=new WeakMap,Be=h=He([b],Be),e.MarkdownString=Be;let K=class{constructor(j,de){this.label=j,this.documentation=de}};K=He([b],K),e.ParameterInformation=K;let se=class{constructor(j,de){this.label=j,this.documentation=de,this.parameters=[]}};se=He([b],se),e.SignatureInformation=se;let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};_e=He([b],_e),e.SignatureHelp=_e;var Ae;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(Ae=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));let Ue=class{constructor(j,de,Te,Ve,Ye){this.text=j,this.range=de,this.description=Te,this.whitespaceBefore=Ve,this.whitespaceAfter=Ye}};Ue=He([b],Ue),e.InlineHint=Ue;var ze;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var ue;(function(q){q[q.Deprecated=1]="Deprecated"})(ue=e.CompletionItemTag||(e.CompletionItemTag={}));let ye=class{constructor(j,de){this.label=j,this.kind=de}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ye=He([b],ye),e.CompletionItem=ye;let Ne=class{constructor(j=[],de=!1){this.items=j,this.isIncomplete=de}};Ne=He([b],Ne),e.CompletionList=Ne;var ee;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(ee=e.ViewColumn||(e.ViewColumn={}));var te;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(te=e.StatusBarAlignment||(e.StatusBarAlignment={}));var G;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(G=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var F;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(F=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ie;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(ie=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var me;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(me=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function j(de){switch(de){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=j}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ke=class{constructor(j,de){if(de&&!D.URI.isUri(de))throw k.illegalArgument("target");if(!N.isRange(j)||j.isEmpty)throw k.illegalArgument("range");this.range=j,this.target=de}};ke=He([b],ke),e.DocumentLink=ke;let Re=class{constructor(j,de,Te,Ve){this.red=j,this.green=de,this.blue=Te,this.alpha=Ve}};Re=He([b],Re),e.Color=Re;let xe=class{constructor(j,de){if(de&&!(de instanceof Re))throw k.illegalArgument("color");if(!N.isRange(j)||j.isEmpty)throw k.illegalArgument("range");this.range=j,this.color=de}};xe=He([b],xe),e.ColorInformation=xe;let qe=class{constructor(j){if(!j||typeof j!="string")throw k.illegalArgument("label");this.label=j}};qe=He([b],qe),e.ColorPresentation=qe;var Ge;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Ge=e.ColorFormat||(e.ColorFormat={}));var Ke;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(Ke=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var st;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(st=e.TaskRevealKind||(e.TaskRevealKind={}));var $e;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})($e=e.TaskPanelKind||(e.TaskPanelKind={}));let Xe=y=class{constructor(j,de){if(typeof j!="string"||typeof de!="string")throw k.illegalArgument("name");this._id=j}static from(j){switch(j){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}get id(){return this._id}};Xe.Clean=new y("clean","Clean"),Xe.Build=new y("build","Build"),Xe.Rebuild=new y("rebuild","Rebuild"),Xe.Test=new y("test","Test"),Xe=y=He([b],Xe),e.TaskGroup=Xe;function ft(q){let j="";for(let de=0;de<q.length;de++)j+=q[de].replace(/,/g,",,")+",";return j}let et=class{constructor(j,de,Te){if(typeof j!="string")throw k.illegalArgument("process");this._args=[],this._process=j,de!==void 0&&(Array.isArray(de)?(this._args=de,this._options=Te):this._options=de)}get process(){return this._process}set process(j){if(typeof j!="string")throw k.illegalArgument("process");this._process=j}get args(){return this._args}set args(j){Array.isArray(j)||(j=[]),this._args=j}get options(){return this._options}set options(j){this._options=j}computeId(){const j=[];if(j.push("process"),this._process!==void 0&&j.push(this._process),this._args&&this._args.length>0)for(let de of this._args)j.push(de);return ft(j)}};et=He([b],et),e.ProcessExecution=et;let mt=class{constructor(j,de,Te){if(this._args=[],Array.isArray(de)){if(!j)throw k.illegalArgument("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw k.illegalArgument("command");this._command=j,this._args=de,this._options=Te}else{if(typeof j!="string")throw k.illegalArgument("commandLine");this._commandLine=j,this._options=de}}get commandLine(){return this._commandLine}set commandLine(j){if(typeof j!="string")throw k.illegalArgument("commandLine");this._commandLine=j}get command(){return this._command?this._command:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw k.illegalArgument("command");this._command=j}get args(){return this._args}set args(j){this._args=j||[]}get options(){return this._options}set options(j){this._options=j}computeId(){const j=[];if(j.push("shell"),this._commandLine!==void 0&&j.push(this._commandLine),this._command!==void 0&&j.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let de of this._args)j.push(typeof de=="string"?de:de.value);return ft(j)}};mt=He([b],mt),e.ShellExecution=mt;var ot;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(ot=e.ShellQuoting||(e.ShellQuoting={}));var Ze;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Ze=e.TaskScope||(e.TaskScope={}));class St{constructor(j){this._callback=j}computeId(){return"customExecution"+I.generateUuid()}set callback(j){this._callback=j}get callback(){return this._callback}}e.CustomExecution=St;let _t=g=class{constructor(j,de,Te,Ve,Ye,nt){this.__deprecated=!1,this._definition=this.definition=j;let ne;typeof de=="string"?(this._name=this.name=de,this._source=this.source=Te,this.execution=Ve,ne=Ye,this.__deprecated=!0):de===Ze.Global||de===Ze.Workspace?(this.target=de,this._name=this.name=Te,this._source=this.source=Ve,this.execution=Ye,ne=nt):(this.target=de,this._name=this.name=Te,this._source=this.source=Ve,this.execution=Ye,ne=nt),typeof ne=="string"?(this._problemMatchers=[ne],this._hasDefinedMatchers=!0):Array.isArray(ne)?(this._problemMatchers=ne,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(j){this.__id=j}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof et?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof mt?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:I.generateUuid()}}get definition(){return this._definition}set definition(j){if(j==null)throw k.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=j}get scope(){return this._scope}set target(j){this.clear(),this._scope=j}get name(){return this._name}set name(j){if(typeof j!="string")throw k.illegalArgument("name");this.clear(),this._name=j}get execution(){return this._execution}set execution(j){j===null&&(j=void 0),this.clear(),this._execution=j;const de=this._definition.type;(g.EmptyType===de||g.ProcessType===de||g.ShellType===de||g.ExtensionCallbackType===de)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(j){if(Array.isArray(j))this.clear(),this._problemMatchers=j,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.clear(),this._isBackground=j}get source(){return this._source}set source(j){if(typeof j!="string"||j.length===0)throw k.illegalArgument("source must be a string of length > 0");this.clear(),this._source=j}get group(){return this._group}set group(j){j===null&&(j=void 0),this.clear(),this._group=j}get detail(){return this._detail}set detail(j){j===null&&(j=void 0),this._detail=j}get presentationOptions(){return this._presentationOptions}set presentationOptions(j){j==null&&(j=Object.create(null)),this.clear(),this._presentationOptions=j}get runOptions(){return this._runOptions}set runOptions(j){j==null&&(j=Object.create(null)),this.clear(),this._runOptions=j}};_t.ExtensionCallbackType="customExecution",_t.ProcessType="process",_t.ShellType="shell",_t.EmptyType="$empty",_t=g=He([b],_t),e.Task=_t;var gt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let at=class{constructor(j,de=ut.None){this.collapsibleState=de,D.URI.isUri(j)?this.resourceUri=j:this.label=j}};at=He([b],at),e.TreeItem=at;var ut;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let rt=class{constructor(j,de){this.id=j,this.color=de}};rt=He([b],rt),e.ThemeIcon=rt,rt.File=new rt("file"),rt.Folder=new rt("folder");let kt=class{constructor(j){this.id=j}};kt=He([b],kt),e.ThemeColor=kt;var wt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(wt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Et=class{constructor(j,de){if(typeof j!="string"&&(!j||!D.URI.isUri(j)&&!D.URI.isUri(j.uri)))throw k.illegalArgument("base");if(typeof de!="string")throw k.illegalArgument("pattern");typeof j=="string"?(this.baseFolder=D.URI.file(j),this.base=j):D.URI.isUri(j)?(this.baseFolder=j,this.base=j.fsPath):(this.baseFolder=j.uri,this.base=j.uri.fsPath),this.pattern=de}};Et=He([b],Et),e.RelativePattern=Et;let pt=class{constructor(j,de,Te,Ve){this.enabled=typeof j=="boolean"?j:!0,typeof de=="string"&&(this.condition=de),typeof Te=="string"&&(this.hitCondition=Te),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=I.generateUuid()),this._id}};pt=He([b],pt),e.Breakpoint=pt;let yt=class extends pt{constructor(j,de,Te,Ve,Ye){super(de,Te,Ve,Ye);if(j===null)throw k.illegalArgument("location");this.location=j}};yt=He([b],yt),e.SourceBreakpoint=yt;let vt=class extends pt{constructor(j,de,Te,Ve,Ye){super(de,Te,Ve,Ye);this.functionName=j}};vt=He([b],vt),e.FunctionBreakpoint=vt;let Ct=class extends pt{constructor(j,de,Te,Ve,Ye,nt,ne){super(Ve,Ye,nt,ne);if(!de)throw k.illegalArgument("dataId");this.label=j,this.dataId=de,this.canPersist=Te}};Ct=He([b],Ct),e.DataBreakpoint=Ct;let Pt=class{constructor(j,de,Te){this.command=j,this.args=de||[],this.options=Te}};Pt=He([b],Pt),e.DebugAdapterExecutable=Pt;let tt=class{constructor(j,de){this.port=j,this.host=de}};tt=He([b],tt),e.DebugAdapterServer=tt;let bt=class{constructor(j){this.path=j}};bt=He([b],bt),e.DebugAdapterNamedPipeServer=bt;let Ut=class{constructor(j){this.implementation=j}};Ut=He([b],Ut),e.DebugAdapterInlineImplementation=Ut;let Bt=class{constructor(j,de){this.range=j,this.expression=de}};Bt=He([b],Bt),e.EvaluatableExpression=Bt;var xt;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(xt=e.FileChangeType||(e.FileChangeType={}));let it=E=class extends Error{constructor(j,de=n.FileSystemProviderErrorCode.Unknown,Te){var Ve;super(D.URI.isUri(j)?j.toString(!0):j);this.code=(Ve=Te==null?void 0:Te.name)!==null&&Ve!==void 0?Ve:"Unknown",n.markAsFileSystemProviderError(this,de),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}static FileExists(j){return new E(j,n.FileSystemProviderErrorCode.FileExists,E.FileExists)}static FileNotFound(j){return new E(j,n.FileSystemProviderErrorCode.FileNotFound,E.FileNotFound)}static FileNotADirectory(j){return new E(j,n.FileSystemProviderErrorCode.FileNotADirectory,E.FileNotADirectory)}static FileIsADirectory(j){return new E(j,n.FileSystemProviderErrorCode.FileIsADirectory,E.FileIsADirectory)}static NoPermissions(j){return new E(j,n.FileSystemProviderErrorCode.NoPermissions,E.NoPermissions)}static Unavailable(j){return new E(j,n.FileSystemProviderErrorCode.Unavailable,E.Unavailable)}};it=E=He([b],it),e.FileSystemError=it;let zt=class{constructor(j,de,Te){this.start=j,this.end=de,this.kind=Te}};zt=He([b],zt),e.FoldingRange=zt;var It;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(It=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Lt;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Lt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ni;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(ni=e.CommentMode||(e.CommentMode={}));class hi{constructor(j,de=[]){this.tokenTypes=j,this.tokenModifiers=de}}e.SemanticTokensLegend=hi;function ri(q){return typeof q=="undefined"||P.isStringArray(q)}class Vt{constructor(j){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,j){this._hasLegend=!0;for(let de=0,Te=j.tokenTypes.length;de<Te;de++)this._tokenTypeStrToInt.set(j.tokenTypes[de],de);for(let de=0,Te=j.tokenModifiers.length;de<Te;de++)this._tokenModifierStrToInt.set(j.tokenModifiers[de],de)}}push(j,de,Te,Ve,Ye){if(typeof j=="number"&&typeof de=="number"&&typeof Te=="number"&&typeof Ve=="number"&&(typeof Ye=="number"||typeof Ye=="undefined"))return typeof Ye=="undefined"&&(Ye=0),this._pushEncoded(j,de,Te,Ve,Ye);if(N.isRange(j)&&typeof de=="string"&&ri(Te))return this._push(j,de,Te);throw k.illegalArgument()}_push(j,de,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(de))throw new Error("`tokenType` is not in the provided legend");const Ve=j.start.line,Ye=j.start.character,nt=j.end.character-j.start.character,ne=this._tokenTypeStrToInt.get(de);let he=0;if(Te)for(const Ie of Te){if(!this._tokenModifierStrToInt.has(Ie))throw new Error("`tokenModifier` is not in the provided legend");const Qe=this._tokenModifierStrToInt.get(Ie);he|=1<<Qe>>>0}this._pushEncoded(Ve,Ye,nt,ne,he)}_pushEncoded(j,de,Te,Ve,Ye){if(this._dataIsSortedAndDeltaEncoded&&(j<this._prevLine||j===this._prevLine&&de<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const he=this._data.length/5|0;let Ie=0,Qe=0;for(let lt=0;lt<he;lt++){let dt=this._data[5*lt],ei=this._data[5*lt+1];dt===0?(dt=Ie,ei+=Qe):dt+=Ie,this._data[5*lt]=dt,this._data[5*lt+1]=ei,Ie=dt,Qe=ei}}let nt=j,ne=de;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(nt-=this._prevLine,nt===0&&(ne-=this._prevChar)),this._data[this._dataLen++]=nt,this._data[this._dataLen++]=ne,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=Ye,this._prevLine=j,this._prevChar=de}static _sortAndDeltaEncode(j){let de=[];const Te=j.length/5|0;for(let ne=0;ne<Te;ne++)de[ne]=ne;de.sort((ne,he)=>{const Ie=j[5*ne],Qe=j[5*he];if(Ie===Qe){const lt=j[5*ne+1],dt=j[5*he+1];return lt-dt}return Ie-Qe});const Ve=new Uint32Array(j.length);let Ye=0,nt=0;for(let ne=0;ne<Te;ne++){const he=5*de[ne],Ie=j[he+0],Qe=j[he+1],lt=j[he+2],dt=j[he+3],ei=j[he+4],Ei=Ie-Ye,Di=Ei===0?Qe-nt:Qe,ti=5*ne;Ve[ti+0]=Ei,Ve[ti+1]=Di,Ve[ti+2]=lt,Ve[ti+3]=dt,Ve[ti+4]=ei,Ye=Ie,nt=Qe}return Ve}build(j){return this._dataIsSortedAndDeltaEncoded?new Wt(new Uint32Array(this._data),j):new Wt(Vt._sortAndDeltaEncode(this._data),j)}}e.SemanticTokensBuilder=Vt;class Wt{constructor(j,de){this.resultId=de,this.data=j}}e.SemanticTokens=Wt;class Tt{constructor(j,de,Te){this.start=j,this.deleteCount=de,this.data=Te}}e.SemanticTokensEdit=Tt;class fi{constructor(j,de){this.resultId=de,this.edits=j}}e.SemanticTokensEdits=fi;var jt;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(jt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var qt;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(qt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let $t=class{constructor(){}};$t.Back={iconPath:new rt("arrow-left")},$t=He([b],$t),e.QuickInputButtons=$t;var mi;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(mi=e.ExtensionKind||(e.ExtensionKind={}));class Rt{constructor(j,de,Te){this.badge=j,this.tooltip=de,this.color=Te}static validate(j){if(j.badge&&j.badge.length!==1&&j.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Rt;let Gt=class{constructor(j){this.kind=j}};Gt=He([b],Gt),e.ColorTheme=Gt;var gi;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{constructor(j,de,Te){this.mime=j,this.value=de,this.metadata=Te}static isNotebookCellOutputItem(j){return j instanceof Kt}}e.NotebookCellOutputItem=Kt;class Ht{constructor(j,de){this.outputs=j,this.metadata=de}static isNotebookCellOutput(j){return j instanceof Ht}toJSON(){let j={},de={},Te=!1;for(let Ve of this.outputs)j[Ve.mime]=Ve.value,Ve.metadata&&(de[Ve.mime]=Ve.metadata,Te=!0);return{outputKind:Yt.Rich,data:j,metadata:Te?{custom:de}:void 0}}}e.NotebookCellOutput=Ht;var Xt;(function(q){q[q.Markdown=1]="Markdown",q[q.Code=2]="Code"})(Xt=e.CellKind||(e.CellKind={}));var Yt;(function(q){q[q.Text=1]="Text",q[q.Error=2]="Error",q[q.Rich=3]="Rich"})(Yt=e.CellOutputKind||(e.CellOutputKind={}));var si;(function(q){q[q.Running=1]="Running",q[q.Idle=2]="Idle",q[q.Success=3]="Success",q[q.Error=4]="Error"})(si=e.NotebookCellRunState||(e.NotebookCellRunState={}));var Qt;(function(q){q[q.Running=1]="Running",q[q.Idle=2]="Idle"})(Qt=e.NotebookRunState||(e.NotebookRunState={}));var Le;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(Le=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Jt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Jt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Ot=class{constructor(j,de){this.label=j,this.timestamp=de}};Ot=He([b],Ot),e.TimelineItem=Ot;var ct;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(ct=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var vi;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(vi=e.StandardTokenType||(e.StandardTokenType={}));class oi{constructor(j,de){this.ranges=j,this.wordPattern=de}}e.LinkedEditingRanges=oi;var ai;(function(q){q[q.Unset=0]="Unset",q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(ai=e.TestRunState||(e.TestRunState={}));var _i;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information",q[q.Hint=3]="Hint"})(_i=e.TestMessageSeverity||(e.TestMessageSeverity={}));let Zt=class{constructor(j,de=[],Te){u.set(this,void 0),m.set(this,void 0),w.set(this,void 0),Je(this,u,j),Je(this,w,Object.freeze(de.map(Ve=>Object.freeze(Ve)))),Je(this,m,Te)}get runState(){return We(this,u)}get duration(){return We(this,m)}get messages(){return We(this,w)}};u=new WeakMap,m=new WeakMap,w=new WeakMap,Zt=He([b],Zt),e.TestState=Zt;var wi;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(wi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[118],pe([0,1,53,11,10,143,106,8,13]),function(Z,e,_,k,R,T,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function C(u,m){m?n.set(u,m):n.delete(u)}e.setWordDefinitionFor=C;function S(u){return n.get(u)}e.getWordDefinitionFor=S;class v extends T.MirrorTextModel{constructor(m,w,p,d,s,a,c,t){super(w,p,d,s);this._proxy=m,this._languageId=a,this._isDirty=c,this._notebook=t,this._isDisposed=!1}dispose(){_.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return I.equals(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===k.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},get notebook(){return m._notebook},save(){return m._save()},getText(w){return w?m._getTextInRange(w):m.getText()},get eol(){return m._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(w){return m._lineAt(w)},offsetAt(w){return m._offsetAt(w)},positionAt(w){return m._positionAt(w)},validateRange(w){return m._validateRange(w)},validatePosition(w){return m._validatePosition(w)},getWordRangeAtPosition(w,p){return m._getWordRangeAtPosition(w,p)}}}return Object.freeze(this._document)}_acceptLanguageId(m){_.ok(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){_.ok(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const w=this._validateRange(m);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const p=this._eol,d=w.start.line,s=w.end.line,a=[];a.push(this._lines[d].substring(w.start.character));for(let c=d+1;c<s;c++)a.push(this._lines[c]);return a.push(this._lines[s].substring(0,w.end.character)),a.join(p)}_lineAt(m){let w;if(m instanceof D.Position?w=m.line:typeof m=="number"&&(w=m),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new f(w,this._lines[w],w===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(m),p=this._lines[w.index].length;return new D.Position(w.index,Math.min(w.remainder,p))}_validateRange(m){if(!(m instanceof D.Range))throw new Error("Invalid argument");const w=this._validatePosition(m.start),p=this._validatePosition(m.end);return w===m.start&&p===m.end?m:new D.Range(w.line,w.character,p.line,p.character)}_validatePosition(m){if(!(m instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:w,character:p}=m,d=!1;if(w<0)w=0,p=0,d=!0;else if(w>=this._lines.length)w=this._lines.length-1,p=this._lines[w].length,d=!0;else{const s=this._lines[w].length;p<0?(p=0,d=!0):p>s&&(p=s,d=!0)}return d?new D.Position(w,p):m}_getWordRangeAtPosition(m,w){const p=this._validatePosition(m);if(!w)w=S(this._languageId);else if(R.regExpLeadsToEndlessLoop(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const d=P.getWordAtText(p.character+1,P.ensureValidWordDefinition(w),this._lines[p.line],0);if(d)return new D.Range(p.line,d.startColumn-1,p.line,d.endColumn-1)}}e.ExtHostDocumentData=v;class f{constructor(m,w,p){this._line=m,this._text=w,this._isLastLine=p}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(ge[203],pe([0,1,8,3,108,5,79,45,22,2,26]),function(Z,e,_,k,R,T,P,D,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class S{constructor(f,u,m,w){this._notebook=m,this._selector=w,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.uri=n.URI.from({scheme:"vscode-concat-doc",path:C.generateUuid()}),this._init(),this._disposables.add(u.onDidChangeDocument(d=>{const s=this._cellUris.get(d.document.uri);s!==void 0&&(this._cellLengths.changeValue(s,this._cells[s].document.getText().length+1),this._cellLines.changeValue(s,this._cells[s].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=d=>{d===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(f.onDidChangeCellLanguage(d=>p(d.document))),this._disposables.add(f.onDidChangeNotebookCells(d=>p(d.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const f=[],u=[];for(const m of this._notebook.cells)m.cellKind===D.CellKind.Code&&(!this._selector||P.score(this._selector,m.uri,m.language,!0))&&(this._cellUris.set(m.uri,this._cells.length),this._cells.push(m),f.push(m.document.getText().length+1),u.push(m.document.lineCount));this._cellLengths=new R.PrefixSumComputer(new Uint32Array(f)),this._cellLines=new R.PrefixSumComputer(new Uint32Array(u))}get version(){return this._versionId}getText(f){var u,m;if(!f){let a="";for(const c of this._cells)a+=c.document.getText()+`
`;return a=a.slice(0,-1),a}if(f.isEmpty)return"";const w=this.locationAt(f.start),p=this.locationAt(f.end),d=this._cells[(u=this._cellUris.get(w.uri))!==null&&u!==void 0?u:-1],s=this._cells[(m=this._cellUris.get(p.uri))!==null&&m!==void 0?m:-1];if(!d||!s)return"";if(d===s)return d.document.getText(new _.Range(w.range.start,p.range.end));{const a=d.document.getText(new _.Range(w.range.start,new _.Position(d.document.lineCount,0))),c=s.document.getText(new _.Range(new _.Position(0,0),p.range.end));return a+`
`+c}}offsetAt(f){const u=this._cellLines.getIndexOf(f.line),m=this._cellLengths.getAccumulatedValue(u.index-1),w=this._cells[u.index].document.offsetAt(f.with(u.remainder));return m+w}positionAt(f){if(typeof f=="number"){const m=this._cellLengths.getIndexOf(f),w=this._cellLines.getAccumulatedValue(m.index-1);return this._cells[m.index].document.positionAt(m.remainder).translate(w)}const u=this._cellUris.get(f.uri);if(u!==void 0){const m=this._cellLines.getAccumulatedValue(u-1);return new _.Position(m+f.range.start.line,f.range.start.character)}return new _.Position(0,0)}locationAt(f){_.Range.isRange(f)||(f=new _.Range(f,f));const u=this._cellLines.getIndexOf(f.start.line);let m=u;f.isEmpty||(m=this._cellLines.getIndexOf(f.end.line));const w=new _.Position(u.remainder,f.start.character),p=new _.Position(m.remainder,f.end.character),d=new _.Range(w,p),s=this._cells[u.index];return new _.Location(s.uri,s.document.validateRange(d))}contains(f){return this._cellUris.has(f)}validateRange(f){const u=this.validatePosition(f.start),m=this.validatePosition(f.end);return f.with(u,m)}validatePosition(f){const u=this._cellLines.getIndexOf(f.line),m=new _.Position(u.remainder,f.character),w=this._cells[u.index].document.validatePosition(m),p=this._cellLines.getAccumulatedValue(u.index-1);return new _.Position(p+w.line,w.character)}}e.ExtHostNotebookConcatDocument=S}),define(ge[204],pe([0,1,15,3,5,8,45]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:Object.assign(Object.assign({},P.notebookDocumentMetadataDefaults),C)})}replaceCellMetadata(C,S){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:S})}replaceCellOutput(C,S){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:C,outputs:S.map(v=>T.NotebookCellOutput.isNotebookCellOutput(v)?P.addIdToOutput(v.toJSON()):P.addIdToOutput(v))})}replaceCells(C,S,v){this._throwIfFinalized(),!(C===S&&v.length===0)&&this._collectedEdits.push({editType:1,index:C,count:S-C,cells:v.map(f=>Object.assign(Object.assign({},f),{outputs:f.outputs.map(u=>P.addIdToOutput(u))}))})}}class I extends R.Disposable{constructor(C,S,v,f,u){super();this.id=C,this._viewType=S,this._proxy=v,this._webComm=f,this.notebookData=u,this._visibleRanges=[],this._active=!1,this._visible=!1,this._onDidDispose=new k.Emitter,this._onDidReceiveMessage=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this.onDidReceiveMessage=this._onDidReceiveMessage.event,this._hasDecorationsForKey=Object.create(null),this._register(this._webComm.onDidReceiveMessage(m=>{this._onDidReceiveMessage.fire(m)}))}get viewColumn(){return this._viewColumn}set viewColumn(C){throw _.readonly("viewColumn")}get kernel(){return this._kernel}set kernel(C){throw _.readonly("kernel")}_acceptKernel(C){this._kernel=C}get visible(){return this._visible}set visible(C){throw _.readonly("visible")}_acceptVisibility(C){this._visible=C}get visibleRanges(){return this._visibleRanges}set visibleRanges(C){throw _.readonly("visibleRanges")}_acceptVisibleRanges(C){this._visibleRanges=C}get active(){return this._active}set active(C){throw _.readonly("active")}_acceptActive(C){this._active=C}get document(){return this.notebookData.notebookDocument}edit(C){const S=new D(this.document.version);return C(S),this._applyEdit(S.finalize())}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const S=[];let v=-1;for(let f=0;f<C.cellEdits.length;f++){if(v<0){S.push(C.cellEdits[f]),v++;continue}const m=S[v];if(m.editType===1&&C.cellEdits[f].editType===1){const w=C.cellEdits[f];if(w.editType!==5&&w.editType!==8&&m.index===w.index){m.cells.push(...C.cellEdits[f].cells),m.count+=C.cellEdits[f].count;continue}}S.push(C.cellEdits[f]),v++}return this._proxy.$tryApplyEdits(this._viewType,this.document.uri,C.documentVersionId,S)}setDecorations(C,S){const v=S.start===S.end;if(!(v&&!this._hasDecorationsForKey[C.key]))return v?delete this._hasDecorationsForKey[C.key]:this._hasDecorationsForKey[C.key]=!0,this._proxy.$trySetDecorations(this.id,S,C.key)}revealRange(C,S){this._proxy.$tryRevealRange(this.id,C,S||T.NotebookEditorRevealType.Default)}async postMessage(C){return this._webComm.postMessage(C)}asWebviewUri(C){return this._webComm.asWebviewUri(C)}dispose(){this._onDidDispose.fire(),super.dispose()}}e.ExtHostNotebookEditor=I}),define(ge[205],pe([0,1,8,14,3]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(D){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new R.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let I=D==="light"?_.ColorThemeKind.Light:D==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(I),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=He([Fe(0,k.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(ge[206],pe([0,1,4,60]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1),e.ITaskService=_.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[207],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=_.createDecorator("environmentVariableService");var k;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(k=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ge[208],pe([0,1,207,9]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class R{constructor(I){this.map=new Map,I.forEach((n,C)=>{const S=n.map.entries();let v=S.next();for(;!v.done;){const f=v.value[0];let u=this.map.get(f);if(u||(u=[],this.map.set(f,u)),u.length>0&&u[0].type===_.EnvironmentVariableMutatorType.Replace){v=S.next();continue}const m=v.value[1];u.unshift({extensionIdentifier:C,value:m.value,type:m.type}),v=S.next()}})}applyToProcessEnvironment(I){let n;k.isWindows&&(n={},Object.keys(I).forEach(C=>n[C.toLowerCase()]=C)),this.map.forEach((C,S)=>{const v=k.isWindows&&n[S.toLowerCase()]||S;C.forEach(f=>{switch(f.type){case _.EnvironmentVariableMutatorType.Append:I[v]=(I[v]||"")+f.value;break;case _.EnvironmentVariableMutatorType.Prepend:I[v]=f.value+(I[v]||"");break;case _.EnvironmentVariableMutatorType.Replace:I[v]=f.value;break}})})}diff(I){const n=new Map,C=new Map,S=new Map;if(I.map.forEach((v,f)=>{const u=this.map.get(f),m=T(v,u);m&&n.set(f,m)}),this.map.forEach((v,f)=>{const u=I.map.get(f),m=T(v,u);m&&S.set(f,m)}),this.map.forEach((v,f)=>{const u=I.map.get(f),m=P(v,u);m&&C.set(f,m)}),!(n.size===0&&C.size===0&&S.size===0))return{added:n,changed:C,removed:S}}}e.MergedEnvironmentVariableCollection=R;function T(D,I){if(!I)return D;const n=new Set;I.forEach(S=>n.add(S.extensionIdentifier));const C=[];return D.forEach(S=>{n.has(S.extensionIdentifier)||C.push(S)}),C.length===0?void 0:C}function P(D,I){if(!!I){const n=new Map;I.forEach(S=>n.set(S.extensionIdentifier,S));const C=[];return D.forEach(S=>{const v=n.get(S.extensionIdentifier);v&&(S.type!==v.type||S.value!==v.value)&&C.push(v)}),C.length===0?void 0:C}}}),define(ge[209],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(R){return[...R.entries()]}e.serializeEnvironmentVariableCollection=_;function k(R){return new Map(R)}e.deserializeEnvironmentVariableCollection=k}),define(ge[210],pe([0,1,172,60]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalContributionsDescriptor=e.DEFAULT_COMMANDS_TO_SKIP_SHELL=e.TERMINAL_COMMAND_ID=e.FlowControlConstants=e.TitleEventSource=e.LinuxDistro=e.ProcessState=e.DEFAULT_LOCAL_ECHO_EXCLUDE=e.SUGGESTIONS_FONT_WEIGHT=e.DEFAULT_BOLD_FONT_WEIGHT=e.DEFAULT_FONT_WEIGHT=e.MAXIMUM_FONT_WEIGHT=e.MINIMUM_FONT_WEIGHT=e.DEFAULT_LINE_HEIGHT=e.MINIMUM_LETTER_SPACING=e.DEFAULT_LETTER_SPACING=e.TERMINAL_ACTION_CATEGORY=e.TERMINAL_CONFIG_SECTION=e.TerminalCursorStyle=e.TERMINAL_CREATION_COMMANDS=e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY=e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=e.TERMINAL_VIEW_ID=void 0,e.TERMINAL_VIEW_ID="terminal",e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=new k.RawContextKey("terminalIsOpen",!1),e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=new k.RawContextKey("terminalFocus",!1),e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY="terminalShellType",e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=new k.RawContextKey(e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY,void 0),e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=new k.RawContextKey("terminalAltBufferActive",!1),e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=new k.RawContextKey("terminalA11yTreeFocus",!1),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=new k.RawContextKey("terminalTextSelected",!1),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=new k.RawContextKey("terminalFindVisible",!1),e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=new k.RawContextKey("terminalFindInputFocused",!1),e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=new k.RawContextKey("terminalFindFocused",!1),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=new k.RawContextKey("terminalProcessSupported",!1),e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY="terminal.integrated.isWorkspaceShellAllowed",e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY="terminal.integrated.neverMeasureRenderTime",e.TERMINAL_CREATION_COMMANDS=["workbench.action.terminal.toggleTerminal","workbench.action.terminal.new","workbench.action.togglePanel","workbench.action.terminal.focus"],e.TerminalCursorStyle={BLOCK:"block",LINE:"line",UNDERLINE:"underline"},e.TERMINAL_CONFIG_SECTION="terminal.integrated",e.TERMINAL_ACTION_CATEGORY=_.localize(0,null),e.DEFAULT_LETTER_SPACING=0,e.MINIMUM_LETTER_SPACING=-5,e.DEFAULT_LINE_HEIGHT=1,e.MINIMUM_FONT_WEIGHT=1,e.MAXIMUM_FONT_WEIGHT=1e3,e.DEFAULT_FONT_WEIGHT="normal",e.DEFAULT_BOLD_FONT_WEIGHT="bold",e.SUGGESTIONS_FONT_WEIGHT=["normal","bold","100","200","300","400","500","600","700","800","900"],e.DEFAULT_LOCAL_ECHO_EXCLUDE=["vim","vi","nano","tmux"];var R;(function(n){n[n.UNINITIALIZED=0]="UNINITIALIZED",n[n.LAUNCHING=1]="LAUNCHING",n[n.RUNNING=2]="RUNNING",n[n.KILLED_DURING_LAUNCH=3]="KILLED_DURING_LAUNCH",n[n.KILLED_BY_USER=4]="KILLED_BY_USER",n[n.KILLED_BY_PROCESS=5]="KILLED_BY_PROCESS"})(R=e.ProcessState||(e.ProcessState={}));var T;(function(n){n[n.Fedora=0]="Fedora",n[n.Ubuntu=1]="Ubuntu",n[n.Unknown=2]="Unknown"})(T=e.LinuxDistro||(e.LinuxDistro={}));var P;(function(n){n[n.Api=0]="Api",n[n.Process=1]="Process",n[n.Sequence=2]="Sequence"})(P=e.TitleEventSource||(e.TitleEventSource={}));var D;(function(n){n[n.HighWatermarkChars=1e5]="HighWatermarkChars",n[n.LowWatermarkChars=5e3]="LowWatermarkChars",n[n.CharCountAckSize=5e3]="CharCountAckSize"})(D=e.FlowControlConstants||(e.FlowControlConstants={}));var I;(function(n){n.FIND_NEXT="workbench.action.terminal.findNext",n.FIND_PREVIOUS="workbench.action.terminal.findPrevious",n.TOGGLE="workbench.action.terminal.toggleTerminal",n.KILL="workbench.action.terminal.kill",n.QUICK_KILL="workbench.action.terminal.quickKill",n.CONFIGURE_TERMINAL_SETTINGS="workbench.action.terminal.openSettings",n.COPY_SELECTION="workbench.action.terminal.copySelection",n.SELECT_ALL="workbench.action.terminal.selectAll",n.DELETE_WORD_LEFT="workbench.action.terminal.deleteWordLeft",n.DELETE_WORD_RIGHT="workbench.action.terminal.deleteWordRight",n.DELETE_TO_LINE_START="workbench.action.terminal.deleteToLineStart",n.MOVE_TO_LINE_START="workbench.action.terminal.moveToLineStart",n.MOVE_TO_LINE_END="workbench.action.terminal.moveToLineEnd",n.NEW="workbench.action.terminal.new",n.NEW_WITH_CWD="workbench.action.terminal.newWithCwd",n.NEW_LOCAL="workbench.action.terminal.newLocal",n.NEW_IN_ACTIVE_WORKSPACE="workbench.action.terminal.newInActiveWorkspace",n.SPLIT="workbench.action.terminal.split",n.SPLIT_IN_ACTIVE_WORKSPACE="workbench.action.terminal.splitInActiveWorkspace",n.RELAUNCH="workbench.action.terminal.relaunch",n.FOCUS_PREVIOUS_PANE="workbench.action.terminal.focusPreviousPane",n.FOCUS_NEXT_PANE="workbench.action.terminal.focusNextPane",n.RESIZE_PANE_LEFT="workbench.action.terminal.resizePaneLeft",n.RESIZE_PANE_RIGHT="workbench.action.terminal.resizePaneRight",n.RESIZE_PANE_UP="workbench.action.terminal.resizePaneUp",n.RESIZE_PANE_DOWN="workbench.action.terminal.resizePaneDown",n.FOCUS="workbench.action.terminal.focus",n.FOCUS_NEXT="workbench.action.terminal.focusNext",n.FOCUS_PREVIOUS="workbench.action.terminal.focusPrevious",n.PASTE="workbench.action.terminal.paste",n.SELECT_DEFAULT_SHELL="workbench.action.terminal.selectDefaultShell",n.RUN_SELECTED_TEXT="workbench.action.terminal.runSelectedText",n.RUN_ACTIVE_FILE="workbench.action.terminal.runActiveFile",n.SWITCH_TERMINAL="workbench.action.terminal.switchTerminal",n.SCROLL_DOWN_LINE="workbench.action.terminal.scrollDown",n.SCROLL_DOWN_PAGE="workbench.action.terminal.scrollDownPage",n.SCROLL_TO_BOTTOM="workbench.action.terminal.scrollToBottom",n.SCROLL_UP_LINE="workbench.action.terminal.scrollUp",n.SCROLL_UP_PAGE="workbench.action.terminal.scrollUpPage",n.SCROLL_TO_TOP="workbench.action.terminal.scrollToTop",n.CLEAR="workbench.action.terminal.clear",n.CLEAR_SELECTION="workbench.action.terminal.clearSelection",n.MANAGE_WORKSPACE_SHELL_PERMISSIONS="workbench.action.terminal.manageWorkspaceShellPermissions",n.RENAME="workbench.action.terminal.rename",n.RENAME_WITH_ARG="workbench.action.terminal.renameWithArg",n.FIND_FOCUS="workbench.action.terminal.focusFind",n.FIND_HIDE="workbench.action.terminal.hideFind",n.QUICK_OPEN_TERM="workbench.action.quickOpenTerm",n.SCROLL_TO_PREVIOUS_COMMAND="workbench.action.terminal.scrollToPreviousCommand",n.SCROLL_TO_NEXT_COMMAND="workbench.action.terminal.scrollToNextCommand",n.SELECT_TO_PREVIOUS_COMMAND="workbench.action.terminal.selectToPreviousCommand",n.SELECT_TO_NEXT_COMMAND="workbench.action.terminal.selectToNextCommand",n.SELECT_TO_PREVIOUS_LINE="workbench.action.terminal.selectToPreviousLine",n.SELECT_TO_NEXT_LINE="workbench.action.terminal.selectToNextLine",n.TOGGLE_ESCAPE_SEQUENCE_LOGGING="toggleEscapeSequenceLogging",n.SEND_SEQUENCE="workbench.action.terminal.sendSequence",n.TOGGLE_FIND_REGEX="workbench.action.terminal.toggleFindRegex",n.TOGGLE_FIND_WHOLE_WORD="workbench.action.terminal.toggleFindWholeWord",n.TOGGLE_FIND_CASE_SENSITIVE="workbench.action.terminal.toggleFindCaseSensitive",n.NAVIGATION_MODE_EXIT="workbench.action.terminal.navigationModeExit",n.NAVIGATION_MODE_FOCUS_NEXT="workbench.action.terminal.navigationModeFocusNext",n.NAVIGATION_MODE_FOCUS_PREVIOUS="workbench.action.terminal.navigationModeFocusPrevious",n.SHOW_ENVIRONMENT_INFORMATION="workbench.action.terminal.showEnvironmentInformation",n.SEARCH_WORKSPACE="workbench.action.terminal.searchWorkspace",n.ATTACH_TO_REMOTE_TERMINAL="workbench.action.terminal.attachToSession"})(I=e.TERMINAL_COMMAND_ID||(e.TERMINAL_COMMAND_ID={})),e.DEFAULT_COMMANDS_TO_SKIP_SHELL=["workbench.action.terminal.clearSelection","workbench.action.terminal.clear","workbench.action.terminal.copySelection","workbench.action.terminal.deleteToLineStart","workbench.action.terminal.deleteWordLeft","workbench.action.terminal.deleteWordRight","workbench.action.terminal.focusFind","workbench.action.terminal.hideFind","workbench.action.terminal.findNext","workbench.action.terminal.findPrevious","workbench.action.terminal.toggleFindRegex","workbench.action.terminal.toggleFindWholeWord","workbench.action.terminal.toggleFindCaseSensitive","workbench.action.terminal.focusNextPane","workbench.action.terminal.focusNext","workbench.action.terminal.focusPreviousPane","workbench.action.terminal.focusPrevious","workbench.action.terminal.focus","workbench.action.terminal.kill","workbench.action.terminal.moveToLineEnd","workbench.action.terminal.moveToLineStart","workbench.action.terminal.newInActiveWorkspace","workbench.action.terminal.new","workbench.action.terminal.paste","workbench.action.terminal.resizePaneDown","workbench.action.terminal.resizePaneLeft","workbench.action.terminal.resizePaneRight","workbench.action.terminal.resizePaneUp","workbench.action.terminal.runActiveFile","workbench.action.terminal.runSelectedText","workbench.action.terminal.scrollDown","workbench.action.terminal.scrollDownPage","workbench.action.terminal.scrollToBottom","workbench.action.terminal.scrollToNextCommand","workbench.action.terminal.scrollToPreviousCommand","workbench.action.terminal.scrollToTop","workbench.action.terminal.scrollUp","workbench.action.terminal.scrollUpPage","workbench.action.terminal.sendSequence","workbench.action.terminal.selectAll","workbench.action.terminal.selectToNextCommand","workbench.action.terminal.selectToNextLine","workbench.action.terminal.selectToPreviousCommand","workbench.action.terminal.selectToPreviousLine","workbench.action.terminal.splitInActiveWorkspace","workbench.action.terminal.split","workbench.action.terminal.toggleTerminal","workbench.action.terminal.navigationModeExit","workbench.action.terminal.navigationModeFocusNext","workbench.action.terminal.navigationModeFocusPrevious","editor.action.toggleTabFocusMode","workbench.action.quickOpen","workbench.action.quickOpenPreviousEditor","workbench.action.showCommands","workbench.action.tasks.build","workbench.action.tasks.restartTask","workbench.action.tasks.runTask","workbench.action.tasks.reRunTask","workbench.action.tasks.showLog","workbench.action.tasks.showTasks","workbench.action.tasks.terminate","workbench.action.tasks.test","workbench.action.toggleFullScreen","workbench.action.terminal.focusAtIndex1","workbench.action.terminal.focusAtIndex2","workbench.action.terminal.focusAtIndex3","workbench.action.terminal.focusAtIndex4","workbench.action.terminal.focusAtIndex5","workbench.action.terminal.focusAtIndex6","workbench.action.terminal.focusAtIndex7","workbench.action.terminal.focusAtIndex8","workbench.action.terminal.focusAtIndex9","workbench.action.focusSecondEditorGroup","workbench.action.focusThirdEditorGroup","workbench.action.focusFourthEditorGroup","workbench.action.focusFifthEditorGroup","workbench.action.focusSixthEditorGroup","workbench.action.focusSeventhEditorGroup","workbench.action.focusEighthEditorGroup","workbench.action.focusNextPart","workbench.action.focusPreviousPart","workbench.action.nextPanelView","workbench.action.previousPanelView","workbench.action.nextSideBarView","workbench.action.previousSideBarView","workbench.action.debug.start","workbench.action.debug.stop","workbench.action.debug.run","workbench.action.debug.restart","workbench.action.debug.continue","workbench.action.debug.pause","workbench.action.debug.stepInto","workbench.action.debug.stepOut","workbench.action.debug.stepOver","workbench.action.nextEditor","workbench.action.previousEditor","workbench.action.nextEditorInGroup","workbench.action.previousEditorInGroup","workbench.action.openNextRecentlyUsedEditor","workbench.action.openPreviousRecentlyUsedEditor","workbench.action.openNextRecentlyUsedEditorInGroup","workbench.action.openPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenPreviousRecentlyUsedEditor","workbench.action.quickOpenLeastRecentlyUsedEditor","workbench.action.quickOpenPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenLeastRecentlyUsedEditorInGroup","workbench.action.focusActiveEditorGroup","workbench.action.focusFirstEditorGroup","workbench.action.focusLastEditorGroup","workbench.action.firstEditorInGroup","workbench.action.lastEditorInGroup","workbench.action.navigateUp","workbench.action.navigateDown","workbench.action.navigateRight","workbench.action.navigateLeft","workbench.action.togglePanel","workbench.action.quickOpenView","workbench.action.toggleMaximizedPanel"],e.terminalContributionsDescriptor={extensionPoint:"terminal",defaultExtensionKind:"workspace",jsonSchema:{description:_.localize(1,null),type:"object",properties:{types:{type:"array",description:_.localize(2,null),items:{type:"object",required:["command","title"],properties:{command:{description:_.localize(3,null),type:"string"},title:{description:_.localize(4,null),type:"string"}}}}}}}}),define(ge[211],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(R){this._callback=R,this._terminalBufferMap=new Map}dispose(){for(const R of this._terminalBufferMap.values())R.dispose()}startBuffering(R,T,P=5){let D;return D=T(I=>{const n=typeof I=="string"?I:I.data;let C=this._terminalBufferMap.get(R);if(C){C.data.push(n);return}const S=setTimeout(()=>this._flushBuffer(R),P);C={data:[n],timeoutId:S,dispose:()=>{clearTimeout(S),this._flushBuffer(R),D.dispose()}},this._terminalBufferMap.set(R,C)}),D}stopBuffering(R){const T=this._terminalBufferMap.get(R);T&&T.dispose()}_flushBuffer(R){const T=this._terminalBufferMap.get(R);T&&(this._terminalBufferMap.delete(R),this._callback(R,T.data.join("")))}}e.TerminalDataBufferer=_}),define(ge[212],pe([0,1,7,9,132]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function T(c,t){if(!!t)if(k.isWindows)for(const r in t){let o=r;for(const i in c)if(r.toLowerCase()===i.toLowerCase()){o=i;break}const l=t[r];P(c,o,l)}else Object.keys(t).forEach(r=>{const o=t[r];P(c,r,o)})}e.mergeEnvironments=T;function P(c,t,r){typeof r=="string"?c[t]=r:delete c[t]}function D(c,t,r,o){c.TERM_PROGRAM="vscode",t&&(c.TERM_PROGRAM_VERSION=t),C(c,o)&&(c.LANG=S(r)),c.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=D;function I(c,t){if(!!t)for(const r of Object.keys(t)){const o=t[r];o&&(c[r]=o)}}function n(c,t){return Object.keys(t).forEach(r=>{const o=t[r];if(typeof o=="string")try{t[r]=c(o)}catch(l){t[r]=o}}),t}function C(c,t){if(t==="on")return!0;if(t==="auto"){const r=c.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=C;function S(c){const t=c?c.split("-"):[],r=t.length;if(r===0)return"en_US.UTF-8";if(r===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=S;function v(c,t,r,o,l,i){if(c.cwd){const y=typeof c.cwd=="object"?c.cwd.fsPath:c.cwd,g=f(y,r);return u(g||y)}let h;return!c.ignoreConfigurationCwd&&l&&(r&&(l=f(l,r,i)),l&&(_.isAbsolute(l)?h=l:o&&(h=_.join(o.fsPath,l)))),h||(h=o?o.fsPath:t||""),u(h)}e.getCwd=v;function f(c,t,r){if(t)try{return t(c)}catch(o){r==null||r.error("Could not resolve terminal cwd",o);return}return c}function u(c){return k.platform===3&&c&&c[1]===":"?c[0].toUpperCase()+c.substr(1):c}function m(c){let t=c;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\")),t.indexOf(" ")!==-1&&(t=t.replace(/ /g,"\\ "));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(r,""),`'${t}'`}e.escapeNonWindowsPath=m;function w(c,t){if(!!t)return r=>t.resolve(c,r)}e.createVariableResolver=w;function p(c,t,r,o,l,i,h,y,g=k.platform){let E=null;y&&(E=s(c,t,"automationShell",g)),E||(E=s(c,t,"shell",g));let b=E||r;if(g===3&&!o&&l){const L=_.join(l,"Sysnative").replace(/\//g,"\\").toLowerCase();b&&b.toLowerCase().indexOf(L)===0&&(b=_.join(l,"System32",b.substr(L.length+1)))}if(b&&g===3&&(b=b.replace(/\//g,"\\")),i)try{b=i(b)}catch(L){h.error("Could not resolve shell",L)}return b}e.getDefaultShell=p;function d(c,t,r,o,l,i=k.platform){if(r&&s(c,t,"automationShell",i))return[];const h=i===3?"windows":i===1?"osx":"linux",y=c(`terminal.integrated.shellArgs.${h}`);let g=(t?y.value:y.userValue)||y.defaultValue;if(!g)return[];if(typeof g=="string"&&i===3)return o?o(g):g;if(o){const E=[];for(const b of g)try{E.push(o(b))}catch(L){l.error(`Could not resolve terminal.integrated.shellArgs.${h}`,L),E.push(b)}g=E}return g}e.getDefaultShellArgs=d;function s(c,t,r,o=k.platform){const i=c(`terminal.integrated.${r}.${o===3?"windows":o===1?"osx":"linux"}`);return(t?i.value:i.userValue)||i.defaultValue}function a(c,t,r,o,l,i,h){let y={};if(c.strictEnv)I(y,c.env);else{I(y,h);const g=Object.assign({},o?t.value:t.userValue);r&&(g&&n(r,g),c.env&&n(r,c.env)),R.sanitizeProcessEnvironment(y,"VSCODE_IPC_HOOK_CLI"),T(y,g),T(y,c.env),D(y,l,k.locale,i)}return y}e.createTerminalEnvironment=a});var ii=this&&this.__asyncValues||function(Z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Z[Symbol.asyncIterator],_;return e?e.call(Z):(Z=typeof __values=="function"?__values(Z):Z[Symbol.iterator](),_={},k("next"),k("throw"),k("return"),_[Symbol.asyncIterator]=function(){return this},_);function k(T){_[T]=Z[T]&&function(P){return new Promise(function(D,I){P=Z[T](P),R(D,I,P.done,P.value)})}}function R(T,P,D,I){Promise.resolve(I).then(function(n){T({value:n,done:D})},P)}};define(ge[119],pe([0,1,34,9,24,210,13,7,101]),function(Z,e,_,k,R,T,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableShells=e.getWindowsBuildNumber=e.linuxDistro=void 0;let n=T.LinuxDistro.Unknown;if(k.isLinux){const m="/etc/os-release";R.fileExists(m).then(async w=>{if(!!w){const d=(await R.readFile(m)).toString();/NAME="?Fedora"?/.test(d)?n=T.LinuxDistro.Fedora:/NAME="?Ubuntu"?/.test(d)&&(n=T.LinuxDistro.Ubuntu)}})}e.linuxDistro=n;function C(){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let w=0;return m&&m.length===4&&(w=parseInt(m[3])),w}e.getWindowsBuildNumber=C;function S(){return k.isWindows?v():f()}e.detectAvailableShells=S;async function v(){var m,w;const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${process.env.windir}\\${p?"Sysnative":"System32"}`;let s=!1;C()>=16299&&(s=!0);const a={"Command Prompt":[`${d}\\cmd.exe`],"WSL Bash":[`${d}\\${s?"wsl.exe":"bash.exe"}`],"Git Bash":[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`]};try{for(var c=ii(I.enumeratePowerShellInstallations()),t;t=await c.next(),!t.done;){const l=t.value;a[l.displayName]=[l.exePath]}}catch(l){m={error:l}}finally{try{t&&!t.done&&(w=c.return)&&await w.call(c)}finally{if(m)throw m.error}}const r=[];Object.keys(a).forEach(l=>r.push(u(l,a[l])));const o=await Promise.all(r);return P.coalesce(o)}async function f(){return(await R.readFile("/etc/shells","utf8")).split(`
`).filter(p=>p.trim().indexOf("#")!==0&&p.trim().length>0).map(p=>({label:D.basename(p),path:p}))}async function u(m,w){if(w.length===0)return Promise.resolve(void 0);const p=w.shift();if(p==="")return u(m,w);try{const d=await R.stat(D.normalize(p));if(d.isFile()||d.isSymbolicLink())return{label:m,path:p}}catch(d){try{const s=await R.lstat(D.normalize(p));if(s.isFile()||s.isSymbolicLink())return{label:m,path:p}}catch(s){}}return u(m,w)}}),define(ge[120],pe([0,1,9,24,7,16,25]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getMainProcessParentEnv=void 0;let D;async function I(C=process.env){if(D)return D;if(_.isLinux){const S=process.ppid,v=R.basename(process.argv[0]);let f=0,u=S,m=v;do f=u,(await k.readFile(`/proc/${f}/status`,"utf8")).split(`
`).forEach(a=>{a.indexOf("Name:")===0&&(m=a.replace(/^Name:\s+/,"")),a.indexOf("PPid:")===0&&(u=parseInt(a.replace(/^PPid:\s+/,"")))});while(m===v);const w=await k.readFile(`/proc/${f}/environ`,"utf8"),p={};w.split("\0").forEach(d=>{const s=d.indexOf("=");p[d.substr(0,s)]=d.substr(s+1)}),D=p}return _.isMacintosh&&(D={},["SHELL","SSH_AUTH_SOCK","Apple_PubSub_Socket_Render","XPC_FLAGS","XPC_SERVICE_NAME","HOME","LOGNAME","TMPDIR"].forEach(v=>{C[v]&&(D[v]=C[v])})),_.isWindows&&(D=C),D}e.getMainProcessParentEnv=I;async function n(C,S,v,f=process.env){if(R.isAbsolute(C))return await k.exists(C)?C:void 0;if(S===void 0&&(S=process.cwd()),R.dirname(C)!=="."){const p=R.join(S,C);return await k.exists(p)?p:void 0}const m=P.getCaseInsensitive(f,"PATH");if(v===void 0&&T.isString(m)&&(v=m.split(R.delimiter)),v===void 0||v.length===0){const p=R.join(S,C);return await k.exists(p)?p:void 0}for(let p of v){let d;if(R.isAbsolute(p)?d=R.join(p,C):d=R.join(S,p,C),await k.exists(d))return d;if(_.isWindows){let s=d+".com";if(await k.exists(s)||(s=d+".exe",await k.exists(s)))return s}}const w=R.join(S,C);return await k.exists(w)?w:void 0}e.findExecutable=n}),define(ge[213],pe([0,1,7,9,39,34,3,119,5,35,12,24,120,2,173]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProcess=void 0;const m=50,w=5;let p=class extends I.Disposable{constructor(a,c,t,r,o,l,i,h){var y;super();this._shellLaunchConfig=a,this._executableEnv=l,this._logService=h,this._currentTitle="",this._isDisposed=!1,this._titleInterval=null,this._writeQueue=[],this._isPtyPaused=!1,this._unacknowledgedCharCount=0,this._onProcessData=this._register(new P.Emitter),this._onProcessExit=this._register(new P.Emitter),this._onProcessReady=this._register(new P.Emitter),this._onProcessTitleChanged=this._register(new P.Emitter);let g;k.isWindows?g=_.basename(this._shellLaunchConfig.executable||""):g="xterm-256color",this._initialCwd=c;const E=i&&process.platform==="win32"&&D.getWindowsBuildNumber()>=18309;this._ptyOptions={name:g,cwd:c,env:o,cols:t,rows:r,useConpty:E,conptyInheritCursor:E&&!!a.initialText},k.isWindows&&E&&t===0&&r===0&&((y=this._shellLaunchConfig.executable)===null||y===void 0?void 0:y.endsWith("Git\\bin\\bash.exe"))&&(this._delayedResizer=new d,this._register(this._delayedResizer.onTrigger(b=>{var L;(L=this._delayedResizer)===null||L===void 0||L.dispose(),this._delayedResizer=void 0,b.cols&&b.rows&&this.resize(b.cols,b.rows)})))}get exitMessage(){return this._exitMessage}get onProcessData(){return this._onProcessData.event}get onProcessExit(){return this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}get onProcessTitleChanged(){return this._onProcessTitleChanged.event}async start(){const c=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(t=>t!==void 0);if(c)return c;try{await this.setupPtyProcess(this._shellLaunchConfig,this._ptyOptions);return}catch(t){return this._logService.trace("IPty#spawn native exception",t),{message:`A native exception occurred during launch (${t.message})`}}}async _validateCwd(){try{if(!(await S.stat(this._initialCwd)).isDirectory())return{message:u.localize(0,null,this._initialCwd.toString())}}catch(a){if((a==null?void 0:a.code)==="ENOENT")return{message:u.localize(1,null,this._initialCwd.toString())}}}async _validateExecutable(){const a=this._shellLaunchConfig;if(!a.executable)throw new Error("IShellLaunchConfig.executable not set");try{const c=await S.stat(a.executable);if(!c.isFile()&&!c.isSymbolicLink())return{message:u.localize(2,null,a.executable)}}catch(c){if((c==null?void 0:c.code)==="ENOENT"){let t=a.cwd instanceof f.URI?a.cwd.path:a.cwd;const r=a.env&&a.env.PATH?a.env.PATH.split(_.delimiter):void 0;if(!await v.findExecutable(a.executable,t,r,this._executableEnv))return{message:u.localize(3,null,a.executable)}}}}async setupPtyProcess(a,c){const t=a.args||[];this._logService.trace("IPty#spawn",a.executable,t,c);const r=(await new Promise((o,l)=>{Z(["node-pty"],o,l)})).spawn(a.executable,t,c);this._ptyProcess=r,this._processStartupComplete=new Promise(o=>{this.onProcessReady(()=>o())}),r.onData(o=>{this._shellLaunchConfig.flowControl&&(this._unacknowledgedCharCount+=o.length,!this._isPtyPaused&&this._unacknowledgedCharCount>1e5&&(this._logService.trace(`Flow control: Pause (${this._unacknowledgedCharCount} > ${1e5})`),this._isPtyPaused=!0,r.pause())),this._onProcessData.fire(o),this._closeTimeout&&(clearTimeout(this._closeTimeout),this._queueProcessExit())}),r.onExit(o=>{this._exitCode=o.exitCode,this._queueProcessExit()}),this._setupTitlePolling(r),this._sendProcessId(r.pid)}dispose(){this._isDisposed=!0,this._titleInterval&&clearInterval(this._titleInterval),this._titleInterval=null,this._onProcessData.dispose(),this._onProcessExit.dispose(),this._onProcessReady.dispose(),this._onProcessTitleChanged.dispose(),super.dispose()}_setupTitlePolling(a){setTimeout(()=>{this._sendProcessTitle(a)},0),k.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==a.process&&this._sendProcessTitle(a)},200))}_queueProcessExit(){this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>this._kill(),250)}async _kill(){if(await this._processStartupComplete,!this._isDisposed){try{this._ptyProcess&&(this._logService.trace("IPty#kill"),this._ptyProcess.kill())}catch(a){}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}_sendProcessId(a){this._onProcessReady.fire({pid:a,cwd:this._initialCwd})}_sendProcessTitle(a){this._isDisposed||(this._currentTitle=a.process,this._onProcessTitleChanged.fire(this._currentTitle))}async shutdown(a){a?await this._kill():this._queueProcessExit()}input(a){if(!(this._isDisposed||!this._ptyProcess)){for(let c=0;c<=Math.floor(a.length/m);c++)this._writeQueue.push(a.substr(c*m,m));this._startWrite()}}_startWrite(){if(!(this._writeTimeout!==void 0||this._writeQueue.length===0)){if(this._doWrite(),this._writeQueue.length===0){this._writeTimeout=void 0;return}this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},w)}}_doWrite(){const a=this._writeQueue.shift();this._logService.trace("IPty#write",`${a.length} characters`),this._ptyProcess.write(a)}resize(a,c){if(!this._isDisposed&&!(typeof a!="number"||typeof c!="number"||isNaN(a)||isNaN(c))&&this._ptyProcess){if(a=Math.max(a,1),c=Math.max(c,1),this._delayedResizer){this._delayedResizer.cols=a,this._delayedResizer.rows=c;return}this._logService.trace("IPty#resize",a,c);try{this._ptyProcess.resize(a,c)}catch(t){if(this._logService.trace("IPty#resize exception "+t.message),this._exitCode!==void 0&&t.message!=="ioctl(2) failed, EBADF")throw t}}}acknowledgeDataEvent(a){var c;!this._shellLaunchConfig.flowControl||(this._unacknowledgedCharCount=Math.max(this._unacknowledgedCharCount-a,0),this._logService.trace(`Flow control: Ack ${a} chars (unacknowledged: ${this._unacknowledgedCharCount})`),this._isPtyPaused&&this._unacknowledgedCharCount<5e3&&(this._logService.trace(`Flow control: Resume (${this._unacknowledgedCharCount} < ${5e3})`),(c=this._ptyProcess)===null||c===void 0||c.resume(),this._isPtyPaused=!1))}clearUnacknowledgedChars(){var a;!this._shellLaunchConfig.flowControl||(this._unacknowledgedCharCount=0,this._logService.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this._isPtyPaused&&((a=this._ptyProcess)===null||a===void 0||a.resume(),this._isPtyPaused=!1))}getInitialCwd(){return Promise.resolve(this._initialCwd)}getCwd(){if(k.isMacintosh){const a=T.release().split(".");if(a.length>0&&parseInt(a[0])<20)return new Promise(c=>{if(!this._ptyProcess){c(this._initialCwd);return}this._logService.trace("IPty#pid"),n.exec("lsof -OPln -p "+this._ptyProcess.pid+" | grep cwd",(t,r,o)=>{!t&&r!==""?c(r.substring(r.indexOf("/"),r.length-1)):(this._logService.error("lsof did not run successfully, it may not be on the $PATH?",t,r,o),c(this._initialCwd))})})}return k.isLinux?new Promise(a=>{if(!this._ptyProcess){a(this._initialCwd);return}this._logService.trace("IPty#pid"),R.readlink("/proc/"+this._ptyProcess.pid+"/cwd",(c,t)=>{c&&a(this._initialCwd),a(t)})}):new Promise(a=>{a(this._initialCwd)})}getLatency(){return Promise.resolve(0)}};p=He([Fe(7,C.ILogService)],p),e.TerminalProcess=p;class d extends I.Disposable{constructor(){super();this._onTrigger=this._register(new P.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register({dispose:()=>{clearTimeout(this._timeout)}})}get onTrigger(){return this._onTrigger.event}dispose(){super.dispose(),clearTimeout(this._timeout)}}}),define(ge[214],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.collectTestResults=e.EMPTY_TEST_RESULT=void 0,e.EMPTY_TEST_RESULT={};const _=D=>D[0]||{};e.collectTestResults=_;var k;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.DeltaDiscoverComplete=3]="DeltaDiscoverComplete",D[D.DeltaRootsComplete=4]="DeltaRootsComplete"})(k=e.TestDiffOpType||(e.TestDiffOpType={}));const R=(D,I)=>`${D}:${I.toString()}`;e.getTestSubscriptionKey=R;class T{add(I){}update(I){}remove(I,n){}complete(){}}e.IncrementalChangeCollector=T;class P{constructor(){this.items=new Map,this.roots=new Set}apply(I){const n=this.createChangeCollector();for(const C of I)switch(C[0]){case 0:{const S=C[1];if(S.parent){if(this.items.has(S.parent)){const v=this.items.get(S.parent);v.children.add(S.id);const f=this.createItem(S,v);this.items.set(S.id,f),n.add(f)}}else{this.roots.add(S.id);const v=this.createItem(S);this.items.set(S.id,v),n.add(v)}break}case 1:{const S=C[1],v=this.items.get(S.id);v&&(Object.assign(v.item,S.item),n.update(v));break}case 2:{const S=this.items.get(C[1]);if(!S)break;S.parent?this.items.get(S.parent).children.delete(S.id):this.roots.delete(S.id);const v=[[C[1]]];for(;v.length;)for(const f of v.pop()){const u=this.items.get(f);u&&(v.push(u.children),this.items.delete(f),n.remove(u,u!==S))}break}case 3:this.updateBusyProviders(C[1]);break;case 4:this.updatePendingRoots(C[1]);break}n.complete()}updateBusyProviders(I){}updatePendingRoots(I){}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=P}),define(ge[215],pe([0,1,7,38,16,25,9,78,174]),function(Z,e,_,k,R,T,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(S,v,f){if(this._contributedVariables=new Map,this._context=S,this._labelService=v,f)if(P.isWindows){const u=Object.create(null);this._envVariables=u,Object.keys(f).forEach(m=>{u[m.toLowerCase()]=f[m]})}else this._envVariables=f}resolve(S,v){return this.recursiveResolve(S?S.uri:void 0,v)}resolveAnyBase(S,v,f,u){const m=T.deepClone(v);return P.isWindows&&m.windows?Object.keys(m.windows).forEach(w=>m[w]=m.windows[w]):P.isMacintosh&&m.osx?Object.keys(m.osx).forEach(w=>m[w]=m.osx[w]):P.isLinux&&m.linux&&Object.keys(m.linux).forEach(w=>m[w]=m.linux[w]),delete m.windows,delete m.osx,delete m.linux,this.recursiveResolve(S?S.uri:void 0,m,f,u)}resolveAny(S,v,f){return this.resolveAnyBase(S,v,f)}resolveAnyMap(S,v,f){const u=new Map;return{newConfig:this.resolveAnyBase(S,v,f,u),resolvedVariables:u}}resolveWithInteractionReplace(S,v,f,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,v,f,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,v){if(this._contributedVariables.has(S))throw new Error("Variable "+S+" is contributed twice.");this._contributedVariables.set(S,v)}recursiveResolve(S,v,f,u){if(R.isString(v))return this.resolveString(S,v,f,u);if(R.isArray(v))return v.map(m=>this.recursiveResolve(S,m,f,u));if(R.isObject(v)){let m=Object.create(null);return Object.keys(v).forEach(w=>{const p=this.resolveString(S,w,f,u);m[p]=this.recursiveResolve(S,v[w],f,u)}),m}return v}resolveString(S,v,f,u){return v.replace(n.VARIABLE_REGEXP,(w,p)=>{if(p.includes(n.VARIABLE_LHS))return w;let d=this.evaluateSingleVariable(w,p,S,f);return u&&u.set(p,d),d})}fsPath(S){return this._labelService?this._labelService.getUriLabel(S,{noPrefix:!0}):S.fsPath}evaluateSingleVariable(S,v,f,u){let m;const w=v.split(":");w.length>1&&(v=w[0],m=w[1]);const p=()=>{const a=this._context.getFilePath();if(a)return a;throw new Error(I.localize(0,null,S))},d=()=>{const a=p();if(this._context.getWorkspaceFolderPathForFile){const c=this._context.getWorkspaceFolderPathForFile();if(c)return c}throw new Error(I.localize(1,null,S,_.basename(a)))},s=()=>{if(m){const a=this._context.getFolderUri(m);if(a)return a;throw new Error(I.localize(2,null,S,m))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error(I.localize(3,null,S)):new Error(I.localize(4,null,S))};switch(v){case"env":if(m){if(this._envVariables){const a=this._envVariables[P.isWindows?m.toLowerCase():m];if(R.isString(a))return a}return""}throw new Error(I.localize(5,null,S));case"config":if(m){const a=this._context.getConfigurationValue(f,m);if(R.isUndefinedOrNull(a))throw new Error(I.localize(6,null,S,m));if(R.isObject(a))throw new Error(I.localize(7,null,S,m));return a}throw new Error(I.localize(8,null,S));case"command":return this.resolveFromMap(S,m,u,"command");case"input":return this.resolveFromMap(S,m,u,"input");default:switch(v){case"workspaceRoot":case"workspaceFolder":return D.normalizeDriveLetter(this.fsPath(s()));case"cwd":return f||m?D.normalizeDriveLetter(this.fsPath(s())):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(s()));case"lineNumber":const a=this._context.getLineNumber();if(a)return a;throw new Error(I.localize(9,null,S));case"selectedText":const c=this._context.getSelectedText();if(c)return c;throw new Error(I.localize(10,null,S));case"file":return p();case"fileWorkspaceFolder":return d();case"relativeFile":return f||m?_.relative(this.fsPath(s()),p()):p();case"relativeFileDirname":const t=_.dirname(p());if(f||m){const l=_.relative(this.fsPath(s()),t);return l.length===0?".":l}return t;case"fileDirname":return _.dirname(p());case"fileExtname":return _.extname(p());case"fileBasename":return _.basename(p());case"fileBasenameNoExtension":const r=_.basename(p());return r.slice(0,r.length-_.extname(r).length);case"fileDirnameBasename":return _.basename(_.dirname(p()));case"execPath":const o=this._context.getExecPath();return o||S;case"pathSeparator":return _.sep;default:try{return this.resolveFromMap(S,v,u,void 0)}catch(l){return S}}}}resolveFromMap(S,v,f,u){if(v&&f){const m=u===void 0?f[v]:f[u+":"+v];if(typeof m=="string")return m;throw new Error(I.localize(11,null,S))}return S}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[216],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=_.createDecorator("editorGroupsService");var k;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var R;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var P;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var I;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.EDITOR_OPEN=2]="EDITOR_OPEN",v[v.EDITOR_CLOSE=3]="EDITOR_CLOSE",v[v.EDITOR_MOVE=4]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=6]="EDITOR_LABEL",v[v.EDITOR_PIN=7]="EDITOR_PIN",v[v.EDITOR_STICKY=8]="EDITOR_STICKY",v[v.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var C;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(C=e.OpenEditorContext||(e.OpenEditorContext={}));function S(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=S}),define(ge[217],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=_.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],pe([0,1,82,8,2,44,98,111,217,16,288,58,25,13,45]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItem=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutputItem=e.NotebookCellOutput=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var m;(function(ee){function te(F){const{selectionStartLineNumber:ie,selectionStartColumn:oe,positionLineNumber:me,positionColumn:ke}=F,Re=new k.Position(ie-1,oe-1),xe=new k.Position(me-1,ke-1);return new k.Selection(Re,xe)}ee.to=te;function G(F){const{anchor:ie,active:oe}=F;return{selectionStartLineNumber:ie.line+1,selectionStartColumn:ie.character+1,positionLineNumber:oe.line+1,positionColumn:oe.character+1}}ee.from=G})(m=e.Selection||(e.Selection={}));var w;(function(ee){function te(F){if(!!F){const{start:ie,end:oe}=F;return{startLineNumber:ie.line+1,startColumn:ie.character+1,endLineNumber:oe.line+1,endColumn:oe.character+1}}}ee.from=te;function G(F){if(!!F){const{startLineNumber:ie,startColumn:oe,endLineNumber:me,endColumn:ke}=F;return new k.Range(ie-1,oe-1,me-1,ke-1)}}ee.to=G})(w=e.Range||(e.Range={}));var p;(function(ee){function te(G){switch(G){case 1:return k.StandardTokenType.Comment;case 0:return k.StandardTokenType.Other;case 4:return k.StandardTokenType.RegEx;case 2:return k.StandardTokenType.String}}ee.to=te})(p=e.TokenType||(e.TokenType={}));var d;(function(ee){function te(F){return new k.Position(F.lineNumber-1,F.column-1)}ee.to=te;function G(F){return{lineNumber:F.line+1,column:F.character+1}}ee.from=G})(d=e.Position||(e.Position={}));var s;(function(ee){function te(F){switch(F){case k.DiagnosticTag.Unnecessary:return 1;case k.DiagnosticTag.Deprecated:return 2}}ee.from=te;function G(F){switch(F){case 1:return k.DiagnosticTag.Unnecessary;case 2:return k.DiagnosticTag.Deprecated;default:return}}ee.to=G})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(ee){function te(F){let ie;return F.code&&(n.isString(F.code)||n.isNumber(F.code)?ie=String(F.code):ie={value:String(F.code.value),target:F.code.target}),Object.assign(Object.assign({},w.from(F.range)),{message:F.message,source:F.source,code:ie,severity:t.from(F.severity),relatedInformation:F.relatedInformation&&F.relatedInformation.map(c.from),tags:Array.isArray(F.tags)?f.coalesce(F.tags.map(s.from)):void 0})}ee.from=te;function G(F){var ie;const oe=new k.Diagnostic(w.to(F),F.message,t.to(F.severity));return oe.source=F.source,oe.code=n.isString(F.code)?F.code:(ie=F.code)===null||ie===void 0?void 0:ie.value,oe.relatedInformation=F.relatedInformation&&F.relatedInformation.map(c.to),oe.tags=F.tags&&f.coalesce(F.tags.map(s.to)),oe}ee.to=G})(a=e.Diagnostic||(e.Diagnostic={}));var c;(function(ee){function te(F){return Object.assign(Object.assign({},w.from(F.location.range)),{message:F.message,resource:F.location.uri})}ee.from=te;function G(F){return new k.DiagnosticRelatedInformation(new k.Location(F.resource,w.to(F)),F.message)}ee.to=G})(c=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var t;(function(ee){function te(F){switch(F){case k.DiagnosticSeverity.Error:return D.MarkerSeverity.Error;case k.DiagnosticSeverity.Warning:return D.MarkerSeverity.Warning;case k.DiagnosticSeverity.Information:return D.MarkerSeverity.Info;case k.DiagnosticSeverity.Hint:return D.MarkerSeverity.Hint}return D.MarkerSeverity.Error}ee.from=te;function G(F){switch(F){case D.MarkerSeverity.Info:return k.DiagnosticSeverity.Information;case D.MarkerSeverity.Warning:return k.DiagnosticSeverity.Warning;case D.MarkerSeverity.Error:return k.DiagnosticSeverity.Error;case D.MarkerSeverity.Hint:return k.DiagnosticSeverity.Hint;default:return k.DiagnosticSeverity.Error}}ee.to=G})(t=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var r;(function(ee){function te(F){return typeof F=="number"&&F>=k.ViewColumn.One?F-1:F===k.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}ee.from=te;function G(F){if(typeof F=="number"&&F>=0)return F+1;throw new Error("invalid 'EditorGroupColumn'")}ee.to=G})(r=e.ViewColumn||(e.ViewColumn={}));function o(ee){return typeof ee.range!="undefined"}function l(ee){return ee.length===0?!0:!!o(ee[0])}e.isDecorationOptionsArr=l;var i;(function(ee){function te(ke){return ke.map(ee.from)}ee.fromMany=te;function G(ke){return ke&&typeof ke=="object"&&typeof ke.language=="string"&&typeof ke.value=="string"}function F(ke){let Re;if(G(ke)){const{language:Ke,value:st}=ke;Re={value:"```"+Ke+`
`+st+"\n```\n"}}else k.MarkdownString.isMarkdownString(ke)?Re={value:ke.value,isTrusted:ke.isTrusted,supportThemeIcons:ke.supportThemeIcons}:typeof ke=="string"?Re={value:ke}:Re={value:""};const xe=Object.create(null);Re.uris=xe;const qe=Ke=>{try{let st=R.URI.parse(Ke,!0);st=st.with({query:ie(st.query,xe)}),xe[Ke]=st}catch(st){}return""},Ge=new C.Renderer;return Ge.link=qe,Ge.image=Ke=>qe(P.parseHrefAndDimensions(Ke).href),C(Re.value,{renderer:Ge}),Re}ee.from=F;function ie(ke,Re){if(!ke)return ke;let xe;try{xe=S.parse(ke)}catch(Ge){}if(!xe)return ke;let qe=!1;return xe=v.cloneAndChange(xe,Ge=>{if(R.URI.isUri(Ge)){const Ke=`__uri_${Math.random().toString(16).slice(2,8)}`;return Re[Ke]=Ge,qe=!0,Ke}else return}),qe?JSON.stringify(xe):ke}function oe(ke){const Re=new k.MarkdownString(ke.value,ke.supportThemeIcons);return Re.isTrusted=ke.isTrusted,Re}ee.to=oe;function me(ke){if(!!ke)return typeof ke=="string"?ke:ee.from(ke)}ee.fromStrict=me})(i=e.MarkdownString||(e.MarkdownString={}));function h(ee){return l(ee)?ee.map(te=>({range:w.from(te.range),hoverMessage:Array.isArray(te.hoverMessage)?i.fromMany(te.hoverMessage):te.hoverMessage?i.from(te.hoverMessage):void 0,renderOptions:te.renderOptions})):ee.map(te=>({range:w.from(te)}))}e.fromRangeOrRangeWithMessage=h;function y(ee){return typeof ee=="undefined"?ee:typeof ee=="string"?R.URI.file(ee):ee}e.pathOrURIToURI=y;var g;(function(ee){function te(G){return typeof G=="undefined"?G:{contentText:G.contentText,contentIconPath:G.contentIconPath?y(G.contentIconPath):void 0,border:G.border,borderColor:G.borderColor,fontStyle:G.fontStyle,fontWeight:G.fontWeight,textDecoration:G.textDecoration,color:G.color,backgroundColor:G.backgroundColor,margin:G.margin,width:G.width,height:G.height}}ee.from=te})(g=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var E;(function(ee){function te(G){return typeof G=="undefined"?G:{backgroundColor:G.backgroundColor,outline:G.outline,outlineColor:G.outlineColor,outlineStyle:G.outlineStyle,outlineWidth:G.outlineWidth,border:G.border,borderColor:G.borderColor,borderRadius:G.borderRadius,borderSpacing:G.borderSpacing,borderStyle:G.borderStyle,borderWidth:G.borderWidth,fontStyle:G.fontStyle,fontWeight:G.fontWeight,textDecoration:G.textDecoration,cursor:G.cursor,color:G.color,opacity:G.opacity,letterSpacing:G.letterSpacing,gutterIconPath:G.gutterIconPath?y(G.gutterIconPath):void 0,gutterIconSize:G.gutterIconSize,overviewRulerColor:G.overviewRulerColor,before:G.before?g.from(G.before):void 0,after:G.after?g.from(G.after):void 0}}ee.from=te})(E=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var b;(function(ee){function te(G){if(typeof G=="undefined")return G;switch(G){case k.DecorationRangeBehavior.OpenOpen:return 0;case k.DecorationRangeBehavior.ClosedClosed:return 1;case k.DecorationRangeBehavior.OpenClosed:return 2;case k.DecorationRangeBehavior.ClosedOpen:return 3}}ee.from=te})(b=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ee){function te(G){return{isWholeLine:G.isWholeLine,rangeBehavior:G.rangeBehavior?b.from(G.rangeBehavior):void 0,overviewRulerLane:G.overviewRulerLane,light:G.light?E.from(G.light):void 0,dark:G.dark?E.from(G.dark):void 0,backgroundColor:G.backgroundColor,outline:G.outline,outlineColor:G.outlineColor,outlineStyle:G.outlineStyle,outlineWidth:G.outlineWidth,border:G.border,borderColor:G.borderColor,borderRadius:G.borderRadius,borderSpacing:G.borderSpacing,borderStyle:G.borderStyle,borderWidth:G.borderWidth,fontStyle:G.fontStyle,fontWeight:G.fontWeight,textDecoration:G.textDecoration,cursor:G.cursor,color:G.color,opacity:G.opacity,letterSpacing:G.letterSpacing,gutterIconPath:G.gutterIconPath?y(G.gutterIconPath):void 0,gutterIconSize:G.gutterIconSize,overviewRulerColor:G.overviewRulerColor,before:G.before?g.from(G.before):void 0,after:G.after?g.from(G.after):void 0}}ee.from=te})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var A;(function(ee){function te(F){return{text:F.newText,eol:F.newEol&&Oe.from(F.newEol),range:w.from(F.range)}}ee.from=te;function G(F){const ie=new k.TextEdit(w.to(F.range),F.text);return ie.newEol=typeof F.eol=="undefined"?void 0:Oe.to(F.eol),ie}ee.to=G})(A=e.TextEdit||(e.TextEdit={}));var N;(function(ee){function te(F,ie,oe){var me;const ke={edits:[]};if(F instanceof k.WorkspaceEdit)for(let Re of F._allEntries())if(Re._type===1)ke.edits.push({_type:1,oldUri:Re.from,newUri:Re.to,options:Re.options,metadata:Re.metadata});else if(Re._type===2){const xe=ie==null?void 0:ie.getDocument(Re.uri);ke.edits.push({_type:2,resource:Re.uri,edit:A.from(Re.edit),modelVersionId:xe==null?void 0:xe.version,metadata:Re.metadata})}else Re._type===3&&ke.edits.push({_type:3,metadata:Re.metadata,resource:Re.uri,edit:Re.edit,notebookMetadata:Re.notebookMetadata,notebookVersionId:(me=oe==null?void 0:oe.lookupNotebookDocument(Re.uri))===null||me===void 0?void 0:me.notebookDocument.version});return ke}ee.from=te;function G(F){const ie=new k.WorkspaceEdit;for(const oe of F.edits)oe.edit?ie.replace(R.URI.revive(oe.resource),w.to(oe.edit.range),oe.edit.text):ie.renameFile(R.URI.revive(oe.oldUri),R.URI.revive(oe.newUri),oe.options);return ie}ee.to=G})(N=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(ee){const te=Object.create(null);te[k.SymbolKind.File]=0,te[k.SymbolKind.Module]=1,te[k.SymbolKind.Namespace]=2,te[k.SymbolKind.Package]=3,te[k.SymbolKind.Class]=4,te[k.SymbolKind.Method]=5,te[k.SymbolKind.Property]=6,te[k.SymbolKind.Field]=7,te[k.SymbolKind.Constructor]=8,te[k.SymbolKind.Enum]=9,te[k.SymbolKind.Interface]=10,te[k.SymbolKind.Function]=11,te[k.SymbolKind.Variable]=12,te[k.SymbolKind.Constant]=13,te[k.SymbolKind.String]=14,te[k.SymbolKind.Number]=15,te[k.SymbolKind.Boolean]=16,te[k.SymbolKind.Array]=17,te[k.SymbolKind.Object]=18,te[k.SymbolKind.Key]=19,te[k.SymbolKind.Null]=20,te[k.SymbolKind.EnumMember]=21,te[k.SymbolKind.Struct]=22,te[k.SymbolKind.Event]=23,te[k.SymbolKind.Operator]=24,te[k.SymbolKind.TypeParameter]=25;function G(ie){return typeof te[ie]=="number"?te[ie]:6}ee.from=G;function F(ie){for(const oe in te)if(te[oe]===ie)return Number(oe);return k.SymbolKind.Property}ee.to=F})(W=e.SymbolKind||(e.SymbolKind={}));var x;(function(ee){function te(F){switch(F){case k.SymbolTag.Deprecated:return 1}}ee.from=te;function G(F){switch(F){case 1:return k.SymbolTag.Deprecated}}ee.to=G})(x=e.SymbolTag||(e.SymbolTag={}));var M;(function(ee){function te(F){return{name:F.name,kind:W.from(F.kind),tags:F.tags&&F.tags.map(x.from),containerName:F.containerName,location:U.from(F.location)}}ee.from=te;function G(F){const ie=new k.SymbolInformation(F.name,W.to(F.kind),F.containerName,U.to(F.location));return ie.tags=F.tags&&F.tags.map(x.to),ie}ee.to=G})(M=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var $;(function(ee){function te(F){var ie,oe;const me={name:F.name||"!!MISSING: name!!",detail:F.detail,range:w.from(F.range),selectionRange:w.from(F.selectionRange),kind:W.from(F.kind),tags:(oe=(ie=F.tags)===null||ie===void 0?void 0:ie.map(x.from))!==null&&oe!==void 0?oe:[]};return F.children&&(me.children=F.children.map(te)),me}ee.from=te;function G(F){const ie=new k.DocumentSymbol(F.name,F.detail,W.to(F.kind),w.to(F.range),w.to(F.selectionRange));return f.isNonEmptyArray(F.tags)&&(ie.tags=F.tags.map(x.to)),F.children&&(ie.children=F.children.map(G)),ie}ee.to=G})($=e.DocumentSymbol||(e.DocumentSymbol={}));var O;(function(ee){function te(G){const F=new k.CallHierarchyItem(W.to(G.kind),G.name,G.detail||"",R.URI.revive(G.uri),w.to(G.range),w.to(G.selectionRange));return F._sessionId=G._sessionId,F._itemId=G._itemId,F}ee.to=te})(O=e.CallHierarchyItem||(e.CallHierarchyItem={}));var B;(function(ee){function te(G){return new k.CallHierarchyIncomingCall(O.to(G.from),G.fromRanges.map(F=>w.to(F)))}ee.to=te})(B=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var J;(function(ee){function te(G){return new k.CallHierarchyOutgoingCall(O.to(G.to),G.fromRanges.map(F=>w.to(F)))}ee.to=te})(J=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(ee){function te(F){return{range:F.range&&w.from(F.range),uri:F.uri}}ee.from=te;function G(F){return new k.Location(F.uri,w.to(F.range))}ee.to=G})(U=e.location||(e.location={}));var V;(function(ee){function te(F){const ie=F,oe=F;return{originSelectionRange:ie.originSelectionRange?w.from(ie.originSelectionRange):void 0,uri:ie.targetUri?ie.targetUri:oe.uri,range:w.from(ie.targetRange?ie.targetRange:oe.range),targetSelectionRange:ie.targetSelectionRange?w.from(ie.targetSelectionRange):void 0}}ee.from=te;function G(F){return{targetUri:F.uri,targetRange:w.to(F.range),targetSelectionRange:F.targetSelectionRange?w.to(F.targetSelectionRange):void 0,originSelectionRange:F.originSelectionRange?w.to(F.originSelectionRange):void 0}}ee.to=G})(V=e.DefinitionLink||(e.DefinitionLink={}));var z;(function(ee){function te(F){return{range:w.from(F.range),contents:i.fromMany(F.contents)}}ee.from=te;function G(F){return new k.Hover(F.contents.map(i.to),w.to(F.range))}ee.to=G})(z=e.Hover||(e.Hover={}));var Q;(function(ee){function te(F){return{range:w.from(F.range),expression:F.expression}}ee.from=te;function G(F){return new k.EvaluatableExpression(w.to(F.range),F.expression)}ee.to=G})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ae;(function(ee){function te(F){return{range:w.from(F.range),kind:F.kind}}ee.from=te;function G(F){return new k.DocumentHighlight(w.to(F.range),F.kind)}ee.to=G})(ae=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(ee){function te(G){switch(G){case 1:return k.CompletionTriggerKind.TriggerCharacter;case 2:return k.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return k.CompletionTriggerKind.Invoke}}ee.to=te})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var fe;(function(ee){function te(G){return{triggerKind:ce.to(G.triggerKind),triggerCharacter:G.triggerCharacter}}ee.to=te})(fe=e.CompletionContext||(e.CompletionContext={}));var we;(function(ee){function te(F){switch(F){case k.CompletionItemTag.Deprecated:return 1}}ee.from=te;function G(F){switch(F){case 1:return k.CompletionItemTag.Deprecated}}ee.to=G})(we=e.CompletionItemTag||(e.CompletionItemTag={}));var be;(function(ee){const te=new Map([[k.CompletionItemKind.Method,0],[k.CompletionItemKind.Function,1],[k.CompletionItemKind.Constructor,2],[k.CompletionItemKind.Field,3],[k.CompletionItemKind.Variable,4],[k.CompletionItemKind.Class,5],[k.CompletionItemKind.Interface,7],[k.CompletionItemKind.Struct,6],[k.CompletionItemKind.Module,8],[k.CompletionItemKind.Property,9],[k.CompletionItemKind.Unit,12],[k.CompletionItemKind.Value,13],[k.CompletionItemKind.Constant,14],[k.CompletionItemKind.Enum,15],[k.CompletionItemKind.EnumMember,16],[k.CompletionItemKind.Keyword,17],[k.CompletionItemKind.Snippet,27],[k.CompletionItemKind.Text,18],[k.CompletionItemKind.Color,19],[k.CompletionItemKind.File,20],[k.CompletionItemKind.Reference,21],[k.CompletionItemKind.Folder,23],[k.CompletionItemKind.Event,10],[k.CompletionItemKind.Operator,11],[k.CompletionItemKind.TypeParameter,24],[k.CompletionItemKind.Issue,26],[k.CompletionItemKind.User,25]]);function G(oe){var me;return(me=te.get(oe))!==null&&me!==void 0?me:9}ee.from=G;const F=new Map([[0,k.CompletionItemKind.Method],[1,k.CompletionItemKind.Function],[2,k.CompletionItemKind.Constructor],[3,k.CompletionItemKind.Field],[4,k.CompletionItemKind.Variable],[5,k.CompletionItemKind.Class],[7,k.CompletionItemKind.Interface],[6,k.CompletionItemKind.Struct],[8,k.CompletionItemKind.Module],[9,k.CompletionItemKind.Property],[12,k.CompletionItemKind.Unit],[13,k.CompletionItemKind.Value],[14,k.CompletionItemKind.Constant],[15,k.CompletionItemKind.Enum],[16,k.CompletionItemKind.EnumMember],[17,k.CompletionItemKind.Keyword],[27,k.CompletionItemKind.Snippet],[18,k.CompletionItemKind.Text],[19,k.CompletionItemKind.Color],[20,k.CompletionItemKind.File],[21,k.CompletionItemKind.Reference],[23,k.CompletionItemKind.Folder],[10,k.CompletionItemKind.Event],[11,k.CompletionItemKind.Operator],[24,k.CompletionItemKind.TypeParameter],[25,k.CompletionItemKind.User],[26,k.CompletionItemKind.Issue]]);function ie(oe){var me;return(me=F.get(oe))!==null&&me!==void 0?me:k.CompletionItemKind.Property}ee.to=ie})(be=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(ee){function te(G,F){var ie;const oe=new k.CompletionItem(typeof G.label=="string"?G.label:G.label.name);return typeof G.label!="string"&&(oe.label2=G.label),oe.insertText=G.insertText,oe.kind=be.to(G.kind),oe.tags=(ie=G.tags)===null||ie===void 0?void 0:ie.map(we.to),oe.detail=G.detail,oe.documentation=P.isMarkdownString(G.documentation)?i.to(G.documentation):G.documentation,oe.sortText=G.sortText,oe.filterText=G.filterText,oe.preselect=G.preselect,oe.commitCharacters=G.commitCharacters,T.Range.isIRange(G.range)?oe.range=w.to(G.range):typeof G.range=="object"&&(oe.range={inserting:w.to(G.range.insert),replacing:w.to(G.range.replace)}),oe.keepWhitespace=typeof G.insertTextRules=="undefined"?!1:Boolean(G.insertTextRules&1),typeof G.insertTextRules!="undefined"&&G.insertTextRules&4?oe.insertText=new k.SnippetString(G.insertText):(oe.insertText=G.insertText,oe.textEdit=oe.range instanceof k.Range?new k.TextEdit(oe.range,oe.insertText):void 0),G.additionalTextEdits&&G.additionalTextEdits.length>0&&(oe.additionalTextEdits=G.additionalTextEdits.map(me=>A.to(me))),oe.command=F&&G.command?F.fromInternal(G.command):void 0,oe}ee.to=te})(H=e.CompletionItem||(e.CompletionItem={}));var X;(function(ee){function te(F){return{label:F.label,documentation:F.documentation?i.fromStrict(F.documentation):void 0}}ee.from=te;function G(F){return{label:F.label,documentation:P.isMarkdownString(F.documentation)?i.to(F.documentation):F.documentation}}ee.to=G})(X=e.ParameterInformation||(e.ParameterInformation={}));var re;(function(ee){function te(F){return{label:F.label,documentation:F.documentation?i.fromStrict(F.documentation):void 0,parameters:Array.isArray(F.parameters)?F.parameters.map(X.from):[],activeParameter:F.activeParameter}}ee.from=te;function G(F){return{label:F.label,documentation:P.isMarkdownString(F.documentation)?i.to(F.documentation):F.documentation,parameters:Array.isArray(F.parameters)?F.parameters.map(X.to):[],activeParameter:F.activeParameter}}ee.to=G})(re=e.SignatureInformation||(e.SignatureInformation={}));var Y;(function(ee){function te(F){return{activeSignature:F.activeSignature,activeParameter:F.activeParameter,signatures:Array.isArray(F.signatures)?F.signatures.map(re.from):[]}}ee.from=te;function G(F){return{activeSignature:F.activeSignature,activeParameter:F.activeParameter,signatures:Array.isArray(F.signatures)?F.signatures.map(re.to):[]}}ee.to=G})(Y=e.SignatureHelp||(e.SignatureHelp={}));var le;(function(ee){function te(F){return{text:F.text,range:w.from(F.range),description:F.description&&i.fromStrict(F.description),whitespaceBefore:F.whitespaceBefore,whitespaceAfter:F.whitespaceAfter}}ee.from=te;function G(F){return new k.InlineHint(F.text,w.to(F.range),P.isMarkdownString(F.description)?i.to(F.description):F.description,F.whitespaceBefore,F.whitespaceAfter)}ee.to=G})(le=e.InlineHint||(e.InlineHint={}));var ve;(function(ee){function te(F){return{range:w.from(F.range),url:F.target,tooltip:F.tooltip}}ee.from=te;function G(F){let ie;if(F.url)try{ie=typeof F.url=="string"?R.URI.parse(F.url,!0):R.URI.revive(F.url)}catch(oe){}return new k.DocumentLink(w.to(F.range),ie)}ee.to=G})(ve=e.DocumentLink||(e.DocumentLink={}));var De;(function(ee){function te(F){const ie=new k.ColorPresentation(F.label);return F.textEdit&&(ie.textEdit=A.to(F.textEdit)),F.additionalTextEdits&&(ie.additionalTextEdits=F.additionalTextEdits.map(oe=>A.to(oe))),ie}ee.to=te;function G(F){return{label:F.label,textEdit:F.textEdit?A.from(F.textEdit):void 0,additionalTextEdits:F.additionalTextEdits?F.additionalTextEdits.map(ie=>A.from(ie)):void 0}}ee.from=G})(De=e.ColorPresentation||(e.ColorPresentation={}));var Me;(function(ee){function te(F){return new k.Color(F[0],F[1],F[2],F[3])}ee.to=te;function G(F){return[F.red,F.green,F.blue,F.alpha]}ee.from=G})(Me=e.Color||(e.Color={}));var Ee;(function(ee){function te(F){return{range:w.from(F.range)}}ee.from=te;function G(F){return new k.SelectionRange(w.to(F.range))}ee.to=G})(Ee=e.SelectionRange||(e.SelectionRange={}));var Pe;(function(ee){function te(G){switch(G){case 2:return k.TextDocumentSaveReason.AfterDelay;case 1:return k.TextDocumentSaveReason.Manual;case 3:case 4:return k.TextDocumentSaveReason.FocusOut}}ee.to=te})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ce;(function(ee){function te(F){switch(F){case k.TextEditorLineNumbersStyle.Off:return 0;case k.TextEditorLineNumbersStyle.Relative:return 2;case k.TextEditorLineNumbersStyle.On:default:return 1}}ee.from=te;function G(F){switch(F){case 0:return k.TextEditorLineNumbersStyle.Off;case 2:return k.TextEditorLineNumbersStyle.Relative;case 1:default:return k.TextEditorLineNumbersStyle.On}}ee.to=G})(Ce=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Oe;(function(ee){function te(F){if(F===k.EndOfLine.CRLF)return 1;if(F===k.EndOfLine.LF)return 0}ee.from=te;function G(F){if(F===1)return k.EndOfLine.CRLF;if(F===0)return k.EndOfLine.LF}ee.to=G})(Oe=e.EndOfLine||(e.EndOfLine={}));var Se;(function(ee){function te(G){if(typeof G=="object")return G.viewId;switch(G){case k.ProgressLocation.SourceControl:return 3;case k.ProgressLocation.Window:return 10;case k.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ee.from=te})(Se=e.ProgressLocation||(e.ProgressLocation={}));var Be;(function(ee){function te(G){const F={start:G.start+1,end:G.end+1};return G.kind&&(F.kind=K.from(G.kind)),F}ee.from=te})(Be=e.FoldingRange||(e.FoldingRange={}));var K;(function(ee){function te(G){if(G)switch(G){case k.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case k.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case k.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ee.from=te})(K=e.FoldingRangeKind||(e.FoldingRangeKind={}));var se;(function(ee){function te(G){if(G)return{pinned:typeof G.preview=="boolean"?!G.preview:void 0,inactive:G.background,preserveFocus:G.preserveFocus,selection:typeof G.selection=="object"?w.from(G.selection):void 0,override:typeof G.override=="boolean"?!1:void 0}}ee.from=te})(se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var _e;(function(ee){function te(F){return F instanceof k.RelativePattern||typeof F=="string"?F:G(F)?new k.RelativePattern(F.base,F.pattern):F}ee.from=te;function G(F){const ie=F;return ie&&typeof ie.base=="string"&&typeof ie.pattern=="string"}})(_e=e.GlobPattern||(e.GlobPattern={}));var Ae;(function(ee){function te(G){if(G)return Array.isArray(G)?G.map(te):typeof G=="string"?G:{language:G.language,scheme:G.scheme,pattern:typeof G.pattern=="undefined"?void 0:_e.from(G.pattern),exclusive:G.exclusive}}ee.from=te})(Ae=e.LanguageSelector||(e.LanguageSelector={}));var Ue;(function(ee){function te(G){return G.toJSON()}ee.from=te})(Ue=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ze;(function(ee){function te(G){return{outputKind:u.CellOutputKind.Rich,data:{[G.mime]:G.value},metadata:G.metadata&&{custom:G.metadata}}}ee.from=te})(ze=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var je;(function(ee){function te(oe){if(oe!=null){if(oe instanceof k.RelativePattern||typeof oe=="string")return oe;if(ie(oe))return new k.RelativePattern(oe.base,oe.pattern);if(F(oe))return{include:_e.from(oe.include)||void 0,exclude:_e.from(oe.exclude)||void 0}}}ee.from=te;function G(oe){return typeof oe=="string"?oe:ie(oe)?{base:oe.base,pattern:oe.pattern}:{include:oe.include,exclude:oe.exclude}}ee.to=G;function F(oe){const me=oe,ke=_e.from(me.include);if(!(ke&&ke instanceof k.RelativePattern||typeof ke=="string"))return!1;const Re=_e.from(me.exclude);return!!(Re&&Re instanceof k.RelativePattern||typeof Re=="string")}function ie(oe){const me=oe;return me&&typeof me.base=="string"&&typeof me.pattern=="string"}})(je=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ue;(function(ee){function te(G){return{backgroundColor:G.backgroundColor,borderColor:G.borderColor,top:G.top?g.from(G.top):void 0}}ee.from=te})(ue=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ye;(function(ee){function te(F){return{runState:F.runState,duration:F.duration,messages:F.messages.map(ie=>({message:i.fromStrict(ie.message)||"",severity:ie.severity,expectedOutput:ie.expectedOutput,actualOutput:ie.actualOutput,location:ie.location?U.from(ie.location):void 0}))}}ee.from=te;function G(F){return new k.TestState(F.runState,F.messages.map(ie=>({message:typeof ie.message=="string"?ie.message:i.to(ie.message),severity:ie.severity,expectedOutput:ie.expectedOutput,actualOutput:ie.actualOutput,location:ie.location&&U.to({range:ie.location.range,uri:R.URI.revive(ie.location.uri)})})),F.duration)}ee.to=G})(ye=e.TestState||(e.TestState={}));var Ne;(function(ee){function te(F,ie){var oe,me,ke;return{extId:(oe=F.id)!==null&&oe!==void 0?oe:ie?`${ie}\0${F.label}`:F.label,label:F.label,location:F.location?U.from(F.location):void 0,debuggable:(me=F.debuggable)!==null&&me!==void 0?me:!1,description:F.description,runnable:(ke=F.runnable)!==null&&ke!==void 0?ke:!0,state:ye.from(F.state)}}ee.from=te;function G(F){return{id:F.extId,label:F.label,location:F.location&&U.to({range:F.location.range,uri:R.URI.revive(F.location.uri)}),debuggable:F.debuggable,description:F.description,runnable:F.runnable,state:ye.to(F.state)}}ee.toShallow=G})(Ne=e.TestItem||(e.TestItem={}))}),define(ge[218],pe([0,1,2,15,8,20,73]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(n,C,S,v={timeout:1500,errors:3}){this._logService=n,this._documents=C,this._mainThreadBulkEdits=S,this._thresholds=v,this._callbacks=new P.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(C,S,v)=>{const u={dispose:this._callbacks.push([C,S,n])};return Array.isArray(v)&&v.push(u),u}}async $participateInSave(n,C){const S=_.URI.revive(n);let v=!1;const f=setTimeout(()=>v=!0,this._thresholds.timeout),u=[];try{for(let m of[...this._callbacks]){if(v)break;const w=this._documents.getDocument(S),p=await this._deliverEventAsyncAndBlameBadListeners(m,{document:w,reason:T.TextDocumentSaveReason.to(C)});u.push(p)}}finally{clearTimeout(f)}return u}_deliverEventAsyncAndBlameBadListeners([n,C,S],v){const f=this._badListeners.get(n);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(S,n,C,v).then(()=>!0,u=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this._logService.error(u),!(u instanceof Error)||u.message!=="concurrent_edits"){const m=this._badListeners.get(n);this._badListeners.set(n,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,C,S,v){const f=[],u=Date.now(),{document:m,reason:w}=v,{version:p}=m,d=Object.freeze({document:m,reason:w,waitUntil(s){if(Object.isFrozen(f))throw k.illegalState("waitUntil can not be called async");f.push(Promise.resolve(s))}});try{C.apply(S,[d])}catch(s){return Promise.reject(s)}return Object.freeze(f),new Promise((s,a)=>{const c=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-u}ms`),clearTimeout(c),s(t)}).catch(t=>{clearTimeout(c),a(t)})}).then(s=>{const a={edits:[]};for(const c of s)if(Array.isArray(c)&&c.every(t=>t instanceof R.TextEdit))for(const{newText:t,newEol:r,range:o}of c)a.edits.push({_type:2,resource:m.uri,edit:{range:o&&T.Range.from(o),text:t,eol:r&&T.EndOfLine.from(r)}});if(a.edits.length!==0)return p===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(ge[219],pe([0,1,3,33,2,20,8]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(C,S,v,f,u){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,v&&(this._config+=1),f&&(this._config+=2),u&&(this._config+=4);const m=k.parse(S),w=C(p=>{if(!v)for(let d of p.created){const s=R.URI.revive(d);m(s.fsPath)&&this._onDidCreate.fire(s)}if(!f)for(let d of p.changed){const s=R.URI.revive(d);m(s.fsPath)&&this._onDidChange.fire(s)}if(!u)for(let d of p.deleted){const s=R.URI.revive(d);m(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class I{constructor(C,S,v){this._logService=S,this._extHostDocumentsAndEditors=v,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new _.AsyncEmitter,this._onWillCreateFile=new _.AsyncEmitter,this._onWillDeleteFile=new _.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,S,v,f){return new D(this._onFileSystemEvent.event,C,S,v,f)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,S){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:S.map(v=>({oldUri:R.URI.revive(v.source),newUri:R.URI.revive(v.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:S.map(v=>R.URI.revive(v.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:S.map(v=>R.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,S){return(v,f,u)=>{const m=function(p){v.call(f,p)};return m.extension=C,S.event(m,void 0,u)}}async $onWillRunFileOperation(C,S,v,f){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:S.map(u=>({oldUri:R.URI.revive(u.source),newUri:R.URI.revive(u.target)}))},v,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:S.map(u=>R.URI.revive(u.target))},v,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:S.map(u=>R.URI.revive(u.target))},v,f)}}async _fireWillEvent(C,S,v,f){const u=new Set,m=[];if(await C.fireAsync(S,f,async(p,d)=>{var s;const a=Date.now(),c=await Promise.resolve(p);c instanceof P.WorkspaceEdit&&(m.push(c),u.add((s=d.extension.displayName)!==null&&s!==void 0?s:d.extension.identifier.value)),Date.now()-a>v&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),!f.isCancellationRequested&&m.length!==0){const w={edits:[]};for(let p of m){let{edits:d}=T.WorkspaceEdit.from(p,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(d)}return{edit:w,extensionNames:Array.from(u)}}}}e.ExtHostFileSystemEventService=I}),define(ge[220],pe([0,1,20,185,161,21,55]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(S){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=S}withProgress(S,v,f){const u=this._handles++,{title:m,location:w,cancellable:p}=v,d=R.localize(0,null,S.displayName||S.name);return this._proxy.$startProgress(u,{location:_.ProgressLocation.from(w),title:m,source:d,cancellable:p},S),this._withProgress(u,f,!!p)}_withProgress(S,v,f){let u;f&&(u=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(S,u));const m=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),u&&u.dispose()};let w;try{w=v(new n(this._proxy,S),f&&u?u.token:T.CancellationToken.None)}catch(p){throw m(S),p}return w.then(p=>m(S),p=>m(S)),w}$acceptProgressCanceled(S){const v=this._mapHandleToCancellationSource.get(S);v&&(v.cancel(),this._mapHandleToCancellationSource.delete(S))}}e.ExtHostProgress=D;function I(C,S){return C.message=S.message,typeof S.increment=="number"&&(typeof C.increment=="number"?C.increment+=S.increment:C.increment=S.increment),C}class n extends k.Progress{constructor(S,v){super(f=>this.throttledReport(f));this._proxy=S,this._handle=v}throttledReport(S){this._proxy.$progressReport(this._handle,S)}}He([P.throttle(100,(C,S)=>I(C,S),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(ge[121],pe([0,1,53,15,71,20,8]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(v,f){this.key=D._Keys.nextId(),this._proxy=v,this._proxy.$registerTextEditorDecorationType(this.key,T.DecorationRenderOptions.from(f))}dispose(){this._proxy.$removeTextEditorDecorationType(this.key)}}e.TextEditorDecorationType=D,D._Keys=new R.IdGenerator("TextEditorDecorationType");class I{constructor(v,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=v,this._documentVersionId=v.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(v,f){this._throwIfFinalized();let u=null;if(v instanceof P.Position)u=new P.Range(v,v);else if(v instanceof P.Range)u=v;else throw new Error("Unrecognized location");this._pushEdit(u,f,!1)}insert(v,f){this._throwIfFinalized(),this._pushEdit(new P.Range(v,v),f,!0)}delete(v){this._throwIfFinalized();let f=null;if(v instanceof P.Range)f=v;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(v,f,u){const m=this._document.validateRange(v);this._collectedEdits.push({range:m,text:f,forceMoveMarkers:u})}setEndOfLine(v){if(this._throwIfFinalized(),v!==P.EndOfLine.LF&&v!==P.EndOfLine.CRLF)throw k.illegalArgument("endOfLine");this._setEndOfLine=v}}e.TextEditorEdit=I;class n{constructor(v,f,u,m){this._proxy=v,this._id=f,this._accept(u),this._logService=m}_accept(v){this._tabSize=v.tabSize,this._indentSize=v.indentSize,this._insertSpaces=v.insertSpaces,this._cursorStyle=v.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(v.lineNumbers)}get tabSize(){return this._tabSize}_validateTabSize(v){if(v==="auto")return"auto";if(typeof v=="number"){const f=Math.floor(v);return f>0?f:null}if(typeof v=="string"){const f=parseInt(v,10);return isNaN(f)?null:f>0?f:null}return null}set tabSize(v){const f=this._validateTabSize(v);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}get indentSize(){return this._indentSize}_validateIndentSize(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const f=Math.floor(v);return f>0?f:null}if(typeof v=="string"){const f=parseInt(v,10);return isNaN(f)?null:f>0?f:null}return null}set indentSize(v){const f=this._validateIndentSize(v);if(f!==null){if(typeof f=="number"){if(this._indentSize===f)return;this._indentSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{indentSize:f}))}}get insertSpaces(){return this._insertSpaces}_validateInsertSpaces(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}set insertSpaces(v){const f=this._validateInsertSpaces(v);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}get cursorStyle(){return this._cursorStyle}set cursorStyle(v){this._cursorStyle!==v&&(this._cursorStyle=v,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:v})))}get lineNumbers(){return this._lineNumbers}set lineNumbers(v){this._lineNumbers!==v&&(this._lineNumbers=v,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(v)})))}assign(v){const f={};let u=!1;if(typeof v.tabSize!="undefined"){const m=this._validateTabSize(v.tabSize);m==="auto"?(u=!0,f.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,u=!0,f.tabSize=m)}if(typeof v.insertSpaces!="undefined"){const m=this._validateInsertSpaces(v.insertSpaces);m==="auto"?(u=!0,f.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,u=!0,f.insertSpaces=m)}typeof v.cursorStyle!="undefined"&&this._cursorStyle!==v.cursorStyle&&(this._cursorStyle=v.cursorStyle,u=!0,f.cursorStyle=v.cursorStyle),typeof v.lineNumbers!="undefined"&&this._lineNumbers!==v.lineNumbers&&(this._lineNumbers=v.lineNumbers,u=!0,f.lineNumbers=T.TextEditorLineNumbersStyle.from(v.lineNumbers)),u&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(v){v.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=n;class C{constructor(v,f,u,m,w,p,d,s){this.id=v,this._proxy=f,this._logService=u,this._disposed=!1,this._documentData=m,this._selections=w,this._options=new n(this._proxy,this.id,p,u),this._visibleRanges=d,this._viewColumn=s,this._hasDecorationsForKey=Object.create(null)}dispose(){_.ok(!this._disposed),this._disposed=!0}show(v){this._proxy.$tryShowEditor(this.id,T.ViewColumn.from(v))}hide(){this._proxy.$tryHideEditor(this.id)}get document(){return this._documentData.document}set document(v){throw k.readonly("document")}get options(){return this._options}set options(v){this._disposed||this._options.assign(v)}_acceptOptions(v){_.ok(!this._disposed),this._options._accept(v)}get visibleRanges(){return this._visibleRanges}set visibleRanges(v){throw k.readonly("visibleRanges")}_acceptVisibleRanges(v){_.ok(!this._disposed),this._visibleRanges=v}get viewColumn(){return this._viewColumn}set viewColumn(v){throw k.readonly("viewColumn")}_acceptViewColumn(v){_.ok(!this._disposed),this._viewColumn=v}get selection(){return this._selections&&this._selections[0]}set selection(v){if(!(v instanceof P.Selection))throw k.illegalArgument("selection");this._selections=[v],this._trySetSelection()}get selections(){return this._selections}set selections(v){if(!Array.isArray(v)||v.some(f=>!(f instanceof P.Selection)))throw k.illegalArgument("selections");this._selections=v,this._trySetSelection()}setDecorations(v,f){const u=f.length===0;u&&!this._hasDecorationsForKey[v.key]||(u?delete this._hasDecorationsForKey[v.key]:this._hasDecorationsForKey[v.key]=!0,this._runOnProxy(()=>{if(T.isDecorationOptionsArr(f))return this._proxy.$trySetDecorations(this.id,v.key,T.fromRangeOrRangeWithMessage(f));{const m=new Array(4*f.length);for(let w=0,p=f.length;w<p;w++){const d=f[w];m[4*w]=d.start.line+1,m[4*w+1]=d.start.character+1,m[4*w+2]=d.end.line+1,m[4*w+3]=d.end.character+1}return this._proxy.$trySetDecorationsFast(this.id,v.key,m)}}))}revealRange(v,f){this._runOnProxy(()=>this._proxy.$tryRevealRange(this.id,T.Range.from(v),f||P.TextEditorRevealType.Default))}_trySetSelection(){const v=this._selections.map(T.Selection.from);return this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,v))}_acceptSelections(v){_.ok(!this._disposed),this._selections=v}edit(v,f={undoStopBefore:!0,undoStopAfter:!0}){if(this._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new I(this._documentData.document,f);return v(u),this._applyEdit(u)}_applyEdit(v){const f=v.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const u=f.edits.map(w=>w.range);u.sort((w,p)=>w.end.line===p.end.line?w.end.character===p.end.character?w.start.line===p.start.line?w.start.character-p.start.character:w.start.line-p.start.line:w.end.character-p.end.character:w.end.line-p.end.line);for(let w=0,p=u.length-1;w<p;w++){const d=u[w].end;if(u[w+1].start.isBefore(d))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=f.edits.map(w=>({range:T.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,m,{setEndOfLine:typeof f.setEndOfLine=="number"?T.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}insertSnippet(v,f,u={undoStopBefore:!0,undoStopAfter:!0}){if(this._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let m;if(!f||Array.isArray(f)&&f.length===0)m=this._selections.map(w=>T.Range.from(w));else if(f instanceof P.Position){const{lineNumber:w,column:p}=T.Position.from(f);m=[{startLineNumber:w,startColumn:p,endLineNumber:w,endColumn:p}]}else if(f instanceof P.Range)m=[T.Range.from(f)];else{m=[];for(const w of f)if(w instanceof P.Range)m.push(T.Range.from(w));else{const{lineNumber:p,column:d}=T.Position.from(w);m.push({startLineNumber:p,startColumn:d,endLineNumber:p,endColumn:d})}}return this._proxy.$tryInsertSnippet(this.id,v.value,m,u)}_runOnProxy(v){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=C}),define(ge[221],pe([0,1,164,23,2,3,5,19,8,16,13,20,21]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(w,p){if(n.isString(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let d;return Array.isArray(w.highlights)&&(d=w.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),d=d.length?d:void 0),{label:w.label,highlights:d}}}class u{constructor(p,d,s){this._proxy=p,this.commands=d,this.logService=s,this.treeViews=new Map;function a(c){return c&&c.$treeViewId&&c.$treeItemHandle}d.registerArgumentProcessor({processArgument:c=>a(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(t=>a(t)?this.convertArgument(t):t):c})}registerTreeDataProvider(p,d,s){const a=this.createTreeView(p,{treeDataProvider:d},s);return{dispose:()=>a.dispose()}}createTreeView(p,d,s){if(!d||!d.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=this.createExtHostTreeView(p,d,s);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(c){a.message=c},get title(){return a.title},set title(c){a.title=c},get description(){return a.description},set description(c){a.description=c},reveal:(c,t)=>a.reveal(c,t),dispose:()=>{this.treeViews.delete(p),a.dispose()}}}$getChildren(p,d){const s=this.treeViews.get(p);return s?s.getChildren(d):Promise.reject(new Error(_.localize(0,null,p)))}async $hasResolve(p){const d=this.treeViews.get(p);if(!d)throw new Error(_.localize(1,null,p));return d.hasResolve}$resolve(p,d,s){const a=this.treeViews.get(p);if(!a)throw new Error(_.localize(2,null,p));return a.resolveTreeItem(d,s)}$setExpanded(p,d,s){const a=this.treeViews.get(p);if(!a)throw new Error(_.localize(3,null,p));a.setExpanded(d,s)}$setSelection(p,d){const s=this.treeViews.get(p);if(!s)throw new Error(_.localize(4,null,p));s.setSelection(d)}$setVisible(p,d){const s=this.treeViews.get(p);if(!s)throw new Error(_.localize(5,null,p));s.setVisible(d)}createExtHostTreeView(p,d,s){const a=new m(p,d,this._proxy,this.commands.converter,this.logService,s);return this.treeViews.set(p,a),a}convertArgument(p){const d=this.treeViews.get(p.$treeViewId);return d?d.getExtensionElement(p.$treeItemHandle):null}}e.ExtHostTreeViews=u;class m extends P.Disposable{constructor(p,d,s,a,c,t){super();if(this.viewId=p,this.proxy=s,this.commands=a,this.logService=c,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new v.CancellationTokenSource,t.contributes&&t.contributes.views)for(const l in t.contributes.views)for(const i of t.contributes.views[l])i.id===p&&(this._title=i.name);this.dataProvider=d.treeDataProvider,this.proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!d.showCollapseAll,canSelectMany:!!d.canSelectMany}),this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let r,o;this._register(T.Event.debounce(this._onDidChangeData.event,(l,i)=>(l||(l={message:!1,elements:[]}),i.element!==!1&&(r||(r=new Promise(h=>o=h),this.refreshPromise=this.refreshPromise.then(()=>r)),l.elements.push(i.element)),i.message&&(l.message=!0),l),200,!0)(({message:l,elements:i})=>{i.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=o;return r=null,this.refresh(i).then(()=>h())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!n.isUndefinedOrNull(p))}getChildren(p){const d=p?this.getExtensionElement(p):void 0;if(p&&!d)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);const s=this.getChildrenNodes(p);return(s?Promise.resolve(s):this.fetchChildrenNodes(d)).then(a=>a.map(c=>c.item))}getExtensionElement(p){return this.elements.get(p)}reveal(p,d){d=d||{select:!0,focus:!1};const s=n.isUndefinedOrNull(d.select)?!0:d.select,a=n.isUndefinedOrNull(d.focus)?!1:d.focus,c=n.isUndefinedOrNull(d.expand)?!1:d.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(t=>this.resolveTreeNode(p,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(o=>o.item)},{select:s,focus:a,expand:c})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:a,expand:c})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}setExpanded(p,d){const s=this.getExtensionElement(p);s&&(d?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelection(p){C.equals(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,d){var s;if(!!this.dataProvider.resolveTreeItem){const a=this.elements.get(p);if(a){const c=this.nodes.get(a);if(c){const t=(s=await this.dataProvider.resolveTreeItem(c.extensionItem,a,d))!==null&&s!==void 0?s:c.extensionItem;return c.item.tooltip=this.getTooltip(t.tooltip),c.item.command=this.getCommand(c.disposableStore,t.command),c.item}}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(d=>d?this.resolveUnknownParentChain(d).then(s=>this.resolveTreeNode(d,s[s.length-1]).then(a=>(s.push(a),s))):Promise.resolve([]))}resolveParent(p){const d=this.nodes.get(p);return d?Promise.resolve(d.parent?this.elements.get(d.parent.item.handle):void 0):D.asPromise(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,d){const s=this.nodes.get(p);return s?Promise.resolve(s):D.asPromise(()=>this.dataProvider.getTreeItem(p)).then(a=>this.createHandle(p,a,d,!0)).then(a=>this.getChildren(d?d.item.handle:void 0).then(()=>{const c=this.getExtensionElement(a);if(c){const t=this.nodes.get(c);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(p){if(p){let d;if(typeof p=="string"){const s=this.getExtensionElement(p);d=s?this.nodes.get(s):void 0}else d=p;return d&&d.children||null}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const d=new v.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=p?this.nodes.get(p):void 0,a=await this.dataProvider.getChildren(p);if(d.token.isCancellationRequested)return[];const c=await Promise.all(C.coalesce(a||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!d.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,s):null}));return d.token.isCancellationRequested?[]:C.coalesce(c)}finally{d.dispose()}}refresh(p){if(p.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new v.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(p);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const d=new Set;for(const a of p){const c=this.nodes.get(a);if(c&&!d.has(c.item.handle)){let t=c;for(;t&&t.parent&&!d.has(t.parent.item.handle);){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&d.add(c.item.handle)}}const s=[];return d.forEach(a=>{const c=this.elements.get(a);if(c){const t=this.nodes.get(c);t&&(!t.parent||!d.has(t.parent.item.handle))&&s.push(a)}}),s}refreshHandles(p){const d={};return Promise.all(p.map(s=>this.refreshNode(s).then(a=>{a&&(d[s]=a.item)}))).then(()=>Object.keys(d).length?this.proxy.$refresh(this.viewId,d):void 0)}refreshNode(p){const d=this.getExtensionElement(p);if(d){const s=this.nodes.get(d);if(s)return this.clearChildren(d),D.asPromise(()=>this.dataProvider.getTreeItem(d)).then(a=>{if(a){const c=this.createTreeNode(d,a,s.parent);return this.updateNodeCache(d,c,s,s.parent),s.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,d,s){const a=this.createTreeNode(p,d,s);if(d.id&&this.elements.has(a.item.handle))throw new Error(_.localize(6,null,d.id));return this.addNodeToCache(p,a),this.addNodeToParentCache(a,s),a}getTooltip(p){return I.MarkdownString.isMarkdownString(p)?S.MarkdownString.from(p):p}getCommand(p,d){return d?this.commands.toInternal(d,p):void 0}createTreeNode(p,d,s){const a=new P.DisposableStore,c=this.createHandle(p,d,s),t=this.getLightIconPath(d);return{item:{handle:c,parentHandle:s?s.item.handle:void 0,label:f(d.label,this.extension),description:d.description,resourceUri:d.resourceUri,tooltip:this.getTooltip(d.tooltip),command:this.getCommand(a,d.command),contextValue:d.contextValue,icon:t,iconDark:this.getDarkIconPath(d)||t,themeIcon:this.getThemeIcon(d),collapsibleState:n.isUndefinedOrNull(d.collapsibleState)?I.TreeItemCollapsibleState.None:d.collapsibleState,accessibilityInformation:d.accessibilityInformation},extensionItem:d,parent:s,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(p){return p.iconPath instanceof I.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:d,label:s,resourceUri:a},c,t){if(d)return`${m.ID_HANDLE_PREFIX}/${d}`;const r=f(s,this.extension),o=c?c.item.handle:m.LABEL_HANDLE_PREFIX;let l=r?r.label:a?k.basename(a):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const i=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,h=this.getChildrenNodes(c)||[];let y,g=0;do{if(y=`${o}/${g}:${l}`,t||!this.elements.has(y)||i===y)break;g++}while(g<=h.length);return y}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof I.ThemeIcon))return typeof p.iconPath=="string"||R.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof I.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return R.URI.isUri(p)?p:R.URI.file(p)}addNodeToCache(p,d){this.elements.set(d.item.handle,p),this.nodes.set(p,d)}updateNodeCache(p,d,s,a){this.elements.delete(d.item.handle),this.nodes.delete(p),d.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(p,d);const c=this.getChildrenNodes(a)||[],t=c.filter(r=>r.item.handle===s.item.handle)[0];t&&c.splice(c.indexOf(t),1,d)}addNodeToParentCache(p,d){d?(d.children||(d.children=[]),d.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const d=this.nodes.get(p);if(d){if(d.children)for(const s of d.children){const a=this.elements.get(s.item.handle);a&&this.clear(a)}d.children=void 0}}else this.clearAll()}clear(p){const d=this.nodes.get(p);if(d){if(d.children)for(const s of d.children){const a=this.elements.get(s.item.handle);a&&this.clear(a)}this.nodes.delete(p),this.elements.delete(d.item.handle),d.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}m.LABEL_HANDLE_PREFIX="0",m.ID_HANDLE_PREFIX="1"}),define(ge[222],pe([0,1,19,55,26,20]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.OwnedTestCollection=void 0;class P{constructor(){this.testIdToInternal=new Map}getTestById(v){return this.testIdToInternal.get(v)}createForHierarchy(v=()=>{}){return new D(this.testIdToInternal,v)}}e.OwnedTestCollection=P;class D{constructor(v,f){this.testIdToInternal=v,this.publishDiff=f,this.testItemToInternal=new Map,this.diff=[],this.disposed=!1,this.debounceSendDiff=new _.RunOnceScheduler(()=>this.throttleSendDiff(),2)}addRoot(v,f){this.addItem(v,f,null),this.debounceSendDiff.schedule()}getTestByReference(v){return this.testItemToInternal.get(v)}onItemChange(v,f){const u=this.testItemToInternal.get(v);if(!u){this.disposed||console.warn("Received a TestProvider.onDidChangeTest for a test that wasn't seen before as a child.");return}this.addItem(v,f,u.parent),this.debounceSendDiff.schedule()}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){this.diff.push(v),this.debounceSendDiff.schedule()}dispose(){for(const v of this.testItemToInternal.values())this.testIdToInternal.delete(v.id);this.diff=[],this.disposed=!0}getId(){return R.generateUuid()}addItem(v,f,u){let m=this.testItemToInternal.get(v);const w=u?this.testIdToInternal.get(u):null;if(m?m.previousEquals(v)||(m.item=T.TestItem.from(v,w==null?void 0:w.item.extId),m.previousEquals=C(v),this.diff.push([1,{id:m.id,parent:u,providerId:f,item:m.item}])):(m={actual:v,id:this.getId(),parent:u,item:T.TestItem.from(v,w==null?void 0:w.item.extId),providerId:f,previousChildren:new Set,previousEquals:C(v)},this.testItemToInternal.set(v,m),this.testIdToInternal.set(m.id,m),this.diff.push([0,{id:m.id,parent:u,providerId:f,item:m.item}])),v.children){const p=m.previousChildren,d=new Set;for(const s of v.children){const a=this.addItem(s,f,m.id);p.delete(a.id),d.add(a.id)}for(const s of p)this.removeItembyId(s);m.previousChildren=d}return m}removeItembyId(v){this.diff.push([2,v]);const f=[this.testIdToInternal.get(v)];for(;f.length;){const u=f.pop();if(!!u){this.testIdToInternal.delete(u.id),this.testItemToInternal.delete(u.actual);for(const m of u.previousChildren)f.push(this.testIdToInternal.get(m))}}}throttleSendDiff(){this.flushDiff()}flushDiff(){const v=this.collectDiff();v.length&&this.publishDiff(v)}}He([k.throttle(200)],D.prototype,"throttleSendDiff",null),e.SingleUseTestCollection=D;const n=Object.keys({id:null,label:null,location:null,state:null,debuggable:null,description:null,runnable:null}),C=S=>{const v=[];for(const f of n)v.push(S[f]);return f=>{for(let u=0;u<n.length;u++)if(v[u]!==f[n[u]])return!1;return!0}}}),define(ge[223],pe([0,1,29,3,7]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(C){this.removedDueToLooping=C}}e.DeltaExtensionsResult=T;class P{constructor(C){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=C,this._initialize()}_initialize(){this._extensionDescriptions.sort(I),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const C of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(C.identifier))){console.error("Extension `"+C.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(C.identifier),C),this._extensionsArr.push(C),Array.isArray(C.activationEvents))for(let S of C.activationEvents)S==="onUri"&&(S=`onUri:${_.ExtensionIdentifier.toKey(C.identifier)}`),this._activationMap.has(S)||this._activationMap.set(S,[]),this._activationMap.get(S).push(C)}}keepOnly(C){const S=new Set;C.forEach(v=>S.add(_.ExtensionIdentifier.toKey(v))),this._extensionDescriptions=this._extensionDescriptions.filter(v=>S.has(_.ExtensionIdentifier.toKey(v.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(C,S){C.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(C));const v=P._findLoopingExtensions(this._extensionDescriptions);if(S=S.concat(v.map(f=>f.identifier)),S.length>0){const f=new Set;S.forEach(u=>f.add(_.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>!f.has(_.ExtensionIdentifier.toKey(u.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(v)}static _findLoopingExtensions(C){const S=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,p){this.addNode(w),this.addNode(p),this._arcs.has(w)?this._arcs.get(w).push(p):this._arcs.set(w,[p])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,p){const d=S.getArcs(w);for(let s=0;s<d.length;s++)if(!p.has(d[s]))return!1;return!0}getNodes(){return this._nodesArr}};let v=new Map;for(let w of C){const p=_.ExtensionIdentifier.toKey(w.identifier);if(v.set(p,w),w.extensionDependencies)for(let d of w.extensionDependencies){const s=_.ExtensionIdentifier.toKey(d);S.addArc(p,s)}}let f=new Set;S.getNodes().filter(w=>S.getArcs(w).length===0).forEach(w=>f.add(w));let u=S.getNodes().filter(w=>!f.has(w)),m;do{m=!1;for(let w=0;w<u.length;w++){const p=u[w];S.hasOnlyGoodArcs(p,f)&&(u.splice(w,1),w--,f.add(p),m=!0)}}while(m);return u.map(w=>v.get(w))}containsActivationEvent(C){return this._activationMap.has(C)}containsExtension(C){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(C))}getExtensionDescriptionsForActivationEvent(C){const S=this._activationMap.get(C);return S?S.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(C){const S=this._extensionsMap.get(_.ExtensionIdentifier.toKey(C));return S||void 0}}e.ExtensionDescriptionRegistry=P;var D;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(D||(D={}));function I(n,C){const S=n.isBuiltin?0:n.isUnderDevelopment?2:1,v=C.isBuiltin?0:C.isUnderDevelopment?2:1;if(S!==v)return S-v;const f=R.posix.basename(n.extensionLocation.path),u=R.posix.basename(C.extensionLocation.path);return f<u?-1:f>u?1:0}}),define(ge[224],pe([0,1,27]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var k;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.StartTimeout60s=56]="StartTimeout60s",D[D.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function T(D){const I=_.VSBuffer.alloc(1);switch(D){case 0:I.writeUInt8(1,0);break;case 1:I.writeUInt8(2,0);break;case 2:I.writeUInt8(3,0);break}return I}e.createMessageOfType=T;function P(D,I){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return I===0;case 2:return I===1;case 3:return I===2;default:return!1}}e.isMessageOfType=P}),define(ge[42],pe([0,1,3,2,4,29,181]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=R.createDecorator("extensionService");class D{constructor(d){this.dependency=d}}e.MissingDependencyError=D;var I;(function(p){p[p.LocalProcess=0]="LocalProcess",p[p.LocalWebWorker=1]="LocalWebWorker",p[p.Remote=2]="Remote"})(I=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(d,s,a,c){this.codeLoadingTime=d,this.activateCallTime=s,this.activateResolvedTime=a,this.activationReason=c}}e.ActivationTimes=n;class C{constructor(d,s){this.description=d,this.value=s}}e.ExtensionPointContribution=C,e.ExtensionHostLogFileName="exthost";var S;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(S=e.ActivationKind||(e.ActivationKind={}));function v(p){p.enableProposedApi||f(p)}e.checkProposedApiEnabled=v;function f(p){throw new Error(`[${p.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.throwProposedApiError=f;function u(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:P.getGalleryExtensionId(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation}}e.toExtension=u;function m(p){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(p.identifier.id),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!1,extensionLocation:p.location},p.manifest),{uuid:p.identifier.uuid})}e.toExtensionDescription=m;class w{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(d){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(d){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(d,s){}_activateById(d,s){return Promise.resolve()}_onWillActivateExtension(d){}_onDidActivateExtension(d,s,a,c,t){}_onExtensionRuntimeError(d,s){}_onExtensionHostExit(d){}}e.NullExtensionService=w}),define(ge[225],pe([0,1,159,29,42,12]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const P=Promise.resolve(void 0);class D{constructor(m,w,p,d){this.startup=m,this.codeLoadingTime=w,this.activateCallTime=p,this.activateResolvedTime=d}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class I{constructor(m){this._startup=m,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(m,w){return m===-1||w===-1?-1:w-m}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class n{constructor(m,w,p,d,s,a){this.activationFailed=m,this.activationFailedError=w,this.activationTimes=p,this.module=d,this.exports=s,this.subscriptions=a}}e.ActivatedExtension=n;class C extends n{constructor(m){super(!1,null,m,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class S extends n{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=S;class v extends n{constructor(m){super(!0,m,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=v;let f=class{constructor(m,w,p,d,s){this._logService=s,this._registry=m,this._resolvedExtensionsSet=new Set,w.forEach(a=>this._resolvedExtensionsSet.add(k.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,p.forEach(a=>this._hostExtensionsMap.set(k.ExtensionIdentifier.toKey(a),a)),this._host=d,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(m){const w=k.ExtensionIdentifier.toKey(m);return this._activatedExtensions.has(w)}getActivatedExtension(m){const w=k.ExtensionIdentifier.toKey(m),p=this._activatedExtensions.get(w);if(!p)throw new Error("Extension `"+m.value+"` is not known or not activated");return p}activateByEvent(m,w){if(this._alreadyActivatedEvents[m])return P;const p=this._registry.getExtensionDescriptionsForActivationEvent(m);return this._activateExtensions(p.map(d=>({id:d.identifier,reason:{startup:w,extensionId:d.identifier,activationEvent:m}}))).then(()=>{this._alreadyActivatedEvents[m]=!0})}activateById(m,w){const p=this._registry.getExtensionDescription(m);if(!p)throw new Error("Extension `"+m+"` is not known");return this._activateExtensions([{id:p.identifier,reason:w}])}_handleActivateRequest(m,w,p){if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(m.id))){w[k.ExtensionIdentifier.toKey(m.id)]=m;return}const d=this._registry.getExtensionDescription(m.id);if(!d){this._host.onExtensionActivationError(m.id,new R.MissingDependencyError(m.id.value));const c=new Error(`Unknown dependency '${m.id.value}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(m.id),new v(c));return}const s=typeof d.extensionDependencies=="undefined"?[]:d.extensionDependencies;let a=!0;for(let c=0,t=s.length;c<t;c++){const r=s[c];if(!this._resolvedExtensionsSet.has(k.ExtensionIdentifier.toKey(r))){const o=this._activatedExtensions.get(k.ExtensionIdentifier.toKey(r));if(!(o&&!o.activationFailed)){if(o&&o.activationFailed){this._host.onExtensionActivationError(d.identifier,_.localize(0,null,d.displayName||d.identifier.value,r));const h=new Error(`Dependency ${r} failed to activate`);h.detail=o.activationFailedError,this._activatedExtensions.set(k.ExtensionIdentifier.toKey(d.identifier),new v(h));return}if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(r))){a=!1,w[k.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(k.ExtensionIdentifier.toKey(r)),reason:m.reason};continue}const l=this._registry.getExtensionDescription(r);if(l){a=!1,w[k.ExtensionIdentifier.toKey(r)]={id:l.identifier,reason:m.reason};continue}this._host.onExtensionActivationError(d.identifier,new R.MissingDependencyError(r));const i=new Error(`Unknown dependency '${r}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(d.identifier),new v(i));return}}}a?w[k.ExtensionIdentifier.toKey(d.identifier)]=m:p.push(m)}_activateExtensions(m){if(m.length===0||(m=m.filter(s=>!this._activatedExtensions.has(k.ExtensionIdentifier.toKey(s.id))),m.length===0))return Promise.resolve(void 0);const w=Object.create(null),p=[];for(let s=0,a=m.length;s<a;s++)this._handleActivateRequest(m[s],w,p);for(let s=0,a=p.length;s<a;s++){const c=k.ExtensionIdentifier.toKey(p[s].id);w[c]&&delete w[c]}const d=Object.keys(w).map(s=>w[s]);return p.length===0?Promise.all(d.map(s=>this._activateExtension(s.id,s.reason))).then(s=>{}):this._activateExtensions(d).then(s=>this._activateExtensions(p))}_activateExtension(m,w){const p=k.ExtensionIdentifier.toKey(m);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const d=this._activatingExtensions.get(p);if(d)return d;const s=this._host.actualActivateExtension(m,w).then(void 0,a=>(this._host.onExtensionActivationError(m,_.localize(1,null,m.value,a.message)),this._logService.error(`Activating extension ${m.value} failed due to an error:`),this._logService.error(a),new v(a))).then(a=>{this._activatedExtensions.set(p,a),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,s),s}};f=He([Fe(4,T.ILogService)],f),e.ExtensionsActivator=f}),define(ge[226],pe([0,1,12,42,28,11,110,23]),function(Z,e,_,k,R,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let I=class extends _.DelegatedLogService{constructor(C){if(C.logFile.scheme!==T.Schemas.file)throw new Error("Only file-logging supported");super(new P.SpdLogService(k.ExtensionHostLogFileName,D.dirname(C.logFile).fsPath,C.logLevel))}$setLevel(C){this.setLevel(C)}};I=He([Fe(0,R.IExtHostInitDataService)],I),e.ExtHostLogService=I}),define(ge[227],pe([0,1,15]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,P)=>{this._actualOk=T,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):_.onUnexpectedError(T))}then(T,P){return this._ensureActual().then(T,P)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=k}),define(ge[122],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(I,n){this.isMain=I,this.sid=n,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const k=[];function R(D){const I=new _(!0,D);return k[I.nid]=I,I}e.createMainContextProxyIdentifier=R;function T(D){const I=new _(!1,D);return k[I.nid]=I,I}e.createExtHostContextProxyIdentifier=T;function P(D){return k[D].sid}e.getStringIdentifierForProxy=P}),define(ge[6],pe([0,1,2,122,58]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var P;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var I;(function(d){d[d.Markdown=1]="Markdown",d[d.Code=2]="Code"})(I=e.CellKind||(e.CellKind={}));var n;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var S;(function(d){d.name="$ident";function s(c,t){return Object.defineProperty(c,d.name,{value:t,enumerable:!0}),c}d.mixin=s;function a(c){return c[d.name]}d.of=a})(S=e.ObjectIdentifier||(e.ObjectIdentifier={}));class v{static mixin(s){return s._id=v._n++,s}}e.IdObject=v,v._n=0;var f;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n",d.label2="o"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(d){if(d&&d.edits)for(const s of d.edits)typeof s.resource=="object"?s.resource=_.URI.revive(s.resource):(s.newUri=_.URI.revive(s.newUri),s.oldUri=_.URI.revive(s.oldUri)),s.metadata&&s.metadata.iconPath&&(s.metadata=R.revive(s.metadata));return d}e.reviveWorkspaceEditDto=w;var p;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:k.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:k.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:k.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:k.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:k.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:k.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:k.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:k.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:k.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:k.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:k.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:k.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:k.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:k.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:k.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:k.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:k.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:k.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:k.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:k.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:k.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:k.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:k.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:k.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:k.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:k.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:k.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:k.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:k.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:k.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:k.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:k.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:k.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:k.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:k.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:k.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:k.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:k.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:k.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:k.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:k.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:k.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:k.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:k.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:k.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:k.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:k.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadTheming:k.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:k.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:k.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:k.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:k.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:k.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:k.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:k.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:k.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:k.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:k.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:k.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:k.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:k.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:k.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:k.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:k.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:k.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:k.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:k.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:k.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:k.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:k.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:k.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:k.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:k.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:k.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:k.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:k.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:k.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:k.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:k.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:k.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:k.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:k.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:k.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:k.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:k.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:k.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:k.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:k.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:k.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:k.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostTheming:k.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:k.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:k.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:k.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:k.createMainContextProxyIdentifier("ExtHostTesting")}}),define(ge[88],pe([0,1,6,3,4]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(D){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,I){return this._proxy.$getPassword(D,I)}store(D,I,n){return this._proxy.$setPassword(D,I,n)}delete(D,I){return this._proxy.$deletePassword(D,I)}}e.ExtHostSecretState=T,e.IExtHostSecretState=R.createDecorator("IExtHostSecretState")}),define(ge[64],pe([0,1,4,12,6,14]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=_.createDecorator("IExtHostApiDeprecationService");let P=class{constructor(I,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=I.getProxy(R.MainContext.MainThreadTelemetry)}report(I,n,C){const S=this.getUsageKey(I,n);this._reportedUsages.has(S)||(this._reportedUsages.add(S),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${I}' is deprecated. ${C}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:I}))}getUsageKey(I,n){return`${I}-${n.identifier.value}`}};P=He([Fe(0,T.IExtHostRpcService),Fe(1,k.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(D,I,n){}})}),define(ge[228],pe([0,1,3,6,8,29]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(I){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=I.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(I){return this._providers=I,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(I,n,C,S={}){const v=T.ExtensionIdentifier.toKey(I.identifier),f=this._inFlightRequests.get(v)||[],u=C.sort().join(" ");let m=f.find(w=>w.scopes===u);if(m)return m.result;{const w=this._getSession(I,v,n,C,S);m={scopes:u,result:w},f.push(m),this._inFlightRequests.set(v,f);try{await w}finally{const p=f.findIndex(d=>d.scopes===u);p>-1&&(f.splice(p),this._inFlightRequests.set(v,f))}return w}}async _getSession(I,n,C,S,v={}){await this._proxy.$ensureProvider(C);const f=this._authenticationProviders.get(C),u=I.displayName||I.name;if(!f)return this._proxy.$getSession(C,S,n,u,v);const m=S.sort().join(" "),w=(await f.provider.getSessions()).filter(d=>d.scopes.slice().sort().join(" ")===m);let p;if(w.length){if(f.options.supportsMultipleAccounts){const d=await this._proxy.$selectSession(C,f.label,n,u,w,S,!!v.clearSessionPreference);p=w.find(s=>s.id===d.id)}else if(p=w[0],!await this._proxy.$getSessionsPrompt(C,p.account.label,f.label,n,u))throw new Error("User did not consent to login.")}else if(v.createIfNone){if(!await this._proxy.$loginPrompt(f.label,u))throw new Error("User did not consent to login.");p=await f.provider.login(S),await this._proxy.$setTrustedExtensionAndAccountPreference(C,p.account.label,n,u,p.id)}else await this._proxy.$requestNewSession(C,S,n,u);return p}async logout(I,n){const C=this._authenticationProviders.get(I);return C?C.provider.logout(n):this._proxy.$logout(I,n)}registerAuthenticationProvider(I,n,C,S){var v;if(this._authenticationProviders.get(I))throw new Error(`An authentication provider with id '${I}' is already registered.`);this._authenticationProviders.set(I,{label:n,provider:C,options:S!=null?S:{supportsMultipleAccounts:!1}}),this._providers.find(u=>u.id===I)||this._providers.push({id:I,label:n});const f=C.onDidChangeSessions(u=>{this._proxy.$sendDidChangeSessions(I,u)});return this._proxy.$registerAuthenticationProvider(I,n,(v=S==null?void 0:S.supportsMultipleAccounts)!==null&&v!==void 0?v:!1),new R.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(I);const u=this._providers.findIndex(m=>m.id===I);u>-1&&this._providers.splice(u),this._proxy.$unregisterAuthenticationProvider(I)})}$login(I,n){const C=this._authenticationProviders.get(I);if(C)return Promise.resolve(C.provider.login(n));throw new Error(`Unable to find authentication provider with handle: ${I}`)}$logout(I,n){const C=this._authenticationProviders.get(I);if(C)return Promise.resolve(C.provider.logout(n));throw new Error(`Unable to find authentication provider with handle: ${I}`)}$getSessions(I){const n=this._authenticationProviders.get(I);if(n)return Promise.resolve(n.provider.getSessions());throw new Error(`Unable to find authentication provider with handle: ${I}`)}async $getSessionAccessToken(I,n){const C=this._authenticationProviders.get(I);if(C){const v=(await C.provider.getSessions()).find(f=>f.id===n);if(v)return v.accessToken;throw new Error(`Unable to find session with id: ${n}`)}throw new Error(`Unable to find authentication provider with handle: ${I}`)}$onDidChangeAuthenticationSessions(I,n,C){return this._onDidChangeSessions.fire(Object.assign({provider:{id:I,label:n}},C)),Promise.resolve()}$onDidChangeAuthenticationProviders(I,n){return I.forEach(C=>{this._providers.some(S=>S.id===C.id)||this._providers.push(C)}),n.forEach(C=>{const S=this._providers.findIndex(v=>v.id===C.id);S>-1&&this._providers.splice(S)}),this._onDidChangeAuthenticationProviders.fire({added:I,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=P}),define(ge[229],pe([0,1,6,14,20]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(D,I,n){this._extHostDocumentsAndEditors=I,this._extHostNotebooks=n,this._proxy=D.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const I=R.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors,this._extHostNotebooks);return this._proxy.$tryApplyWorkspaceEdit(I)}};T=He([Fe(0,k.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(ge[230],pe([0,1,6]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(T){this._proxy=T.getProxy(_.MainContext.MainThreadClipboard)}readText(){return this._proxy.$readText()}writeText(T){return this._proxy.$writeText(T)}}e.ExtHostClipboard=k}),define(ge[52],pe([0,1,16,8,20,25,6,13,12,58,44,48,2,5,4,14]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(P.MainContext.MainThreadCommands),this._logService=r,this.converter=new p(this,o=>{const l=this._apiCommands.get(o);return(l==null?void 0:l.result)===s.Void?l:void 0},r),this._argumentProcessors=[{processArgument(o){return n.revive(o)}},{processArgument(o){return T.cloneAndChange(o,function(l){if(C.Range.isIRange(l))return R.Range.to(l);if(S.Position.isIPosition(l))return R.Position.to(l);if(C.Range.isIRange(l.range)&&v.URI.isUri(l.uri))return R.location.to(l);if(!Array.isArray(l))return l})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...o)=>{const l=t.args.map((h,y)=>{if(!h.validate(o[y]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${o[y]}`);return h.convert(o[y])}),i=await this.executeCommand(t.internalId,...l);return t.result.convert(i,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new k.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,o,l,i){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:o,thisArg:l,description:i}),t&&this._proxy.$registerCommand(r),new k.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,o){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const l=T.cloneAndChange(r,function(i){if(i instanceof k.Position)return R.Position.from(i);if(i instanceof k.Range)return R.Range.from(i);if(i instanceof k.Location)return R.location.from(i);if(!Array.isArray(i))return i});try{const i=await this._proxy.$executeCommand(t,l,o);return n.revive(i)}catch(i){if(i instanceof Error&&i.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw i}}}async _executeContributedCommand(t,r){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:l,thisArg:i,description:h}=o;if(h)for(let y=0;y<h.args.length;y++)try{_.validateConstraint(r[y],h.args[y].constraint)}catch(g){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[y].name}' - ${h.args[y].description}`)}try{return await l.apply(i,r)}catch(y){throw this._logService.error(y,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(o=>this._argumentProcessors.reduce((l,i)=>i.processArgument(l),o)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(o=>o[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,o]of this._commands){let{description:l}=o;l&&(t[r]=l)}return Promise.resolve(t)}};w=He([Fe(0,m.IExtHostRpcService),Fe(1,I.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=u.createDecorator("IExtHostCommands");class p{constructor(t,r,o){this._commands=t,this._lookupApiCommand=r,this._logService=o,this._cache=new Map,this._cachIdPool=0,this._delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._commands.registerCommand(!0,this._delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const l=this._lookupApiCommand(t.command);if(l)o.id=l.internalId,o.arguments=l.args.map((i,h)=>i.convert(t.arguments&&t.arguments[h]));else if(D.isNonEmptyArray(t.arguments)){const i=++this._cachIdPool;this._cache.set(i,t),r.add(f.toDisposable(()=>{this._cache.delete(i),this._logService.trace("CommandsConverter#DISPOSE",i)})),o.$ident=i,o.id=this._delegatingCommandId,o.arguments=[i],this._logService.trace("CommandsConverter#CREATE",t.command,i)}return o}}fromInternal(t){const r=P.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}_executeConvertedCommand(...t){const r=this._cache.get(t[0]);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=p;class d{constructor(t,r,o,l){this.name=t,this.description=r,this.validate=o,this.convert=l}optional(){return new d(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new d(t!=null?t:this.name,r!=null?r:this.description,this.validate,this.convert)}}e.ApiCommandArgument=d,d.Uri=new d("uri","Uri of a text document",c=>v.URI.isUri(c),c=>c),d.Position=new d("position","A position in a text document",c=>k.Position.isPosition(c),R.Position.from),d.Range=new d("range","A range in a text document",c=>k.Range.isRange(c),R.Range.from),d.Selection=new d("selection","A selection in a text document",c=>k.Selection.isSelection(c),R.Selection.from),d.Number=new d("number","",c=>typeof c=="number",c=>c),d.String=new d("string","",c=>typeof c=="string",c=>c),d.CallHierarchyItem=new d("item","A call hierarchy item",c=>c instanceof k.CallHierarchyItem,R.CallHierarchyItem.to);class s{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=s,s.Void=new s("no result",c=>c);class a{constructor(t,r,o,l,i){this.id=t,this.internalId=r,this.description=o,this.args=l,this.result=i}}e.ApiCommand=a}),define(ge[231],pe([0,1,5,20,8,82,52,196,13,107]),function(Z,e,_,k,R,T,P,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new P.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",v(k.DocumentHighlight.to))),new P.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(u,m)=>{if(!I.isFalsyOrEmpty(u)){class w extends R.SymbolInformation{static to(d){const s=new w(d.name,k.SymbolKind.to(d.kind),d.containerName||"",new R.Location(m[0],k.Range.to(d.range)));return s.detail=d.detail,s.range=s.location.range,s.selectionRange=k.Range.to(d.selectionRange),s.children=d.children?d.children.map(w.to):[],s}}return u.map(w.to)}})),new P.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new P.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range,new P.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new P.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,new P.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new P.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new P.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new P.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new P.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new P.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new P.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new P.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Location-instances.",v(k.location.to))),new P.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A promise that resolves to an array of Hover-instances.",v(k.Hover.to))),new P.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("position","A positions in a text document",u=>Array.isArray(u)&&u.every(m=>R.Position.isPosition(m)),u=>u.map(k.Position.from))],new P.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(m=>{let w;for(const p of m.reverse())w=new R.SelectionRange(k.Range.to(p),w);return w}))),new P.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[P.ApiCommandArgument.String.with("query","Search string")],new P.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>{const m=[];if(Array.isArray(u))for(let w of u)m.push(...w[1].map(k.WorkspaceSymbol.to));return m})),new P.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position],new P.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(k.CallHierarchyItem.to))),new P.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(k.CallHierarchyIncomingCall.to))),new P.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[P.ApiCommandArgument.CallHierarchyItem],new P.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(k.CallHierarchyOutgoingCall.to))),new P.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("newName","The new symbol name")],new P.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return k.WorkspaceEdit.to(u)}})),new P.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new P.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(k.DocumentLink.to))),new P.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new R.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!!u){const m=n.decodeSemanticTokensDto(u);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)}})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new R.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new P.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!!u){const m=n.decodeSemanticTokensDto(u);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)}})),new P.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new P.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,m,w)=>{if(!u)return new R.CompletionList([]);const p=u.suggestions.map(d=>k.CompletionItem.to(d,w));return new R.CompletionList(p,u.incomplete)})),new P.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Position,P.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new P.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return k.SignatureHelp.to(u)})),new P.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new P.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,m,w)=>v(p=>new R.CodeLens(k.Range.to(p.range),p.command&&w.fromInternal(p.command)))(u))),new P.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>R.Range.isRange(u),u=>R.Selection.isSelection(u)?k.Selection.from(u):k.Range.from(u)),P.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),P.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new P.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,m,w)=>v(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return w.fromInternal(p.command)}else{const d=new R.CodeAction(p.title,p.kind?new R.CodeActionKind(p.kind):void 0);return p.edit&&(d.edit=k.WorkspaceEdit.to(p.edit)),p.command&&(d.command=w.fromInternal(p.command)),d.isPreferred=p.isPreferred,d}})(u))),new P.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[P.ApiCommandArgument.Uri],new P.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(m=>new R.ColorInformation(k.Range.to(m.range),k.Color.to(m.color))):[])),new P.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new P.ApiCommandArgument("color","The color to show and insert",u=>u instanceof R.Color,k.Color.from),new P.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:k.Range.from(u.range)}))],new P.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(k.ColorPresentation.to):[])),new P.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[P.ApiCommandArgument.Uri,P.ApiCommandArgument.Range],new P.ApiCommandResult("A promise that resolves to an array of InlineHint objects",u=>u.map(k.InlineHint.to))),new P.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new P.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",v(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientMetadata:u.options.transientMetadata},filenamePattern:u.filenamePattern.map(m=>k.NotebookExclusiveDocumentPattern.to(m))})))),new P.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or a http(s) url. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[P.ApiCommandArgument.Uri,new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[k.ViewColumn.from(u.viewColumn),k.TextEditorOpenOptions.from(u)])).optional(),P.ApiCommandArgument.String.with("label","").optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[P.ApiCommandArgument.Uri.with("resource","Resource to open"),P.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[k.ViewColumn.from(u.viewColumn),k.TextEditorOpenOptions.from(u)])).optional()],P.ApiCommandResult.Void),new P.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[P.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),P.ApiCommandArgument.Uri.with("right","Rigth-hand side resource of the diff editor"),P.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new P.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[k.ViewColumn.from(u.viewColumn),k.TextEditorOpenOptions.from(u)]).optional()],P.ApiCommandResult.Void)];class S{constructor(m){this._disposables=new _.DisposableStore,this._commands=m}static register(m){return C.forEach(m.registerApiCommand,m),new S(m).registerCommands()}registerCommands(){const m=w=>(...p)=>w(this._commands,...p);this._register(D.RemoveFromRecentlyOpenedAPICommand.ID,m(D.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:w=>typeof w=="string"}]}),this._register(D.OpenIssueReporter.ID,m(D.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:w=>typeof w=="string"||typeof w=="object"&&typeof w.extensionId=="string"}]})}_register(m,w,p){const d=this._commands.registerCommand(!1,m,w,this,p);this._disposables.add(d)}}e.ExtHostApiCommands=S;function v(u){return m=>{if(Array.isArray(m))return m.map(u)}}function f(u){if(!!Array.isArray(u)){const m=[];for(const w of u)T.isLocationLink(w)?m.push(k.DefinitionLink.to(w)):m.push(k.location.to(w));return m}}}),define(ge[232],pe([0,1,19,55,3,5,2,82,29,20,8,6]),function(Z,e,_,k,R,T,P,D,I,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class v{constructor(a,c,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=a.getProxy(S.MainContext.MainThreadComments),c.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const o=this._commentControllers.get(r.handle);return o||r}else if(r&&r.$mid===7){const o=this._commentControllers.get(r.commentControlHandle);if(!o)return r;const l=o.getCommentThread(r.commentThreadHandle);return l||r}else if(r&&r.$mid===8){const o=this._commentControllers.get(r.thread.commentControlHandle);if(!o)return r;const l=o.getCommentThread(r.thread.commentThreadHandle);return l?{thread:l,text:r.text}:r}else if(r&&r.$mid===9){const o=this._commentControllers.get(r.thread.commentControlHandle);if(!o)return r;const l=o.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let i=r.commentUniqueId,h=l.getCommentByUniqueId(i);return h||r}else if(r&&r.$mid===10){const o=this._commentControllers.get(r.thread.commentControlHandle);if(!o)return r;const l=o.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let i=r.text,h=r.commentUniqueId,y=l.getCommentByUniqueId(h);return y?(y.body=i,y):r}return r}})}createCommentController(a,c,t){const r=v.handlePool++,o=new u(a,r,this._proxy,c,t);this._commentControllers.set(o.handle,o);const l=this._commentControllersByExtension.get(I.ExtensionIdentifier.toKey(a.identifier))||[];return l.push(o),this._commentControllersByExtension.set(I.ExtensionIdentifier.toKey(a.identifier),l),o}$createCommentThreadTemplate(a,c,t){const r=this._commentControllers.get(a);!r||r.$createCommentThreadTemplate(c,t)}async $updateCommentThreadTemplate(a,c,t){const r=this._commentControllers.get(a);!r||r.$updateCommentThreadTemplate(c,t)}$deleteCommentThread(a,c){const t=this._commentControllers.get(a);t&&t.$deleteCommentThread(c)}$provideCommentingRanges(a,c,t){const r=this._commentControllers.get(a);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(P.URI.revive(c));return _.asPromise(()=>r.commentingRangeProvider.provideCommentingRanges(o,t)).then(l=>l?l.map(i=>n.Range.from(i)):void 0)}$toggleReaction(a,c,t,r,o){const l=this._commentControllers.get(a);return!l||!l.reactionHandler?Promise.resolve(void 0):_.asPromise(()=>{const i=l.getCommentThread(c);if(i){const h=i.getCommentByUniqueId(r.uniqueIdInThread);if(l!==void 0&&h&&l.reactionHandler)return l.reactionHandler(h,p(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=v,v.handlePool=0;class f{constructor(a,c,t,r,o,l,i){this._proxy=a,this._commentController=c,this._id=t,this._uri=r,this._range=o,this._comments=l,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new R.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${c.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),i),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=l}set threadId(a){this._id=a}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(a){a.isEqual(this._range)||(this._range=a,this.modifications.range=a,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(a){this._canReply!==a&&(this._canReply=a,this.modifications.canReply=a,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(a){this._label=a,this.modifications.label=a,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(a){this._contextValue=a,this.modifications.contextValue=a,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(a){this._comments=a,this.modifications.comments=a,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(a){this._collapseState=a,this.modifications.collapsibleState=a,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const a=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),c={};a("range")&&(c.range=n.Range.from(this._range)),a("label")&&(c.label=this.label),a("contextValue")&&(c.contextValue=this.contextValue),a("comments")&&(c.comments=this._comments.map(t=>m(this,this._commentController,t,this._commentsMap))),a("collapsibleState")&&(c.collapseState=d(this._collapseState)),a("canReply")&&(c.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,c)}}getCommentByUniqueId(a){for(let c of this._commentsMap){let t=c[0],r=c[1];if(a===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(a=>a.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,He([k.debounce(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class u{constructor(a,c,t,r,o){this._extension=a,this._handle=c,this._proxy=t,this._id=r,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(a){this._reactionHandler=a,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this._options}set options(a){this._options=a,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(a,c,t,r){if(typeof a=="string"){const o=new f(this._proxy,this,a,c,t,r,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new f(this._proxy,this,void 0,a,c,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(a,c){const t=new f(this._proxy,this,void 0,P.URI.revive(a),n.Range.to(c),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(a,c){let t=this._threads.get(a);t&&(t.range=n.Range.to(c))}$deleteCommentThread(a){let c=this._threads.get(a);c&&c.dispose(),this._threads.delete(a)}getCommentThread(a){return this._threads.get(a)}dispose(){this._threads.forEach(a=>{a.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function m(s,a,c,t){let r=t.get(c);r||(r=++s.commentHandle,t.set(c,r));const o=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:r,body:n.MarkdownString.from(c.body),userName:c.author.name,userIconPath:o,label:c.label,commentReactions:c.reactions?c.reactions.map(l=>w(l)):void 0}}function w(s){return{label:s.label,iconPath:s.iconPath?n.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function p(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?P.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function d(s){if(s!==void 0)switch(s){case C.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case C.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(ge[123],pe([0,1,2,6,8,4,14,12,13,10,7]),function(Z,e,_,k,R,T,P,D,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class li{constructor(f,u){this._logService=u,this._provider=new Map,this._proxy=f.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,u){const m=li._handlePool++;this._provider.set(m,{provider:f,extensionId:u}),this._proxy.$registerDecorationProvider(m,u.value);const w=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(p=>{if(!p){this._proxy.$onDidChange(m,null);return}let d=I.asArray(p);if(d.length<=li._maxEventSize){this._proxy.$onDidChange(m,d);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.value,d.length);const s=d.map(t=>({uri:t,rank:n.count(t.path,"/")})),a=I.groupBy(s,(t,r)=>t.rank-r.rank||n.compare(t.uri.path,r.uri.path));let c=[];e:for(let t of a){let r;for(let o of t){let l=C.dirname(o.uri.path);if(r!==l&&(r=l,c.push(o.uri)>=li._maxEventSize))break e}}this._proxy.$onDidChange(m,c)});return new R.Disposable(()=>{w==null||w.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(f,u,m){if(!this._provider.has(f))return Object.create(null);const w=Object.create(null),{provider:p,extensionId:d}=this._provider.get(f);return await Promise.all(u.map(async s=>{try{const{uri:a,id:c}=s,t=await Promise.resolve(p.provideFileDecoration(_.URI.revive(a),m));if(!t)return;try{R.FileDecoration.validate(t),w[c]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${d.value}': ${r}`)}}catch(a){this._logService.error(a)}})),w}};S._handlePool=0,S._maxEventSize=250,S=He([Fe(0,P.IExtHostRpcService),Fe(1,D.ILogService)],S),e.ExtHostDecorations=S,e.IExtHostDecorations=T.createDecorator("IExtHostDecorations")}),define(ge[233],pe([0,1,158,111,2,6,8,20,13,3,12,22]),function(Z,e,_,k,R,T,P,D,I,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(m,w,p,d,s){this._name=m,this._owner=w,this._maxDiagnosticsPerFile=p,this._proxy=d,this._onDidChangeDiagnostics=s,this._isDisposed=!1,this._data=new S.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(m,w){if(!m){this.clear();return}this._checkDisposed();let p=[];if(R.URI.isUri(m)){if(!w){this.delete(m);return}this._data.set(m,w.slice()),p=[m]}else if(Array.isArray(m)){p=[];let s;m=I.mergeSort([...m],v._compareIndexedTuplesByUri);for(const a of m){const[c,t]=a;if((!s||c.toString()!==s.toString())&&(s&&this._data.get(s).length===0&&this._data.delete(s),s=c,p.push(c),this._data.set(c,[])),t){const r=this._data.get(c);r&&r.push(...t)}else{const r=this._data.get(c);r&&(r.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!!this._proxy){const d=[];for(let s of p){let a=[];const c=this._data.get(s);if(c)if(c.length>this._maxDiagnosticsPerFile){a=[];const t=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let o of c)if(o.severity===t[r]&&a.push(D.Diagnostic.from(o))===this._maxDiagnosticsPerFile)break e;a.push({severity:k.MarkerSeverity.Info,message:_.localize(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=c.map(t=>D.Diagnostic.from(t));d.push([s,a])}this._proxy.$changeMany(this._owner,d)}}delete(m){this._checkDisposed(),this._onDidChangeDiagnostics.fire([m]),this._data.delete(m),this._proxy&&this._proxy.$changeMany(this._owner,[[m,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(m,w){this._checkDisposed();for(let p of this._data.keys())m.apply(w,[p,this.get(p),this])}get(m){this._checkDisposed();const w=this._data.get(m);return Array.isArray(w)?Object.freeze(w.slice(0)):[]}has(m){return this._checkDisposed(),Array.isArray(this._data.get(m))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(m,w){return m[0].toString()<w[0].toString()?-1:m[0].toString()>w[0].toString()?1:0}}e.DiagnosticCollection=v;let f=class Ft{constructor(m,w){this._logService=w,this._collections=new Map,this._onDidChangeDiagnostics=new n.Emitter,this.onDidChangeDiagnostics=n.Event.map(n.Event.debounce(this._onDidChangeDiagnostics.event,Ft._debouncer,50),Ft._mapper),this._proxy=m.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(m,w){return m?m.concat(w):w}static _mapper(m){const w=[],p=new Set;for(const d of m)typeof d=="string"?p.has(d)||(p.add(d),w.push(R.URI.parse(d))):p.has(d.toString())||(p.add(d.toString()),w.push(d));return Object.freeze(w),{uris:w}}createDiagnosticCollection(m,w){const{_collections:p,_proxy:d,_onDidChangeDiagnostics:s,_logService:a}=this,c=new class{$changeMany(o,l){d.$changeMany(o,l),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,o,l.length===0?"CLEARING":l)}$clear(o){d.$clear(o),a.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,o)}dispose(){d.dispose()}};let t;if(!w)w="_generated_diagnostic_collection_name_#"+Ft._idPool++,t=w;else if(!p.has(w))t=w;else{this._logService.warn(`DiagnosticCollection with name '${w}' does already exist.`);do t=w+Ft._idPool++;while(p.has(t))}return new class extends v{constructor(){super(w,t,Ft._maxDiagnosticsPerFile,c,s);p.set(t,this)}dispose(){super.dispose(),p.delete(t)}}}getDiagnostics(m){if(m)return this._getDiagnostics(m);{const w=new Map,p=[];for(const d of this._collections.values())d.forEach((s,a)=>{let c=w.get(s.toString());typeof c=="undefined"&&(c=p.length,w.set(s.toString(),c),p.push([s,[]])),p[c][1]=p[c][1].concat(...a)});return p}}_getDiagnostics(m){let w=[];for(let p of this._collections.values())p.has(m)&&(w=w.concat(p.get(m)));return w}$acceptMarkersChange(m){if(!this._mirrorCollection){const w="_generated_mirror",p=new v(w,w,Ft._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(w,p),this._mirrorCollection=p}for(const[w,p]of m)this._mirrorCollection.set(R.URI.revive(w),p.map(D.Diagnostic.to))}};f._idPool=0,f._maxDiagnosticsPerFile=1e3,f=He([Fe(1,C.ILogService)],f),e.ExtHostDiagnostics=f}),define(ge[234],pe([0,1,2,6]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(P){this._proxy=P.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(P){return this._proxy.$showOpenDialog(P).then(D=>D?D.map(I=>_.URI.revive(I)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(D=>D?_.URI.revive(D):void 0)}}e.ExtHostDialogs=R}),define(ge[235],pe([0,1,15,2,8,6,11,21,10]),function(Z,e,_,k,R,T,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(S,v,f){this._documentsAndEditors=v,this._logService=f,this._documentContentProviders=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,v){if(Object.keys(P.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const f=n._handlePool++;this._documentContentProviders.set(f,v),this._proxy.$registerTextContentProvider(f,S);let u;return typeof v.onDidChange=="function"&&(u=v.onDidChange(m=>{if(m.scheme!==S){this._logService.warn(`Provider for scheme '${S}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(f,m).then(w=>{if(!(!w&&typeof w!="string")){const p=this._documentsAndEditors.getDocument(m);if(!!p){const d=I.splitLines(w);if(!p.equalLines(d))return this._proxy.$onVirtualDocumentChange(m,w)}}},_.onUnexpectedError)})),new R.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),u&&(u.dispose(),u=void 0)})}$provideTextDocumentContent(S,v){const f=this._documentContentProviders.get(S);return f?Promise.resolve(f.provideTextDocumentContent(k.URI.revive(v),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(ge[236],pe([0,1,3,5,2,6,118,20,16,25]),function(Z,e,_,k,R,T,P,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class C{constructor(v,f){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=v.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const m of u)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const m of u)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(v){if(!!v){const f=this._documentsAndEditors.getDocument(v);if(f)return f}}getDocument(v){const f=this.getDocumentData(v);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${v}'`);return f.document}ensureDocumentData(v){const f=this._documentsAndEditors.getDocument(v);if(f)return Promise.resolve(f);let u=this._documentLoader.get(v.toString());return u||(u=this._proxy.$tryOpenDocument(v).then(m=>{this._documentLoader.delete(v.toString());const w=R.URI.revive(m);return I.assertIsDefined(this._documentsAndEditors.getDocument(w))},m=>(this._documentLoader.delete(v.toString()),Promise.reject(m))),this._documentLoader.set(v.toString(),u)),u}createDocumentData(v){return this._proxy.$tryCreateDocument(v).then(f=>R.URI.revive(f))}$acceptModelModeChanged(v,f,u){const m=R.URI.revive(v),w=this._documentsAndEditors.getDocument(m);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(u),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(v){const f=R.URI.revive(v),u=this._documentsAndEditors.getDocument(f);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(v,f){const u=R.URI.revive(v),m=this._documentsAndEditors.getDocument(u);if(!m)throw new Error("unknown document");m._acceptIsDirty(f),this._onDidChangeDocument.fire({document:m.document,contentChanges:[]})}$acceptModelChanged(v,f,u){const m=R.URI.revive(v),w=this._documentsAndEditors.getDocument(m);if(!w)throw new Error("unknown document");w._acceptIsDirty(u),w.onEvents(f),this._onDidChangeDocument.fire(n.deepFreeze({document:w.document,contentChanges:f.changes.map(p=>({range:D.Range.to(p.range),rangeOffset:p.rangeOffset,rangeLength:p.rangeLength,text:p.text}))}))}setWordDefinitionFor(v,f){P.setWordDefinitionFor(v,f)}}e.ExtHostDocuments=C}),define(ge[40],pe([0,1,53,3,5,2,4,6,118,14,121,20,12,22,11,72]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let p=class{constructor(s,a){this._extHostRpc=s,this._logService=a,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const a=[],c=[],t=[];if(s.removedDocuments)for(const r of s.removedDocuments){const o=T.URI.revive(r),l=this._documents.get(o);(l==null?void 0:l.unref())&&(this._documents.delete(o),a.push(l.value))}if(s.addedDocuments)for(const r of s.addedDocuments){const o=T.URI.revive(r.uri);let l=this._documents.get(o);if(l&&o.scheme!==u.Schemas.vscodeNotebookCell)throw new Error(`document '${o} already exists!'`);l||(l=new w(new I.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),o,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(o,l),c.push(l.value)),l.ref()}if(s.removedEditors)for(const r of s.removedEditors){const o=this._editors.get(r);this._editors.delete(r),o&&t.push(o)}if(s.addedEditors)for(const r of s.addedEditors){const o=T.URI.revive(r.documentUri);_.ok(this._documents.has(o),`document '${o}' does not exist`),_.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const l=this._documents.get(o).value,i=new C.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,l,r.selections.map(S.Selection.to),r.options,r.visibleRanges.map(h=>S.Range.to(h)),typeof r.editorPosition=="number"?S.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,i)}s.newActiveEditor!==void 0&&(_.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),R.dispose(a),R.dispose(t),s.removedDocuments&&this._onDidRemoveDocuments.fire(a),s.addedDocuments&&this._onDidAddDocuments.fire(c),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors()),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){var a;return(a=this._documents.get(s))===null||a===void 0?void 0:a.value}allDocuments(){return m.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(){if(this._activeEditorId)return this._editors.get(this._activeEditorId)}allEditors(){return[...this._editors.values()]}};p=He([Fe(0,n.IExtHostRpcService),Fe(1,v.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=P.createDecorator("IExtHostDocumentsAndEditors")}),define(ge[237],pe([0,1,2,6,5,8,20,141,10,27]),function(Z,e,_,k,R,T,P,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class C{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const u=this._schemes.indexOf(f);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),u=[];let m,w,p=14,d=14;for(const s of f){let a=m?I.commonPrefixLength(m,s):0;for(a===0?w=1:w=d;a<s.length;a++)a+1===s.length?(p=d,d=9):d+=1,u.push([w,s.toUpperCase().charCodeAt(a),d]),u.push([w,s.toLowerCase().charCodeAt(a),d]),w=d;m=s,d=p}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new D.StateMachine(u)}}provideDocumentLinks(f){this._initStateMachine();const u=[],m=D.LinkComputer.computeLinks({getLineContent(w){return f.lineAt(w-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const w of m){const p=P.DocumentLink.to(w);p.target&&u.push(p)}return u}}class S{constructor(f,u){this._extHostLanguageFeatures=u,this._linkProvider=new C,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,u,m,w={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const p=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(p,m);let d=2;w.isCaseSensitive&&(d+=1024),w.isReadonly&&(d+=2048),typeof m.copy=="function"&&(d+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&(d+=4),this._proxy.$registerFileSystemProvider(p,u,d).catch(a=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${u}`),console.error(a)});const s=m.onDidChangeFile(a=>{const c=[];for(const t of a){let{uri:r,type:o}=t;if(r.scheme===u){let l;switch(o){case T.FileChangeType.Changed:l=0;break;case T.FileChangeType.Created:l=1;break;case T.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:r,type:l})}}this._proxy.$onFileSystemChange(p,c)});return R.toDisposable(()=>{s.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(f){const{type:u,ctime:m,mtime:w,size:p}=f;return{type:u,ctime:m,mtime:w,size:p}}$stat(f,u){return Promise.resolve(this._getFsProvider(f).stat(_.URI.revive(u))).then(S._asIStat)}$readdir(f,u){return Promise.resolve(this._getFsProvider(f).readDirectory(_.URI.revive(u)))}$readFile(f,u){return Promise.resolve(this._getFsProvider(f).readFile(_.URI.revive(u))).then(m=>n.VSBuffer.wrap(m))}$writeFile(f,u,m,w){return Promise.resolve(this._getFsProvider(f).writeFile(_.URI.revive(u),m.buffer,w))}$delete(f,u,m){return Promise.resolve(this._getFsProvider(f).delete(_.URI.revive(u),m))}$rename(f,u,m,w){return Promise.resolve(this._getFsProvider(f).rename(_.URI.revive(u),_.URI.revive(m),w))}$copy(f,u,m,w){const p=this._getFsProvider(f);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(_.URI.revive(u),_.URI.revive(m),w))}$mkdir(f,u){return Promise.resolve(this._getFsProvider(f).createDirectory(_.URI.revive(u)))}$watch(f,u,m,w){const p=this._getFsProvider(f).watch(_.URI.revive(m),w);this._watches.set(u,p)}$unwatch(f,u){const m=this._watches.get(u);m&&(m.dispose(),this._watches.delete(u))}$open(f,u,m){const w=this._getFsProvider(f);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(_.URI.revive(u),m))}$close(f,u){const m=this._getFsProvider(f);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(u))}$read(f,u,m,w){const p=this._getFsProvider(f);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const d=n.VSBuffer.alloc(w);return Promise.resolve(p.read(u,m,d.buffer,0,w)).then(s=>d.slice(0,s))}$write(f,u,m,w){const p=this._getFsProvider(f);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(u,m,w.buffer,0,w.byteLength))}_getFsProvider(f){const u=this._fsProvider.get(f);if(!u){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return u}}e.ExtHostFileSystem=S}),define(ge[89],pe([0,1,6,50,8,27,4,14,62]),function(Z,e,_,k,R,T,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Dt{constructor(S,v){this._fileSystemInfo=v,this._proxy=S.getProxy(_.MainContext.MainThreadFileSystem)}stat(S){return this._proxy.$stat(S).catch(Dt._handleError)}readDirectory(S){return this._proxy.$readdir(S).catch(Dt._handleError)}createDirectory(S){return this._proxy.$mkdir(S).catch(Dt._handleError)}async readFile(S){return this._proxy.$readFile(S).then(v=>v.buffer).catch(Dt._handleError)}writeFile(S,v){return this._proxy.$writeFile(S,T.VSBuffer.wrap(v)).catch(Dt._handleError)}delete(S,v){return this._proxy.$delete(S,Object.assign({recursive:!1,useTrash:!1},v)).catch(Dt._handleError)}rename(S,v,f){return this._proxy.$rename(S,v,Object.assign({overwrite:!1},f)).catch(Dt._handleError)}copy(S,v,f){return this._proxy.$copy(S,v,Object.assign({overwrite:!1},f)).catch(Dt._handleError)}isWritableFileSystem(S){const v=this._fileSystemInfo.getCapabilities(S);if(typeof v=="number")return!(v&2048)}static _handleError(S){if(!(S instanceof Error))throw new R.FileSystemError(String(S));if(S.name==="ENOPRO")throw R.FileSystemError.Unavailable(S.message);switch(S.name){case k.FileSystemProviderErrorCode.FileExists:throw R.FileSystemError.FileExists(S.message);case k.FileSystemProviderErrorCode.FileNotFound:throw R.FileSystemError.FileNotFound(S.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw R.FileSystemError.FileNotADirectory(S.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw R.FileSystemError.FileIsADirectory(S.message);case k.FileSystemProviderErrorCode.NoPermissions:throw R.FileSystemError.NoPermissions(S.message);case k.FileSystemProviderErrorCode.Unavailable:throw R.FileSystemError.Unavailable(S.message);default:throw new R.FileSystemError(S.message,S.name)}}};n=He([Fe(0,D.IExtHostRpcService),Fe(1,I.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=P.createDecorator("IExtHostConsumerFileSystem")}),define(ge[238],pe([0,1,5,6]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class R{constructor(P){this._handlePool=0,this._proxy=P.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,P),_.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=R}),define(ge[239],pe([0,1,2,25,20,8,19,6,10,44,13,16,138,5,107,71,86,47,15]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(H,X){this._documents=H,this._provider=X}provideDocumentSymbols(H,X){const re=this._documents.getDocument(H);return P.asPromise(()=>this._provider.provideDocumentSymbols(re,X)).then(Y=>{if(!C.isFalsyOrEmpty(Y))return Y[0]instanceof T.DocumentSymbol?Y.map(R.DocumentSymbol.from):s._asDocumentSymbolTree(Y)})}static _asDocumentSymbolTree(H){var X;H=H.slice(0).sort((le,ve)=>{let De=le.location.range.start.compareTo(ve.location.range.start);return De===0&&(De=ve.location.range.end.compareTo(le.location.range.end)),De});const re=[],Y=[];for(const le of H){const ve={name:le.name||"!!MISSING: name!!",kind:R.SymbolKind.from(le.kind),tags:((X=le.tags)===null||X===void 0?void 0:X.map(R.SymbolTag.from))||[],detail:"",containerName:le.containerName,range:R.Range.from(le.location.range),selectionRange:R.Range.from(le.location.range),children:[]};for(;;){if(Y.length===0){Y.push(ve),re.push(ve);break}const De=Y[Y.length-1];if(n.Range.containsRange(De.range,ve.range)&&!n.Range.equalsRange(De.range,ve.range)){De.children&&De.children.push(ve),Y.push(ve);break}Y.pop()}}return re}}class a{constructor(H,X,re){this._documents=H,this._commands=X,this._provider=re,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,X){const re=this._documents.getDocument(H),Y=await this._provider.provideCodeLenses(re,X);if(!(!Y||X.isCancellationRequested)){const le=this._cache.add(Y),ve=new f.DisposableStore;this._disposables.set(le,ve);const De={cacheId:le,lenses:[]};for(let Me=0;Me<Y.length;Me++)De.lenses.push({cacheId:[le,Me],range:R.Range.from(Y[Me].range),command:this._commands.toInternal(Y[Me].command,ve)});return De}}async resolveCodeLens(H,X){var re;const Y=H.cacheId&&this._cache.get(...H.cacheId);if(!!Y){let le;if(typeof this._provider.resolveCodeLens!="function"||Y.isResolved?le=Y:le=await this._provider.resolveCodeLens(Y,X),le||(le=Y),!X.isCancellationRequested){const ve=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!ve)return H.command=this._commands.toInternal((re=le.command)!==null&&re!==void 0?re:a._badCmd,ve),H}}}releaseCodeLenses(H){var X;(X=this._disposables.get(H))===null||X===void 0||X.dispose(),this._disposables.delete(H),this._cache.delete(H)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function c(be){return Array.isArray(be)?be.map(R.DefinitionLink.from):be?[R.DefinitionLink.from(be)]:[]}class t{constructor(H,X){this._documents=H,this._provider=X}provideDefinition(H,X,re){const Y=this._documents.getDocument(H),le=R.Position.to(X);return P.asPromise(()=>this._provider.provideDefinition(Y,le,re)).then(c)}}class r{constructor(H,X){this._documents=H,this._provider=X}provideDeclaration(H,X,re){const Y=this._documents.getDocument(H),le=R.Position.to(X);return P.asPromise(()=>this._provider.provideDeclaration(Y,le,re)).then(c)}}class o{constructor(H,X){this._documents=H,this._provider=X}provideImplementation(H,X,re){const Y=this._documents.getDocument(H),le=R.Position.to(X);return P.asPromise(()=>this._provider.provideImplementation(Y,le,re)).then(c)}}class l{constructor(H,X){this._documents=H,this._provider=X}provideTypeDefinition(H,X,re){const Y=this._documents.getDocument(H),le=R.Position.to(X);return P.asPromise(()=>this._provider.provideTypeDefinition(Y,le,re)).then(c)}}class i{constructor(H,X){this._documents=H,this._provider=X}provideHover(H,X,re){const Y=this._documents.getDocument(H),le=R.Position.to(X);return P.asPromise(()=>this._provider.provideHover(Y,le,re)).then(ve=>{if(!(!ve||C.isFalsyOrEmpty(ve.contents)))return ve.range||(ve.range=Y.getWordRangeAtPosition(le)),ve.range||(ve.range=new T.Range(le,le)),R.Hover.from(ve)})}}class h{constructor(H,X){this._documents=H,this._provider=X}provideEvaluatableExpression(H,X,re){const Y=this._documents.getDocument(H),le=R.Position.to(X);return P.asPromise(()=>this._provider.provideEvaluatableExpression(Y,le,re)).then(ve=>{if(ve)return R.EvaluatableExpression.from(ve)})}}class y{constructor(H,X){this._documents=H,this._provider=X}provideDocumentHighlights(H,X,re){const Y=this._documents.getDocument(H),le=R.Position.to(X);return P.asPromise(()=>this._provider.provideDocumentHighlights(Y,le,re)).then(ve=>{if(Array.isArray(ve))return ve.map(R.DocumentHighlight.from)})}}class g{constructor(H,X){this._documents=H,this._provider=X}provideLinkedEditingRanges(H,X,re){const Y=this._documents.getDocument(H),le=R.Position.to(X);return P.asPromise(()=>this._provider.provideLinkedEditingRanges(Y,le,re)).then(ve=>{if(ve&&Array.isArray(ve.ranges))return{ranges:C.coalesce(ve.ranges.map(R.Range.from)),wordPattern:ve.wordPattern}})}}class E{constructor(H,X){this._documents=H,this._provider=X}provideReferences(H,X,re,Y){const le=this._documents.getDocument(H),ve=R.Position.to(X);return P.asPromise(()=>this._provider.provideReferences(le,ve,re,Y)).then(De=>{if(Array.isArray(De))return De.map(R.location.from)})}}class b{constructor(H,X,re,Y,le,ve,De){this._documents=H,this._commands=X,this._diagnostics=re,this._provider=Y,this._logService=le,this._extension=ve,this._apiDeprecation=De,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(H,X,re,Y){const le=this._documents.getDocument(H),ve=v.Selection.isISelection(X)?R.Selection.to(X):R.Range.to(X),De=[];for(const Ee of this._diagnostics.getDiagnostics(H))if(ve.intersection(Ee.range)&&De.push(Ee)>b._maxCodeActionsPerFile)break;const Me={diagnostics:De,only:re.only?new T.CodeActionKind(re.only):void 0};return P.asPromise(()=>this._provider.provideCodeActions(le,ve,Me,Y)).then(Ee=>{var Pe;if(!(!C.isNonEmptyArray(Ee)||Y.isCancellationRequested)){const Ce=this._cache.add(Ee),Oe=new f.DisposableStore;this._disposables.set(Ce,Oe);const Se=[];for(let Be=0;Be<Ee.length;Be++){const K=Ee[Be];!K||(b._isCommand(K)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Se.push({_isSynthetic:!0,title:K.title,command:this._commands.toInternal(K,Oe)})):(Me.only&&(K.kind?Me.only.contains(K.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${K.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Se.push({cacheId:[Ce,Be],title:K.title,command:K.command&&this._commands.toInternal(K.command,Oe),diagnostics:K.diagnostics&&K.diagnostics.map(R.Diagnostic.from),edit:K.edit&&R.WorkspaceEdit.from(K.edit),kind:K.kind&&K.kind.value,isPreferred:K.isPreferred,disabled:(Pe=K.disabled)===null||Pe===void 0?void 0:Pe.reason})))}return{cacheId:Ce,actions:Se}}})}async resolveCodeAction(H,X){var re;const[Y,le]=H,ve=this._cache.get(Y,le);if(!(!ve||b._isCommand(ve))&&!!this._provider.resolveCodeAction){const De=(re=await this._provider.resolveCodeAction(ve,X))!==null&&re!==void 0?re:ve;return(De==null?void 0:De.edit)?R.WorkspaceEdit.from(De.edit):void 0}}releaseCodeActions(H){var X;(X=this._disposables.get(H))===null||X===void 0||X.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}b._maxCodeActionsPerFile=1e3;class L{constructor(H,X){this._documents=H,this._provider=X}provideDocumentFormattingEdits(H,X,re){const Y=this._documents.getDocument(H);return P.asPromise(()=>this._provider.provideDocumentFormattingEdits(Y,X,re)).then(le=>{if(Array.isArray(le))return le.map(R.TextEdit.from)})}}class A{constructor(H,X){this._documents=H,this._provider=X}provideDocumentRangeFormattingEdits(H,X,re,Y){const le=this._documents.getDocument(H),ve=R.Range.to(X);return P.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(le,ve,re,Y)).then(De=>{if(Array.isArray(De))return De.map(R.TextEdit.from)})}}class N{constructor(H,X){this._documents=H,this._provider=X,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(H,X,re,Y,le){const ve=this._documents.getDocument(H),De=R.Position.to(X);return P.asPromise(()=>this._provider.provideOnTypeFormattingEdits(ve,De,re,Y,le)).then(Me=>{if(Array.isArray(Me))return Me.map(R.TextEdit.from)})}}class W{constructor(H,X){this._provider=H,this._logService=X,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(H,X){const re=D.IdObject.mixin({symbols:[]});return P.asPromise(()=>this._provider.provideWorkspaceSymbols(H,X)).then(Y=>{if(C.isNonEmptyArray(Y)){for(const le of Y)if(!!le){if(!le.name){this._logService.warn("INVALID SymbolInformation, lacks name",le);continue}const ve=D.IdObject.mixin(R.WorkspaceSymbol.from(le));this._symbolCache.set(ve._id,le),re.symbols.push(ve)}}}).then(()=>(re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re))}async resolveWorkspaceSymbol(H,X){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const re=this._symbolCache.get(H._id);if(re){const Y=await P.asPromise(()=>this._provider.resolveWorkspaceSymbol(re,X));return Y&&k.mixin(H,R.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(H){const X=this._resultCache.get(H);if(X){for(let[re,Y]=X;re<=Y;re++)this._symbolCache.delete(re);this._resultCache.delete(H)}}}class x{constructor(H,X,re){this._documents=H,this._provider=X,this._logService=re}static supportsResolving(H){return typeof H.prepareRename=="function"}provideRenameEdits(H,X,re,Y){const le=this._documents.getDocument(H),ve=R.Position.to(X);return P.asPromise(()=>this._provider.provideRenameEdits(le,ve,re,Y)).then(De=>{if(!!De)return R.WorkspaceEdit.from(De)},De=>{const Me=x._asMessage(De);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(De)})}resolveRenameLocation(H,X,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const Y=this._documents.getDocument(H),le=R.Position.to(X);return P.asPromise(()=>this._provider.prepareRename(Y,le,re)).then(ve=>{let De,Me;if(T.Range.isRange(ve)?(De=ve,Me=Y.getText(ve)):S.isObject(ve)&&(De=ve.range,Me=ve.placeholder),!!De){if(De.start.line>le.line||De.end.line<le.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:R.Range.from(De),text:Me}}},ve=>{const De=x._asMessage(ve);return De?{rejectReason:De,range:void 0,text:void 0}:Promise.reject(ve)})}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class M{constructor(H,X){this.resultId=H,this.tokens=X}}class ${constructor(H,X){this._documents=H,this._provider=X,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(H,X,re){const Y=this._documents.getDocument(H),le=X!==0?this._previousResults.get(X):null;return P.asPromise(()=>le&&typeof le.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(Y,le.resultId,re):this._provider.provideDocumentSemanticTokens(Y,re)).then(ve=>(le&&this._previousResults.delete(X),ve?(ve=$._fixProvidedSemanticTokens(ve),this._send($._convertToEdits(le,ve),ve)):null))}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return $._isSemanticTokens(H)?$._isCorrectSemanticTokens(H)?H:new T.SemanticTokens(new Uint32Array(H.data),H.resultId):$._isSemanticTokensEdits(H)?$._isCorrectSemanticTokensEdits(H)?H:new T.SemanticTokensEdits(H.edits.map(X=>new T.SemanticTokensEdit(X.start,X.deleteCount,X.data?new Uint32Array(X.data):X.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const X of H.edits)if(!(X.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,X){if(!$._isSemanticTokens(X)||!H||!H.tokens)return X;const re=H.tokens,Y=re.length,le=X.data,ve=le.length;let De=0;const Me=Math.min(Y,ve);for(;De<Me&&re[De]===le[De];)De++;if(De===Y&&De===ve)return new T.SemanticTokensEdits([],X.resultId);let Ee=0;const Pe=Me-De;for(;Ee<Pe&&re[Y-Ee-1]===le[ve-Ee-1];)Ee++;return new T.SemanticTokensEdits([{start:De,deleteCount:Y-De-Ee,data:le.subarray(De,ve-Ee)}],X.resultId)}_send(H,X){if($._isSemanticTokens(H)){const re=this._nextResultId++;return this._previousResults.set(re,new M(H.resultId,H.data)),u.encodeSemanticTokensDto({id:re,type:"full",data:H.data})}if($._isSemanticTokensEdits(H)){const re=this._nextResultId++;return $._isSemanticTokens(X)?this._previousResults.set(re,new M(X.resultId,X.data)):this._previousResults.set(re,new M(H.resultId)),u.encodeSemanticTokensDto({id:re,type:"delta",deltas:(H.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class O{constructor(H,X){this._documents=H,this._provider=X}provideDocumentRangeSemanticTokens(H,X,re){const Y=this._documents.getDocument(H);return P.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(Y,R.Range.to(X),re)).then(le=>le?this._send(le):null)}_send(H){return u.encodeSemanticTokensDto({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=O;class B{constructor(H,X,re,Y,le){this._documents=H,this._commands=X,this._provider=re,this._apiDeprecation=Y,this._extension=le,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,X,re,Y){const le=this._documents.getDocument(H),ve=R.Position.to(X),De=le.getWordRangeAtPosition(ve)||new T.Range(ve,ve),Me=De.with({end:ve}),Ee=new p.StopWatch(!0),Pe=await P.asPromise(()=>this._provider.provideCompletionItems(le,ve,Y,R.CompletionContext.to(re)));if(!!Pe&&!Y.isCancellationRequested){const Ce=Array.isArray(Pe)?new T.CompletionList(Pe):Pe,Oe=B.supportsResolving(this._provider)?this._cache.add(Ce.items):this._cache.add([]),Se=new f.DisposableStore;this._disposables.set(Oe,Se);const Be=[],K={x:Oe,b:Be,a:{replace:R.Range.from(De),insert:R.Range.from(Me)},c:Ce.isIncomplete||void 0,d:Ee.elapsed()};for(let se=0;se<Ce.items.length;se++){const _e=Ce.items[se],Ae=this._convertCompletionItem(_e,[Oe,se],Me,De);Be.push(Ae)}return K}}async resolveCompletionItem(H,X){if(typeof this._provider.resolveCompletionItem=="function"){const re=this._cache.get(...H);if(!!re){const Y=await P.asPromise(()=>this._provider.resolveCompletionItem(re,X));if(!!Y)return this._convertCompletionItem(Y,H)}}}releaseCompletionItems(H){var X;(X=this._disposables.get(H))===null||X===void 0||X.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,X,re,Y){var le;const ve=this._disposables.get(X[0]);if(!ve)throw Error("DisposableStore is missing...");const De={x:X,a:(le=H.label)!==null&&le!==void 0?le:"",o:H.label2,b:H.kind!==void 0?R.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(R.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:R.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(R.TextEdit.from),m:this._commands.toInternal(H.command,ve)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),De.h=H.textEdit.newText):typeof H.insertText=="string"?De.h=H.insertText:H.insertText instanceof T.SnippetString&&(De.h=H.insertText.value,De.i|=4);let Me;return H.textEdit?Me=H.textEdit.range:H.range&&(Me=H.range),T.Range.isRange(Me)?De.j=R.Range.from(Me):Me&&(!(re==null?void 0:re.isEqual(Me.inserting))||!(Y==null?void 0:Y.isEqual(Me.replacing)))&&(De.j={insert:R.Range.from(Me.inserting),replace:R.Range.from(Me.replacing)}),De}}class J{constructor(H,X){this._documents=H,this._provider=X,this._cache=new w.Cache("SignatureHelp")}provideSignatureHelp(H,X,re,Y){const le=this._documents.getDocument(H),ve=R.Position.to(X),De=this.reviveContext(re);return P.asPromise(()=>this._provider.provideSignatureHelp(le,ve,Y,De)).then(Me=>{if(Me){const Ee=this._cache.add([Me]);return Object.assign(Object.assign({},R.SignatureHelp.from(Me)),{id:Ee})}})}reviveContext(H){let X;if(H.activeSignatureHelp){const re=R.SignatureHelp.to(H.activeSignatureHelp),Y=this._cache.get(H.activeSignatureHelp.id,0);Y?(X=Y,X.activeSignature=re.activeSignature,X.activeParameter=re.activeParameter):X=re}return Object.assign(Object.assign({},H),{activeSignatureHelp:X})}releaseSignatureHelp(H){this._cache.delete(H)}}class U{constructor(H,X){this._documents=H,this._provider=X}provideInlineHints(H,X,re){const Y=this._documents.getDocument(H);return P.asPromise(()=>this._provider.provideInlineHints(Y,R.Range.to(X),re)).then(le=>le?{hints:le.map(R.InlineHint.from)}:void 0)}}class V{constructor(H,X){this._documents=H,this._provider=X,this._cache=new w.Cache("DocumentLink")}provideLinks(H,X){const re=this._documents.getDocument(H);return P.asPromise(()=>this._provider.provideDocumentLinks(re,X)).then(Y=>{if(!(!Array.isArray(Y)||Y.length===0)&&!X.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:Y.map(R.DocumentLink.from)};{const le=this._cache.add(Y),ve={links:[],id:le};for(let De=0;De<Y.length;De++){const Me=R.DocumentLink.from(Y[De]);Me.cacheId=[le,De],ve.links.push(Me)}return ve}}})}resolveLink(H,X){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const re=this._cache.get(...H);return re?P.asPromise(()=>this._provider.resolveDocumentLink(re,X)).then(Y=>Y&&R.DocumentLink.from(Y)||void 0):Promise.resolve(void 0)}releaseLinks(H){this._cache.delete(H)}}class z{constructor(H,X){this._documents=H,this._provider=X}provideColors(H,X){const re=this._documents.getDocument(H);return P.asPromise(()=>this._provider.provideDocumentColors(re,X)).then(Y=>Array.isArray(Y)?Y.map(ve=>({color:R.Color.from(ve.color),range:R.Range.from(ve.range)})):[])}provideColorPresentations(H,X,re){const Y=this._documents.getDocument(H),le=R.Range.to(X.range),ve=R.Color.to(X.color);return P.asPromise(()=>this._provider.provideColorPresentations(ve,{document:Y,range:le},re)).then(De=>{if(!!Array.isArray(De))return De.map(R.ColorPresentation.from)})}}class Q{constructor(H,X){this._documents=H,this._provider=X}provideFoldingRanges(H,X,re){const Y=this._documents.getDocument(H);return P.asPromise(()=>this._provider.provideFoldingRanges(Y,X,re)).then(le=>{if(!!Array.isArray(le))return le.map(R.FoldingRange.from)})}}class ae{constructor(H,X,re){this._documents=H,this._provider=X,this._logService=re}provideSelectionRanges(H,X,re){const Y=this._documents.getDocument(H),le=X.map(R.Position.to);return P.asPromise(()=>this._provider.provideSelectionRanges(Y,le,re)).then(ve=>{if(!C.isNonEmptyArray(ve))return[];if(ve.length!==le.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const De=[];for(let Me=0;Me<le.length;Me++){const Ee=[];De.push(Ee);let Pe=le[Me],Ce=ve[Me];for(;;){if(!Ce.range.contains(Pe))throw new Error("INVALID selection range, must contain the previous range");if(Ee.push(R.SelectionRange.from(Ce)),!Ce.parent)break;Pe=Ce.range,Ce=Ce.parent}}return De})}}class ce{constructor(H,X){this._documents=H,this._provider=X,this._idPool=new m.IdGenerator(""),this._cache=new Map}async prepareSession(H,X,re){const Y=this._documents.getDocument(H),le=R.Position.to(X),ve=await this._provider.prepareCallHierarchy(Y,le,re);if(!!ve){const De=this._idPool.nextId();return this._cache.set(De,new Map),Array.isArray(ve)?ve.map(Me=>this._cacheAndConvertItem(De,Me)):[this._cacheAndConvertItem(De,ve)]}}async provideCallsTo(H,X,re){const Y=this._itemFromCache(H,X);if(!Y)throw new Error("missing call hierarchy item");const le=await this._provider.provideCallHierarchyIncomingCalls(Y,re);if(!!le)return le.map(ve=>({from:this._cacheAndConvertItem(H,ve.from),fromRanges:ve.fromRanges.map(De=>R.Range.from(De))}))}async provideCallsFrom(H,X,re){const Y=this._itemFromCache(H,X);if(!Y)throw new Error("missing call hierarchy item");const le=await this._provider.provideCallHierarchyOutgoingCalls(Y,re);if(!!le)return le.map(ve=>({to:this._cacheAndConvertItem(H,ve.to),fromRanges:ve.fromRanges.map(De=>R.Range.from(De))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,X){var re;const Y=this._cache.get(H),le={_sessionId:H,_itemId:Y.size.toString(36),name:X.name,detail:X.detail,kind:R.SymbolKind.from(X.kind),uri:X.uri,range:R.Range.from(X.range),selectionRange:R.Range.from(X.selectionRange),tags:(re=X.tags)===null||re===void 0?void 0:re.map(R.SymbolTag.from)};return Y.set(le._itemId,X),le}_itemFromCache(H,X){const re=this._cache.get(H);return re==null?void 0:re.get(X)}}class fe{constructor(H,X){this.adapter=H,this.extension=X}}class we{constructor(H,X,re,Y,le,ve,De){this._adapter=new Map,this._uriTransformer=X,this._proxy=H.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=Y,this._diagnostics=le,this._logService=ve,this._apiDeprecation=De}_transformDocumentSelector(H){return C.coalesce(C.asArray(H).map(X=>this._doTransformDocumentSelector(X)))}_doTransformDocumentSelector(H){if(typeof H=="string")return{$serialized:!0,language:H};if(H)return{$serialized:!0,language:H.language,scheme:this._transformScheme(H.scheme),pattern:typeof H.pattern=="undefined"?void 0:R.GlobPattern.from(H.pattern),exclusive:H.exclusive}}_transformScheme(H){return this._uriTransformer&&typeof H=="string"?this._uriTransformer.transformOutgoingScheme(H):H}_createDisposable(H){return new T.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return we._handlePool++}_withAdapter(H,X,re,Y,le=!1){const ve=this._adapter.get(H);if(!ve)return Promise.resolve(Y);if(ve.adapter instanceof X){let De;ve.extension&&(De=Date.now(),this._logService.trace(`[${ve.extension.identifier.value}] INVOKE provider '${X.name}'`));const Me=re(ve.adapter,ve.extension),Ee=ve.extension;return Ee&&Promise.resolve(Me).then(()=>this._logService.trace(`[${Ee.identifier.value}] provider DONE after ${Date.now()-De}ms`),Pe=>{le&&Pe instanceof d.CancellationError||(this._logService.error(`[${Ee.identifier.value}] provider FAILED`),this._logService.error(Pe))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(H,X){const re=this._nextHandle();return this._adapter.set(re,new fe(H,X)),re}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,X,re,Y){const le=this._addNewAdapter(new s(this._documents,re),H),ve=Y&&Y.label||we._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(le,this._transformDocumentSelector(X),ve),this._createDisposable(le)}$provideDocumentSymbols(H,X,re){return this._withAdapter(H,s,Y=>Y.provideDocumentSymbols(_.URI.revive(X),re),void 0)}registerCodeLensProvider(H,X,re){const Y=this._nextHandle(),le=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(Y,new fe(new a(this._documents,this._commands.converter,re),H)),this._proxy.$registerCodeLensSupport(Y,this._transformDocumentSelector(X),le);let ve=this._createDisposable(Y);if(le!==void 0){const De=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(le));ve=T.Disposable.from(ve,De)}return ve}$provideCodeLenses(H,X,re){return this._withAdapter(H,a,Y=>Y.provideCodeLenses(_.URI.revive(X),re),void 0)}$resolveCodeLens(H,X,re){return this._withAdapter(H,a,Y=>Y.resolveCodeLens(X,re),void 0)}$releaseCodeLenses(H,X){this._withAdapter(H,a,re=>Promise.resolve(re.releaseCodeLenses(X)),void 0)}registerDefinitionProvider(H,X,re){const Y=this._addNewAdapter(new t(this._documents,re),H);return this._proxy.$registerDefinitionSupport(Y,this._transformDocumentSelector(X)),this._createDisposable(Y)}$provideDefinition(H,X,re,Y){return this._withAdapter(H,t,le=>le.provideDefinition(_.URI.revive(X),re,Y),[])}registerDeclarationProvider(H,X,re){const Y=this._addNewAdapter(new r(this._documents,re),H);return this._proxy.$registerDeclarationSupport(Y,this._transformDocumentSelector(X)),this._createDisposable(Y)}$provideDeclaration(H,X,re,Y){return this._withAdapter(H,r,le=>le.provideDeclaration(_.URI.revive(X),re,Y),[])}registerImplementationProvider(H,X,re){const Y=this._addNewAdapter(new o(this._documents,re),H);return this._proxy.$registerImplementationSupport(Y,this._transformDocumentSelector(X)),this._createDisposable(Y)}$provideImplementation(H,X,re,Y){return this._withAdapter(H,o,le=>le.provideImplementation(_.URI.revive(X),re,Y),[])}registerTypeDefinitionProvider(H,X,re){const Y=this._addNewAdapter(new l(this._documents,re),H);return this._proxy.$registerTypeDefinitionSupport(Y,this._transformDocumentSelector(X)),this._createDisposable(Y)}$provideTypeDefinition(H,X,re,Y){return this._withAdapter(H,l,le=>le.provideTypeDefinition(_.URI.revive(X),re,Y),[])}registerHoverProvider(H,X,re,Y){const le=this._addNewAdapter(new i(this._documents,re),H);return this._proxy.$registerHoverProvider(le,this._transformDocumentSelector(X)),this._createDisposable(le)}$provideHover(H,X,re,Y){return this._withAdapter(H,i,le=>le.provideHover(_.URI.revive(X),re,Y),void 0)}registerEvaluatableExpressionProvider(H,X,re,Y){const le=this._addNewAdapter(new h(this._documents,re),H);return this._proxy.$registerEvaluatableExpressionProvider(le,this._transformDocumentSelector(X)),this._createDisposable(le)}$provideEvaluatableExpression(H,X,re,Y){return this._withAdapter(H,h,le=>le.provideEvaluatableExpression(_.URI.revive(X),re,Y),void 0)}registerDocumentHighlightProvider(H,X,re){const Y=this._addNewAdapter(new y(this._documents,re),H);return this._proxy.$registerDocumentHighlightProvider(Y,this._transformDocumentSelector(X)),this._createDisposable(Y)}$provideDocumentHighlights(H,X,re,Y){return this._withAdapter(H,y,le=>le.provideDocumentHighlights(_.URI.revive(X),re,Y),void 0)}registerLinkedEditingRangeProvider(H,X,re){const Y=this._addNewAdapter(new g(this._documents,re),H);return this._proxy.$registerLinkedEditingRangeProvider(Y,this._transformDocumentSelector(X)),this._createDisposable(Y)}$provideLinkedEditingRanges(H,X,re,Y){return this._withAdapter(H,g,async le=>{const ve=await le.provideLinkedEditingRanges(_.URI.revive(X),re,Y);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?we._serializeRegExp(ve.wordPattern):void 0}},void 0)}registerReferenceProvider(H,X,re){const Y=this._addNewAdapter(new E(this._documents,re),H);return this._proxy.$registerReferenceSupport(Y,this._transformDocumentSelector(X)),this._createDisposable(Y)}$provideReferences(H,X,re,Y,le){return this._withAdapter(H,E,ve=>ve.provideReferences(_.URI.revive(X),re,Y,le),void 0)}registerCodeActionProvider(H,X,re,Y){var le,ve;const De=new f.DisposableStore,Me=this._addNewAdapter(new b(this._documents,this._commands.converter,this._diagnostics,re,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(Me,this._transformDocumentSelector(X),{providedKinds:(le=Y==null?void 0:Y.providedCodeActionKinds)===null||le===void 0?void 0:le.map(Ee=>Ee.value),documentation:(ve=Y==null?void 0:Y.documentation)===null||ve===void 0?void 0:ve.map(Ee=>({kind:Ee.kind.value,command:this._commands.converter.toInternal(Ee.command,De)}))},we._extLabel(H),Boolean(re.resolveCodeAction)),De.add(this._createDisposable(Me)),De}$provideCodeActions(H,X,re,Y,le){return this._withAdapter(H,b,ve=>ve.provideCodeActions(_.URI.revive(X),re,Y,le),void 0)}$resolveCodeAction(H,X,re){return this._withAdapter(H,b,Y=>Y.resolveCodeAction(X,re),void 0)}$releaseCodeActions(H,X){this._withAdapter(H,b,re=>Promise.resolve(re.releaseCodeActions(X)),void 0)}registerDocumentFormattingEditProvider(H,X,re){const Y=this._addNewAdapter(new L(this._documents,re),H);return this._proxy.$registerDocumentFormattingSupport(Y,this._transformDocumentSelector(X),H.identifier,H.displayName||H.name),this._createDisposable(Y)}$provideDocumentFormattingEdits(H,X,re,Y){return this._withAdapter(H,L,le=>le.provideDocumentFormattingEdits(_.URI.revive(X),re,Y),void 0)}registerDocumentRangeFormattingEditProvider(H,X,re){const Y=this._addNewAdapter(new A(this._documents,re),H);return this._proxy.$registerRangeFormattingSupport(Y,this._transformDocumentSelector(X),H.identifier,H.displayName||H.name),this._createDisposable(Y)}$provideDocumentRangeFormattingEdits(H,X,re,Y,le){return this._withAdapter(H,A,ve=>ve.provideDocumentRangeFormattingEdits(_.URI.revive(X),re,Y,le),void 0)}registerOnTypeFormattingEditProvider(H,X,re,Y){const le=this._addNewAdapter(new N(this._documents,re),H);return this._proxy.$registerOnTypeFormattingSupport(le,this._transformDocumentSelector(X),Y,H.identifier),this._createDisposable(le)}$provideOnTypeFormattingEdits(H,X,re,Y,le,ve){return this._withAdapter(H,N,De=>De.provideOnTypeFormattingEdits(_.URI.revive(X),re,Y,le,ve),void 0)}registerWorkspaceSymbolProvider(H,X){const re=this._addNewAdapter(new W(X,this._logService),H);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(H,X,re){return this._withAdapter(H,W,Y=>Y.provideWorkspaceSymbols(X,re),{symbols:[]})}$resolveWorkspaceSymbol(H,X,re){return this._withAdapter(H,W,Y=>Y.resolveWorkspaceSymbol(X,re),void 0)}$releaseWorkspaceSymbols(H,X){this._withAdapter(H,W,re=>re.releaseWorkspaceSymbols(X),void 0)}registerRenameProvider(H,X,re){const Y=this._addNewAdapter(new x(this._documents,re,this._logService),H);return this._proxy.$registerRenameSupport(Y,this._transformDocumentSelector(X),x.supportsResolving(re)),this._createDisposable(Y)}$provideRenameEdits(H,X,re,Y,le){return this._withAdapter(H,x,ve=>ve.provideRenameEdits(_.URI.revive(X),re,Y,le),void 0)}$resolveRenameLocation(H,X,re,Y){return this._withAdapter(H,x,le=>le.resolveRenameLocation(_.URI.revive(X),re,Y),void 0)}registerDocumentSemanticTokensProvider(H,X,re,Y){const le=this._nextHandle(),ve=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(le,new fe(new $(this._documents,re),H)),this._proxy.$registerDocumentSemanticTokensProvider(le,this._transformDocumentSelector(X),Y,ve);let De=this._createDisposable(le);if(ve){const Me=re.onDidChangeSemanticTokens(Ee=>this._proxy.$emitDocumentSemanticTokensEvent(ve));De=T.Disposable.from(De,Me)}return De}$provideDocumentSemanticTokens(H,X,re,Y){return this._withAdapter(H,$,le=>le.provideDocumentSemanticTokens(_.URI.revive(X),re,Y),null,!0)}$releaseDocumentSemanticTokens(H,X){this._withAdapter(H,$,re=>re.releaseDocumentSemanticColoring(X),void 0)}registerDocumentRangeSemanticTokensProvider(H,X,re,Y){const le=this._addNewAdapter(new O(this._documents,re),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(le,this._transformDocumentSelector(X),Y),this._createDisposable(le)}$provideDocumentRangeSemanticTokens(H,X,re,Y){return this._withAdapter(H,O,le=>le.provideDocumentRangeSemanticTokens(_.URI.revive(X),re,Y),null,!0)}registerCompletionItemProvider(H,X,re,Y){const le=this._addNewAdapter(new B(this._documents,this._commands.converter,re,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(le,this._transformDocumentSelector(X),Y,B.supportsResolving(re),`${H.identifier.value}(${Y.join("")})`),this._createDisposable(le)}$provideCompletionItems(H,X,re,Y,le){return this._withAdapter(H,B,ve=>ve.provideCompletionItems(_.URI.revive(X),re,Y,le),void 0)}$resolveCompletionItem(H,X,re){return this._withAdapter(H,B,Y=>Y.resolveCompletionItem(X,re),void 0)}$releaseCompletionItems(H,X){this._withAdapter(H,B,re=>re.releaseCompletionItems(X),void 0)}registerSignatureHelpProvider(H,X,re,Y){const le=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,ve=this._addNewAdapter(new J(this._documents,re),H);return this._proxy.$registerSignatureHelpProvider(ve,this._transformDocumentSelector(X),le),this._createDisposable(ve)}$provideSignatureHelp(H,X,re,Y,le){return this._withAdapter(H,J,ve=>ve.provideSignatureHelp(_.URI.revive(X),re,Y,le),void 0)}$releaseSignatureHelp(H,X){this._withAdapter(H,J,re=>re.releaseSignatureHelp(X),void 0)}registerInlineHintsProvider(H,X,re){const Y=typeof re.onDidChangeInlineHints=="function"?this._nextHandle():void 0,le=this._addNewAdapter(new U(this._documents,re),H);this._proxy.$registerInlineHintsProvider(le,this._transformDocumentSelector(X),Y);let ve=this._createDisposable(le);if(Y!==void 0){const De=re.onDidChangeInlineHints(Me=>this._proxy.$emitInlineHintsEvent(Y));ve=T.Disposable.from(ve,De)}return ve}$provideInlineHints(H,X,re,Y){return this._withAdapter(H,U,le=>le.provideInlineHints(_.URI.revive(X),re,Y),void 0)}registerDocumentLinkProvider(H,X,re){const Y=this._addNewAdapter(new V(this._documents,re),H);return this._proxy.$registerDocumentLinkProvider(Y,this._transformDocumentSelector(X),typeof re.resolveDocumentLink=="function"),this._createDisposable(Y)}$provideDocumentLinks(H,X,re){return this._withAdapter(H,V,Y=>Y.provideLinks(_.URI.revive(X),re),void 0)}$resolveDocumentLink(H,X,re){return this._withAdapter(H,V,Y=>Y.resolveLink(X,re),void 0)}$releaseDocumentLinks(H,X){this._withAdapter(H,V,re=>re.releaseLinks(X),void 0)}registerColorProvider(H,X,re){const Y=this._addNewAdapter(new z(this._documents,re),H);return this._proxy.$registerDocumentColorProvider(Y,this._transformDocumentSelector(X)),this._createDisposable(Y)}$provideDocumentColors(H,X,re){return this._withAdapter(H,z,Y=>Y.provideColors(_.URI.revive(X),re),[])}$provideColorPresentations(H,X,re,Y){return this._withAdapter(H,z,le=>le.provideColorPresentations(_.URI.revive(X),re,Y),void 0)}registerFoldingRangeProvider(H,X,re){const Y=this._nextHandle(),le=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(Y,new fe(new Q(this._documents,re),H)),this._proxy.$registerFoldingRangeProvider(Y,this._transformDocumentSelector(X),le);let ve=this._createDisposable(Y);if(le!==void 0){const De=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(le));ve=T.Disposable.from(ve,De)}return ve}$provideFoldingRanges(H,X,re,Y){return this._withAdapter(H,Q,le=>le.provideFoldingRanges(_.URI.revive(X),re,Y),void 0)}registerSelectionRangeProvider(H,X,re){const Y=this._addNewAdapter(new ae(this._documents,re,this._logService),H);return this._proxy.$registerSelectionRangeProvider(Y,this._transformDocumentSelector(X)),this._createDisposable(Y)}$provideSelectionRanges(H,X,re,Y){return this._withAdapter(H,ae,le=>le.provideSelectionRanges(_.URI.revive(X),re,Y),[])}registerCallHierarchyProvider(H,X,re){const Y=this._addNewAdapter(new ce(this._documents,re),H);return this._proxy.$registerCallHierarchyProvider(Y,this._transformDocumentSelector(X)),this._createDisposable(Y)}$prepareCallHierarchy(H,X,re,Y){return this._withAdapter(H,ce,le=>Promise.resolve(le.prepareSession(_.URI.revive(X),re,Y)),void 0)}$provideCallHierarchyIncomingCalls(H,X,re,Y){return this._withAdapter(H,ce,le=>le.provideCallsTo(X,re,Y),void 0)}$provideCallHierarchyOutgoingCalls(H,X,re,Y){return this._withAdapter(H,ce,le=>le.provideCallsFrom(X,re,Y),void 0)}$releaseCallHierarchy(H,X){this._withAdapter(H,ce,re=>Promise.resolve(re.releaseSession(X)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:I.regExpFlags(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:we._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:we._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?we._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?we._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:we._serializeRegExp(H.beforeText),afterText:H.afterText?we._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?we._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(we._serializeOnEnterRule)}setLanguageConfiguration(H,X,re){let{wordPattern:Y}=re;if(Y&&I.regExpLeadsToEndlessLoop(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this._documents.setWordDefinitionFor(X,Y):this._documents.setWordDefinitionFor(X,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const le=this._nextHandle(),ve={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?we._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?we._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?we._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(le,X,ve),this._createDisposable(le)}$setWordDefinitions(H){for(const X of H)this._documents.setWordDefinitionFor(X.languageId,new RegExp(X.regexSource,X.regexFlags))}}e.ExtHostLanguageFeatures=we,we._handlePool=0}),define(ge[240],pe([0,1,6,20,8]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(D,I){this._proxy=D.getProxy(_.MainContext.MainThreadLanguages),this._documents=I}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,I){await this._proxy.$changeLanguage(D,I);const n=this._documents.getDocumentData(D);if(!n)throw new Error(`document '${D.toString}' NOT found`);return n.document}async tokenAtPosition(D,I){var n;const C=D.version,S=k.Position.from(I),v=await this._proxy.$tokensAtPosition(D.uri,S),f={type:R.StandardTokenType.Other,range:(n=D.getWordRangeAtPosition(I))!==null&&n!==void 0?n:new R.Range(I.line,I.character,I.line,I.character)};if(!v)return f;const u={range:k.Range.to(v.range),type:k.TokenType.to(v.type)};return!u.range.contains(I)||C!==D.version?f:u}}e.ExtHostLanguages=T}),define(ge[241],pe([0,1,6,12,42]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(D){return D&&D.title}let P=class{constructor(I,n){this._logService=n,this._proxy=I.getProxy(_.MainContext.MainThreadMessageService)}showMessage(I,n,C,S,v){const f={extension:I};let u;typeof S=="string"||T(S)?u=[S,...v]:(f.modal=S&&S.modal,f.useCustom=S&&S.useCustom,u=v),f.useCustom&&R.checkProposedApiEnabled(I);const m=[];for(let w=0;w<u.length;w++){const p=u[w];if(typeof p=="string")m.push({title:p,handle:w,isCloseAffordance:!1});else if(typeof p=="object"){let{title:d,isCloseAffordance:s}=p;m.push({title:d,isCloseAffordance:!!s,handle:w})}else this._logService.warn("Invalid message item:",p)}return this._proxy.$showMessage(n,C,f,m).then(w=>{if(typeof w=="number")return u[w]})}};P=He([Fe(1,k.ILogService)],P),e.ExtHostMessageService=P}),define(ge[242],pe([0,1,21,3,5,2,26,6,20,8,87,45,22,202,204,71,16]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class p extends R.Disposable{constructor(i,h,y,g,E){super();this._editorId=i,this.uri=h,this._proxy=y,this._webviewInitData=g,this.document=E,this._onDidReceiveDocumentMessage=new k.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:b=>this._proxy.$postMessage(this._editorId,void 0,b),asWebviewUri:b=>this._asWebviewUri(b)}}onDidReceiveMessage(i,h){var y;this._onDidReceiveDocumentMessage.fire(h),i!==void 0&&((y=this._rendererIdToEmitters.get(i))===null||y===void 0||y.fire(h))}getRendererComm(i){const h=new k.Emitter;return this._rendererIdToEmitters.set(i,h),{editorId:this._editorId,onDidReceiveMessage:h.event,postMessage:y=>this._proxy.$postMessage(this._editorId,i,y),asWebviewUri:y=>this._asWebviewUri(y)}}_asWebviewUri(i){return C.asWebviewUri(this._webviewInitData,this._editorId,i)}}class d extends R.Disposable{constructor(i,h,y,g){super();this._proxy=i,this._handle=h,this._extension=y,this._provider=g,this._kernelToFriendlyId=new Map,this._friendlyIdToKernel=new Map,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(E=>{const b=E==null?void 0:E.uri;this._proxy.$onNotebookKernelChange(this._handle,b)}))}async provideKernels(i,h){const y=await this._provider.provideKernels(i.notebookDocument,h)||[],g=new Map;let E=0;const b=new Set,L=y.map(A=>{let N=this._kernelToFriendlyId.get(A);return N===void 0&&(A.id&&b.has(A.id)?N=`${this._extension.identifier.value}_${A.id}_${E++}`:N=`${this._extension.identifier.value}_${A.id||P.generateUuid()}`,this._kernelToFriendlyId.set(A,N)),g.set(A,N),{id:A.id,friendlyId:N,label:A.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,description:A.description,detail:A.detail,isPreferred:A.isPreferred,preloads:A.preloads}});return this._kernelToFriendlyId=g,this._friendlyIdToKernel.clear(),this._kernelToFriendlyId.forEach((A,N)=>{this._friendlyIdToKernel.set(A,N)}),L}getKernelByFriendlyId(i){return this._friendlyIdToKernel.get(i)}async resolveNotebook(i,h,y,g){const E=this._friendlyIdToKernel.get(i);if(E&&this._provider.resolveKernel)return this._provider.resolveKernel(E,h.notebookDocument,y,g)}async executeNotebook(i,h,y){const g=this._friendlyIdToKernel.get(i);if(!!g)return s(y?E=>g.executeCell(h.notebookDocument,y.cell,E):E=>g.executeAllCells(h.notebookDocument,E))}async cancelNotebook(i,h,y){const g=this._friendlyIdToKernel.get(i);if(!!g)return y?g.cancelCellExecution(h.notebookDocument,y.cell):g.cancelAllCellsExecution(h.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=d;async function s(l){const i=new _.CancellationTokenSource;try{await l(i.token)}finally{i.dispose()}}class a{constructor(i,h){this.key=a._Keys.nextId(),this._proxy=i,this._proxy.$registerNotebookEditorDecorationType(this.key,I.NotebookDecorationRenderOptions.from(h))}dispose(){this._proxy.$removeNotebookEditorDecorationType(this.key)}}e.NotebookEditorDecorationType=a,a._Keys=new m.IdGenerator("NotebookEditorDecorationType");class c{constructor(i,h,y,g,E,b){this._documentsAndEditors=y,this._webviewInitData=g,this.logService=E,this._extensionStoragePaths=b,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new v.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new k.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new k.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new k.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new k.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new k.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellLanguage=new k.Emitter,this.onDidChangeCellLanguage=this._onDidChangeCellLanguage.event,this._onDidChangeCellMetadata=new k.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new k.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidOpenNotebookDocument=new k.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new k.Emitter,this.onDidSaveNotebookDocument=this._onDidCloseNotebookDocument.event,this.visibleNotebookEditors=[],this._onDidChangeActiveNotebookKernel=new k.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._proxy=i.getProxy(D.MainContext.MainThreadNotebook),this._mainThreadBulkEdits=i.getProxy(D.MainContext.MainThreadBulkEdits),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:L=>{var A;if(L&&L.$mid===12){const N=(A=L.notebookEditor)===null||A===void 0?void 0:A.notebookUri,W=L.cell.handle,x=this._documents.get(N),M=x==null?void 0:x.getCell(W);if(M)return M.cell}return L}})}get outputDisplayOrder(){return this._outputDisplayOrder}get activeNotebookEditor(){return this._activeNotebookEditor}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(i){return this._documents.get(i)}registerNotebookContentProvider(i,h,y,g){var E,b,L;if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:i,provider:y});const A=[];A.push(y.onDidChangeNotebook?y.onDidChangeNotebook(x=>{const M=this._documents.get(T.URI.revive(x.document.uri));if(!M)throw new Error(`Notebook document ${x.document.uri.toString()} not found`);if(t(x)){const $=M.addEdit(x);this._proxy.$onUndoableContentChange(x.document.uri,h,$,x.label)}else this._proxy.$onContentChange(x.document.uri,h)}):R.Disposable.None),A.push(y.onDidChangeNotebookContentOptions?y.onDidChangeNotebookContentOptions(()=>{this._proxy.$updateNotebookProviderOptions(h,y.options)}):R.Disposable.None);const N=!!y.backupNotebook,W=(E=g==null?void 0:g.viewOptions)===null||E===void 0?void 0:E.filenamePattern.map(x=>I.NotebookExclusiveDocumentPattern.from(x)).filter(x=>x!==void 0);return((b=g==null?void 0:g.viewOptions)===null||b===void 0?void 0:b.filenamePattern)&&!W&&console.warn(`Notebook content provider view options file name pattern is invalid ${(L=g==null?void 0:g.viewOptions)===null||L===void 0?void 0:L.filenamePattern}`),this._proxy.$registerNotebookProvider({id:i.identifier,location:i.extensionLocation,description:i.description},h,N,{transientOutputs:(g==null?void 0:g.transientOutputs)||!1,transientMetadata:(g==null?void 0:g.transientMetadata)||{},viewOptions:(g==null?void 0:g.viewOptions)&&W?{displayName:g.viewOptions.displayName,filenamePattern:W,exclusive:g.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{A.forEach(x=>x.dispose()),this._notebookContentProviders.delete(h),this._proxy.$unregisterNotebookProvider(h)})}registerNotebookKernelProvider(i,h,y){const g=c._notebookKernelProviderHandlePool++,E=new d(this._proxy,g,i,y);return this._notebookKernelProviders.set(g,E),this._proxy.$registerNotebookKernelProvider({id:i.identifier,location:i.extensionLocation,description:i.description},g,{viewType:h.viewType,filenamePattern:h.filenamePattern?I.NotebookExclusiveDocumentPattern.from(h.filenamePattern):void 0}),new n.Disposable(()=>{E.dispose(),this._notebookKernelProviders.delete(g),this._proxy.$unregisterNotebookKernelProvider(g)})}createNotebookEditorDecorationType(i){return new a(this._proxy,i)}async openNotebookDocument(i,h){const y=this._documents.get(T.URI.revive(i));if(y)return Promise.resolve(y.notebookDocument);await this._proxy.$tryOpenDocument(i,h);const g=this._documents.get(T.URI.revive(i));return w.assertIsDefined(g==null?void 0:g.notebookDocument)}_withAdapter(i,h,y){const g=this._documents.get(T.URI.revive(h));if(!g)return[];const E=this._notebookKernelProviders.get(i);return E?y(E,g):[]}async showNotebookDocument(i,h){var y;let g;typeof h=="object"?g={position:I.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selection:h.selection,pinned:typeof h.preview=="boolean"?!h.preview:void 0}:g={preserveFocus:!1};const E=await this._proxy.$tryShowNotebookDocument(i.uri,i.viewType,g),b=E&&((y=this._editors.get(E))===null||y===void 0?void 0:y.editor);if(b)return b;throw E?new Error(`Could NOT open editor for "${i.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.toString()}".`)}async $provideNotebookKernels(i,h,y){return this._withAdapter(i,h,(g,E)=>g.provideKernels(E,y))}async $resolveNotebookKernel(i,h,y,g,E){await this._withAdapter(i,y,async(b,L)=>{const A=this._webviewComm.get(h);A&&await b.resolveNotebook(g,L,A.contentProviderComm,E)})}async $resolveNotebookData(i,h,y){const g=this._notebookContentProviders.get(i);if(!g)throw new Error(`NO provider for '${i}'`);const E=await g.provider.openNotebook(T.URI.revive(h),{backupId:y});return{metadata:Object.assign(Object.assign({},S.notebookDocumentMetadataDefaults),E.metadata),languages:E.languages,cells:E.cells.map(b=>Object.assign(Object.assign({},b),{outputs:b.outputs.map(L=>S.addIdToOutput(L))}))}}async $resolveNotebookEditor(i,h,y){const g=this._notebookContentProviders.get(i),E=T.URI.revive(h),b=this._documents.get(E);if(!(!b||!g)){let L=this._webviewComm.get(y);L||(L=new p(y,E,this._proxy,this._webviewInitData,b),this._webviewComm.set(y,L)),!!g.provider.resolveNotebook&&await g.provider.resolveNotebook(b.notebookDocument,L.contentProviderComm)}}async $executeNotebookKernelFromProvider(i,h,y,g){await this._withAdapter(i,h,async(E,b)=>{const L=g!==void 0?b.getCell(g):void 0;return E.executeNotebook(y,b,L)})}async $cancelNotebookKernelFromProvider(i,h,y,g){await this._withAdapter(i,h,async(E,b)=>{const L=g!==void 0?b.getCell(g):void 0;return E.cancelNotebook(y,b,L)})}async $saveNotebook(i,h,y){const g=this._documents.get(T.URI.revive(h));return g&&this._notebookContentProviders.has(i)?(await this._notebookContentProviders.get(i).provider.saveNotebook(g.notebookDocument,y),!0):!1}async $saveNotebookAs(i,h,y,g){const E=this._documents.get(T.URI.revive(h));return E&&this._notebookContentProviders.has(i)?(await this._notebookContentProviders.get(i).provider.saveNotebookAs(T.URI.revive(y),E.notebookDocument,g),!0):!1}async $undoNotebook(i,h,y,g){const E=this._documents.get(T.URI.revive(h));!E||E.undo(y,g)}async $redoNotebook(i,h,y,g){const E=this._documents.get(T.URI.revive(h));!E||E.redo(y,g)}async $backup(i,h,y){const g=this._documents.get(T.URI.revive(h)),E=this._notebookContentProviders.get(i);if(g&&E&&E.provider.backupNotebook){const b=await E.provider.backupNotebook(g.notebookDocument,{destination:g.getNewBackupUri()},y);return g.updateBackup(b),b.id}}$acceptDisplayOrder(i){this._outputDisplayOrder=i}$acceptNotebookActiveKernelChange(i){i.providerHandle!==void 0&&this._withAdapter(i.providerHandle,i.uri,async(h,y)=>{const g=i.kernelFriendlyId?h.getKernelByFriendlyId(i.kernelFriendlyId):void 0;this._editors.forEach(E=>{E.editor.notebookData===y&&E.editor._acceptKernel(g)}),this._onDidChangeActiveNotebookKernel.fire({document:y.notebookDocument,kernel:g})})}_getEditorFromURI(i){const h=T.URI.revive(i).toString();let y;return this._editors.forEach(g=>{g.editor.document.uri.toString()===h&&(y=g)}),y}$onDidReceiveMessage(i,h,y){var g;(g=this._webviewComm.get(i))===null||g===void 0||g.onDidReceiveMessage(h,y)}$acceptModelChanged(i,h,y){const g=this._documents.get(T.URI.revive(i));g&&g.acceptModelChanged(h,y)}$acceptModelSaved(i){const h=this._documents.get(T.URI.revive(i));h&&this._onDidSaveNotebookDocument.fire(h.notebookDocument)}$acceptEditorPropertiesChanged(i,h){var y;this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",i,h);let g;if(this._editors.forEach(E=>{E.editor.id===i&&(g=E)}),!!g&&(h.visibleRanges&&(g.editor._acceptVisibleRanges(h.visibleRanges.ranges),this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:g.editor,visibleRanges:g.editor.visibleRanges})),h.selections)){if(h.selections.selections.length){const E=h.selections.selections[0];g.editor.selection=(y=g.editor.notebookData.getCell(E))===null||y===void 0?void 0:y.cell}else g.editor.selection=void 0;this._onDidChangeNotebookEditorSelection.fire({notebookEditor:g.editor,selection:g.editor.selection})}}$acceptDocumentPropertiesChanged(i,h){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",i.path,h);const y=this._getEditorFromURI(i);!y||h.metadata&&y.editor.notebookData.acceptDocumentPropertiesChanged(h)}_createExtHostEditor(i,h,y,g){var E,b;const L=i.uri;let A=this._webviewComm.get(h);A||(A=new p(h,L,this._proxy,this._webviewInitData,i),this._webviewComm.set(h,A));const N=new u.ExtHostNotebookEditor(h,i.notebookDocument.viewType,this._proxy,A.contentProviderComm,i);if(y.length){const W=y[0];N.selection=(E=N.notebookData.getCell(W))===null||E===void 0?void 0:E.cell}else N.selection=void 0;N._acceptVisibleRanges(g),(b=this._editors.get(h))===null||b===void 0||b.editor.dispose(),this._editors.set(h,{editor:N})}$acceptDocumentAndEditorsDelta(i){var h,y,g,E,b;let L=!1;if(i.removedDocuments)for(const N of i.removedDocuments){const W=T.URI.revive(N),x=this._documents.get(W);x&&(x.dispose(),this._documents.delete(W),this._documentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:x.notebookDocument.cells.map(M=>M.uri)}),this._onDidCloseNotebookDocument.fire(x.notebookDocument));for(const M of this._editors.values())M.editor.document.uri.toString()===W.toString()&&(M.editor.dispose(),this._editors.delete(M.editor.id),L=!0)}if(i.addedDocuments){const N=[];for(const W of i.addedDocuments){const x=T.URI.revive(W.uri),M=W.viewType,$=this._notebookContentProviders.get(M),O=$&&((h=this._extensionStoragePaths.workspaceValue($.extension))!==null&&h!==void 0?h:this._extensionStoragePaths.globalValue($.extension));if(this._documents.has(x))throw new Error(`adding EXISTING notebook ${x}`);const B=this,J=new f.ExtHostNotebookDocument(this._proxy,this._documentsAndEditors,this._mainThreadBulkEdits,{emitModelChange(U){B._onDidChangeNotebookCells.fire(U)},emitCellOutputsChange(U){B._onDidChangeCellOutputs.fire(U)},emitCellLanguageChange(U){B._onDidChangeCellLanguage.fire(U)},emitCellMetadataChange(U){B._onDidChangeCellMetadata.fire(U)},emitDocumentMetadataChange(U){B._onDidChangeNotebookDocumentMetadata.fire(U)}},M,W.contentOptions,Object.assign(Object.assign({},S.notebookDocumentMetadataDefaults),W.metadata),x,O);J.acceptModelChanged({versionId:W.versionId,rawEvents:[{kind:S.NotebookCellsChangeType.Initialize,changes:[[0,0,W.cells]]}]},!1),N.push(...W.cells.map(U=>f.ExtHostCell.asModelAddData(J.notebookDocument,U))),(y=this._documents.get(x))===null||y===void 0||y.dispose(),this._documents.set(x,J),W.attachedEditor&&(this._createExtHostEditor(J,W.attachedEditor.id,W.attachedEditor.selections,W.attachedEditor.visibleRanges),L=!0),this._documentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:N}),this._onDidOpenNotebookDocument.fire(J.notebookDocument)}}if(i.addedEditors)for(const N of i.addedEditors){if(this._editors.has(N.id))return;const W=T.URI.revive(N.documentUri),x=this._documents.get(W);x&&(this._createExtHostEditor(x,N.id,N.selections,N.visibleRanges),L=!0)}const A=[];if(i.removedEditors)for(const N of i.removedEditors){const W=this._editors.get(N);W&&(L=!0,this._editors.delete(N),((g=this.activeNotebookEditor)===null||g===void 0?void 0:g.id)===W.editor.id&&(this._activeNotebookEditor=void 0),A.push(W))}if(L&&A.forEach(N=>{N.editor.dispose()}),i.visibleEditors){this.visibleNotebookEditors=i.visibleEditors.map(W=>this._editors.get(W).editor).filter(W=>!!W);const N=new Set;this.visibleNotebookEditors.forEach(W=>N.add(W.id));for(const W of this._editors.values()){const x=N.has(W.editor.id);W.editor._acceptVisibility(x)}this.visibleNotebookEditors=[...this._editors.values()].map(W=>W.editor).filter(W=>W.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}if(i.newActiveEditor!==void 0){if(i.newActiveEditor){this._activeNotebookEditor=(E=this._editors.get(i.newActiveEditor))===null||E===void 0?void 0:E.editor,(b=this._activeNotebookEditor)===null||b===void 0||b._acceptActive(!0);for(const N of this._editors.values())N.editor!==this.activeNotebookEditor&&N.editor._acceptActive(!1)}else{this._activeNotebookEditor=void 0;for(const N of this._editors.values())N.editor._acceptActive(!1)}this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor)}}createNotebookCellStatusBarItemInternal(i,h,y){const g=new r(this._proxy,this._commandsConverter,i,h,y),E=S.CellUri.parse(i.uri);if(E){const b=this._documents.get(E.notebook);if(b){const L=b.getCell(E.handle);L&&k.Event.once(L.onDidDispose)(()=>g.dispose())}}return g}}e.ExtHostNotebookController=c,c._notebookKernelProviderHandlePool=0;function t(l){return typeof l.undo=="function"&&typeof l.redo=="function"}class r extends R.Disposable{constructor(i,h,y,g,E){super();this._proxy=i,this._commands=h,this._cell=y,this._priority=E,this._id=r.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new R.DisposableStore),this._alignment=g!=null?g:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=o(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(i){this._alignment=i,this.update()}get priority(){return this._priority}set priority(i){this._priority=i,this.update()}get text(){return this._text}set text(i){this._text=i,this.update()}get tooltip(){return this._tooltip}set tooltip(i){this._tooltip=i,this.update()}get command(){var i;return(i=this._command)===null||i===void 0?void 0:i.fromApi}set command(i){var h;((h=this._command)===null||h===void 0?void 0:h.fromApi)!==i&&(this._internalCommandRegistration.clear(),typeof i=="string"?this._command={fromApi:i,internal:this._commands.toInternal({title:"",command:i},this._internalCommandRegistration)}:i?this._command={fromApi:i,internal:this._commands.toInternal(i,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(i){this._accessibilityInformation=i,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var i;if(!this._isDisposed){const h={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.uri,command:(i=this._command)===null||i===void 0?void 0:i.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,h)}}}e.NotebookCellStatusBarItemInternal=r,r.NEXT_ID=0;function o(l){return Object.freeze({cell:l.cell,get alignment(){return l.alignment},set alignment(i){l.alignment=i},get priority(){return l.priority},set priority(i){l.priority=i},get text(){return l.text},set text(i){l.text=i},get tooltip(){return l.tooltip},set tooltip(i){l.tooltip=i},get command(){return l.command},set command(i){l.command=i},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(i){l.accessibilityInformation=i},show(){l.show()},hide(){l.hide()},dispose(){l.dispose()}})}}),define(ge[65],pe([0,1,6,3,5,27,4,14]),function(Z,e,_,k,R,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class I extends R.Disposable{constructor(u,m,w,p){super();this._onDidAppend=this._register(new k.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=u,this._proxy=p,this._id=p.$register(this.name,m,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(u){this.validate(),this._offset+=u?T.VSBuffer.fromString(u).byteLength:0}update(){this._id.then(u=>this._proxy.$update(u))}appendLine(u){this.validate(),this.append(u+`
`)}clear(){this.validate();const u=this._offset;this._id.then(m=>this._proxy.$clear(m,u))}show(u,m){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof u=="boolean"?u:m)))}hide(){this.validate(),this._id.then(u=>this._proxy.$close(u))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(u=>this._proxy.$dispose(u)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=I;class n extends I{constructor(u,m){super(u,!1,void 0,m)}append(u){super.append(u),this._id.then(m=>this._proxy.$append(m,u)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class C extends I{constructor(u,m,w){super(u,!0,m,w)}append(u){throw new Error("Not supported")}}class S{constructor(u,m){this.name=u,this._channel=m}append(u){this._channel.then(m=>m.append(u))}appendLine(u){this._channel.then(m=>m.appendLine(u))}clear(){this._channel.then(u=>u.clear())}show(u,m){this._channel.then(w=>w.show(u,m))}hide(){this._channel.then(u=>u.hide())}dispose(){this._channel.then(u=>u.dispose())}}e.LazyOutputChannel=S;let v=class{constructor(u){this._proxy=u.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(u){}createOutputChannel(u){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");return new n(u,this._proxy)}createOutputChannelFromLogFile(u,m){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if(!m)throw new Error("illegal argument `file`. must not be falsy");return new C(u,m,this._proxy)}};v=He([Fe(0,D.IExtHostRpcService)],v),e.ExtHostOutputService=v,e.IExtHostOutputService=P.createDecorator("IExtHostOutputService")}),define(ge[243],pe([0,1,19,21,3,5,6,2,8,15,13]),function(Z,e,_,k,R,T,P,D,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickOpen=void 0;class S{constructor(s,a,c){this._sessions=new Map,this._instances=0,this._proxy=s.getProxy(P.MainContext.MainThreadQuickOpen),this._workspace=a,this._commands=c}showQuickPick(s,a,c,t=k.CancellationToken.None){this._onDidSelectItem=void 0;const r=Promise.resolve(s),o=++this._instances,l=this._proxy.$show(o,{placeHolder:c&&c.placeHolder,matchOnDescription:c&&c.matchOnDescription,matchOnDetail:c&&c.matchOnDetail,ignoreFocusLost:c&&c.ignoreFocusOut,canPickMany:c&&c.canPickMany},t),i={},h=l.then(()=>i);return Promise.race([h,r]).then(y=>{if(y!==i)return r.then(g=>{const E=[];for(let b=0;b<g.length;b++){const L=g[b];let A,N,W,x,M;typeof L=="string"?A=L:(A=L.label,N=L.description,W=L.detail,x=L.picked,M=L.alwaysShow),E.push({label:A,description:N,handle:b,detail:W,picked:x,alwaysShow:M})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=b=>{c.onDidSelectItem(g[b])}),this._proxy.$setItems(o,E),l.then(b=>{if(typeof b=="number")return g[b];if(Array.isArray(b))return b.map(L=>g[L])})})}).then(void 0,y=>{if(!n.isPromiseCanceledError(y))return this._proxy.$setError(o,y),Promise.reject(y)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,a=k.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,this._proxy.$input(s,typeof this._validateInput=="function",a).then(void 0,c=>{if(!n.isPromiseCanceledError(c))return Promise.reject(c)})}$validateInput(s){return this._validateInput?_.asPromise(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,a=k.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!!c){const t=await this._workspace.getWorkspaceFolders2();if(!!t)return t.find(r=>r.uri.toString()===c.uri.toString())}}createQuickPick(s,a){const c=new w(this._proxy,s,a,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(s){const a=new p(this._proxy,s,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(s,a){const c=this._sessions.get(s);c&&c._fireDidChangeValue(a)}$onDidAccept(s){const a=this._sessions.get(s);a&&a._fireDidAccept()}$onDidChangeActive(s,a){const c=this._sessions.get(s);c instanceof w&&c._fireDidChangeActive(a)}$onDidChangeSelection(s,a){const c=this._sessions.get(s);c instanceof w&&c._fireDidChangeSelection(a)}$onDidTriggerButton(s,a){const c=this._sessions.get(s);c&&c._fireDidTriggerButton(a)}$onDidHide(s){const a=this._sessions.get(s);a&&a._fireDidHide()}}e.ExtHostQuickOpen=S;class v{constructor(s,a,c){this._proxy=s,this._extensionId=a,this._onDidDispose=c,this._id=w._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new R.Emitter,this._onDidChangeValueEmitter=new R.Emitter,this._onDidTriggerButtonEmitter=new R.Emitter,this._onDidHideEmitter=new R.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((a,c)=>{const t=a===I.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(t,a)}),this.update({buttons:s.map((a,c)=>({iconPath:f(a.iconPath),tooltip:a.tooltip,handle:a===I.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const a=this._handlesToButtons.get(s);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=T.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),this._proxy.$dispose(this._id))}update(s){if(!this._disposed){for(const a of Object.keys(s)){const c=s[a];this._pendingUpdate[a]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){this._proxy.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function f(d){if(d instanceof I.ThemeIcon)return{id:d.id};const s=m(d),a=u(d);return{dark:typeof s=="string"?D.URI.file(s):s,light:typeof a=="string"?D.URI.file(a):a}}function u(d){return typeof d=="object"&&"light"in d?d.light:d}function m(d){return typeof d=="object"&&"dark"in d?d.dark:d}class w extends v{constructor(s,a,c,t){super(s,a,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new R.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new R.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((a,c)=>{this._handlesToItems.set(c,a),this._itemsToHandles.set(a,c)}),this.update({items:s.map((a,c)=>({label:a.label,description:a.description,handle:c,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(s){const a=C.coalesce(s.map(c=>this._handlesToItems.get(c)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(s){const a=C.coalesce(s.map(c=>this._handlesToItems.get(c)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class p extends v{constructor(s,a,c){super(s,a,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s})}}}),define(ge[244],pe([0,1,2,3,55,5,19,6,13,93,12,29,42]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(l){if(l)return typeof l.iconPath=="string"?_.URI.file(l.iconPath):l.iconPath}function u(l,i){if(!l.iconPath&&!i.iconPath)return 0;if(l.iconPath){if(!i.iconPath)return 1}else return-1;const h=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath,y=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath;return n.comparePaths(h,y)}function m(l,i){let h=0;if(l.strikeThrough!==i.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==i.faded)return l.faded?1:-1;if(l.tooltip!==i.tooltip)return(l.tooltip||"").localeCompare(i.tooltip||"");if(h=u(l,i),h!==0)return h;if(l.light&&i.light)h=u(l.light,i.light);else{if(l.light)return 1;if(i.light)return-1}if(h!==0)return h;if(l.dark&&i.dark)h=u(l.dark,i.dark);else{if(l.dark)return 1;if(i.dark)return-1}return h}function w(l,i){if(l.command!==i.command)return l.command<i.command?-1:1;if(l.title!==i.title)return l.title<i.title?-1:1;if(l.tooltip!==i.tooltip){if(l.tooltip!==void 0&&i.tooltip!==void 0)return l.tooltip<i.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(i.tooltip!==void 0)return-1}if(l.arguments===i.arguments)return 0;if(l.arguments)if(i.arguments){if(l.arguments.length!==i.arguments.length)return l.arguments.length-i.arguments.length}else return 1;else return-1;for(let h=0;h<l.arguments.length;h++){const y=l.arguments[h],g=i.arguments[h];if(y!==g)return y<g?-1:1}return 0}function p(l,i){let h=n.comparePaths(l.resourceUri.fsPath,i.resourceUri.fsPath,!0);if(h!==0)return h;if(l.command&&i.command)h=w(l.command,i.command);else{if(l.command)return 1;if(i.command)return-1}if(h!==0)return h;if(l.decorations&&i.decorations)h=m(l.decorations,i.decorations);else{if(l.decorations)return 1;if(i.decorations)return-1}return h}function d(l,i){for(let h=0;h<l.length;h++)if(l[h]!==i[h])return!1;return!0}function s(l,i){return l.command===i.command&&l.title===i.title&&l.tooltip===i.tooltip&&(l.arguments&&i.arguments?d(l.arguments,i.arguments):l.arguments===i.arguments)}function a(l,i){return I.equals(l,i,s)}class c{constructor(i,h,y){this._extension=i,this._proxy=h,this._sourceControlHandle=y,this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(i){this._proxy.$setInputBoxValue(this._sourceControlHandle,i),this.updateValue(i)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(i){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,i),this._placeholder=i}get validateInput(){return v.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(i){if(v.checkProposedApiEnabled(this._extension),i&&typeof i!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=i,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!i)}get visible(){return this._visible}set visible(i){i=!!i,this._visible!==i&&(this._visible=i,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,i))}$onInputBoxValueChange(i){this.updateValue(i)}updateValue(i){this._value=i,this._onDidChange.fire(i)}}e.ExtHostSCMInputBox=c;class t{constructor(i,h,y,g,E){this._proxy=i,this._commands=h,this._sourceControlHandle=y,this._id=g,this._label=E,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(i){this._label=i,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,i)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(i){this._hideWhenEmpty=i,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(i){this._resourceStates=[...i],this._onDidUpdateResourceStates.fire()}getResourceState(i){return this._resourceStatesMap.get(i)}$executeResourceCommand(i,h){const y=this._resourceStatesCommandsMap.get(i);return y?P.asPromise(()=>this._commands.executeCommand(y.command,...y.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var i;const h=[...this._resourceStates].sort(p),g=I.sortedDiff(this._resourceSnapshot,h,p).map(L=>{const A=L.toInsert.map(N=>{const W=this._resourceHandlePool++;this._resourceStatesMap.set(W,N);const x=N.resourceUri,M=f(N.decorations),$=N.decorations&&f(N.decorations.light)||M,O=N.decorations&&f(N.decorations.dark)||M,B=[];let J;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const ce=new T.DisposableStore;J=this._commands.converter.toInternal(N.command,ce),this._resourceStatesDisposablesMap.set(W,ce)}else this._resourceStatesCommandsMap.set(W,N.command);$&&B.push($),O&&O.toString()!==($==null?void 0:$.toString())&&B.push(O);const U=N.decorations&&N.decorations.tooltip||"",V=N.decorations&&!!N.decorations.strikeThrough,z=N.decorations&&!!N.decorations.faded,Q=N.contextValue||"";return{rawResource:[W,x,B,U,V,z,Q,J],handle:W}});return{start:L.start,deleteCount:L.deleteCount,toInsert:A}}),E=g.map(({start:L,deleteCount:A,toInsert:N})=>[L,A,N.map(W=>W.rawResource)]),b=g.reverse();for(const{start:L,deleteCount:A,toInsert:N}of b){const W=N.map(M=>M.handle),x=this._handlesSnapshot.splice(L,A,...W);for(const M of x)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),(i=this._resourceStatesDisposablesMap.get(M))===null||i===void 0||i.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=h,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(i,h,y,g,E,b){this._proxy=h,this._commands=y,this._id=g,this._label=E,this._rootUri=b,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new c(i,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,g,E,b)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(i){this._count!==i&&(this._count=i,this._proxy.$updateSourceControl(this.handle,{count:i}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(i){this._quickDiffProvider=i,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!i})}get commitTemplate(){return this._commitTemplate}set commitTemplate(i){i!==this._commitTemplate&&(this._commitTemplate=i,this._proxy.$updateSourceControl(this.handle,{commitTemplate:i}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(i){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=i;const h=this._commands.converter.toInternal(i,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(i){if(!(this._statusBarCommands&&i&&a(this._statusBarCommands,i))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=i;const h=(i||[]).map(y=>this._commands.converter.toInternal(y,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}}get selected(){return this._selected}createResourceGroup(i,h){const y=new t(this._proxy,this._commands,this.handle,i,h),g=k.Event.once(y.onDidDispose)(()=>this.createdResourceGroups.delete(y));return this.createdResourceGroups.set(y,g),this.eventuallyAddResourceGroups(),y}eventuallyAddResourceGroups(){const i=[],h=[];for(const[y,g]of this.createdResourceGroups){g.dispose();const E=y.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(y),this.eventuallyUpdateResourceStates()});k.Event.once(y.onDidDispose)(()=>{this.updatedResourceGroups.delete(y),E.dispose(),this._groups.delete(y.handle),this._proxy.$unregisterGroup(this.handle,y.handle)}),i.push([y.handle,y.id,y.label,y.features]);const b=y._takeResourceStateSnapshot();b.length>0&&h.push([y.handle,b]),this._groups.set(y.handle,y)}this._proxy.$registerGroups(this.handle,i,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const i=[];this.updatedResourceGroups.forEach(h=>{const y=h._takeResourceStateSnapshot();y.length!==0&&i.push([h.handle,y])}),i.length>0&&this._proxy.$spliceResourceStates(this.handle,i),this.updatedResourceGroups.clear()}getResourceGroup(i){return this._groups.get(i)}setSelectionState(i){this._selected=i,this._onDidChangeSelection.fire(i)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(i=>i.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,He([R.debounce(100)],r.prototype,"eventuallyAddResourceGroups",null),He([R.debounce(100)],r.prototype,"eventuallyUpdateResourceStates",null);let o=class yi{constructor(i,h,y){this._commands=h,this.logService=y,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=i.getProxy(D.MainContext.MainThreadSCM),this._telemetry=i.getProxy(D.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===3){const E=this._sourceControls.get(g.sourceControlHandle);if(!E)return g;const b=E.getResourceGroup(g.groupHandle);return b?b.getResourceState(g.handle):g}else if(g&&g.$mid===4){const E=this._sourceControls.get(g.sourceControlHandle);return E?E.getResourceGroup(g.groupHandle):g}else if(g&&g.$mid===5){const E=this._sourceControls.get(g.handle);return E||g}return g}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(i,h,y,g){this.logService.trace("ExtHostSCM#createSourceControl",i.identifier.value,h,y,g),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:i.identifier.value});const E=yi._handlePool++,b=new r(i,this._proxy,this._commands,h,y,g);this._sourceControls.set(E,b);const L=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(i.identifier))||[];return L.push(b),this._sourceControlsByExtension.set(S.ExtensionIdentifier.toKey(i.identifier),L),b}getLastInputBox(i){this.logService.trace("ExtHostSCM#getLastInputBox",i.identifier.value);const h=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(i.identifier)),y=h&&h[h.length-1];return y&&y.inputBox}$provideOriginalResource(i,h,y){const g=_.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",i,g.toString());const E=this._sourceControls.get(i);return!E||!E.quickDiffProvider||!E.quickDiffProvider.provideOriginalResource?Promise.resolve(null):P.asPromise(()=>E.quickDiffProvider.provideOriginalResource(g,y)).then(b=>b||null)}$onInputBoxValueChange(i,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",i);const y=this._sourceControls.get(i);return y&&y.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(i,h,y,g){this.logService.trace("ExtHostSCM#$executeResourceCommand",i,h,y);const E=this._sourceControls.get(i);if(!E)return Promise.resolve(void 0);const b=E.getResourceGroup(h);return b?b.$executeResourceCommand(y,g):Promise.resolve(void 0)}$validateInput(i,h,y){this.logService.trace("ExtHostSCM#$validateInput",i);const g=this._sourceControls.get(i);return!g||!g.inputBox.validateInput?Promise.resolve(void 0):P.asPromise(()=>g.inputBox.validateInput(h,y)).then(E=>E?Promise.resolve([E.message,E.type]):Promise.resolve(void 0))}$setSelectedSourceControl(i){var h,y;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",i),i!==void 0&&((h=this._sourceControls.get(i))===null||h===void 0||h.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((y=this._sourceControls.get(this._selectedSourceControlHandle))===null||y===void 0||y.setSelectionState(!1)),this._selectedSourceControlHandle=i,Promise.resolve(void 0)}};o._handlePool=0,o=He([Fe(2,C.ILogService)],o),e.ExtHostSCM=o}),define(ge[245],pe([0,1,8,6,162,5]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(C,S,v,f,u=_.StatusBarAlignment.Left,m,w){this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,this._id=P.ID_GEN++,this._proxy=C,this._commands=S,this._statusId=v,this._statusName=f,this._alignment=u,this._priority=m,this._accessibilityInformation=w}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var C;return(C=this._command)===null||C===void 0?void 0:C.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(C){this._text=C,this.update()}set tooltip(C){this._tooltip=C,this.update()}set color(C){this._color=C,this.update()}set backgroundColor(C){C&&!P.ALLOWED_BACKGROUND_COLORS.has(C.id)&&(C=void 0),this._backgroundColor=C,this.update()}set command(C){var S;((S=this._command)===null||S===void 0?void 0:S.fromApi)!==C&&(this._internalCommandRegistration.clear(),typeof C=="string"?this._command={fromApi:C,internal:this._commands.toInternal({title:"",command:C},this._internalCommandRegistration)}:C?this._command={fromApi:C,internal:this._commands.toInternal(C,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(C){this._accessibilityInformation=C,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this._proxy.$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var C;this._timeoutHandle=void 0;let S=this._color;this._backgroundColor&&(S=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),this._proxy.$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(C=this._command)===null||C===void 0?void 0:C.internal,S,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=(()=>{const n=new Map;return n.set("statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")),n})();class D{constructor(C){this._messages=[],this._item=C.createStatusBarEntry("status.extensionMessage",R.localize(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(C){const S={message:C};return this._messages.unshift(S),this._update(),new _.Disposable(()=>{const v=this._messages.indexOf(S);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(C,S){this._proxy=C.getProxy(k.MainContext.MainThreadStatusBar),this._commands=S,this._statusMessage=new D(this)}createStatusBarEntry(C,S,v,f,u){return new P(this._proxy,this._commands,C,S,v,f,u)}setStatusBarMessage(C,S){const v=this._statusMessage.setMessage(C);let f;return typeof S=="number"?f=setTimeout(()=>v.dispose(),S):typeof S!="undefined"&&S.then(()=>v.dispose(),()=>v.dispose()),new _.Disposable(()=>{v.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=I}),define(ge[90],pe([0,1,6,3,4]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(D){this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,I){this._proxy.$registerExtensionStorageKeysToSync(D,I)}getValue(D,I,n){return this._proxy.$getValue(D,I).then(C=>C||n)}setValue(D,I,n){return this._proxy.$setValue(D,I,n)}$acceptValue(D,I,n){this._onDidChangeStorage.fire({shared:D,key:I,value:n})}}e.ExtHostStorage=T,e.IExtHostStorage=R.createDecorator("IExtHostStorage")}),define(ge[91],pe([0,1,4,28,12,89,2]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=_.createDecorator("IExtensionStoragePaths");let D=class{constructor(n,C,S){var v;this._logService=C,this._extHostFileSystem=S,this._workspace=(v=n.workspace)!==null&&v!==void 0?v:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,S=P.URI.joinPath(this._environment.workspaceStorageHome,C);try{return await this._extHostFileSystem.stat(S),this._logService.trace("[ExtHostStorage] storage dir already exists",S),S}catch(v){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",S),await this._extHostFileSystem.createDirectory(S),await this._extHostFileSystem.writeFile(P.URI.joinPath(S,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=P.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),S}catch(v){this._logService.error("[ExtHostStorage]",v);return}}workspaceValue(n){if(this._value)return P.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return P.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};D=He([Fe(0,k.IExtHostInitDataService),Fe(1,R.ILogService),Fe(2,T.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(ge[36],pe([0,1,3,6,4,2,14,211,5,8,163,15,209,21,26]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=R.createDecorator("IExtHostTerminalService");class m{constructor(t,r,o,l){this._proxy=t,this._id=r,this._creationOptions=o,this._name=l,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(i=>this._pidPromiseComplete=i)}async create(t,r,o,l,i,h,y,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:r,cwd:o,env:l,waitOnExit:i,strictEnv:h,hideFromUser:y,isFeatureTerminal:g})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}dispose(){this._disposed||(this._disposed=!0,this._proxy.$dispose(this._id))}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}get name(){return this._name||""}set name(t){this._name=t}get exitStatus(){return this._exitStatus}get dimensions(){if(!(this._cols===void 0||this._rows===void 0))return{columns:this._cols,rows:this._rows}}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,r){return t===this._cols&&r===this._rows||t===0||r===0?!1:(this._cols=t,this._rows=r,!0)}get processId(){return this._pidPromise}get creationOptions(){return this._creationOptions}sendText(t,r=!0){this._checkDisposed(),this._proxy.$sendText(this._id,t,r)}show(t){this._checkDisposed(),this._proxy.$show(this._id,t)}hide(){this._checkDisposed(),this._proxy.$hide(this._id)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=m;class w{constructor(t){this._pty=t,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,r){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:r})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let p=1,d=class extends I.Disposable{constructor(t,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=r.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new D.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,l]of this._terminalProcesses)l.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal}get terminals(){return this._terminals}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const r=new m(this._proxy,u.generateUuid(),t,t.name),o=new w(t.pty);return r.createExtensionTerminal().then(l=>{const i=this._setupExtHostProcessListeners(l,o);this._terminalProcessDisposables[l]=i}),this._terminals.push(r),r}attachPtyToTerminal(t,r){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const l=new w(r),i=this._setupExtHostProcessListeners(t,l);this._terminalProcessDisposables[t]=i}async $acceptActiveTerminalChanged(t){const r=this._activeTerminal;if(t===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal))}async $acceptTerminalProcessData(t,r){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o,data:r})}async $acceptTerminalDimensions(t,r,o){const l=this._getTerminalById(t);l&&l.setDimensions(r,o)&&this._onDidChangeTerminalDimensions.fire({terminal:l,dimensions:l.dimensions})}async $acceptTerminalMaximumDimensions(t,r,o){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.resize(r,o)}async $acceptTerminalTitleChange(t,r){const o=this._getTerminalById(t);o&&(o.name=r)}async $acceptTerminalClosed(t,r){const o=this._getTerminalObjectIndexById(this.terminals,t);if(o!==null){const l=this._terminals.splice(o,1)[0];l.setExitCode(r),this._onDidCloseTerminal.fire(l)}}$acceptTerminalOpened(t,r,o,l){if(r){const y=this._getTerminalObjectIndexById(this._terminals,r);if(y!==null){this.terminals[y]._id=t,this._onDidOpenTerminal.fire(this.terminals[y]),this.terminals[y].isOpen=!0;return}}const i={name:l.name,shellPath:l.executable,shellArgs:l.args,cwd:typeof l.cwd=="string"?l.cwd:T.URI.revive(l.cwd),env:l.env,hideFromUser:l.hideFromUser},h=new m(this._proxy,t,i,o);this._terminals.push(h),this._onDidOpenTerminal.fire(h),h.isOpen=!0}async $acceptTerminalProcessId(t,r){const o=this._getTerminalById(t);o&&o._setProcessId(r)}async $startExtensionTerminal(t,r){const o=this._getTerminalById(t);if(!o)return{message:C.localize(0,null,t)};o.isOpen||await new Promise(i=>{const h=this.onDidOpenTerminal(async y=>{y===o&&(h.dispose(),i())})});const l=this._terminalProcesses.get(t);l?l.startSendingEvents(r):this._extensionTerminalAwaitingStart[t]={initialDimensions:r}}_setupExtHostProcessListeners(t,r){const o=new I.DisposableStore;o.add(r.onProcessReady(i=>this._proxy.$sendProcessReady(t,i.pid,i.cwd))),o.add(r.onProcessTitleChanged(i=>this._proxy.$sendProcessTitle(t,i))),this._bufferer.startBuffering(t,r.onProcessData),o.add(r.onProcessExit(i=>this._onProcessExit(t,i))),r.onProcessOverrideDimensions&&o.add(r.onProcessOverrideDimensions(i=>this._proxy.$sendOverrideDimensions(t,i))),this._terminalProcesses.set(t,r);const l=this._extensionTerminalAwaitingStart[t];return l&&r instanceof w&&(r.startSendingEvents(l.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,r){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(r)}$acceptProcessInput(t,r){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(r)}$acceptProcessResize(t,r,o){var l;try{(l=this._terminalProcesses.get(t))===null||l===void 0||l.resize(r,o)}catch(i){if(i.code!=="EPIPE"&&i.code!=="ERR_IPC_CHANNEL_CLOSED")throw i}}$acceptProcessShutdown(t,r){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(r)}$acceptProcessRequestInitialCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new n.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,r){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const l=this._terminalLinkCancellationSource.get(t);l&&l.dispose(!0);const i=new f.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,i);const h=[],y={terminal:o,line:r},g=[];for(const L of this._linkProviders)g.push(new Promise(async A=>{i.token.onCancellationRequested(()=>A({provider:L,links:[]}));const N=await L.provideTerminalLinks(y,i.token)||[];i.token.isCancellationRequested||A({provider:L,links:N})}));const E=await Promise.all(g);if(i.token.isCancellationRequested)return[];const b=new Map;for(const L of E)L&&L.links.length>0&&h.push(...L.links.map(A=>{const N={id:p++,startIndex:A.startIndex,length:A.length,label:A.tooltip};return b.set(N.id,{provider:L.provider,link:A}),N}));return this._terminalLinkCache.set(t,b),h}$activateLink(t,r){var o;const l=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(r);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(t,r){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,r)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,r){const o=this._getTerminalObjectIndexById(t,r);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,r){let o=null;return t.some((l,i)=>l._id===r?(o=i,!0):!1),o}getEnvironmentVariableCollection(t){let r=this._environmentVariableCollections.get(t.identifier.value);return r||(r=new s,this._setEnvironmentVariableCollection(t.identifier.value,r)),r}_syncEnvironmentVariableCollection(t,r){const o=v.serializeEnvironmentVariableCollection(r.map);this._proxy.$setEnvironmentVariableCollection(t,r.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(r=>{const o=r[0],l=new s(r[1]);this._setEnvironmentVariableCollection(o,l)})}_setEnvironmentVariableCollection(t,r){this._environmentVariableCollections.set(t,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,r)})}};d=He([Fe(1,P.IExtHostRpcService)],d),e.BaseExtHostTerminalService=d;class s{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,r){this._setIfDiffers(t,{value:r,type:n.EnvironmentVariableMutatorType.Replace})}append(t,r){this._setIfDiffers(t,{value:r,type:n.EnvironmentVariableMutatorType.Append})}prepend(t,r){this._setIfDiffers(t,{value:r,type:n.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,r){const o=this.map.get(t);(!o||o.value!==r.value||o.type!==r.type)&&(this.map.set(t,r),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,r){this.map.forEach((o,l)=>t.call(r,l,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=s;let a=class extends d{constructor(t){super(!1,t)}createTerminal(t,r,o){throw new S.NotSupportedError}createTerminalFromOptions(t){throw new S.NotSupportedError}getDefaultShell(t,r){return""}getDefaultShellArgs(t,r){throw new S.NotSupportedError}$spawnExtHostProcess(t,r,o,l,i,h){throw new S.NotSupportedError}$getAvailableShells(){throw new S.NotSupportedError}async $getDefaultShellAndArgs(t){throw new S.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};a=He([Fe(0,P.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a}),define(ge[246],pe([0,1,3,13,6,121,20,8]),function(Z,e,_,k,R,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class I{constructor(C,S){this._extHostDocumentsAndEditors=S,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=C.getProxy(R.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(v=>this._onDidChangeVisibleTextEditors.fire(v)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(v=>this._onDidChangeActiveTextEditor.fire(v))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(){return this._extHostDocumentsAndEditors.allEditors()}async showTextDocument(C,S,v){let f;typeof S=="number"?f={position:P.ViewColumn.from(S),preserveFocus:v}:typeof S=="object"?f={position:P.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?P.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:f={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(C.uri,f),m=u&&this._extHostDocumentsAndEditors.getEditor(u);if(m)return m;throw u?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}createTextEditorDecorationType(C){return new T.TextEditorDecorationType(this._proxy,C)}$acceptEditorPropertiesChanged(C,S){const v=this._extHostDocumentsAndEditors.getEditor(C);if(!v)throw new Error("unknown text editor");if(S.options&&v._acceptOptions(S.options),S.selections){const f=S.selections.selections.map(P.Selection.to);v._acceptSelections(f)}if(S.visibleRanges){const f=k.coalesce(S.visibleRanges.map(P.Range.to));v._acceptVisibleRanges(f)}if(S.options&&this._onDidChangeTextEditorOptions.fire({textEditor:v,options:Object.assign(Object.assign({},S.options),{lineNumbers:P.TextEditorLineNumbersStyle.to(S.options.lineNumbers)})}),S.selections){const f=D.TextEditorSelectionChangeKind.fromValue(S.selections.source),u=S.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:v,selections:u,kind:f})}if(S.visibleRanges){const f=k.coalesce(S.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:v,visibleRanges:f})}}$acceptEditorPositionData(C){for(const S in C){const v=this._extHostDocumentsAndEditors.getEditor(S);if(!v)throw new Error("Unknown text editor");const f=P.ViewColumn.to(C[S]);v.viewColumn!==f&&(v._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:v,viewColumn:f}))}}getDiffInformation(C){return Promise.resolve(this._proxy.$getDiffInformation(C))}}e.ExtHostEditors=I});var di=this&&this.__rest||function(Z,e){var _={};for(var k in Z)Object.prototype.hasOwnProperty.call(Z,k)&&e.indexOf(k)<0&&(_[k]=Z[k]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,k=Object.getOwnPropertySymbols(Z);R<k.length;R++)e.indexOf(k[R])<0&&Object.prototype.propertyIsEnumerable.call(Z,k[R])&&(_[k[R]]=Z[k[R]]);return _};define(ge[247],pe([0,1,2,4,6,5,8]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=k.createDecorator("IExtHostTimeline");class D{constructor(C,S){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=C.getProxy(R.MainContext.MainThreadTimeline),S.registerArgumentProcessor({processArgument:v=>{var f,u;if(v&&v.$mid===11){const m=v.uri===void 0?void 0:_.URI.revive(v.uri);return(u=(f=this._itemsBySourceAndUriMap.get(v.source))===null||f===void 0?void 0:f.get(I(m)))===null||u===void 0?void 0:u.get(v.handle)}return v}})}async $getTimeline(C,S,v,f,u){const m=this._providers.get(C);return m==null?void 0:m.provideTimeline(_.URI.revive(S),v,f,u)}registerTimelineProvider(C,S,v,f){const u=new T.DisposableStore,m=this.convertTimelineItem(S.id,f,u).bind(this);let w;S.onDidChange&&(w=S.onDidChange(d=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},d),{id:S.id})),this));const p=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},S),{scheme:C,onDidChange:void 0,async provideTimeline(d,s,a,c){var t;(c==null?void 0:c.resetCache)&&(u.clear(),(t=p.get(S.id))===null||t===void 0||t.clear());const r=await S.provideTimeline(d,s,a);if(r!=null){const o=m(d,c);return Object.assign(Object.assign({},r),{source:S.id,items:r.items.map(o)})}},dispose(){var d;for(const s of p.values())(d=s.get(S.id))===null||d===void 0||d.clear();w==null||w.dispose(),u.dispose()}}))}convertTimelineItem(C,S,v){return(f,u)=>{let m;if(u==null?void 0:u.cacheResults){let w=this._itemsBySourceAndUriMap.get(C);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(C,w));const p=I(f);m=w.get(p),m===void 0&&(m=new Map,w.set(p,m))}return w=>{var p,d;const{iconPath:s}=w,a=di(w,["iconPath"]),c=`${C}|${(p=w.id)!==null&&p!==void 0?p:w.timestamp}`;m==null||m.set(c,w);let t,r,o;return w.iconPath&&(s instanceof P.ThemeIcon?o={id:s.id}:_.URI.isUri(s)?(t=s,r=s):{light:t,dark:r}=s),Object.assign(Object.assign({},a),{id:(d=a.id)!==null&&d!==void 0?d:void 0,handle:c,source:C,command:w.command?S.toInternal(w.command,v):void 0,icon:t,iconDark:r,themeIcon:o,accessibilityInformation:w.accessibilityInformation})}}}registerTimelineProviderCore(C){if(this._providers.get(C.id))throw new Error(`Timeline Provider ${C.id} already exists.`);return this._proxy.$registerTimelineProvider({id:C.id,label:C.label,scheme:C.scheme}),this._providers.set(C.id,C),T.toDisposable(()=>{var v;for(const f of this._itemsBySourceAndUriMap.values())(v=f.get(C.id))===null||v===void 0||v.clear();this._providers.delete(C.id),this._proxy.$unregisterTimelineProvider(C.id),C.dispose()})}}e.ExtHostTimeline=D;function I(n){return n==null?void 0:n.toString()}}),define(ge[248],pe([0,1,5,11,2,6]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(I){this._openers=new Map,this._proxy=I.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(I,n,C,S){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const v=S.schemes.find(f=>!P.supportedSchemes.has(f));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,C),this._proxy.$registerUriOpener(n,S.schemes,I,S.label),_.toDisposable(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(I,n,C){const S=this._openers.get(I);if(!S)throw new Error(`Unknown opener with id: ${I}`);const v=R.URI.revive(n);return S.canOpenExternalUri(v,C)}async $openUri(I,n,C){const S=this._openers.get(I);if(!S)throw new Error(`Unknown opener id: '${I}'`);return S.openExternalUri(R.URI.revive(n.resolvedUri),{sourceUri:R.URI.revive(n.sourceUri)},C)}}e.ExtHostUriOpeners=P,P.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}),define(ge[249],pe([0,1,6,2,5,15,29]),function(Z,e,_,k,R,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(n,C){if(this.handles.has(P.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const S=D.HandlePool++;return this.handles.add(P.ExtensionIdentifier.toKey(n)),this.handlers.set(S,C),this._proxy.$registerUriHandler(S,n),R.toDisposable(()=>{this.handles.delete(P.ExtensionIdentifier.toKey(n)),this.handlers.delete(S),this._proxy.$unregisterUriHandler(S)})}$handleExternalUri(n,C){const S=this.handlers.get(n);if(!S)return Promise.resolve(void 0);try{S.handleUri(k.URI.revive(C))}catch(v){T.onUnexpectedError(v)}return Promise.resolve(void 0)}async createAppUri(n){return k.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=D,D.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},We=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[66],pe([0,1,3,2,87,6]),function(Z,e,_,k,R,T){"use strict";var P,D,I,n,C,S,v,f,u,m,w;Object.defineProperty(e,"__esModule",{value:!0}),e.convertWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class p{constructor(o,l,i,h,y,g,E){P.set(this,void 0),D.set(this,void 0),I.set(this,void 0),n.set(this,void 0),C.set(this,void 0),S.set(this,void 0),v.set(this,""),f.set(this,void 0),u.set(this,!1),m.set(this,!1),this._onMessageEmitter=new _.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,w.set(this,new _.Emitter),this._onDidDispose=We(this,w).event,Je(this,P,o),Je(this,D,l),Je(this,f,i),Je(this,n,h),Je(this,C,y),Je(this,S,g),Je(this,I,E)}dispose(){Je(this,u,!0),We(this,w).fire(),We(this,w).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return Je(this,m,!0),R.asWebviewUri(We(this,n),We(this,P),o)}get cspSource(){return We(this,n).webviewCspSource.replace("{{uuid}}",We(this,P))}get html(){return this.assertNotDisposed(),We(this,v)}set html(o){this.assertNotDisposed(),We(this,v)!==o&&(Je(this,v,o),!We(this,m)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(Je(this,m,!0),We(this,I).report("Webview vscode-resource: uris",We(this,S),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),We(this,D).$setHtml(We(this,P),o))}get options(){return this.assertNotDisposed(),We(this,f)}set options(o){this.assertNotDisposed(),We(this,D).$setOptions(We(this,P),a(We(this,S),We(this,C),o)),Je(this,f,o)}async postMessage(o){return We(this,u)?!1:We(this,D).$postMessage(We(this,P),o)}assertNotDisposed(){if(We(this,u))throw new Error("Webview is disposed")}}e.ExtHostWebview=p,P=new WeakMap,D=new WeakMap,I=new WeakMap,n=new WeakMap,C=new WeakMap,S=new WeakMap,v=new WeakMap,f=new WeakMap,u=new WeakMap,m=new WeakMap,w=new WeakMap;class d{constructor(o,l,i,h,y){this.initData=l,this.workspace=i,this._logService=h,this._deprecationService=y,this._webviews=new Map,this._webviewProxy=o.getProxy(T.MainContext.MainThreadWebviews)}$onMessage(o,l){const i=this.getWebview(o);i&&i._onMessageEmitter.fire(l)}$onMissingCsp(o,l){this._logService.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,l,i){const h=new p(o,this._webviewProxy,c(l),this.initData,this.workspace,i,this._deprecationService);return this._webviews.set(o,h),h._onDidDispose(()=>{this._webviews.delete(o)}),h}deleteWebview(o){this._webviews.delete(o)}getWebview(o){return this._webviews.get(o)}}e.ExtHostWebviews=d;function s(r){return{id:r.identifier,location:r.extensionLocation}}e.toExtensionData=s;function a(r,o,l){return Object.assign(Object.assign({},l),{localResourceRoots:l.localResourceRoots||t(r,o)})}e.convertWebviewOptions=a;function c(r){var o;return Object.assign(Object.assign({},r),{localResourceRoots:(o=r.localResourceRoots)===null||o===void 0?void 0:o.map(l=>k.URI.from(l))})}function t(r,o){return[...((o==null?void 0:o.getWorkspaceFolders())||[]).map(l=>l.uri),r.extensionLocation]}}),define(ge[250],pe([0,1,21,75,5,11,23,2,20,66,86,6,8]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new C.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=a(this.document.uri)+this._backupCounter++;return P.joinPath(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class u{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,o){const l=this.key(t,r.uri);if(this._documents.has(l))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const i=new f(r,o);return this._documents.set(l,i),i}delete(t,r){const o=this.key(t,r.uri);this._documents.delete(o)}key(t,r){return`${t}@@@${r}`}}var m;(function(c){c[c.Text=0]="Text",c[c.Custom=1]="Custom"})(m||(m={}));class w{constructor(){this._providers=new Map}addTextProvider(t,r,o){return this.add(0,t,r,o)}addCustomProvider(t,r,o){return this.add(1,t,r,o)}get(t){return this._providers.get(t)}add(t,r,o,l){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:o,provider:l}),new v.Disposable(()=>this._providers.delete(r))}}class p{constructor(t,r,o,l,i){this._extHostDocuments=r,this._extensionStoragePaths=o,this._extHostWebview=l,this._extHostWebviewPanels=i,this._editorProviders=new w,this._documents=new u,this._proxy=t.getProxy(S.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,o,l){const i=new R.DisposableStore;return d(o)?(i.add(this._editorProviders.addTextProvider(r,t,o)),this._proxy.$registerTextEditorProvider(n.toExtensionData(t),r,l.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor})):(i.add(this._editorProviders.addCustomProvider(r,t,o)),this.supportEditing(o)&&i.add(o.onDidChangeCustomDocument(h=>{const y=this.getCustomDocumentEntry(r,h.document.uri);if(s(h)){const g=y.addEdit(h);this._proxy.$onDidEdit(h.document.uri,r,g,h.label)}else this._proxy.$onContentChange(h.document.uri,r)})),this._proxy.$registerCustomEditorProvider(n.toExtensionData(t),r,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument)),v.Disposable.from(i,new v.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,o,l){var i;const h=this._editorProviders.get(r);if(!h)throw new Error(`No provider found for '${r}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${r}'`);const y=D.URI.revive(t),g=await h.provider.openCustomDocument(y,{backupId:o},l);let E;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(E=(i=this._extensionStoragePaths.workspaceValue(h.extension))!==null&&i!==void 0?i:this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(r,g,E),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(t,r){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${r}'`);const l=D.URI.revive(t),{document:i}=this.getCustomDocumentEntry(r,l);this._documents.delete(r,i),i.dispose()}async $resolveWebviewEditor(t,r,o,l,i,h,y){const g=this._editorProviders.get(o);if(!g)throw new Error(`No provider found for '${o}'`);const E=I.ViewColumn.to(i),b=this._extHostWebview.createNewWebview(r,h,g.extension),L=this._extHostWebviewPanels.createNewWebviewPanel(r,o,l,E,h,b),A=D.URI.revive(t);switch(g.type){case 1:{const{document:N}=this.getCustomDocumentEntry(o,A);return g.provider.resolveCustomEditor(N,L,y)}case 0:{const N=this._extHostDocuments.getDocument(A);return g.provider.resolveCustomTextEditor(N,L,y)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,o){this.getCustomDocumentEntry(r,t).disposeEdits(o)}async $onMoveCustomEditor(t,r,o){const l=this._editorProviders.get(o);if(!l)throw new Error(`No provider found for '${o}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const i=this._extHostWebviewPanels.getWebviewPanel(t);if(!i)throw new Error("No webview found");const h=D.URI.revive(r),y=this._extHostDocuments.getDocument(h);await l.provider.moveCustomTextEditor(y,i,_.CancellationToken.None)}async $undo(t,r,o,l){return this.getCustomDocumentEntry(r,t).undo(o,l)}async $redo(t,r,o,l){return this.getCustomDocumentEntry(r,t).redo(o,l)}async $revert(t,r,o){const l=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(l.document,o),l.disposeBackup()}async $onSave(t,r,o){const l=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(l.document,o),l.disposeBackup()}async $onSaveAs(t,r,o,l){const i=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(i.document,D.URI.revive(o),l)}async $backup(t,r,o){const l=this.getCustomDocumentEntry(r,t),h=await this.getCustomEditorProvider(r).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},o);return l.updateBackup(h),h.id}getCustomDocumentEntry(t,r){const o=this._documents.get(t,D.URI.revive(r));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const r=this._editorProviders.get(t),o=r==null?void 0:r.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=p;function d(c){return typeof c.resolveCustomTextEditor=="function"}function s(c){return typeof c.undo=="function"&&typeof c.redo=="function"}function a(c){const t=c.scheme===T.Schemas.file||c.scheme===T.Schemas.untitled?c.fsPath:c.toString();return k.hash(t)+""}});var Je=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},We=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[251],pe([0,1,3,5,2,26,20,66,6,8]),function(Z,e,_,k,R,T,P,D,I,n){"use strict";var C,S,v,f,u,m,w,p,d,s,a,c,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends k.Disposable{constructor(i,h,y,g,E,b,L){super();C.set(this,void 0),S.set(this,void 0),v.set(this,void 0),f.set(this,void 0),u.set(this,void 0),m.set(this,void 0),w.set(this,void 0),p.set(this,void 0),d.set(this,!0),s.set(this,!0),a.set(this,!1),c.set(this,this._register(new _.Emitter)),this.onDidDispose=We(this,c).event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=We(this,t).event,Je(this,C,i),Je(this,S,h),Je(this,v,y),Je(this,u,b),Je(this,p,E),Je(this,m,g),Je(this,f,L)}dispose(){We(this,a)||(Je(this,a,!0),We(this,c).fire(),We(this,S).$disposeWebview(We(this,C)),We(this,f).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),We(this,f)}get viewType(){return this.assertNotDisposed(),We(this,v)}get title(){return this.assertNotDisposed(),We(this,m)}set title(i){this.assertNotDisposed(),We(this,m)!==i&&(Je(this,m,i),We(this,S).$setTitle(We(this,C),i))}get iconPath(){return this.assertNotDisposed(),We(this,w)}set iconPath(i){this.assertNotDisposed(),We(this,w)!==i&&(Je(this,w,i),We(this,S).$setIconPath(We(this,C),R.URI.isUri(i)?{light:i,dark:i}:i))}get options(){return We(this,u)}get viewColumn(){if(this.assertNotDisposed(),!(typeof We(this,p)=="number"&&We(this,p)<0))return We(this,p)}get active(){return this.assertNotDisposed(),We(this,s)}get visible(){return this.assertNotDisposed(),We(this,d)}_updateViewState(i){We(this,a)||(this.active!==i.active||this.visible!==i.visible||this.viewColumn!==i.viewColumn)&&(Je(this,s,i.active),Je(this,d,i.visible),Je(this,p,i.viewColumn),We(this,t).fire({webviewPanel:this}))}reveal(i,h){this.assertNotDisposed(),We(this,S).$reveal(We(this,C),{viewColumn:i?P.ViewColumn.from(i):void 0,preserveFocus:!!h})}assertNotDisposed(){if(We(this,a))throw new Error("Webview is disposed")}}C=new WeakMap,S=new WeakMap,v=new WeakMap,f=new WeakMap,u=new WeakMap,m=new WeakMap,w=new WeakMap,p=new WeakMap,d=new WeakMap,s=new WeakMap,a=new WeakMap,c=new WeakMap,t=new WeakMap;class o{constructor(i,h,y){this.webviews=h,this.workspace=y,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=i.getProxy(I.MainContext.MainThreadWebviewPanels)}static newHandle(){return T.generateUuid()}createWebviewPanel(i,h,y,g,E={}){const b=typeof g=="object"?g.viewColumn:g,L={viewColumn:P.ViewColumn.from(b),preserveFocus:typeof g=="object"&&!!g.preserveFocus},A=o.newHandle();this._proxy.$createWebviewPanel(D.toExtensionData(i),A,h,y,L,D.convertWebviewOptions(i,this.workspace,E));const N=this.webviews.createNewWebview(A,E,i);return this.createNewWebviewPanel(A,h,y,b,E,N)}$onDidChangeWebviewPanelViewStates(i){const h=Object.keys(i);h.sort((y,g)=>{const E=i[y],b=i[g];return E.active?1:b.active?-1:+E.visible-+b.visible});for(const y of h){const g=this.getWebviewPanel(y);if(!!g){const E=i[y];g._updateViewState({active:E.active,visible:E.visible,viewColumn:P.ViewColumn.to(E.position)})}}}async $onDidDisposeWebviewPanel(i){const h=this.getWebviewPanel(i);h==null||h.dispose(),this._webviewPanels.delete(i),this.webviews.deleteWebview(i)}registerWebviewPanelSerializer(i,h,y){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:y,extension:i}),this._proxy.$registerSerializer(h),new n.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(i,h,y,g,E,b){const L=this._serializers.get(h);if(!L)throw new Error(`No serializer found for '${h}'`);const{serializer:A,extension:N}=L,W=this.webviews.createNewWebview(i,b,N),x=this.createNewWebviewPanel(i,h,y,E,b,W);await A.deserializeWebviewPanel(x,g)}createNewWebviewPanel(i,h,y,g,E,b){const L=new r(i,this._proxy,h,y,g,E,b);return this._webviewPanels.set(i,L),L}getWebviewPanel(i){return this._webviewPanels.get(i)}}e.ExtHostWebviewPanels=o});var Je=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},We=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(ge[252],pe([0,1,3,5,66,6,8]),function(Z,e,_,k,R,T,P){"use strict";var D,I,n,C,S,v,f,u,m,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends k.Disposable{constructor(a,c,t,r,o,l){super();D.set(this,void 0),I.set(this,void 0),n.set(this,void 0),C.set(this,void 0),S.set(this,!1),v.set(this,void 0),f.set(this,void 0),u.set(this,void 0),m.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=We(this,m).event,w.set(this,this._register(new _.Emitter)),this.onDidDispose=We(this,w).event,Je(this,n,t),Je(this,f,r),Je(this,D,a),Je(this,I,c),Je(this,C,o),Je(this,v,l)}dispose(){We(this,S)||(Je(this,S,!0),We(this,w).fire(),We(this,C).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),We(this,f)}set title(a){this.assertNotDisposed(),We(this,f)!==a&&(Je(this,f,a),We(this,I).$setWebviewViewTitle(We(this,D),a))}get description(){return this.assertNotDisposed(),We(this,u)}set description(a){this.assertNotDisposed(),We(this,u)!==a&&(Je(this,u,a),We(this,I).$setWebviewViewDescription(We(this,D),a))}get visible(){return We(this,v)}get webview(){return We(this,C)}get viewType(){return We(this,n)}_setVisible(a){a===We(this,v)||We(this,S)||(Je(this,v,a),We(this,m).fire())}show(a){this.assertNotDisposed(),We(this,I).$show(We(this,D),!!a)}assertNotDisposed(){if(We(this,S))throw new Error("Webview is disposed")}}D=new WeakMap,I=new WeakMap,n=new WeakMap,C=new WeakMap,S=new WeakMap,v=new WeakMap,f=new WeakMap,u=new WeakMap,m=new WeakMap,w=new WeakMap;class d{constructor(a,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=a.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(a,c,t,r){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:t,extension:a}),this._proxy.$registerWebviewViewProvider(R.toExtensionData(a),c,r),new P.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(a,c,t,r,o){const l=this._viewProviders.get(c);if(!l)throw new Error(`No view provider found for '${c}'`);const{provider:i,extension:h}=l,y=this._extHostWebview.createNewWebview(a,{},h),g=new p(a,this._proxy,c,t,y,!0);this._webviewViews.set(a,g),await i.resolveWebviewView(g,{state:r},o)}async $onDidChangeWebviewViewVisibility(a,c){this.getWebviewView(a)._setVisible(c)}async $disposeWebviewView(a){const c=this.getWebviewView(a);this._webviewViews.delete(a),c.dispose(),this._extHostWebview.deleteWebview(a)}getWebviewView(a){const c=this._webviewViews.get(a);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=d}),define(ge[124],pe([0,1,3,6,2,11,10,4,14]),function(Z,e,_,k,R,T,P,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class ki{constructor(S){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ki.InitialState,this._proxy=S.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}get state(){return this._state}$onDidChangeWindowFocus(S){S!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:S}),this._onDidChangeWindowState.fire(this._state))}openUri(S,v){let f;if(typeof S=="string"){f=S;try{S=R.URI.parse(S)}catch(u){return Promise.reject(`Invalid uri - '${S}'`)}}return P.isFalsyOrWhitespace(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,f,v)}async asExternalUri(S,v){if(P.isFalsyOrWhitespace(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(S.scheme))return Promise.reject(`Invalid scheme '${S.scheme}'`);const f=await this._proxy.$asExternalUri(S,v);return R.URI.from(f)}};n.InitialState={focused:!0},n=He([Fe(0,I.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=D.createDecorator("IExtHostWindow")}),define(ge[253],pe([0,1,7,34,26,52,5,6,2,14]),function(Z,e,_,k,R,T,P,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let C=class extends P.Disposable{constructor(v,f){super();const u=v.getProxy(D.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async m=>{const w=I.URI.file(_.join(k.tmpdir(),R.generateUuid()));return await u.$download(m,w),w})}};C=He([Fe(0,n.IExtHostRpcService),Fe(1,T.IExtHostCommands)],C),e.ExtHostDownloadService=C}),define(ge[254],pe([0,1,6,14,5,28,2,35,23,39,24,9,51,3,59,74,12]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.findPorts=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class p{constructor(i,h,y){this.remoteAddress=i,this.localAddress=h,this._dispose=y,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function d(l){const i=l.trim().split(`
`),h=[];return i.forEach(y=>{const g=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(y);g&&g.length>=3&&h.push({pid:parseInt(g[1],10),socket:parseInt(g[2],10)})}),h}e.getSockets=d;function s(...l){const i=[].concat(...l.map(c));return[...new Map(i.filter(h=>h.st==="0A").map(h=>{const y=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:a(y[0]),port:parseInt(y[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=s;function a(l){let i="";if(l.length===8)for(let h=l.length-2;h>=0;h-=2)i+=parseInt(l.substr(h,2),16),h!==0&&(i+=".");else for(let h=l.length-4;h>=0;h-=4)i+=parseInt(l.substr(h,4),16).toString(16),h!==0&&(i+=":");return i}e.parseIpAddress=a;function c(l){const i=l.trim().split(`
`),h=i.shift().trim().split(/\s+/).filter(g=>g!=="rx_queue"&&g!=="tm->when");return i.map(g=>g.trim().split(/\s+/).reduce((E,b,L)=>(E[h[L]||L]=b,E),{}))}e.loadConnectionTable=c;function t(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/vs/server/main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}async function r(l,i,h,y){const g=s(l,i),b=d(h).reduce((N,W)=>(N[W.socket]=W,N),{}),L=y.reduce((N,W)=>(N[W.pid]=W,N),{}),A=[];return g.filter(N=>b[N.socket]).forEach(({socket:N,ip:W,port:x})=>{const M=L[b[N].pid].cmd;t(M)||A.push({host:W,port:x,detail:L[b[N].pid].cmd,pid:b[N].pid})}),A}e.findPorts=r;let o=class extends R.Disposable{constructor(i,h,y){super();this.logService=y,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._proxy=i.getProxy(_.MainContext.MainThreadTunnelService),S.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setCandidateFinder()}async openTunnel(i,h){const y=await this._proxy.$openTunnel(h,i.displayName);if(y){const g=new p(y.remoteAddress,y.localAddress,()=>this._proxy.$closeTunnel(y.remoteAddress));return this._register(g),g}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(i){return Math.max(i*20,2e3)}async $registerCandidateFinder(i){if(!(i&&this._candidateFindingEnabled)){this._candidateFindingEnabled=i;let h=new m.MovingAverage,y;for(;this._candidateFindingEnabled;){const g=new Date().getTime(),E=await this.findCandidatePorts(),b=new Date().getTime()-g;h.update(b),(!y||JSON.stringify(y)!==JSON.stringify(E))&&(y=E,await this._proxy.$onFoundNewCandidates(y)),await new Promise(L=>setTimeout(()=>L(),this.calculateDelay(h.value)))}}}async setTunnelExtensionFunctions(i){var h;return i?(i.showCandidatePort&&(this._showCandidatePort=i.showCandidatePort,await this._proxy.$setCandidateFilter()),i.tunnelFactory&&(this._forwardPortProvider=i.tunnelFactory,await this._proxy.$setTunnelProvider((h=i.tunnelFeatures)!==null&&h!==void 0?h:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,R.toDisposable(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(i,h){if(this._extensionTunnels.has(i.host)){const y=this._extensionTunnels.get(i.host);y.has(i.port)&&(h&&y.get(i.port).disposeListener.dispose(),await y.get(i.port).tunnel.dispose(),y.delete(i.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(i,h){if(this._forwardPortProvider)try{this.logService.trace("$forwardPort: Getting tunnel from provider.");const y=this._forwardPortProvider(i,h);if(this.logService.trace("$forwardPort: Got tunnel promise from provider."),y!==void 0){const g=await y;this.logService.trace("$forwardPort: Successfully awaited tunnel from provider."),this._extensionTunnels.has(i.remoteAddress.host)||this._extensionTunnels.set(i.remoteAddress.host,new Map);const E=this._register(g.onDidDispose(()=>this._proxy.$closeTunnel(g.remoteAddress)));return this._extensionTunnels.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:g,disposeListener:E}),v.TunnelDto.fromApiTunnel(g)}else this.logService.trace("$forwardPort: Tunnel is undefined")}catch(y){this.logService.trace("$forwardPort: tunnel provider error")}}async $applyCandidateFilter(i){const h=await Promise.all(i.map(y=>this._showCandidatePort(y.host,y.port,y.detail)));return i.filter((y,g)=>h[g])}async findCandidatePorts(){let i="",h="";try{i=await C.readFile("/proc/net/tcp","utf8"),h=await C.readFile("/proc/net/tcp6","utf8")}catch(b){}const y=await new Promise(b=>{D.exec("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(L,A,N)=>{b(A)})}),g=await C.readdir("/proc"),E=[];for(let b of g)try{const L=Number(b),A=I.joinPath(P.URI.file("/proc"),b);if((await C.stat(A.fsPath)).isDirectory()&&!isNaN(L)){const W=await u.promisify(n.readlink)(I.joinPath(A,"cwd").fsPath),x=await C.readFile(I.joinPath(A,"cmdline").fsPath,"utf8");E.push({pid:L,cwd:W,cmd:x})}}catch(L){}return r(i,h,y,E)}};o=He([Fe(0,k.IExtHostRpcService),Fe(1,T.IExtHostInitDataService),Fe(2,w.ILogService)],o),e.ExtHostTunnelService=o}),define(ge[255],pe([0,1,19,21,15,3,5,99,227,122,27]),function(Z,e,_,k,R,T,P,D,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function S(t,r){try{return JSON.stringify(t,r)}catch(o){return"null"}}function v(t,r){return JSON.stringify(t,r)}function f(t){return t?(r,o)=>o&&o.$mid===1?t.transformOutgoing(o):o:null}var u;(function(t){t[t.LocalSide=0]="LocalSide",t[t.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(t){t[t.Responsive=0]="Responsive",t[t.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{};class p extends P.Disposable{constructor(r,o=null,l=null){super();this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=r,this._logger=o,this._uriTransformer=l,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let i=0,h=n.ProxyIdentifier.count;i<h;i++)this._locals[i]=null,this._proxies[i]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(i=>this._receiveOneMessage(i))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(r=>{this._pendingRPCReplies[r].resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(r){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+p.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(r){this._unresponsiveTime=Date.now()+p.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(r){this._responsiveState!==r&&(this._responsiveState=r,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(r){return this._uriTransformer?D.transformIncomingURIs(r,this._uriTransformer):r}getProxy(r){const o=r.nid;return this._proxies[o]||(this._proxies[o]=this._createProxy(o)),this._proxies[o]}_createProxy(r){let o={get:(l,i)=>(typeof i=="string"&&!l[i]&&i.charCodeAt(0)===36&&(l[i]=(...h)=>this._remoteCall(r,i,h)),l[i])};return new Proxy(Object.create(null),o)}set(r,o){return this._locals[r.nid]=o,o}assertRegistered(r){for(let o=0,l=r.length;o<l;o++){const i=r[o];if(!this._locals[i.nid])throw new Error(`Missing actor ${i.sid} (isMain: ${i.isMain})`)}}_receiveOneMessage(r){if(!this._isDisposed){const o=r.byteLength,l=d.read(r,0),i=l.readUInt8(),h=l.readUInt32();switch(i){case 1:case 2:{let{rpcId:y,method:g,args:E}=s.deserializeRequestJSONArgs(l);this._uriTransformer&&(E=D.transformIncomingURIs(E,this._uriTransformer)),this._receiveRequest(o,h,y,g,E,i===2);break}case 3:case 4:{let{rpcId:y,method:g,args:E}=s.deserializeRequestMixedArgs(l);this._uriTransformer&&(E=D.transformIncomingURIs(E,this._uriTransformer)),this._receiveRequest(o,h,y,g,E,i===4);break}case 5:{this._logger&&this._logger.logIncoming(o,h,0,"ack"),this._onDidReceiveAcknowledge(h);break}case 6:{this._receiveCancel(o,h);break}case 7:{this._receiveReply(o,h,void 0);break}case 9:{let y=s.deserializeReplyOKJSON(l);this._uriTransformer&&(y=D.transformIncomingURIs(y,this._uriTransformer)),this._receiveReply(o,h,y);break}case 8:{let y=s.deserializeReplyOKVSBuffer(l);this._receiveReply(o,h,y);break}case 10:{let y=s.deserializeReplyErrError(l);this._uriTransformer&&(y=D.transformIncomingURIs(y,this._uriTransformer)),this._receiveReplyErr(o,h,y);break}case 11:{this._receiveReplyErr(o,h,void 0);break}default:console.error("received unexpected message"),console.error(r)}}}_receiveRequest(r,o,l,i,h,y){this._logger&&this._logger.logIncoming(r,o,1,`receiveRequest ${n.getStringIdentifierForProxy(l)}.${i}(`,h);const g=String(o);let E,b;if(y){const A=new k.CancellationTokenSource;h.push(A.token),E=this._invokeHandler(l,i,h),b=()=>A.cancel()}else E=this._invokeHandler(l,i,h),b=w;this._cancelInvokedHandlers[g]=b;const L=s.serializeAcknowledged(o);this._logger&&this._logger.logOutgoing(L.byteLength,o,1,"ack"),this._protocol.send(L),E.then(A=>{delete this._cancelInvokedHandlers[g];const N=s.serializeReplyOK(o,A,this._uriReplacer);this._logger&&this._logger.logOutgoing(N.byteLength,o,1,"reply:",A),this._protocol.send(N)},A=>{delete this._cancelInvokedHandlers[g];const N=s.serializeReplyErr(o,A);this._logger&&this._logger.logOutgoing(N.byteLength,o,1,"replyErr:",A),this._protocol.send(N)})}_receiveCancel(r,o){this._logger&&this._logger.logIncoming(r,o,1,"receiveCancel");const l=String(o);this._cancelInvokedHandlers[l]&&this._cancelInvokedHandlers[l]()}_receiveReply(r,o,l){this._logger&&this._logger.logIncoming(r,o,0,"receiveReply:",l);const i=String(o);if(!!this._pendingRPCReplies.hasOwnProperty(i)){const h=this._pendingRPCReplies[i];delete this._pendingRPCReplies[i],h.resolveOk(l)}}_receiveReplyErr(r,o,l){this._logger&&this._logger.logIncoming(r,o,0,"receiveReplyErr:",l);const i=String(o);if(!!this._pendingRPCReplies.hasOwnProperty(i)){const h=this._pendingRPCReplies[i];delete this._pendingRPCReplies[i];let y;l&&(l.$isError?(y=new Error,y.name=l.name,y.message=l.message,y.stack=l.stack):y=l),h.resolveErr(y)}}_invokeHandler(r,o,l){try{return Promise.resolve(this._doInvokeHandler(r,o,l))}catch(i){return Promise.reject(i)}}_doInvokeHandler(r,o,l){const i=this._locals[r];if(!i)throw new Error("Unknown actor "+n.getStringIdentifierForProxy(r));let h=i[o];if(typeof h!="function")throw new Error("Unknown method "+o+" on actor "+n.getStringIdentifierForProxy(r));return h.apply(i,l)}_remoteCall(r,o,l){if(this._isDisposed)return Promise.reject(R.canceled());let i=null;if(l.length>0&&k.CancellationToken.isCancellationToken(l[l.length-1])&&(i=l.pop()),i&&i.isCancellationRequested)return Promise.reject(R.canceled());const h=s.serializeRequestArguments(l,this._uriReplacer),y=++this._lastMessageId,g=String(y),E=new I.LazyPromise;i&&i.onCancellationRequested(()=>{const L=s.serializeCancel(y);this._logger&&this._logger.logOutgoing(L.byteLength,y,0,"cancel"),this._protocol.send(s.serializeCancel(y))}),this._pendingRPCReplies[g]=E,this._onWillSendRequest(y);const b=s.serializeRequest(y,r,o,h,!!i);return this._logger&&this._logger.logOutgoing(b.byteLength,y,0,`request: ${n.getStringIdentifierForProxy(r)}.${o}(`,l),this._protocol.send(b),E}}e.RPCProtocol=p,p.UNRESPONSIVE_TIME=3*1e3;class d{constructor(r,o){this._buff=r,this._offset=o}static alloc(r,o,l){let i=new d(C.VSBuffer.alloc(l+1+4),0);return i.writeUInt8(r),i.writeUInt32(o),i}static read(r,o){return new d(r,o)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(r){this._buff.writeUInt8(r,this._offset),this._offset+=1}readUInt8(){const r=this._buff.readUInt8(this._offset);return this._offset+=1,r}writeUInt32(r){this._buff.writeUInt32BE(r,this._offset),this._offset+=4}readUInt32(){const r=this._buff.readUInt32BE(this._offset);return this._offset+=4,r}static sizeShortString(r){return 1+r.byteLength}writeShortString(r){this._buff.writeUInt8(r.byteLength,this._offset),this._offset+=1,this._buff.set(r,this._offset),this._offset+=r.byteLength}readShortString(){const r=this._buff.readUInt8(this._offset);this._offset+=1;const l=this._buff.slice(this._offset,this._offset+r).toString();return this._offset+=r,l}static sizeLongString(r){return 4+r.byteLength}writeLongString(r){this._buff.writeUInt32BE(r.byteLength,this._offset),this._offset+=4,this._buff.set(r,this._offset),this._offset+=r.byteLength}readLongString(){const r=this._buff.readUInt32BE(this._offset);this._offset+=4;const l=this._buff.slice(this._offset,this._offset+r).toString();return this._offset+=r,l}writeBuffer(r){this._buff.writeUInt32BE(r.byteLength,this._offset),this._offset+=4,this._buff.set(r,this._offset),this._offset+=r.byteLength}static sizeVSBuffer(r){return 4+r.byteLength}writeVSBuffer(r){this._buff.writeUInt32BE(r.byteLength,this._offset),this._offset+=4,this._buff.set(r,this._offset),this._offset+=r.byteLength}readVSBuffer(){const r=this._buff.readUInt32BE(this._offset);this._offset+=4;const o=this._buff.slice(this._offset,this._offset+r);return this._offset+=r,o}static sizeMixedArray(r,o){let l=0;l+=1;for(let i=0,h=r.length;i<h;i++){const y=r[i],g=o[i];switch(l+=1,g){case 1:l+=this.sizeLongString(y);break;case 2:l+=this.sizeVSBuffer(y);break;case 3:break}}return l}writeMixedArray(r,o){this._buff.writeUInt8(r.length,this._offset),this._offset+=1;for(let l=0,i=r.length;l<i;l++){const h=r[l];switch(o[l]){case 1:this.writeUInt8(1),this.writeLongString(h);break;case 2:this.writeUInt8(2),this.writeVSBuffer(h);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const r=this._buff.readUInt8(this._offset);this._offset+=1;let o=new Array(r);for(let l=0;l<r;l++)switch(this.readUInt8()){case 1:o[l]=this.readLongString();break;case 2:o[l]=this.readVSBuffer();break;case 3:o[l]=void 0;break}return o}}class s{static _arrayContainsBufferOrUndefined(r){for(let o=0,l=r.length;o<l;o++)if(r[o]instanceof C.VSBuffer||typeof r[o]=="undefined")return!0;return!1}static serializeRequestArguments(r,o){if(this._arrayContainsBufferOrUndefined(r)){let l=[],i=[];for(let h=0,y=r.length;h<y;h++){const g=r[h];g instanceof C.VSBuffer?(l[h]=g,i[h]=2):typeof g=="undefined"?(l[h]=C.VSBuffer.alloc(0),i[h]=3):(l[h]=C.VSBuffer.fromString(v(g,o)),i[h]=1)}return{type:"mixed",args:l,argsType:i}}return{type:"simple",args:v(r,o)}}static serializeRequest(r,o,l,i,h){return i.type==="mixed"?this._requestMixedArgs(r,o,l,i.args,i.argsType,h):this._requestJSONArgs(r,o,l,i.args,h)}static _requestJSONArgs(r,o,l,i,h){const y=C.VSBuffer.fromString(l),g=C.VSBuffer.fromString(i);let E=0;E+=d.sizeUInt8(),E+=d.sizeShortString(y),E+=d.sizeLongString(g);let b=d.alloc(h?2:1,r,E);return b.writeUInt8(o),b.writeShortString(y),b.writeLongString(g),b.buffer}static deserializeRequestJSONArgs(r){const o=r.readUInt8(),l=r.readShortString(),i=r.readLongString();return{rpcId:o,method:l,args:JSON.parse(i)}}static _requestMixedArgs(r,o,l,i,h,y){const g=C.VSBuffer.fromString(l);let E=0;E+=d.sizeUInt8(),E+=d.sizeShortString(g),E+=d.sizeMixedArray(i,h);let b=d.alloc(y?4:3,r,E);return b.writeUInt8(o),b.writeShortString(g),b.writeMixedArray(i,h),b.buffer}static deserializeRequestMixedArgs(r){const o=r.readUInt8(),l=r.readShortString(),i=r.readMixedArray(),h=new Array(i.length);for(let y=0,g=i.length;y<g;y++){const E=i[y];typeof E=="string"?h[y]=JSON.parse(E):h[y]=E}return{rpcId:o,method:l,args:h}}static serializeAcknowledged(r){return d.alloc(5,r,0).buffer}static serializeCancel(r){return d.alloc(6,r,0).buffer}static serializeReplyOK(r,o,l){return typeof o=="undefined"?this._serializeReplyOKEmpty(r):o instanceof C.VSBuffer?this._serializeReplyOKVSBuffer(r,o):this._serializeReplyOKJSON(r,S(o,l))}static _serializeReplyOKEmpty(r){return d.alloc(7,r,0).buffer}static _serializeReplyOKVSBuffer(r,o){let l=0;l+=d.sizeVSBuffer(o);let i=d.alloc(8,r,l);return i.writeVSBuffer(o),i.buffer}static deserializeReplyOKVSBuffer(r){return r.readVSBuffer()}static _serializeReplyOKJSON(r,o){const l=C.VSBuffer.fromString(o);let i=0;i+=d.sizeLongString(l);let h=d.alloc(9,r,i);return h.writeLongString(l),h.buffer}static deserializeReplyOKJSON(r){const o=r.readLongString();return JSON.parse(o)}static serializeReplyErr(r,o){return o?this._serializeReplyErrEror(r,o):this._serializeReplyErrEmpty(r)}static _serializeReplyErrEror(r,o){const l=C.VSBuffer.fromString(S(R.transformErrorForSerialization(o),null));let i=0;i+=d.sizeLongString(l);let h=d.alloc(10,r,i);return h.writeLongString(l),h.buffer}static deserializeReplyErrError(r){const o=r.readLongString();return JSON.parse(o)}static _serializeReplyErrEmpty(r){return d.alloc(11,r,0).buffer}}var a;(function(t){t[t.RequestJSONArgs=1]="RequestJSONArgs",t[t.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",t[t.RequestMixedArgs=3]="RequestMixedArgs",t[t.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",t[t.Acknowledged=5]="Acknowledged",t[t.Cancel=6]="Cancel",t[t.ReplyOKEmpty=7]="ReplyOKEmpty",t[t.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",t[t.ReplyOKJSON=9]="ReplyOKJSON",t[t.ReplyErrError=10]="ReplyErrError",t[t.ReplyErrEmpty=11]="ReplyErrEmpty"})(a||(a={}));var c;(function(t){t[t.String=1]="String",t[t.VSBuffer=2]="VSBuffer",t[t.Undefined=3]="Undefined"})(c||(c={}))}),define(ge[256],pe([0,1,110,50]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputAppender=void 0;class R{constructor(P,D){this.file=D,this.appender=_.createRotatingLogger(P,D,30*k.ByteSize.MB,1),this.appender.clearFormatters()}append(P){this.appender.critical(P)}flush(){this.appender.flush()}}e.OutputAppender=R}),define(ge[257],pe([0,1,2,7,256,145,24,65,28,14,5,12]),function(Z,e,_,k,R,T,P,D,I,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class v extends D.AbstractExtHostOutputChannel{constructor(m,w,p){super(m,!1,_.URI.file(w.file),p);this._appender=w}append(m){super.append(m),this._appender.append(m),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(m,w){this._appender.flush(),super.show(m,w)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=v;let f=class extends D.ExtHostOutputService{constructor(m,w,p){super(m);this.logService=w,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new C.MutableDisposable,this._logsLocation=p.logsLocation}$setVisibleChannel(m){if(m){const w=this._channels.get(m);w&&(this._visibleChannelDisposable.value=w.onDidAppend(()=>w.update()))}}createOutputChannel(m){if(m=m.trim(),!m)throw new Error("illegal argument `name`. must not be falsy");const w=this._doCreateOutChannel(m);return w.then(p=>p._id.then(d=>this._channels.set(d,p))),new D.LazyOutputChannel(m,w)}async _doCreateOutChannel(m){try{const w=k.join(this._logsLocation.fsPath,`output_logging_${T.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await P.dirExists(w)||await P.mkdirp(w);const d=`${this._namePool++}-${m.replace(/[\\/:\*\?"<>\|]/g,"")}`,s=_.URI.file(k.join(w,`${d}.log`)),a=new R.OutputAppender(d,s.fsPath);return new v(m,a,this._proxy)}catch(w){return this.logService.error(w),new D.ExtHostPushOutputChannel(m,this._proxy)}}};f=He([Fe(0,n.IExtHostRpcService),Fe(1,S.ILogService),Fe(2,I.IExtHostInitDataService)],f),e.ExtHostOutputService2=f}),define(ge[258],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=_.createDecorator("remoteAgentService")}),define(ge[259],pe([0,1,11,7,9,2,4,258]),function(Z,e,_,k,R,T,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=P.createDecorator("pathService");let I=class{constructor(C,S){this.localUserHome=C,this.remoteAgentService=S,this.resolveOS=(async()=>{const v=await this.remoteAgentService.getEnvironment();return(v==null?void 0:v.os)||R.OS})(),this.resolveUserHome=(async()=>{const v=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(v==null?void 0:v.userHome)||C})()}async userHome(C){return(C==null?void 0:C.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(C=>C===1?k.win32:k.posix)}async fileURI(C){let S="";if(await this.resolveOS===1&&(C=C.replace(/\\/g,"/")),C[0]==="/"&&C[1]==="/"){const f=C.indexOf("/",2);f===-1?(S=C.substring(2),C="/"):(S=C.substring(2,f),C=C.substring(f)||"/")}return T.URI.from({scheme:_.Schemas.file,authority:S,path:C,query:"",fragment:""})}};I=He([Fe(1,D.IRemoteAgentService)],I),e.AbstractPathService=I}),define(ge[31],pe([0,1,13,33,25,30,10,4,7,15]),function(Z,e,_,k,R,T,P,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const C="\u27EA ",S=" characters skipped \u27EB",v=(C.length+S.length+5)*2;e.ISearchService=D.createDecorator("searchService");var f;(function(O){O[O.file=0]="file",O[O.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(O){O[O.File=1]="File",O[O.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function m(O){return!!O.preview}e.resultIsMatch=m;function w(O){return!!O.resource}e.isFileMatch=w;function p(O){return!!O.message}e.isProgressMessage=p;var d;(function(O){O[O.Normal=0]="Normal",O[O.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class s{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=s;class a{constructor(B,J,U){this.ranges=J;const V=Array.isArray(J)?J:[J];if(U&&U.matchLines===1&&c(V)){B=P.getNLines(B,U.matchLines);let z="",Q=0,ae=0;const ce=Math.floor(U.charsPerLine/5),fe=[];for(const we of V){const be=Math.max(we.startColumn-ce,0),H=we.startColumn+U.charsPerLine;if(be>ae+ce+v){const X=C+(be-ae)+S;z+=X+B.slice(be,H),Q+=be-(ae+X.length)}else z+=B.slice(ae,H);fe.push(new r(0,we.startColumn-Q,we.endColumn-Q)),ae=H}this.preview={text:z,matches:Array.isArray(this.ranges)?fe:fe[0]}}else{const z=Array.isArray(J)?J[0].startLineNumber:J.startLineNumber;this.preview={text:B,matches:_.mapArrayOrNot(J,Q=>new t(Q.startLineNumber-z,Q.startColumn,Q.endLineNumber-z,Q.endColumn))}}}}e.TextSearchMatch=a;function c(O){const B=O[0].startLineNumber;for(const J of O)if(J.startLineNumber!==B||J.endLineNumber!==B)return!1;return!0}class t{constructor(B,J,U,V){this.startLineNumber=B,this.startColumn=J,this.endLineNumber=U,this.endColumn=V}}e.SearchRange=t;class r extends t{constructor(B,J,U){super(B,J,B,U)}}e.OneLineRange=r;var o;(function(O){O.Default="default",O.FileNames="fileNames",O.Type="type",O.Modified="modified",O.CountDescending="countDescending",O.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function l(O,B=!0){const J=O&&O.files&&O.files.exclude,U=B&&O&&O.search&&O.search.exclude;if(!(!J&&!U)){if(!J||!U)return J||U;let V=Object.create(null);return V=R.mixin(V,R.deepClone(J)),V=R.mixin(V,R.deepClone(U),!0),V}}e.getExcludes=l;function i(O,B){return O.excludePattern&&k.match(O.excludePattern,B)?!1:O.includePattern||O.usingSearchPaths?O.includePattern&&k.match(O.includePattern,B)?!0:O.usingSearchPaths?!!O.folderQueries&&O.folderQueries.some(J=>{const U=J.folder.fsPath;if(T.isEqualOrParent(B,U)){const V=I.relative(U,B);return!J.includePattern||!!k.match(J.includePattern,V)}else return!1}):!1:!0}e.pathIncludedInQuery=i;var h;(function(O){O[O.unknownEncoding=1]="unknownEncoding",O[O.regexParseError=2]="regexParseError",O[O.globParseError=3]="globParseError",O[O.invalidLiteral=4]="invalidLiteral",O[O.rgProcessError=5]="rgProcessError",O[O.other=6]="other",O[O.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(B,J){super(B);this.code=J}}e.SearchError=y;function g(O){const B=O.message;if(n.isPromiseCanceledError(O))return new y(B,h.canceled);try{const J=JSON.parse(B);return new y(J.message,J.code)}catch(J){return new y(B,h.other)}}e.deserializeSearchError=g;function E(O){const B={message:O.message,code:O.code};return new Error(JSON.stringify(B))}e.serializeSearchError=E;function b(O){return O.type==="error"?!0:O.type==="success"}e.isSerializedSearchComplete=b;function L(O){return O.type==="success"}e.isSerializedSearchSuccess=L;function A(O){return!!O.path}e.isSerializedFileMatch=A;function N(O,B){const J=O.searchPath?O.searchPath:O.relativePath;return P.fuzzyContains(J,B)}e.isFilePatternMatch=N;class W{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=W;function x(O,B){const J=Object.assign(Object.assign({},O||{}),B||{});return Object.keys(J).filter(U=>{const V=J[U];return typeof V=="boolean"&&V})}e.resolvePatternsForProvider=x;class M{constructor(B,J){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},B.excludePattern||{}),J.excludePattern||{}),this._parsedExcludeExpression=k.parse(this._excludeExpression);let U=B.includePattern;J.includePattern&&(U?U=Object.assign(Object.assign({},U),J.includePattern):U=J.includePattern),U&&(this._parsedIncludeExpression=k.parse(U))}includedInQuerySync(B,J,U){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,J,U)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,J,U))}includedInQuery(B,J,U){return Promise.resolve(this._parsedExcludeExpression(B,J,U)).then(z=>!!z).then(z=>z?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(B,J,U)).then(Q=>!!Q):Promise.resolve(!0)).then(z=>z)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=M;function $(O){for(const B in O)if(typeof O[B]!="boolean")return!0;return!1}}),define(ge[32],pe([0,1,13,19,21,3,22,11,74,23,10,16,2,165,4,12,183,61,62,28,14,8,31,6]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p,d,s,a,c,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(L,A,N){return new n.ExtUri(W=>y(W,N)).isEqual(L,A)}function l(L,A,N){return o(L.uri,A.uri,N)?0:C.compare(L.uri.toString(),A.uri.toString())}function i(L,A,N){return L.index!==A.index?L.index<A.index?-1:1:o(L.uri,A.uri,N)?C.compare(L.name,A.name):C.compare(L.uri.toString(),A.uri.toString())}function h(L,A,N,W){const x=L.slice(0).sort(($,O)=>N($,O,W)),M=A.slice(0).sort(($,O)=>N($,O,W));return _.delta(x,M,($,O)=>N($,O,W))}function y(L,A){const N=A.getCapabilities(L.scheme);return!(N&&N&1024)}class g extends p.Workspace{constructor(A,N,W,x,M,$){super(A,W.map(O=>new p.WorkspaceFolder(O)),x,$);this._name=N,this._isUntitled=M,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris($),W.forEach(O=>{this._workspaceFolders.push(O),this._structure.set(O.uri,O)})}static toExtHostWorkspace(A,N,W,x){if(!A)return{workspace:null,added:[],removed:[]};const{id:M,name:$,folders:O,configuration:B,isUntitled:J}=A,U=[],V=N;N?O.forEach((ce,fe)=>{const we=v.URI.revive(ce.uri),be=g._findFolder(W||N,we,x);be?(be.name=ce.name,be.index=ce.index,U.push(be)):U.push({uri:we,name:ce.name,index:fe})}):U.push(...O.map(({uri:ce,name:fe,index:we})=>({uri:v.URI.revive(ce),name:fe,index:we}))),U.sort((ce,fe)=>ce.index<fe.index?-1:1);const z=new g(M,$,U,B?v.URI.revive(B):null,!!J,ce=>y(ce,x)),{added:Q,removed:ae}=h(V?V.workspaceFolders:[],z.workspaceFolders,l,x);return{workspace:z,added:Q,removed:ae}}static _findFolder(A,N,W){for(let x=0;x<A.folders.length;x++){const M=A.workspaceFolders[x];if(o(M.uri,N,W))return M}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(A,N){return N&&this._structure.get(A)&&(A=n.dirname(A)),this._structure.findSubstr(A)}resolveWorkspaceFolder(A){return this._structure.get(A)}}let E=class{constructor(A,N,W,x){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._activeSearchCallbacks=[],this._logService=x,this._extHostFileSystemInfo=W,this._requestIdProvider=new I.Counter,this._barrier=new k.Barrier,this._proxy=A.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=A.getProxy(r.MainContext.MainThreadMessageService);const M=N.workspace;this._confirmedWorkspace=M?new g(M.id,M.name,[],M.configuration?v.URI.revive(M.configuration):null,!!M.isUntitled,$=>y($,W)):void 0}$initializeWorkspace(A){this.$acceptWorkspaceData(A),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?v.URI.from({scheme:D.Schemas.untitled,path:n.basename(n.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(A,N,W,...x){const M=[];if(Array.isArray(x)&&x.forEach(U=>{v.URI.isUri(U.uri)&&!M.some(V=>o(V.uri,U.uri,this._extHostFileSystemInfo))&&M.push({uri:U.uri,name:U.name||n.basenameOrAuthority(U.uri)})}),this._unconfirmedWorkspace||[N,W].some(U=>typeof U!="number"||U<0)||W===0&&M.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+W>$.length)return!1;const O=$.slice(0);O.splice(N,W,...M.map(U=>({uri:U.uri,name:U.name||n.basenameOrAuthority(U.uri),index:void 0})));for(let U=0;U<O.length;U++){const V=O[U];if(O.some((z,Q)=>Q!==U&&o(V.uri,z.uri,this._extHostFileSystemInfo)))return!1}O.forEach((U,V)=>U.index=V);const{added:B,removed:J}=h($,O,i,this._extHostFileSystemInfo);if(B.length===0&&J.length===0)return!1;if(this._proxy){const U=A.displayName||A.name;this._proxy.$updateWorkspaceFolders(U,N,W,M).then(void 0,V=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,f.localize(0,null,U,V.toString()),{extension:A},[])})}return this.trySetWorkspaceFolders(O),!0}getWorkspaceFolder(A,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,N)}async getWorkspaceFolder2(A,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,N)}async resolveWorkspaceFolder(A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(A)}getPath(){if(!!this._actualWorkspace){const{folders:A}=this._actualWorkspace;if(A.length!==0)return A[0].uri.fsPath}}getRelativePath(A,N){let W,x="";if(typeof A=="string"?(W=v.URI.file(A),x=A):typeof A!="undefined"&&(W=A,x=A.fsPath),!W)return x;const M=this.getWorkspaceFolder(W,!0);if(!M)return x;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let $=n.relativePath(M.uri,W);return N&&M.name&&($=`${M.name}/${$}`),$}trySetWorkspaceFolders(A){this._actualWorkspace&&(this._unconfirmedWorkspace=g.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:A,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:N,added:W,removed:x}=g.toExtHostWorkspace(A,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:W,removed:x}))}findFiles(A,N,W,x,M=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let $;if(N===null?$=!1:N&&(typeof N=="string"?$=N:$=N.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:O,folder:B}=b(A);return this._proxy.$startFileSearch(S.withUndefinedAsNull(O),S.withUndefinedAsNull(B),S.withUndefinedAsNull($),S.withUndefinedAsNull(W),M).then(J=>Array.isArray(J)?J.map(U=>v.URI.revive(U)):[])}async findTextInFiles(A,N,W,x,M=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),O=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:B,folder:J}=b(N.include),U=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,V={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:O,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:B,excludePattern:U},z=!1;if(this._activeSearchCallbacks[$]=Q=>{if(!z){const ae=v.URI.revive(Q.resource);Q.results.forEach(ce=>{t.resultIsMatch(ce)?W({uri:ae,preview:{text:ce.preview.text,matches:_.mapArrayOrNot(ce.preview.matches,fe=>new c.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))},ranges:_.mapArrayOrNot(ce.ranges,fe=>new c.Range(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))}):W({uri:ae,text:ce.text,lineNumber:ce.lineNumber})})}},M.isCancellationRequested)return{};try{const Q=await this._proxy.$startTextSearch(A,S.withUndefinedAsNull(J),V,$,M);return delete this._activeSearchCallbacks[$],Q||{}}catch(Q){throw delete this._activeSearchCallbacks[$],Q}}$handleTextSearchResult(A,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](A)}saveAll(A){return this._proxy.$saveAll(A)}resolveProxy(A){return this._proxy.$resolveProxy(A)}};E=He([Fe(0,a.IExtHostRpcService),Fe(1,s.IExtHostInitDataService),Fe(2,d.IExtHostFileSystemInfo),Fe(3,m.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=u.createDecorator("IExtHostWorkspace");function b(L){let A,N;return L&&(typeof L=="string"?A=L:(A=L.pattern,N=L.baseFolder||v.URI.file(L.base))),{includePattern:A,folder:N}}}),define(ge[37],pe([0,1,25,3,32,6,8,186,84,16,19,4,14,12,2]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(r,o){if(o){const l=o.split(".");let i=r;for(let h=0;i&&h<l.length;h++)i=i[l[h]];return i}}function w(r){return r instanceof u.URI}function p(r){return r&&r.uri instanceof u.URI&&r.languageId&&typeof r.languageId=="string"}function d(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function s(r){return r&&r.uri instanceof u.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function a(r){if(w(r))return{resource:r};if(p(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(d(r))return{overrideIdentifier:r.languageId};if(s(r))return{resource:r.uri};if(r===null)return{resource:null}}let c=class{constructor(o,l,i){this._proxy=o.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=i,this._barrier=new C.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,l){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(o,l))}};c=He([Fe(0,v.IExtHostRpcService),Fe(1,R.IExtHostWorkspace),Fe(2,f.ILogService)],c),e.ExtHostConfiguration=c;class t{constructor(o,l,i,h){this._onDidChangeConfiguration=new k.Emitter,this._proxy=o,this._logService=h,this._extHostWorkspace=l,this._configuration=D.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,l){const i={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,i))}getConfiguration(o,l,i){const h=a(l)||{},y=this._toReadonlyValue(o?m(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,h,i==null?void 0:i.identifier);function g(b){if(b==null)return null;if(typeof b=="boolean")return b?1:4;switch(b){case P.ConfigurationTarget.Global:return 1;case P.ConfigurationTarget.Workspace:return 4;case P.ConfigurationTarget.WorkspaceFolder:return 5}}const E={has(b){return typeof m(y,b)!="undefined"},get:(b,L)=>{this._validateConfigurationAccess(o?`${o}.${b}`:b,h,i==null?void 0:i.identifier);let A=m(y,b);if(typeof A=="undefined")A=L;else{let N;const W=(x,M)=>{let $;const O=()=>{N=N||_.deepClone(y),$=$||m(N,M)};return n.isObject(x)?new Proxy(x,{get:(B,J)=>{if(typeof J=="string"&&J.toLowerCase()==="tojson")return O(),()=>$;if(N)return $=$||m(N,M),$[J];const U=B[J];return typeof J=="string"?W(U,`${M}.${J}`):U},set:(B,J,U)=>(O(),$&&($[J]=U),!0),deleteProperty:(B,J)=>(O(),$&&delete $[J],!0),defineProperty:(B,J,U)=>(O(),$&&Object.defineProperty($,J,U),!0)}):x};A=W(A,b)}return A},update:(b,L,A,N)=>{b=o?`${o}.${b}`:b;const W=g(A);return L!==void 0?this._proxy.$updateConfigurationOption(W,b,L,h,N):this._proxy.$removeConfigurationOption(W,b,h,N)},inspect:b=>{var L,A,N,W,x,M,$,O;b=o?`${o}.${b}`:b;const B=_.deepClone(this._configuration.inspect(b,h,this._extHostWorkspace.workspace));if(B)return{key:b,defaultValue:(L=B.default)===null||L===void 0?void 0:L.value,globalValue:(A=B.user)===null||A===void 0?void 0:A.value,workspaceValue:(N=B.workspace)===null||N===void 0?void 0:N.value,workspaceFolderValue:(W=B.workspaceFolder)===null||W===void 0?void 0:W.value,defaultLanguageValue:(x=B.default)===null||x===void 0?void 0:x.override,globalLanguageValue:(M=B.user)===null||M===void 0?void 0:M.override,workspaceLanguageValue:($=B.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(O=B.workspaceFolder)===null||O===void 0?void 0:O.override,languageIds:B.overrideIdentifiers}}};return typeof y=="object"&&_.mixin(E,y,!1),Object.freeze(E)}_toReadonlyValue(o){const l=i=>n.isObject(i)?new Proxy(i,{get:(h,y)=>l(h[y]),set:(h,y,g)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(h,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(h,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):i;return l(o)}_validateConfigurationAccess(o,l,i){const h=I.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),y=i?`[${i.value}] `:"";if(h===4){typeof(l==null?void 0:l.resource)=="undefined"&&this._logService.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){(l==null?void 0:l.resource)&&this._logService.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,l){const i=new D.ConfigurationChangeEvent(o,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,y)=>i.affectsConfiguration(h,a(y))})}_toMap(o){return o.reduce((l,i)=>(l.set(i[0],i[1]),l),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=S.createDecorator("IExtHostConfiguration")}),define(ge[67],pe([0,1,2,19,3,6,8,32,40,37,21,36,14,28,4,11,9,12,64,206,15]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p,d,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var c;(function(W){function x($){if($!=null)return $}W.from=x;function M($){if($!=null)return $}W.to=M})(c=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var t;(function(W){function x($){if($!=null)return $}W.from=x;function M($){if($!=null)return $}W.to=M})(t=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(W){function x($){if($!=null)return $}W.from=x;function M($){if($!=null)return $}W.to=M})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(W){function x(O){if(O){const B=O;return B&&!!B.process}else return!1}W.is=x;function M(O){if(O!=null){const B={process:O.process,args:O.args};return O.options&&(B.options=r.from(O.options)),B}}W.from=M;function $(O){if(O!=null)return new P.ProcessExecution(O.process,O.args,O.options)}W.to=$})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(W){function x($){if($!=null)return $}W.from=x;function M($){if($!=null)return $}W.to=M})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var i;(function(W){function x(O){if(O){const B=O;return B&&(!!B.commandLine||!!B.command)}else return!1}W.is=x;function M(O){if(O!=null){const B={};return O.commandLine!==void 0?B.commandLine=O.commandLine:(B.command=O.command,B.args=O.args),O.options&&(B.options=l.from(O.options)),B}}W.from=M;function $(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new P.ShellExecution(O.commandLine,O.options):new P.ShellExecution(O.command,O.args?O.args:[],O.options)}W.to=$})(i=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var h;(function(W){function x(O){if(O){let B=O;return B&&B.customExecution==="customExecution"}else return!1}W.is=x;function M(O){return{customExecution:"customExecution"}}W.from=M;function $(O,B){return B.get(O)}W.to=$})(h=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var y;(function(W){function x(M,$){let O;return M.scope!==void 0&&typeof M.scope!="number"?O=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===P.TaskScope.Workspace&&$&&$.workspaceFile?O=$.workspaceFile:O=s.USER_TASKS_GROUP_KEY),{id:M._id,workspaceFolder:O}}W.from=x})(y=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(W){function x(O,B){if(O==null)return[];const J=[];for(let U of O){const V=M(U,B);V&&J.push(V)}return J}W.fromMany=x;function M(O,B){if(O!=null){let J;O.execution instanceof P.ProcessExecution?J=o.from(O.execution):O.execution instanceof P.ShellExecution?J=i.from(O.execution):O.execution&&O.execution instanceof P.CustomExecution&&(J=h.from(O.execution));const U=c.from(O.definition);let V;if(O.scope?typeof O.scope=="number"?V=O.scope:V=O.scope.uri:V=P.TaskScope.Workspace,!(!U||!V)){const z=O.group?O.group.id:void 0;return{_id:O._id,definition:U,name:O.name,source:{extensionId:B.identifier.value,label:O.source,scope:V},execution:J,isBackground:O.isBackground,group:z,presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}}}W.from=M;async function $(O,B,J){if(O!=null){let U;o.is(O.execution)?U=o.to(O.execution):i.is(O.execution)?U=i.to(O.execution):h.is(O.execution)&&(U=h.to(O._id,J));const V=c.to(O.definition);let z;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?z=O.source.scope:z=await B.resolveWorkspaceFolder(_.URI.revive(O.source.scope)):z=P.TaskScope.Workspace),!(!V||!z)){const Q=new P.Task(V,z,O.name,O.source.label,U,O.problemMatchers);return O.isBackground!==void 0&&(Q.isBackground=O.isBackground),O.group!==void 0&&(Q.group=P.TaskGroup.from(O.group)),O.presentationOptions&&(Q.presentationOptions=t.to(O.presentationOptions)),O._id&&(Q._id=O._id),O.detail&&(Q.detail=O.detail),Q}}}W.to=$})(g=e.TaskDTO||(e.TaskDTO={}));var E;(function(W){function x($){return $}W.from=x;function M($){if(!!$)return Object.assign(Object.create(null),$)}W.to=M})(E=e.TaskFilterDTO||(e.TaskFilterDTO={}));class b{constructor(x,M,$){this._tasks=x,this._id=M,this._task=$}get task(){return this._task}terminate(){this._tasks.terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}var L;(function(W){function x(M){return{id:M._id,task:void 0}}W.from=x})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let A=class{constructor(x,M,$,O,B,J,U,V){this._onDidExecuteTask=new R.Emitter,this._onDidTerminateTask=new R.Emitter,this._onDidTaskProcessStarted=new R.Emitter,this._onDidTaskProcessEnded=new R.Emitter,this._proxy=x.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=O,this._configurationService=B,this._terminalService=J,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=U,this._deprecationService=V,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,M,$){if(!$)return new P.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:M,provider:$,extension:x}),this._proxy.$registerTaskProvider(O,M),new P.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(x,M){this._proxy.$registerTaskSystem(x,M)}fetchTasks(x){return this._proxy.$fetchTasks(E.from(x)).then(async M=>{const $=[];for(let O of M){const B=await g.to(O,this._workspaceProvider,this._providedCustomExecutions2);B&&$.push(B)}return $})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(M=>x.push(M)),x}terminateTask(x){if(!(x instanceof b))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,M,$){const O=this._providedCustomExecutions2.get(x.id);if(O){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,O),this._terminalService.attachPtyToTerminal(M,await O.callback($))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const M=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:M})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const M=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:M,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const M=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:M,exitCode:x.exitCode})}$provideTasks(x,M){const $=this._handlers.get(x);if(!$)return Promise.reject(new Error("no handler found"));const O=[],B=k.asPromise(()=>$.provider.provideTasks(C.CancellationToken.None)).then(J=>this.provideTasksInternal(M,O,$,J));return new Promise(J=>{B.then(U=>{Promise.all(O).then(()=>{J(U)})})})}async $resolveTask(x,M){const $=this._handlers.get(x);if(!$)return Promise.reject(new Error("no handler found"));if(M.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${$.type}].`);const O=await g.to(M,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const B=await $.provider.resolveTask(O,C.CancellationToken.None);if(!!B){this.checkDeprecation(B,$);const J=g.from(B,$.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(J.execution)&&await this.addCustomExecution(J,B,!0),await this.resolveTaskInternal(J)}}nextHandle(){return this._handleCounter++}async addCustomExecution(x,M,$){const O=await this._proxy.$createTaskId(x);!$&&!this._providedCustomExecutions2.has(O)&&this._notProvidedCustomExecutions.add(O),this._providedCustomExecutions2.set(O,M.execution)}async getTaskExecution(x,M){if(typeof x=="string"){const B=this._taskExecutionPromises.get(x);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let $=this._taskExecutionPromises.get(x.id);if($)return $;const O=new Promise(async(B,J)=>{const U=M||await g.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);U?B(new b(this,x.id,U)):J("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,O),O.then(B=>(this._taskExecutions.set(x.id,B),B),B=>Promise.reject(B))}checkDeprecation(x,M){x._deprecated&&this._deprecationService.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let $=this._notProvidedCustomExecutions.values(),O=$.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=$.next()}};A=He([Fe(0,v.IExtHostRpcService),Fe(1,f.IExtHostInitDataService),Fe(2,D.IExtHostWorkspace),Fe(3,I.IExtHostDocumentsAndEditors),Fe(4,n.IExtHostConfiguration),Fe(5,S.IExtHostTerminalService),Fe(6,p.ILogService),Fe(7,d.IExtHostApiDeprecationService)],A),e.ExtHostTaskBase=A;let N=class extends A{constructor(x,M,$,O,B,J,U,V){super(x,M,$,O,B,J,U,V);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(x,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const $=g.from(M,x);if($===void 0)throw new Error("Task is not valid");if(h.is($.execution))await this.addCustomExecution($,M,!1);else throw new a.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution($),M);return this._proxy.$executeTask($).catch(B=>{throw new Error(B)}),O}provideTasksInternal(x,M,$,O){const B=[];if(O)for(let J of O){this.checkDeprecation(J,$),(!J.definition||!x[J.definition.type])&&this._logService.warn(`The task [${J.source}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`);const U=g.from(J,$.extension);U&&h.is(U.execution)?(B.push(U),M.push(this.addCustomExecution(U,J,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:$.extension}}async resolveTaskInternal(x){if(h.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,M){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(x,M,$){}};N=He([Fe(0,v.IExtHostRpcService),Fe(1,f.IExtHostInitDataService),Fe(2,D.IExtHostWorkspace),Fe(3,I.IExtHostDocumentsAndEditors),Fe(4,n.IExtHostConfiguration),Fe(5,S.IExtHostTerminalService),Fe(6,p.ILogService),Fe(7,d.IExtHostApiDeprecationService)],N),e.WorkerExtHostTask=N,e.IExtHostTask=u.createDecorator("IExtHostTask")});var Je=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},We=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)},di=this&&this.__rest||function(Z,e){var _={};for(var k in Z)Object.prototype.hasOwnProperty.call(Z,k)&&e.indexOf(k)<0&&(_[k]=Z[k]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,k=Object.getOwnPropertySymbols(Z);R<k.length;R++)e.indexOf(k[R])<0&&Object.prototype.propertyIsEnumerable.call(Z,k[R])&&(_[k[R]]=Z[k[R]]);return _};define(ge[260],pe([0,1,13,19,21,3,70,5,16,2,26,6,40,14,20,8,32,222,214]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p,d){"use strict";var s,a;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.ExtHostTesting=void 0;const c=(L,A)=>`${L}:${A.toString()}`;let t=class{constructor(A,N,W){this.documents=N,this.workspace=W,this.resultsChangedEmitter=new T.Emitter,this.providers=new Map,this.ownedTests=new p.OwnedTestCollection,this.testSubscriptions=new Map,this.onLastResultsChanged=this.resultsChangedEmitter.event,this.proxy=A.getProxy(S.MainContext.MainThreadTesting),this.workspaceObservers=new E(this.proxy),this.textDocumentObservers=new b(this.proxy,N)}registerTestProvider(A){const N=C.generateUuid();this.providers.set(N,A),this.proxy.$registerTestProvider(N);const W=[...this.testSubscriptions.keys()];return setTimeout(()=>{var x;for(const M of W)(x=this.testSubscriptions.get(M))===null||x===void 0||x.subscribeFn(N,A)},0),new m.Disposable(()=>{this.providers.delete(N),this.proxy.$unregisterTestProvider(N)})}createTextDocumentTestObserver(A){return this.textDocumentObservers.checkout(A.uri)}createWorkspaceTestObserver(A){return this.workspaceObservers.checkout(A.uri)}async runTests(A,N=R.CancellationToken.None){await this.proxy.$runTests({tests:A.tests.map(W=>{var x,M;return(M=(x=this.workspaceObservers.getMirroredTestDataByReference(W))!==null&&x!==void 0?x:_.mapFind(this.testSubscriptions.values(),$=>$.collection.getTestByReference(W)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(W)}).filter(I.isDefined).map(W=>({providerId:W.providerId,testId:W.id})),debug:A.debug},N)}$publishTestResults(A){const N=W=>Object.assign(Object.assign({},u.TestItem.toShallow(W.item)),{children:W.children.map(N)});this.lastResults={tests:A.tests.map(N)},this.resultsChangedEmitter.fire()}async $subscribeToTests(A,N){const W=n.URI.revive(N),x=c(A,W);if(!this.testSubscriptions.has(x)){let M;if(A===1){let J=this.documents.getDocument(W);if(!J){const U=new D.DisposableStore;J=await new Promise(V=>{U.add(k.disposableTimeout(()=>V(void 0),5e3)),U.add(this.documents.onDidAddDocuments(z=>{const Q=z.find(ae=>ae.document.uri.toString()===W.toString());Q&&V(Q)}))}).finally(()=>U.dispose())}if(J){const U=await this.workspace.getWorkspaceFolder2(W,!1);M=V=>V.createDocumentTestHierarchy?V.createDocumentTestHierarchy(J.document):this.createDefaultDocumentTestHierarchy(V,J.document,U)}}else{const J=await this.workspace.getWorkspaceFolder2(W,!1);J&&(M=U=>{var V;return(V=U.createWorkspaceTestHierarchy)===null||V===void 0?void 0:V.call(U,J)})}if(!!M){const $=(J,U)=>{try{const V=M(U);if(!V)return;B.pushDiff([3,1]),O.add(V),B.addRoot(V.root,J),Promise.resolve(V.discoveredInitialTests).then(()=>B.pushDiff([3,-1])),V.onDidChangeTest(z=>B.onItemChange(z,J))}catch(V){console.error(V)}},O=new D.DisposableStore,B=O.add(this.ownedTests.createForHierarchy(J=>this.proxy.$publishDiff(A,N,J)));for(const[J,U]of this.providers)$(J,U);B.pushDiff([4,-1]),this.testSubscriptions.set(x,{store:O,collection:B,subscribeFn:$})}}}$unsubscribeFromTests(A,N){var W;const x=n.URI.revive(N),M=c(A,x);(W=this.testSubscriptions.get(M))===null||W===void 0||W.store.dispose(),this.testSubscriptions.delete(M)}$acceptDiff(A,N,W){A===1?this.textDocumentObservers.acceptDiff(n.URI.revive(N),W):this.workspaceObservers.acceptDiff(n.URI.revive(N),W)}async $runTestsForProvider(A,N){const W=this.providers.get(A.providerId);if(!W||!W.runTests)return d.EMPTY_TEST_RESULT;const x=A.ids.map(M=>{var $;return($=this.ownedTests.getTestById(M))===null||$===void 0?void 0:$.actual}).filter(I.isDefined).map(M=>M instanceof r?M.actual:M);if(!x.length)return d.EMPTY_TEST_RESULT;try{await W.runTests({tests:x,debug:A.debug},N);for(const{collection:M}of this.testSubscriptions.values())M.flushDiff();return d.EMPTY_TEST_RESULT}catch(M){throw console.error(M),M}}$lookupTest(A){const N=this.ownedTests.getTestById(A.testId);if(!N)return Promise.resolve(void 0);const{actual:W,previousChildren:x,previousEquals:M}=N,$=di(N,["actual","previousChildren","previousEquals"]);return Promise.resolve($)}createDefaultDocumentTestHierarchy(A,N,W){var x;if(!!W){const M=(x=A.createWorkspaceTestHierarchy)===null||x===void 0?void 0:x.call(A,W);if(!!M){const $=new T.Emitter;return M.onDidChangeTest(O=>{const B=r.getWrapperForTestItem(O,N);if(B.hasNodeMatchingFilter){if(B.reset(),B.hasNodeMatchingFilter){$.fire(B);return}$.fire(B.visibleParent);return}const U=B.visibleParent;B.reset(),!!B.hasNodeMatchingFilter&&(U.reset(),$.fire(U))}),{root:r.getWrapperForTestItem(M.root,N),dispose:()=>{$.dispose(),r.removeFilter(N)},onDidChangeTest:$.event}}}}};t=He([Fe(0,f.IExtHostRpcService),Fe(1,v.IExtHostDocumentsAndEditors),Fe(2,w.IExtHostWorkspace)],t),e.ExtHostTesting=t;class r{constructor(A,N,W){this.actual=A,this.filterDocument=N,this.parent=W,this.getWrappedChildren()}static removeFilter(A){this.wrapperMap.delete(A)}static getWrapperForTestItem(A,N,W){let x=this.wrapperMap.get(N);if(x==null?void 0:x.has(A))return x.get(A);x||(x=new WeakMap,this.wrapperMap.set(N,x));const M=new r(A,N,W);return x.set(A,M),M}get label(){return this.actual.label}get debuggable(){return this.actual.debuggable}get description(){return this.actual.description}get location(){return this.actual.location}get runnable(){return this.actual.runnable}get state(){return this.actual.state}get children(){return this.getWrappedChildren().filter(A=>A.hasNodeMatchingFilter)}get visibleParent(){return this.hasNodeMatchingFilter?this:this.parent.visibleParent}get hasNodeMatchingFilter(){var A;return this.matchesFilter===void 0&&(this.matchesFilter=!this.parent||((A=this.actual.location)===null||A===void 0?void 0:A.uri.toString())===this.filterDocument.uri.toString()||this.getWrappedChildren().some(N=>N.hasNodeMatchingFilter)),this.matchesFilter}reset(){var A;this!==this.visibleParent&&((A=this.parent)===null||A===void 0||A.reset()),this.matchesFilter=void 0}getWrappedChildren(){var A;return((A=this.actual.children)===null||A===void 0?void 0:A.map(N=>r.getWrapperForTestItem(N,this.filterDocument,this)))||[]}}e.TestItemFilteredWrapper=r,r.wrapperMap=new WeakMap;class o extends d.IncrementalChangeCollector{constructor(A,N){super();this.collection=A,this.emitter=N,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,u.TestItem.toShallow(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.id);return}this.removed.add(A)}getChangeEvent(){const{collection:A,added:N,updated:W,removed:x}=this;return{get added(){return[...N].map(A.getPublicTestItem,A)},get updated(){return[...W].map(A.getPublicTestItem,A)},get removed(){return[...x].map(A.getPublicTestItem,A)},get commonChangeAncestor(){let M;const $=U=>{if(!!U){const V=new Array(U.depth+1);for(let z=U.depth;z>=0;z--){if(!U)return;V[U.depth]=U,U=U.parent?A.getMirroredTestDataById(U.parent):void 0}return V}},O=U=>{if(!(M&&M.length===0)){const V=$(U);if(!!V){if(!M){M=V;return}for(let z=M.length-1;z>=0;z--)M[z]!==V[z]&&M.pop()}}},B=U=>{if(!(M&&M.length===0))if(U.parent===null)M=[];else{const V=A.getMirroredTestDataById(U.parent);V&&O(V)}};for(const U of N)B(U);for(const U of W)O(U);for(const U of x)B(U);const J=M&&M[M.length-1];return J?A.getPublicTestItem(J):null}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends d.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(A){let N=[];for(const W of A){const x=this.items.get(W);x&&N.push(this.getPublicTestItem(x))}return N}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){const N=i(A);return N?this.items.get(N):void 0}createItem(A,N){return Object.assign(Object.assign({},A),{revived:u.TestItem.toShallow(A.item),depth:N?N.depth+1:0,children:new Set})}createChangeCollector(){return new o(this,this.changeEmitter)}getPublicTestItem(A){return A.wrapped||(A.wrapped=new y(A,this)),A.wrapped}}e.MirroredTestCollection=l;const i=L=>L[h],h=Symbol("MirroredItemId");class y{constructor(A,N){s.set(this,void 0),a.set(this,void 0),Je(this,s,A),Je(this,a,N)}get id(){return We(this,s).revived.id}get label(){return We(this,s).revived.label}get description(){return We(this,s).revived.description}get state(){return We(this,s).revived.state}get location(){return We(this,s).revived.location}get runnable(){var A;return(A=We(this,s).revived.runnable)!==null&&A!==void 0?A:!0}get debuggable(){var A;return(A=We(this,s).revived.debuggable)!==null&&A!==void 0?A:!1}get children(){return We(this,a).getAllAsTestItem(We(this,s).children)}get[(s=new WeakMap,a=new WeakMap,h)](){return We(this,s).id}toJSON(){return{id:this.id,label:this.label,description:this.description,state:this.state,location:this.location,runnable:this.runnable,debuggable:this.debuggable,children:this.children.map(N=>N.toJSON()),providerId:We(this,s).providerId,testId:We(this,s).id}}}class g{constructor(){this.resources=new Map}checkout(A){var N,W;const x=A.toString(),M=(N=this.resources.get(x))!==null&&N!==void 0?N:this.createObserverData(A);return(W=M.pendingDeletion)===null||W===void 0||W.dispose(),M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,onDidDiscoverInitialTests:new T.Emitter().event,get tests(){return M.tests.rootTestItems},dispose:P.once(()=>{--M.observers||(M.pendingDeletion=this.eventuallyDispose(A))})}}getMirroredTestDataByReference(A){for(const{tests:N}of this.resources.values()){const W=N.getMirroredTestDataByReference(A);if(W)return W}}eventuallyDispose(A){return k.disposableTimeout(()=>this.unlisten(A),10*1e3)}createObserverData(A){const N=new l,W=this.listen(A,M=>N.apply(M)),x={observers:0,tests:N,listener:W};return this.resources.set(A.toString(),x),x}unlisten(A){var N;const W=A.toString(),x=this.resources.get(W);x&&(x.observers=-1,(N=x.pendingDeletion)===null||N===void 0||N.dispose(),x.listener.dispose(),this.resources.delete(W))}}class E extends g{constructor(A){super();this.proxy=A,this.diffListeners=new Map}acceptDiff(A,N){var W;(W=this.diffListeners.get(A.toString()))===null||W===void 0||W(N)}listen(A,N){this.proxy.$subscribeToDiffs(0,A);const W=A.toString();return this.diffListeners.set(W,N),new m.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,A),this.diffListeners.delete(W)})}}class b extends g{constructor(A,N){super();this.proxy=A,this.documents=N,this.diffListeners=new Map}acceptDiff(A,N){var W;(W=this.diffListeners.get(A.toString()))===null||W===void 0||W(N)}listen(A,N){if(!this.documents.getDocument(A))return new m.Disposable(()=>{});const x=A.toString();return this.diffListeners.set(x,N),this.proxy.$subscribeToDiffs(1,A),new m.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,A),this.diffListeners.delete(x)})}}}),define(ge[261],pe([0,1,13,54,33,78,22,11,7,23,10,16,2,139,171,85,61,216,259,31]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let a=class{constructor(g,E,b,L){this.configurationService=g,this.workspaceContextService=E,this.editorGroupsService=b,this.pathService=L}text(g,E,b={}){g=this.getContentPattern(g,b);const L=this.configurationService.getValue(),A=E&&E.some(W=>!this.configurationService.getValue({resource:W}).search.useRipgrep),N=this.commonQuery(E==null?void 0:E.map(w.toWorkspaceFolder),b);return Object.assign(Object.assign({},N),{type:2,contentPattern:g,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:L.search.usePCRE2||A||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles})}getContentPattern(g,E){const b=this.configurationService.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const L=Object.assign(Object.assign({},g),{wordSeparators:b.editor.wordSeparators});return this.isCaseSensitive(g,E)&&(L.isCaseSensitive=!0),this.isMultiline(g)&&(L.isMultiline=!0),L}file(g,E={}){const b=this.commonQuery(g,E);return Object.assign(Object.assign({},b),{type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey})}handleIncludeExclude(g,E){return g?(g=Array.isArray(g)?g.map(l):l(g),E?this.parseSearchPaths(g):{pattern:t(...Array.isArray(g)?g:[g])}):{}}commonQuery(g=[],E={}){const b=this.handleIncludeExclude(E.includePattern,E.expandPatterns),L=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),A=g.length>1,N=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(M=>this.getFolderQueryForSearchPath(M,E,L)):g.map(M=>this.getFolderQueryForRoot(M,E,L,A))).filter(M=>!!M),W={_reason:E._reason,folderQueries:N,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:L.pattern,includePattern:b.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const $=_.coalesce(_.flatten(this.editorGroupsService.groups.map(B=>B.editors.map(J=>J.resource)))).filter(B=>s.pathIncludedInQuery(W,B.fsPath)),O=this.commonQueryFromFileList($);return Object.assign(Object.assign({},W),O)}const x=E.extraFileResources&&E.extraFileResources.filter(M=>s.pathIncludedInQuery(W,M.fsPath));return W.extraFileResources=x&&x.length?x:void 0,W}commonQueryFromFileList(g){const E=[],b=new P.ResourceMap,L={};let A=!1;return g.forEach(N=>{var W,x;if(N.scheme!==D.Schemas.walkThrough){const M=n.isAbsolutePath(N),$=N.scheme===D.Schemas.userData;if(M&&!$){const O=(x=(W=this.workspaceContextService.getWorkspaceFolder(N))===null||W===void 0?void 0:W.uri)!==null&&x!==void 0?x:N.with({path:I.dirname(N.fsPath)});let B=b.get(O);B||(A=!0,B={folder:O,includePattern:{}},E.push(B),b.set(O,B));const J=I.relative(O.fsPath,N.fsPath);S.assertIsDefined(B.includePattern)[J.replace(/\\/g,"/")]=!0}else N.fsPath&&(A=!0,L[N.fsPath]=!0)}}),{folderQueries:E,includePattern:L,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(g,E){if(E.isSmartCase){if(g.isRegExp){if(C.containsUppercaseCharacter(g.pattern,!0))return!0}else if(C.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}isMultiline(g){return g.isMultiline||g.isRegExp&&f.isMultilineRegexSource(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const E=O=>I.isAbsolute(O)||/^\.\.?([\/\\]|$)/.test(O),L=(Array.isArray(g)?g:r(g)).map(O=>{const B=this.pathService.resolvedUserHome;return B?T.untildify(O,B.scheme===D.Schemas.file?B.fsPath:B.path):O}),A=k.groupBy(L,O=>E(O)?"searchPaths":"exprSegments"),N=(A.exprSegments||[]).map(O=>C.rtrim(O,"/")).map(O=>C.rtrim(O,"\\")).map(O=>(O[0]==="."&&(O="*"+O),o(O))),W={},x=this.expandSearchPathPatterns(A.searchPaths||[]);x&&x.length&&(W.searchPaths=x);const M=_.flatten(N),$=t(...M);return $&&(W.pattern=$),W}getExcludesForFolder(g,E){return E.disregardExcludeSettings?void 0:s.getExcludes(g,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(g){if(!g||!g.length)return[];const E=_.flatten(g.map(L=>{let{pathPortion:A,globPortion:N}=c(L);N&&(N=i(N));const W=this.expandOneSearchPath(A);return _.flatten(W.map(x=>this.resolveOneSearchPathPattern(x,N)))})),b=new Map;return E.forEach(L=>{const A=L.searchPath.toString(),N=b.get(A);N?L.pattern&&(N.pattern=N.pattern||{},N.pattern[L.pattern]=!0):b.set(A,{searchPath:L.searchPath,pattern:L.pattern?t(L.pattern):void 0})}),Array.from(b.values())}expandOneSearchPath(g){if(I.isAbsolute(g)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==D.Schemas.file?[{searchPath:E[0].uri.with({path:g})}]:[{searchPath:v.URI.file(I.normalize(g))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(g=l(g),g.startsWith("../")||g===".."){const L=I.posix.resolve(E.path,g);return[{searchPath:E.with({path:L})}]}const b=i(g);return[{searchPath:E,pattern:b}]}else{if(g==="./"||g===".\\")return[];{const E=g.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(E){const b=E[1],L=this.workspaceContextService.getWorkspace().folders.filter(A=>A.name===b);if(L.length)return L.map(A=>{const N=E[2];return{searchPath:A.uri,pattern:N&&i(N)}});{const A=u.localize(0,null,b);throw new Error(A)}}}}return[]}resolveOneSearchPathPattern(g,E){const b=g.pattern&&E?`${g.pattern}/${E}`:g.pattern||E,L=[{searchPath:g.searchPath,pattern:b}];return b&&!b.endsWith("**")&&L.push({searchPath:g.searchPath,pattern:b+"/**"}),L}getFolderQueryForSearchPath(g,E,b){const L=this.getFolderQueryForRoot(w.toWorkspaceFolder(g.searchPath),E,b,!1);return L?Object.assign(Object.assign({},L),{includePattern:g.pattern}):null}getFolderQueryForRoot(g,E,b,L){let A;const N=v.URI.isUri(g)?g:g.uri;if(b.searchPaths){const O=b.searchPaths.filter(B=>n.isEqual(B.searchPath,N))[0];if(O&&!O.pattern)return null;O&&(A=O.pattern)}const W=this.configurationService.getValue({resource:N}),x=this.getExcludesForFolder(W,E),M=Object.assign(Object.assign({},x||{}),A||{}),$=v.URI.isUri(g)?n.basename(g):g.name;return{folder:N,folderName:L?$:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!W.search.followSymlinks}}};a=He([Fe(0,m.IConfigurationService),Fe(1,w.IWorkspaceContextService),Fe(2,p.IEditorGroupsService),Fe(3,d.IPathService)],a),e.QueryBuilder=a;function c(y){const g=y.match(/[\*\{\}\(\)\[\]\?]/);if(g){const E=g.index,b=y.substr(0,E).match(/[/|\\][^/\\]*$/);if(b){let L=y.substr(0,b.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:y.substr((b.index||0)+1)}}}return{pathPortion:y}}function t(...y){return y.length?y.reduce((g,E)=>(g[E]=!0,g),Object.create(null)):void 0}function r(y){return R.splitGlobAware(y,",").map(g=>g.trim()).filter(g=>!!g.length)}function o(y){return[`**/${y}/**`,`**/${y}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function l(y){return y.replace(/\\/g,"/")}function i(y){return l(y).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(y,g){y=_.distinct(y,L=>L.toString());const E=[],b=g.getWorkspace();return y&&y.forEach(L=>{let A;if(g.getWorkbenchState()===2)A=n.relativePath(b.folders[0].uri,L),A&&A!=="."&&(A="./"+A);else{const N=g.getWorkspaceFolder(L);if(N){const W=N.name;if(b.folders.filter(M=>M.name===W).length===1){const M=n.relativePath(N.uri,L);M===""?A=`./${N.name}`:A=`./${N.name}/${M}`}else A=L.fsPath}}A&&E.push(A)}),E}e.resolveResourcesForSearchIncludes=h}),define(ge[262],pe([0,1,23,2,21,15,4,261,31,61]),function(Z,e,_,k,R,T,P,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const C=7e3;function S(m,w){const p=w.activationEvents;if(!p)return Promise.resolve(void 0);const d=[],s=[];for(const l of p)if(/^workspaceContains:/.test(l)){const i=l.substr("workspaceContains:".length);i.indexOf("*")>=0||i.indexOf("?")>=0||m.forceUsingSearch?s.push(i):d.push(i)}if(d.length===0&&s.length===0)return Promise.resolve(void 0);let a;const c=new Promise((l,i)=>{a=l}),t=l=>a({activationEvent:l}),r=Promise.all(d.map(l=>v(m,l,t))).then(()=>{}),o=f(m,w.identifier,s,t);return Promise.all([r,o]).then(()=>{a(void 0)}),c}e.checkActivateWorkspaceContainsExtension=S;async function v(m,w,p){for(const d of m.folders)if(await m.exists(_.joinPath(k.URI.revive(d),w))){p(`workspaceContains:${w}`);return}}async function f(m,w,p,d){if(p.length===0)return Promise.resolve(void 0);const s=new R.CancellationTokenSource,a=m.checkExists(m.folders,p,s.token),c=setTimeout(async()=>{s.cancel(),d(`workspaceContainsTimeout:${p.join(",")}`)},C);let t=!1;try{t=await a}catch(r){T.isPromiseCanceledError(r)||T.onUnexpectedError(r)}s.dispose(),clearTimeout(c),t&&d(`workspaceContains:${p.join(",")}`)}function u(m,w,p,d){const s=m.get(P.IInstantiationService),a=m.get(I.ISearchService),t=s.createInstance(D.QueryBuilder).file(w.map(r=>n.toWorkspaceFolder(k.URI.revive(r))),{_reason:"checkExists",includePattern:p,exists:!0});return a.fileSearch(t,d).then(r=>!!r.limitHit,r=>T.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=u}),define(ge[43],pe([0,1,160,7,68,23,19,5,22,2,12,6,37,225,90,32,42,223,15,29,11,27,192,8,113,4,28,91,14,83,51,36,3,262,88,193]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p,d,s,a,c,t,r,o,l,i,h,y,g,E,b,L,A,N,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=l.createDecorator("IHostUtils");let x=class Pi extends D.Disposable{constructor(O,B,J,U,V,z,Q,ae,ce,fe){super();this._onDidChangeRemoteConnectionData=this._register(new L.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=B,this._extHostContext=J,this._initData=Q,this._extHostWorkspace=U,this._extHostConfiguration=V,this._logService=z,this._extHostTunnelService=ce,this._extHostTerminalService=fe,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(S.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(S.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(S.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new P.Barrier,this._readyToStartExtensionHost=new P.Barrier,this._readyToRunExtensions=new P.Barrier,this._registry=new p.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new u.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=ae,this._instaService=O.createChild(new g.ServiceCollection([u.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));const we=new Set;this._initData.hostExtensions.forEach(be=>we.add(s.ExtensionIdentifier.toKey(be))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(be,H)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(be,H)},actualActivateExtension:async(be,H)=>{if(we.has(s.ExtensionIdentifier.toKey(be)))return await this._mainThreadExtensionsProxy.$activateExtension(be,H),new f.HostExtension;const X=this._registry.getExtensionDescription(be);return this._activateExtension(X,H)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),R.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){d.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(V=>V.identifier).filter(V=>this.isActivated(V)).map(V=>this._deactivate(V))}catch(B){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,B){return this._activator.activateByEvent(O,B)}_activateById(O,B){return this._activator.activateById(O,B)}activateByIdWithErrors(O,B){return this._activateById(O,B).then(()=>{const J=this._activator.getActivatedExtension(O);if(J.activationFailed)return Promise.reject(J.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=I.TernarySearchTree.forPaths(),B=this._registry.getAllExtensionDescriptions().map(J=>{if(!!this._getEntryPoint(J))return this._hostUtils.realpath(J.extensionLocation.fsPath).then(U=>O.set(n.URI.file(U).fsPath,J))});this._extensionPathIndex=Promise.all(B).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let B=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return B;const J=this._activator.getActivatedExtension(O);if(!J)return B;try{typeof J.module.deactivate=="function"&&(B=Promise.resolve(J.module.deactivate()).then(void 0,U=>Promise.resolve(void 0)))}catch(U){}try{D.dispose(J.subscriptions)}catch(U){}return B}async _activateExtension(O,B){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,B).then(J=>{const U=J.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,U.codeLoadingTime,U.activateCallTime,U.activateResolvedTime,B),this._logExtensionActivationTimes(O,B,"success",U),J},J=>{throw this._logExtensionActivationTimes(O,B,"failure"),J})}_logExtensionActivationTimes(O,B,J,U){const V=M(O,B);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},V),U||{}),{outcome:J}))}_doActivateExtension(O,B){const J=M(O,B);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",J);const U=this._getEntryPoint(O);if(!U)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(B)}`),this._logService.flush();const V=new f.ExtensionActivationTimesBuilder(B.startup);return Promise.all([this._loadCommonJSModule(O.identifier,T.joinPath(O.extensionLocation,U),V),this._loadExtensionContext(O)]).then(z=>(R.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Pi._callActivate(this._logService,O.identifier,z[0],z[1],V))).then(z=>(R.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),z))}_loadExtensionContext(O){const B=new t.ExtensionGlobalMemento(O,this._storage),J=new t.ExtensionMemento(O.identifier.value,!1,this._storage),U=new W.ExtensionSecrets(O,this._secretState),V=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([B.whenReady,J.whenReady,this._storagePath.whenReady]).then(()=>{const z=this;return Object.freeze({globalState:B,workspaceState:J,secrets:U,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Q){return k.join(O.extensionLocation.fsPath,Q)},get storagePath(){var Q;return(Q=z._storagePath.workspaceValue(O))===null||Q===void 0?void 0:Q.fsPath},get globalStoragePath(){return z._storagePath.globalValue(O).fsPath},get logPath(){return k.join(z._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return n.URI.joinPath(z._initData.logsLocation,O.identifier.value)},get storageUri(){return z._storagePath.workspaceValue(O)},get globalStorageUri(){return z._storagePath.globalValue(O)},get extensionMode(){return V},get extensionRuntime(){return w.checkProposedApiEnabled(O),z.extensionRuntime},get environmentVariableCollection(){return z._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,B,J,U,V){return J=J||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,B,J,U,V).then(z=>new f.ActivatedExtension(!1,null,V.build(),J,z,U.subscriptions))}static _callActivateOptional(O,B,J,U,V){if(typeof J.activate=="function")try{V.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${B.value}`);const z=typeof global=="object"?global:self,Q=J.activate.apply(z,[U]);return V.activateCallStop(),V.activateResolveStart(),Promise.resolve(Q).then(ae=>(V.activateResolveStop(),ae))}catch(z){return Promise.reject(z)}else return Promise.resolve(J)}_activateOneStartupFinished(O,B){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:B}).then(void 0,J=>{this._logService.error(J)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(R.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const B of O.activationEvents)B==="onStartupFinished"&&this._activateOneStartupFinished(O,B)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,V=>{this._logService.error(V)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(V=>this._handleWorkspaceContainsEagerExtensions(V.added)));const B=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],J=this._handleWorkspaceContainsEagerExtensions(B),U=Promise.all([O,J]).then(()=>{});return Promise.race([U,P.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),U}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(B=>this._handleWorkspaceContainsEagerExtension(O,B))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,B){if(!this.isActivated(B.identifier)){const J=!this._initData.remote.isRemote&&!!this._initData.remote.authority,U={folders:O.map(z=>z.uri),forceUsingSearch:J,exists:z=>this._hostUtils.exists(z.fsPath),checkExists:(z,Q,ae)=>this._mainThreadWorkspaceProxy.$checkExists(z,Q,ae)},V=await A.checkActivateWorkspaceContainsExtension(U,B);if(!!V)return this._activateById(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:V.activationEvent}).then(void 0,z=>this._logService.error(z))}}_handleExtensionTests(){return this._doHandleExtensionTests().then(void 0,O=>(console.error(O),Promise.reject(O)))}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:B}=this._initData.environment;if(!(O&&B&&B.scheme===a.Schemas.file))return Promise.resolve(void 0);const J=T.originalFSPath(B);let U,V;try{U=await this._loadCommonJSModule(null,n.URI.file(J),new f.ExtensionActivationTimesBuilder(!1))}catch(z){V=z}return U&&typeof U.run=="function"?new Promise((z,Q)=>{const ae=(fe,we)=>{fe?Q(fe.toString()):z(void 0),this._testRunnerExit(fe||typeof we=="number"&&we>0?1:0)},ce=U.run(J,ae);ce&&ce.then&&ce.then(()=>{z(),this._testRunnerExit(0)}).catch(fe=>{Q(fe.toString()),this._testRunnerExit(1)})}):(this._testRunnerExit(1),Promise.reject(new Error(V?V.toString():_.localize(0,null,J))))}_testRunnerExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.flush();const B=this._mainThreadExtensionsProxy.$onExtensionHostExit(O),J=this._extHostContext.drain();Promise.race([Promise.all([B,J]),P.timeout(5e3)]).then(()=>{this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>this._handleExtensionTests()).then(()=>{this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,B){return this._resolvers[O]=B,D.toDisposable(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,B){const J=O.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const U=O.substr(0,J);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${U}`,!1);const V=this._resolvers[U];if(!V)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${U}.`,detail:void 0}};try{R.mark(`code/extHost/willResolveAuthority/${U}`);const z=await V.resolve(O,{resolveAttempt:B});R.mark(`code/extHost/didResolveAuthorityOK/${U}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(V));const Q={authority:O,host:z.host,port:z.port,connectionToken:z.connectionToken},ae={extensionHostEnv:z.extensionHostEnv};return{type:"ok",value:{authority:Q,options:ae,tunnelInformation:{environmentTunnels:z.environmentTunnels}}}}catch(z){if(R.mark(`code/extHost/didResolveAuthorityError/${U}`),z instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:z._code,message:z._message,detail:z._detail}};throw z}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,B){return B===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(J=>this._activateByEvent(O,!1))}async $activate(O,B){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,B),!0):!1}async $deltaExtensions(O,B){O.forEach(U=>U.extensionLocation=n.URI.revive(U.extensionLocation));const J=await this.getExtensionPathIndex();return await Promise.all(B.map(async U=>{const V=this._registry.getExtensionDescription(U);if(!!V){const z=await this._hostUtils.realpath(V.extensionLocation.fsPath);J.delete(n.URI.file(z).fsPath)}})),await Promise.all(O.map(async U=>{const V=await this._hostUtils.realpath(U.extensionLocation.fsPath);J.set(n.URI.file(V).fsPath,U)})),this._registry.deltaExtensions(O,B),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let B=c.VSBuffer.alloc(O),J=Math.random()%256;for(let U=0;U<O;U++)B.writeUInt8(J,U);return B}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};x=He([Fe(0,l.IInstantiationService),Fe(1,e.IHostUtils),Fe(2,y.IExtHostRpcService),Fe(3,m.IExtHostWorkspace),Fe(4,v.IExtHostConfiguration),Fe(5,C.ILogService),Fe(6,i.IExtHostInitDataService),Fe(7,h.IExtensionStoragePaths),Fe(8,E.IExtHostTunnelService),Fe(9,b.IExtHostTerminalService)],x),e.AbstractExtHostExtensionService=x;function M($,O){return{id:$.identifier.value,name:$.name,extensionVersion:$.version,publisherDisplayName:$.publisher,activationEvents:$.activationEvents?$.activationEvents.join(","):null,isBuiltin:$.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=l.createDecorator("IExtHostExtensionService")}),define(ge[46],pe([0,1,7,2,3,19,6,8,116,32,43,40,215,37,197,14,4,16]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=w.createDecorator("IExtHostDebugService");let d=class{constructor(i,h,y,g,E){this._workspaceService=h,this._extensionService=y,this._editorsService=g,this._configurationService=E,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new R.Emitter,this._onDidTerminateDebugSession=new R.Emitter,this._onDidChangeActiveDebugSession=new R.Emitter,this._onDidReceiveDebugSessionCustomEvent=new R.Emitter,this._debugServiceProxy=i.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new R.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(b=>{b.onDidChange(L=>{this.registerAllDebugTypes(b)}),this.registerAllDebugTypes(b)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole}asDebugSourceUri(i,h){const y=i;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let g=`debug:${encodeURIComponent(y.path||"")}`,E="?";return h&&(g+=`${E}session=${encodeURIComponent(h.id)}`,E="&"),g+=`${E}ref=${y.sourceReference}`,k.URI.parse(g)}else{if(y.path)return k.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const h=[];for(const y of i.getAllExtensionDescriptions())if(y.contributes){const g=y.contributes.debuggers;if(g&&g.length>0)for(const E of g)u.isDebuggerMainContribution(E)&&h.push(E.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(h=>i.push(h)),i}addBreakpoints(i){this.startBreakpoints();const h=i.filter(E=>{const b=E.id;return this._breakpoints.has(b)?!1:(this._breakpoints.set(b,E),!0)});this.fireBreakpointChanges(h,[],[]);const y=[],g=new Map;for(const E of h)if(E instanceof D.SourceBreakpoint){let b=g.get(E.location.uri.toString());b||(b={type:"sourceMulti",uri:E.location.uri,lines:[]},g.set(E.location.uri.toString(),b),y.push(b)),b.lines.push({id:E.id,enabled:E.enabled,condition:E.condition,hitCondition:E.hitCondition,logMessage:E.logMessage,line:E.location.range.start.line,character:E.location.range.start.character})}else E instanceof D.FunctionBreakpoint&&y.push({type:"function",id:E.id,enabled:E.enabled,hitCondition:E.hitCondition,logMessage:E.logMessage,condition:E.condition,functionName:E.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(i){this.startBreakpoints();const h=i.filter(b=>this._breakpoints.delete(b.id));this.fireBreakpointChanges([],h,[]);const y=h.filter(b=>b instanceof D.SourceBreakpoint).map(b=>b.id),g=h.filter(b=>b instanceof D.FunctionBreakpoint).map(b=>b.id),E=h.filter(b=>b instanceof D.DataBreakpoint).map(b=>b.id);return this._debugServiceProxy.$unregisterBreakpoints(y,g,E)}startDebugging(i,h,y){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,h,{parentSessionID:y.parentSession?y.parentSession.id:void 0,repl:y.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,h,y){if(!h)return new D.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:g,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,y,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,g),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(E=>E.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(i,h,y){if(!y)return new D.Disposable(()=>{});if(!this.definesDebugType(i,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:g,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,g),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(E=>E.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(i,h){if(!h)return new D.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:y,factory:h}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==h)})}async $runInTerminal(i){return Promise.resolve(void 0)}async $substituteVariables(i,h){if(!this._variableResolver){const[E,b]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(E||[],this._editorsService,b)}let y;const g=await this.getFolder(i);return g&&(y={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(y,h)}createDebugAdapter(i,h){if(i.type==="implementation")return new r(i.implementation)}createSignService(){}async $startDASession(i,h){const y=this,g=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const b=this.convertToDto(E),L=this.createDebugAdapter(b,g);if(!L)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const A=L;return this._debugAdapters.set(i,A),this.getDebugAdapterTrackers(g).then(N=>(N&&this._debugAdaptersTrackers.set(i,N),A.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const x=W,M={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(x.arguments.value);M.body={signature:$},A.sendResponse(M)}else throw new Error("no signer")}catch($){M.success=!1,M.message=$.message,A.sendResponse(M)}}else N&&N.onDidSendMessage&&N.onDidSendMessage(W),W=u.convertToVSCPaths(W,!0),y._debugServiceProxy.$acceptDAMessage(i,W)}),A.onError(W=>{N&&N.onError&&N.onError(W),this._debugServiceProxy.$acceptDAError(i,W.name,W.message,W.stack)}),A.onExit(W=>{N&&N.onExit&&N.onExit(p.withNullAsUndefined(W),void 0),this._debugServiceProxy.$acceptDAExit(i,p.withNullAsUndefined(W),void 0)}),N&&N.onWillStartSession&&N.onWillStartSession(),A.startSession()))})}$sendDAMessage(i,h){h=u.convertToDAPaths(h,!1);const y=this._debugAdaptersTrackers.get(i);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(h);const g=this._debugAdapters.get(i);g&&g.sendMessage(h)}$stopDASession(i){const h=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),h&&h.onWillStopSession&&h.onWillStopSession();const y=this._debugAdapters.get(i);return this._debugAdapters.delete(i),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const h=[],y=[],g=[];if(i.added)for(const E of i.added){const b=E.id;if(b&&!this._breakpoints.has(b)){let L;if(E.type==="function")L=new D.FunctionBreakpoint(E.functionName,E.enabled,E.condition,E.hitCondition,E.logMessage);else if(E.type==="data")L=new D.DataBreakpoint(E.label,E.dataId,E.canPersist,E.enabled,E.hitCondition,E.condition,E.logMessage);else{const A=k.URI.revive(E.uri);L=new D.SourceBreakpoint(new D.Location(A,new D.Position(E.line,E.character)),E.enabled,E.condition,E.hitCondition,E.logMessage)}L._id=b,this._breakpoints.set(b,L),h.push(L)}}if(i.removed)for(const E of i.removed){const b=this._breakpoints.get(E);b&&(this._breakpoints.delete(E),y.push(b))}if(i.changed){for(const E of i.changed)if(E.id){const b=this._breakpoints.get(E.id);if(b){if(b instanceof D.FunctionBreakpoint&&E.type==="function"){const L=b;L.enabled=E.enabled,L.condition=E.condition,L.hitCondition=E.hitCondition,L.logMessage=E.logMessage,L.functionName=E.functionName}else if(b instanceof D.SourceBreakpoint&&E.type==="source"){const L=b;L.enabled=E.enabled,L.condition=E.condition,L.hitCondition=E.hitCondition,L.logMessage=E.logMessage,L.location=new D.Location(k.URI.revive(E.uri),new D.Position(E.line,E.character))}g.push(b)}}}this.fireBreakpointChanges(h,y,g)}$provideDebugConfigurations(i,h,y){return T.asPromise(async()=>{const g=this.getConfigProviderByHandle(i);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const E=await this.getFolder(h);return g.provideDebugConfigurations(E,y)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(i,h,y,g){return T.asPromise(async()=>{const E=this.getConfigProviderByHandle(i);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const b=await this.getFolder(h);return E.resolveDebugConfiguration(b,y,g)})}$resolveDebugConfigurationWithSubstitutedVariables(i,h,y,g){return T.asPromise(async()=>{const E=this.getConfigProviderByHandle(i);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const b=await this.getFolder(h);return E.resolveDebugConfigurationWithSubstitutedVariables(b,y,g)})}async $provideDebugAdapter(i,h){const y=this.getAdapterDescriptorFactoryByHandle(i);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(h);return this.getAdapterDescriptor(y,g).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(E)})}async $acceptDebugSessionStarted(i){const h=await this.getSession(i);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(i){const h=await this.getSession(i);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,h){const y=await this.getSession(i);y&&y._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(i,h){const g={session:await this.getSession(i),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(i){if(i instanceof D.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof D.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const h=this._adapterFactories.filter(y=>y.type===i);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(i){const h=this._adapterFactories.filter(y=>y.handle===i);if(h.length>0)return h[0].factory}getConfigProviderByHandle(i){const h=this._configProviders.filter(y=>y.handle===i);if(h.length>0)return h[0].provider}definesDebugType(i,h){if(i.contributes){const y=i.contributes.debuggers;if(y&&y.length>0){for(const g of y)if(g.label&&g.type&&g.type===h)return!0}}return!1}getDebugAdapterTrackers(i){const y=i.configuration.type,g=this._trackerFactories.filter(E=>E.type===y||E.type==="*").map(E=>T.asPromise(()=>E.factory.createDebugAdapterTracker(i)).then(b=>b,b=>null));return Promise.race([Promise.all(g).then(E=>{const b=E.filter(L=>!!L);if(b.length>0)return new t(b)}),new Promise((E,b)=>{const L=setTimeout(()=>{clearTimeout(L),b(new Error("timeout"))},1e3)})]).catch(E=>{})}async getAdapterDescriptor(i,h){const y=h.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new D.DebugAdapterServer(y));if(i){const E=await this._extensionService.getExtensionRegistry();return T.asPromise(()=>i.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,E))).then(b=>{if(b)return b})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,g))}daExecutableFromPackage(i,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,h,y){(i.length>0||h.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:h,changed:y}))}async getSession(i){if(i)if(typeof i=="string"){const h=this._debugSessions.get(i);if(h)return h}else{let h=this._debugSessions.get(i.id);if(!h){const y=await this.getFolder(i.folderUri);h=new s(this._debugServiceProxy,i.id,i.type,i.name,y,i.configuration),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(i){if(i){const h=k.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};d=He([Fe(0,m.IExtHostRpcService),Fe(1,n.IExtHostWorkspace),Fe(2,C.IExtHostExtensionService),Fe(3,S.IExtHostDocumentsAndEditors),Fe(4,f.IExtHostConfiguration)],d),e.ExtHostDebugServiceBase=d;class s{constructor(i,h,y,g,E,b){this._debugServiceProxy=i,this._id=h,this._type=y,this._name=g,this._workspaceFolder=E,this._configuration=b}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,h)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=s;class a{constructor(i){this._debugServiceProxy=i}append(i){this._debugServiceProxy.$appendDebugConsole(i)}appendLine(i){this.append(i+`
`)}}e.ExtHostDebugConsole=a;class c extends v.AbstractVariableResolverService{constructor(i,h,y,g,E){super({getFolderUri:b=>{const L=i.filter(A=>A.name===b);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>i.length,getConfigurationValue:(b,L)=>y.getConfiguration(void 0,b).get(L),getExecPath:()=>g?g.VSCODE_EXEC_PATH:void 0,getFilePath:()=>{if(h){const b=h.activeEditor();if(b)return _.normalize(b.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(h&&E){const b=h.activeEditor();if(b){const L=E.getWorkspaceFolder(b.document.uri);if(L)return _.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(h){const b=h.activeEditor();if(b&&!b.selection.isEmpty)return b.document.getText(b.selection)}},getLineNumber:()=>{if(h){const b=h.activeEditor();if(b)return String(b.selection.end.line+1)}}},void 0,g)}}e.ExtHostVariableResolverService=c;class t{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(h=>h.onError?h.onError(i):void 0)}onExit(i,h){this.trackers.forEach(y=>y.onExit?y.onExit(i,h):void 0)}}class r extends I.AbstractDebugAdapter{constructor(i){super();this.implementation=i,i.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends d{constructor(i,h,y,g,E){super(i,h,y,g,E)}createVariableResolver(i,h,y){return new c(i,h,y)}};o=He([Fe(0,m.IExtHostRpcService),Fe(1,n.IExtHostWorkspace),Fe(2,C.IExtHostExtensionService),Fe(3,S.IExtHostDocumentsAndEditors),Fe(4,f.IExtHostConfiguration)],o),e.WorkerExtHostDebugService=o}),define(ge[263],pe([0,1,68,2,6,37,42,29,14,28,4,43,38,12]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(s,a,c,t,r,o,l){this._apiFactory=s,this._extensionRegistry=a,this._instaService=c,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=o,this._logService=l,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,a,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(p,a,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let a of s.nodeModuleName)this._factories.set(a,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(a=>s.alternativeModuleName(a))}};u=He([Fe(2,C.IInstantiationService),Fe(3,T.IExtHostConfiguration),Fe(4,S.IExtHostExtensionService),Fe(5,n.IExtHostInitDataService),Fe(6,f.ILogService)],u),e.RequireInterceptor=u;class m{constructor(s,a,c,t,r){this._apiFactory=s,this._extensionPaths=a,this._extensionRegistry=c,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,a){const c=this._extensionPaths.findSubstr(a.fsPath);if(c){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(c.identifier));return t||(t=this._apiFactory(c,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(c.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,o)=>t+=`	${o} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(P.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(s,a){this.nodeModuleName="keytar";const{environment:c}=a,t=s.getProxy(R.MainContext.MainThreadKeytar);if(c.appRoot){let r=c.appRoot.fsPath;v.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,o)=>t.$getPassword(r,o),setPassword:(r,o,l)=>t.$setPassword(r,o,l),deletePassword:(r,o)=>t.$deletePassword(r,o),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(s,a){return this._impl}alternativeModuleName(s){const a=s.length;if(!(a<=7||!this.alternativeNames)){const c=a-7;if((s.charAt(c)==="/"||s.charAt(c)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}}};w=He([Fe(0,I.IExtHostRpcService),Fe(1,n.IExtHostInitDataService)],w);let p=class{constructor(s,a,c){this._extensionPaths=s,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=c.getProxy(R.MainContext.MainThreadTelemetry);const t=c.getProxy(R.MainContext.MainThreadWindow);this._impl=(r,o)=>{const l=k.URI.parse(r);return o?this.callOriginal(r,o):l.scheme==="http"||l.scheme==="https"?t.$openUri(l,r,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this._appUriScheme?t.$openUri(l,r,{}):this.callOriginal(r,o)}}load(s,a,c){const t=this._extensionPaths.findSubstr(a.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=c(s),this._impl}callOriginal(s,a){return this.sendNoForwardTelemetry(),this._original(s,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};p=He([Fe(2,I.IExtHostRpcService)],p)}),define(ge[264],pe([0,1,166,8,198,32,43,40,37,36,14,46,187,201,19]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let m=class extends S.ExtHostDebugServiceBase{constructor(d,s,a,c,t,r){super(d,s,a,c,t);this._terminalService=r,this._integratedTerminalInstances=new w}createDebugAdapter(d,s){switch(d.type){case"server":return new R.SocketDebugAdapter(d);case"pipeServer":return new R.NamedPipeDebugAdapter(d);case"executable":return new R.ExecutableDebugAdapter(d,s.type)}return super.createDebugAdapter(d,s)}daExecutableFromPackage(d,s){const a=R.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),d.type);if(a)return new k.DebugAdapterExecutable(a.command,a.args,a.options)}createSignService(){return new v.SignService}async $runInTerminal(d){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(y=>{this._integratedTerminalInstances.onTerminalClosed(y)}));const s=await this._configurationService.getConfigProvider(),a=this._terminalService.getDefaultShell(!0,s),c=this._terminalService.getDefaultShellArgs(!0,s),t=JSON.stringify({shell:a,shellArgs:c});let r=await this._integratedTerminalInstances.checkout(t),o,l=!1;if(r)o=d.cwd;else{const y={shellPath:a,shellArgs:c,cwd:d.cwd,name:d.title||_.localize(0,null)};l=!0,r=this._terminalService.createTerminalFromOptions(y,!0),this._integratedTerminalInstances.insert(r,t)}r.show(!0);const i=await r.processId;l&&await new Promise(y=>setTimeout(y,1e3));const h=f.prepareCommand(a,d.args,o,d.env);return r.sendText(h,!0),i}else if(d.kind==="external")return f.runInExternalTerminal(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d)}createVariableResolver(d,s,a){return new S.ExtHostVariableResolverService(d,s,a,process.env,this._workspaceService)}};m=He([Fe(0,C.IExtHostRpcService),Fe(1,T.IExtHostWorkspace),Fe(2,P.IExtHostExtensionService),Fe(3,D.IExtHostDocumentsAndEditors),Fe(4,I.IExtHostConfiguration),Fe(5,n.IExtHostTerminalService)],m),e.ExtHostDebugService=m;class w{constructor(){this._terminalInstances=new Map}async checkout(d){const a=[...this._terminalInstances.keys()].map(c=>u.createCancelablePromise(async t=>{const r=await c.processId;if(await f.hasChildProcesses(r))return null;const o=Date.now(),l=this._terminalInstances.get(c);return!l||l.lastUsedAt+w.minUseDelay>o||t.isCancellationRequested||l.config!==d?null:(l.lastUsedAt=o,c)}));return await u.firstParallel(a,c=>!!c)}insert(d,s){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:s})}onTerminalClosed(d){this._terminalInstances.delete(d)}}w.minUseDelay=1e3}),define(ge[265],pe([0,1,7,2,80,32,46,40,37,36,14,28,67,11,12,64]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends v.ExtHostTaskBase{constructor(d,s,a,c,t,r,o,l){super(d,s,a,c,t,r,o,l);this.workspaceService=a,s.remote.isRemote&&s.remote.authority&&this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(d,s){const a=s;if(!s.execution&&a._id===void 0)throw new Error("Tasks to execute must include an execution");if(a._id!==void 0){const c=v.TaskHandleDTO.from(a,this.workspaceService),t=await this._proxy.$getTaskExecution(c);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(t,s);return this._proxy.$executeTask(c).catch(()=>{}),r}else{const c=v.TaskDTO.from(s,d);if(c===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(c.execution)&&await this.addCustomExecution(c,s,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(c),s);return this._proxy.$executeTask(c).catch(()=>{}),t}}provideTasksInternal(d,s,a,c){const t=[];if(c)for(let r of c){this.checkDeprecation(r,a),(!r.definition||!d[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const o=v.TaskDTO.from(r,a.extension);o&&(t.push(o),v.CustomExecutionDTO.is(o.execution)&&s.push(this.addCustomExecution(o,r,!0)))}return{tasks:t,extension:a.extension}}async resolveTaskInternal(d){return d}async getVariableResolver(d){if(this._variableResolver===void 0){const s=await this._configurationService.getConfigProvider();this._variableResolver=new P.ExtHostVariableResolverService(d,this._editorService,s,process.env,this.workspaceService)}return this._variableResolver}async $resolveVariables(d,s){const a=k.URI.revive(d),c={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(a),r=await this._workspaceProvider.getWorkspaceFolders2();if(!r||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const o=await this.getVariableResolver(r),l={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let i of s.variables)c.variables[i]=o.resolve(l,i);if(s.process!==void 0){let i;if(s.process.path!==void 0){i=s.process.path.split(_.delimiter);for(let h=0;h<i.length;h++)i[h]=o.resolve(l,i[h])}c.process=await R.win32.findExecutable(o.resolve(l,s.process.name),s.process.cwd!==void 0?o.resolve(l,s.process.cwd):void 0,i)}return c}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(d,s,a){return R.win32.findExecutable(d,s,a)}};w=He([Fe(0,C.IExtHostRpcService),Fe(1,S.IExtHostInitDataService),Fe(2,T.IExtHostWorkspace),Fe(3,D.IExtHostDocumentsAndEditors),Fe(4,I.IExtHostConfiguration),Fe(5,n.IExtHostTerminalService),Fe(6,u.ILogService),Fe(7,m.IExtHostApiDeprecationService)],w),e.ExtHostTask=w}),define(ge[266],pe([0,1,34,2,9,212,37,12,213,32,46,40,119,120,36,14,208,28,16,148,26]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p,d,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let c=class extends u.BaseExtHostTerminalService{constructor(r,o,l,i,h,y){super(!0,r);this._extHostConfiguration=o,this._extHostWorkspace=l,this._extHostDocumentsAndEditors=i,this._logService=h,this._extHostInitDataService=y,this._isWorkspaceShellAllowed=!1,s.getSystemShell(R.platform).then(g=>this._defaultShell=g),this._updateLastActiveWorkspace(),this._updateVariableResolver(),this._registerListeners()}createTerminal(r,o,l){const i=new u.ExtHostTerminal(this._proxy,a.generateUuid(),{name:r,shellPath:o,shellArgs:l},r);return this._terminals.push(i),i.create(o,l),i}createTerminalFromOptions(r,o){const l=new u.ExtHostTerminal(this._proxy,a.generateUuid(),r,r.name);return this._terminals.push(l),l.create(d.withNullAsUndefined(r.shellPath),d.withNullAsUndefined(r.shellArgs),d.withNullAsUndefined(r.cwd),d.withNullAsUndefined(r.env),void 0,d.withNullAsUndefined(r.strictEnv),d.withNullAsUndefined(r.hideFromUser),d.withNullAsUndefined(o)),l}getDefaultShell(r,o){var l;const i=h=>{const y=o.getConfiguration(h.substr(0,h.lastIndexOf("."))).inspect(h.substr(h.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(y)};return T.getDefaultShell(i,this._isWorkspaceShellAllowed,(l=this._defaultShell)!==null&&l!==void 0?l:s.getSystemShellSync(R.platform),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,T.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,r)}getDefaultShellArgs(r,o){const l=i=>{const h=o.getConfiguration(i.substr(0,i.lastIndexOf("."))).inspect(i.substr(i.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(h)};return T.getDefaultShellArgs(l,this._isWorkspaceShellAllowed,r,T.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_apiInspectConfigToPlain(r){return{userValue:r?r.globalValue:void 0,value:r?r.workspaceValue:void 0,defaultValue:r?r.defaultValue:void 0}}async _getNonInheritedEnv(){const r=await f.getMainProcessParentEnv();return r.VSCODE_IPC_HOOK_CLI=process.env.VSCODE_IPC_HOOK_CLI,r}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>this._updateVariableResolver())}_updateLastActiveWorkspace(){const r=this._extHostDocumentsAndEditors.activeEditor();r&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(r.document.uri))}async _updateVariableResolver(){const r=await this._extHostConfiguration.getConfigProvider(),o=await this._extHostWorkspace.getWorkspaceFolders2();this._variableResolver=new C.ExtHostVariableResolverService(o||[],this._extHostDocumentsAndEditors,r,process.env)}async $spawnExtHostProcess(r,o,l,i,h,y){const g={name:o.name,executable:o.executable,args:o.args,cwd:typeof o.cwd=="string"?o.cwd:k.URI.revive(o.cwd),env:o.env,flowControl:o.flowControl},E=R.isWindows?"windows":R.isMacintosh?"osx":"linux",b=await this._extHostConfiguration.getConfigProvider();if(!g.executable)g.executable=this.getDefaultShell(!1,b),g.args=this.getDefaultShellArgs(!1,b);else if(this._variableResolver&&(g.executable=this._variableResolver.resolve(this._lastActiveWorkspace,g.executable),g.args))if(Array.isArray(g.args)){const U=[];for(const V of g.args)U.push(this._variableResolver.resolve(this._lastActiveWorkspace,V));g.args=U}else g.args=this._variableResolver.resolve(this._lastActiveWorkspace,g.args);const L=k.URI.revive(l);let A;if(l&&L){const U=await this._extHostWorkspace.getWorkspaceFolder(L);U&&(A={uri:U.uri,name:U.name,index:U.index,toResource:()=>{throw new Error("Not implemented")}})}const N=b.getConfiguration("terminal.integrated"),W=T.getCwd(g,_.homedir(),T.createVariableResolver(A,this._variableResolver),L,N.cwd,this._logService);g.cwd=W;const x=this._apiInspectConfigToPlain(b.getConfiguration("terminal.integrated").inspect(`env.${E}`)),M=N.get("inheritEnv",!0)?process.env:await this._getNonInheritedEnv(),$=T.createTerminalEnvironment(g,x,T.createVariableResolver(A,this._variableResolver),y,this._extHostInitDataService.version,N.get("detectLocale","auto"),M);g.strictEnv||new w.MergedEnvironmentVariableCollection(this._environmentVariableCollections).applyToProcessEnvironment($),this._proxy.$sendResolvedLaunchConfig(r,g),this._logService.debug("Terminal process launching on ext host",{shellLaunchConfig:g,initialCwd:W,cols:i,rows:h,env:$});const O=!1,B=new I.TerminalProcess(g,W,i,h,$,process.env,O,this._logService);this._setupExtHostProcessListeners(r,B);const J=await B.start();if(J)return J}$getAvailableShells(){return v.detectAvailableShells()}async $getDefaultShellAndArgs(r){const o=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(r,o),args:this.getDefaultShellArgs(r,o)}}$acceptWorkspacePermissionsChanged(r){this._isWorkspaceShellAllowed=r}};c=He([Fe(0,m.IExtHostRpcService),Fe(1,P.IExtHostConfiguration),Fe(2,n.IExtHostWorkspace),Fe(3,S.IExtHostDocumentsAndEditors),Fe(4,D.ILogService),Fe(5,p.IExtHostInitDataService)],c),e.ExtHostTerminalService=c}),define(ge[267],pe([0,1,19,15,68,5,2,6,255,12,81,83,28,182,14,63,43,36]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{constructor(a,c,t,r){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new I.RPCProtocol(a,null,r);c=d._transform(c,o);const l=new S.ServiceCollection(...C.getSingletonServiceDescriptors());l.set(v.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},c)),l.set(u.IExtHostRpcService,new u.ExtHostRpcService(o)),l.set(m.IURITransformerService,new m.URITransformerService(r)),l.set(w.IHostUtils,t);const i=new f.InstantiationService(l,!0),h=i.invokeFunction(b=>b.get(p.IExtHostTerminalService));this._disposables.add(h),this._logService=i.invokeFunction(b=>b.get(n.ILogService)),R.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",c),this._extensionService=i.invokeFunction(b=>b.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const y=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(L,A)=>{let N="",W,x;for(const M of A)N+=`
	at ${M.toString()}`,x=M.getFileName(),!W&&x&&(W=b.findSubstr(x));return y.set(L,W),`${L.name||"Error"}: ${L.message||""}${N}`}});const g=o.getProxy(D.MainContext.MainThreadExtensionService),E=o.getProxy(D.MainContext.MainThreadErrors);k.setUnexpectedErrorHandler(b=>{const L=k.transformErrorForSerialization(b),A=y.get(b);A?g.$onExtensionRuntimeError(A.identifier,L):E.$onUnexpectedError(L)})}terminate(a){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${a}`),this._logService.flush(),this._disposables.dispose(),k.setUnexpectedErrorHandler(t=>{});const c=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([_.timeout(4e3),c]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(a,c){a.extensions.forEach(r=>r.extensionLocation=P.URI.revive(c.transformIncomingURIs(r.extensionLocation))),a.environment.appRoot=P.URI.revive(c.transformIncomingURIs(a.environment.appRoot));const t=a.environment.extensionDevelopmentLocationURI;return t&&(a.environment.extensionDevelopmentLocationURI=t.map(r=>P.URI.revive(c.transformIncomingURIs(r)))),a.environment.extensionTestsLocationURI=P.URI.revive(c.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=P.URI.revive(c.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=P.URI.revive(c.transformIncomingURIs(a.environment.workspaceStorageHome)),a.logsLocation=P.URI.revive(c.transformIncomingURIs(a.logsLocation)),a.logFile=P.URI.revive(c.transformIncomingURIs(a.logFile)),a.workspace=c.transformIncomingURIs(a.workspace),a}}e.ExtensionHostMain=d}),define(ge[268],pe([0,1,7,21,49,33,23,47,31,38]),function(Z,e,_,k,R,T,P,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(f,u,m){this.config=f,this.provider=u,this.sessionToken=m,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&T.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&T.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const u=this.config.folderQueries||[];return new Promise((m,w)=>{const p=d=>{this.resultCount++,f(d)};if(this.isCanceled)return m({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(d=>{const s=d.toString(),a=_.basename(s);this.globalExcludePattern&&this.globalExcludePattern(s,a)||this.matchFile(p,{base:d,basename:a})}),Promise.all(u.map(d=>this.searchInFolder(d,p))).then(d=>{m({limitHit:this.isLimitHit,stats:d[0]||void 0})},d=>{w(new Error(R.toErrorMessage(d)))})})}searchInFolder(f,u){const m=new k.CancellationTokenSource;return new Promise((w,p)=>{const d=this.getSearchOptionsForFolder(f),s=this.initDirectoryTree(),a=new I.QueryGlobTester(this.config,f),c=!a.hasSiblingExcludeClauses();let t;new Promise(r=>n.nextTick(r)).then(()=>(this.activeCancellationTokens.add(m),t=D.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,m.token))).then(r=>{const o=t.elapsed(),l=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(i=>{const h=_.posix.relative(f.folder.path,i.path);if(c){const y=_.basename(i.path);this.matchFile(u,{base:f.folder,relativePath:h,basename:y});return}this.addDirectoryEntries(s,f.folder,h,u)}),this.activeCancellationTokens.delete(m),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(s,a,u),{providerTime:o,postProcessTime:l.elapsed()})}).then(r=>{m.dispose(),w(r)},r=>{m.dispose(),p(r)})})}getSearchOptionsForFolder(f){const u=I.resolvePatternsForProvider(this.config.includePattern,f.includePattern),m=I.resolvePatternsForProvider(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:m,includes:u,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},u,m,w){if(m===this.filePattern){const d=_.basename(this.filePattern);this.matchFile(w,{base:u,relativePath:this.filePattern,basename:d})}function p(d){const s=_.basename(d),a=_.dirname(d);let c=f[a];c||(c=f[a]=[],p(a)),c.push({base:u,relativePath:d,basename:s})}p(m)}matchDirectoryTree({rootEntries:f,pathToEntries:u},m,w){const p=this,d=this.filePattern;function s(a){const c=T.hasSiblingFn(()=>a.map(t=>t.basename));for(let t=0,r=a.length;t<r;t++){const o=a[t],{relativePath:l,basename:i}=o;if(!!m.includedInQuerySync(l,i,d!==i?c:void 0)){const h=u[l];if(h)s(h);else{if(l===d)continue;p.matchFile(w,o)}if(p.isLimitHit)break}}}s(f)}matchFile(f,u){(!this.includePattern||u.relativePath&&this.includePattern(u.relativePath,u.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(u))}}class S{constructor(){this.sessions=new Map}fileSearch(f,u,m,w){const p=this.getSessionTokenSource(f.cacheKey),d=new C(f,u,p&&p.token);let s=0;const a=c=>{s+=c.length,m(c.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(d,S.BATCH_SIZE,a,w).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:s,detailStats:c.stats}}))}clearCache(f){const u=this.getSessionTokenSource(f);u&&u.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new k.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:P.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,u,m,w){w.onCancellationRequested(()=>{f.cancel()});const p=s=>{s&&(d.push(s),u>0&&d.length>=u&&(m(d),d=[]))};let d=[];return f.search(p).then(s=>(d.length&&m(d),s),s=>(d.length&&m(d),Promise.reject(s)))}}e.FileSearchManager=S,S.BATCH_SIZE=512}),define(ge[125],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class _{constructor(T,P){this.line=T,this.character=P}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,P){return new _(0,0)}with(T){return new _(0,0)}}e.Position=_;class k{constructor(T,P,D,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new _(T,P),this.end=new _(D,I)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new k(0,0,0,0)}with(T){return new k(0,0,0,0)}}e.Range=k}),define(ge[126],pe([0,1,7,13,21,49,23,33,2,31,38,11]),function(Z,e,_,k,R,T,P,D,I,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class v{constructor(s,a,c){this.query=s,this.provider=a,this.fileUtils=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,a){const c=this.query.folderQueries||[],t=new R.CancellationTokenSource;return a.onCancellationRequested(()=>t.cancel()),new Promise((r,o)=>{this.collector=new u(s);let l=!1;const i=(h,y)=>{if(!l&&!this.isLimitHit){const g=this.resultSize(h);w(h)&&typeof this.query.maxResults=="number"&&this.resultCount+g>this.query.maxResults&&(this.isLimitHit=!0,l=!0,t.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const E=this.resultSize(h);this.resultCount+=E,(E>0||!w(h))&&this.collector.add(h,y)}};Promise.all(c.map((h,y)=>this.searchInFolder(h,g=>i(g,y),t.token))).then(h=>{t.dispose(),this.collector.flush();const y=h.some(g=>!!g&&!!g.limitHit);r({limitHit:this.isLimitHit||y,stats:{type:"textSearchProvider"}})},h=>{t.dispose();const y=T.toErrorMessage(h);o(new Error(y))})})}resultSize(s){return w(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,a){const c=Array.isArray(s.ranges)?s.ranges:[s.ranges],t=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:c.slice(0,a),preview:{matches:t.slice(0,a),text:s.preview.text},uri:s.uri}}searchInFolder(s,a,c){const t=new n.QueryGlobTester(this.query,s),r=[],o={report:i=>{if(!!this.validateProviderResult(i)){const h=s.folder.scheme===S.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(P.dirname(i.uri))):void 0,y=P.relativePath(s.folder,i.uri);y&&r.push(t.includedInQuery(y,_.basename(y),h).then(g=>{g&&a(i)}))}}},l=this.getSearchOptionsForFolder(s);return new Promise(i=>C.nextTick(i)).then(()=>this.provider.provideTextSearchResults(f(this.query.contentPattern),l,o,c)).then(i=>Promise.all(r).then(()=>i))}validateProviderResult(s){if(w(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const a=n.resolvePatternsForProvider(this.query.includePattern,s.includePattern),c=n.resolvePatternsForProvider(this.query.excludePattern,s.excludePattern),t={folder:I.URI.from(s.folder),excludes:c,includes:a,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=v;function f(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class u{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,a=>this.sendItems(a))}add(s,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!P.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(m(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=u;function m(d){return w(d)?{preview:{matches:k.mapArrayOrNot(d.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:d.preview.text},ranges:k.mapArrayOrNot(d.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function w(d){return!!d.preview}e.extensionResultIsMatch=w;class p{constructor(s,a){this.maxBatchSize=s,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,a){!s||this.addItemToBatch(s,a)}addItems(s,a){!s||this.addItemsToBatch(s,a)}addItemToBatch(s,a){this.batch.push(s),this.batchSize+=a,this.onUpdate()}addItemsToBatch(s,a){this.batch=this.batch.concat(s),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<p.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},p.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=p,p.TIMEOUT=4e3,p.START_BATCH_AFTER_COUNT=50}),define(ge[69],pe([0,1,5,6,4,268,14,63,12,2,126]),function(Z,e,_,k,R,T,P,D,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=R.createDecorator("IExtHostSearch");let S=class{constructor(m,w,p){this.extHostRpc=m,this._uriTransformer=w,this._logService=p,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,w){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const p=this._handlePool++;return this._textSearchProvider.set(p,w),this._proxy.$registerTextSearchProvider(p,this._transformScheme(m)),_.toDisposable(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}registerFileSearchProvider(m,w){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const p=this._handlePool++;return this._fileSearchProvider.set(p,w),this._proxy.$registerFileSearchProvider(p,this._transformScheme(m)),_.toDisposable(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}$provideFileSearchResults(m,w,p,d){const s=v(p),a=this._fileSearchProvider.get(m);if(a)return this._fileSearchManager.fileSearch(s,a,c=>{this._proxy.$handleFileMatch(m,w,c.map(t=>t.resource))},d);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,w,p,d){const s=this._textSearchProvider.get(m);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const a=v(p);return this.createTextSearchManager(a,s).search(t=>this._proxy.$handleTextMatch(m,w,t),d)}createTextSearchManager(m,w){return new C.TextSearchManager(m,w,{readdir:p=>Promise.resolve([]),toCanonicalName:p=>p})}};S=He([Fe(0,P.IExtHostRpcService),Fe(1,D.IURITransformerService),Fe(2,I.ILogService)],S),e.ExtHostSearch=S;function v(u){return Object.assign(Object.assign({},u),{folderQueries:u.folderQueries&&u.folderQueries.map(f),extraFileResources:u.extraFileResources&&u.extraFileResources.map(m=>n.URI.revive(m))})}e.reviveQuery=v;function f(u){return Object.assign(Object.assign({},u),{folder:n.URI.revive(u.folder)})}}),define(ge[269],pe([0,1,157,21,15,3,7,76,2,150,105,140,79,50,6,231,230,52,232,37,233,234,235,218,236,40,43,237,219,239,240,241,65,220,243,244,245,90,36,246,221,20,8,249,66,124,32,42,23,54,194,238,114,123,67,46,69,12,63,14,28,242,205,51,64,228,247,203,91,89,252,250,251,229,62,260,248,88,191]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p,d,s,a,c,t,r,o,l,i,h,y,g,E,b,L,A,N,W,x,M,$,O,B,J,U,V,z,Q,ae,ce,fe,we,be,H,X,re,Y,le,ve,De,Me,Ee,Pe,Ce,Oe,Se,Be,K,se,_e,Ae,Ue,ze,je,ue,ye,Ne,ee,te,G,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ie(me){const ke=me.get(Pe.IExtHostInitDataService),Re=me.get(Ne.IExtHostFileSystemInfo),xe=me.get(Ue.IExtHostConsumerFileSystem),qe=me.get(i.IExtHostExtensionService),Ge=me.get(ae.IExtHostWorkspace),Ke=me.get(s.IExtHostConfiguration),st=me.get(Me.IURITransformerService),$e=me.get(Ee.IExtHostRpcService),Xe=me.get(M.IExtHostStorage),ft=me.get(Ae.IExtensionStoragePaths),et=me.get(De.ILogService),mt=me.get(Se.IExtHostTunnelService),ot=me.get(Be.IExtHostApiDeprecationService),Ze=me.get(Q.IExtHostWindow),St=me.get(G.IExtHostSecretState);$e.set(u.ExtHostContext.ExtHostFileSystemInfo,Re),$e.set(u.ExtHostContext.ExtHostLogService,et),$e.set(u.ExtHostContext.ExtHostWorkspace,Ge),$e.set(u.ExtHostContext.ExtHostConfiguration,Ke),$e.set(u.ExtHostContext.ExtHostExtensionService,qe),$e.set(u.ExtHostContext.ExtHostStorage,Xe),$e.set(u.ExtHostContext.ExtHostTunnelService,mt),$e.set(u.ExtHostContext.ExtHostWindow,Ze),$e.set(u.ExtHostContext.ExtHostSecretState,St);const _t=$e.set(u.ExtHostContext.ExtHostDecorations,me.get(re.IExtHostDecorations)),gt=$e.set(u.ExtHostContext.ExtHostDocumentsAndEditors,me.get(l.IExtHostDocumentsAndEditors)),at=$e.set(u.ExtHostContext.ExtHostCommands,me.get(p.IExtHostCommands)),ut=$e.set(u.ExtHostContext.ExtHostTerminalService,me.get($.IExtHostTerminalService)),rt=$e.set(u.ExtHostContext.ExtHostDebugService,me.get(le.IExtHostDebugService)),kt=$e.set(u.ExtHostContext.ExtHostSearch,me.get(ve.IExtHostSearch)),wt=$e.set(u.ExtHostContext.ExtHostTask,me.get(Y.IExtHostTask)),Et=$e.set(u.ExtHostContext.ExtHostOutputService,me.get(L.IExtHostOutputService)),pt=$e.set(u.ExtHostContext.ExtHostEditorTabs,new F.ExtHostEditorTabs),yt=$e.set(u.ExtHostContext.ExtHostUrls,new V.ExtHostUrls($e)),vt=$e.set(u.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments($e,gt)),Ct=$e.set(u.ExtHostContext.ExtHostDocumentContentProviders,new t.ExtHostDocumentContentProvider($e,gt,et)),Pt=$e.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(et,vt,$e.getProxy(u.MainContext.MainThreadBulkEdits))),tt=$e.set(u.ExtHostContext.ExtHostNotebook,new Ce.ExtHostNotebookController($e,at,gt,ke.environment,et,ft)),bt=$e.set(u.ExtHostContext.ExtHostEditors,new O.ExtHostEditors($e,gt)),Ut=$e.set(u.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews($e.getProxy(u.MainContext.MainThreadTreeViews),at,et)),Bt=$e.set(u.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets($e.getProxy(u.MainContext.MainThreadEditorInsets),bt,ke.environment)),xt=$e.set(u.ExtHostContext.ExtHostDiagnostics,new a.ExtHostDiagnostics($e,et)),it=$e.set(u.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures($e,st,vt,at,xt,et,ot)),zt=$e.set(u.ExtHostContext.ExtHostFileSystem,new h.ExtHostFileSystem($e,it)),It=$e.set(u.ExtHostContext.ExtHostFileSystemEventService,new y.ExtHostFileSystemEventService($e,et,gt)),Lt=$e.set(u.ExtHostContext.ExtHostQuickOpen,new N.ExtHostQuickOpen($e,Ge,at)),ni=$e.set(u.ExtHostContext.ExtHostSCM,new W.ExtHostSCM($e,at,et)),hi=$e.set(u.ExtHostContext.ExtHostComments,new d.ExtHostComments($e,at,vt)),ri=$e.set(u.ExtHostContext.ExtHostProgress,new A.ExtHostProgress($e.getProxy(u.MainContext.MainThreadProgress))),Vt=$e.set(u.ExtHostContext.ExtHosLabelService,new H.ExtHostLabelService($e)),Wt=$e.set(u.ExtHostContext.ExtHostTheming,new Oe.ExtHostTheming($e)),Tt=$e.set(u.ExtHostContext.ExtHostAuthentication,new K.ExtHostAuthentication($e)),fi=$e.set(u.ExtHostContext.ExtHostTimeline,new se.ExtHostTimeline($e,at)),jt=$e.set(u.ExtHostContext.ExtHostWebviews,new z.ExtHostWebviews($e,ke.environment,Ge,et,ot)),qt=$e.set(u.ExtHostContext.ExtHostWebviewPanels,new ue.ExtHostWebviewPanels($e,jt,Ge)),$t=$e.set(u.ExtHostContext.ExtHostCustomEditors,new je.ExtHostCustomEditors($e,vt,ft,jt,qt)),mi=$e.set(u.ExtHostContext.ExtHostWebviewViews,new ze.ExtHostWebviewViews($e,jt)),Rt=$e.set(u.ExtHostContext.ExtHostTesting,new ee.ExtHostTesting($e,gt,Ge)),Gt=$e.set(u.ExtHostContext.ExtHostUriOpeners,new te.ExtHostUriOpeners($e)),gi=we.values(u.ExtHostContext);$e.assertRegistered(gi);const Kt=new ye.ExtHostBulkEdits($e,gt,tt),Ht=new w.ExtHostClipboard($e),Xt=new b.ExtHostMessageService($e,et),Yt=new c.ExtHostDialogs($e),si=new x.ExtHostStatusBar($e,at.converter),Qt=new E.ExtHostLanguages($e,vt);return m.ExtHostApiCommands.register(at),function(Le,Jt,Ot){const ct=function(){let ne=!Le.isUnderDevelopment;function he(Ie){ne||(et.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ie(Qe){return Array.isArray(Qe)?Qe.forEach(Ie):typeof Qe=="string"?he(Qe):(typeof Qe.scheme=="undefined"&&he(Qe),!Le.enableProposedApi&&typeof Qe.exclusive=="boolean"&&ce.throwProposedApiError(Le)),Qe}}(),pi={getSession(ne,he,Ie){return Tt.getSession(Le,ne,he,Ie)},get onDidChangeSessions(){return Tt.onDidChangeSessions},registerAuthenticationProvider(ne,he,Ie,Qe){return ce.checkProposedApiEnabled(Le),Tt.registerAuthenticationProvider(ne,he,Ie,Qe)},get onDidChangeAuthenticationProviders(){return ce.checkProposedApiEnabled(Le),Tt.onDidChangeAuthenticationProviders},get providers(){return ce.checkProposedApiEnabled(Le),Tt.providers},logout(ne,he){return ce.checkProposedApiEnabled(Le),Tt.logout(ne,he)}},vi={registerCommand(ne,he,Ie){return at.registerCommand(!0,ne,he,Ie)},registerTextEditorCommand(ne,he,Ie){return at.registerCommand(!0,ne,(...Qe)=>{const lt=bt.getActiveTextEditor();if(!lt){et.warn("Cannot execute "+ne+" because there is no active text editor.");return}return lt.edit(dt=>{he.apply(Ie,[lt,dt,...Qe])}).then(dt=>{dt||et.warn("Edits from command "+ne+" were not applied.")},dt=>{et.warn("An error occurred while running command "+ne,dt)})})},registerDiffInformationCommand:(ne,he,Ie)=>(ce.checkProposedApiEnabled(Le),at.registerCommand(!0,ne,async(...Qe)=>{const lt=bt.getActiveTextEditor();if(!lt){et.warn("Cannot execute "+ne+" because there is no active text editor.");return}const dt=await bt.getDiffInformation(lt.id);he.apply(Ie,[dt,...Qe])})),executeCommand(ne,...he){return at.executeCommand(ne,...he)},getCommands(ne=!1){return at.getCommands(ne)}},oi={get machineId(){return ke.telemetryInfo.machineId},get sessionId(){return ke.telemetryInfo.sessionId},get language(){return ke.environment.appLanguage},get appName(){return ke.environment.appName},get appRoot(){var ne,he;return(he=(ne=ke.environment.appRoot)===null||ne===void 0?void 0:ne.fsPath)!==null&&he!==void 0?he:""},get uriScheme(){return ke.environment.appUriScheme},get clipboard(){return Ht},get shell(){return ut.getDefaultShell(!1,Ot)},openExternal(ne,he){return Ze.openUri(ne,{allowTunneling:!!ke.remote.authority,allowContributedOpeners:he==null?void 0:he.allowContributedOpeners})},asExternalUri(ne){return ne.scheme===ke.environment.appUriScheme?yt.createAppUri(ne):Ze.asExternalUri(ne,{allowTunneling:!!ke.remote.authority})},get remoteName(){return X.getRemoteName(ke.remote.authority)},get uiKind(){return ke.uiKind}};ke.environment.extensionTestsLocationURI||Object.freeze(oi);const ai=ke.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,_i={registerTestProvider(ne){return ce.checkProposedApiEnabled(Le),Rt.registerTestProvider(ne)},createDocumentTestObserver(ne){return ce.checkProposedApiEnabled(Le),Rt.createTextDocumentTestObserver(ne)},createWorkspaceTestObserver(ne){return ce.checkProposedApiEnabled(Le),Rt.createWorkspaceTestObserver(ne)},runTests(ne){return ce.checkProposedApiEnabled(Le),Rt.runTests(ne)},get onDidChangeTestResults(){return ce.checkProposedApiEnabled(Le),Rt.onLastResultsChanged},get testResults(){return ce.checkProposedApiEnabled(Le),Rt.lastResults}},Zt={getExtension(ne){const he=Jt.getExtensionDescription(ne);if(he)return new oe(qe,Le.identifier,he,ai)},get all(){return Jt.getAllExtensionDescriptions().map(ne=>new oe(qe,Le.identifier,ne,ai))},get onDidChange(){return Jt.onDidChange}},wi={createDiagnosticCollection(ne){return xt.createDiagnosticCollection(Le.identifier,ne)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:ne=>xt.getDiagnostics(ne),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(ne,he){return Qt.changeLanguage(ne.uri,he)},match(ne,he){return v.score(J.LanguageSelector.from(ne),he.uri,he.languageId,!0)},registerCodeActionsProvider(ne,he,Ie){return it.registerCodeActionProvider(Le,ct(ne),he,Ie)},registerCodeLensProvider(ne,he){return it.registerCodeLensProvider(Le,ct(ne),he)},registerDefinitionProvider(ne,he){return it.registerDefinitionProvider(Le,ct(ne),he)},registerDeclarationProvider(ne,he){return it.registerDeclarationProvider(Le,ct(ne),he)},registerImplementationProvider(ne,he){return it.registerImplementationProvider(Le,ct(ne),he)},registerTypeDefinitionProvider(ne,he){return it.registerTypeDefinitionProvider(Le,ct(ne),he)},registerHoverProvider(ne,he){return it.registerHoverProvider(Le,ct(ne),he,Le.identifier)},registerEvaluatableExpressionProvider(ne,he){return it.registerEvaluatableExpressionProvider(Le,ct(ne),he,Le.identifier)},registerDocumentHighlightProvider(ne,he){return it.registerDocumentHighlightProvider(Le,ct(ne),he)},registerLinkedEditingRangeProvider(ne,he){return it.registerLinkedEditingRangeProvider(Le,ct(ne),he)},registerReferenceProvider(ne,he){return it.registerReferenceProvider(Le,ct(ne),he)},registerRenameProvider(ne,he){return it.registerRenameProvider(Le,ct(ne),he)},registerDocumentSymbolProvider(ne,he,Ie){return it.registerDocumentSymbolProvider(Le,ct(ne),he,Ie)},registerWorkspaceSymbolProvider(ne){return it.registerWorkspaceSymbolProvider(Le,ne)},registerDocumentFormattingEditProvider(ne,he){return it.registerDocumentFormattingEditProvider(Le,ct(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return it.registerDocumentRangeFormattingEditProvider(Le,ct(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Ie,...Qe){return it.registerOnTypeFormattingEditProvider(Le,ct(ne),he,[Ie].concat(Qe))},registerDocumentSemanticTokensProvider(ne,he,Ie){return it.registerDocumentSemanticTokensProvider(Le,ct(ne),he,Ie)},registerDocumentRangeSemanticTokensProvider(ne,he,Ie){return it.registerDocumentRangeSemanticTokensProvider(Le,ct(ne),he,Ie)},registerSignatureHelpProvider(ne,he,Ie,...Qe){return typeof Ie=="object"?it.registerSignatureHelpProvider(Le,ct(ne),he,Ie):it.registerSignatureHelpProvider(Le,ct(ne),he,typeof Ie=="undefined"?[]:[Ie,...Qe])},registerCompletionItemProvider(ne,he,...Ie){return it.registerCompletionItemProvider(Le,ct(ne),he,Ie)},registerDocumentLinkProvider(ne,he){return it.registerDocumentLinkProvider(Le,ct(ne),he)},registerColorProvider(ne,he){return it.registerColorProvider(Le,ct(ne),he)},registerFoldingRangeProvider(ne,he){return it.registerFoldingRangeProvider(Le,ct(ne),he)},registerSelectionRangeProvider(ne,he){return it.registerSelectionRangeProvider(Le,ne,he)},registerCallHierarchyProvider(ne,he){return it.registerCallHierarchyProvider(Le,ne,he)},setLanguageConfiguration:(ne,he)=>it.setLanguageConfiguration(Le,ne,he),getTokenInformationAtPosition(ne,he){return ce.checkProposedApiEnabled(Le),Qt.tokenAtPosition(ne,he)},registerInlineHintsProvider(ne,he){return ce.checkProposedApiEnabled(Le),it.registerInlineHintsProvider(Le,ne,he)}},q={get activeTextEditor(){return bt.getActiveTextEditor()},get visibleTextEditors(){return bt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(ne,he,Ie){const Qe=await(I.URI.isUri(ne)?Promise.resolve(j.openTextDocument(ne)):Promise.resolve(ne));return bt.showTextDocument(Qe,he,Ie)},createTextEditorDecorationType(ne){return bt.createTextEditorDecorationType(ne)},onDidChangeActiveTextEditor(ne,he,Ie){return bt.onDidChangeActiveTextEditor(ne,he,Ie)},onDidChangeVisibleTextEditors(ne,he,Ie){return bt.onDidChangeVisibleTextEditors(ne,he,Ie)},onDidChangeTextEditorSelection(ne,he,Ie){return bt.onDidChangeTextEditorSelection(ne,he,Ie)},onDidChangeTextEditorOptions(ne,he,Ie){return bt.onDidChangeTextEditorOptions(ne,he,Ie)},onDidChangeTextEditorVisibleRanges(ne,he,Ie){return bt.onDidChangeTextEditorVisibleRanges(ne,he,Ie)},onDidChangeTextEditorViewColumn(ne,he,Ie){return bt.onDidChangeTextEditorViewColumn(ne,he,Ie)},onDidCloseTerminal(ne,he,Ie){return ut.onDidCloseTerminal(ne,he,Ie)},onDidOpenTerminal(ne,he,Ie){return ut.onDidOpenTerminal(ne,he,Ie)},onDidChangeActiveTerminal(ne,he,Ie){return ut.onDidChangeActiveTerminal(ne,he,Ie)},onDidChangeTerminalDimensions(ne,he,Ie){return ce.checkProposedApiEnabled(Le),ut.onDidChangeTerminalDimensions(ne,he,Ie)},onDidWriteTerminalData(ne,he,Ie){return ce.checkProposedApiEnabled(Le),ut.onDidWriteTerminalData(ne,he,Ie)},get state(){return Ze.state},onDidChangeWindowState(ne,he,Ie){return Ze.onDidChangeWindowState(ne,he,Ie)},showInformationMessage(ne,...he){return Xt.showMessage(Le,D.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return Xt.showMessage(Le,D.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return Xt.showMessage(Le,D.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Ie){return Lt.showQuickPick(ne,!!Le.enableProposedApi,he,Ie)},showWorkspaceFolderPick(ne){return Lt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Lt.showInput(ne,he)},showOpenDialog(ne){return Yt.showOpenDialog(ne)},showSaveDialog(ne){return Yt.showSaveDialog(ne)},createStatusBarItem(ne,he){let Ie,Qe,lt,dt;return ne&&typeof ne!="number"?(Ie=ne.id,Qe=ne.name,lt=ne.alignment,he=ne.priority,dt=ne.accessibilityInformation):(Ie=Le.identifier.value,Qe=_.localize(0,null,Le.displayName||Le.name),lt=ne),si.createStatusBarEntry(Ie,Qe,lt,he,dt)},setStatusBarMessage(ne,he){return si.setStatusBarMessage(ne,he)},withScmProgress(ne){return ot.report("window.withScmProgress",Le,"Use 'withProgress' instead."),ri.withProgress(Le,{location:U.ProgressLocation.SourceControl},(he,Ie)=>ne({report(Qe){}}))},withProgress(ne,he){return ri.withProgress(Le,ne,he)},createOutputChannel(ne){return Et.createOutputChannel(ne)},createWebviewPanel(ne,he,Ie,Qe){return qt.createWebviewPanel(Le,ne,he,Ie,Qe)},createWebviewTextEditorInset(ne,he,Ie,Qe){return ce.checkProposedApiEnabled(Le),Bt.createWebviewEditorInset(ne,he,Ie,Qe,Le)},createTerminal(ne,he,Ie){return typeof ne=="object"?"pty"in ne?ut.createExtensionTerminal(ne):ut.createTerminalFromOptions(ne):ut.createTerminal(ne,he,Ie)},registerTerminalLinkProvider(ne){return ut.registerLinkProvider(ne)},registerTreeDataProvider(ne,he){return Ut.registerTreeDataProvider(ne,he,Le)},createTreeView(ne,he){return Ut.createTreeView(ne,he,Le)},registerWebviewPanelSerializer:(ne,he)=>qt.registerWebviewPanelSerializer(Le,ne,he),registerCustomEditorProvider:(ne,he,Ie={})=>$t.registerCustomEditorProvider(Le,ne,he,Ie),registerFileDecorationProvider(ne){return _t.registerFileDecorationProvider(ne,Le.identifier)},registerUriHandler(ne){return yt.registerUriHandler(Le.identifier,ne)},createQuickPick(){return Lt.createQuickPick(Le.identifier,!!Le.enableProposedApi)},createInputBox(){return Lt.createInputBox(Le.identifier)},get activeColorTheme(){return Wt.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Ie){return Wt.onDidChangeActiveColorTheme(ne,he,Ie)},registerWebviewViewProvider(ne,he,Ie){return mi.registerWebviewViewProvider(Le,ne,he,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return ce.checkProposedApiEnabled(Le),tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Ie){return ce.checkProposedApiEnabled(Le),tt.onDidChangeActiveNotebookEditor(ne,he,Ie)},get visibleNotebookEditors(){return ce.checkProposedApiEnabled(Le),tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ce.checkProposedApiEnabled(Le),tt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Ie){return ce.checkProposedApiEnabled(Le),tt.onDidChangeNotebookEditorSelection(ne,he,Ie)},onDidChangeNotebookEditorVisibleRanges(ne,he,Ie){return ce.checkProposedApiEnabled(Le),tt.onDidChangeNotebookEditorVisibleRanges(ne,he,Ie)},showNotebookDocument(ne,he){return ce.checkProposedApiEnabled(Le),tt.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Ie){return ce.checkProposedApiEnabled(Le),Gt.registerExternalUriOpener(Le.identifier,ne,he,Ie)},get openEditors(){return ce.checkProposedApiEnabled(Le),pt.tabs},get onDidChangeOpenEditors(){return ce.checkProposedApiEnabled(Le),pt.onDidChangeTabs}},j={get rootPath(){return ot.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ge.getPath()},set rootPath(ne){throw R.readonly()},getWorkspaceFolder(ne){return Ge.getWorkspaceFolder(ne)},get workspaceFolders(){return Ge.getWorkspaceFolders()},get name(){return Ge.name},set name(ne){throw R.readonly()},get workspaceFile(){return Ge.workspaceFile},set workspaceFile(ne){throw R.readonly()},updateWorkspaceFolders:(ne,he,...Ie)=>Ge.updateWorkspaceFolders(Le,ne,he||0,...Ie),onDidChangeWorkspaceFolders:function(ne,he,Ie){return Ge.onDidChangeWorkspace(ne,he,Ie)},asRelativePath:(ne,he)=>Ge.getRelativePath(ne,he),findFiles:(ne,he,Ie,Qe)=>Ge.findFiles(J.GlobPattern.from(ne),J.GlobPattern.from(he),Ie,Le.identifier,Qe),findTextInFiles:(ne,he,Ie,Qe)=>{let lt,dt;return typeof he=="object"?(lt=he,dt=Ie):(lt={},dt=he,Qe=Ie),Ge.findTextInFiles(ne,lt||{},dt,Le.identifier,Qe)},saveAll:ne=>Ge.saveAll(ne),applyEdit(ne){return Kt.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,he,Ie,Qe)=>It.createFileSystemWatcher(J.GlobPattern.from(ne),he,Ie,Qe),get textDocuments(){return vt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw R.readonly()},openTextDocument(ne){let he;const Ie=ne;if(typeof ne=="string")he=Promise.resolve(I.URI.file(ne));else if(I.URI.isUri(ne))he=Promise.resolve(ne);else if(!Ie||typeof Ie=="object")he=vt.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(Qe=>vt.ensureDocumentData(Qe).then(lt=>lt.document))},onDidOpenTextDocument:(ne,he,Ie)=>vt.onDidAddDocument(ne,he,Ie),onDidCloseTextDocument:(ne,he,Ie)=>vt.onDidRemoveDocument(ne,he,Ie),onDidChangeTextDocument:(ne,he,Ie)=>vt.onDidChangeDocument(ne,he,Ie),onDidSaveTextDocument:(ne,he,Ie)=>vt.onDidSaveDocument(ne,he,Ie),onWillSaveTextDocument:(ne,he,Ie)=>Pt.getOnWillSaveTextDocumentEvent(Le)(ne,he,Ie),onDidChangeConfiguration:(ne,he,Ie)=>Ot.onDidChangeConfiguration(ne,he,Ie),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,Ot.getConfiguration(ne,he,Le)},registerTextDocumentContentProvider(ne,he){return Ct.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(ot.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider(Le,ne,he)),registerFileSystemProvider(ne,he,Ie){return zt.registerFileSystemProvider(Le.identifier,ne,he,Ie)},get fs(){return xe},registerFileSearchProvider:(ne,he)=>(ce.checkProposedApiEnabled(Le),kt.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>(ce.checkProposedApiEnabled(Le),kt.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>(ce.checkProposedApiEnabled(Le),qe.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>(ce.checkProposedApiEnabled(Le),Vt.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Ie)=>It.onDidCreateFile(ne,he,Ie),onDidDeleteFiles:(ne,he,Ie)=>It.onDidDeleteFile(ne,he,Ie),onDidRenameFiles:(ne,he,Ie)=>It.onDidRenameFile(ne,he,Ie),onWillCreateFiles:(ne,he,Ie)=>It.getOnWillCreateFileEvent(Le)(ne,he,Ie),onWillDeleteFiles:(ne,he,Ie)=>It.getOnWillDeleteFileEvent(Le)(ne,he,Ie),onWillRenameFiles:(ne,he,Ie)=>It.getOnWillRenameFileEvent(Le)(ne,he,Ie),openTunnel:ne=>(ce.checkProposedApiEnabled(Le),mt.openTunnel(Le,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return ce.checkProposedApiEnabled(Le),mt.getTunnels()},onDidChangeTunnels:(ne,he,Ie)=>(ce.checkProposedApiEnabled(Le),mt.onDidChangeTunnels(ne,he,Ie)),registerTimelineProvider:(ne,he)=>(ce.checkProposedApiEnabled(Le),fi.registerTimelineProvider(ne,he,Le.identifier,at.converter))},de={get inputBox(){return ot.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Le)},createSourceControl(ne,he,Ie){return ni.createSourceControl(Le,ne,he,Ie)}},Te={createCommentController(ne,he){return hi.createCommentController(Le,ne,he)}},Ve={get activeDebugSession(){return rt.activeDebugSession},get activeDebugConsole(){return rt.activeDebugConsole},get breakpoints(){return rt.breakpoints},onDidStartDebugSession(ne,he,Ie){return rt.onDidStartDebugSession(ne,he,Ie)},onDidTerminateDebugSession(ne,he,Ie){return rt.onDidTerminateDebugSession(ne,he,Ie)},onDidChangeActiveDebugSession(ne,he,Ie){return rt.onDidChangeActiveDebugSession(ne,he,Ie)},onDidReceiveDebugSessionCustomEvent(ne,he,Ie){return rt.onDidReceiveDebugSessionCustomEvent(ne,he,Ie)},onDidChangeBreakpoints(ne,he,Ie){return rt.onDidChangeBreakpoints(ne,he,Ie)},registerDebugConfigurationProvider(ne,he,Ie){return rt.registerDebugConfigurationProvider(ne,he,Ie||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return rt.registerDebugAdapterDescriptorFactory(Le,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return rt.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?rt.startDebugging(ne,he,{parentSession:Ie}):rt.startDebugging(ne,he,Ie||{})},stopDebugging(ne){return rt.stopDebugging(ne)},addBreakpoints(ne){return rt.addBreakpoints(ne)},removeBreakpoints(ne){return rt.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return rt.asDebugSourceUri(ne,he)}},Ye={registerTaskProvider:(ne,he)=>wt.registerTaskProvider(Le,ne,he),fetchTasks:ne=>wt.fetchTasks(ne),executeTask:ne=>wt.executeTask(Le,ne),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(ne,he,Ie)=>wt.onDidStartTask(ne,he,Ie),onDidEndTask:(ne,he,Ie)=>wt.onDidEndTask(ne,he,Ie),onDidStartTaskProcess:(ne,he,Ie)=>wt.onDidStartTaskProcess(ne,he,Ie),onDidEndTaskProcess:(ne,he,Ie)=>wt.onDidEndTaskProcess(ne,he,Ie)},nt={openNotebookDocument:(ne,he)=>(ce.checkProposedApiEnabled(Le),tt.openNotebookDocument(ne,he)),get onDidOpenNotebookDocument(){return ce.checkProposedApiEnabled(Le),tt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return ce.checkProposedApiEnabled(Le),tt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return ce.checkProposedApiEnabled(Le),tt.onDidSaveNotebookDocument},get notebookDocuments(){return ce.checkProposedApiEnabled(Le),tt.notebookDocuments.map(ne=>ne.notebookDocument)},get visibleNotebookEditors(){return ce.checkProposedApiEnabled(Le),tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ce.checkProposedApiEnabled(Le),tt.onDidChangeVisibleNotebookEditors},get onDidChangeActiveNotebookKernel(){return ce.checkProposedApiEnabled(Le),tt.onDidChangeActiveNotebookKernel},registerNotebookContentProvider:(ne,he,Ie)=>(ce.checkProposedApiEnabled(Le),tt.registerNotebookContentProvider(Le,ne,he,Ie)),registerNotebookKernelProvider:(ne,he)=>(ce.checkProposedApiEnabled(Le),tt.registerNotebookKernelProvider(Le,ne,he)),createNotebookEditorDecorationType(ne){return ce.checkProposedApiEnabled(Le),tt.createNotebookEditorDecorationType(ne)},get activeNotebookEditor(){return ce.checkProposedApiEnabled(Le),tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Ie){return ce.checkProposedApiEnabled(Le),tt.onDidChangeActiveNotebookEditor(ne,he,Ie)},onDidChangeNotebookDocumentMetadata(ne,he,Ie){return ce.checkProposedApiEnabled(Le),tt.onDidChangeNotebookDocumentMetadata(ne,he,Ie)},onDidChangeNotebookCells(ne,he,Ie){return ce.checkProposedApiEnabled(Le),tt.onDidChangeNotebookCells(ne,he,Ie)},onDidChangeNotebookEditorSelection(ne,he,Ie){return ce.checkProposedApiEnabled(Le),tt.onDidChangeNotebookEditorSelection(ne,he,Ie)},onDidChangeNotebookEditorVisibleRanges(ne,he,Ie){return ce.checkProposedApiEnabled(Le),tt.onDidChangeNotebookEditorVisibleRanges(ne,he,Ie)},onDidChangeCellOutputs(ne,he,Ie){return ce.checkProposedApiEnabled(Le),tt.onDidChangeCellOutputs(ne,he,Ie)},onDidChangeCellLanguage(ne,he,Ie){return ce.checkProposedApiEnabled(Le),tt.onDidChangeCellLanguage(ne,he,Ie)},onDidChangeCellMetadata(ne,he,Ie){return ce.checkProposedApiEnabled(Le),tt.onDidChangeCellMetadata(ne,he,Ie)},createConcatTextDocument(ne,he){return ce.checkProposedApiEnabled(Le),new _e.ExtHostNotebookConcatDocument(tt,vt,ne,he)},createCellStatusBarItem(ne,he,Ie){return ce.checkProposedApiEnabled(Le),tt.createNotebookCellStatusBarItemInternal(ne,he,Ie)}};return{version:ke.version,authentication:pi,commands:vi,comments:Te,debug:Ve,env:oi,extensions:Zt,languages:wi,notebook:nt,scm:de,tasks:Ye,test:_i,window:q,workspace:j,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:k.CancellationTokenSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTrigger:U.CodeActionTrigger,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:f.FileType,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,Hover:U.Hover,IndentAction:S.IndentAction,InlineHint:U.InlineHint,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:U.ParameterInformation,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:n.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,UIKind:u.UIKind,Uri:I.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,get RemoteAuthorityResolverError(){return U.RemoteAuthorityResolverError},get ResolvedAuthority(){return U.ResolvedAuthority},get SourceControlInputBoxValidationType(){return U.SourceControlInputBoxValidationType},get ExtensionRuntime(){return U.ExtensionRuntime},get TimelineItem(){return U.TimelineItem},get CellKind(){return U.CellKind},get CellOutputKind(){return U.CellOutputKind},get NotebookCellRunState(){return U.NotebookCellRunState},get NotebookRunState(){return U.NotebookRunState},get NotebookCellStatusBarAlignment(){return U.NotebookCellStatusBarAlignment},get NotebookEditorRevealType(){return U.NotebookEditorRevealType},get NotebookCellOutput(){return U.NotebookCellOutput},get NotebookCellOutputItem(){return U.NotebookCellOutputItem},get LinkedEditingRanges(){return U.LinkedEditingRanges},get TestRunState(){return U.TestRunState},get TestMessageSeverity(){return U.TestMessageSeverity},get TestState(){return U.TestState}}}}e.createApiFactoryAndRegisterActors=ie;class oe{constructor(ke,Re,xe,qe){this._extensionService=ke,this._originExtensionId=Re,this._identifier=xe.identifier,this.id=xe.identifier.value,this.extensionUri=xe.extensionLocation,this.extensionPath=P.normalize(fe.originalFSPath(xe.extensionLocation)),this.packageJSON=xe,this.extensionKind=qe}get isActive(){return this._extensionService.isActivated(this._identifier)}get exports(){if(this.packageJSON.api!=="none")return this._extensionService.getExtensionExports(this._identifier)}activate(){return this._extensionService.activateByIdWithErrors(this._identifier,{startup:!1,extensionId:this._originExtensionId,activationEvent:"api"}).then(()=>this.exports)}}}),define(ge[270],pe([0,1,81,65,32,123,37,52,40,36,67,46,69,91,90,51,64,124,89,62,88]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p,d,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),_.registerSingleton(f.IExtensionStoragePaths,f.ExtensionStoragePaths),_.registerSingleton(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),_.registerSingleton(D.IExtHostCommands,D.ExtHostCommands),_.registerSingleton(P.IExtHostConfiguration,P.ExtHostConfiguration),_.registerSingleton(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem),_.registerSingleton(S.IExtHostDebugService,S.WorkerExtHostDebugService),_.registerSingleton(T.IExtHostDecorations,T.ExtHostDecorations),_.registerSingleton(I.IExtHostDocumentsAndEditors,I.ExtHostDocumentsAndEditors),_.registerSingleton(s.IExtHostFileSystemInfo,s.ExtHostFileSystemInfo),_.registerSingleton(k.IExtHostOutputService,k.ExtHostOutputService),_.registerSingleton(v.IExtHostSearch,v.ExtHostSearch),_.registerSingleton(u.IExtHostStorage,u.ExtHostStorage),_.registerSingleton(C.IExtHostTask,C.WorkerExtHostTask),_.registerSingleton(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),_.registerSingleton(m.IExtHostTunnelService,m.ExtHostTunnelService),_.registerSingleton(p.IExtHostWindow,p.ExtHostWindow),_.registerSingleton(R.IExtHostWorkspace,R.ExtHostWorkspace),_.registerSingleton(a.IExtHostSecretState,a.ExtHostSecretState)}),define(ge[92],pe([0,1,13,12,31,125]),function(Z,e,_,k,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function P(S){return S.startsWith("**")||S.startsWith("/")?S:`/${S}`}e.anchorGlob=P;function D(S,v,f,u){const m=_.mapArrayOrNot(f,I),w=new R.TextSearchMatch(v,m,u),p=w.preview.matches;return{ranges:_.mapArrayOrNot(m,n),uri:S,preview:{text:w.preview.text,matches:_.mapArrayOrNot(p,n)}}}e.createTextSearchResult=D;function I(S){return new R.SearchRange(S.start.line,S.start.character,S.end.line,S.end.character)}function n(S){return new T.Range(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn)}let C=class{constructor(v){this.logService=v}appendLine(v){this.logService.debug("RipgrepSearchEH#search",v)}};C=He([Fe(0,k.ILogService)],C),e.OutputChannel=C}),define(ge[271],pe([0,1,94,27]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function R(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=R,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,P=512,D=512*8,I=512*128;class n{constructor(r){this.iconvLiteDecoder=r}static async create(r){let o;if(r!==e.UTF8)o=(await new Promise((i,h)=>{Z(["iconv-lite-umd"],i,h)})).getDecoder(f(r));else{const l=new TextDecoder;o={write(i){return l.decode(i,{stream:!0})},end(){return l.decode()}}}return new n(o)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function C(t,r){var o;const l=((o=r.minBytesRequiredForDetection)!==null&&o!==void 0?o:r.guessEncoding)?D:P;return new Promise((i,h)=>{const y=_.newWriteableStream(A=>A.join("")),g=[];let E=0,b;const L=async()=>{try{const A=await c({buffer:k.VSBuffer.concat(g),bytesRead:E},r.guessEncoding);A.encoding=await r.overwriteEncoding(A.encoding),b=await n.create(A.encoding);const N=b.write(k.VSBuffer.concat(g).buffer);y.write(N),g.length=0,E=0,i({stream:y,detected:A})}catch(A){h(A)}};t.on("error",A=>y.error(A)),t.on("data",async A=>{b?y.write(b.write(A.buffer)):(g.push(A),E+=A.byteLength,E>=l&&(t.pause(),await L(),setTimeout(()=>t.resume())))}),t.on("end",async()=>{b||await L(),y.end(b==null?void 0:b.end())})})}e.toDecodeStream=C;async function S(t,r,o){const i=(await new Promise((g,E)=>{Z(["iconv-lite-umd"],g,E)})).getEncoder(f(r),o);let h=!1,y=!1;return{read(){if(y)return null;const g=t.read();if(typeof g!="string"){if(y=!0,!h&&(o==null?void 0:o.addBOM))switch(r){case e.UTF8:case e.UTF8_with_bom:return k.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return k.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return k.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const E=i.end();return E&&E.length>0?(h=!0,k.VSBuffer.wrap(E)):null}return h=!0,k.VSBuffer.wrap(i.write(g))}}}e.toEncodeReadable=S;async function v(t){return(await new Promise((o,l)=>{Z(["iconv-lite-umd"],o,l)})).encodingExists(f(t))}e.encodingExists=v;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function u(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),l=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&l===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&l===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const i=t.readUInt8(2);return o===e.UTF8_BOM[0]&&l===e.UTF8_BOM[1]&&i===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=u;const m=["ascii","utf-16","utf-32"];async function w(t){const r=await new Promise((y,g)=>{Z(["jschardet"],y,g)}),o=t.slice(0,I),l=s(o.buffer),i=r.detect(l);if(!i||!i.encoding)return null;const h=i.encoding.toLowerCase();return 0<=m.indexOf(h)?null:d(i.encoding)}const p={ibm866:"cp866",big5:"cp950"};function d(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return p[r]||r}function s(t){let r="";for(let o=0;o<t.length;o++)r+=String.fromCharCode(t[o]);return r}function a(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=a;function c({buffer:t,bytesRead:r},o){let l=u(t,r),i=!1;if(l!==e.UTF16be&&l!==e.UTF16le&&t){let h=!0,y=!0,g=!1;for(let E=0;E<r&&E<T;E++){const b=E%2==1,L=t.readUInt8(E)===0;if(L&&(g=!0),h&&(b&&!L||!b&&L)&&(h=!1),y&&(b&&L||!b&&!L)&&(y=!1),L&&!h&&!y)break}g&&(h?l=e.UTF16le:y?l=e.UTF16be:i=!0)}return o&&!i&&!l&&t?w(t.slice(0,r)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:i,encoding:l}}e.detectEncodingFromBuffer=c,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[127],pe([0,1,271,24,126]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends R.TextSearchManager{constructor(D,I,n=k){super(D,I,{readdir:C=>n.readdir(C.fsPath),toCanonicalName:C=>_.toCanonicalName(C)})}}e.NativeTextSearchManager=T}),define(ge[272],pe([0,1,273,289,290,291,34,39,35,292,49,2,59]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function f(N,W,x,M,$,O){const B=m(N,W,M,$,O),J=a(W,B);return o(x,J)}e.connectProxyResolver=f;const u=5e3;function m(N,W,x,M,$){const O=process.env;let B=d(W.getConfiguration("http").get("proxy"));W.onDidChangeConfiguration(Oe=>{B=d(W.getConfiguration("http").get("proxy"))});let J=d(O.https_proxy||O.HTTPS_PROXY||O.http_proxy||O.HTTP_PROXY),U=s(O.no_proxy||O.NO_PROXY),V=0,z=new Map,Q=new Map;function ae(Oe){return T.format(Object.assign(Object.assign({},Oe),{pathname:void 0,search:void 0,hash:void 0}))}function ce(Oe){let Se=Q.get(Oe);return Se||(Se=z.get(Oe),Se&&(z.delete(Oe),fe(Oe,Se)),Se)}function fe(Oe,Se){Q.set(Oe,Se),Q.size>=u&&(z=Q,Q=new Map,V++,x.trace("ProxyResolver#cacheProxy cacheRolls",V))}let we,be=0,H=0,X=0,re=0,Y=0,le=0,ve=0,De=0,Me=[];function Ee(){we=void 0,M.$publicLog2("resolveProxy",{count:be,duration:H,errorCount:X,cacheCount:re,cacheSize:Q.size,cacheRolls:V,envCount:Y,settingsCount:le,localhostCount:ve,envNoProxyCount:De,results:Me}),be=H=X=re=Y=le=ve=De=0,Me=[]}function Pe(Oe,Se,Be,K,se){we||(we=setTimeout(Ee,10*60*1e3));const _e=$.environment.useHostProxy,Ae=typeof _e=="boolean"?_e:!$.remote.isRemote;l(x,Oe.useSystemCertificates,Be,()=>{Ce(Ae,Oe.useProxySettings,Se,Be,K,se)})}function Ce(Oe,Se,Be,K,se,_e){if(!Se){_e("DIRECT");return}const Ae=T.parse(se),Ue=Ae.hostname;if(Ue==="localhost"||Ue==="127.0.0.1"||Ue==="::1"||Ue==="::ffff:127.0.0.1"){ve++,_e("DIRECT"),x.trace("ProxyResolver#resolveProxy localhost",se,"DIRECT");return}if(typeof Ue=="string"&&U(Ue,String(Ae.port||K.agent.defaultPort))){De++,_e("DIRECT"),x.trace("ProxyResolver#resolveProxy envNoProxy",se,"DIRECT");return}if(B){le++,_e(B),x.trace("ProxyResolver#resolveProxy settings",se,B);return}if(J){Y++,_e(J),x.trace("ProxyResolver#resolveProxy env",se,J);return}const ze=ae(Ae),je=ce(ze);if(je){re++,w(Me,je,Ae.protocol==="https:"?"HTTPS":"HTTP",Be),_e(je),x.trace("ProxyResolver#resolveProxy cached",se,je);return}if(!Oe){_e("DIRECT"),x.trace("ProxyResolver#resolveProxy unconfigured",se,"DIRECT");return}const ue=Date.now();N.resolveProxy(se).then(ye=>{ye&&(fe(ze,ye),w(Me,ye,Ae.protocol==="https:"?"HTTPS":"HTTP",Be)),_e(ye),x.debug("ProxyResolver#resolveProxy",se,ye)}).then(()=>{be++,H=Date.now()-ue+H},ye=>{X++,_e(),x.error("ProxyResolver#resolveProxy",C.toErrorMessage(ye))})}return Pe}function w(N,W,x,M){const $=W?String(W).trim().split(/\s+/,1)[0]:"EMPTY";M.on("response",O=>{const B=`HTTP_${O.statusCode}`,J=p(N,$,x,B);J.count++}),M.on("error",O=>{const B=O&&typeof O.code=="string"&&O.code||"UNKNOWN_ERROR",J=p(N,$,x,B);J.count++})}function p(N,W,x,M){for(const O of N)if(O.proxy===W&&O.connection===x&&O.code===M)return O;const $={proxy:W,connection:x,code:M,count:0};return N.push($),$}function d(N){const W=(N||"").trim(),x=W.indexOf("://");if(x!==-1){const M=W.substr(0,x).toLowerCase(),$=W.substr(x+3);if(M==="http")return"PROXY "+$;if(M==="https")return"HTTPS "+$;if(M==="socks")return"SOCKS "+$}}function s(N){const W=(N||"").trim().toLowerCase();if(W==="*")return()=>!0;const x=W.split(",").map(M=>M.trim().split(":",2)).map(([M,$])=>({name:M,port:$})).filter(M=>!!M.name).map(({name:M,port:$})=>({domain:M[0]==="."?M:`.${M}`,port:$}));return x.length?(M,$)=>x.some(({domain:O,port:B})=>`.${M.toLowerCase()}`.endsWith(O)&&(!B||$===B)):()=>!1}function a(N,W){const x={config:N.getConfiguration("http").get("proxySupport")||"off"};N.onDidChangeConfiguration($=>{x.config=N.getConfiguration("http").get("proxySupport")||"off"});const M={config:!!N.getConfiguration("http").get("systemCertificates")};return N.onDidChangeConfiguration($=>{M.config=!!N.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},_,c(_,W,{config:"off"},M,!0)),on:Object.assign({},_,c(_,W,{config:"on"},M,!0)),override:Object.assign({},_,c(_,W,{config:"override"},M,!0)),onRequest:Object.assign({},_,c(_,W,x,M,!0)),default:Object.assign(_,c(_,W,x,M,!1))},https:{off:Object.assign({},k,c(k,W,{config:"off"},M,!0)),on:Object.assign({},k,c(k,W,{config:"on"},M,!0)),override:Object.assign({},k,c(k,W,{config:"override"},M,!0)),onRequest:Object.assign({},k,c(k,W,x,M,!0)),default:Object.assign(k,c(k,W,x,M,!1))},tls:Object.assign(R,t(R))}}function c(N,W,x,M,$){return{get:O(N.get),request:O(N.request)};function O(B){function J(U,V,z){if(typeof U!="string"&&!(U&&U.searchParams)&&(z=V,V=U,U=null),typeof V=="function"&&(z=V,V=null),V=V||{},V.socketPath)return B.apply(null,arguments);const Q=V.agent;if(Q===!0)throw new Error("Unexpected agent option: true");const ae=Q instanceof n.ProxyAgent,ce=$&&(V._vscodeProxySupport||V._vscodeSystemProxy)||x.config,fe=!ae&&(ce==="override"||ce==="on"&&Q===void 0),we=!ae&&M.config&&N===k&&!V.ca;if(fe||we){if(U){const be=typeof U=="string"?new T.URL(U):U,H={protocol:be.protocol,hostname:be.hostname.lastIndexOf("[",0)===0?be.hostname.slice(1,-1):be.hostname,port:be.port,path:`${be.pathname}${be.search}`};(be.username||be.password)&&(V.auth=`${be.username}:${be.password}`),V=Object.assign(Object.assign({},H),V)}else V=Object.assign({},V);return V.agent=new n.ProxyAgent({resolveProxy:W.bind(void 0,{useProxySettings:fe,useSystemCertificates:we}),defaultPort:N===k?443:80,originalAgent:Q}),B(V,z)}return B.apply(null,arguments)}return J}}function t(N){return{createSecureContext:W(N.createSecureContext)};function W(x){return function(M){const $=x.apply(null,arguments),O=M._vscodeAdditionalCaCerts;if(O)for(const B of O)$.context.addCACert(B);return $}}}const r=new Map;function o(N,W){return N.getExtensionPathIndex().then(x=>{const M=Z.__$__nodeRequire("module"),$=M._load;M._load=function(B,J,U){if(B==="tls")return W.tls;if(B!=="http"&&B!=="https")return $.apply(this,arguments);const V=W[B],z=x.findSubstr(S.URI.file(J.filename).fsPath);let Q=r.get(z);if(Q||r.set(z,Q={}),!Q[B]){let ae=V.default;z&&z.enableProposedApi&&(ae=V[z.proxySupport]||V.onRequest),Q[B]=Object.assign({},ae)}return Q[B]}})}function l(N,W,x,M){W?h(N).then($=>{$&&($.append?x._vscodeAdditionalCaCerts=$.certs:x.ca=$.certs),M()}).catch($=>{N.error("ProxyResolver#useSystemCertificates",C.toErrorMessage($))}):M()}let i;async function h(N){return i||(i=y().then(W=>(N.debug("ProxyResolver#getCaCertificates count",W&&W.certs.length),W&&W.certs.length?W:void 0)).catch(W=>{N.error("ProxyResolver#getCaCertificates error",C.toErrorMessage(W))})),i}async function y(){if(process.platform==="win32")return g();if(process.platform==="darwin")return E();if(process.platform==="linux")return L()}async function g(){const N=await new Promise(($,O)=>{Z(["vscode-windows-ca-certs"],$,O)});let W=[];const x=new N.Crypt32;try{let $;for(;$=x.next();)W.push($)}finally{x.done()}const M=new Set(W.map(A));return{certs:Array.from(M),append:!0}}async function E(){const N=await new Promise((x,M)=>{const $=I.spawn("/usr/bin/security",["find-certificate","-a","-p"]),O=[];$.stdout.setEncoding("utf8"),$.stdout.on("data",B=>O.push(B)),$.on("error",M),$.on("exit",B=>B?M(B):x(O.join("")))}),W=new Set(N.split(/(?=-----BEGIN CERTIFICATE-----)/g).filter(x=>!!x.length));return{certs:Array.from(W),append:!0}}const b=["/etc/ssl/certs/ca-certificates.crt","/etc/ssl/certs/ca-bundle.crt"];async function L(){for(const N of b)try{const W=await v.promisify(D.readFile)(N,{encoding:"utf8"}),x=new Set(W.split(/(?=-----BEGIN CERTIFICATE-----)/g).filter(M=>!!M.length));return{certs:Array.from(x),append:!1}}catch(W){if(W.code!=="ENOENT")throw W}}function A(N){const W=["-----BEGIN CERTIFICATE-----"],x=N.toString("base64");for(let M=0;M<x.length;M+=64)W.push(x.substr(M,64));return W.push("-----END CERTIFICATE-----",""),W.join(P.EOL)}}),define(ge[274],pe([0,1,35,7,77,30,9,10,92,275]),function(Z,e,_,k,R,T,P,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const C=n.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function S(s,a,c,t){const r=v(s,a,c,t),o=a.folder.fsPath;return{cmd:_.spawn(C,r.args,{cwd:o}),rgDiskPath:C,siblingClauses:r.siblingClauses,rgArgs:r,cwd:o}}e.spawnRipgrepCmd=S;function v(s,a,c,t){const r=["--files","--hidden","--case-sensitive"];u([a],c,!1).forEach(l=>{const i=I.anchorGlob(l);if(r.push("-g",i),P.isMacintosh){const h=R.normalizeNFD(i);h!==i&&r.push("-g",h)}});const o=f([a],t,void 0,!1);return o.globArgs.forEach(l=>{const i=`!${I.anchorGlob(l)}`;if(r.push("-g",i),P.isMacintosh){const h=R.normalizeNFD(i);h!==i&&r.push("-g",h)}}),a.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),a.ignoreSymlinks||r.push("--follow"),s.exists&&r.push("--quiet"),r.push("--no-config"),a.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:o.siblingClauses}}function f(s,a,c,t=!0){const r=[];let o={};return s.forEach(l=>{const i=Object.assign({},l.excludePattern||{},a||{}),h=m(i,t?l.folder.fsPath:void 0,c);r.push(...h.globArgs),h.siblingClauses&&(o=Object.assign(o,h.siblingClauses))}),{globArgs:r,siblingClauses:o}}e.foldersToRgExcludeGlobs=f;function u(s,a,c=!0){const t=[];return s.forEach(r=>{const o=Object.assign({},a||{},r.includePattern||{}),l=m(o,c?r.folder.fsPath:void 0);t.push(...l.globArgs)}),t}e.foldersToIncludeGlobs=u;function m(s,a,c){const t=[],r={};return Object.keys(s).forEach(o=>{if(!(c&&c.has(o))&&!!o){const l=s[o];o=p(a?w(a,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof l=="boolean"&&l?(o.startsWith("\\\\")&&(o+="**"),t.push(d(o))):l&&l.when&&(r[o]=l)}}),{globArgs:t,siblingClauses:r}}function w(s,a){return k.isAbsolute(a)?a:k.join(s,a)}e.getAbsoluteGlob=w;function p(s){return s=D.rtrim(s,"\\"),D.rtrim(s,"/")}function d(s){return T.getRoot(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.fixDriveC=d}),define(ge[276],pe([0,1,35,39,7,100,13,49,33,77,30,9,47,10,16,24,31,274,97]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const s=new Set;process.on("exit",()=>{s.forEach(o=>o())});class a{constructor(l){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=l,this.filePattern=l.filePattern||"",this.includePattern=l.includePattern&&I.parse(l.includePattern),this.maxResults=l.maxResults||null,this.exists=!!l.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=d.prepareQuery(this.filePattern).normalizedLowercase),this.globalExcludePattern=l.excludePattern&&I.parse(l.excludePattern),this.folderExcludePatterns=new Map,l.folderQueries.forEach(i=>{const h=Object.assign({},i.excludePattern||{},this.config.excludePattern||{}),y=i.folder.fsPath;l.folderQueries.map(g=>g.folder.fsPath).filter(g=>g!==y).forEach(g=>{C.isEqualOrParent(g,y)&&(h[R.relative(y,g)]=!0)}),this.folderExcludePatterns.set(y,new t(h,y))})}cancel(){this.isCanceled=!0}walk(l,i,h,y,g){if(this.fileWalkSW=v.StopWatch.create(!1),this.isCanceled)return g(null,this.isLimitHit);i.forEach(E=>{const b=R.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,b)||this.matchFile(h,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=v.StopWatch.create(!1),this.parallel(l,(E,b)=>{this.call(this.cmdTraversal,this,E,h,y,L=>{if(L){const A=D.toErrorMessage(L);console.error(A),this.errors.push(A),b(L,void 0)}else b(null,void 0)})},(E,b)=>{this.fileWalkSW.stop();const L=E?P.coalesce(E)[0]:null;g(L,this.isLimitHit)})}parallel(l,i,h){const y=new Array(l.length),g=new Array(l.length);let E=!1,b=0;if(l.length===0)return h(null,[]);l.forEach((L,A)=>{i(L,(N,W)=>{if(N?(E=!0,y[A]=null,g[A]=N):(y[A]=W,g[A]=null),++b===l.length)return h(E?g:null,y)})})}call(l,i,...h){try{l.apply(i,h)}catch(y){h[h.length-1](y)}}cmdTraversal(l,i,h,y){const g=l.folder.fsPath,E=S.isMacintosh;let b;const L=()=>b&&b.kill();s.add(L);let A=B=>{s.delete(L),A=()=>{},y(B)},N="";const W=this.initDirectoryTree();let x;const M=p.spawnRipgrepCmd(this.config,l,this.config.includePattern,this.folderExcludePatterns.get(l.folder.fsPath).expression);b=M.cmd,x=!Object.keys(M.siblingClauses).length;const $=M.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let O=`${M.rgDiskPath} ${$}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),h({message:O}),this.cmdResultCount=0,this.collectStdout(b,"utf8",h,(B,J,U)=>{if(B){A(B);return}if(this.isLimitHit){A();return}const z=(N+(E?n.normalizeNFC(J||""):J)).split(`
`);if(U){const Q=z.length;z[Q-1]=z[Q-1].trim(),z[Q-1]||z.pop()}else N=z.pop()||"";if(z.length&&z[0].indexOf(`
`)!==-1){A(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=z.length,x){for(const Q of z)if(this.matchFile(i,{base:g,relativePath:Q,searchPath:this.getSearchPath(l,Q)}),this.isLimitHit){L();break}(U||this.isLimitHit)&&A();return}this.addDirectoryEntries(l,W,g,z,i),U&&(this.matchDirectoryTree(W,g,i),A())})}spawnFindCmd(l){const i=this.folderExcludePatterns.get(l.folder.fsPath),h=i.getBasenameTerms(),y=i.getPathTerms(),g=["-L","."];if(h.length||y.length){g.push("-not","(","(");for(const E of h)g.push("-name",E),g.push("-o");for(const E of y)g.push("-path",E),g.push("-o");g.pop(),g.push(")","-prune",")")}return g.push("-type","f"),_.spawn("find",g,{cwd:l.folder.fsPath})}readStdout(l,i,h){let y="";this.collectStdout(l,i,()=>{},(g,E,b)=>{if(g){h(g);return}y+=E,b&&h(null,y)})}collectStdout(l,i,h,y){let g=(L,A,N)=>{(L||N)&&(g=()=>{},this.cmdSW&&this.cmdSW.stop()),y(L,A,N)},E=!1;l.stdout?(this.forwardData(l.stdout,i,g),l.stdout.once("data",()=>E=!0)):h({message:"stdout is null"});let b;l.stderr?b=this.collectData(l.stderr):h({message:"stderr is null"}),l.on("error",L=>{g(L)}),l.on("close",L=>{let A;!E&&(A=this.decodeData(b,i))&&r(A)?g(new Error(`command failed with error code ${L}: ${this.decodeData(b,i)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),g(null,"",!0))})}forwardData(l,i,h){const y=new T.StringDecoder(i);return l.on("data",g=>{h(null,y.write(g))}),y}collectData(l){const i=[];return l.on("data",h=>{i.push(h)}),i}decodeData(l,i){const h=new T.StringDecoder(i);return l.map(y=>h.write(y)).join("")}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries(l,{pathToEntries:i},h,y,g){y.indexOf(this.filePattern)!==-1&&this.matchFile(g,{base:h,relativePath:this.filePattern,searchPath:this.getSearchPath(l,this.filePattern)});const E=b=>{const L=R.basename(b),A=R.dirname(b);let N=i[A];N||(N=i[A]=[],E(A)),N.push({base:h,relativePath:b,basename:L,searchPath:this.getSearchPath(l,b)})};y.forEach(E)}matchDirectoryTree({rootEntries:l,pathToEntries:i},h,y){const g=this,E=this.folderExcludePatterns.get(h),b=this.filePattern;function L(A){g.directoriesWalked++;const N=I.hasSiblingFn(()=>A.map(W=>W.basename));for(let W=0,x=A.length;W<x;W++){const M=A[W],{relativePath:$,basename:O}=M;if(!E.test($,O,b!==O?N:void 0)){const B=i[$];if(B)L(B);else{if(g.filesWalked++,$===b)continue;g.matchFile(y,M)}if(g.isLimitHit)break}}}L(l)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(l,i,h,y,g){const E=l.folder,b=I.hasSiblingFn(()=>h);this.parallel(h,(L,A)=>{if(this.isCanceled||this.isLimitHit)return A(null);const N=i?[i,L].join(R.sep):L;if(this.folderExcludePatterns.get(l.folder.fsPath).test(N,L,this.config.filePattern!==L?b:void 0))return A(null);const W=[E.fsPath,N].join(R.sep);k.lstat(W,(x,M)=>{if(x||this.isCanceled||this.isLimitHit)return A(null);this.statLinkIfNeeded(W,M,($,O)=>$||this.isCanceled||this.isLimitHit?A(null):O.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(W,M,(B,J)=>B||this.isCanceled||this.isLimitHit||(J=J||"",this.walkedPaths[J])?A(null):(this.walkedPaths[J]=!0,m.readdir(W).then(U=>{if(this.isCanceled||this.isLimitHit)return A(null);this.doWalk(l,N,U,y,V=>A(V||null))},U=>{A(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&u.isNumber(O.size)&&O.size>this.maxFilesize||this.matchFile(y,{base:E.fsPath,relativePath:N,searchPath:this.getSearchPath(l,N)}),A(null,void 0)))})},L=>{const A=L&&P.coalesce(L);return g(A&&A.length>0?A[0]:void 0)})}matchFile(l,i){this.isFileMatch(i)&&(!this.includePattern||this.includePattern(i.relativePath,R.basename(i.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||l(i))}isFileMatch(l){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return w.isFilePatternMatch(l,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(l,i,h){return i.isSymbolicLink()?k.stat(l,h):h(null,i)}realPathIfNeeded(l,i,h){return i.isSymbolicLink()?k.realpath(l,(y,g)=>y?h(y):h(null,g)):h(null,l)}getSearchPath(l,i){return l.folderName?R.join(l.folderName,i):i}}e.FileWalker=a;class c{constructor(l){this.folderQueries=l.folderQueries,this.extraFiles=l.extraFileResources||[],this.walker=new a(l)}search(l,i,h){this.walker.walk(this.folderQueries,this.extraFiles,l,i,(y,g)=>{h(y,{limitHit:g,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=c;class t{constructor(l,i){this.expression=l,this.root=i,this.init(l)}init(l){let i,h;Object.keys(l).filter(y=>l[y]).forEach(y=>{R.isAbsolute(y)?(i=i||I.getEmptyExpression(),i[y]=l[y]):(h=h||I.getEmptyExpression(),h[y]=l[y])}),this.absoluteParsedExpr=i&&I.parse(i,{trimForExclusions:!0}),this.relativeParsedExpr=h&&I.parse(h,{trimForExclusions:!0})}test(l,i,h){return this.relativeParsedExpr&&this.relativeParsedExpr(l,i,h)||this.absoluteParsedExpr&&this.absoluteParsedExpr(R.join(this.root,l),i,h)}getBasenameTerms(){const l=[];return this.absoluteParsedExpr&&l.push(...I.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&l.push(...I.getBasenameTerms(this.relativeParsedExpr)),l}getPathTerms(){const l=[];return this.absoluteParsedExpr&&l.push(...I.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&l.push(...I.getPathTerms(this.relativeParsedExpr)),l}}function r(o){const l=o.trim().split(`
`),i=l[0].trim();if(i.startsWith("Error parsing regex"))return i;if(i.startsWith("regex parse error"))return f.uppercaseFirstLetter(l[l.length-1].trim());if(i.startsWith("error parsing glob")||i.startsWith("unsupported encoding"))return i.charAt(0).toUpperCase()+i.substr(1);if(i==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(i.startsWith("Literal "))return i}e.rgErrorMsgForDisplay=r}),define(ge[128],pe([0,1,35,293,100,13,54,33,7,10,2,31,125,294,275,92]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const w=u.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class p{constructor(E){this.outputChannel=E}provideTextSearchResults(E,b,L,A){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify(Object.assign(Object.assign({},b),{folder:b.folder.toString()}))}`),new Promise((N,W)=>{A.onCancellationRequested(()=>V());const x=r(E,b),M=b.folder.fsPath,$=x.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.outputChannel.appendLine(`${w} ${$}
 - cwd: ${M}`);let O=_.spawn(w,x,{cwd:M});O.on("error",fe=>{console.error(fe),this.outputChannel.appendLine("Error: "+(fe&&fe.message)),W(S.serializeSearchError(new S.SearchError(fe&&fe.message,S.SearchErrorCode.rgProcessError)))});let B=!1;const J=new a(b.maxResults,M,b.previewOptions);J.on("result",fe=>{B=!0,Q="",L.report(fe)});let U=!1;const V=()=>{U=!0,O&&O.kill(),J&&J.cancel()};let z=!1;J.on("hitLimit",()=>{z=!0,V()});let Q="";O.stdout.on("data",fe=>{J.handleData(fe),B||(Q+=fe)});let ae=!1;O.stdout.once("data",()=>ae=!0);let ce="";O.stderr.on("data",fe=>{const we=fe.toString();this.outputChannel.appendLine(we),ce+=we}),O.on("close",()=>{if(this.outputChannel.appendLine(ae?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(B?"Got result from parser":"No result from parser"),Q&&this.outputChannel.appendLine(`Got data without result: ${Q}`),this.outputChannel.appendLine(""),U)N({limitHit:z});else{J.flush(),O=null;let fe;ce&&!ae&&(fe=d(ce))?W(S.serializeSearchError(new S.SearchError(fe.message,fe.code))):N({limitHit:z})}})})}}e.RipgrepTextSearchEngine=p;function d(g){const E=g.split(`
`),b=E[0].trim();if(E.some(A=>A.startsWith("regex parse error")))return new S.SearchError(s(E),S.SearchErrorCode.regexParseError);const L=b.match(/grep config error: unknown encoding: (.*)/);if(L)return new S.SearchError(`Unknown encoding: ${L[1]}`,S.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new S.SearchError(b.charAt(0).toUpperCase()+b.substr(1),S.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new S.SearchError(b.charAt(0).toUpperCase()+b.substr(1),S.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new S.SearchError(b,S.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=d;function s(g){const E=["Regex parse error"],b=g.filter(L=>L.startsWith("PCRE2:"));if(b.length>=1){const L=b[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const A=L.split(":")[1];E.push(":"+A)}}return E.join("")}e.buildRegexParseError=s;class a extends k.EventEmitter{constructor(E,b,L){super();this.maxResults=E,this.rootFolder=b,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new R.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,b){return super.on(E,b),this}handleData(E){if(!this.isDone){const b=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(b)}}handleDecodedData(E){let b=E.indexOf(`
`);const L=this.remainder+E;if(b>=0)b+=this.remainder.length;else{this.remainder=L;return}let A=0;for(;b>=0;)this.handleLine(L.substring(A,b).trim()),A=b+1,b=L.indexOf(`
`,A);this.remainder=L.substring(A)}handleLine(E){if(!(this.isDone||!E)){let b;try{b=JSON.parse(E)}catch(L){throw new Error(`malformed line from rg: ${E}`)}if(b.type==="match"){const L=c(b.data.path),A=C.URI.file(I.join(this.rootFolder,L)),N=this.createTextSearchMatch(b.data,A);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const L=c(b.data.path),A=C.URI.file(I.join(this.rootFolder,L));this.createTextSearchContext(b.data,A).forEach(W=>this.onResult(W))}}}createTextSearchMatch(E,b){const L=E.line_number-1;let A=!1,N=c(E.lines);L===0&&n.startsWithUTF8BOM(N)&&(A=!0,N=n.stripUTF8BOM(N));const W=Buffer.from(N);let x=0,M=0,$=L;E.submatches.length===0&&E.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const O=T.coalesce(E.submatches.map((B,J)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let U=c(B.match);L===0&&J===0&&A&&(U=n.stripUTF8BOM(U),B.start=B.start<=3?0:B.start-3,B.end=B.end<=3?0:B.end-3);const V=W.slice(x,B.start).toString().length,z=M+V,Q=t(U),ae=$,ce=Q.numLines+ae,fe=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+z;return x=B.end,M=fe,$=ce,new v.Range(ae,z,ce,fe)}));return m.createTextSearchResult(b,N,O,this.previewOptions)}createTextSearchContext(E,b){const L=c(E.lines),A=E.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((N,W)=>({text:N,uri:b,lineNumber:A+W}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=a;function c(g){return g.bytes?Buffer.from(g.bytes,"base64").toString():g.text}function t(g){const E=/\n/g;let b=0,L=-1,A;for(;A=E.exec(g);)b++,L=A.index;const N=L>=0?g.length-L-1:g.length;return{numLines:b,lastLineLength:N}}function r(g,E){const b=["--hidden"];b.push(g.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:A}=P.groupBy(E.includes,W=>W.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(A&&A.length){const W=new Set;A.forEach(x=>{W.add(x)}),b.push("-g","!*"),W.forEach(x=>{o(x).map(m.anchorGlob).forEach(M=>{b.push("-g",M)})})}L&&L.length&&L.forEach(W=>{b.push("-g",W)}),E.excludes.map(m.anchorGlob).forEach(W=>b.push("-g",`!${W}`)),E.maxFileSize&&b.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?b.push("--no-ignore-parent"):b.push("--no-ignore"),E.followSymlinks&&b.push("--follow"),E.encoding&&E.encoding!=="utf8"&&b.push("--encoding",E.encoding),g.pattern==="--"&&(g.isRegExp=!0,g.pattern="\\-\\-"),g.isMultiline&&!g.isRegExp&&(g.pattern=n.escapeRegExpCharacters(g.pattern),g.isRegExp=!0),E.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),g.isRegExp&&(g.pattern=l(g.pattern),b.push("--auto-hybrid-regex"));let N;if(g.isWordMatch){const x=n.createRegExp(g.pattern,!!g.isRegExp,{wholeWord:g.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",x)}else if(g.isRegExp){let W=h(g.pattern);W=y(W),b.push("--regexp",W)}else N=g.pattern,b.push("--fixed-strings");return b.push("--no-config"),E.useGlobalIgnoreFiles||b.push("--no-ignore-global"),b.push("--json"),g.isMultiline&&b.push("--multiline"),E.beforeContext&&b.push("--before-context",E.beforeContext+""),E.afterContext&&b.push("--after-context",E.afterContext+""),b.push("--"),N&&b.push(N),b.push("."),b}function o(g){const E=D.splitGlobAware(g,"/");return E.map((b,L)=>E.slice(0,L+1).join("/"))}e.spreadGlobComponents=o;function l(g){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;g.match(E);)g=g.replace(E,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;g.match(b);)g=g.replace(b,"$1\\x{$2}");return g}e.unicodeEscapesToPCRE2=l;const i=g=>g.type==="Assertion"&&g.kind==="lookbehind";function h(g){let E;try{E=new f.RegExpParser().parsePattern(g)}catch(x){return g}let b="",L=0;const A=(x,M,$)=>{b+=g.slice(L,x)+$,L=M},N=[];return new f.RegExpVisitor({onCharacterEnter(x){if(x.raw==="\\n"){const M=N[0];if(!M)A(x.start,x.end,"\\r?\\n");else if(!N.some(i))if(M.type==="CharacterClass"){const $=g.slice(M.start+1,x.start)+g.slice(x.end,M.end-1);A(M.start,M.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else M.type==="Quantifier"&&A(x.start,x.end,"(?:\\r?\\n)")}},onQuantifierEnter(x){N.unshift(x)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(x){N.unshift(x)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(x){N.unshift(x)},onCharacterClassLeave(){N.shift()},onAssertionEnter(x){i(x)&&N.push(x)},onAssertionLeave(x){N[0]===x&&N.shift()}}).visit(E),b+=g.slice(L),b}e.fixRegexNewline=h;function y(g){return g.replace(/\n/g,"\\r?\\n")}e.fixNewline=y}),define(ge[277],pe([0,1,21,128]),function(Z,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(D){this.outputChannel=D,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(D,I,n,C){const S=new k.RipgrepTextSearchEngine(this.outputChannel);return this.withToken(C,v=>S.provideTextSearchResults(D,I,n,v))}async withToken(D,I){const n=T(D);this.inProgress.add(n);const C=await I(n.token);return this.inProgress.delete(n),C}dispose(){this.inProgress.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=R;function T(P){const D=new _.CancellationTokenSource;return P.onCancellationRequested(()=>D.cancel()),D}}),define(ge[278],pe([0,1,24,128,127]),function(Z,e,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(I){this.query=I}search(I,n,C){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const S={appendLine(f){C({message:f})}},v=new R.NativeTextSearchManager(this.query,new k.RipgrepTextSearchEngine(S),_);return new Promise((f,u)=>v.search(m=>{n(m.map(P))},I).then(m=>f({limitHit:m.limitHit,type:"success"}),u))}}e.TextSearchEngineAdapter=T;function P(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((I,n)=>{if(n.ranges){const C=n;return I+(Array.isArray(C.ranges)?C.ranges.length:1)}else return I+1},0)}}}),define(ge[279],pe([0,1,39,295,13,19,15,3,97,7,47,2,24,31,276,278]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,k.gracefulify(_);class w{constructor(){this.caches=Object.create(null)}fileSearch(t){let r;const o=s(t),l=new D.Emitter({onFirstListenerDidAdd:()=>{r=T.createCancelablePromise(i=>this.doFileSearchWithEngine(u.Engine,o,h=>l.fire(h),i)),r.then(i=>l.fire(i),i=>l.fire({type:"error",error:{message:i.message,stack:i.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return l.event}textSearch(t){let r;const o=s(t),l=new D.Emitter({onFirstListenerDidAdd:()=>{r=T.createCancelablePromise(i=>this.ripgrepTextSearch(o,h=>l.fire(h),i)),r.then(i=>l.fire(i),i=>l.fire({type:"error",error:{message:i.message,stack:i.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return l.event}ripgrepTextSearch(t,r,o){return t.maxFileSize=v.MAX_FILE_SIZE,new m.TextSearchEngineAdapter(t).search(o,r,r)}doFileSearch(t,r,o){return this.doFileSearchWithEngine(u.Engine,t,r,o)}doFileSearchWithEngine(t,r,o,l,i=w.BATCH_SIZE){let h=0;const y=E=>{Array.isArray(E)?(h+=E.length,o(E.map(b=>this.rawMatchToSearchItem(b)))):E.relativePath?(h++,o(this.rawMatchToSearchItem(E))):o(E)};if(r.sortByScore){let E=this.trySortedSearchFromCache(r,y,l);if(!E){const b=r.maxResults?Object.assign({},r,{maxResults:null}):r,L=new t(b);E=this.doSortedSearch(L,r,o,y,l)}return new Promise((b,L)=>{E.then(([A,N])=>{const W=N.map(x=>this.rawMatchToSearchItem(x));this.sendProgress(W,o,i),b(A)},L)})}const g=new t(r);return this.doSearch(g,y,i,l).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:"searchProcess",fromCache:!1,resultCount:h,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?n.join(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,o,l,i){const h=new D.Emitter;let y=T.createCancelablePromise(E=>{let b=[];const L=A=>{Array.isArray(A)?b=A:(l(A),h.fire(A))};return this.doSearch(t,L,-1,E).then(A=>[A,b])}),g;if(r.cacheKey){g=this.getOrCreateCache(r.cacheKey);const E={promise:y,event:h.event,resolved:!1};g.resultsToSearchCache[r.filePattern||""]=E,y.then(()=>{E.resolved=!0},b=>{delete g.resultsToSearchCache[r.filePattern||""]}),y=this.preventCancellation(y)}return y.then(([E,b])=>{const L=g?g.scorerCache:Object.create(null),A=(typeof r.maxResults!="number"||r.maxResults>0)&&C.StopWatch.create(!1);return this.sortResults(r,b,L,i).then(N=>{const W=A?A.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:W,fromCache:!1,type:"searchProcess",workspaceFolderCount:r.folderQueries.length,resultCount:N.length},limitHit:E.limitHit||typeof r.maxResults=="number"&&b.length>r.maxResults},N]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new p)}trySortedSearchFromCache(t,r,o){const l=t.cacheKey&&this.caches[t.cacheKey];if(!!l){const i=this.getResultsFromCache(l,t.filePattern||"",r,o);if(i)return i.then(([h,y,g])=>{const E=C.StopWatch.create(!1);return this.sortResults(t,y,l.scorerCache,o).then(b=>{const L=E.elapsed(),A={fromCache:!0,detailStats:g,type:"searchProcess",resultCount:y.length,sortingTime:L};return[{type:"success",limitHit:h.limitHit||typeof t.maxResults=="number"&&y.length>t.maxResults,stats:A},b]})})}}sortResults(t,r,o,l){const i=I.prepareQuery(t.filePattern||""),h=(g,E)=>I.compareItemsByFuzzyScore(g,E,i,!0,d,o),y=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return R.topAsync(r,h,y,1e4,l)}sendProgress(t,r,o){if(o&&o>0)for(let l=0;l<t.length;l+=o)r(t.slice(l,l+o));else r(t)}getResultsFromCache(t,r,o,l){const i=C.StopWatch.create(!1),h=r.indexOf(n.sep)>=0;let y;for(const L in t.resultsToSearchCache)if(r.startsWith(L)){if(h&&L.indexOf(n.sep)<0&&L!=="")continue;const A=t.resultsToSearchCache[L];y={promise:this.preventCancellation(A.promise),event:A.event,resolved:A.resolved};break}if(!y)return null;const g=i.elapsed(),E=C.StopWatch.create(!1),b=y.event(o);return l&&l.onCancellationRequested(()=>{b.dispose()}),y.promise.then(([L,A])=>{if(l&&l.isCancellationRequested)throw P.canceled();const N=[],W=I.prepareQuery(r).normalizedLowercase;for(const x of A)!f.isFilePatternMatch(x,W)||N.push(x);return[L,N,{cacheWasResolved:y.resolved,cacheLookupTime:g,cacheFilterTime:E.elapsed(),cacheEntryCount:A.length}]})}doSearch(t,r,o,l){return new Promise((i,h)=>{let y=[];l&&l.onCancellationRequested(()=>t.cancel()),t.search(g=>{g&&(o?(y.push(g),o>0&&y.length>=o&&(r(y),y=[])):r(g))},g=>{r(g)},(g,E)=>{y.length&&r(y),g?h(g):i(E)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,o){return t.then(r,o)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=w,w.BATCH_SIZE=512;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(c){return n.basename(c.relativePath)}getItemDescription(c){return n.dirname(c.relativePath)}getItemPath(c){return c.relativePath}};function s(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(a),extraFileResources:c.extraFileResources&&c.extraFileResources.map(t=>S.URI.revive(t))})}function a(c){return Object.assign(Object.assign({},c),{folder:S.URI.revive(c.folder)})}}),define(ge[280],pe([0,1,5,2,24,12,31,279,277,92,14,63,28,69,11,127]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let w=class extends f.ExtHostSearch{constructor(d,s,a,c){super(d,a,c);this._pfs=R,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const d=new n.OutputChannel(this._logService);this.registerTextSearchProvider(u.Schemas.file,new I.RipgrepSearchProvider(d)),this.registerInternalFileSearchProvider(u.Schemas.file,new D.SearchService)}registerInternalFileSearchProvider(d,s){const a=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(d)),_.toDisposable(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(d,s,a,c){const t=f.reviveQuery(a);return d===this._internalFileSearchHandle?this.doInternalFileSearch(d,s,t,c):super.$provideFileSearchResults(d,s,a,c)}doInternalFileSearch(d,s,a,c){const t=r=>{if(P.isSerializedFileMatch(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(d,s,r.map(o=>k.URI.file(o.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,t,c)}$clearCache(d){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(d),super.$clearCache(d)}createTextSearchManager(d,s){return new m.NativeTextSearchManager(d,s)}};w=He([Fe(0,C.IExtHostRpcService),Fe(1,v.IExtHostInitDataService),Fe(2,S.IURITransformerService),Fe(3,T.ILogService)],w),e.NativeExtHostSearch=w}),define(ge[129],pe([0,1,296,117,297,3,102,7,34,26,5,27,103,15,9]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(y){this.socket=y}dispose(){this.socket.destroy()}onData(y){const g=E=>y(S.VSBuffer.wrap(E));return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(y){return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(y){return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(y){if(!this.socket.destroyed)try{this.socket.write(y.buffer)}catch(g){if(g.code==="EPIPE")return;f.onUnexpectedError(g)}}end(){this.socket.end()}drain(){return new Promise((y,g)=>{if(this.socket.bufferSize===0){y();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),y()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=m;var w;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var p;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(p||(p={}));class d extends C.Disposable{constructor(y,g,E,b){super();this._onDidZlibFlush=this._register(new T.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new T.Emitter),this._onClose=this._register(new T.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=y,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=g,this._recordInflateBytes=b,g?(this._zlibInflate=R.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",L=>{console.error(L),f.onUnexpectedError(L),this._onClose.fire()}),this._zlibInflate.on("data",L=>{this._pendingInflateData.push(L)}),E&&(this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=R.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{console.error(L),f.onUnexpectedError(L),this._onClose.fire()}),this._zlibDeflate.on("data",L=>{this._pendingDeflateData.push(L)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new v.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?S.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):S.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this._onData.event(y)}onClose(y){return this._onClose.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){this._totalOutgoingDataBytes+=y.byteLength,this._zlibDeflate?(this._zlibDeflate.write(y.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let g=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,g=g.slice(0,g.length-4),this._isEnded||this._write(S.VSBuffer.wrap(g),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(y,!1)}_write(y,g){let E=2;y.byteLength<126?E+=0:y.byteLength<2**16?E+=2:E+=8;const b=S.VSBuffer.alloc(E);if(g?b.writeUInt8(194,0):b.writeUInt8(130,0),y.byteLength<126)b.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){b.writeUInt8(126,1);let L=1;b.writeUInt8(y.byteLength>>>8&255,++L),b.writeUInt8(y.byteLength>>>0&255,++L)}else{b.writeUInt8(127,1);let L=1;b.writeUInt8(0,++L),b.writeUInt8(0,++L),b.writeUInt8(0,++L),b.writeUInt8(0,++L),b.writeUInt8(y.byteLength>>>24&255,++L),b.writeUInt8(y.byteLength>>>16&255,++L),b.writeUInt8(y.byteLength>>>8&255,++L),b.writeUInt8(y.byteLength>>>0&255,++L)}this._totalOutgoingWireBytes+=b.byteLength+y.byteLength,this.socket.write(S.VSBuffer.concat([b,y]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(y){if(y.byteLength!==0){for(this._totalIncomingWireBytes+=y.byteLength,this._incomingData.acceptChunk(y);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const g=this._incomingData.peek(this._state.readLen),b=(g.readUInt8(0)&128)>>>7,L=g.readUInt8(1),A=(L&128)>>>7,N=L&127;this._state.state=2,this._state.readLen=2+(A?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=b,this._state.mask=0}else if(this._state.state===2){const g=this._incomingData.read(this._state.readLen),E=g.readUInt8(1),b=(E&128)>>>7;let L=E&127,A=1;L===126?L=g.readUInt8(++A)*2**8+g.readUInt8(++A):L===127&&(L=g.readUInt8(++A)*0+g.readUInt8(++A)*0+g.readUInt8(++A)*0+g.readUInt8(++A)*0+g.readUInt8(++A)*2**24+g.readUInt8(++A)*2**16+g.readUInt8(++A)*2**8+g.readUInt8(++A));let N=0;b&&(N=g.readUInt8(++A)*2**24+g.readUInt8(++A)*2**16+g.readUInt8(++A)*2**8+g.readUInt8(++A)),this._state.state=3,this._state.readLen=L,this._state.mask=N}else if(this._state.state===3){const g=this._incomingData.read(this._state.readLen);s(g,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(g.buffer)),this._zlibInflate.write(g.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const E=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=E.length,this._onData.fire(S.VSBuffer.wrap(E))})):(this._totalIncomingDataBytes+=g.byteLength,this._onData.fire(g))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await T.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=d;function s(h,y){if(y!==0){let g=h.byteLength>>>2;for(let W=0;W<g;W++){const x=h.readUInt32BE(W*4);h.writeUInt32BE(x^y,W*4)}let E=g*4,b=h.byteLength-E;const L=y>>>24&255,A=y>>>16&255,N=y>>>8&255;b>=1&&h.writeUInt8(h.readUInt8(E)^L,E),b>=2&&h.writeUInt8(h.readUInt8(E+1)^A,E+1),b>=3&&h.writeUInt8(h.readUInt8(E+2)^N,E+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function c(){const h=n.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let y;return e.XDG_RUNTIME_DIR?y=D.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):y=D.join(I.tmpdir(),`vscode-ipc-${h}.sock`),r(y),y}e.createRandomIPCHandle=c;function t(h,y,g){const E=_.createHash("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${g}-${y}-sock`;let b;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?b=D.join(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${g}-${y}.sock`):b=D.join(h,`${g}-${y}.sock`),r(b),b}e.createStaticIPCHandle=t;function r(h){const y=a[u.platform];typeof y=="number"&&h.length>=y&&console.warn(`WARNING: IPC handle "${h}" is longer than ${y} chars, try a shorter --user-data-dir`)}class o extends P.IPCServer{constructor(y){super(o.toClientConnectionEvent(y));this.server=y}static toClientConnectionEvent(y){const g=T.Event.fromNodeEventEmitter(y,"connection");return T.Event.map(g,E=>({protocol:new v.Protocol(new m(E)),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(E,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function l(h){return new Promise((y,g)=>{const E=k.createServer();E.on("error",g),E.listen(h,()=>{E.removeListener("error",g),y(new o(E))})})}e.serve=l;function i(h,y){return new Promise((g,E)=>{const b=k.createConnection(h,()=>{b.removeListener("error",E),g(v.Client.fromSocket(new m(b),y))});b.once("error",E)})}e.connect=i}),define(ge[281],pe([0,1,129,273,39,52,2,115,12,7,34]),function(Z,e,_,k,R,T,P,D,I,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class S{constructor(u,m,w){this._commands=u,this.logService=m,this._ipcHandlePath=w,this._server=k.createServer((p,d)=>this.onRequest(p,d)),this.setup().catch(p=>(m.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){R.promises.writeFile(n.join(C.tmpdir(),"vscode-ipc"),this._ipcHandlePath).catch(u=>{this.logService.error(u)});try{this._server.listen(this.ipcHandlePath),this._server.on("error",u=>this.logService.error(u))}catch(u){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(u,m){const w=[];u.setEncoding("utf8"),u.on("data",p=>w.push(p)),u.on("end",()=>{const p=JSON.parse(w.join(""));switch(p.type){case"open":this.open(p,m);break;case"openExternal":this.openExternal(p,m);break;case"status":this.getStatus(p,m);break;case"command":this.runCommand(p,m).catch(this.logService.error);break;case"extensionManagement":this.manageExtensions(p,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${p.type}`,d=>{d&&this.logService.error(d)}),m.end();break}})}open(u,m){let{fileURIs:w,folderURIs:p,forceNewWindow:d,diffMode:s,addMode:a,forceReuseWindow:c,gotoLineMode:t,waitMarkerFilePath:r}=u;const o=[];if(Array.isArray(p))for(const l of p)try{o.push({folderUri:P.URI.parse(l)})}catch(i){}if(Array.isArray(w))for(const l of w)try{D.hasWorkspaceFileExtension(l)?o.push({workspaceUri:P.URI.parse(l)}):o.push({fileUri:P.URI.parse(l)})}catch(i){}if(o.length){const l=r?P.URI.file(r):void 0,h={forceNewWindow:d,diffMode:s,addMode:a,gotoLineMode:t,forceReuseWindow:c,preferNewWindow:!c&&!l&&!a,waitMarkerFileURI:l};this._commands.executeCommand("_files.windowOpen",o,h)}m.writeHead(200),m.end()}async openExternal(u,m){for(const w of u.uris)await this._commands.executeCommand("_remoteCLI.openExternal",P.URI.parse(w),{allowTunneling:!0});m.writeHead(200),m.end()}async manageExtensions(u,m){console.log("server: manageExtensions");try{const w=s=>s==null?void 0:s.map(a=>/\.vsix$/i.test(a)?P.URI.parse(a):a),p={list:u.list,install:w(u.install),uninstall:w(u.uninstall),force:u.force},d=await this._commands.executeCommand("_remoteCLI.manageExtensions",p,{allowTunneling:!0});m.writeHead(200),m.write(d)}catch(w){m.writeHead(500),m.write(String(w))}m.end()}async getStatus(u,m){try{const w=await this._commands.executeCommand("_issues.getSystemStatus");m.writeHead(200),m.write(w),m.end()}catch(w){m.writeHead(500),m.write(String(w),p=>{p&&this.logService.error(p)}),m.end()}}async runCommand(u,m){try{const{command:w,args:p}=u,d=await this._commands.executeCommand(w,...p);m.writeHead(200),m.write(JSON.stringify(d),s=>{s&&this.logService.error(s)}),m.end()}catch(w){m.writeHead(500),m.write(String(w),p=>{p&&this.logService.error(p)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&R.existsSync(this._ipcHandlePath)&&R.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=S;let v=class extends S{constructor(u,m){super(u,m,_.createRandomIPCHandle())}};v=He([Fe(0,T.IExtHostCommands),Fe(1,I.ILogService)],v),e.CLIServer=v}),define(ge[282],pe([0,1,68,269,263,6,272,43,253,281,2,11,8]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class f extends R.RequireInterceptor{_installInterceptor(){const w=this,p=Z.__$__nodeRequire("module"),d=p._load;p._load=function(a,c,t){for(let r of w._alternatives){let o=r(a);if(o){a=o;break}}return w._factories.has(a)?w._factories.get(a).load(a,C.URI.file(c.filename),r=>d.apply(this,[r,c,t])):d.apply(this,arguments)}}}class u extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=v.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(k.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(I.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const c=this._instaService.createInstance(n.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}await this._instaService.createInstance(f,w,this._registry).install(),_.mark("code/extHost/didInitAPI");const d=await this._extHostConfiguration.getConfigProvider();await P.connectProxyResolver(this._extHostWorkspace,d,this,this._logService,this._mainThreadTelemetryProxy,this._initData),_.mark("code/extHost/didInitProxyResolver");const s=process.send,a=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);process.send=(...c)=>c.length===0||!c[0]||c[0].type!=="__$console"?s.apply(process,c):(a.$logExtensionHostMessage(c[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,p,d){if(p.scheme!==S.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let s=null;d.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this._logService.flush();try{w&&_.mark(`code/extHost/willLoadExtensionCode/${w.value}`),s=Z.__$__nodeRequire(p.fsPath)}catch(a){return Promise.reject(a)}finally{w&&_.mark(`code/extHost/didLoadExtensionCode/${w.value}`),d.codeLoadingStop()}return Promise.resolve(s)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const p in w){const d=w[p];d===null?delete process.env[p]:process.env[p]=d}}}e.ExtHostExtensionService=u}),define(ge[283],pe([0,1,81,257,266,265,264,280,282,226,254,46,43,65,69,67,36,51,12]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),_.registerSingleton(v.IExtHostExtensionService,I.ExtHostExtensionService),_.registerSingleton(d.ILogService,n.ExtHostLogService),_.registerSingleton(S.IExtHostDebugService,P.ExtHostDebugService),_.registerSingleton(f.IExtHostOutputService,k.ExtHostOutputService2),_.registerSingleton(u.IExtHostSearch,D.NativeExtHostSearch),_.registerSingleton(m.IExtHostTask,T.ExtHostTask),_.registerSingleton(w.IExtHostTerminalService,R.ExtHostTerminalService),_.registerSingleton(p.IExtHostTunnelService,C.ExtHostTunnelService)}),define(ge[284],pe([0,1,117,298,68,15,103,129,184,224,267,27,99,24,135,19,136,270,283]),function(Z,e,_,k,R,T,P,D,I,n,C,S,v,f,u,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let i=0;i<process.execArgv.length;i++)process.execArgv[i]==="--inspect-port=0"&&(process.execArgv.splice(i,1),i--)}();const p=k(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const l=Z.__$__nodeRequire("module"),i=l._load;l._load=function(h){if(h==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return i.apply(this,arguments)}})();const d=process.exit.bind(process);function s(l){process.exit=function(i){if(l)d(i);else{const h=new Error("An extension called process.exit() and this was prevented.");console.warn(h.stack)}},process.crash=function(){const i=new Error("An extension called process.crash() and this was prevented.");console.warn(i.stack)}}let a=function(l){d()};function c(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((l,i)=>{let h=null,y=setTimeout(()=>{i(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const g=108e5,E=3e5,b=new m.RunOnceScheduler(()=>a("renderer disconnected for too long (1)"),g),L=new m.RunOnceScheduler(()=>a("renderer disconnected for too long (2)"),E);process.on("message",(N,W)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){const x=S.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let M;if(N.skipWebSocketFrames)M=new D.NodeSocket(W);else{const $=S.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));M=new D.WebSocketNodeSocket(new D.NodeSocket(W),N.permessageDeflate,$,!1)}h?(b.cancel(),L.cancel(),h.beginAcceptReconnection(M,x),h.endAcceptReconnection()):(clearTimeout(y),h=new P.PersistentProtocol(M,x),h.onDidDispose(()=>a("renderer disconnected")),l(h),h.onSocketClose(()=>{process.send({type:"VSCODE_EXTHOST_DISCONNECTED"})}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(L.isScheduled())return;b.isScheduled()&&L.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const l=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((i,h)=>{const y=_.createConnection(l,()=>{y.removeListener("error",h),i(new P.PersistentProtocol(new D.NodeSocket(y)))});y.once("error",h)})}}async function t(){const l=await c();return new class{constructor(){this._onMessage=new P.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,l.onMessage(i=>{n.isMessageOfType(i,2)?(this._terminating=!0,a("received terminate message from renderer")):this._onMessage.fire(i)})}send(i){this._terminating||l.send(i)}drain(){return l.drain()}}}function r(l){return new Promise(i=>{const h=l.onMessage(y=>{h.dispose();const g=JSON.parse(y.toString()),E=g.commit,b=I.default.commit;E&&b&&E!==b&&d(55);const L=[];process.on("unhandledRejection",(W,x)=>{L.push(x),setTimeout(()=>{const M=L.indexOf(x);M>=0&&x.catch($=>{L.splice(M,1),console.warn(`rejected promise not handled within 1 second: ${$}`),$&&$.stack&&console.warn(`stack trace: ${$.stack}`),T.onUnexpectedError(W)})},1e3)}),process.on("rejectionHandled",W=>{const x=L.indexOf(W);x>=0&&L.splice(x,1)}),process.on("uncaughtException",function(W){T.onUnexpectedError(W)});let A=0;setInterval(function(){try{process.kill(g.parentPid,0),A=0}catch(W){W&&W.code==="EPERM"?(A++,A>=3&&a(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${W.message} (code: ${W.code}) (errno: ${W.errno})`)):a(`parent process ${g.parentPid} does not exist anymore: ${W.message} (code: ${W.code}) (errno: ${W.errno})`)}},1e3);let N;try{N=Z.__$__nodeRequire("native-watchdog"),N.start(g.parentPid)}catch(W){T.onUnexpectedError(W)}l.send(n.createMessageOfType(0)),i({protocol:l,initData:g})});l.send(n.createMessageOfType(1))})}async function o(){w.monkeyPatch(!0),R.mark("code/extHost/willConnectToRenderer");const l=await t();R.mark("code/extHost/didConnectToRenderer");const i=await r(l);R.mark("code/extHost/didWaitForInitData");const{initData:h}=i;s(!!h.environment.extensionTestsLocationURI),h.environment.useHostProxy=p.useHostProxy!==void 0?p.useHostProxy!=="false":void 0;const y=new class{exit(L){d(L)}exists(L){return f.exists(L)}realpath(L){return u.realpath(L)}};let g=null;if(h.remote.authority)try{g=new v.URITransformer(h.remote.authority)}catch(b){console.error(b)}const E=new C.ExtensionHostMain(i.protocol,h,y,g);a=b=>E.terminate(b)}e.startExtensionHostProcess=o}),define(ge[299],pe([0,1,284]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),_.startExtensionHostProcess().catch(k=>console.log(k))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
